package holders;

import java.util.HashMap;
import medstore.String.StringUtils;
import medstore.remote.io.login.RemoteLogin;

public class User{
    public static final String SESSION_ID = "session";
    public static final String USERNAME = "user";
    public static final String PASSWORD = "pass";
    public static final String UID = "uid";
    public static final String active_macro = "active_macro";
    public static final String user_abrv = "user_abrv";
    private HashMap usermap;
    
    public User() {
        this.usermap = new HashMap();
        this.usermap.put(SESSION_ID,null);
        this.usermap.put(USERNAME,null);
        this.usermap.put(PASSWORD,null);
        this.usermap.put(UID,null);
        this.usermap.put(user_abrv,null);
    }
    public User(HashMap usermap) {
        this.usermap = usermap;
    }
    public User(String sessionid, String uid, String username, String password, String abrv) {
        usermap = new HashMap();
        usermap.put(SESSION_ID,sessionid);
        usermap.put(USERNAME,username);
        usermap.put(UID,uid);
        usermap.put(user_abrv,abrv);
    }
    public void setSesssionId(String value){
        usermap.put(SESSION_ID,value);
    }
    
    public void setUsername(String value){
        usermap.put(USERNAME,value);
    }
    public void setPassword(String value){
        usermap.put(PASSWORD,value);
    }
    
    public void setUID(String value){
        usermap.put(UID,value);
    }
    public String getUID(){
        return StringUtils.clearString(usermap.get(UID),"-1");
    }
    
    public void setActiveMacro(String value){
        usermap.put(active_macro,value);
    }
    public Integer getActiveMacro() throws Exception{
        return new Integer(usermap.get(active_macro).toString());
    }
    
    public void setAbbr(String value){
        usermap.put(user_abrv,value);
    }
    public void getAbbr(){
        usermap.get(user_abrv);
    }
    
    public HashMap getUserMap(){
        return usermap;
    }
    public boolean validateRemote() throws Exception{
        try {
            HashMap map = RemoteLogin.Login(this);
            
            String session = map.get(SESSION_ID).toString();
            String uid = map.get(UID).toString();
            String active_macro = StringUtils.clearString(map.get(this.active_macro));
            String abbr = StringUtils.clearString(map.get(this.user_abrv));
            
            setSesssionId(session);
            setUID(uid);
            setActiveMacro(active_macro);
            setAbbr(abbr);
            return true;
        } catch (Exception ex) {
            throw new Exception("Login Failed!");
        }
    }
    public boolean validate() throws Exception{
        try {
            String username = usermap.get(USERNAME).toString();
            String password = usermap.get(PASSWORD).toString();
            return true;
        } catch (Exception ex) {
            throw new Exception("Login Failed!");
        }
    }
    public void invalidate(){
        usermap = null;
    }
}
