package holders.person;

import java.math.BigDecimal;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import medstore.String.StringUtils;
import medstore.date.DateUtil;
import medstore.math.BigDec;
import medstore.verifiers.UniversalInputVerifier;
import org.jfree.date.DateUtilities;

public class Person {
    
    HashMap person;
    
    public Person() throws Exception{
        person = new HashMap();
        prsn_fnam("");
        prsn_lnam("");
        prsn_appl("");
        clcode("");
        type_idnt("-1");
        prsn_dscn("0.00");
        prv1_good(false);
        prv1_good(false);
        alow_prch(false);
        vatfree(false);
        altr_name("");
        prsn_strt("");
        city_code("");
        prsn_city("");
        cntr_idnt("-1");
        prsn_key("");
        birthdate("01.01.10");
        priv_phon("");
        work_phon("");
        mobi_phon("");
        prsn_fax("");
        prsn_eml("");
        prsn_info("");
        
        prv1_idnt(null);
        prv1_comm("0.00");
        
        prv2_idnt(null);
        prv2_comm("0.00");
        
        prv3_idnt(null);
        prv3_comm("0.00");
        
    }
    public Person(HashMap person) {
        this.person = person == null ? new HashMap() : person;
    }
    
    public HashMap getPerson() {
        return person;
    }
    
    public String prsn_key(){
        Object value = person.get("base_prsn.prsn_key");
        return "null".equalsIgnoreCase(String.valueOf(value).trim()) ? "" : String.valueOf(value).trim();
    }
    public void prsn_key(Object value) throws Exception{
        try {
            if(value!=null && String.valueOf(value).trim().length()>0)
                new Integer(String.valueOf(value));
        } catch (NumberFormatException ex) {
            throw new Exception("Invalid decimal value");
        }
        person.put("base_prsn.prsn_key",value);
    }
    public String type_idnt(){
        Object value = person.get("base_prsn.type_idnt");
        return value == null ? "-1" : String.valueOf(value).trim();
    }
    public void type_idnt(Object value){
        person.put("base_prsn.type_idnt",value);
    }
    
    public String prsn_lnam(){
        Object value = person.get("base_prsn.prsn_lnam");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prsn_lnam(Object value){
        person.put("base_prsn.prsn_lnam",value);
    }
    public String prsn_fnam(){
        Object value = person.get("base_prsn.prsn_fnam");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prsn_fnam(Object value){
        person.put("base_prsn.prsn_fnam",value);
    }
    public String prsn_appl(){
        Object value = person.get("base_prsn.prsn_appl");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prsn_appl(Object value){
        person.put("base_prsn.prsn_appl",value);
    }
    public String type_abbr(){
        Object value = person.get("base_prsn.type_abbr");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void type_abbr(Object value){
        person.put("base_prsn.type_abbr",value);
        
    }
    public String prsn_dscn(){
        Object value = person.get("base_prsn.prsn_dscn");
        return value == null ? "" : BigDec.scaledRoundHalfUp(String.valueOf(value).trim(),2);
    }
    public void prsn_dscn(Object value) throws Exception{
        try {
            if(String.valueOf(value).trim().length()>0)
                new BigDecimal(String.valueOf(value));
            else
                value = "0.00";
        } catch (NumberFormatException ex) {
            throw new Exception("Invalid discount value");
        }
        value = BigDec.scaledRoundHalfUp(String.valueOf(value).trim(),2);
        person.put("base_prsn.prsn_dscn",value);
    }
    public String prsn_info(){
        Object value = person.get("base_prsn.prsn_info");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prsn_info(Object value){
        person.put("base_prsn.prsn_info",value);
    }
    public boolean alow_prch(){
        Object value = person.get("base_prsn.alow_prch");
        value = value == null ? "N" : String.valueOf(value).trim();
        return String.valueOf(value).equalsIgnoreCase("Y");
    }
    public void alow_prch(boolean value){
        person.put("base_prsn.alow_prch",value ? "Y" : "N");
    }
    public int cntr_idnt(){
        Object value = person.get("base_prsn.cntr_idnt");
        int cntr_idnt = -1;
        try {
            cntr_idnt = new Integer(String.valueOf(value));
        } catch (NumberFormatException ex) {
            ex.printStackTrace();
        }
        return cntr_idnt;
    }
    public void cntr_idnt(Object value){
        person.put("base_prsn.cntr_idnt",value);
    }
    public String cntr_name(){
        Object value = person.get("base_prsn.cntr_name");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public String prsn_city(){
        Object value = person.get("base_prsn.prsn_city");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prsn_city(Object value){
        person.put("base_prsn.prsn_city",value);
    }
    public String city_code(){
        Object value = person.get("base_prsn.city_code");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void city_code(Object value){
        person.put("base_prsn.city_code",value);
    }
    public String prsn_strt(){
        Object value = person.get("base_prsn.prsn_strt");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prsn_strt(Object value){
        person.put("base_prsn.prsn_strt",value);
    }
    public String prv1_idnt(){
        Object value = person.get("base_prsn.prv1_idnt");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prv1_idnt(Object value) throws Exception{
        try {
            if(value!=null && String.valueOf(value).trim().length()>0)
                new Integer(String.valueOf(value));
            else
                value = null;
        } catch (NumberFormatException ex) {
            throw new Exception("Invalid decimal value");
        }
        person.put("base_prsn.prv1_idnt", value);
    }
    public String prv1_comm(){
        Object value = person.get("base_prsn.prv1_comm");
        value = BigDec.scaledRoundHalfUp(String.valueOf(value),2);
        return value == null ? "0.00" : String.valueOf(value).trim();
    }
    public void prv1_comm(Object value) throws Exception{
        try {
            if(String.valueOf(value).trim().length()>0)
                new BigDecimal(String.valueOf(value));
            else
                value = "0.00";
        } catch (NumberFormatException ex) {
            throw new Exception("Invalid decimal value");
        }
        value = BigDec.scaledRoundHalfUp(String.valueOf(value),2);
        person.put("base_prsn.prv1_comm",value);
    }
    public String prv2_idnt(){
        Object value = person.get("base_prsn.prv2_idnt");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prv2_idnt(Object value) throws Exception{
        try {
            if(value!=null && String.valueOf(value).trim().length()>0)
                new Integer(String.valueOf(value));
            else
                value = null;
        } catch (NumberFormatException ex) {
            throw new Exception("Invalid decimal value");
        }
        person.put("base_prsn.prv2_idnt", value);
    }
    public String prv2_comm(){
        Object value = person.get("base_prsn.prv2_comm");
        value = BigDec.scaledRoundHalfUp(String.valueOf(value),2);
        return value == null ? "0.00" : String.valueOf(value).trim();
    }
    public void prv2_comm(Object value) throws Exception{
        try {
            if(String.valueOf(value).trim().length()>0)
                new BigDecimal(String.valueOf(value));
            else
                value = null;
        } catch (NumberFormatException ex) {
            throw new Exception("Invalid decimal value");
        }
        value = BigDec.scaledRoundHalfUp(String.valueOf(value),2);
        person.put("base_prsn.prv2_comm",value);
    }
    public boolean prv1_good(){
        Object value = person.get("base_prsn.prv1_good");
        value = value == null ? "N" : String.valueOf(value).trim();
        return String.valueOf(value).equalsIgnoreCase("Y");
    }
    public void prv1_good(boolean value){
        person.put("base_prsn.prv1_good",value ? "Y" : "N");
    }
    public boolean prv2_good(){
        Object value = person.get("base_prsn.prv2_good");
        value = value == null ? "N" : String.valueOf(value).trim();
        return String.valueOf(value).equalsIgnoreCase("Y");
    }
    public void prv2_good(boolean value){
        person.put("base_prsn.prv2_good",value ? "Y" : "N");
    }
    public String priv_phon(){
        Object value = person.get("base_prsn.priv_phon");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void priv_phon(Object value){
        person.put("base_prsn.priv_phon",value);
    }
    public String work_phon(){
        Object value = person.get("base_prsn.work_phon");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void work_phon(Object value){
        person.put("base_prsn.work_phon",value);
    }
    public String mobi_phon(){
        Object value = person.get("base_prsn.mobi_phon");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void mobi_phon(Object value){
        person.put("base_prsn.mobi_phon",value);
    }
    public String prsn_fax(){
        Object value = person.get("base_prsn.prsn_fax");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prsn_fax(Object value){
        person.put("base_prsn.prsn_fax",value);
    }
    public String prsn_eml(){
        Object value = person.get("base_prsn.prsn_eml");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prsn_eml(Object value){
        person.put("base_prsn.prsn_eml",value);
    }
    public String clcode(){
        Object value = person.get("base_prsn.clcode");
        value = StringUtils.clearString(value);
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void clcode(Object value){
        value = String.valueOf(value);
        value = StringUtils.clearString(value);
        person.put("base_prsn.clcode",value);
    }
    public boolean vatfree(){
        Object value = person.get("base_prsn.vatfree");
        value = value == null ? "N" : String.valueOf(value).trim();
        return String.valueOf(value).equalsIgnoreCase("Y");
    }
    public void vatfree(boolean value){
        person.put("base_prsn.vatfree",value ? "Y" : "N");
    }
    public String altr_name(){
        Object value = person.get("base_prsn.altr_name");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void altr_name(Object value){
        person.put("base_prsn.altr_name",value);
    }
    public String altr_addr(){
        return StringUtils.clearString(person.get("base_prsn.alternate_address"),"");
    }
    public String prv3_idnt(){
        Object value = person.get("base_prsn.prv3_idnt");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void prv3_idnt(Object value) throws Exception{
        try {
            if(value!=null && String.valueOf(value).trim().length()>0)
                new Integer(String.valueOf(value));
            else
                value = null;
        } catch (NumberFormatException ex) {
            throw new Exception("Invalid decimal value");
        }
        person.put("base_prsn.prv3_idnt",value);
    }
    public String prv3_comm(){
        Object value = person.get("base_prsn.prv3_comm");
        value = BigDec.scaledRoundHalfUp(String.valueOf(value),2);
        return value == null ? "0.00" : String.valueOf(value).trim();
    }
    public void prv3_comm(Object value) throws Exception{
        try {
            if(String.valueOf(value).trim().length()>0 && prv3_idnt().trim().length()>0)
                new BigDecimal(String.valueOf(value));
            else
                value = null;
        } catch (NumberFormatException ex) {
            throw new Exception("Invalid decimal value");
        }
        value = BigDec.scaledRoundHalfUp(String.valueOf(value),2);
        person.put("base_prsn.prv3_comm",value);
    }
    public String birthdate(){
        Object value = person.get("base_prsn.birthdate");
        return value == null ? "" : String.valueOf(value).trim();
    }
    public void birthdate(Object value) throws Exception{
        person.put("base_prsn.birthdate",value);
    }
    public void setProv1(Person value){
        person.put("prov1",value.getPerson());
    }
    public void setProv2(Person value){
        person.put("prov2",value.getPerson());
    }
    public void setProv3(Person value){
        person.put("prov3",value.getPerson());
    }
    public Person getProv1(){
        HashMap map = (HashMap)person.get("prov1");
        Person prov1 = new Person(map);
        return prov1;
    }
    public Person getProv2(){
        HashMap map = (HashMap)person.get("prov2");
        Person prov2 = new Person(map);
        return prov2;
    }
    public Person getProv3(){
        HashMap map = (HashMap)person.get("prov3");
        Person prov2 = new Person(map);
        return prov2;
    }
    
    public void setDiscount(String value){
        value = BigDec.scaledRoundHalfUp(value,2);
        person.put("base_prsn.prsn_dscn",value);
    }
    
    public String getCntrVatPers(){
        String vat = vatfree() ? StringUtils.clearString(person.get("cntr_no_vat"),"0.00") :
            StringUtils.clearString(person.get("cntr_vat"),"0.00");
        return vat;
    }    
}
