/*
 * SharedConstants.java
 *
 * Created on , 2005,  27, 14:04
 */

package medstore;

/**
 *
 * @author JohnyEdu
 */
public interface SharedConstants {    
    
    public static final float PRINT_FONT_SIZE = 10.5f;

     public final String connectionString = "jdbc:odbc:medstore";
    public final String connectionStringOldSystem = "jdbc:odbc:isvita";

   public final int STOCK_STATUS_UNKNOWN = 2;
   public final int STOCK_STATUS_NOTPACKED = 1;
   public final int STOCK_STATUS_PACKED = 2;      

   public final int EVENT_TYPE_UNKNOWN = 0;
   public final int EVENT_TYPE_INPUT = 1;
   public final int EVENT_TYPE_OUTPUT = 2;
   public final int EVENT_TYPE_MOVETO = 3;
   public final int EVENT_TYPE_MOVEFROM = 4;
   
   public final String EVENT_TYPE_INPUT_STR = "1";
   public final String EVENT_TYPE_OUTPUT_STR = "2";
   
   public final String EVENT_TEXT_INPUT = "Move In";
   public final String EVENT_TEXT_OUTPUT = "Move Out";
   public final String EVENT_TEXT_MOVETO = "Move To";
   public final String EVENT_TEXT_MOVEFROM = "Move From";  
   
   public final int EVENT_STATUS_ACTIVE = 1;
   public final int EVENT_STATUS_NOTACTIVE = 2;
   public final int EVENT_STATUS_UNPACK = 3;
   
   public final String EVENT_STATUS_TEXT_ACTIVE = "Done";
   public final String EVENT_STATUS_TEXT_NOTACTIVE = "Undone";


   public final int STORE_ID_UNKNOWN = 1;   


   public final int DB_ERROR = 0;
   public final int DB_RECORD_EXISTS = 1;
   public final int DB_RECORD_DONTEXISTS = 2;

   public final int MedStoreNavigatorDialog_STOCK_COUNT = 1;
   public final int MedStoreNavigatorDialog_ORDER_ID = 2;
   public final int MedStoreNavigatorDialog_BARCODE = 3;   
   public final int AddStockDialog_STOCK_COUNT = 4;
   public final int AddStockDialog_STOCK_NAME = 5;
   public final int AddStockDialog_STOCK_BARCODE = 6;   
   public final int OrdersInOut_STOCK_COUNT = 7;
   public final int OrdersMoveFromTo_STOCK_COUNT = 8;   
   public final int StoreManager_STORE_NAME= 9;
   public final int MovementInOut_STOCK_COUNT = 10;
   public final int MovementInOut_BARCODE = 11;   
   public final int MovementFromTo_STOCK_COUNT = 12;
   public final int MovementFromTo_BARCODE = 13;      
   public final int EditInventoryCellEditor_INVENTORY_COUNT = 14;
   public final int OrderFullfilment_ORDERNO = 15;
   public final int OrderFullfilment_STOCK_COUNT = 16;
   public final int OrderFullfilment_BARCODE = 17;
   public final int FilterQueryDialog_DATE = 18;
   public final int Universal_Integer = 19;
   public final int Universal_Float = 20;
   public final int INTEGER_PERSENT = 21;
   public final int SCALED2_PERSENT = 23;
   public final int UNI_SCALED2_PARAMS = 24;
   public final int AddStockDialog_STOCK_GROUP = 22;
   
   public final int ANY_TABLE_ROW = 0;
   public final int SELECTED_TABLE_ROW = 1;

   public final String OPCODE_INPUT = "IN";
   public final String OPCODE_OUTPUT = "OT";
   public final String OPCODE_MOVE = "MV";
   public final String OPCODE_QUERY = "QR";
   public final String OPCODE_PACK = "UK";
   
   public final String OPNAME_INPUT = "INPUT";
   public final String OPNAME_OUTPUT = "OUTPUT";
   public final String OPNAME_MOVE = "MOVE";
   public final String OPNAME_QUERY = "QUERY";
   public final String OPNAME_PACK = "UNPACK";

  public final int NO_ERROR =  0;
  public final int UNKNOWN_BARCODE =  1;
  public final int INVALID_BALANCE =  2;
  public final int STOCK_COUNT_IN_STOR_INSERT_ERROR =  3;
  public final int STOCK_COUNT_IN_STOR_UPDATE_ERROR =  4;
  public final int STOCK_COUNT_IN_STOR_DELETE_ERROR =  5;
  public final int INVALID_OPCODE =  6;
  public final int INSERT_EVENT_ERROR =  7;
  public final int STOCK_COUNT_IN_EVENT_INSERT_ERROR =  8;  
  public final int EVENT_FOR_STORNO_NOT_FOUND =  9;
  public final int STORNO_UPDATE_EVENT_TABLE_ERROR =  10;
  public final int INSERT_TRANSACTION_EVENT_ERROR =  11; 
  public final int INSERT_EVENTS_IN_TRAN_ERROR =  12;
  public final int NO_EVENTS_FOR_TRAN_FOUND =  13;
  public final int UNPACK_AGAINST_ATOMIC_STOCK_ERROR =  14;
  public final int GENERAL_DB_ERROR =  15;
  public final int INTERNAL_SYSTEM_ERROR =  16;

  public final String STORE_TYPE_STORING = "ST";
  public final String STORE_TYPE_PACKING = "PK";
//store types 
  
  
// query filter constants
   public final int TEXT_DATE_FILTER = 1;
   public final int MONTH_DATE_FILTER = 2;
   public final int WEEK_DATE_FILTER = 3;
   public final int STOCK_FILTER = 4; 
   public final int LIMIT_PERSENT_FILTER = 5;
   public final int STORE_FILTER = 6;
   public final int YEAR_FILTER = 7;   
// query filter constants  
   
// query filter var constants
   public final String TEXT_DATE_FROM = "1";
   public final String TEXT_DATE_TO = "2";
   public final String MONTH_DATE_FROM = "3";
   public final String MONTH_DATE_TO = "4";
   public final String WEEK_DATE_FROM = "5";
   public final String WEEK_DATE_TO = "6";
   public final String STOCK_LIST = "7";
   public final String COMBO_OBJ_ID = "8";
   public final String LIMIT_PERSENT = "9";
   public final String YEAR_FILTER_VALUE = "YEAR_FILTER_VALUE";
   public final String MONTH_FILTER_VALUE = "MONTH_FILTER_VALUE";
// query filter var constants
   
// query constants  
   public final int ORDERS_AMMOUNT_QUERY =  -1;
   public final int ORDERS_HISTORY_ITEMS_QUERY =  0;
   public final int ORDERS_DETAILS_QUERY =  1; 
   public final int MOVEMENT_REVISION_QUERY = 2;
   public final int STOCK_ON_HAND_QUERY = 3;
   public final int STOCK_ON_HAND_TOTALS_QUERY = 4;
   public final int INVENTORY_CHECKOUT_QUERY = 5;
   public final int INVENTORY_CHECKOUT_DIFF_QUERY = 6;
   public final int TIME_TO_PURCHASE_QUERY = 7;
   public final int ORDERS_PENDING_QUERY =  8;
   public final int ORDERS_UNPAID_QUERY =  9;
   public final int ORDERS_HISTORY_QUERY =  10;   
   public final int ORDERS_USAGE =  11;
   public final int ORDERS_USAGE_MONTHS =  12;//
   public final int ORDERS_NUMORDERS_DAILY =  13;
   public final int ORDERS_NUMORDERS_MONTHLY =  14;
   public final int ORDERS_ACTIVE_SALES_PEOPLE_DAILY = 16;
   public final int ORDERS_ORDERS_ACTIVE_SALES_PEOPLE_MONTHLY = 17;
   public final int ORDERS_ACTIVE_CUSTOMERS_DAILY = 18;
   public final int ORDERS_ACTIVE_CUSTOMERS_MONTHLY = 19;
   public final int ORDERS_ORDERS_COMMISIONS = 20;
   public final int ORDERS_COMMISSION_AMMOUNT = 21;   
   public final int ORDERS_LETTER1 = 22;
   public final int ORDERS_LETTER2 = 23;
   public final int ORDERS_LETTER3 = 24;
   public final int ORDERS_ORDERS_COMMISIONS_BY_PERSON = 25;
   public final int RDERS_ORDERS_COMMISIONS_BY_PERSON_MA = 26;
   public final int ORDERS_ANALYSIS_MA_DR = 27;
// query constants
   
// permissions
   public final int MENU_NOT_ALLOWED = 0;
   public final int MENU_ALLOWED = 1;
// permissions
  
//person constants
  public final String DOCTOR_TEXT = "doctor"; 
  public final String DEALER_TEXT = "dealer";
//person constants   
  
  public static final int codes[][] = {
             {   '\u00E4',		0   },
             {   '!'	,		1   },
             {   '"'	,		2   },	
             {   '#'	,		3   },
             {   '$'	,		4   },
             {   '%'	,		5   },
             {   '&'	,		6   },
             {   '\''	,		7   },
             {   '('	,		8   },
             {   ')'	,		9   },
             {   '*'	,		10  },
             {   '+'	,		11  },
             {   ','	,		12  },
             {   '-'	,		13  },
             {   '.'	,		14  },
             {   '/'	,		15  },
             {   '0'	,		16  },
             {   '1'	,		17  },
             {   '2'	,		18  },
             {   '3'	,		19  },
             {   '4'	,		20  },
             {   '5'	,		21  },
             {   '6'	,		22  },
             {   '7'	,		23  },
             {   '8'	,		24  },
             {   '9'	,		25  },
             {   ':'	,		26  },
             {   ';'	,		27  },
             {   '<'	,		28  },
             {   '='	,		29  }, 
             {   '>'	,		30  },
             {   '?'	,		31  },
             {   '@'	,		32  },
             {   'A'	,		33  },
             {   'B'	,		34  },
             {   'C'	,		35  },
             {   'D'	,		36  },
             {   'E'	,		37  },
             {   'F'	,		38  },
             {   'G'	,		39  },
             {   'H'	,		40  },
             {   'I'	,		41  },
             {   'J'	,		42  },
             {   'K'	,		43  },
             {   'L'	,		44  },
             {   'N'	,		46  },
             {   'O'	,		47  } , 
             {   'P'	,		48  },
             {   'Q'	,		49  },
             {   'R'	,		50  },
             {   'S'	,		51  },
             {   'T'	,		52  },
             {   'U'	,		53  },
             {   'V'	,		54  },
             {   'W'	,		55  },
             {   'X'	,		56  },
             {   'Y'	,		57  },
             {   'Z'	,		58  },
             {   '['	,		59  },
             {   '\\'	,		60  },
             {   ']'	,		61  },
             {   '^'	,		62  },
             {   '_'	,		63  },
             {   '`'	,		64  },
             {   'a'	,		65  },
             {   'b'	,		66  },
             {   'c'	,		67  },
             {   'd'	,		68  },
             {   'e'	,		69  },
             {   'f'	,		70  },
             {   'g'	,		71  },
             {   'h'	,		72  },
             {   'i'	,		73  },
             {   'j'	,		74  },
             {   'k'	,		75  },
             {   'l'	,		76  },
             {   'm'	,		77  },
             {   'n'	,		78  },
             {   'o'	,		79  },
             {   'p'	,		80  },
             {   'q'	,		81  },
             {   'r'	,		82  },
             {   's'	,		83  },
             {   't'	,		84  },
             {   'u'	,		85  },
             {   'v'	,		86  },
             {   'w'	,		87  },
             {   'x'	,		88  },
             {   'y'	,		89  },
             {   'z'	,		90  },
             {   '\u00C2',		91  },
             {   '\u00C3',		92  },
             {   '\u00C4',		93  },
             {   '\u00C5',		94  },
             {   '\u00C6',		95  },
             {   '\u00C7', 		96  },
             {   '\u00C8', 		97  },
             {   '\u00C9',		98  },
             {   '\u00CA',		99  },
             {   '\u00CB',		100  },
             {   '\u00CC',		101  },
             {   '\u00CD',		102  }, 
             {   '\u007B',		103  },
             {   '\u007C',		104  },
             {   '\u007D',		105  },
             {   '\u007E',		-1   }           
        };
  /*public static final int codes[][] = {
             {   '?'	,		0   },
             {   '!'	,		1   },
             {   '"'	,		2   },	
             {   '#'	,		3   },
             {   '$'	,		4   },
             {   '%'	,		5   },
             {   '&'	,		6   },
             {   '\''	,		7   },
             {   '('	,		8   },
             {   ')'	,		9   },
             {   '*'	,		10  },
             {   '+'	,		11  },
             {   ','	,		12  },
             {   '-'	,		13  },
             {   '.'	,		14  },
             {   '/'	,		15  },
             {   '0'	,		16  },
             {   '1'	,		17  },
             {   '2'	,		18  },
             {   '3'	,		19  },
             {   '4'	,		20  },
             {   '5'	,		21  },
             {   '6'	,		22  },
             {   '7'	,		23  },
             {   '8'	,		24  },
             {   '9'	,		25  },
             {   ':'	,		26  },
             {   ';'	,		27  },
             {   '<'	,		28  },
             {   '='	,		29  }, 
             {   '>'	,		30  },
             {   '?'	,		31  },
             {   '@'	,		32  },
             {   'A'	,		33  },
             {   'B'	,		34  },
             {   'C'	,		35  },
             {   'D'	,		36  },
             {   'E'	,		37  },
             {   'F'	,		38  },
             {   'G'	,		39  },
             {   'H'	,		40  },
             {   'I'	,		41  },
             {   'J'	,		42  },
             {   'K'	,		43  },
             {   'L'	,		44  },
             {   'N'	,		46  },
             {   'O'	,		47  } , 
             {   'P'	,		48  },
             {   'Q'	,		49  },
             {   'R'	,		50  },
             {   'S'	,		51  },
             {   'T'	,		52  },
             {   'U'	,		53  },
             {   'V'	,		54  },
             {   'W'	,		55  },
             {   'X'	,		56  },
             {   'Y'	,		57  },
             {   'Z'	,		58  },
             {   '['	,		59  },
             {   '\\'	,		60  },
             {   ']'	,		61  },
             {   '^'	,		62  },
             {   '_'	,		63  },
             {   '`'	,		64  },
             {   'a'	,		65  },
             {   'b'	,		66  },
             {   'c'	,		67  },
             {   'd'	,		68  },
             {   'e'	,		69  },
             {   'f'	,		70  },
             {   'g'	,		71  },
             {   'h'	,		72  },
             {   'i'	,		73  },
             {   'j'	,		74  },
             {   'k'	,		75  },
             {   'l'	,		76  },
             {   'm'	,		77  },
             {   'n'	,		78  },
             {   'o'	,		79  },
             {   'p'	,		80  },
             {   'q'	,		81  },
             {   'r'	,		82  },
             {   's'	,		83  },
             {   't'	,		84  },
             {   'u'	,		85  },
             {   'v'	,		86  },
             {   'w'	,		87  },
             {   'x'	,		88  },
             {   'y'	,		89  },
             {   'z'	,		90  },
             {   '?'	,		91  },
             {   '?'	,		92  },
             {   '?'	,		93  },
             {   '?'	,		94  },
             {   '?'	,		95  },
             {   '?'	,		96  },
             {   '?'	,		97  },
             {   '?'	,		98  },
             {   '?'	,		99  },
             {   '?'	,		100  },
             {   '?'	,		101  },
             {   '?'	,		102  }, 
             {   '{'	,		103  },
             {   '|'	,		104  },
             {   '}'	,		105  },
             {   '~'	,		-1   }           
        };*/

    
}
