package medstore.date;

import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

public class DateUtil {
    private String date;
    private String delimiter;
    private SimpleDateFormat sdf = new SimpleDateFormat("dd.mm.yyyy");
    
    public DateUtil(){
        date = sdf.format(new java.util.Date());
        delimiter = ".";
    }
    public DateUtil(String date, String delimiter) {
        this.date = date;
        this.delimiter = delimiter;
    }
    
    public void setDate(String value){
        date = value;
    }
    public void setDelimiter(String value){
        delimiter = value;
    }
    
    public String getDMYtoYDM() throws Exception{
        String[] dateFields = date.split("\\" + delimiter);
        if(dateFields.length<3)
            throw new Exception("Error in Class DateUtil:\nInvalid Date Format");
        int nToDay = Integer.parseInt(dateFields[0]);
        int nToMonth = Integer.parseInt(dateFields[1]);
        int nToYear = Integer.parseInt(dateFields[2]);
        
        return nToMonth + "." + nToDay + "." + nToYear;
    }
    public String getYDMtoDMY() throws Exception{
        
        String[] dateFields = date.split("\\" + delimiter);
        if(dateFields.length<3)
            throw new Exception("Error in Class DateUtil:\nInvalid Date Format");
        int nToDay = Integer.parseInt(dateFields[1]);
        int nToMonth = Integer.parseInt(dateFields[2]);
        int nToYear = Integer.parseInt(dateFields[0]);
        
        
        return nToDay + "." + nToMonth + "." + nToYear;
    }
    
    public static String[] parseDateString(String strInput){
        strInput = strInput.replace('-', '.');
        String dateFields[] = strInput.split("\\.");
        int dfCount = dateFields.length;
        for(int i = 0; i < dfCount; i++){
            if(dateFields[i].length()<2)
                dateFields[i]="0" + dateFields[i];
            if(i==2){
                if(dateFields[2].length()==4)
                    dateFields[2] = dateFields[2].substring(2);
            }
        }
        
        String strCurrentDate = getCurrentOnlyDateStringFormatted();
        String currDateFields[] = strCurrentDate.split("\\.");
        int cdfCount = currDateFields.length;
        String strFormattedDate="";
        for(int i = 0; i < cdfCount; i++){
            if(i < dfCount)
                currDateFields[i] = dateFields[i];
        }
        return currDateFields;
    }
    public static String getCurrentOnlyDateStringFormatted() {
        Calendar calendar = Calendar.getInstance();
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month);
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day);
        if(day < 10 )
            strDay = "0" + strDay;
        String strYear = String.valueOf(year).substring(2);
        return strDay + "." + strMonth + "." + strYear;
    }
    public static String fromTimestamp(Object value, String format){
        try {
            SimpleDateFormat sdf = new SimpleDateFormat(format);
            Timestamp t = (Timestamp)value;
            Date d = new Date(t.getTime());
            return sdf.format(d);
        } catch(Exception e) {               
            return String.valueOf(value);
        }
    }
}
