package medstore.main;

import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.JFrame;
import javax.swing.table.TableModel;
import medstore.*;
import medstore.orders.OrdersPlacement;
import medstore.orders.fullfilment.OrderFullfilment;
import medstore.stock.AllStocks;
import medstore.remote.io.stock.RemoteStocks;
import medstore.stock.nomenclature.StockListForm;

public class MainMenu extends javax.swing.JFrame{
    
    private Main main;
    private StockListForm stockListForm;
    private OrderFullfilment orderFullfilment;
    
    public MainMenu(Main main) {
        super("Medstore Navigator");
        try {
            this.main = main;
            initComponents();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        mainMenuBar = new javax.swing.JMenuBar();
        File = new javax.swing.JMenu();
        fileLogin = new javax.swing.JMenuItem();
        fileExit = new javax.swing.JMenuItem();
        stocksMenu = new javax.swing.JMenu();
        stockAdmin = new javax.swing.JMenuItem();
        stocksAll = new javax.swing.JMenuItem();
        menuOrders = new javax.swing.JMenu();
        mitemOrderFullfilment = new javax.swing.JMenuItem();
        mitemPlaceOrders = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        File.setText("File");
        File.setFont(new java.awt.Font("Arial", 1, 12));
        fileLogin.setFont(new java.awt.Font("Arial", 1, 12));
        fileLogin.setText("Login");
        fileLogin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileLoginActionPerformed(evt);
            }
        });

        File.add(fileLogin);

        fileExit.setFont(new java.awt.Font("Arial", 1, 12));
        fileExit.setText("Exit");
        fileExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileExitActionPerformed(evt);
            }
        });

        File.add(fileExit);

        mainMenuBar.add(File);

        stocksMenu.setText("Nomenclatures");
        stocksMenu.setFont(new java.awt.Font("Arial", 1, 12));
        stockAdmin.setFont(new java.awt.Font("Arial", 1, 12));
        stockAdmin.setText("Stocks, Admin ...");
        stockAdmin.setEnabled(false);
        stockAdmin.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stockAdminActionPerformed(evt);
            }
        });

        stocksMenu.add(stockAdmin);

        stocksAll.setFont(new java.awt.Font("Arial", 1, 12));
        stocksAll.setText("All Stocks");
        stocksAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                stocksAllActionPerformed(evt);
            }
        });

        stocksMenu.add(stocksAll);

        mainMenuBar.add(stocksMenu);

        menuOrders.setText("Orders  ");
        menuOrders.setFont(new java.awt.Font("Arial", 1, 12));
        menuOrders.setName("ord");
        mitemOrderFullfilment.setFont(new java.awt.Font("Arial", 1, 12));
        mitemOrderFullfilment.setText("Order Fullfilment");
        mitemOrderFullfilment.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemOrderFullfilmentActionPerformed(evt);
            }
        });

        menuOrders.add(mitemOrderFullfilment);

        mitemPlaceOrders.setBackground(new java.awt.Color(236, 233, 216));
        mitemPlaceOrders.setFont(new java.awt.Font("Arial", 1, 12));
        mitemPlaceOrders.setText("Place Orders");
        mitemPlaceOrders.setName("ord_plc");
        mitemPlaceOrders.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemPlaceOrdersactionPerformed(evt);
            }
        });

        menuOrders.add(mitemPlaceOrders);

        mainMenuBar.add(menuOrders);

        setJMenuBar(mainMenuBar);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 530, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 2, Short.MAX_VALUE)
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void mitemOrderFullfilmentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemOrderFullfilmentActionPerformed
        if(orderFullfilment == null){
            orderFullfilment = new OrderFullfilment(main);            
            orderFullfilment.addWindowListener(new WindowListener() {
                public void windowActivated(WindowEvent e) {
                }
                public void windowClosed(WindowEvent e) {
                    orderFullfilment.stopThread();
                    orderFullfilment = null;
                    System.out.println("closed");
                }
                public void windowClosing(WindowEvent e) {
                }
                public void windowDeactivated(WindowEvent e) {
                }
                public void windowDeiconified(WindowEvent e) {
                }
                public void windowIconified(WindowEvent e) {
                }
                public void windowOpened(WindowEvent e) {
                }
            });
        }
        
        orderFullfilment.setVisible(true);
    }//GEN-LAST:event_mitemOrderFullfilmentActionPerformed
    
    private void stockAdminActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stockAdminActionPerformed
        
        if(stockListForm==null)
            stockListForm = new StockListForm(main);
        stockListForm.loadProducts();
        stockListForm.setVisible(true);
    }//GEN-LAST:event_stockAdminActionPerformed
    
    private void stocksAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_stocksAllActionPerformed
        try{
            TableModel model = RemoteStocks.getAllStocks(main.user);
            AllStocks allStocks = new AllStocks();
            allStocks.setStockModel(model);
            allStocks.setVisible(true);
        } catch(Exception e){
            e.printStackTrace();
        }
    }//GEN-LAST:event_stocksAllActionPerformed
    
    private void mitemPlaceOrdersactionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemPlaceOrdersactionPerformed
        OrdersPlacement op = new OrdersPlacement(main);
        op.setVisible(true);
    }//GEN-LAST:event_mitemPlaceOrdersactionPerformed
    
    private void fileLoginActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileLoginActionPerformed
        dispose();
        main.Login();
    }//GEN-LAST:event_fileLoginActionPerformed
    
    private void fileExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileExitActionPerformed
        Main.exit();
    }//GEN-LAST:event_fileExitActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenu File;
    private javax.swing.JMenuItem fileExit;
    private javax.swing.JMenuItem fileLogin;
    private javax.swing.JMenuBar mainMenuBar;
    private javax.swing.JMenu menuOrders;
    private javax.swing.JMenuItem mitemOrderFullfilment;
    private javax.swing.JMenuItem mitemPlaceOrders;
    private javax.swing.JMenuItem stockAdmin;
    private javax.swing.JMenuItem stocksAll;
    private javax.swing.JMenu stocksMenu;
    // End of variables declaration//GEN-END:variables
    
}
