package medstore.model;

import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.LinkedHashMap;
import java.util.Vector;

public class ColumnSorter implements Comparator {
    int colIndex;
    boolean ascending;
    
    public ColumnSorter(int colIndex, boolean ascending) {
        this.colIndex = colIndex;
        this.ascending = ascending;
    }
    public int compare(Object a, Object b) {
        LinkedHashMap v1 = ((LinkedHashMap)a);
        LinkedHashMap v2 = ((LinkedHashMap)b);
        v1 = v1 == null ? v2 : v1;
        v2 = v2 == null ? v1 : v2;
        
        if(v1==null || v2==null){
            return 0;
        }
        
        Object[] keyArray = v1.keySet().toArray();
        String key = String.valueOf(keyArray[Math.min(colIndex,keyArray.length-1)]);
        
        Object o1 = ascending ? v1.get(key) : v2.get(key);
        Object o2 = ascending ? v2.get(key) : v1.get(key);
        
        boolean is_decimal = false;
        
        try{
            new Float(o1.toString().trim());
            new Float(o2.toString().trim());
            is_decimal = true;
        } catch(Exception e){
            
        }
        try{
            String[] dateArr1 = o1.toString().split("\\.");
            String[] dateArr2 = o2.toString().split("\\.");
            
            if(dateArr1.length == 3 && dateArr2.length == 3){                
                Calendar calendar = Calendar.getInstance();
                calendar.set(Calendar.DAY_OF_MONTH, new Integer(dateArr1[0]));
                calendar.set(Calendar.MONTH,new Integer(dateArr1[1])-1);
                calendar.set(Calendar.YEAR,new Integer(dateArr1[2]));
                
                Date d1 = calendar.getTime();
                
                calendar = Calendar.getInstance();
                calendar.set(Calendar.DAY_OF_MONTH, new Integer(dateArr2[0]));
                calendar.set(Calendar.MONTH,new Integer(dateArr2[1])-1);
                calendar.set(Calendar.YEAR,new Integer(dateArr2[2]));
                
                Date d2 = calendar.getTime();
                
                return d1.compareTo(d2);
            }
            else{
               
            }
            
        } catch(Exception e){
           
        }
        if(is_decimal){
            return new Float(o1.toString()).compareTo(new Float(o2.toString()));
        } else{
            return o1.toString().compareToIgnoreCase(o2.toString());
        }
    }
    public static HashTableModel sortColumn(HashTableModel model, int colIndex, boolean ascending) {
        Vector data = model.getDataVector();
        Collections.sort(data, new ColumnSorter(colIndex, ascending));
        model.fireTableStructureChanged();
        return model;
    }
}