package medstore.model;

import java.util.Vector;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultSingleSelectionModel;
import javax.swing.event.ListDataListener;

public class ComboDataModel extends DefaultSingleSelectionModel implements ComboBoxModel{
    Vector vecData;
    
    public ComboDataModel(Vector data) {
        vecData = new Vector();
        try{
            if(data==null){
                return;
            }
            int nColumnCount = data.size();
            
            for( int i = 0; i < data.size(); i++  ) {
                Vector row = (Vector)data.get(i);                
                String name = row.get(0).toString();
                int key = Integer.parseInt(row.get(1).toString());                
                vecData.addElement(new ComboDataRow(name.toString(),key));                
            }
        } catch(Exception e){
            e.printStackTrace();
        }        
    }
    public Object getElementAt(int index) {
        return (String)((ComboDataRow)vecData.get(index)).strComboItem;
    }
    public ComboDataRow getCObjectAt(int index) {
        return (ComboDataRow)vecData.get(index);
    }
    public void insertCObjectAt(int index, ComboDataRow cdrRow) {
        vecData.insertElementAt(cdrRow,index);
    }
    
    public int getSize() {
        return(vecData.size());
    }
    
    public void addListDataListener(ListDataListener l) {
        
    }
    
    public void removeListDataListener(ListDataListener l) {
        
    }
    
    public Object getSelectedItem() {
        if(vecData!=null) {
            if(vecData.size()>0) {
                final int nSelIndex = getSelectedIndex();
                if(nSelIndex != -1)
                    return ((ComboDataRow)vecData.get(nSelIndex)).strComboItem;
                return ((ComboDataRow)vecData.get(0)).strComboItem;
            }
        }
        return null;
    }
    
    public void setSelectedItem(Object obj) {
        for(int index=0;index<vecData.size();index++) {
            if(((ComboDataRow)vecData.get(index)).strComboItem.equals((String)obj)) {
                setSelectedIndex(index);
                fireStateChanged();
                break;
            }
        }
    }
    
    public int getSelectedIndex(){
        return super.getSelectedIndex();
    }
    public void setSelectedIndex(int index){
        super.setSelectedIndex(index);
    }
    public void selectIndexByContent(Object obj) {
        for(int index=0;index<vecData.size();index++) {
            if(((ComboDataRow)vecData.get(index)).strComboItem.equals((String)obj)) {
                setSelectedIndex(index);
                break;
            }
        }
    }
    
    public void selectIndexByKey(int nDBItem){
        for(int index=0;index<vecData.size();index++) {
            if(((ComboDataRow)vecData.get(index)).nItemDBKey == nDBItem) {
                setSelectedIndex(index);
                break;
            }
        }
    }
    public void removeAll(){
        vecData = new Vector();
    }
    public Vector getDataVector(){
        return vecData;
    }
}
