package medstore.model;
import java.util.LinkedHashMap;
import javax.swing.AbstractListModel;
import javax.swing.ListModel;
import javax.swing.event.TableModelListener;
import javax.swing.table.TableModel;

public class MixedDataModel extends AbstractListModel implements ListModel, TableModel{
    HashTableModel tableModel;
    public MixedDataModel(HashTableModel tableModel) {
        this.tableModel = tableModel;
    }
    
    public Object getValueAt(int rowIndex, int columnIndex) {
        
        return tableModel.getValueAt(rowIndex, columnIndex);
    }
    public void setValueAt(Object value, int row, int col){
        tableModel.setValueAt(value, row, col);
    }
    
    public Object getElementAt(int index){
        return tableModel.getValueAt(index, 0);
    }
    public boolean addRow(LinkedHashMap el){
        if(isExist(el))
            return false;
        
        tableModel.addRow(el);
        tableModel.fireTableDataChanged();
        
        return true;
    }
    public LinkedHashMap getRow(int index){
        return tableModel.getRowAt(index);
    }
    public int getSize(){
        return tableModel.getRowCount();
    }
    public void removeRow(int i){
        tableModel.removeRow(i);
        tableModel.fireTableDataChanged();
    }
    public boolean isExist(LinkedHashMap el){
        
        //if(!tableModel.objectExistsAt(el.getRowElement(CompositeProduct.poduct_index), CompositeProduct.poduct_index)){
            return false;
        //}
        
        //return true;
    }
    
    public boolean isCellEditable(int row, int col){
        if(col==1)
            return true;
        return false;
    }
    public Class getColumnClass(int c){
        return tableModel.getColumnClass(c);
    }
    public String getColumnName(int col){
        return tableModel.getColumnName(col);
    }
    public int getColumnCount(){
        return tableModel.getColumnCount();
    }
    public int getRowCount(){
        return tableModel.getRowCount();
    }
    
    public void removeTableModelListener(TableModelListener l){
        
    }
    public void addTableModelListener(TableModelListener l){
        
    }
}
