package medstore.model;

import javax.swing.JTable;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

public class TableUtils {
    public static void setTableColumnsWidth(JTable table, int[] widths){
        int columns = widths.length;
        for(int i=0;i<columns;i++){
            try{
                TableColumn col = table.getColumnModel().getColumn(i);
                col.setPreferredWidth(widths[i]);
            } catch (Exception e) {
            }
            
        }
        try {
            table.updateUI();
        } catch (Exception e) {
        }
    }
    public static void setTableHeader(JTable table){
        table.getTableHeader().setFont(new java.awt.Font("Arial", 1, 12));
    }
    public static void setColumnSorter(JTable table){
        table.getTableHeader().addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent e) {
                JTableHeader h = (JTableHeader)e.getSource();
                TableColumnModel columnModel = h.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX());
                int column = columnModel.getColumn(viewColumn).getModelIndex();
                ((HashTableModel)h.getTable().getModel()).sortColumn(column);
                h.getTable().updateUI();
            }
        });
    }
    public static void setColumnWidth( JTable table, int columnIndex, int preferredWidth ) {
        TableColumn col = table.getColumnModel().getColumn(columnIndex);
        col.setPreferredWidth(preferredWidth);
    }
    
    public static void setHorizontalAlignment( JTable table, int columnIndex, int align ) {
        DefaultTableCellRenderer tcrColumn = new DefaultTableCellRenderer();
        tcrColumn.setHorizontalAlignment(align);
        table.getColumnModel().getColumn(columnIndex).setCellRenderer(tcrColumn);
        
    }
}
