package medstore.orders;

import java.awt.Dialog;
import java.awt.Window;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import medstore.forms.FormConvertor;

public class AlternateAddressPanel extends javax.swing.JPanel {
    private AlternateAddress altAddress;
    private String address;
    private boolean isPermanent;
    public AlternateAddressPanel() {
        initComponents();
        address = "";
        isPermanent = false;
    }
    public void setAlternateAddress(String text){
        address = "null".equalsIgnoreCase(text) ? "" : text;        
    }
    public String getAlternateAddress() throws Exception{
        if(chkbAltAddress.isSelected() && (altAddress==null || altAddress.getAddress().length()<=0)){
            throw new Exception("Type Alternate Address, or uncheck this option!");
        }
        return altAddress == null ? "" : altAddress.getAddress();
    }
    public boolean isPermanent() {
        return altAddress == null ? false : altAddress.isPermanent();
    }

    public void setIsPermanent(boolean isPermanent) {
        this.isPermanent = isPermanent;
    }

    public void setPreview(){
        if(address.trim().length()>0){
            btnSet.setText("View address");
            chkbAltAddress.setEnabled(false);
            btnSet.setEnabled(true);
        } else{
            btnSet.setText("Set Address");
            chkbAltAddress.setEnabled(false);
            btnSet.setEnabled(false);
        }
    }
    public void clearComtrols(){
        btnSet.setText("Set Address");
        chkbAltAddress.setEnabled(true);
        btnSet.setEnabled(true);
        address="";
        isPermanent = false;
    }
    public void enableControls(boolean value){
        chkbAltAddress.setEnabled(value);
        btnSet.setEnabled(value);
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        chkbAltAddress = new javax.swing.JCheckBox();
        btnSet = new javax.swing.JButton();

        chkbAltAddress.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkbAltAddress.setText("Use alternate address");
        chkbAltAddress.setMaximumSize(new java.awt.Dimension(163, 25));
        chkbAltAddress.setMinimumSize(new java.awt.Dimension(163, 25));
        chkbAltAddress.setName("chkAltAddress");
        chkbAltAddress.setPreferredSize(new java.awt.Dimension(163, 25));

        btnSet.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSet.setText("Set Address");
        btnSet.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSet.setName("btnOPSetAltAddress");
        btnSet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSetactionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(chkbAltAddress, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(10, 10, 10)
                .add(btnSet))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                .add(chkbAltAddress, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(btnSet))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void btnSetactionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSetactionPerformed
        
        
        final Window w = SwingUtilities.windowForComponent(this);
        Dialog parWin  = FormConvertor.convertor(w);
        altAddress = new AlternateAddress(parWin);
        altAddress.setAddress(address);
        altAddress.setPermanent(isPermanent);
        altAddress.setVisible(true);
        altAddress.addWindowListener(new WindowListener() {
            public void windowActivated(WindowEvent e) {
            }
            public void windowClosed(WindowEvent e) {
            }
            public void windowClosing(WindowEvent e) {
            }
            public void windowDeactivated(WindowEvent e) {
                address = altAddress.getAddress();
            }
            public void windowDeiconified(WindowEvent e) {
            }
            public void windowIconified(WindowEvent e) {
            }
            public void windowOpened(WindowEvent e) {
            }
        });
        
    }//GEN-LAST:event_btnSetactionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSet;
    private javax.swing.JCheckBox chkbAltAddress;
    // End of variables declaration//GEN-END:variables
    
}
