
package medstore.orders;

import holders.User;
import java.awt.Dialog;
import java.util.HashMap;
import javax.swing.JOptionPane;
import medstore.Base;
import medstore.String.StringUtils;
import medstore.forms.CommonDialog;

public class MacroEditDialog extends CommonDialog {
        
    private Base base;
    private User user;
    public MacroEditDialog(Dialog parent) {        
        super(parent,true);
        initComponents();          
    }
    public void setBase(Base base){
        this.base = base;
        user = base.getUser();
        afterInitComponets();
    }

    public void setMacros(HashMap macros){
        tpMacro1.setText(StringUtils.clearString(macros.get("macro1")));
        tpMacro2.setText(StringUtils.clearString(macros.get("macro2")));
        tpMacro3.setText(StringUtils.clearString(macros.get("macro3")));
        int active = 0;
        try {
            active = user.getActiveMacro();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        switch(active){
            case 1: rbMacro1.setSelected(true); return;
            case 2: rbMacro2.setSelected(true); return;
            case 3: rbMacro3.setSelected(true); return;
            default: JOptionPane.showMessageDialog(null, "Select default Macro!"); return;
        }
    }
    
    private void afterInitComponets(){
        
        HashMap macros = new HashMap();
        try {
            macros = MacroUtils.loadMacros(user);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        setMacros(macros);
    }
    public String getMacroText(){
        if(rbMacro1.isSelected())
            return tpMacro1.getText();
        if(rbMacro2.isSelected())
            return tpMacro2.getText();
        if(rbMacro3.isSelected())
            return tpMacro3.getText();
        return "";
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        buttonGroup1 = new javax.swing.ButtonGroup();
        jScrollPane2 = new javax.swing.JScrollPane();
        tpMacro1 = new javax.swing.JTextPane();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jScrollPane3 = new javax.swing.JScrollPane();
        tpMacro2 = new javax.swing.JTextPane();
        jScrollPane1 = new javax.swing.JScrollPane();
        tpMacro3 = new javax.swing.JTextPane();
        jPanel5 = new javax.swing.JPanel();
        rbMacro1 = new javax.swing.JRadioButton();
        rbMacro2 = new javax.swing.JRadioButton();
        rbMacro3 = new javax.swing.JRadioButton();
        jPanel1 = new javax.swing.JPanel();
        btnOK = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        btnSave = new javax.swing.JButton();

        setTitle("Edit Macros");
        tpMacro1.setFont(new java.awt.Font("Tahoma", 0, 13));
        jScrollPane2.setViewportView(tpMacro1);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText(" Macro 1");

        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText(" Macro 2");

        jLabel3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel3.setText(" Macro 3");

        tpMacro2.setFont(new java.awt.Font("Tahoma", 0, 13));
        jScrollPane3.setViewportView(tpMacro2);

        tpMacro3.setFont(new java.awt.Font("Tahoma", 0, 13));
        jScrollPane1.setViewportView(tpMacro3);

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Active Macro", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 13)));
        jPanel5.setPreferredSize(new java.awt.Dimension(422, 60));
        buttonGroup1.add(rbMacro1);
        rbMacro1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        rbMacro1.setText("Macro 1");

        buttonGroup1.add(rbMacro2);
        rbMacro2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        rbMacro2.setText("Macro 2");

        buttonGroup1.add(rbMacro3);
        rbMacro3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        rbMacro3.setText("Macro 3");

        org.jdesktop.layout.GroupLayout jPanel5Layout = new org.jdesktop.layout.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .add(34, 34, 34)
                .add(rbMacro1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(30, 30, 30)
                .add(rbMacro2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(30, 30, 30)
                .add(rbMacro3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel5Layout.createSequentialGroup()
                .add(20, 20, 20)
                .add(jPanel5Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(rbMacro1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(rbMacro2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(rbMacro3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
        );

        btnOK.setFont(new java.awt.Font("Arial", 1, 12));
        btnOK.setText("OK");
        btnOK.setPreferredSize(new java.awt.Dimension(73, 25));
        btnOK.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MacroEditDialog.this.actionPerformed(evt);
            }
        });

        btnCancel.setFont(new java.awt.Font("Arial", 1, 12));
        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MacroEditDialog.this.actionPerformed(evt);
            }
        });

        btnSave.setFont(new java.awt.Font("Arial", 1, 12));
        btnSave.setText("Save");
        btnSave.setPreferredSize(new java.awt.Dimension(73, 25));
        btnSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSaveActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(41, 41, 41)
                .add(btnOK, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(64, 64, 64)
                .add(btnSave, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(85, 85, 85)
                .add(btnCancel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(53, 53, 53))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnSave, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnOK, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnCancel))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jLabel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 440, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 440, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 150, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 440, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jPanel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 440, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 460, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(10, 10, 10)
                .add(jLabel1)
                .add(2, 2, 2)
                .add(jScrollPane2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 113, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(10, 10, 10)
                .add(jLabel2)
                .add(2, 2, 2)
                .add(jScrollPane3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 113, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(10, 10, 10)
                .add(jLabel3)
                .add(2, 2, 2)
                .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 113, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(14, 14, 14)
                .add(jPanel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 68, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-468)/2, (screenSize.height-589)/2, 468, 589);
    }// </editor-fold>//GEN-END:initComponents

    private void btnSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSaveActionPerformed
        
        int active_macro = 0;
        
        if(rbMacro1.isSelected())
            active_macro = 1;
        if(rbMacro2.isSelected())
            active_macro = 2;
        if(rbMacro3.isSelected())
            active_macro = 3;
        
        HashMap macros = new HashMap();
        macros.put("macro1",tpMacro1.getText());
        macros.put("macro2",tpMacro2.getText());
        macros.put("macro3",tpMacro3.getText());        
        macros.put(User.active_macro,active_macro);
        try {
            boolean saved = MacroUtils.saveMacros(user,macros);
            if(saved){
                JOptionPane.showMessageDialog(null,"Macros Saved");
            }
            else{
                JOptionPane.showMessageDialog(null,"Unknown Error: Macros Not Saved");
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null,"Error: Macros Not Saved\n"+ex.getMessage());
        }
        user.setActiveMacro(String.valueOf(active_macro));
    }//GEN-LAST:event_btnSaveActionPerformed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        setVisible(false);        
    }//GEN-LAST:event_actionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnOK;
    private javax.swing.JButton btnSave;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JRadioButton rbMacro1;
    private javax.swing.JRadioButton rbMacro2;
    private javax.swing.JRadioButton rbMacro3;
    private javax.swing.JTextPane tpMacro1;
    private javax.swing.JTextPane tpMacro2;
    private javax.swing.JTextPane tpMacro3;
    // End of variables declaration//GEN-END:variables
    
}
