package medstore.orders;

import holders.User;
import holders.orders.Order;
import holders.person.Person;
import java.math.BigDecimal;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;
import medstore.Base;
import medstore.String.StringUtils;
import medstore.date.DateUtil;
import medstore.math.BigDec;
import medstore.model.ComboDataModel;
import medstore.model.ComboDataRow;
import medstore.model.HashTableModel;
import medstore.person.BasePersonPanel;
import medstore.print.orders.OrderPrintUtils;
import medstore.remote.io.forms.RemotePersonSearch;
import medstore.stock.BaseStockSelection;
import medstore.stock.Stock;
import medstore.verifiers.UniversalInputVerifier;

public class OrdersPlacement extends javax.swing.JFrame
        implements BaseOrdersPanel, BaseStockSelection, BasePersonPanel, BasePlaceOrderPanel, BaseStockTable {
    
    private User user;
    
    public OrdersPlacement(Base base) {
        super("Order Plcaement");
        initComponents();
        editPayDate.setInputVerifier(new UniversalInputVerifier(UniversalInputVerifier.UNI_DATE_VERIFIER));
        
        user = base.getUser();
        setLocationByPlatform(true);
        stockTablePanel.setProductsModel(null);
        ComboDataModel c_model = new ComboDataModel(null);
        c_model.insertCObjectAt(0,new ComboDataRow("Invoice",1));
        c_model.insertCObjectAt(1,new ComboDataRow("Credit Note",2));
        comboDocType.setModel(c_model);
        
        tableSumsPanel.prepareSumsTable();
        placeControls4Invoice();
        
        
        selectStockPane1.setBase(this);
        ordersPanel.setBase(this);
        personPanel.setBase(this);
        placeOrderPanel.setBase(this);
        stockTablePanel.setBase(this);
        selectStockPane1.loadStocks();
        stockTablePanel.loadCampaign();
        prepareNewOrder();
    }
    
    public void prepareNewOrder(){
        clearControls();
        
        enableLeftSide(true);
        
        tableSumsPanel.clearControls();
        selectStockPane1.diasableControls(true);
        
        placeOrderPanel.disableBtnPlace(false);
        placeOrderPanel.disableBtnPay(false);
        placeOrderPanel.btnCancel_CancelOrder();
        
        ordersPanel.getBtnPrintInvoice().setEnabled(false);
        ordersPanel.getBtnPrintPacking().setEnabled(false);
        ordersPanel.getBtnCreditNote().setEnabled(false);
        ordersPanel.getTblOrders().clearSelection();
        
        alternateAddressPanel.clearComtrols();
        alternateAddressPanel.setAlternateAddress(personPanel.getAltAddress());
        
        personPanel.reload();
        
        tableSumsPanel.prepareSumsTable();
        tableSumsPanel.setVatPers(personPanel.getVatPers());
        tableSumsPanel.setDiscount(personPanel.getEditDiscount());
        
        tableSumsPanel.calculate(false);
        
    }
    String old_vnr = "";
    OrderPrintUtils op;
    
    public void print(int what) throws Exception{
        String v_nr = editDocNo.getText();
        old_vnr = old_vnr != null ? old_vnr : v_nr;
        if(!old_vnr.equals(v_nr)) {
            op = null;
            op = op != null ? op : new OrderPrintUtils(editDocNo.getText(), user);
        }
        switch (what){
            case 1 : op.printInvoice(true); return;
            case 2 : op.printPacking(true); return;
        }
    }
    private String calculatePercents(){
        String strUIN = personPanel.getEditUIN();
        String strProv1Idnt = personPanel.getEditProv1UIN();
        String strProv2Idnt = personPanel.getEditProv2UIN();
        String strProv3Idnt = personPanel.getEditProv3UIN();
        
        double discount = 0;
        try{
            discount = Double.parseDouble( personPanel.getEditDiscount());
        } catch(Exception e){
            discount = 0;
        }
        
        double prov1Pers = 0;
        try{
            prov1Pers = Double.parseDouble( personPanel.getEditProv1Pers() );
        } catch(Exception e){
            prov1Pers = 0;
        }
        
        double prov2Pers = 0;
        try{
            prov2Pers = Double.parseDouble( personPanel.getEditProv2Pers() );
        } catch(Exception e){
            prov2Pers = 0;
        }
        
        double prov3Pers = 0;
        try{
            prov3Pers = Double.parseDouble( personPanel.getEditProv3Pers() );
        } catch(Exception e){
            prov3Pers = 0;
        }
        
        {
            if(discount + prov1Pers>50){
                double calc = 50 - discount;
                prov1Pers = calc > 0 ? calc : 0;
            }
            if(discount + prov1Pers + prov2Pers > 50){
                double calc = 50 - ( discount + prov1Pers );
                prov2Pers = calc > 0 ? calc : 0;
            }
            if(discount + prov1Pers + prov2Pers + prov3Pers > 50){
                double calc = 50 - (discount + prov1Pers + prov2Pers);
                prov3Pers = calc > 0 ? calc : 0;
            }
        }
        
        personPanel.setEditProv1Pers(BigDec.scaledRoundHalfUp(prov1Pers,2));
        personPanel.setEditProv2Pers(BigDec.scaledRoundHalfUp(prov2Pers,2));
        personPanel.setEditProv3Pers(BigDec.scaledRoundHalfUp(prov3Pers,2));
        
        if( strUIN.equals( strProv1Idnt )  ) {
            discount += prov1Pers;
            prov1Pers = 0;
            personPanel.setEditProv1Pers("0.00");
        }
        if( strUIN.equals( strProv2Idnt )  ) {
            discount += prov2Pers;
            prov2Pers = 0;
            personPanel.setEditProv2Pers("0.00");
        }
        if( strUIN.equals( strProv3Idnt)  ) {
            discount += prov3Pers;
            prov3Pers = 0;
            personPanel.setEditProv3Pers("0.00");
        }
        String strDiscount = BigDec.scaledRoundHalfUp(discount,2);
        personPanel.setDiscount(strDiscount);
        tableSumsPanel.setDiscount(strDiscount);
        return strDiscount;
        
    }
    public boolean canSelectStock(){
        if(!personPanel.isPersonSelected()){
            JOptionPane.showMessageDialog(this,"Select patient!");
            personPanel.getBtnSearchClient().doClick(100);
            return false;
        }
        if(!personPanel.isProvSelected(1)){
            JOptionPane.showMessageDialog(this,"Select provision 1!");
            personPanel.getBtnDoctors().doClick(100);
            return false;
        }
        if(!personPanel.isProvSelected(2)){
            JOptionPane.showMessageDialog(this,"Select provision 2!");
            personPanel.getBtnDealers().doClick(100);
            return false;
        }
        return true;
    }
    public void altNameChanged(){
        
    }
    public void discountChanged(){
        
    }
    public Object getPerson(String uid){
        try {
            HashMap data = RemotePersonSearch.loadPerson(user,uid);
            return data;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return null;
    }
    public void placeOrder(){
        try{
            String patn_idnt = personPanel.getEditUIN();
            
            String patn_dscn = tableSumsPanel.getDiscount();
            String prv1_idnt = personPanel.getEditProv1UIN();
            String prv1_comm = personPanel.getEditProv1Pers();
            String prv1_name = personPanel.getEditProv1Name();
            String prv2_idnt = personPanel.getEditProv2UIN();
            String prv2_comm = personPanel.getEditProv2Pers();
            String invc_addr = alternateAddressPanel.getAlternateAddress();
            String oper_idnt = user.getUID();
            String pay_sum = StringUtils.clearString(editPayed.getText(),"0");
            String neto_sum = tableSumsPanel.getNetto();
            String totl_sum = tableSumsPanel.getTotl_sum();
            String altr_name = personPanel.getEditAlternateName();
            String patn_cntr = personPanel.getEditCountry();
            String patn_city = personPanel.getEditCity();
            String patn_code = personPanel.getEditCode();
            String patn_strt = personPanel.getEditStreet();
            String invc_prto = tableSumsPanel.getInvc_prto();
            String prv3_idnt = personPanel.getEditProv3UIN();
            String prv3_comm = personPanel.getEditProv3Pers();
            String macro1text = ordersPanel.getMacroText();
            String cntr_idnt = String.valueOf(personPanel.getCntrIdnt());
            
            HashMap order = new HashMap();
            order.put(Order.PATN_IDNT, patn_idnt);
            order.put(Order.PATN_DSCN, patn_dscn);
            order.put(Order.PROV1_IDNT, prv1_idnt);
            order.put(Order.PROV1_COMM, prv1_comm);
            order.put("prv1_name", prv1_name);
            order.put(Order.PROV2_IDNT, prv2_idnt);
            order.put(Order.PROV2_COMM, prv2_comm);
            order.put(Order.INVC_ADDR, invc_addr);
            order.put(Order.oper_idnt, oper_idnt);
            order.put(Order.PAY_SUM, pay_sum);
            order.put(Order.NETO_SUM, neto_sum);
            order.put(Order.TOTL_SUM, totl_sum);
            order.put(Order.ALT_NAME, altr_name);
            order.put(Order.PATN_CNTR, patn_cntr);
            order.put(Order.PATN_CITY, patn_city);
            order.put(Order.PATN_CODE, patn_code);
            order.put(Order.PATN_STRT, patn_strt);
            order.put(Order.INVC_PRTO, invc_prto);
            order.put(Order.PROV3_IDNT, prv3_idnt);
            order.put(Order.PROV3_COMM, prv3_comm);
            order.put(Order.macro1text, macro1text);
            order.put("cntr_idnt", cntr_idnt);
            
            HashMap settings = new HashMap();
            settings.put("permanent",new Boolean(alternateAddressPanel.isPermanent()));
            
            Vector stock = stockTablePanel.getProducts();
            HashMap data = new HashMap();
            data.put("order",order);
            data.put("stock",stock);
            data.put("settings",settings);
            
            try {
                String v_nr = RemotePersonSearch.placeOrder(user,data);
                loadOrders(v_nr);
            } catch (Exception ex) {
                ex.printStackTrace();
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            JOptionPane.showMessageDialog(this,ex.getMessage());
        }
        
    }
    public void payOrder(){
        HashMap data = new HashMap();
        if(!UniversalInputVerifier.DATE_Verifier(editPayDate)){
            JOptionPane.showMessageDialog(this,"Invalid Pay Date!");
            return;
        }
        try{
            new BigDecimal(editPayed.getText());
        } catch(Exception e){
            JOptionPane.showMessageDialog(this,"Invalid Pay Sum!");
            e.printStackTrace();
            return;
        }
        
        data.put(Order.PAY_SUM,editPayed.getText());
        data.put(Order.PAY_DATE,editPayDate.getText());
        data.put(Order.V_NR,editDocNo.getText());
        
        try {
            RemotePersonSearch.payOrder(user,data);
            loadOrders(editDocNo.getText());
            int row = ((HashTableModel)ordersPanel.getTblOrders().getModel()).getContentIndex(Order.V_NR,editDocNo.getText());
            ordersPanel.getTblOrders().setRowSelectionInterval(row,row);
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    public void creditNote(){
        HashMap data = new HashMap();
        data.put(Order.V_NR,editDocNo.getText());
        try {
            String v_nr = RemotePersonSearch.creditNote(user,data);
            loadOrders(v_nr);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    public Object getStocks(){
        return stockTablePanel.getProducts();
    }
    public Object getStockSelected(){
        return selectStockPane1.getStockSelected();
    }
    public void setSelectedStock(Object value){
        if(value==null)
            return;
        
        LinkedHashMap row = (LinkedHashMap)value;
        int nRow = stockTablePanel.stockRowExsits(row);
        if(nRow > -1){
            int i = JOptionPane.showConfirmDialog(this,"Stock exist, do you want to replace it?",
                    "Stock exist", JOptionPane.YES_NO_OPTION);
            if(i==JOptionPane.NO_OPTION)
                return;
            if(i==JOptionPane.YES_OPTION){
                stockTablePanel.removeRow(nRow);
            }
        }
        Object count = row.get(Stock.count);
        LinkedHashMap new_row = stockTablePanel.fmtNewStock((LinkedHashMap)value,count);
        
        stockTablePanel.addRow(new_row);
        enableLeftSide(false);
        placeOrderPanel.disableBtnPlace(true);
        selectStockPane1.diasableControls(true);
        calculatePercents();
        tableSumsPanel.calculate(false);
        
    }
    public void stockRowRemoved(){
        Vector products = stockTablePanel.getProducts();
        if(products==null || products.size()<=0){
            personPanel.disableControls(true);
        }
        tableSumsPanel.setNetto(stockTablePanel.getTotal());
        tableSumsPanel.calculate(false);
    }
    public void newStockRowAdded(){
        tableSumsPanel.setNetto(stockTablePanel.getTotal());
        tableSumsPanel.calculate(false);
        placeOrderPanel.btnCancel_NewOrder();
        alternateAddressPanel.enableControls(true);
    }
    public User getUser(){
        return user;
    }
    public void loadOrders(String v_nr){
        try {
            tableSumsPanel.clearControls();
            HashMap data = RemotePersonSearch.loadPersonByOrder(user,v_nr);
            loadResultData(data);
            LinkedHashMap order = (LinkedHashMap)ordersPanel.getOrder(v_nr);
            setOrder(order);
            enableLeftSide(false);
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    public void setOrder(Object value){
        if(value == null)
            return;
        
        tableSumsPanel.clearControls();
        LinkedHashMap order = (LinkedHashMap)value;
        Object v_nr = order.get(Order.V_NR);
        Object pay_sum = BigDec.scaledRoundHalfUp(String.valueOf(order.get(Order.PAY_SUM)),2);
        Object invc_addr = StringUtils.clearString(String.valueOf(order.get(Order.INVC_ADDR)));
        Object pay_date =DateUtil.fromTimestamp(order.get(Order.PAY_DATE),"dd.MM.yyyy");
        Object invoiceid = StringUtils.clearString(String.valueOf(order.get(Order.INVOICEID)));
        Object invc_date = DateUtil.fromTimestamp(order.get(Order.INVC_DATE),"dd.MM.yyyy");
        
        Object operator = StringUtils.clearString(String.valueOf(order.get(Order.OPERATOR)));
        Object patn_dscn = StringUtils.clearString(String.valueOf(order.get(Order.PATN_DSCN)));
        Object doc_type = StringUtils.clearString(String.valueOf(order.get(Order.DOC_TYPE_IDNT)));
        Object altr_name  = StringUtils.clearString(String.valueOf(order.get(Order.ALT_NAME)));
        
        boolean credit_note = false;
        
        try{
            String type = doc_type.toString();
            
            if(type.equalsIgnoreCase("1") || type.equalsIgnoreCase("invoice")){
                type = "Invoice";
                credit_note = false;
                placeControls4Invoice();
            } else{
                type = "Credit Note";
                credit_note = true;
                placeControls4CreditNote();
            }
        } catch(Exception e){
            
        }
        if(StringUtils.clearString(invc_addr,"").trim().length() > 0){
            ordersPanel.getBtnPrintPacking().setEnabled(true);
        } else{
            ordersPanel.getBtnPrintPacking().setEnabled(false);
        }
        ordersPanel.getBtnPrintInvoice().setEnabled(true);
        
        editDocNo.setText(v_nr.toString());
        editOrderDate.setText(invc_date.toString());
        editInvoiceNum.setText(invoiceid.toString());
        editOperator.setText(operator.toString());
        
        alternateAddressPanel.setAlternateAddress(invc_addr.toString());
        alternateAddressPanel.setPreview();
        editPayDate.setText(pay_date.toString());
        editPayed.setText(pay_sum.toString());
        
        tableSumsPanel.loadOrderDetails(value);
        stockTablePanel.loadProducts(String.valueOf(v_nr));
        personPanel.setDiscount(patn_dscn.toString());
        personPanel.setAltName(altr_name.toString());
        
        tableSumsPanel.setDiscount(patn_dscn.toString());
        Object prov1uid = StringUtils.clearString(String.valueOf(order.get(Order.PROV1KEY)));
        Object prov1name = StringUtils.clearString(String.valueOf(order.get(Order.PROV1NAME)));
        Object prov1comm = StringUtils.clearString(String.valueOf(order.get(Order.PROV1_COMM)));
        
        Object prov2uid = StringUtils.clearString(String.valueOf(order.get(Order.PROV2KEY)));
        Object prov2name = StringUtils.clearString(String.valueOf(order.get(Order.PROV2NAME)));
        Object prov2comm = StringUtils.clearString(String.valueOf(order.get(Order.PROV2_COMM)));
        
        Object prov3uid = StringUtils.clearString(String.valueOf(order.get(Order.PROV3KEY)));
        Object prov3name = StringUtils.clearString(String.valueOf(order.get(Order.PROV3NAME)));
        Object prov3comm = StringUtils.clearString(String.valueOf(order.get(Order.PROV3_COMM)));
        
        personPanel.setProv1(prov1uid.toString(),prov1name.toString(),prov1comm.toString());
        personPanel.setProv2(prov2uid.toString(),prov2name.toString(),prov2comm.toString());
        personPanel.setProv3(prov3uid.toString(),prov3name.toString(),prov3comm.toString());
        placeOrderPanel.disableBtnPlace(false);
        placeOrderPanel.disableBtnPay(true);
        selectStockPane1.diasableControls(false);
        
        tableSumsPanel.calculate(credit_note);
        placeOrderPanel.btnCancel_NewOrder();
        if(credit_note || ordersPanel.hasCreditNote(v_nr.toString())>-1){
            ordersPanel.getBtnCreditNote().setEnabled(false);
            placeOrderPanel.disableBtnPay(false);
        }
        else{
            ordersPanel.getBtnCreditNote().setEnabled(true);
        }
        enableLeftSide(false);
    }
    public void loadPerson(String uid){
        try {
            
            HashMap data = (HashMap)getPerson(uid);
            loadResultData(data);
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    public void loadResultData(HashMap data){
        try {
            
            HashMap person = (HashMap)data.get("person");
            HashMap prov1 = (HashMap)data.get("prov1");
            HashMap prov2 = (HashMap)data.get("prov2");
            HashMap prov3 = (HashMap)data.get("prov3");
            Vector orders = (Vector)data.get("orders");
            Vector products = (Vector)data.get("products");
            
            
            
            Person m_person = new Person(person);
            
            Person m_prov1 = new Person(prov1);
            Person m_prov2 = new Person(prov2);
            Person m_prov3 = new Person(prov3);
            
            m_person.setProv1(m_prov1);
            m_person.setProv2(m_prov2);
            m_person.setProv3(m_prov3);
            
            personPanel.setPersonData(m_person, m_prov1, m_prov2, m_prov3);
            stockTablePanel.setProducts(products);
            ordersPanel.setOrdersModel(orders);
            tableSumsPanel.prepareSumsTable();
            tableSumsPanel.setDiscount(personPanel.getEditDiscount());
            tableSumsPanel.setVatPers(personPanel.getVatPers());
            alternateAddressPanel.setAlternateAddress(m_person.altr_addr());
            alternateAddressPanel.setPreview();
            clearControls();
            placeControls4Invoice();
            tableSumsPanel.calculate(false);
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    private void placeControls4Invoice() {
        editInvoiceNum.setVisible(false);
        lblInvoice.setVisible(false);
        
        lblDate.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDate.setText("Date");
        lblDate.setBounds(10, 20, 50, 18);
        
        lblDocNum.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocNum.setText("Document No.");
        lblDocNum.setBounds(130, 20, 130, 18);
        
        lblDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocType.setText("Document Type");
        lblDocType.setBounds(270, 20, 110, 18);
        
        lblOper.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblOper.setText("Operator");
        lblOper.setBounds(430, 20, 80, 18);
        
        editOrderDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOrderDate.setBounds(10, 40, 90, 21);
        
        editDocNo.setEditable(false);
        editDocNo.setFont(new java.awt.Font("Tahoma", 0, 13));
        editDocNo.setEnabled(false);
        editDocNo.setBounds(130, 40, 90, 21);
        
        comboDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboDocType.setEnabled(false);
        ((ComboDataModel)comboDocType.getModel()).setSelectedIndex(0);
        comboDocType.setBounds(270, 40, 110, 22);
        comboDocType.updateUI();
        
        editOperator.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOperator.setEnabled(false);
        editOperator.setBounds(430, 40, 90, 21);
    }
    private void placeControls4CreditNote() {
        editInvoiceNum.setVisible(true);
        lblInvoice.setVisible(true);
        
        lblDate.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDate.setText("Date");
        lblDate.setBounds(10, 20, 50, 18);
        
        lblDocNum.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocNum.setText("Document No.");
        lblDocNum.setBounds(95, 20, 125, 18);
        
        lblInvoice.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblInvoice.setText("Invoice No.");
        lblInvoice.setBounds(225, 20, 110, 18);
        
        lblDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocType.setText("Document Type");
        lblDocType.setBounds(335, 20, 110, 18);
        
        lblOper.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblOper.setText("Operator");
        lblOper.setBounds(450, 20, 80, 18);
        
        editOrderDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOrderDate.setBounds(10, 40, 80, 21);
        
        editDocNo.setEditable(false);
        editDocNo.setFont(new java.awt.Font("Tahoma", 0, 13));
        editDocNo.setEnabled(false);
        editDocNo.setBounds(95, 40, 90, 21);
        
        editInvoiceNum.setEditable(false);
        editInvoiceNum.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editInvoiceNum.setPreferredSize(new java.awt.Dimension(62, 21));
        editInvoiceNum.setBounds(225, 40, 100, 21);
        
        comboDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboDocType.setEnabled(false);
        comboDocType.setBounds(335, 40, 110, 22);
        ((ComboDataModel)comboDocType.getModel()).setSelectedIndex(1);
        comboDocType.updateUI();
        
        editOperator.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOperator.setEnabled(false);
        editOperator.setBounds(450, 40, 90, 21);
    }
    private void clearControls(){
        stockTablePanel.setProductsModel(null);
        //editAltAddress.setText("");
        editOrderDate.setText("");
        editOperator.setText("");
        
        editDocNo.setText("");
        comboDocType.setSelectedIndex(0);
        editPayed.setText("");
        editPayDate.setText("");
        
        
    }
    private void enableLeftSide(boolean value) {
        personPanel.disableControls(value);
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        personPanel = new medstore.orders.PersonPanel();
        jPanel9 = new javax.swing.JPanel();
        jpanOPOrderDetails = new javax.swing.JPanel();
        editOrderDate = new javax.swing.JTextField();
        editOperator = new javax.swing.JTextField();
        editDocNo = new javax.swing.JTextField();
        lblDate = new javax.swing.JLabel();
        lblDocNum = new javax.swing.JLabel();
        comboDocType = new javax.swing.JComboBox();
        lblDocType = new javax.swing.JLabel();
        lblOper = new javax.swing.JLabel();
        editPayDate = new javax.swing.JTextField();
        jLabel24 = new javax.swing.JLabel();
        editPayed = new javax.swing.JTextField();
        jLabel25 = new javax.swing.JLabel();
        lblInvoice = new javax.swing.JLabel();
        editInvoiceNum = new javax.swing.JTextField();
        stockTablePanel = new medstore.stock.StockTablePanel();
        tableSumsPanel = new medstore.orders.TableSumsPanel();
        selectStockPane1 = new medstore.stock.SelectStockPanel();
        placeOrderPanel = new medstore.orders.PlaceOrderPanel();
        alternateAddressPanel = new medstore.orders.AlternateAddressPanel();
        ordersPanel = new medstore.orders.OrdersPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel9.setLayout(null);

        jPanel9.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Order Details", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jpanOPOrderDetails.setLayout(null);

        jpanOPOrderDetails.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jpanOPOrderDetails.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jpanOPOrderDetails.setName("jpanOPOrderDetails");
        editOrderDate.setEditable(false);
        editOrderDate.setFont(new java.awt.Font("Arial", 1, 12));
        jpanOPOrderDetails.add(editOrderDate);
        editOrderDate.setBounds(10, 40, 80, 21);

        editOperator.setEditable(false);
        editOperator.setFont(new java.awt.Font("Arial", 1, 12));
        jpanOPOrderDetails.add(editOperator);
        editOperator.setBounds(450, 40, 90, 21);

        editDocNo.setEditable(false);
        editDocNo.setFont(new java.awt.Font("Arial", 1, 12));
        jpanOPOrderDetails.add(editDocNo);
        editDocNo.setBounds(95, 40, 120, 21);

        lblDate.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDate.setText("Date");
        lblDate.setName("lblOPDate");
        jpanOPOrderDetails.add(lblDate);
        lblDate.setBounds(10, 20, 60, 18);

        lblDocNum.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocNum.setText("Document No.");
        lblDocNum.setName("lblOPDocNo");
        jpanOPOrderDetails.add(lblDocNum);
        lblDocNum.setBounds(95, 20, 120, 18);

        comboDocType.setEditable(true);
        comboDocType.setFont(new java.awt.Font("Arial", 1, 12));
        comboDocType.setEnabled(false);
        jpanOPOrderDetails.add(comboDocType);
        comboDocType.setBounds(330, 40, 110, 22);

        lblDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocType.setText("Document Type");
        lblDocType.setName("lblOPDocType");
        jpanOPOrderDetails.add(lblDocType);
        lblDocType.setBounds(330, 20, 120, 18);

        lblOper.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblOper.setText("Operator");
        lblOper.setName("lblOPOperator");
        jpanOPOrderDetails.add(lblOper);
        lblOper.setBounds(450, 20, 90, 18);

        editPayDate.setFont(new java.awt.Font("Arial", 1, 12));
        jpanOPOrderDetails.add(editPayDate);
        editPayDate.setBounds(360, 330, 110, 21);

        jLabel24.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel24.setText("Pay Date");
        jLabel24.setName("lblOPPayDate");
        jpanOPOrderDetails.add(jLabel24);
        jLabel24.setBounds(360, 310, 110, 20);

        editPayed.setFont(new java.awt.Font("Arial", 1, 12));
        editPayed.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        jpanOPOrderDetails.add(editPayed);
        editPayed.setBounds(480, 330, 90, 21);

        jLabel25.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel25.setText("Payed");
        jLabel25.setName("lblOPPayed");
        jpanOPOrderDetails.add(jLabel25);
        jLabel25.setBounds(480, 310, 90, 20);

        lblInvoice.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblInvoice.setText("Invoice No.");
        lblInvoice.setName("lblOPInvNo");
        jpanOPOrderDetails.add(lblInvoice);
        lblInvoice.setBounds(220, 20, 110, 18);

        editInvoiceNum.setEditable(false);
        editInvoiceNum.setFont(new java.awt.Font("Arial", 1, 12));
        editInvoiceNum.setPreferredSize(new java.awt.Dimension(62, 21));
        jpanOPOrderDetails.add(editInvoiceNum);
        editInvoiceNum.setBounds(220, 40, 100, 21);

        jpanOPOrderDetails.add(stockTablePanel);
        stockTablePanel.setBounds(10, 70, 560, 130);

        jpanOPOrderDetails.add(tableSumsPanel);
        tableSumsPanel.setBounds(355, 210, 210, 96);

        jpanOPOrderDetails.add(selectStockPane1);
        selectStockPane1.setBounds(10, 210, 330, 80);

        jpanOPOrderDetails.add(placeOrderPanel);
        placeOrderPanel.setBounds(10, 328, 330, 25);

        jpanOPOrderDetails.add(alternateAddressPanel);
        alternateAddressPanel.setBounds(10, 290, 320, 25);

        jPanel9.add(jpanOPOrderDetails);
        jpanOPOrderDetails.setBounds(10, 20, 580, 360);

        jPanel9.add(ordersPanel);
        ordersPanel.setBounds(10, 400, 580, 200);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(personPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel9, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 600, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, personPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel9, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 607, Short.MAX_VALUE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pack();
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private medstore.orders.AlternateAddressPanel alternateAddressPanel;
    private javax.swing.JComboBox comboDocType;
    private javax.swing.JTextField editDocNo;
    private javax.swing.JTextField editInvoiceNum;
    private javax.swing.JTextField editOperator;
    private javax.swing.JTextField editOrderDate;
    private javax.swing.JTextField editPayDate;
    private javax.swing.JTextField editPayed;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JPanel jpanOPOrderDetails;
    private javax.swing.JLabel lblDate;
    private javax.swing.JLabel lblDocNum;
    private javax.swing.JLabel lblDocType;
    private javax.swing.JLabel lblInvoice;
    private javax.swing.JLabel lblOper;
    private medstore.orders.OrdersPanel ordersPanel;
    private medstore.orders.PersonPanel personPanel;
    private medstore.orders.PlaceOrderPanel placeOrderPanel;
    private medstore.stock.SelectStockPanel selectStockPane1;
    private medstore.stock.StockTablePanel stockTablePanel;
    private medstore.orders.TableSumsPanel tableSumsPanel;
    // End of variables declaration//GEN-END:variables
    
}
