package medstore.orders;

import holders.User;
import holders.person.Person;
import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Window;
import java.util.HashMap;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import medstore.String.StringUtils;
import medstore.forms.FormConvertor;
import medstore.math.BigDec;
import medstore.person.AddPerson;
import medstore.person.BasePersonPanel;
import medstore.person.PersonSearch;

public class PersonPanel extends javax.swing.JPanel {
    private Person person;
    
    private PersonSearch searchform;
    
    private User user;
    BasePersonPanel base;
    AddPerson addPerson;
    
    public PersonPanel() {
        initComponents();
    }
    public void reload(){
        if(person==null){
          return;  
        }
        setPersonData(person,person.getProv1(),person.getProv2(),person.getProv3());
    }
    public boolean isPersonSelected(){
        try{
            new Integer(getEditUIN().trim());
            return true;
        } catch(Exception e){
            
        }
        return false;
    }
    public boolean isProvSelected(int prov){
        switch(prov){
            case 1: return  provisionersPanel.isProv1Selected();
            case 2: return  provisionersPanel.isProv2Selected();
            case 3: return  provisionersPanel.isProv3Selected();
            default: JOptionPane.showMessageDialog(this,"Bad Provision Index - " + prov); return false;
        }
    }
    public void setBase(BasePersonPanel base) {
        this.base = base;
        this.user = base.getUser();
        provisionersPanel.setBase(base);
    }
    public void setPersonData(Person person, Person prov1, Person prov2, Person prov3){
        this.person = person;
        setPerson(person);
        
        if(prov1!=null){
            provisionersPanel.setProv1(prov1.prsn_key(),
                    prov1.prsn_lnam() + ", " + prov1.prsn_fnam(),
                    person.prv1_comm());
            
        } else{
            provisionersPanel.setProv1("","","0.00");
        }
        if(prov2!=null){
            provisionersPanel.setProv2(prov2.prsn_key(),
                    prov2.prsn_lnam() + ", " + prov2.prsn_fnam(),
                    person.prv2_comm());
        } else{
            provisionersPanel.setProv2("","","0.00");
        }
        if(prov3!=null){
            provisionersPanel.setProv3(prov3.prsn_key(),
                    prov3.prsn_lnam() + ", " + prov3.prsn_fnam(),
                    person.prv3_comm());
        } else{
            provisionersPanel.setProv3("","","0.00");
        }
    }
    public void setPerson(Person person) {
        this.person = person;
        editFirstName.setText(person.prsn_fnam());
        editSurname.setText(person.prsn_lnam());
        editAppeal.setText(person.prsn_appl());
        editAlternateName.setText(person.altr_name());
        editType.setText(person.type_abbr());
        editStreet.setText(person.prsn_strt());
        editDiscount.setText(person.prsn_dscn());
        editCode.setText(person.city_code());
        editCity.setText(person.prsn_city());
        editCountry.setText(person.cntr_name());
        chkbCanPurchase.setSelected(person.alow_prch());
        chkVatFree.setSelected(person.vatfree());
        editCLCode.setText(person.clcode());
        editUIN.setText(person.prsn_key());
        edpInfo.setText(person.prsn_info());
    }
    
    public void setProv1(Person prov1){
        if(prov1!=null){
            provisionersPanel.setProv1(prov1.prsn_key(),
                    prov1.prsn_lnam() + ", " + prov1.prsn_fnam(),
                    person.prv1_comm());
            
        } else{
            provisionersPanel.setProv1("","","0.00");
        }
        
        
    }
    public void setProv2(Person prov2){
        if(prov2!=null){
            provisionersPanel.setProv2(prov2.prsn_key(),
                    prov2.prsn_lnam() + ", " + prov2.prsn_fnam(),
                    person.prv2_comm());
        } else{
            provisionersPanel.setProv2("","","0.00");
        }
    }
    public void setProv3(Person prov3){
        if(prov3!=null){
            provisionersPanel.setProv3(prov3.prsn_key(),
                    prov3.prsn_lnam() + ", " + prov3.prsn_fnam(),
                    person.prv3_comm());
        } else{
            provisionersPanel.setProv3("","","0.00");
        }
    }
    public void setProv1(String uid, String name, String comm){
        provisionersPanel.setProv1(uid, name, comm);
    }
    public void setProv2(String uid, String name, String comm){
        provisionersPanel.setProv2(uid, name, comm);
    }
    public void setProv3(String uid, String name, String comm){
        provisionersPanel.setProv3(uid, name, comm);
    }
    public void setDiscount(String value){
        editDiscount.setText(BigDec.scaledRoundHalfUp(value.toString(),2));
    }
    public HashMap getPerson() {
        HashMap person = this.person.getPerson();
        person.put("base_prsn.prsn_dscn",editDiscount.getText());
        return person;
    }
    public String getEditUIN() {
        return editUIN.getText();
    }
    public String getEditDiscount() {
        return editDiscount.getText();
    }
    public String getEditAlternateName() {
        return editAlternateName.getText();
    }
    public String getEditCountry() {
        return editCountry.getText();
    }
    public String getEditCity() {
        return editCity.getText();
    }
    public String getEditCode() {
        return editCode.getText();
    }
    public String getEditStreet() {
        return editStreet.getText();
    }
    public int getCntrIdnt(){
        return person.cntr_idnt();
    }
    
    public String getEditProv1UIN() {
        return provisionersPanel.getProv1UIN();
    }
    public String getEditProv1Name() {
        return provisionersPanel.getProv1Name();
    }
    public String getEditProv2UIN() {
        return provisionersPanel.getProv2UIN();
    }
    public String getEditProv3UIN() {
        return provisionersPanel.getProv3UIN();
    }
    
    public String getEditProv1Pers() {
        return provisionersPanel.getProv1Pers();
    }
    public String getEditProv2Pers() {
        return provisionersPanel.getProv2Pers();
    }
    public String getEditProv3Pers() {
        return provisionersPanel.getProv3Pers();
    }
    
    public JButton getBtnSearchClient() {
        return btnSearchClient;
    }
    public JButton getBtnDoctors() {
        return provisionersPanel.getBtnDoctors();
    }

    public JButton getBtnProv3() {
        return provisionersPanel.getBtnProv3();
    }

    public JButton getBtnDealers() {
        return provisionersPanel.getBtnDealers();
    }
    
    public void setEditProv1Pers(String value) {
        provisionersPanel.setProv1Pers(value);
    }
    public void setEditProv2Pers(String value) {
        provisionersPanel.setProv2Pers(value);
    }
    public void setEditProv3Pers(String value) {
        provisionersPanel.setProv3Pers(value);
    }
    
    public String getVatPers(){
        return person == null ? "0.00" : person.getCntrVatPers();
    }
    public String getAltAddress(){
        return person == null ? "" : person.altr_addr();
    }
    public void setAltName(String value){
        editAlternateName.setText(StringUtils.clearString(value,""));
    }
    public void disableControls(boolean value) {
        btnNew.setEnabled(value);
        btnMoreClient.setEnabled(value);
        btnSearchClient.setEnabled(value);
        editDiscount.setEnabled(value);
        provisionersPanel.disableControls(value);
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jpanOPClient = new javax.swing.JPanel();
        editAppeal = new javax.swing.JTextField();
        editUIN = new javax.swing.JTextField();
        editDiscount = new javax.swing.JTextField();
        editAlternateName = new javax.swing.JTextField();
        btnSearchClient = new javax.swing.JButton();
        editSurname = new javax.swing.JTextField();
        editFirstName = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        editStreet = new javax.swing.JTextField();
        editCity = new javax.swing.JTextField();
        editCode = new javax.swing.JTextField();
        lblOPFName = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        editType = new javax.swing.JTextField();
        editCountry = new javax.swing.JTextField();
        chkbCanPurchase = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        editCLCode = new javax.swing.JTextField();
        chkVatFree = new javax.swing.JCheckBox();
        btnMoreClient = new javax.swing.JButton();
        btnNew = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        edpInfo = new javax.swing.JEditorPane();
        provisionersPanel = new medstore.orders.ProvisionersPanel();

        setMinimumSize(new java.awt.Dimension(340, 600));
        setPreferredSize(new java.awt.Dimension(340, 600));
        jpanOPClient.setLayout(null);

        jpanOPClient.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Client", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jpanOPClient.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jpanOPClient.setName("jpanOPClient");
        editAppeal.setEditable(false);
        editAppeal.setFont(new java.awt.Font("Arial", 1, 12));
        editAppeal.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editAppeal.setEnabled(false);
        jpanOPClient.add(editAppeal);
        editAppeal.setBounds(260, 80, 60, 21);

        editUIN.setEditable(false);
        editUIN.setFont(new java.awt.Font("Arial", 1, 12));
        editUIN.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editUIN.setEnabled(false);
        jpanOPClient.add(editUIN);
        editUIN.setBounds(140, 310, 90, 21);

        editDiscount.setFont(new java.awt.Font("Arial", 1, 12));
        editDiscount.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editDiscount.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                editDiscountFocusLost(evt);
            }
        });

        jpanOPClient.add(editDiscount);
        editDiscount.setBounds(230, 180, 90, 21);

        editAlternateName.setFont(new java.awt.Font("Arial", 1, 12));
        jpanOPClient.add(editAlternateName);
        editAlternateName.setBounds(10, 130, 210, 21);

        btnSearchClient.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSearchClient.setText("Search");
        btnSearchClient.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSearchClient.setName("btnOPSearchClient");
        btnSearchClient.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchClientActionPerformed(evt);
            }
        });

        jpanOPClient.add(btnSearchClient);
        btnSearchClient.setBounds(240, 30, 80, 26);

        editSurname.setEditable(false);
        editSurname.setFont(new java.awt.Font("Arial", 1, 12));
        editSurname.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editSurname.setEnabled(false);
        jpanOPClient.add(editSurname);
        editSurname.setBounds(140, 80, 110, 21);

        editFirstName.setEditable(false);
        editFirstName.setFont(new java.awt.Font("Arial", 1, 12));
        editFirstName.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editFirstName.setEnabled(false);
        jpanOPClient.add(editFirstName);
        editFirstName.setBounds(10, 80, 120, 21);

        jLabel5.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel5.setText("UIN");
        jLabel5.setName("lblOPUIN");
        jpanOPClient.add(jLabel5);
        jLabel5.setBounds(140, 290, 180, 18);

        jLabel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel6.setText("Appeal");
        jLabel6.setName("lblOPApeal");
        jpanOPClient.add(jLabel6);
        jLabel6.setBounds(260, 60, 60, 18);

        jLabel7.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel7.setText("Type");
        jLabel7.setName("lblOPType");
        jpanOPClient.add(jLabel7);
        jLabel7.setBounds(230, 110, 90, 18);

        jLabel8.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel8.setText("Discount %");
        jLabel8.setName("lblOPDiscount");
        jpanOPClient.add(jLabel8);
        jLabel8.setBounds(230, 160, 90, 18);

        editStreet.setEditable(false);
        editStreet.setFont(new java.awt.Font("Arial", 1, 12));
        editStreet.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editStreet.setEnabled(false);
        jpanOPClient.add(editStreet);
        editStreet.setBounds(10, 180, 210, 21);

        editCity.setEditable(false);
        editCity.setFont(new java.awt.Font("Arial", 1, 12));
        editCity.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editCity.setEnabled(false);
        jpanOPClient.add(editCity);
        editCity.setBounds(110, 230, 110, 21);

        editCode.setEditable(false);
        editCode.setFont(new java.awt.Font("Arial", 1, 12));
        editCode.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editCode.setEnabled(false);
        jpanOPClient.add(editCode);
        editCode.setBounds(10, 230, 90, 21);

        lblOPFName.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblOPFName.setText("First Name");
        lblOPFName.setName("lblOPFName");
        jpanOPClient.add(lblOPFName);
        lblOPFName.setBounds(10, 60, 120, 18);

        jLabel10.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel10.setText("Surname");
        jLabel10.setName("lblOPLName");
        jpanOPClient.add(jLabel10);
        jLabel10.setBounds(140, 60, 110, 18);

        jLabel11.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel11.setText("Alternative Name");
        jLabel11.setName("lblOPAltName");
        jpanOPClient.add(jLabel11);
        jLabel11.setBounds(10, 110, 210, 18);

        jLabel12.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel12.setText("Street");
        jLabel12.setName("lblOPStreet");
        jpanOPClient.add(jLabel12);
        jLabel12.setBounds(10, 160, 210, 18);

        jLabel13.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel13.setText("Code");
        jLabel13.setName("lblOPCode");
        jpanOPClient.add(jLabel13);
        jLabel13.setBounds(10, 210, 100, 18);

        jLabel14.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel14.setText("City");
        jLabel14.setName("lblOPCity");
        jpanOPClient.add(jLabel14);
        jLabel14.setBounds(110, 210, 120, 18);

        jLabel15.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel15.setText("Country");
        jLabel15.setName("lblOPCountry");
        jpanOPClient.add(jLabel15);
        jLabel15.setBounds(230, 210, 90, 18);

        editType.setEditable(false);
        editType.setFont(new java.awt.Font("Arial", 1, 12));
        editType.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editType.setEnabled(false);
        jpanOPClient.add(editType);
        editType.setBounds(230, 130, 90, 21);

        editCountry.setEditable(false);
        editCountry.setFont(new java.awt.Font("Arial", 1, 12));
        editCountry.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editCountry.setEnabled(false);
        jpanOPClient.add(editCountry);
        editCountry.setBounds(230, 230, 90, 21);

        chkbCanPurchase.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkbCanPurchase.setText("Can purchase");
        chkbCanPurchase.setEnabled(false);
        chkbCanPurchase.setMargin(new java.awt.Insets(0, 0, 0, 0));
        chkbCanPurchase.setName("chkOPCanPurchase");
        jpanOPClient.add(chkbCanPurchase);
        chkbCanPurchase.setBounds(10, 265, 130, 20);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Client/Firm No ");
        jLabel1.setName("lblOPFirmNo");
        jpanOPClient.add(jLabel1);
        jLabel1.setBounds(10, 290, 130, 18);

        editCLCode.setEditable(false);
        editCLCode.setFont(new java.awt.Font("Arial", 1, 12));
        editCLCode.setEnabled(false);
        jpanOPClient.add(editCLCode);
        editCLCode.setBounds(10, 310, 120, 21);

        chkVatFree.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkVatFree.setText("VAT free");
        chkVatFree.setEnabled(false);
        chkVatFree.setName("chkOPVatFree");
        jpanOPClient.add(chkVatFree);
        chkVatFree.setBounds(140, 265, 180, 20);

        btnMoreClient.setFont(new java.awt.Font("Arial", 1, 12));
        btnMoreClient.setText("More");
        btnMoreClient.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnMoreClientActionPerformed(evt);
            }
        });

        jpanOPClient.add(btnMoreClient);
        btnMoreClient.setBounds(120, 30, 80, 26);

        btnNew.setFont(new java.awt.Font("Arial", 1, 12));
        btnNew.setText("New");
        btnNew.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnMoreClientActionPerformed(evt);
            }
        });

        jpanOPClient.add(btnNew);
        btnNew.setBounds(10, 30, 59, 25);

        jPanel6.setLayout(null);

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Additional Client Info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jPanel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jPanel6.setName("jpanOPClientInfo");
        edpInfo.setEditable(false);
        edpInfo.setFont(new java.awt.Font("Arial", 1, 12));
        edpInfo.setEnabled(false);
        jScrollPane5.setViewportView(edpInfo);

        jPanel6.add(jScrollPane5);
        jScrollPane5.setBounds(10, 20, 310, 90);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jPanel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jpanOPClient, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, provisionersPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(jpanOPClient, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 344, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(provisionersPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 124, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void editDiscountFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_editDiscountFocusLost
        
        if(person==null){
            return;
        }
        //person.setDiscount(getEditDiscount());
        base.discountChanged();
    }//GEN-LAST:event_editDiscountFocusLost
    
    private void btnMoreClientActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnMoreClientActionPerformed
        int mode = 0;
        int ctry = 15;
        Person p = null;
        
        if(evt.getSource() == btnMoreClient){
            if(person==null)
                return;
            
            p = person;
            mode=AddPerson.EDIT_MODE;
            ctry = person.cntr_idnt();
            
        } else{
            if(evt.getSource() == btnNew){
                p = null;
                mode = AddPerson.ADD_MODE;
                ctry = 15;
                
            } else{
                JOptionPane.showMessageDialog(null,"Unknown sorce action!");
                return;
            }
        }
        try{
            
            final Window w = SwingUtilities.windowForComponent(this);
            Dialog parWin  = FormConvertor.convertor(w);
            addPerson = new AddPerson(p,parWin,mode);
            addPerson.setBase(base);
            addPerson.loadUserTypes();
            addPerson.loadPerson();
            addPerson.loadCountries(ctry);
            addPerson.setSize(700,590);
            addPerson.setVisible(true);
            try{
                Integer.parseInt(addPerson.getPerson().prsn_key().toString());
                if(addPerson.isChanged()){
                    person = addPerson.getPerson();
                    base.loadPerson(person.prsn_key().toString());
                }
                
            } catch(Exception ex){
                return;
            } finally{
                addPerson.dispose();
                addPerson = null;
            }
            
        } catch(Exception e){
            JOptionPane.showMessageDialog(null,"Cant load person details!\nError:" + e.getMessage());
            e.printStackTrace();
        }
    }//GEN-LAST:event_btnMoreClientActionPerformed
    
    private void btnSearchClientActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchClientActionPerformed
        try {
            if(searchform==null){
                final Window w = SwingUtilities.windowForComponent(this);
                Dialog parWin  = FormConvertor.convertor(w);
                searchform = new PersonSearch(base, parWin);
            }
            searchform.setVisible(true);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_btnSearchClientActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnMoreClient;
    private javax.swing.JButton btnNew;
    private javax.swing.JButton btnSearchClient;
    private javax.swing.JCheckBox chkVatFree;
    private javax.swing.JCheckBox chkbCanPurchase;
    private javax.swing.JTextField editAlternateName;
    private javax.swing.JTextField editAppeal;
    private javax.swing.JTextField editCLCode;
    private javax.swing.JTextField editCity;
    private javax.swing.JTextField editCode;
    private javax.swing.JTextField editCountry;
    private javax.swing.JTextField editDiscount;
    private javax.swing.JTextField editFirstName;
    private javax.swing.JTextField editStreet;
    private javax.swing.JTextField editSurname;
    private javax.swing.JTextField editType;
    private javax.swing.JTextField editUIN;
    private javax.swing.JEditorPane edpInfo;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JPanel jpanOPClient;
    private javax.swing.JLabel lblOPFName;
    private medstore.orders.ProvisionersPanel provisionersPanel;
    // End of variables declaration//GEN-END:variables
    
}
