package medstore.orders;

import holders.User;
import holders.person.Person;
import java.awt.Dialog;
import java.awt.Window;
import java.util.HashMap;
import javax.swing.JButton;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import medstore.forms.FormConvertor;
import medstore.math.BigDec;
import medstore.person.BasePerson;
import medstore.person.BasePersonPanel;
import medstore.person.PersonSearch;


public class ProvisionersPanel extends javax.swing.JPanel {
    
    private PersonSearch prov1searchform;
    private PersonSearch prov2searchform;
    private PersonSearch prov3searchform;
    BasePersonPanel base;
    
    public ProvisionersPanel() {
        initComponents();
    }
    
    public void setBase(BasePersonPanel base) {
        this.base = base;
    }
    
    public String getProv1UIN() {
        return editProv1UIN.getText();
    }
    public String getProv2UIN() {
        return editProv2UIN.getText();
    }
    public String getProv3UIN() {
        return editProv3UIN.getText();
    }
    public String getProv1Pers() {
        return editProv1Pers.getText();
    }
    public String getProv2Pers() {
        return editProv2Pers.getText();
    }
    public String getProv3Pers() {
        return editProv3Pers.getText();
    }
    public String getProv1Name() {
        return editProv1Name.getText();
    }
    
    public void setProv1Pers(String value) {
        editProv1Pers.setText(value);
    }
    public void setProv2Pers(String value) {
        editProv2Pers.setText(value);
    }
    public void setProv3Pers(String value) {
        editProv3Pers.setText(value);
    }
    
    public JTextField getEditProv1Pers() {
        return editProv1Pers;
    }
    public JTextField getEditProv2Pers() {
        return editProv2Pers;
    }
    public JTextField getEditProv3Pers() {
        return editProv3Pers;
    }
    
    public JButton getBtnDoctors() {
        return btnDoctors;
    }
    
    public JButton getBtnProv3() {
        return btnProv3;
    }
    
    public JButton getBtnDealers() {
        return btnDealers;
    }
    
    public void setProv1(String uid, String name, String comm){
        editProv1UIN.setText(uid);
        editProv1Name.setText(name);
        comm = BigDec.scaledRoundHalfUp(comm,2);
        editProv1Pers.setText(comm);
    }
    public void setProv2(String uid, String name, String comm){
        editProv2UIN.setText(uid);
        editProv2Name.setText(name);
        comm = BigDec.scaledRoundHalfUp(comm,2);
        editProv2Pers.setText(comm);
    }
    public void setProv3(String uid, String name, String comm){
        editProv3UIN.setText(uid);
        editProv3Name.setText(name);
        comm = BigDec.scaledRoundHalfUp(comm,2);
        editProv3Pers.setText(comm);
    }
    public boolean isProv1Selected(){
        try{
            new Integer(getProv1UIN());
            return true;
        } catch(Exception e){
            return false;
        }
    }
    public boolean isProv2Selected(){
        try{
            new Integer(getProv2UIN());
            return true;
        } catch(Exception e){
            return false;
        }
    }
    public boolean isProv3Selected(){
        try{
            new Integer(getProv3UIN());
            return true;
        } catch(Exception e){
            return false;
        }
    }
    public void disableControls(boolean value) {
        btnDoctors.setEnabled(value);
        btnDealers.setEnabled(value);
        btnProv3.setEnabled(value);
        editProv1Pers.setEnabled(value);
        editProv2Pers.setEnabled(value);
        editProv3Pers.setEnabled(value);
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel3 = new javax.swing.JPanel();
        editProv1UIN = new javax.swing.JTextField();
        editProv1Name = new javax.swing.JTextField();
        editProv1Pers = new javax.swing.JTextField();
        editProv2UIN = new javax.swing.JTextField();
        editProv2Name = new javax.swing.JTextField();
        editProv2Pers = new javax.swing.JTextField();
        lblProv1 = new javax.swing.JLabel();
        lblProv2 = new javax.swing.JLabel();
        btnDoctors = new javax.swing.JButton();
        btnDealers = new javax.swing.JButton();
        editProv3UIN = new javax.swing.JTextField();
        editProv3Name = new javax.swing.JTextField();
        editProv3Pers = new javax.swing.JTextField();
        btnProv3 = new javax.swing.JButton();

        setPreferredSize(new java.awt.Dimension(336, 120));
        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Provision 1/2/3", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jPanel3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        editProv1UIN.setEditable(false);
        editProv1UIN.setFont(new java.awt.Font("Arial", 1, 12));
        editProv1UIN.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editProv1UIN.setEnabled(false);

        editProv1Name.setEditable(false);
        editProv1Name.setFont(new java.awt.Font("Arial", 1, 12));
        editProv1Name.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editProv1Name.setEnabled(false);

        editProv1Pers.setFont(new java.awt.Font("Arial", 1, 12));
        editProv1Pers.setText("0");
        editProv1Pers.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editProv1Pers.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                editProv1PersFocusLost(evt);
            }
        });

        editProv2UIN.setEditable(false);
        editProv2UIN.setFont(new java.awt.Font("Arial", 1, 12));
        editProv2UIN.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editProv2UIN.setEnabled(false);

        editProv2Name.setEditable(false);
        editProv2Name.setFont(new java.awt.Font("Arial", 1, 12));
        editProv2Name.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editProv2Name.setEnabled(false);

        editProv2Pers.setFont(new java.awt.Font("Arial", 1, 12));
        editProv2Pers.setText("0");
        editProv2Pers.setDisabledTextColor(new java.awt.Color(113, 111, 100));
        editProv2Pers.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                editProv2PersFocusLost(evt);
            }
        });

        lblProv1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblProv1.setText("DR");

        lblProv2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblProv2.setText("DL");

        btnDoctors.setFont(new java.awt.Font("Arial", 1, 12));
        btnDoctors.setText("?");
        btnDoctors.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnDoctors.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDoctorsActionPerformed(evt);
            }
        });

        btnDealers.setFont(new java.awt.Font("Arial", 1, 12));
        btnDealers.setText("?");
        btnDealers.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnDealers.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDealersActionPerformed(evt);
            }
        });

        editProv3UIN.setFont(new java.awt.Font("Arial", 1, 12));
        editProv3UIN.setEnabled(false);

        editProv3Name.setFont(new java.awt.Font("Arial", 1, 12));
        editProv3Name.setEnabled(false);

        editProv3Pers.setFont(new java.awt.Font("Arial", 1, 12));
        editProv3Pers.setText("0");
        editProv3Pers.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                editProv3PersFocusLost(evt);
            }
        });

        btnProv3.setFont(new java.awt.Font("Arial", 1, 12));
        btnProv3.setText("?");
        btnProv3.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnProv3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnProv3ActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(editProv1UIN, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editProv2UIN, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editProv3UIN, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(editProv2Name, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)
                    .add(editProv3Name, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE)
                    .add(editProv1Name, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 145, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
                        .add(editProv1Pers, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnDoctors, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(lblProv1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel3Layout.createSequentialGroup()
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(jPanel3Layout.createSequentialGroup()
                                .add(editProv3Pers, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnProv3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(jPanel3Layout.createSequentialGroup()
                                .add(editProv2Pers, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnDealers, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(lblProv2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(7, 7, 7)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(editProv1UIN, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(9, 9, 9)
                        .add(editProv2UIN, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(9, 9, 9)
                        .add(editProv3UIN, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(editProv1Name, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(9, 9, 9)
                        .add(editProv2Name, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(9, 9, 9)
                        .add(editProv3Name, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(lblProv1)
                        .add(btnDoctors)
                        .add(editProv1Pers, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(60, 60, 60)
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(btnProv3)
                            .add(editProv3Pers, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(jPanel3Layout.createSequentialGroup()
                        .add(30, 30, 30)
                        .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(lblProv2)
                            .add(btnDealers)
                            .add(editProv2Pers, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 121, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void editProv3PersFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_editProv3PersFocusLost
        try{
            new Integer(getProv3UIN());
            new Double(getProv3Pers());
            base.discountChanged();
        } catch(Exception e){
            
        }
    }//GEN-LAST:event_editProv3PersFocusLost
    
    private void editProv2PersFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_editProv2PersFocusLost
        try{
            new Integer(getProv2UIN());
            new Double(getProv2Pers());
            base.discountChanged();
        } catch(Exception e){
            
        }
    }//GEN-LAST:event_editProv2PersFocusLost
    
    private void editProv1PersFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_editProv1PersFocusLost
        try{
            new Integer(getProv1UIN());
            new Double(getProv1Pers());
            base.discountChanged();
        } catch(Exception e){
            
        }
    }//GEN-LAST:event_editProv1PersFocusLost
    
    private void btnProv3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnProv3ActionPerformed
        try {
            final Window parent = SwingUtilities.windowForComponent(this);
            Dialog parWin  = FormConvertor.convertor(parent);
            if(prov3searchform==null){
                
                prov3searchform = new PersonSearch(new BasePerson(){
                    public void loadPerson(String uid){
                        HashMap data = (HashMap)base.getPerson(uid);
                        HashMap person = (HashMap)data.get("person");
                        
                        Person m_person = new Person(person);
                        String name = m_person.prsn_lnam() + ", " + m_person.prsn_fnam();
                        String comm = m_person.prv1_comm();
                        setProv3(uid,name,comm);
                    }
                    public User getUser(){
                        return base.getUser();
                    }
                    public Object getPerson(String uid){
                        return null;
                    }
                    public void loadPerson(Object data){
                        
                    }
                    
                }
                , parWin);
            }
            
            prov3searchform.setVisible(true);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_btnProv3ActionPerformed
    
    private void btnDealersActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDealersActionPerformed
        try {
            final Window parent = SwingUtilities.windowForComponent(this);
            Dialog parWin  = FormConvertor.convertor(parent);
            if(prov2searchform==null){
                
                prov2searchform = new PersonSearch(new BasePerson(){
                    public void loadPerson(String uid){
                        HashMap data = (HashMap)base.getPerson(uid);
                        HashMap person = (HashMap)data.get("person");
                        
                        Person m_person = new Person(person);
                        String name = m_person.prsn_lnam() + ", " + m_person.prsn_fnam();
                        String comm = m_person.prv2_comm();
                        setProv2(uid,name,comm);
                        try{
                            
                            HashMap p3data = (HashMap)base.getPerson(m_person.prv3_idnt());
                            HashMap prov3 = (HashMap)p3data.get("person");
                            Person m_prov3 = new Person(prov3);
                            
                            int i = Integer.parseInt(m_prov3.prv3_idnt());
                            String p3uid = m_prov3.prsn_key();
                            String p3name = m_prov3.prsn_lnam() + ", " + m_prov3.prsn_fnam();
                            String p3comm = m_prov3.prv1_comm();
                            
                            setProv3(p3uid,p3name,p3comm);
                            
                        } catch(Exception ex){
                            
                        }
                    }
                    public User getUser(){
                        return base.getUser();
                    }
                    public Object getPerson(String uid){
                        return null;
                    }
                    public void loadPerson(Object data){
                        
                    }
                    
                }
                , parWin);
                
                prov2searchform.selectComboPrsType(2);
                prov2searchform.setEnableComboPrsType(false);
            }
            
            prov2searchform.setVisible(true);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_btnDealersActionPerformed
    
    private void btnDoctorsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDoctorsActionPerformed
        try {
            final Window parent = SwingUtilities.windowForComponent(this);
            Dialog parWin  = FormConvertor.convertor(parent);
            
            if(prov1searchform==null){
                prov1searchform = new PersonSearch(new BasePerson(){
                    public void loadPerson(String uid){
                        HashMap data = (HashMap)base.getPerson(uid);
                        
                        HashMap person = (HashMap)data.get("person");
                        
                        Person m_person = new Person(person);
                        String name = m_person.prsn_lnam() + ", " + m_person.prsn_fnam();
                        String comm = m_person.prv1_comm();
                        setProv1(uid,name,comm);
                        
                        HashMap prov2 = (HashMap)data.get("prov2");
                        Person m_prov2 = new Person(prov2);
                        try {
                            int i = Integer.parseInt(m_prov2.prsn_key());
                            
                            String p2uid = m_prov2.prsn_key();
                            String p2name = m_prov2.prsn_lnam() + ", " + m_prov2.prsn_fnam();
                            String p2comm = m_prov2.prv1_comm();
                            
                            setProv2(p2uid,p2name,p2comm);
                            
                        } catch(Exception ex) {
                            setProv2("","","0.00");
                        }
                        
                        try {
                            int i = Integer.parseInt(m_prov2.prv3_idnt());
                            
                            HashMap p3data = (HashMap)base.getPerson(m_prov2.prv3_idnt());
                            HashMap prov3 = (HashMap)p3data.get("person");
                            Person m_prov3 = new Person(prov3);
                            String p3uid = m_prov3.prsn_key();
                            String p3name = m_prov3.prsn_lnam() + ", " + m_prov3.prsn_fnam();
                            String p3comm = m_prov3.prv1_comm();
                            
                            setProv3(p3uid,p3name,p3comm);
                            
                        } catch(Exception ex) {
                            setProv3("","","0.00");
                        }
                        
                    }
                    public User getUser(){
                        return base.getUser();
                    }
                    public Object getPerson(String uid){
                        return null;
                    }
                    public void loadPerson(Object data){
                        
                    }
                }
                , parWin);
                prov1searchform.selectComboPrsType(1);
                prov1searchform.setEnableComboPrsType(false);
            }
            
            prov1searchform.setVisible(true);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }//GEN-LAST:event_btnDoctorsActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnDealers;
    private javax.swing.JButton btnDoctors;
    private javax.swing.JButton btnProv3;
    private javax.swing.JTextField editProv1Name;
    private javax.swing.JTextField editProv1Pers;
    private javax.swing.JTextField editProv1UIN;
    private javax.swing.JTextField editProv2Name;
    private javax.swing.JTextField editProv2Pers;
    private javax.swing.JTextField editProv2UIN;
    private javax.swing.JTextField editProv3Name;
    private javax.swing.JTextField editProv3Pers;
    private javax.swing.JTextField editProv3UIN;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JLabel lblProv1;
    private javax.swing.JLabel lblProv2;
    // End of variables declaration//GEN-END:variables
}