/*
 * ShowOrderInfo.java
 *
 * Created on , 2005,  27, 19:02
 */

package medstore.orders;

import holders.orders.Order;
import java.awt.Dialog;
import java.util.LinkedHashMap;
import java.util.Vector;
import medstore.forms.CommonDialog;
import medstore.model.HashTableModel;
import medstore.stock.Stock;


public class ShowOrderInfo extends CommonDialog  {
    
    public ShowOrderInfo(Dialog parent) {
        super(parent, true);
        initComponents();        
    }
    public void setModal(boolean b){
        super.setModal(b);
    }
    public void setModel(Vector data){
        String[] columns = {"No.","Order No.","Stock Name","Barcode", "Quantity"};
        int[] nrgnWidths = {30,200,350,350,180};
        Vector copy = formatStockRows(data);
        HashTableModel model = new HashTableModel(copy,columns);
        try {
            model.sortColumn(0);
        } catch(Exception e) {
        }
        tblOrderInfo.setModel(model);
    }
    public Vector formatStockRows(Vector data){
        if(data == null || data.size()<=0)
            return data;
        Vector copy = new Vector();
        for(int i = 0; i < data.size(); i ++){
            LinkedHashMap row = (LinkedHashMap)data.get(i);
            Object v_nr = row.get(Order.V_NR);
            Object stck_name = row.get(Stock.stck_name);
            Object stck_brcd = row.get(Stock.stck_brcd);
            Object p_menge = row.get(Stock.p_menge);
            Object p_pos = row.get(Stock.p_pos);
            Object stck_key = row.get(Stock.stck_key);
            
            LinkedHashMap new_row = new LinkedHashMap();
            new_row.put(Stock.p_pos, p_pos);
            new_row.put(Order.V_NR, v_nr);
            new_row.put(Stock.stck_name, stck_name);
            new_row.put(Stock.stck_brcd, stck_brcd);
            new_row.put(Stock.p_menge, p_menge);            
            new_row.put(Stock.stck_key, stck_key);
            
            copy.add(new_row);
        }
        return copy;
    }
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        labelAllStocks = new javax.swing.JLabel();
        scrOrderInfo = new javax.swing.JScrollPane();
        tblOrderInfo = new javax.swing.JTable();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("ShowOrderInfo");
        labelAllStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        labelAllStocks.setText("Order Info");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(labelAllStocks, gridBagConstraints);

        scrOrderInfo.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        tblOrderInfo.setFont(new java.awt.Font("Tahoma", 0, 13));
        tblOrderInfo.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblOrderInfo.setSelectionBackground(new java.awt.Color(125, 162, 246));
        scrOrderInfo.setViewportView(tblOrderInfo);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 10, 10);
        getContentPane().add(scrOrderInfo, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-487)/2, (screenSize.height-205)/2, 487, 205);
    }//GEN-END:initComponents
        // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel labelAllStocks;
    private javax.swing.JScrollPane scrOrderInfo;
    private javax.swing.JTable tblOrderInfo;
    // End of variables declaration//GEN-END:variables
    
}
