package medstore.orders;

import holders.orders.Order;
import java.math.BigDecimal;
import java.util.LinkedHashMap;
import medstore.String.StringUtils;
import medstore.math.BigDec;
import medstore.model.HashTableModel;
import medstore.model.TableUtils;


public class TableSumsPanel extends javax.swing.JPanel {
    public static final int NETTO_INDEX = 0;
    public static final int DISCOUNT_INDEX = 1;
    public static final int PORTO_INDEX = 2;
    public static final int TOTAL_WITHOUT_VAT = 3;
    public static final int VAT_INDEX = 4;
    public static final int TOTAL_INDEX = 5;
    
    public static final int VALUE_COL_INDEX = 2;
    
    String vat_pers;
    String totl_sum;
    String invc_prto;
    String discount;
    String netto;
    
    public TableSumsPanel() {
        initComponents();
        netto = "0.00";        
        totl_sum = "0.00";
        invc_prto= "4.50";
        discount= "0.00";
        vat_pers = "0.00";
    }
    
    public String getNetto(){
        return netto;
    }
    public void setNetto(String netto){
        this.netto = netto;
        tblSums.setValueAt(netto,NETTO_INDEX,VALUE_COL_INDEX);
        tblSums.updateUI();
    }
    public void setDiscount(String disc){
        discount = BigDec.scaledRoundHalfUp(disc,2);
        tblSums.setValueAt(discount + " %",DISCOUNT_INDEX,1);        
    }
    public String getDiscount(){
        return discount;
    }
    public void setVatPers(String vat_pers) {
        this.vat_pers = vat_pers;
        tblSums.setValueAt(vat_pers,VAT_INDEX,1);        
    }
    public String getVatPers() {
        return vat_pers;
    }
    public String getTotl_sum() {
        return totl_sum;
    }
    
    public void setTotl_sum(String totl_sum) {
        this.totl_sum = totl_sum;
    }
    
    public String getInvc_prto() {
        return invc_prto;
    }
    
    public void setInvc_prto(String invc_prto) {
        this.invc_prto = invc_prto;
    }
    
    public void prepareSumsTable(){
        String str_rgn_columnNamesSums[] = {"","","","","",""};
        HashTableModel tbmSums = new HashTableModel(null,str_rgn_columnNamesSums);
        tblSums.setModel(tbmSums);
        int[] nrgnSumsWidthsOrd = {185,100,120};
        TableUtils.setTableColumnsWidth(tblSums, nrgnSumsWidthsOrd);
        LinkedHashMap uniTableRow1 = null;
        LinkedHashMap uniTableRow2 = null;
        LinkedHashMap uniTableRow3 = null;
        LinkedHashMap uniTableRow4 = null;
        LinkedHashMap uniTableRow5 = null;
        LinkedHashMap uniTableRow6 = null;
        {
            uniTableRow1 = new LinkedHashMap();
            uniTableRow1.put("1","Netto");
            uniTableRow1.put("2","");
            uniTableRow1.put("3","0.00");
            
            uniTableRow2 = new LinkedHashMap();
            uniTableRow2.put("1","Discount");
            uniTableRow2.put("2","0.00 %");
            uniTableRow2.put("3","0.00");
            
            uniTableRow3 = new LinkedHashMap();
            uniTableRow3.put("1","Porto");
            uniTableRow3.put("2","");
            uniTableRow3.put("3","4.50");
            
            uniTableRow4 = new LinkedHashMap();
            uniTableRow4.put("1","Total");
            uniTableRow4.put("2","");
            uniTableRow4.put("3","0.00");
            
            uniTableRow5 = new LinkedHashMap();
            uniTableRow5.put("1","VAT");
            uniTableRow5.put("2","");
            uniTableRow5.put("3","0.00");
            
            uniTableRow6 = new LinkedHashMap();
            uniTableRow6.put("1","Total");
            uniTableRow6.put("2","EUR");
            uniTableRow6.put("3","0.00");
        }
        
        
        ((HashTableModel)tblSums.getModel()).addRow(uniTableRow1);
        ((HashTableModel)tblSums.getModel()).addRow(uniTableRow2);
        ((HashTableModel)tblSums.getModel()).addRow(uniTableRow3);
        ((HashTableModel)tblSums.getModel()).addRow(uniTableRow4);
        ((HashTableModel)tblSums.getModel()).addRow(uniTableRow5);
        ((HashTableModel)tblSums.getModel()).addRow(uniTableRow6);
    }
    
    public void loadOrderDetails(Object value){
        
        LinkedHashMap order = (LinkedHashMap)value;
        
        Object doc_type = StringUtils.clearString(String.valueOf(order.get(Order.DOC_TYPE_IDNT)),"1");
        
        setTotl_sum(BigDec.scaledRoundHalfUp(String.valueOf(order.get(Order.TOTL_SUM)),2));
        setInvc_prto(BigDec.scaledRoundHalfUp(String.valueOf(order.get(Order.INVC_PRTO)),2));
        setDiscount(BigDec.scaledRoundHalfUp(String.valueOf(order.get(Order.PATN_DSCN)),2));
        setVatPers(BigDec.scaledRoundHalfUp(String.valueOf(order.get(Order.VAT_PERS)),2));
        setNetto(BigDec.scaledRoundHalfUp(String.valueOf(order.get(Order.NETO_SUM)),2));
        
        boolean credit_note = false;
        try{
            credit_note = !(doc_type.toString().equalsIgnoreCase("1") || doc_type.toString().equalsIgnoreCase("invoice"));
        } catch(Exception e){
            
        }
        calculate(credit_note);
        
    }
    
    public void calculate(boolean creditnote){
        
        
        String invc_prto = BigDec.scaledRoundHalfUp(getInvc_prto(),2);
        String patn_dscn = BigDec.scaledRoundHalfUp(getDiscount(),2);
        String vat_pers = BigDec.scaledRoundHalfUp(getVatPers(),2);
        String neto_sum = BigDec.scaledRoundHalfUp(getNetto(),2);
                
        BigDecimal bdmNetto = new BigDecimal(0);
        try {
            
            bdmNetto = new BigDecimal(neto_sum.toString());
            bdmNetto = bdmNetto.abs();
        } catch(Exception e){
            
        }
        
        BigDecimal bdmPorto = new BigDecimal(0);
        try {
            bdmPorto = new BigDecimal(invc_prto.toString());
            bdmPorto = bdmPorto.abs();
        } catch(Exception e){
            
        }
        
        BigDecimal bdmDiscountPers = new BigDecimal(0);
        try{
            bdmDiscountPers = new BigDecimal(patn_dscn.toString());
            bdmDiscountPers = bdmDiscountPers.abs();
        } catch(Exception e){
            
        }
        
        BigDecimal bdmVatPers = new BigDecimal(0);
        try{
            bdmVatPers = new BigDecimal(vat_pers.toString());
            bdmVatPers = bdmVatPers.abs();
        } catch(Exception e){
            
        }
        
        
        BigDecimal bdmDiscount = bdmNetto.multiply(bdmDiscountPers).divide(new BigDecimal(100.0),3,BigDecimal.ROUND_HALF_UP);
        bdmDiscount = bdmDiscount.abs();
        
        BigDecimal discNeto = new BigDecimal(Math.abs(bdmNetto.doubleValue()) - Math.abs(bdmDiscount.doubleValue()));
        discNeto = discNeto.abs();
        
        BigDecimal subTotal = new BigDecimal(Math.abs(discNeto.doubleValue()) + Math.abs(bdmPorto.doubleValue()));
        subTotal = subTotal.abs();
        subTotal = subTotal.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal bdmVatValue = subTotal.multiply(bdmVatPers).divide( new BigDecimal(100.0), 3, BigDecimal.ROUND_HALF_UP );
        bdmVatValue = bdmVatValue.abs();
        
        BigDecimal bdmTotal = new BigDecimal(0);
        
        try{
            bdmTotal = new BigDecimal(subTotal.doubleValue() + bdmVatValue.doubleValue());
            bdmTotal = bdmTotal.setScale(2,BigDecimal.ROUND_HALF_UP);
            bdmTotal = bdmTotal.abs();
        } catch(Exception e){
            
        }
        neto_sum = BigDec.scaledRoundHalfUp(bdmNetto.toString(),2);
        String vatValue = BigDec.scaledRoundHalfUp(bdmVatValue.toString(),2);
        String discValue = BigDec.scaledRoundHalfUp(bdmDiscount.toString(),2);
        totl_sum = BigDec.scaledRoundHalfUp(bdmTotal.toString(),2);
        
        String pref = creditnote ? "-" : "";
        String dpref = creditnote || bdmDiscount.doubleValue() <= 0 ? "" : "-";
        
        tblSums.getModel().setValueAt(pref + neto_sum, NETTO_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt(dpref+discValue, DISCOUNT_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt(patn_dscn+"%", DISCOUNT_INDEX, 1);
        tblSums.getModel().setValueAt(pref + invc_prto, PORTO_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt(pref + subTotal, TOTAL_WITHOUT_VAT, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt(pref + vatValue, VAT_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt(vat_pers+"%", VAT_INDEX, 1 );
        tblSums.getModel().setValueAt(pref + totl_sum, TOTAL_INDEX, VALUE_COL_INDEX);
        realign();
        ((HashTableModel)tblSums.getModel()).fireTableDataChanged();
    }
    public void clearControls(){
        netto = "0.00";        
        totl_sum = "0.00";
        invc_prto= "4.50";
        discount= "0.00";
        vat_pers = "0.00";
        
        prepareSumsTable();
        try{
            ((HashTableModel)tblSums.getModel()).fireTableDataChanged();
        } catch(Exception e){
            e.printStackTrace();
        }
        realign();
    }
    public void realign(){
        TableUtils.setHorizontalAlignment(tblSums, 0, javax.swing.JTextField.LEFT );
        TableUtils.setHorizontalAlignment(tblSums, 1, javax.swing.JTextField.RIGHT );
        TableUtils.setHorizontalAlignment(tblSums, 2, javax.swing.JTextField.RIGHT );
        
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        tblSums = new javax.swing.JTable();

        tblSums.setBackground(new java.awt.Color(172, 168, 153));
        tblSums.setFont(new java.awt.Font("SansSerif", 1, 13));
        tblSums.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"Netto", "EUR", "0"},
                {"Discount", "EUR", "0"},
                {"Porto", "EUR", "4.5"},
                {"Total", "EUR", "0"},
                {"VAT", "EUR", "0"},
                {"Total", "EUR", "0"}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblSums.setAutoCreateColumnsFromModel(false);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 225, Short.MAX_VALUE)
            .add(tblSums, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 96, Short.MAX_VALUE)
            .add(tblSums, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable tblSums;
    // End of variables declaration//GEN-END:variables
    
}
