package medstore.print;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import javax.print.PrintService;
import org.jfree.report.JFreeReport;
import org.jfree.report.ReportProcessingException;
import org.jfree.report.modules.gui.base.ReportPane;
import org.jfree.report.modules.gui.print.PrintUtil;



public class CustomPrintUtil {
    public static boolean printOn(JFreeReport report, final int pId)
    throws PrinterException, ReportProcessingException {
          final String jobName = report.getReportConfiguration().getConfigProperty
                (PrintUtil.PRINTER_JOB_NAME_KEY, report.getName());
        
        final PrinterJob printerJob = PrinterJob.getPrinterJob();
        printerJob.setJobName(jobName);
               
        PrintService[] service = printerJob.lookupPrintServices();
        
        if(service.length < pId || pId < 0){
          return false;
        }
       
       
        printerJob.setPrintService(service[pId]);
        printerJob.print();
        return true;
        
        
    }
    public static boolean printOn(JFreeReport report, final int pId,int copies)
    throws PrinterException, ReportProcessingException {
          final String jobName = report.getReportConfiguration().getConfigProperty
                (PrintUtil.PRINTER_JOB_NAME_KEY, report.getName());
        
        final PrinterJob printerJob = PrinterJob.getPrinterJob();
        printerJob.setJobName(jobName);
        printerJob.setPageable(new ReportPane(report));
        
        
        PrintService[] service = printerJob.lookupPrintServices();
        
        
        
        if(service.length < pId || pId < 0){
          return false;
        }
       
        printerJob.setCopies(copies);
        printerJob.setPrintService(service[pId]);
        printerJob.print();
        return true;
        
        
    }
}

