package medstore.print.orders;

import java.net.URL;
import javax.swing.JComponent;

import org.jfree.report.JFreeReport;
import org.jfree.report.demo.helper.AbstractXmlDemoHandler;
import org.jfree.report.demo.helper.ReportDefinitionException;
import org.jfree.report.Element;
import org.jfree.report.GroupFooter;
import org.jfree.util.ObjectUtilities;

public class SimplePrintUtils extends AbstractXmlDemoHandler{
    
    private static InvoiceTableModel data;
    private String printTemplate;
    private String name;
    public SimplePrintUtils(InvoiceTableModel data, String printTemplate,String name) {
        this.data = data;
        this.printTemplate = printTemplate;
        this.name = name;
    }
    public JFreeReport createReport() throws ReportDefinitionException {
        final JFreeReport report = parseReport();
        report.setName(name);
        report.setData(data);
        return report;
    }
    
    public JComponent getPresentationComponent() {
        return createDefaultTable(data);
    }
    public URL getDemoDescriptionSource() {
        return null;
    }
    public String getDemoName() {
        return name;
    }
    public URL getReportDefinitionSource() {
        return ObjectUtilities.getResourceRelative
                (printTemplate, SimplePrintUtils.class);
    }
    public void ShowHideItems(JFreeReport report,boolean hide) throws Exception{
        try{            
            
                
                GroupFooter el = report.getGroupByName("payment").getFooter();
                
                Element discountLabel = el.getElement("discountLabel");                
                discountLabel.setVisible(hide);
                
                Element invoiceDicountPerc = el.getElement("invoice.invoiceDicountPerc");
                invoiceDicountPerc.setVisible(hide);
                
                Element discount = el.getElement("invoice.discount");
                discount.setVisible(hide);
                
           
        } catch(Exception e){
            throw new Exception("Can't hide discont: " + e.getMessage());
        }
    }
}
