package medstore.remote.io.fullfill;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.HashMap;
import java.util.Vector;
import medstore.remote.io.RemoteIO;
import medstore.remote.io.ServletWriter;

public class RemoteFullFill extends RemoteIO{
    
    public static Vector getUnFiled(HashMap user, boolean all) throws Exception{
        URL url = new URL(RemoteUrl.unfiled);
        Serializable[] obj = {(Serializable)user, (Serializable)new Boolean(all)};
        ObjectInputStream in = ServletWriter.postObjects(url,obj);
        Vector data = (Vector)in.readObject();
        closeInput(in);
        return data;
    }
    public static boolean isOrderFilled(HashMap user, String v_nr) throws Exception{
        URL url = new URL(RemoteUrl.isOrderFilled);
        HashMap data = new HashMap();
        data.put("v_nr",v_nr);
        Serializable[] obj = {(Serializable)user,(Serializable)data};
        ObjectInputStream in = ServletWriter.postObjects(url,obj);
        boolean result = in.readBoolean();
        closeInput(in);
        return result;
    }
    public static HashMap isValidRow(HashMap user, HashMap data) throws Exception{
        URL url = new URL(RemoteUrl.isValidRow);
        Serializable[] obj = {(Serializable)user,(Serializable)data};
        ObjectInputStream in = ServletWriter.postObjects(url,obj);
        HashMap result = (HashMap)in.readObject();
        closeInput(in);
        return result;
    }
    public static Vector loadOrderDetails(HashMap user, String v_nr) throws Exception{
        try {
            URL url = new URL(RemoteUrl.orderDetails);
            HashMap data = new HashMap();
            data.put("v_nr",v_nr);
            Serializable[] obj = {(Serializable)user,(Serializable)data};
            ObjectInputStream in = ServletWriter.postObjects(url,obj);
            Vector result = (Vector)in.readObject();
            closeInput(in);
            return result;
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return null;
    }
    
    public static String fullfill(HashMap user, HashMap data) throws Exception{
        URL url = new URL(RemoteUrl.fullfill);
        Serializable[] obj = {(Serializable)user,(Serializable)data};
        ObjectInputStream in = ServletWriter.postObjects(url,obj);
        String result = (String)in.readObject();
        closeInput(in);
        return result;
    }
}
