package medstore.remote.io.stock;

import medstore.remote.io.RemoteURL;
import holders.StockUrl;
import holders.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.Serializable;
import java.net.URL;
import java.util.HashMap;
import java.util.Vector;
import javax.swing.table.TableModel;
import medstore.Main;
import medstore.remote.io.ServletWriter;

public class RemoteStocks {

    public static Vector stockInStore(HashMap user, String stck_key) throws Exception{
        try {           
            URL url = new URL(RemoteUrl.stockInStore);
            Serializable[] obj = {(Serializable)user, (Serializable)stck_key};            
            ObjectInputStream in = ServletWriter.postObjects(url, obj);
            Vector stocks = (Vector)in.readObject();
            return stocks;
        } catch (Exception ex) {    
            ex.printStackTrace();
            throw new Exception("Can't load Stocks!\n"+ex.getMessage());
        }     
    }
    
    public static TableModel getAllStocks(User user) throws Exception{
        try {            
            Serializable[] obj = {(Serializable)user.getUserMap()};            
            ObjectInputStream in = ServletWriter.postObjects(new URL(RemoteURL.allStocksModelUrl+Main.getUrlSessionId(user)), obj);
            TableModel stocksModel = (TableModel)in.readObject();
            return stocksModel;
        } catch (Exception ex) {    
            ex.printStackTrace();
            throw new Exception("Can't load Stock Model!\n"+ex.getMessage());
        }     
    }
    
    public static Vector getStocks(User user) throws Exception{
        try {            
            HashMap map = new HashMap();
            map.put("user",user.getUserMap());
            Serializable[] obj = {(Serializable)map};            
            ObjectInputStream in = ServletWriter.postObjects(new URL(RemoteURL.loadStock), obj);
            Vector stocks = (Vector)in.readObject();
            return stocks;
        } catch (Exception ex) {    
            ex.printStackTrace();
            throw new Exception("Can't load Stocks!\n"+ex.getMessage());
        }     
    }
    
    public static Vector stockList(User user) throws Exception{
        try {            
            Serializable[] obj = {(Serializable)user.getUserMap()};            
            ObjectInputStream in = ServletWriter.postObjects(new URL(StockUrl.stockList),obj);
            Vector data = (Vector)in.readObject();
            closeInput(in);
            return data;
        } catch (Exception ex) {    
            ex.printStackTrace();
            throw new Exception("Can't load Stock Model!\n"+ex.getMessage());
        }     
    }
    public static String saveStock(User user, HashMap data) throws Exception{
        try {            
            Serializable[] obj = {(Serializable)user.getUserMap(),(Serializable)data};            
            ObjectInputStream in = ServletWriter.postObjects(new URL(StockUrl.saveStock),obj);
            String result = (String)in.readObject();
            closeInput(in);
            return result;
        } catch (Exception ex) {    
            ex.printStackTrace();
            throw new Exception("Can't save Stock !\n"+ex.getMessage());
        }     
    }
            
    public static String updateStock(User user, HashMap data) throws Exception{
        try {            
            Serializable[] obj = {(Serializable)user.getUserMap(),(Serializable)data};            
            ObjectInputStream in = ServletWriter.postObjects(new URL(StockUrl.updateStock),obj);
            String result = (String)in.readObject();
            closeInput(in);
            return result;
        } catch (Exception ex) {    
            ex.printStackTrace();
            throw new Exception("Can't save Stock !\n"+ex.getMessage());
        }     
    }
     
    private static void closeInput( ObjectInputStream in){
        try {
            in.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
