package medstore.stock;

import holders.User;
import java.awt.Dialog;
import java.awt.Window;
import java.util.LinkedHashMap;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import medstore.String.StringUtils;
import medstore.forms.FormConvertor;
import medstore.remote.io.stock.RemoteStocks;

public class SelectStockPanel extends javax.swing.JPanel implements BaseStockSelection{
    private String stockId;
    private String stockCount;
    Vector stocks;
    private User user;
    private StockSelectionForm stockSelectionForm;
    
    private LinkedHashMap lastSelected;
    
    private BaseStockSelection base;
    
    public SelectStockPanel() {
        initComponents();
        lastSelected = null;
        base = null;
    }
    public boolean canSelectStock(){
        return true;
    }
    public void loadStocks(){
        try {            
            stocks = RemoteStocks.getStocks(user);
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null,ex.getMessage());
            ex.printStackTrace();
        }
    }
    public void setBase(BaseStockSelection base){
        this.base = base;
        this.user = base.getUser();
    }
    
    public User getUser(){
        return user;
    }
    public String getStockId(){
        return stockId;
    }
    public String getStockCount(){
        return stockCount;
    }
    public Object getStocks(){
        return stocks;
    }
    public Object getStockSelected(){        
        return lastSelected;
    }
    public void setSelectedStock(Object value){
        lastSelected = value == null ? new  LinkedHashMap(): (LinkedHashMap)value;
        editNewStock.setText(StringUtils.clearString(lastSelected.get(Stock.stck_abrv)));
        lblStockName.setText(StringUtils.clearString(lastSelected.get(Stock.stck_name),"Stock not selected!"));
        if(lastSelected==null){
            btnAddStock.setEnabled(false);            
        }
        else{
            btnAddStock.setEnabled(true);            
            editCount.setText("1");
            editCount.selectAll();            
        }
        
    }
    public void diasableControls(boolean value){
        btnAddStock.setEnabled(value);
        btnSelectStock.setEnabled(value);
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jLabel24 = new javax.swing.JLabel();
        editNewStock = new javax.swing.JTextField();
        btnSelectStock = new javax.swing.JButton();
        editCount = new javax.swing.JTextField();
        jLabel25 = new javax.swing.JLabel();
        btnAddStock = new javax.swing.JButton();
        lblStockName = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(230, 80));
        setMinimumSize(new java.awt.Dimension(230, 80));
        setPreferredSize(new java.awt.Dimension(230, 80));
        jLabel24.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel24.setText("Stock");
        jLabel24.setName("lblOPStock");

        editNewStock.setFont(new java.awt.Font("Tahoma", 0, 13));
        editNewStock.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                editNewStockKeyPressed(evt);
            }
        });

        btnSelectStock.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSelectStock.setText("?");
        btnSelectStock.setToolTipText("Search stock");
        btnSelectStock.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSelectStock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSelectStockActionPerformed(evt);
            }
        });

        editCount.setFont(new java.awt.Font("Tahoma", 0, 13));
        editCount.setText("1");
        editCount.setMaximumSize(new java.awt.Dimension(6, 22));
        editCount.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                editCountKeyPressed(evt);
            }
        });

        jLabel25.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel25.setText("Count");
        jLabel25.setMaximumSize(new java.awt.Dimension(35, 18));
        jLabel25.setMinimumSize(new java.awt.Dimension(35, 18));
        jLabel25.setName("lblOPCount");
        jLabel25.setPreferredSize(new java.awt.Dimension(35, 18));

        btnAddStock.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnAddStock.setText("Add");
        btnAddStock.setEnabled(false);
        btnAddStock.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAddStock.setName("btnOPAddProduct");
        btnAddStock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddStockActionPerformed(evt);
            }
        });

        lblStockName.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        lblStockName.setText("Stock not selected!");
        lblStockName.setName("lblOPStockNotSel");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(lblStockName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 176, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                            .add(jLabel24, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(editNewStock, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 88, Short.MAX_VALUE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSelectStock, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 28, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(editCount, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 41, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(btnAddStock))
                            .add(jLabel25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel24, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel25, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(editNewStock, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnSelectStock, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editCount, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 21, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnAddStock))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(lblStockName)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void editCountKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_editCountKeyPressed
        if( evt.getKeyCode()!= evt.VK_ENTER )
            return;
        btnAddStock.doClick();        
    }//GEN-LAST:event_editCountKeyPressed

    private void btnAddStockActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddStockActionPerformed
        try{
            if(!base.canSelectStock()){
                return;
            }
            int key;            
            Integer count = new Integer(0);
            try {
                key = Integer.parseInt(lastSelected.get(Stock.stck_key).toString());
            } catch (Exception ex) {
               JOptionPane.showMessageDialog(null,"Stock not selected!");
               return;
            }
            try{
                count = new Integer(editCount.getText().trim());
            }
            catch(Exception e){
                JOptionPane.showMessageDialog(null,"Incorrect stock count!");
                return;
            }
            LinkedHashMap curRow = null;
            for(int i = 0; i < stocks.size(); i++){
                int stck_key = Integer.parseInt(StringUtils.clearString(((LinkedHashMap)stocks.get(i)).get(Stock.stck_key)));                
                
                if(stck_key==key){
                    curRow = (LinkedHashMap)stocks.get(i);
                    curRow.put(Stock.count,count);
                    break;
                }
            }
            base.setSelectedStock(curRow);
            setSelectedStock(null);
            editCount.setText("1");
            editNewStock.requestFocus();
        }
        catch(Exception e){
            JOptionPane.showMessageDialog(null,"Error: " + e.getMessage());
            e.printStackTrace();
        }
    }//GEN-LAST:event_btnAddStockActionPerformed
    
    private void editNewStockKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_editNewStockKeyPressed
        if(evt.getSource() == editNewStock){
            SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    String strSearchText = editNewStock.getText();                    
                    if(strSearchText.trim().length()<=0){
                        setSelectedStock(null);                      
                        return;
                    }
                    
                    for(int i = 0; i < stocks.size(); i++){
                        String abbr = StringUtils.clearString(((LinkedHashMap)stocks.get(i)).get(Stock.stck_abrv));
                        if(abbr.equalsIgnoreCase(strSearchText)){
                            LinkedHashMap row = StockSelectionForm.formatRow((LinkedHashMap)stocks.get(i));
                            setSelectedStock(row);
                            return;
                        }                        
                    }
                    setSelectedStock(null);
                    editNewStock.setText(strSearchText);
                }
            });            
        }
    }//GEN-LAST:event_editNewStockKeyPressed
    
    private void btnSelectStockActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSelectStockActionPerformed
        if(stockSelectionForm==null){
            final Window w = SwingUtilities.windowForComponent(this);
            Dialog parWin  = FormConvertor.convertor(w);
            stockSelectionForm = new StockSelectionForm(this,parWin);
        }
        stockSelectionForm.setVisible(true);
    }//GEN-LAST:event_btnSelectStockActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddStock;
    private javax.swing.JButton btnSelectStock;
    private javax.swing.JTextField editCount;
    private javax.swing.JTextField editNewStock;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel lblStockName;
    // End of variables declaration//GEN-END:variables
    
}
