package medstore.stock;

import java.util.Vector;
import javax.swing.JTable;
import medstore.Base;
import medstore.model.ComboDataModel;
import medstore.model.HashTableModel;
import medstore.remote.io.stock.RemoteStocks;
import medstore.remote.io.stores.RemoteStores;

public class StockOnHand extends javax.swing.JFrame{   
    private Base base;
    
    public StockOnHand(Base base, int stor_key){
        this.base = base;        
        initComponents();
        setStore(stor_key); 
    }
    
    public void loadProducts(){
        int nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
        try {
            Vector data = RemoteStocks.stockInStore(base.getUser().getUserMap(),""+nStoreId);
            setModel(data);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    public void loadStores(int stor_key){
        try {
            Vector data = RemoteStores.loadStores(base.getUser().getUserMap());
            ComboDataModel cdbStores = new ComboDataModel(data);
            cdbStores.selectIndexByKey(stor_key);
            comboStore.setModel(cdbStores);        
            loadProducts();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    public void setModel(Vector data){
        String[] columns = {"Stock Name","Barcode","Stock Count"};
        HashTableModel model = new HashTableModel(data, columns);
        tblStoreStocks.setModel(model);
        tblStoreStocks.updateUI();
    }
    public void setStore(int stor_key){
        loadStores(stor_key);
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        btngOperations = new javax.swing.ButtonGroup();
        jpmUnpack = new javax.swing.JPopupMenu();
        mitemUnpack = new javax.swing.JMenuItem();
        comboStore = new javax.swing.JComboBox();
        scrAllStocks = new javax.swing.JScrollPane();
        tblStoreStocks = new javax.swing.JTable();
        lblStore = new javax.swing.JLabel();
        lblStocks = new javax.swing.JLabel();
        buttonRefresh = new javax.swing.JButton();

        mitemUnpack.setText("Unpack");
        mitemUnpack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StockOnHand.this.actionPerformed(evt);
            }
        });

        jpmUnpack.add(mitemUnpack);

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Stocks on hand");
        comboStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboStore.setMinimumSize(new java.awt.Dimension(250, 22));
        comboStore.setPreferredSize(new java.awt.Dimension(250, 22));
        comboStore.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                valueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 100);
        getContentPane().add(comboStore, gridBagConstraints);

        scrAllStocks.setFont(new java.awt.Font("Tahoma", 1, 13));
        tblStoreStocks.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        scrAllStocks.setViewportView(tblStoreStocks);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 10);
        getContentPane().add(scrAllStocks, gridBagConstraints);

        lblStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStore.setText("Store");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 36;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(lblStore, gridBagConstraints);

        lblStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStocks.setText("Stocks available in selected store");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.ipadx = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(8, 10, 0, 0);
        getContentPane().add(lblStocks, gridBagConstraints);

        buttonRefresh.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonRefresh.setText("Refresh");
        buttonRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StockOnHand.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        getContentPane().add(buttonRefresh, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-454)/2, (screenSize.height-259)/2, 454, 259);
    }// </editor-fold>//GEN-END:initComponents
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource()==buttonRefresh){            
            loadProducts();
        } 
    }//GEN-LAST:event_actionPerformed
    
    private void valueChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_valueChanged
        if(evt.getSource() == comboStore){
            if(evt.getItem() == comboStore.getSelectedItem()){                
                loadProducts();
            }            
        }
        
    }//GEN-LAST:event_valueChanged
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup btngOperations;
    private javax.swing.JButton buttonRefresh;
    private javax.swing.JComboBox comboStore;
    private javax.swing.JPopupMenu jpmUnpack;
    private javax.swing.JLabel lblStocks;
    private javax.swing.JLabel lblStore;
    private javax.swing.JMenuItem mitemUnpack;
    private javax.swing.JScrollPane scrAllStocks;
    private javax.swing.JTable tblStoreStocks;
    // End of variables declaration//GEN-END:variables
    
}
