package medstore.stock;

import holders.stock.Campaign;
import java.awt.event.InputEvent;
import java.math.BigDecimal;
import java.util.LinkedHashMap;
import java.util.Vector;
import javax.swing.JOptionPane;
import medstore.String.StringUtils;
import medstore.math.BigDec;
import medstore.model.HashTableModel;
import medstore.model.TableUtils;
import medstore.orders.BaseStockTable;

public class StockTablePanel extends javax.swing.JPanel {
    String columnNamesProducts[] = {"Stock Code","Abbr.","Stock Name","Count","Unit Price","Sum Price"};
    private Vector products;
    private BaseStockTable base;
    private Vector campaigns;
    int[] width = {200,200,200,120,160,120};
    
    public StockTablePanel() {
        initComponents();
        TableUtils.setTableHeader(tblOrderGoods);
        tblOrderGoods.getTableHeader().setReorderingAllowed(false);
    }
    
    public String getTotal(){
        int nStockCount = tblOrderGoods.getRowCount();
        BigDecimal bdmNetto = new BigDecimal(0);
        for(int i=0 ; i< nStockCount; i++) {
            LinkedHashMap row = ((HashTableModel)tblOrderGoods.getModel()).getRowAt(i);
            try{
                String sum = StringUtils.clearString(row.get("sum_pric"),"0");
                BigDecimal bdmSum = new BigDecimal(sum);
                bdmNetto = bdmNetto.add(bdmSum);
            } catch(Exception e){
                JOptionPane.showMessageDialog(this,"Error calculating " + row.get(Stock.stck_name));
            }
        }
        return BigDec.scaledRoundHalfUp(bdmNetto.toString(),2);
    }
    public void setBase(BaseStockTable base) {
        this.base = base;
    }
    
    public Vector getProducts() {
        return ((HashTableModel)tblOrderGoods.getModel()).getDataVector();
    }
    public void setProductsModel(Vector data){
        HashTableModel model = new HashTableModel(data,columnNamesProducts);
        model.formatDecimal(Stock.unit_pric);
        model.formatDecimal(Stock.sum_pric);
        tblOrderGoods.setModel(model);
        
        TableUtils.setHorizontalAlignment(tblOrderGoods, 0, javax.swing.JTextField.LEFT );
        TableUtils.setHorizontalAlignment(tblOrderGoods, 1, javax.swing.JTextField.LEFT );
        TableUtils.setHorizontalAlignment(tblOrderGoods, 2, javax.swing.JTextField.LEFT );
        TableUtils.setHorizontalAlignment(tblOrderGoods, 3, javax.swing.JTextField.RIGHT );
        TableUtils.setHorizontalAlignment(tblOrderGoods, 4, javax.swing.JTextField.RIGHT );
        TableUtils.setHorizontalAlignment(tblOrderGoods, 5, javax.swing.JTextField.RIGHT );
        
        //set width
        TableUtils.setColumnWidth( tblOrderGoods, 2, 200 );
        TableUtils.setColumnWidth( tblOrderGoods, 0, 90 );
        
        try {
            model.fireTableDataChanged();
            tblOrderGoods.updateUI();
        } catch (Exception ex) {
        }
    }
    public int stockRowExsits(LinkedHashMap row){
        String key = StringUtils.clearString(row.get(Stock.stck_key));
        Vector data = ((HashTableModel)tblOrderGoods.getModel()).getDataVector();
        for(int i = 0; i < data.size(); i++){
            LinkedHashMap map = (LinkedHashMap)data.get(i);
            String map_key = StringUtils.clearString(map.get(Stock.stck_key));
            if(key.equalsIgnoreCase(map_key)){
                return i;
            }
        }
        return -1;
    }
    public LinkedHashMap fmtNewStock(LinkedHashMap row, Object count){
        LinkedHashMap new_row = new LinkedHashMap();
        
        
        String pric_sell = StringUtils.clearString(row.get(Stock.pric_sell),"0");
        String total = "0.00";
        
        Integer count_new = new Integer(StringUtils.clearString(count,"0"));
        Float price = new Float(pric_sell);
        total = BigDec.scaledRoundHalfUp(String.valueOf(count_new * price),2);
        String camp_id = "null";
        try{
            LinkedHashMap campRow = Campaign.findCampaign(row.get(Stock.stck_key).toString(),campaigns);
            
            if(campRow==null){
                throw new Exception("not in campaing");
            }
            
            int lownum = new Integer(StringUtils.clearString(campRow.get(Campaign.lownum),"-1")).intValue();
            int highnum = new Integer(StringUtils.clearString(campRow.get(Campaign.highnum),"-1")).intValue();
            
            if( lownum <= count_new && highnum >= count_new ){
                double disc = Double.parseDouble( StringUtils.clearString(campRow.get(Campaign.discount),"-1") );
                
                double disc_unit_price = price * ( 100 - disc ) / 100;
                String strUPrice = BigDec.scaledRoundHalfUp( "" + disc_unit_price, 2 );
                String disc_price = BigDec.scaledRoundHalfUp( "" + (disc_unit_price*count_new), 2 );
                int i = JOptionPane.showConfirmDialog(this,"Please confirm CAMPAIGN discount\n\n Price: " +
                        BigDec.scaledRoundHalfUp( "" + total, 2) +
                        " - " + disc +"% = " +
                        BigDec.scaledRoundHalfUp( "" + disc_price, 2 )+"\n\n","Please confirm CAMPAIGN discount" +
                        "",JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                
                if(i==JOptionPane.OK_OPTION){
                    pric_sell = BigDec.scaledRoundHalfUp(""+disc_unit_price, 2 );
                    total = disc_price;
                    camp_id = ""+campRow.get(Campaign.id);
                }
            } else{
                //throw new Exception(lownum + ">=" + count_new + "||" + count_new + ">=" + highnum);
            }
        } catch(Exception e){
            System.out.println(e.getMessage());
        }
        new_row.put(Stock.stck_brcd,row.get(Stock.stck_brcd));
        new_row.put(Stock.stck_abrv,row.get(Stock.stck_abrv));
        new_row.put(Stock.stck_name,row.get(Stock.stck_name));
        new_row.put(Stock.p_menge,count);
        new_row.put(Stock.pric_sell,BigDec.scaledRoundHalfUp(String.valueOf(pric_sell),2));
        new_row.put(Stock.sum_pric,BigDec.scaledRoundHalfUp(String.valueOf(total),2));
        new_row.put(Campaign.id,camp_id);
        new_row.put(Stock.stck_key,row.get(Stock.stck_key));
        return new_row;
    }
    
    public void addRow(LinkedHashMap new_row){
        ((HashTableModel)tblOrderGoods.getModel()).addRow(new_row);
        base.newStockRowAdded();
    }
    public void removeRow(int index){
        ((HashTableModel)tblOrderGoods.getModel()).removeRow(index);
        ((HashTableModel)tblOrderGoods.getModel()).fireTableDataChanged();
        tblOrderGoods.updateUI();
        base.stockRowRemoved();
    }
    public void loadProducts(String v_nr){
        if(products==null || products.size()<=0){
            return;
        }
        int vnr = 0;
        try {
            vnr = Integer.parseInt(v_nr);
        } catch (NumberFormatException ex) {
            ex.printStackTrace();
            return;
        }
        Vector data = new Vector();
        for(int i = 0; i < products.size(); i++){
            LinkedHashMap row = (LinkedHashMap)products.get(i);
            int id = Integer.parseInt(row.get("v_nr").toString());
            if(vnr==id)
                data.add(row);
        }
        setProductsModel(data);
        
    }
    public void loadCampaign(){
        try {
            campaigns = RemoteCampaign.loadCampaign(base.getUser());
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(this,"Error: Can't load campaigns!\n"+ex.getMessage());
        }
    }
    
    public void setProducts(Vector products) {
        this.products = products;
    }
    
    public void negate(String pref){
        HashTableModel model = (HashTableModel)tblOrderGoods.getModel();
        for( int i = 0; i < model.getRowCount(); i++ ) {
            String sprice = String.valueOf(model.getValueAt(i,4));
            String price = String.valueOf(model.getValueAt(i,5));
            if( sprice != null && !sprice.equals("") )
                model.setValueAt( pref + BigDec.scaledRoundHalfUp(sprice,2), i, 4 );
            if( price != null && !price.equals("") )
                model.setValueAt( pref + BigDec.scaledRoundHalfUp(price,2), i, 5 );
            
        }
        ((HashTableModel)tblOrderGoods.getModel()).fireTableDataChanged();
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jpmOrders = new javax.swing.JPopupMenu();
        mitemDelete = new javax.swing.JMenuItem();
        jScrollPane6 = new javax.swing.JScrollPane();
        tblOrderGoods = new javax.swing.JTable();

        mitemDelete.setText("Delete row");
        mitemDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemDeleteActionPerformed(evt);
            }
        });

        jpmOrders.add(mitemDelete);

        jScrollPane6.setFont(new java.awt.Font("Arial", 1, 12));
        tblOrderGoods.setFont(new java.awt.Font("Arial", 1, 12));
        tblOrderGoods.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Stock Code", "Abbr.", "Stock Name", "Count", "Unit Price", "Sum Price"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblOrderGoods.setName("tblOrderGoods");
        tblOrderGoods.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblOrderGoodsMouseClicked(evt);
            }
        });

        jScrollPane6.setViewportView(tblOrderGoods);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 481, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jScrollPane6, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 156, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    private void mitemDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemDeleteActionPerformed
        int nRow = tblOrderGoods.getSelectedRow();
        removeRow(nRow);           
    }//GEN-LAST:event_mitemDeleteActionPerformed
    
    private void tblOrderGoodsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblOrderGoodsMouseClicked
        if(evt.getSource() == tblOrderGoods){
            if ((evt.getModifiers() & InputEvent.BUTTON3_MASK) != 0) {
                int nRow = tblOrderGoods.rowAtPoint(evt.getPoint());
                //String strEventStatus = (String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(nRow)).getRowElement(EVENTTEXT_INDEX);
                if(nRow < 0)
                    return;
                tblOrderGoods.getSelectionModel().setSelectionInterval( nRow,nRow ) ;
                jpmOrders.show(evt.getComponent(),evt.getX(),evt.getY());
                
            }
        }
    }//GEN-LAST:event_tblOrderGoodsMouseClicked
        // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JPopupMenu jpmOrders;
    private javax.swing.JMenuItem mitemDelete;
    private javax.swing.JTable tblOrderGoods;
    // End of variables declaration//GEN-END:variables
    
}
