package medstore.stock.nomenclature;
import java.awt.Dialog;
import java.util.LinkedHashMap;
import java.util.Vector;
import medstore.String.StringUtils;
import medstore.forms.CommonDialog;
import medstore.stock.CompositeProduct;
import medstore.stock.Stock;
import medstore.stock.StockList;

public class AddEditStock extends CommonDialog {
    
    private StockBase base;
    
    private String strStockId;
    private boolean bAddNewStock;
    private String strPanelTitle;
    private int nSelRow;
    private CompositeProduct cp;
    boolean isPartOfComposite = false;
    
    public static final int EDIT_MODE = 1;
    public static final int ADD_MODE = 2;
    int mode;
    
    String stck_name;
    String stck_abrv;
    String stockgroup;
    String stck_brcd;
    String cntn_bcod;
    String stck_pcnt;
    String stck_limt;
    String pric_buy;
    String pric_mid;
    String pric_sell;
    String stck_key;
    String quote;
    String composite;
    
    public AddEditStock(Dialog parent, int mode) {
        super(parent,true);
        initComponents();
        stck_name = "";
        stck_abrv = "";
        stockgroup = "";
        stck_brcd = "";
        cntn_bcod = "";
        stck_pcnt = "";
        stck_limt = "";
        pric_buy = "";
        pric_mid = "";
        pric_sell = "";
        stck_key = "";
        quote = "";
        composite = "";
        this.mode = mode;
        if(mode == AddEditStock.ADD_MODE){
            setTitle("Add Stock");
        }
        else{
            setTitle("Edit Stock");
        }
    }
    public void setProducts(LinkedHashMap row){
        stck_name = StringUtils.clearString(row.get(Stock.stck_name),"");
        stck_abrv = StringUtils.clearString(row.get(Stock.stck_abrv),"");
        stockgroup = StringUtils.clearString(row.get(Stock.stockgroup),"");
        stck_brcd = StringUtils.clearString(row.get(Stock.stck_brcd),"");
        cntn_bcod = StringUtils.clearString(row.get(Stock.cntn_bcod),"");
        stck_pcnt = StringUtils.clearString(row.get(Stock.stck_pcnt),"");
        stck_limt = StringUtils.clearString(row.get(Stock.stck_limt),"");
        pric_buy = StringUtils.clearString(row.get(Stock.pric_buy),"");
        pric_mid = StringUtils.clearString(row.get(Stock.pric_mid),"");
        pric_sell = StringUtils.clearString(row.get(Stock.pric_sell),"");
        stck_key = StringUtils.clearString(row.get(Stock.stck_key),"");
        quote = StringUtils.clearString(row.get(Stock.quote),"");
        composite = StringUtils.clearString(row.get(Stock.composite),"");
        
        editStockName.setText(stck_name);
        editStockBarcode.setText(stck_brcd);
        editStockCount.setText(stck_pcnt);
        editContentBarcode.setText(cntn_bcod);
        editLimit.setText(stck_limt);
        editBPrice.setText(pric_buy);
        editMPrice.setText(pric_mid);
        editSPrice.setText(pric_sell);
        editAbbreviation.setText(stck_abrv);
        editStockGroup.setText(stockgroup);
        editQuote.setText(quote);
    }
    public void setComposite(Vector data){
        compositeStockPanel.setComposite(data);
    }
    public LinkedHashMap getProduct(){
        stck_name = editStockName.getText();
        stck_abrv = editAbbreviation.getText();
        stockgroup = editStockGroup.getText();
        stck_brcd = editStockBarcode.getText();
        cntn_bcod = editContentBarcode.getText();
        stck_pcnt = editStockCount.getText();
        stck_limt = editLimit.getText();
        pric_buy = editBPrice.getText();
        pric_mid = editMPrice.getText();
        pric_sell = editSPrice.getText();        
        quote = editQuote.getText();
        
        LinkedHashMap new_row = new LinkedHashMap();
        new_row.put(Stock.stck_name,stck_name);
        new_row.put(Stock.stck_abrv,stck_abrv);
        new_row.put(Stock.stockgroup,stockgroup);
        new_row.put(Stock.stck_brcd,stck_brcd);
        new_row.put(Stock.cntn_bcod,cntn_bcod);
        new_row.put(Stock.stck_pcnt,stck_pcnt);
        new_row.put(Stock.stck_limt,stck_limt);
        new_row.put(Stock.pric_buy,pric_buy);
        new_row.put(Stock.pric_mid,pric_mid);
        new_row.put(Stock.pric_sell,pric_sell);
        new_row.put(Stock.stck_key,stck_key);
        new_row.put(Stock.quote,quote);
        new_row.put(Stock.composite,composite);
        
        return StockList.formatRow(new_row);
        
    }
    public void setBase(StockBase base) {
        this.base = base;
    }

    public StockBase getBase() {
        return base;
    }

    public int getMode() {
        return mode;
    }

    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        editStockName = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        editStockCount = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        editStockBarcode = new javax.swing.JTextField();
        editContentBarcode = new javax.swing.JTextField();
        labelCntBarcode = new javax.swing.JLabel();
        editLimit = new javax.swing.JTextField();
        editBPrice = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        editMPrice = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        editSPrice = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        editAbbreviation = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        editStockGroup = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        btnCancel = new javax.swing.JButton();
        buttonSubmit = new javax.swing.JButton();
        jLabel10 = new javax.swing.JLabel();
        editQuote = new javax.swing.JTextField();
        compositeStockPanel = new medstore.stock.nomenclature.CompositeStockPanel();
        selectedCompositPanel = new medstore.stock.nomenclature.SelectedCompositPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Add stock");
        setFont(new java.awt.Font("Arial", 0, 14));
        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Name");

        editStockName.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockName.setMaximumSize(new java.awt.Dimension(230, 21));
        editStockName.setMinimumSize(new java.awt.Dimension(230, 21));
        editStockName.setPreferredSize(new java.awt.Dimension(230, 21));

        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText("Count in packet");

        editStockCount.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockCount.setText("1");
        editStockCount.setMinimumSize(new java.awt.Dimension(20, 21));
        editStockCount.setPreferredSize(new java.awt.Dimension(20, 21));
        editStockCount.setSelectionEnd(2);

        jLabel3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel3.setText("barcode");
        jLabel3.setMinimumSize(new java.awt.Dimension(60, 18));

        editStockBarcode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockBarcode.setMaximumSize(new java.awt.Dimension(100, 21));
        editStockBarcode.setMinimumSize(new java.awt.Dimension(100, 21));
        editStockBarcode.setPreferredSize(new java.awt.Dimension(100, 21));

        editContentBarcode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editContentBarcode.setEnabled(false);

        labelCntBarcode.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        labelCntBarcode.setText("Content barcode");
        labelCntBarcode.setEnabled(false);

        editLimit.setFont(new java.awt.Font("Tahoma", 0, 13));

        editBPrice.setFont(new java.awt.Font("Tahoma", 0, 13));
        editBPrice.setMinimumSize(new java.awt.Dimension(50, 21));
        editBPrice.setPreferredSize(new java.awt.Dimension(50, 21));

        jLabel4.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel4.setText("Limit");

        jLabel5.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel5.setText("Buy price");

        editMPrice.setFont(new java.awt.Font("Tahoma", 0, 13));
        editMPrice.setMinimumSize(new java.awt.Dimension(70, 21));
        editMPrice.setPreferredSize(new java.awt.Dimension(80, 21));

        jLabel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel6.setText("Mid price");

        editSPrice.setFont(new java.awt.Font("Tahoma", 0, 13));
        editSPrice.setMinimumSize(new java.awt.Dimension(50, 21));
        editSPrice.setPreferredSize(new java.awt.Dimension(50, 21));

        jLabel7.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel7.setText("Sell price");

        editAbbreviation.setFont(new java.awt.Font("Tahoma", 0, 13));

        jLabel8.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel8.setText("Abbr.");

        editStockGroup.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editStockGroup.setMinimumSize(new java.awt.Dimension(11, 21));
        editStockGroup.setPreferredSize(new java.awt.Dimension(11, 21));

        jLabel9.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel9.setText("Group");

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMinimumSize(new java.awt.Dimension(101, 37));
        jPanel1.setPreferredSize(new java.awt.Dimension(101, 37));
        btnCancel.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnCancel.setText("Cancel");
        btnCancel.setMargin(new java.awt.Insets(1, 5, 2, 4));
        btnCancel.setMaximumSize(new java.awt.Dimension(55, 25));
        btnCancel.setMinimumSize(new java.awt.Dimension(55, 25));
        btnCancel.setPreferredSize(new java.awt.Dimension(55, 25));
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 15;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        jPanel1.add(btnCancel, gridBagConstraints);

        buttonSubmit.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonSubmit.setText("Submit");
        buttonSubmit.setMargin(new java.awt.Insets(1, 5, 2, 4));
        buttonSubmit.setMaximumSize(new java.awt.Dimension(60, 25));
        buttonSubmit.setMinimumSize(new java.awt.Dimension(60, 25));
        buttonSubmit.setPreferredSize(new java.awt.Dimension(60, 25));
        buttonSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonSubmitActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 20);
        jPanel1.add(buttonSubmit, gridBagConstraints);

        jLabel10.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel10.setText("Quote");

        editQuote.setFont(new java.awt.Font("Tahoma", 0, 13));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jLabel1)
                        .add(255, 255, 255)
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(editStockName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 272, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(20, 20, 20)
                        .add(editStockBarcode, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 252, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jLabel8, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(34, 34, 34)
                        .add(jLabel7, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(34, 34, 34)
                        .add(jLabel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(34, 34, 34)
                        .add(jLabel6, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 70, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(44, 44, 44)
                        .add(jLabel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 110, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(editAbbreviation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(20, 20, 20)
                        .add(editSPrice, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(20, 20, 20)
                        .add(editBPrice, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(20, 20, 20)
                        .add(editMPrice, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 94, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(20, 20, 20)
                        .add(editStockCount, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 78, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(10, 10, 10)
                        .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 40, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(44, 44, 44)
                        .add(jLabel10)
                        .add(66, 66, 66)
                        .add(labelCntBarcode, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 130, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(88, 88, 88)
                        .add(jLabel9, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 90, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .addContainerGap()
                        .add(compositeStockPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(selectedCompositPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                        .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                            .addContainerGap()
                            .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .add(org.jdesktop.layout.GroupLayout.LEADING, layout.createSequentialGroup()
                            .add(10, 10, 10)
                            .add(editLimit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 64, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(20, 20, 20)
                            .add(editQuote, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(20, 20, 20)
                            .add(editContentBarcode, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 198, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(20, 20, 20)
                            .add(editStockGroup, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 138, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))))
                .add(10, 10, 10))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(30, 30, 30)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel1)
                    .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(3, 3, 3)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(editStockName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editStockBarcode, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(10, 10, 10)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel8)
                    .add(jLabel7)
                    .add(jLabel5)
                    .add(jLabel6)
                    .add(jLabel2))
                .add(2, 2, 2)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(editAbbreviation, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editSPrice, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editBPrice, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editMPrice, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editStockCount, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(10, 10, 10)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jLabel4)
                    .add(jLabel10)
                    .add(labelCntBarcode)
                    .add(jLabel9))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(editLimit, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editQuote, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editContentBarcode, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(editStockGroup, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(compositeStockPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(selectedCompositPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-572)/2, (screenSize.height-444)/2, 572, 444);
    }// </editor-fold>//GEN-END:initComponents

    private void buttonSubmitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonSubmitActionPerformed
        base.saveStock();
        dispose();
    }//GEN-LAST:event_buttonSubmitActionPerformed
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        dispose();
    }//GEN-LAST:event_btnCancelActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    public javax.swing.JButton buttonSubmit;
    private medstore.stock.nomenclature.CompositeStockPanel compositeStockPanel;
    private javax.swing.JTextField editAbbreviation;
    private javax.swing.JTextField editBPrice;
    private javax.swing.JTextField editContentBarcode;
    private javax.swing.JTextField editLimit;
    private javax.swing.JTextField editMPrice;
    private javax.swing.JTextField editQuote;
    private javax.swing.JTextField editSPrice;
    private javax.swing.JTextField editStockBarcode;
    private javax.swing.JTextField editStockCount;
    private javax.swing.JTextField editStockGroup;
    private javax.swing.JTextField editStockName;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel labelCntBarcode;
    private medstore.stock.nomenclature.SelectedCompositPanel selectedCompositPanel;
    // End of variables declaration//GEN-END:variables
    
}
