package adminmodul.accesscontrol;

import medstore.SharedUtils;

public class FormPassChange extends javax.swing.JFrame {
    private PassChangeData userData;
    public FormPassChange() {        
        initComponents();
        setLocationRelativeTo(this);
        userData = new PassChangeData();
        userData.setId(SharedUtils.nUserID);
        try{
            init();
        }
        catch(Exception e){
            javax.swing.JOptionPane.showMessageDialog(this,"User Details can not be loaded!\n" + e.getMessage());
        }
        
    }   
    public void init() throws Exception{
        userData.getUser();
        txtUsername.setText(userData.getUserName());                
    }
    public void updatePass(){             
        userData.setConfirmNewPass(txtConfirmNewPass.getText());
        userData.setNewPass(txtNewPass.getText());
        try{
            if(userData.validatePass()){
                userData.updateUser();
                javax.swing.JOptionPane.showMessageDialog(this,"Password updated successfully");
                dispose();
            }            
        }
        catch(Exception e){
            javax.swing.JOptionPane.showMessageDialog(this,e.getMessage());
        }
        
    }
    private void keyPressed(java.awt.event.KeyEvent evt){
        char chKeyPressed = evt.getKeyChar();
        if(chKeyPressed == evt.VK_ENTER){
            cmdConfirm.requestFocus();
            cmdConfirm.doClick();
        }        
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        cmdConfirm = new javax.swing.JButton();
        jLabel5 = new javax.swing.JLabel();
        txtUsername = new javax.swing.JTextField();
        txtNewPass = new javax.swing.JPasswordField();
        txtConfirmNewPass = new javax.swing.JPasswordField();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jLabel1.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel1.setText("Username");
        jLabel1.setMinimumSize(new java.awt.Dimension(150, 21));
        jLabel1.setPreferredSize(new java.awt.Dimension(150, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        getContentPane().add(jLabel1, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel4.setText("New Password");
        jLabel4.setMinimumSize(new java.awt.Dimension(150, 21));
        jLabel4.setPreferredSize(new java.awt.Dimension(150, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jLabel4, gridBagConstraints);

        cmdConfirm.setFont(new java.awt.Font("Tahoma", 1, 12));
        cmdConfirm.setText("Confirm Password");
        cmdConfirm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdConfirmActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        getContentPane().add(cmdConfirm, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel5.setText("Confirm New Password");
        jLabel5.setMinimumSize(new java.awt.Dimension(150, 21));
        jLabel5.setPreferredSize(new java.awt.Dimension(150, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        getContentPane().add(jLabel5, gridBagConstraints);

        txtUsername.setFont(new java.awt.Font("Tahoma", 1, 12));
        txtUsername.setEnabled(false);
        txtUsername.setMinimumSize(new java.awt.Dimension(150, 21));
        txtUsername.setPreferredSize(new java.awt.Dimension(150, 21));
        txtUsername.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtUsernameKeyPressed(evt);
            }
        });

        getContentPane().add(txtUsername, new java.awt.GridBagConstraints());

        txtNewPass.setMinimumSize(new java.awt.Dimension(150, 21));
        txtNewPass.setPreferredSize(new java.awt.Dimension(150, 21));
        txtNewPass.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtNewPassKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        getContentPane().add(txtNewPass, gridBagConstraints);

        txtConfirmNewPass.setMinimumSize(new java.awt.Dimension(150, 21));
        txtConfirmNewPass.setPreferredSize(new java.awt.Dimension(150, 21));
        txtConfirmNewPass.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                txtConfirmNewPassKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        getContentPane().add(txtConfirmNewPass, gridBagConstraints);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents

    private void txtConfirmNewPassKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtConfirmNewPassKeyPressed
        keyPressed(evt);
    }//GEN-LAST:event_txtConfirmNewPassKeyPressed

    private void txtNewPassKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtNewPassKeyPressed
        keyPressed(evt);
    }//GEN-LAST:event_txtNewPassKeyPressed

    private void txtUsernameKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_txtUsernameKeyPressed
        keyPressed(evt);
    }//GEN-LAST:event_txtUsernameKeyPressed

    private void cmdConfirmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdConfirmActionPerformed
        updatePass();
    }//GEN-LAST:event_cmdConfirmActionPerformed
    
    
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FormPassChange().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cmdConfirm;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JPasswordField txtConfirmNewPass;
    private javax.swing.JPasswordField txtNewPass;
    private javax.swing.JTextField txtUsername;
    // End of variables declaration//GEN-END:variables
    
}
