package adminmodul.accesscontrol;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import medstore.SharedUtils;

public class UserPerm extends DBConn {
    
    private UserData userData = null;
    private Connection connDB = null;
    private PreparedStatement pstm = null;
    private ResultSet rs = null;
    
    private ArrayList userList = null;
    
    public UserPerm(UserData userData) {
        this.userData = userData;
    }
    public UserData getCurrent(){
        return userData;
    }
    public int setUser() throws Exception{
        try {
            
            
            try{
                isUsernameExist();
            } catch(Exception e){
                throw new Exception("User already exist!");
            }
            connDB = SharedUtils.getConnection();
            pstm = connDB.prepareStatement(sqlInsertNewUser);
            pstm.setString(1,userData.getUserName());
            pstm.setString(2,userData.getUserPass());
            pstm.setInt(3,userData.getUserType());
            pstm.setString(4,userData.getAbbr());
            pstm.setInt(5,userData.getActiveMacroId());
            
            int br = pstm.executeUpdate();
            
            return br;
            
        } catch (SQLException ex) {
            ex.printStackTrace();
        } finally{
            try {
                pstm.close();
                connDB.close();
            } catch(Exception e) {
            }
        }
        return 0;
    }
    public int setPerms() throws Exception{
        
        try{
            int rows = userData.getPerms().size();
            int uid = isUserExist();
            //System.out.println(" setPerms " + rows + " " + uid);
            if(uid<1){
                throw new Exception("Error: Permissions can not be set!");
            }
            connDB = SharedUtils.getConnection();
            
            for(int i=0; i < rows; i++){
                PermData permData = userData.getPerm(i);
                pstm = connDB.prepareStatement(strSetUserPerm);
                
                pstm.setInt(1,permData.getId());
                pstm.setInt(2,userData.getId());
                pstm.setInt(3,permData.getPermStatus());
                
                pstm.execute();
                pstm.clearParameters();
                pstm.close();
                pstm = null;
            }
            
            return rows;
            
        }catch(Exception ex){
            //System.out.println("setPerms " + ex.getMessage());
            throw new Exception(ex.getMessage());
        } finally{
            try{
                connDB.close();
            } catch(Exception e){
                
            }
            return -1;
        }
        
    }
    public int isUsernameExist() throws Exception{
        try{
            connDB = SharedUtils.getConnection();
            pstm = connDB.prepareStatement(strUNameExist);
            pstm.setString(1,userData.getUserName());
            
            rs = pstm.executeQuery();
            if(rs.next()){
                throw new Exception("User Exsit!");
            }
            return userData.getId();
        }catch(Exception ex){
            //System.out.println("isUserExist " + ex.getMessage());
            throw new Exception(ex.getMessage());
        } finally{
            try{
                connDB.close();
            } catch(Exception e){
                
            }
        }
    }
    
    public int isUserExist() throws Exception{
        try{
            connDB = SharedUtils.getConnection();
            pstm = connDB.prepareStatement(strLInsId);
            pstm.setString(1,userData.getUserName());
            
            rs = pstm.executeQuery();
            if(rs.next()){
                userData.setId(rs.getInt(1));
                System.out.println(userData.getUserName());
            }
            return userData.getId();
        }catch(Exception ex){
            //System.out.println("isUserExist " + ex.getMessage());
            throw new Exception(ex.getMessage());
        } finally{
            try{
                connDB.close();
            } catch(Exception e){
                
            }
        }
    }
   
    public ArrayList getUserList(){
        return userList;
    }
    public void setUserList(ResultSet value) throws Exception{
        while(rs.next()){
            String user_name = value.getString("user_name");
            String user_pass = value.getString("user_pass");
            int user_type = value.getInt("user_type");
            String user_abrv = value.getString("user_abrv");
            int active_macro = value.getInt("active_macro");
            
            UserData userData = new UserData(user_name,user_pass,user_type, user_abrv,active_macro);
            userList.add(userData);
        }
    }
    public UserData getUser() throws Exception{
        try{
            connDB = SharedUtils.getConnection();
            pstm = connDB.prepareStatement(strUserById);
            pstm.setInt(1,userData.getId());
            
            rs = pstm.executeQuery();
            
            while(rs.next()){
                
                int uid = rs.getInt("user_key");
                String user_name = rs.getString("user_name");
                String user_pass = rs.getString("user_pass");
                int user_type = rs.getInt("user_type");
                String user_abrv = rs.getString("user_abrv");
                int active_macro = rs.getInt("active_macro");
                
                userData = new UserData(uid, user_name,user_pass,user_type, user_abrv,active_macro);
            }
            pstm.close();
            return userData;
        }catch(Exception ex){
            System.out.println("getUsers() " + ex.getMessage());
            throw new Exception(ex.getMessage());
        } finally{
            try{
                connDB.close();
            } catch(Exception e){
                
            }
        }
    }
    public UserData getUserPerms() throws Exception{
        try{
            connDB = SharedUtils.getConnection();
            pstm = connDB.prepareStatement(strGetUserPerm);
            pstm.setInt(1,userData.getId());
            
            rs = pstm.executeQuery();
            
            while(rs.next()){
                
                String menu_desc = rs.getString("menu_desc");
                int user_perm = rs.getInt("user_perm");
                int user_idnt = rs.getInt("user_idnt");
                int menu_idnt = rs.getInt("menu_idnt");
                PermData permData = new PermData(menu_idnt,menu_desc,user_perm);
                userData.setPerm(permData);
            }
            pstm.close();
            
            return userData;
        }catch(Exception ex){
            System.out.println("getUserPerms " + ex.getMessage());
            throw new Exception(ex.getMessage());
        } finally{
            try{
                connDB.close();
            } catch(Exception e){
                
            }
        }
    }
    public void deleteUserPerms() throws Exception{
        try{
            connDB = SharedUtils.getConnection();
            pstm = connDB.prepareStatement(strDelConnUserMenu);
            pstm.setInt(1,userData.getId());
            pstm.executeUpdate();
            
        }catch(Exception ex){
            //System.out.println("deleteUserPerms() " + ex.getMessage());
            throw new Exception(ex.getMessage());
        } finally{
            try{
                connDB.close();
            } catch(Exception e){
                
            }
        }
    }
    public void updateUser() throws Exception{
        try{            
            connDB = SharedUtils.getConnection();
            pstm = connDB.prepareStatement(strUserUpdate);            
            pstm.setString(1,userData.getUserName());
            pstm.setString(2,userData.getUserPass());
            //pstm.setInt(3,userData.getUserType());
            pstm.setString(3,userData.getAbbr());
            pstm.setInt(4,userData.getActiveMacroId());
            pstm.setInt(5,userData.getId());
            int br = pstm.executeUpdate();
            System.out.println("updateUser() " + br);
        }catch(Exception ex){
            //System.out.println("updateUser() " + ex.getMessage());
            if(ex.getMessage().indexOf("duplicate key")!=-1)
                throw new Exception("Update failed! Username already exist!!");
            else
                throw new Exception(ex.getMessage());
        } finally{
            try{
                connDB.close();
            } catch(Exception e){
                
            }
        }
    }
}
