/*
 * AddStockDialog.java
 *
 * Created on , 2005,  27, 22:49
 */

package medstore;
import java.sql.Connection;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.JOptionPane;
import medstore.products.composite.MixedDataModel;
import medstore.products.composite.MixedActions;
import medstore.products.composite.CompositeProduct;

/**
 *
 * @author  JohnyEdu
 */
public class AddStockDialogAdmin extends CommonDialog implements SharedConstants{
    
    private String strStockId;
    private boolean bAddNewStock;
    private String strPanelTitle;
    private int nSelRow;
    private CompositeProduct cp;
    boolean isPartOfComposite = false;
    
    /** Creates new form AddStockDialog */
    public AddStockDialogAdmin(String strStockId,java.awt.Frame parent, boolean modal,int nSelRow) {
        super(parent, modal);
        initComponents();
        
        afterInitComponents();
        this.strStockId = strStockId;
        this.nSelRow = nSelRow;
        UniversalTableRow tableRow = null;
        if(strStockId == null) {
            bAddNewStock = true;
            strPanelTitle = "Add new stock to nomenclature";
        } else {
            bAddNewStock = false;
            strPanelTitle = "Edit existing stock in nomenclature";
            tableRow =((UniversalTableModel)StockManagerAdmin.tblAllStocks.getModel()).getRowObject(nSelRow);
            editStockName.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_NAME_INDEX));
            editStockBarcode.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_BARCODE_INDEX));
            editStockCount.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_PCOUNT_INDEX));
            editContentBarcode.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_CNTN_BARCODE_INDEX));
            editLimit.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_LIMIT_INDEX));
            editBPrice.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_BPRICE_INDEX));
            editMPrice.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_MPRICE_INDEX));
            editSPrice.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_SPRICE_INDEX));
            editAbbreviation.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_ABBR_INDEX));
            editStockGroup.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_GROUP_INDEX));
            editQuote.setText((String)tableRow.vecRowElements.get(StockManagerAdmin.STOCK_QUOTE_INDEX));
        }
        if(Integer.parseInt(editStockCount.getText())>1){
            editContentBarcode.setEnabled(true);
            labelCntBarcode.setEnabled(true);
        } else{
            editContentBarcode.setEnabled(false);
            labelCntBarcode.setEnabled(false);
        }
        try{
            cp = new CompositeProduct(tableRow);
            
            MixedDataModel listSrcModel = new MixedDataModel(cp.loadProducts());
            lstSrcProds.setModel(listSrcModel);
            
            MixedDataModel listSelModel = new MixedDataModel(cp.loadChilds());
            int[] widths = {190,10};
            
            selTabl.setModel(listSelModel);
            selTabl.setSelectionMode(selTabl.getSelectionModel().SINGLE_SELECTION);
            SharedUtils.setTableColumnsWidth(selTabl, widths);
            UIUtils.setHorizontalAlignment(selTabl, 1, javax.swing.JTextField.RIGHT );
            new MixedActions(lstSrcProds, selTabl, chkComposite);
            isPartOfComposite = CompositeProduct.isPartOfComposite(this.strStockId);
            if(isPartOfComposite){
                chkComposite.setSelected(false);
                chkComposite.addMouseListener(new java.awt.event.MouseAdapter() {
                    public void mouseClicked(java.awt.event.MouseEvent evt) {                        
                        JOptionPane.showMessageDialog(null,"This product is part of composite stock!");
                        chkComposite.setSelected(false);
                    }
                });
                
            }else{
                
                boolean isComposite = CompositeProduct.isComposite(this.strStockId);
                chkComposite.setSelected(isComposite);
            }
            
            
        } catch(Exception e){
            JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
            e.printStackTrace();
        }
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel1 = new javax.swing.JLabel();
        editStockName = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        editStockCount = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        editStockBarcode = new javax.swing.JTextField();
        editContentBarcode = new javax.swing.JTextField();
        labelCntBarcode = new javax.swing.JLabel();
        editLimit = new javax.swing.JTextField();
        editBPrice = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        editMPrice = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        editSPrice = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        editAbbreviation = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        editStockGroup = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        btnCancel = new javax.swing.JButton();
        buttonSubmit = new javax.swing.JButton();
        jLabel10 = new javax.swing.JLabel();
        editQuote = new javax.swing.JTextField();
        chkComposite = new javax.swing.JCheckBox();
        scrSrcPane = new javax.swing.JScrollPane();
        lstSrcProds = new javax.swing.JList();
        scrSelPane = new javax.swing.JScrollPane();
        selTabl = new javax.swing.JTable();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Add stock");
        setFont(new java.awt.Font("Arial", 0, 14));
        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Name");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 1, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        editStockName.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockName.setMaximumSize(new java.awt.Dimension(230, 21));
        editStockName.setMinimumSize(new java.awt.Dimension(230, 21));
        editStockName.setPreferredSize(new java.awt.Dimension(230, 21));
        editStockName.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(editStockName, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText("Count in packet");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 10);
        getContentPane().add(jLabel2, gridBagConstraints);

        editStockCount.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockCount.setText("1");
        editStockCount.setMinimumSize(new java.awt.Dimension(20, 21));
        editStockCount.setPreferredSize(new java.awt.Dimension(20, 21));
        editStockCount.setSelectionEnd(2);
        editStockCount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editStockCountActionPerformed(evt);
            }
        });
        editStockCount.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                AddStockDialogAdmin.this.focusLost(evt);
            }
        });
        editStockCount.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 10, 70);
        getContentPane().add(editStockCount, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel3.setText("barcode");
        jLabel3.setMinimumSize(new java.awt.Dimension(60, 18));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 1, 0);
        getContentPane().add(jLabel3, gridBagConstraints);

        editStockBarcode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockBarcode.setMaximumSize(new java.awt.Dimension(100, 21));
        editStockBarcode.setMinimumSize(new java.awt.Dimension(100, 21));
        editStockBarcode.setPreferredSize(new java.awt.Dimension(100, 21));
        editStockBarcode.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editStockBarcodeActionPerformed(evt);
            }
        });
        editStockBarcode.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 10);
        getContentPane().add(editStockBarcode, gridBagConstraints);

        editContentBarcode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editContentBarcode.setEnabled(false);
        editContentBarcode.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 10, 0);
        getContentPane().add(editContentBarcode, gridBagConstraints);

        labelCntBarcode.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        labelCntBarcode.setText("Content barcode");
        labelCntBarcode.setEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 25;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        getContentPane().add(labelCntBarcode, gridBagConstraints);

        editLimit.setFont(new java.awt.Font("Tahoma", 0, 13));
        editLimit.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 10, 0);
        getContentPane().add(editLimit, gridBagConstraints);

        editBPrice.setFont(new java.awt.Font("Tahoma", 0, 13));
        editBPrice.setMinimumSize(new java.awt.Dimension(50, 21));
        editBPrice.setPreferredSize(new java.awt.Dimension(50, 21));
        editBPrice.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 10, 0);
        getContentPane().add(editBPrice, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel4.setText("Limit");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.ipadx = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        getContentPane().add(jLabel4, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel5.setText("Buy price");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 10;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel5, gridBagConstraints);

        editMPrice.setFont(new java.awt.Font("Tahoma", 0, 13));
        editMPrice.setMinimumSize(new java.awt.Dimension(70, 21));
        editMPrice.setPreferredSize(new java.awt.Dimension(80, 21));
        editMPrice.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 10, 0);
        getContentPane().add(editMPrice, gridBagConstraints);

        jLabel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel6.setText("Mid price");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel6, gridBagConstraints);

        editSPrice.setFont(new java.awt.Font("Tahoma", 0, 13));
        editSPrice.setMinimumSize(new java.awt.Dimension(50, 21));
        editSPrice.setPreferredSize(new java.awt.Dimension(50, 21));
        editSPrice.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                evnhKeyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 10, 0);
        getContentPane().add(editSPrice, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel7.setText("Sell price");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel7, gridBagConstraints);

        editAbbreviation.setFont(new java.awt.Font("Tahoma", 0, 13));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 10, 0);
        getContentPane().add(editAbbreviation, gridBagConstraints);

        jLabel8.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel8.setText("Abbr.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 16;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(jLabel8, gridBagConstraints);

        editStockGroup.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editStockGroup.setMinimumSize(new java.awt.Dimension(11, 21));
        editStockGroup.setPreferredSize(new java.awt.Dimension(11, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 2.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 10, 10);
        getContentPane().add(editStockGroup, gridBagConstraints);

        jLabel9.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel9.setText("Group");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.ipadx = 51;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        getContentPane().add(jLabel9, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMinimumSize(new java.awt.Dimension(101, 37));
        jPanel1.setPreferredSize(new java.awt.Dimension(101, 37));
        btnCancel.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnCancel.setText("Cancel");
        btnCancel.setMargin(new java.awt.Insets(1, 5, 2, 4));
        btnCancel.setMaximumSize(new java.awt.Dimension(55, 25));
        btnCancel.setMinimumSize(new java.awt.Dimension(55, 25));
        btnCancel.setPreferredSize(new java.awt.Dimension(55, 25));
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 15;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        jPanel1.add(btnCancel, gridBagConstraints);

        buttonSubmit.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonSubmit.setText("Submit");
        buttonSubmit.setMargin(new java.awt.Insets(1, 5, 2, 4));
        buttonSubmit.setMaximumSize(new java.awt.Dimension(60, 25));
        buttonSubmit.setMinimumSize(new java.awt.Dimension(60, 25));
        buttonSubmit.setPreferredSize(new java.awt.Dimension(60, 25));
        buttonSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddStockDialogAdmin.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 20);
        jPanel1.add(buttonSubmit, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jPanel1, gridBagConstraints);

        jLabel10.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel10.setText("Quote");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        getContentPane().add(jLabel10, gridBagConstraints);

        editQuote.setFont(new java.awt.Font("Tahoma", 0, 13));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 10, 0);
        getContentPane().add(editQuote, gridBagConstraints);

        chkComposite.setFont(new java.awt.Font("Tahoma", 1, 13));
        chkComposite.setText("Composite");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        getContentPane().add(chkComposite, gridBagConstraints);

        scrSrcPane.setBorder(new javax.swing.border.TitledBorder(null, "All Products", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12)));
        scrSrcPane.setMinimumSize(new java.awt.Dimension(100, 150));
        scrSrcPane.setPreferredSize(new java.awt.Dimension(100, 150));
        scrSrcPane.setViewportView(lstSrcProds);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        getContentPane().add(scrSrcPane, gridBagConstraints);

        scrSelPane.setBorder(new javax.swing.border.TitledBorder(null, "Selected Products", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12)));
        scrSelPane.setMinimumSize(new java.awt.Dimension(100, 150));
        scrSelPane.setPreferredSize(new java.awt.Dimension(100, 150));
        selTabl.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        scrSelPane.setViewportView(selTabl);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        getContentPane().add(scrSelPane, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-572)/2, (screenSize.height-420)/2, 572, 420);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void editStockBarcodeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editStockBarcodeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_editStockBarcodeActionPerformed
    
    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        // TODO add your handling code here:
        dispose();
    }//GEN-LAST:event_btnCancelActionPerformed
    
    private void focusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_focusLost
        if(evt.getSource()==editStockCount){
            if(Integer.parseInt(editStockCount.getText())>1){
                editContentBarcode.setEnabled(true);
                labelCntBarcode.setEnabled(true);
            } else{
                editContentBarcode.setEnabled(false);
                labelCntBarcode.setEnabled(false);
            }
        }
    }//GEN-LAST:event_focusLost
    
    private void editStockCountActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editStockCountActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_editStockCountActionPerformed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource() == buttonSubmit) {
            //--- uncomment here
            /*
            if(!UniversalInputVerifier.Universal_String_Verifier(editStockName)){
                JOptionPane.showMessageDialog(null,"Please, enter valid stock name");
                return;
            }
             */
            if(!UniversalInputVerifier.BARCODE_Verifier(editStockBarcode)){
                JOptionPane.showMessageDialog(null,"Please, enter valid barcode");
                return;
            }
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editStockCount)){
                JOptionPane.showMessageDialog(null,"Please, enter valid stock count in packet");
                return;
            }
            if(editContentBarcode.isEnabled()){
                if(editContentBarcode.getText().equals("")){
                    JOptionPane.showMessageDialog(null,"Please, enter valid content barcode");
                    return;
                }
            }
            
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editStockGroup)){
                JOptionPane.showMessageDialog(null,"Please, enter Stock Group");
                return;
            }
            
            String strStockName = editStockName.getText();
            try {
                //strStockName = new String( strStockName.getBytes("ISO-8859-1") );
            } catch(Exception e) {
                e.printStackTrace();
            }
            String strCountInPacket = editStockCount.getText();
            String strLimit = editLimit.getText();
            String strBPrice = editBPrice.getText();
            String strMPrice = editMPrice.getText();
            String strSPrice = editSPrice.getText();
            String strBarcode = editStockBarcode.getText();
            String strContentBarcode = editContentBarcode.getText();
            String strAbbreviation = editAbbreviation.getText();
            String strStockGroup = editStockGroup.getText();
            String quote = "0";
            try{
                quote = String.valueOf(Math.max(0,Integer.parseInt(editQuote.getText())));
            } catch(Exception e){
                
            }
            Connection connDB=null;
            String strLastOrdrID = null;
            try {
                connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
                Statement stm = connDB.createStatement();
                String strSQL;
                if(bAddNewStock){
                    if(SharedConstants.DB_RECORD_EXISTS == SharedUtils.recordExists(connDB,
                            "SELECT STCK_KEY FROM BASE_STCK WHERE STCK_ABRV = '" + strAbbreviation + "'")){
                        JOptionPane.showMessageDialog(null,"There is existing stock with that abbreviation. Please, choose another!");
                        return;
                    }
                    if(SharedConstants.DB_RECORD_EXISTS == SharedUtils.recordExists(connDB,
                            "SELECT STCK_KEY FROM BASE_STCK WHERE stck_brcd = '" + strBarcode + "'")){
                        JOptionPane.showMessageDialog(null,"There is existing stock with that barcode. Please, choose another!");
                        return;
                    }
                    strSQL = "INSERT INTO BASE_STCK" +
                            " (stck_name,stck_brcd,stck_pcnt,cntn_bcod,stck_limt," +
                            " pric_buy,pric_mid,pric_sell,stck_abrv,stockgroup,quote)" +
                            " VALUES('" + strStockName + "','"+ strBarcode + "'," +
                            strCountInPacket + ",'" + strContentBarcode + "'," + strLimit + "," + strBPrice +
                            "," + strMPrice + "," + strSPrice +  ",'" + strAbbreviation + "'," + strStockGroup +"," + quote + ")";
                } else{
                    if(SharedConstants.DB_RECORD_EXISTS == SharedUtils.recordExists(connDB,
                            "SELECT STCK_KEY FROM BASE_STCK WHERE STCK_ABRV = '" + strAbbreviation +
                            "' AND STCK_KEY != " + strStockId )){
                        JOptionPane.showMessageDialog(null,"There is existing stock with that abbreviation.Please, choose another!");
                        return;
                    }
                    if(SharedConstants.DB_RECORD_EXISTS == SharedUtils.recordExists(connDB,
                            "SELECT STCK_KEY FROM BASE_STCK WHERE stck_brcd = '" + strBarcode +
                            "' AND STCK_KEY != " + strStockId )){
                        JOptionPane.showMessageDialog(null,"There is existing stock with that barcode .Please, choose another!");
                        return;
                    }
                    if(strStockId==null){
                        JOptionPane.showMessageDialog(null,"System error, please restart!");
                        return;
                    }
                    strSQL = "UPDATE BASE_STCK SET STCK_NAME ='" + strStockName + "', STCK_BRCD ='" + strBarcode +
                            "',STCK_PCNT = " + strCountInPacket + ", CNTN_BCOD ='" + strContentBarcode +
                            "',STCK_LIMT = " + strLimit  + ",PRIC_BUY = " + strBPrice + ",PRIC_MID = " + strMPrice +
                            ",PRIC_SELL = " + strSPrice + ", STCK_ABRV = '" + strAbbreviation + "', STOCKGROUP=" + strStockGroup + "," + "quote=" + quote + " WHERE STCK_KEY = " + strStockId;
                }
                int nRowsModified = stm.executeUpdate(strSQL);
                if(nRowsModified != 1){
                    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
                    return;
                }
                
                stm.close();
                final String msg;
                if(bAddNewStock) {
                    strLastOrdrID = SharedUtils.getLastInsertedID(connDB);
                    cp.setStckKey(strLastOrdrID);
                    Vector vecRowElements = new Vector();
                    vecRowElements.addElement(strStockName);
                    vecRowElements.addElement(strAbbreviation);
                    vecRowElements.addElement(strStockGroup);
                    vecRowElements.addElement(strBarcode);
                    vecRowElements.addElement(strContentBarcode);
                    vecRowElements.addElement(strCountInPacket);
                    vecRowElements.addElement(strLimit);
                    vecRowElements.addElement(strBPrice);
                    vecRowElements.addElement(strMPrice);
                    vecRowElements.addElement(strSPrice);
                    vecRowElements.addElement(strLastOrdrID);
                    vecRowElements.addElement(quote);
                    vecRowElements.addElement("-1");
                    final UniversalTableRow uniTableRow = new UniversalTableRow(vecRowElements);
                    javax.swing.SwingUtilities.invokeLater(new Runnable(){
                        public void run() {
                            ((UniversalTableModel)StockManagerAdmin.tblAllStocks.getModel()).addObject((Object)uniTableRow);
                            StockManagerAdmin.tblAllStocks.updateUI();
                            
                        }
                    });
                    msg = "The Stock was added successfully to the system!";
                    ////////////////////////
                    editStockName.setText("");
                    editStockBarcode.setText("");
                    editStockCount.setText("");
                    editLimit.setText("");
                    editBPrice.setText("");
                    editMPrice.setText("");
                    editSPrice.setText("");
                    editAbbreviation.setText("");
                    editStockGroup.setText("");
                    editQuote.setText("0");
                    
                } else {
                    Vector vecRowElements = new Vector();
                    vecRowElements.addElement(strStockName);
                    vecRowElements.addElement(strAbbreviation);
                    vecRowElements.addElement(strStockGroup);
                    vecRowElements.addElement(strBarcode);
                    vecRowElements.addElement(strContentBarcode);
                    vecRowElements.addElement(strCountInPacket);
                    vecRowElements.addElement(strLimit);
                    vecRowElements.addElement(strBPrice);
                    vecRowElements.addElement(strMPrice);
                    vecRowElements.addElement(strSPrice);
                    vecRowElements.addElement(strStockId);
                    vecRowElements.addElement(quote);
                    vecRowElements.addElement("-1");
                    final UniversalTableRow uniTableRow = new UniversalTableRow(vecRowElements);
                    javax.swing.SwingUtilities.invokeLater(new Runnable(){
                        public void run() {
                            ((UniversalTableModel)StockManagerAdmin.tblAllStocks.getModel()).setRowObject((Object)uniTableRow,nSelRow);
                            StockManagerAdmin.tblAllStocks.updateUI();
                        }
                    });
                    msg = "The Stock was successfully edited!";
                }
                try{
                    cp.insertComposite((MixedDataModel)selTabl.getModel(),chkComposite.isSelected());
                } catch(Exception e){
                    JOptionPane.showMessageDialog(null,e.getMessage());
                } finally{
                    JOptionPane.showMessageDialog(null,msg);
                    dispose();
                }
                editStockName.requestFocus();
            } catch(Exception e){
                JOptionPane.showMessageDialog(null,"Some data are not confirmed.\nError - " + e.getMessage());
                e.printStackTrace();
                return;
            } finally {
                SharedUtils.closeConnection(connDB);
            }
        }
    }//GEN-LAST:event_actionPerformed
    
    private void evnhKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_evnhKeyPressed
        char chKeyPressed = evt.getKeyChar();
        if(evt.getSource() == editStockName) {
            if(chKeyPressed == evt.VK_ENTER) {
                editStockCount.requestFocus();
                editStockCount.setText("1");
                editStockCount.setSelectionStart(0);
                editStockCount.setSelectionEnd(1);
            }
        } else if(evt.getSource() == editStockCount) {
            if(chKeyPressed == evt.VK_ENTER) {
                editLimit.requestFocus();
            }
        } else if(evt.getSource() == editLimit) {
            if(chKeyPressed == evt.VK_ENTER) {
                editBPrice.requestFocus();
            }
        } else if(evt.getSource() == editBPrice) {
            if(chKeyPressed == evt.VK_ENTER) {
                editMPrice.requestFocus();
            }
        } else if(evt.getSource() == editMPrice) {
            if(chKeyPressed == evt.VK_ENTER) {
                editSPrice.requestFocus();
            }
        } else if(evt.getSource() == editSPrice) {
            if(chKeyPressed == evt.VK_ENTER) {
                editStockBarcode.requestFocus();
            }
        } else if(evt.getSource() == editStockBarcode) {
            if(chKeyPressed == evt.VK_ENTER) {
                if(editContentBarcode.isEnabled()){
                    editContentBarcode.requestFocus();
                } else{
                    buttonSubmit.requestFocus();
                    buttonSubmit.doClick();
                }
            }
        } else if(evt.getSource() == editContentBarcode) {
            if(chKeyPressed == evt.VK_ENTER) {
                buttonSubmit.requestFocus();
                buttonSubmit.doClick();
            }
        }
    }//GEN-LAST:event_evnhKeyPressed
    
    private void afterInitComponents() {
        UniversalInputVerifier stockCountInputVerifier = new UniversalInputVerifier(AddStockDialog_STOCK_COUNT,this);
        editStockCount.setInputVerifier(stockCountInputVerifier);
        UniversalInputVerifier stockGroupInputVerifier = new UniversalInputVerifier(AddStockDialog_STOCK_GROUP,this);
        editStockGroup.setInputVerifier(stockGroupInputVerifier);
        UniversalInputVerifier stockNameInputVerifier = new UniversalInputVerifier(AddStockDialog_STOCK_NAME,this);
        editStockName.setInputVerifier(stockNameInputVerifier);
        UniversalInputVerifier stockBarcodeInputVerifier = new UniversalInputVerifier(AddStockDialog_STOCK_BARCODE,this);
        editStockBarcode.setInputVerifier(stockBarcodeInputVerifier);
        UniversalInputVerifier integerVerifier = new UniversalInputVerifier(Universal_Integer,this);
        editLimit.setInputVerifier(integerVerifier);
        UniversalInputVerifier floatBVerifier = new UniversalInputVerifier(Universal_Float,this);
        editBPrice.setInputVerifier(floatBVerifier);
        UniversalInputVerifier floatMVerifier = new UniversalInputVerifier(Universal_Float,this);
        editMPrice.setInputVerifier(floatMVerifier);
        UniversalInputVerifier floatSVerifier = new UniversalInputVerifier(Universal_Float,this);
        editSPrice.setInputVerifier(floatSVerifier);
        //panelEventRegister.setBorder(new javax.swing.border.TitledBorder(strPanelTitle));
        
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    public javax.swing.JButton buttonSubmit;
    private javax.swing.JCheckBox chkComposite;
    private javax.swing.JTextField editAbbreviation;
    private javax.swing.JTextField editBPrice;
    private javax.swing.JTextField editContentBarcode;
    private javax.swing.JTextField editLimit;
    private javax.swing.JTextField editMPrice;
    private javax.swing.JTextField editQuote;
    private javax.swing.JTextField editSPrice;
    private javax.swing.JTextField editStockBarcode;
    private javax.swing.JTextField editStockCount;
    private javax.swing.JTextField editStockGroup;
    private javax.swing.JTextField editStockName;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel labelCntBarcode;
    private javax.swing.JList lstSrcProds;
    private javax.swing.JScrollPane scrSelPane;
    private javax.swing.JScrollPane scrSrcPane;
    private javax.swing.JTable selTabl;
    // End of variables declaration//GEN-END:variables
    
}
