/*
 * ComboDataModel.java
 *
 * Created on , 2005,  1, 20:34
 */

package medstore;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.Vector;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultSingleSelectionModel;
import javax.swing.JOptionPane;
import javax.swing.SwingUtilities;
import javax.swing.event.ListDataListener;

/**
 *
 * @author JohnyEdu
 */
public class ComboDataModel extends DefaultSingleSelectionModel implements ComboBoxModel,SharedConstants{
    Vector vecData;
    
    /** Creates a new instance of ComboDataModel */
    public ComboDataModel(ResultSet rsSQLResult) {
        vecData = new Vector();
        try{                                                
                ResultSetMetaData resultsMetaData = rsSQLResult.getMetaData();
                int nColumnCount = resultsMetaData.getColumnCount();
                boolean bEOF = rsSQLResult.next();           
                while( bEOF )
                {
                          String strItemName = new String((rsSQLResult.getString(1)));                                                    
                          if(strItemName==null)
                          {
                              //some error handling here      
                              break;                                                                      
                          }
                          int nItemId = -1;
                          if(nColumnCount > 1)
                                  nItemId = rsSQLResult.getInt(2);
                          vecData.addElement(new ComboDataRow(strItemName,nItemId));
                          bEOF=rsSQLResult.next();
                }                            
        }catch(SQLException sqle){  SharedUtils.handleError(GENERAL_DB_ERROR); return; } 
        catch(NullPointerException npe){ SharedUtils.handleError(INTERNAL_SYSTEM_ERROR); return; }
    }
    public Object getElementAt(int index) {
        return (String)((ComboDataRow)vecData.get(index)).strComboItem;
    }
    public ComboDataRow getCObjectAt(int index)
    {
        return (ComboDataRow)vecData.get(index);
    }
    public void insertCObjectAt(int index, ComboDataRow cdrRow)
    {
        vecData.insertElementAt(cdrRow,index);
    }
    //public int getIndexByContent
    public int getSize() {
        return(vecData.size());
    }

    public void addListDataListener(ListDataListener l) {
           //this.addListDataListener(l);
    }

    public void removeListDataListener(ListDataListener l) {
           //this.removeListDataListener(l);
    }
    
    public Object getSelectedItem()
    {
        if(vecData!=null)
        {
            if(vecData.size()>0)
            {
                final int nSelIndex = getSelectedIndex();                 
                /*
                SwingUtilities.invokeLater(new Runnable(){
                  public void run()
                  {
                    if(nSelIndex!=2)
                      JOptionPane.showMessageDialog(null,String.valueOf(nSelIndex));
                  }});
                 */
                if(nSelIndex != -1)
                    return ((ComboDataRow)vecData.get(nSelIndex)).strComboItem;
                return ((ComboDataRow)vecData.get(0)).strComboItem;
            }
        }
        return null;       
    }
    
    public void setSelectedItem(Object obj)
    {
        for(int index=0;index<vecData.size();index++)
        {
            if(((ComboDataRow)vecData.get(index)).strComboItem.equals((String)obj))
            {
                setSelectedIndex(index);
                fireStateChanged();
                break;
                //set
            }
        }
    }
    
    public int getSelectedIndex(){
        return super.getSelectedIndex();       
    }
    public void setSelectedIndex(int index){
        super.setSelectedIndex(index);       
    }
    public void selectIndexByContent(Object obj)
    {
        for(int index=0;index<vecData.size();index++)
        {
            if(((ComboDataRow)vecData.get(index)).strComboItem.equals((String)obj))
            {
                setSelectedIndex(index);
                break;
                //set
            }
        }
    }
    
    public void selectIndexByKey(int nDBItem){
        for(int index=0;index<vecData.size();index++)
        {
            if(((ComboDataRow)vecData.get(index)).nItemDBKey == nDBItem)
            {
                setSelectedIndex(index);
                break;
            }
        }
    }
    public void removeAll(){
        vecData = new Vector();
    }
    public Vector getDataVector(){
        return vecData;
    }
}
