/*
 * ComponentPageable.java
 *
 * Created on , 2005,  15, 23:45
 */

package medstore;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.print.PageFormat;
import java.awt.print.Pageable;
import java.awt.print.Printable;


/**
 *
 * @author JohnyEdu
 */
public class ComponentPageable implements Pageable{
    
    private Component printableComponent;
    private int totalNumPages ;
    private PageFormat pageFormat;
    Printable printable;
    /** Creates a new instance of ComponentPageable */
    public ComponentPageable(Component printableComponent, PageFormat pageFormat, Printable printable) {
        
        this.printableComponent = printableComponent;
        this.pageFormat = pageFormat;
        this.printable = printable;
        Dimension d = printableComponent.getSize(); //get size of document
        double panelWidth = d.width; //width in pixels
        double panelHeight = d.height; //height in pixels
        double pageHeight = pageFormat.getImageableHeight(); //height of printer page
        double pageWidth = pageFormat.getImageableWidth(); //width of printer page
        double scale = pageWidth / panelWidth;
        this.totalNumPages = (int) Math.ceil(scale * panelHeight / pageHeight);
    }
    
    public int getNumberOfPages(){
        return totalNumPages;
    }
    
    public PageFormat getPageFormat(int pageIndex){
        return pageFormat;
    }
    
    public void printComponent(){
        
    }
    public Printable getPrintable(int pageIndex){
        return printable;
    }
}
