/*
 * GenerateLettersDialog.java
 *
 * Created on , 2005,  3, 15:21
 */

package medstore;

import java.awt.Component;
import java.awt.print.*;
import java.util.Vector;
import java.util.HashMap;
import javax.swing.JOptionPane;
import java.sql.*;

/**
 *
 * @author  JohnyEdu
 */
public class GenerateLettersDialog extends CommonDialog implements SharedConstants {

    public static final int ORDERNO_IDEX = 0;
    public static final int DATE_IDEX = 1;
    public static final int DOCTYPE_IDEX = 2;
    public static final int NETTO_IDEX = 3;
    public static final int TOTAL_IDEX = 4;
    public static final int PAYED_IDEX = 5;

    public static final int APPEAL_IDEX = 0;
    public static final int FIRSTNAME_IDEX = 1;
    public static final int LASTNAME_IDEX = 2;
    public static final int STREET_IDEX = 3;
    public static final int CODE_IDEX = 4;
    public static final int CITY_IDEX = 5;
    public static final int CLIENT_DATE_IDEX = 6;
    public static final int CLIENT_ORDERNO_IDEX = 7;
    public static final int CLIENTIDNT_IDEX = 8;

    private Vector vecOrders;
    private int letterMode;
    private Vector vecClientInfo;
    HashMap m_invoiceDates;
    String m_orderNum;
    int m_currentRow;
    /** Creates new form GenerateLettersDialog */
    public GenerateLettersDialog(java.awt.Frame parent, boolean modal, Vector vecClientInfo, Vector vecOrders, int letterMode, HashMap invoiceDates ) {
        super(parent, modal);
        this.vecClientInfo = vecClientInfo;
        this.m_invoiceDates = invoiceDates;
        initComponents();
        this.vecOrders = vecOrders;
        this.letterMode = letterMode;
        afterInitComponets();        
    }    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel9 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        edpInvoice = new javax.swing.JEditorPane();
        btnPrint = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Send Letter");
        jPanel9.setLayout(new java.awt.GridBagLayout());

        edpInvoice.setFont(new java.awt.Font("Tahoma", 0, 13));
        jScrollPane4.setViewportView(edpInvoice);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel9.add(jScrollPane4, gridBagConstraints);

        btnPrint.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnPrint.setText("Print ...");
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                GenerateLettersDialog.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.ipadx = 21;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 10, 10);
        jPanel9.add(btnPrint, gridBagConstraints);

        getContentPane().add(jPanel9, java.awt.BorderLayout.CENTER);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-561)/2, (screenSize.height-577)/2, 561, 577);
    }
    // </editor-fold>//GEN-END:initComponents

    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if( evt.getSource() == btnPrint){
            PrinterJob printerJob = PrinterJob.getPrinterJob();
            /////////////////////
            PageFormat pageFormat = printerJob.defaultPage();
            Paper paper = new Paper();
            paper.setImageableArea( 28.346456692913385, 28.346456692913385, 
                    538.5826771653543, 785.1968503937007 );
            paper.setSize( 595.275590551181, 841.8897637795276 );
            pageFormat.setPaper( paper );        
            pageFormat = printerJob.pageDialog(pageFormat);
            /////////////////////
            PrintUtilities printUtilities = new PrintUtilities((Component)edpInvoice, 1.5);
            ComponentPageable componentPagable = new ComponentPageable((Component)edpInvoice, pageFormat, (Printable)printUtilities);
            

            printerJob.setPageable(componentPagable);
            try{
                if(printerJob.printDialog()){
                    printerJob.print();
                }
            }catch(PrinterException pex){

                JOptionPane.showMessageDialog(null,"There is a problem with your printer!Invoice cannot be printed!");
                return;
            }
            //update dates
            Connection conn = null;
            try
            {
                Timestamp tmspCurrentDate = SharedUtils.getCurrentTimestamp();
                String  sql = "update vorgang set letter" + letterMode + "date=?" + 
                        " where v_nr=" + m_orderNum;
                conn = SharedUtils.getConnection();
                PreparedStatement pstm = conn.prepareStatement(sql);
                pstm.setTimestamp(1, tmspCurrentDate );
                pstm.executeUpdate();
                pstm.close();
            }
            catch(SQLException e)
            {
                SharedUtils.handleError( GENERAL_DB_ERROR );
            }
            finally
            {
                SharedUtils.closeConnection(conn);
            }
        }
    }//GEN-LAST:event_actionPerformed

    /**
     * @param args the command line arguments
     */
   private void afterInitComponets(){
        String strHtml = "<html><body>";
        strHtml += "<br>" + getLetterText();
        strHtml += "</html></body>";
        edpInvoice.setContentType("text/html");
        final String str = strHtml;
        javax.swing.SwingUtilities.invokeLater( new Runnable()
        {
            public void run()
            {
                edpInvoice.setText(str);
            }
        });        
   }
   
   private String getLetterText()
   {
       String strAppeal = (String) vecClientInfo.get(0);
        String strFirstName = (String) vecClientInfo.get(1);
        String strLastName = (String) vecClientInfo.get(2);
        String strStreet = (String) vecClientInfo.get(3);
        String strCode = (String) vecClientInfo.get(4);
        String strCity = (String) vecClientInfo.get(5);
        String strDate = SharedUtils.getCurrentOnlyDateStringFormatted();//(String) vecClientInfo.get(6);
        //String strOrderNo = (String)((UniversalTableRow)vecOrders.get(0)).getRowElement(0);
        String strClientIdnt = (String) vecClientInfo.get(8);
        String altName = SharedUtils.executeSqlScalar( "select altr_name from base_prsn where prsn_key="+strClientIdnt );
        if( altName == null )
            altName = "";
        if( altName != null && !altName.equals("") )
            altName += "<br>";

        int printerRows = 13;
        int rowsPerPage = 20;
        String strHtml = "<html><body topmargin='0'><table width='100%' border='0' style=\"FONT-SIZE: 14pt\">" +
             "<tr><td align='center' colspan='2'><font size='10'><b>VITA NATURA</b></font><br><br></td></tr>" +
             "<tr><td width='50%' align='left'>";
        strHtml += strAppeal + "<br>" + strFirstName + " " + strLastName + "<br>" + altName;
        strHtml += strStreet + "<br>" + strCode + " " + strCity;
        strHtml += "</td><td align='right' ><br><br>Ihre Kunden-Nr.: " + strClientIdnt + "<br>Datum: " 
                + strDate +" </td></tr></table>";
        
        strHtml += "<br><br>";
        
        strHtml += "<table  width='100%' border='0'><tr><td>" + getBeforTableHTML( strAppeal, strLastName ) + "</td></tr></table>";
        
        strHtml += "<table  width='100%' cellspacing='0' cellpadding='0' ><tr>";
        strHtml += "<td><b>Rechnunng</b></td><td><b>Datum</b></td><td><b>Zinstage</b></td>";
        strHtml += "<td align='right'><b>Betrag</b></td><td align='right'><b>bezahlt</b></td><td align='right'><b>zu zahlen</b></td></tr>";
        int orderCount = vecOrders.size();
        String strTableOrderNo = "";
        String strDocType = "";
        String strNetto = "";
        String strTotal = "";
        String strPayed = "";
        double sumTotals = 0;
        for( int i = 0; i < orderCount; i++ ){
            String strTableDate = "";
            UniversalTableRow uniRow = (UniversalTableRow)vecOrders.get(i);
            strTableOrderNo = m_orderNum = (String)uniRow.getRowElement( ORDERNO_IDEX );
            strTableDate = (String)m_invoiceDates.get(strTableOrderNo);
            strDocType = (String)uniRow.getRowElement( DOCTYPE_IDEX );
            strNetto = (String)uniRow.getRowElement( NETTO_IDEX );
            strTotal = (String)uniRow.getRowElement( TOTAL_IDEX );
            strPayed = (String)uniRow.getRowElement( PAYED_IDEX );
            sumTotals += Double.parseDouble(strTotal);

            strHtml += "<tr><td>" + strTableOrderNo + "</td><td>" + strTableDate + "</td><td>" + strDocType + "</td>";
            strHtml += "<td align='right'>" + SharedUtils.formatFloat(strNetto, '.' ) + "</td><td align='right'>" + SharedUtils.formatFloat(strPayed, '.' ) +
                       "</td><td align='right'>" + SharedUtils.formatFloat(strTotal, '.' ) + " EUR</td></tr>";
            
            printerRows++;
            if ( printerRows > rowsPerPage){
                strHtml += "<tr><td colspan='5'>&nbsp</td></tr>";
                strHtml += "<tr><td colspan='5'>&nbsp</td></tr>";
                printerRows = 1;
            }
        }
        String penalty = getPenalty();
        String totalPenalty = "" + ( Double.parseDouble( penalty ) + sumTotals );
        strHtml += "<tr><td colspan='3'>&nbsp;</td><td colspan ='2' align='right'>Zwischensumme:&nbsp</td><td align='right'>" + SharedUtils.formatFloat( "" + sumTotals, '.' ) + " EUR</td></tr>";
        if( Double.parseDouble( penalty ) > 0 )
            strHtml += "<tr><td colspan='3'>&nbsp;</td><td colspan ='2' align='right'>Mahneb&#252;hr:&nbsp</td><td align='right'>" + SharedUtils.formatFloat( penalty, '.' ) + " EUR</td></tr>";
        strHtml += "<tr><td colspan='3'>&nbsp;</td><td colspan ='2' align='right'>Gesamtsumme:&nbsp</td><td align='right'>" + SharedUtils.formatFloat( totalPenalty, '.' ) + " EUR</td></tr>";
        strHtml +="</table><br>";
     
        
        strHtml += "<table  width='100%'><tr><td>" + getAfterTableHTML( strDate ) + "</td></tr></table>";
        //fix
        strHtml += "<table  width='100%'><tr><td><br>" + getLastHTML() + "</td></tr></table>";
        strHtml += "</body></html>";        
        return strHtml.trim();
   }
   
   private String getPenalty()
   {
       if( letterMode == SendLetterDialog.LETTER1_MODE )
           return "0.00";
       if( letterMode == SendLetterDialog.LETTER2_MODE )
           return "5.00";
       if( letterMode == SendLetterDialog.LETTER3_MODE )
           return "10.00";
       throw new java.lang.AssertionError();       
   }
   
   private String getBeforTableHTML(String strAppeal,String strLastName)
   {
       if( letterMode == SendLetterDialog.LETTER1_MODE )
             return 
             "<table width='100%' border='0' cellpadding='-1' cellspacing='-1'>" +
             "<tr><td align='left'><font size='5'>Zahlungserinnerung<br></font></td></tr>" +
             "<tr><td align='left'>Sehr geehrte " + strAppeal + " " + strLastName + " ,</td></tr>" +
             "<tr><td align='left'>Sicherlich ist es Ihnen entgangen , die im folgenden aufgef&#252;hrten Rechnungen</td></tr>" +
             "<tr><td align='left'>zubegleichen:</td></tr>"+
             "</table>";
       if( letterMode == SendLetterDialog.LETTER2_MODE )
           return "<table width='100%' border='0' cellpadding='-1' cellspacing='-1' >" +
             "<tr><td align='left'><font size='5'>2.MAHNUNG<br></font></td></tr>" +
             "<tr><td align='left'>Sehr geehrter " + strAppeal + " "+ strLastName + ",</td></tr>" +
             "<tr><td align='left'>sicher haben Sie &#252;bersehen, dab die unten aufgef&#252;hrten Rechnungen</td></tr>" +
             "<tr><td align='left'>zur Zahlung f&#228;lling geworden sind.Wir bitten Sie deshalb um sofortige</td></tr>" +
             "<tr><td align='left'>&#252;berweisung des Gesamtbetrages auf unser Konto.</td></tr></table>";
       if( letterMode == SendLetterDialog.LETTER3_MODE )
           return "<table width='100%' border='0' cellpadding='-1' cellspacing='-1'>" +
             "<tr><td align='left'><font size='5'>3.MAHNUNG<br></font></td></tr>" +
             "<tr><td align='left'>Sehr geehrter " + strAppeal + " " +  strLastName+ ",</td></tr>" +
             "<tr><td align='left'>nachdem unsere 1. und 2. Mahnung ohne Erfolg blieb, setzen wir Ihnen nun eine letzte</td></tr>" +
             "<tr><td align='left'>Zahlungsfrist.</td></tr>" +
             "<tr><td align='left'>Sollte der von Ihnen geschuldete Betrag nicht bis zu dem, der Zahlungsaufstellung,</td></tr>" +
             "<tr><td align='left'>folgendem Datum auf unser Konto eingegangen sein, so warden wir   ein Inkassoinstitut</td></tr>" +
             "<tr><td align='left'>damit beauftragen, unsere Forderungen von Ihnen einzuziehen.</td></tr>" +
             "<tr><td align='left'>Die damit verbundenen Kosten gehen zu Ihren Lasten.</td></tr></table>";
       throw new java.lang.AssertionError();       
   }
   
   private String getAfterTableHTML(String date)
   {
       if( letterMode == SendLetterDialog.LETTER1_MODE )
           return "<table width='100%' border='0' cellpadding='-1' cellspacing='-1'>" +
            "<tr><td align='left'>Wir bitten Sie h&#246;flichst den o.g. Betrag innerhalb der n&#228;chsten 7 Tage</td></tr>" +
            "<tr><td align='left'>auf unser Konto zu &#252;berweisen.</td></tr>" +
            "<tr><td align='left'>Sollten Sie inzwischen den Betrag an uns &#252;berwiesen haben, so sehen Sie</td></tr>" +
            "<tr><td align='left'>dieses Schreiben als gegenstandslos an.</td></tr>" +
            "<tr><td align='left'>Mit freundlichen Gr&#252;ben</td></tr>" +
            "<tr><td align='left'>(Diese Mahnung ist nicht unterschrieben, da maschinell erstellt.)</td></tr></table>";
       if( letterMode == SendLetterDialog.LETTER2_MODE )
           return "<table width='100%' border='0' cellpadding='-1' cellspacing='-1'>" +
             "<tr><td align='left'>Wir erwarten Ihre Zahlung bis zum " + SharedUtils.incDate(date, 10) + "</td></tr>" +
             "<tr><td align='left'>Sollten Sie inzwischen den Betrag an uns &#252;berwiesen haben , so sehen Sie</td></tr>" +
             "<tr><td align='left'>dieses Schreiben als gegenstandslos an.</td></tr>" +
             "<tr><td align='left'>Mit freundlichen Gr&#252;ben</td></tr>" +
             "<tr><td align='left'>(Diese Mahnung ist nicht unterschrieben, da maschinell erstellt.)</td></tr></table>";

       if( letterMode == SendLetterDialog.LETTER3_MODE )
           return "<table width='100%' border='0' cellpadding='-1' cellspacing='-1'>" +
             "<tr><td align='left'><b>Wir  gew&#228;hren Ihnen eine letzte Zahlungsfrist bis zum " + SharedUtils.incDate(date, 10)+ "</b></td></tr>" + 
	     "<tr><td align='left'>Sollte der Betrag bis zu diesem Datum nicht auf unser auf unser Konto eingegangen sein,</td></tr>" + 
	     "<tr><td align='left'>werden wir rechtliche Schritte gegen Sie einleiten,die mit weiteren Kosten f&#252;r Sie verbunden</td></tr>" + 
	     "<tr><td align='left'>sind.</td></tr>" + 
	     "<tr><td align='left'>Mit freundlichen Gr&#252;ben</td></tr>" + 
	     "<tr><td align='left'>(Diese Mahnung ist nicht unterschrieben, da maschinell erstellt.)</td></tr></table>";
       throw new java.lang.AssertionError();       
   }
     
   private String getLastHTML()
   {
        return "<table width='100%' border='0' cellpadding='-1' cellspacing='-1' style=\"FONT-FAMILY: 'Times New Roman'\">" +
            "<tr><td align='left'><font size='3'><b>ABN/AMRO Frankfurt</b></font></td><td align='left'><font size='3'><b>&nbsp;&nbsp;&nbsp;Vita Natura BV  </b></font></td><td align='left'><font size='3'><b>&nbsp;&nbsp;&nbsp;Kontaktb&#252;ro Deutschlland</b></font></td></tr>" +
            "<tr><td align='left'><font size='3'><b>KONTO NR.: 1659804019</b></font></td><td align='left'><font size='3'><b>&nbsp;&nbsp;&nbsp;Heerenweg 251  </b></font></td>   <td align='left'><font size='3'><b>&nbsp;&nbsp;&nbsp;Telefon (ISDN) (0180) 0180 - 523 6312</b></font></td></tr>" +
            "<tr><td align='left'><font size='3'><b>BANKLEITZAHL: 50230400</b></font></td><td align='left'><font size='3'><b>&nbsp;&nbsp;&nbsp;6414 AJ Heerlen NL  </b></font></td>   <td align='left'><font size='3'><b>&nbsp;&nbsp;&nbsp;FAX (ISDN) (0180) 0180 - 523 6312</b></font></td></tr>" +
            "<tr><td align='left'><font size='3'><b>Ust-IdNr. NL-814305398</b></font></td><td align='left'><font size='3'><b>&nbsp;&nbsp;&nbsp;https://vip.isvita.com  </b></font></td>   <td align='left'><font size='3'><b>&nbsp;&nbsp;&nbsp;E-Mail : order@isvita.com </b></font></td></tr></table>";
   }
         
   private void addRow( StringBuffer content, String row, String padding )
    {
        content.append( row );
        m_currentRow++;
        if( m_currentRow > SharedUtils.rowsPerPage )
        {
            if( padding != null )
                content.append( padding );
            m_currentRow = 1;
        }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnPrint;
    private javax.swing.JEditorPane edpInvoice;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane4;
    // End of variables declaration//GEN-END:variables

}
