/*
 * Main.java
 *
 * Created on , 2005,  26, 17:14
 */

package medstore;

import java.awt.Frame;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import medstore.auftrag.AuftragFile;
import medstore.init_config.DailyLoader;
import medstore.init_config.print.Printer;
import medstore.trans.MenuLoader;

/**
 *
 * @author Nencho Lupanov
 */
public class Main implements SharedConstants{
    
    private static JFrame frmLogin;
    private static LoginDialog dlgLogin;
    private static JFrame frmLimits;
    private static StockLimits dlgLimits;
    private static JFrame frmMainNavigator;
    private static MedStoreNavigatorDialog dlgMainNavigator;
    public static AuftragFile auftragFile;
    public static Printer printer;
    public static MenuLoader def_app_lang;
    
    public static void main(String[] args) {
        try {
            
            DailyLoader dailyLoader = new DailyLoader();
            auftragFile = dailyLoader.getAuftragFile();
            
        } catch(Exception e){
            JOptionPane.showMessageDialog(null,"Error: " + e.getMessage());
            e.printStackTrace();
            System.exit(0);
        } finally {
        }
        
        try {
            javax.swing.UIManager.setLookAndFeel("com.birosoft.liquid.LiquidLookAndFeel");
            Object o = Class.forName("com.birosoft.liquid.LiquidLookAndFeel");
            //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            //e.printStackTrace();
        }
        frmLogin = new JFrame();
        dlgLogin = new LoginDialog(frmLogin,true);
        dlgLogin.show();
        
        try{
            frmMainNavigator = new JFrame();
            
            dlgMainNavigator = new MedStoreNavigatorDialog(frmMainNavigator,false);
            dlgMainNavigator.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

            dlgMainNavigator.setName("main");
            dlgMainNavigator.show();
        } catch(Exception e){
            JOptionPane.showMessageDialog(null,e.getMessage());
            System.exit(0);
        } finally{
            
        }
        
        //
    }
    public static AuftragFile getAuftragFile() throws Exception{
        if(auftragFile!=null){
            return auftragFile;
        } else{
            throw new Exception("Unknown Auftrag file");
        }
    }
    public static void reload(){        
          Frame[] frame =  dlgMainNavigator.getFrames();
           for(int i=0; i<frame.length; i++){
               if(!frame[i].getName().equals("main"))
                   frame[i].dispose();
           }
          dlgMainNavigator.reload();
    }
    public static int openFramesCount(){
        int count = 0;
        Frame[] frame =  dlgMainNavigator.getFrames();
        for(int i=0; i<frame.length; i++){
               if(frame[i].isVisible())
                  count++; 
           }
        return count;
    }
}
