/*
 * MedStoreNavigatorDialog.java
 *
 * Created on , 2005,  26, 17:39
 */

package medstore;

import java.awt.Component;
import java.awt.Cursor;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Hashtable;
import java.util.HashSet;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import java.awt.Frame;
import java.sql.CallableStatement;
import medstore.export.ActiveUsersForm;
import medstore.init_config.print.SetPrintForm;
import medstore.init_config.translate.SetLangForm;
import medstore.print.gui.PrintPreview;
import medstore.print.letters.GenerateLetter;
import medstore.print.reports.customersdaily.CADayReport;
import medstore.print.reports.customersmonthly.CAMonthReport;
import medstore.print.reports.daily.ODayReport;
import medstore.print.reports.inventory.checkout.COutReport;
import medstore.print.reports.inventory.checkoutdiff.COutDiffReport;
import medstore.print.reports.inventory.movmentrevision.MRevReport;
import medstore.print.reports.inventory.stockonhand.SOHReport;
import medstore.print.reports.inventory.stockonhandtotal.SOHTReport;
import medstore.print.reports.inventory.timetopurchase.TTPReport;
import medstore.print.reports.monthly.OMonthReport;
import medstore.print.reports.orderhistory.OHReport;
import medstore.print.reports.orderhistoryitems.OHIReport;
import medstore.print.reports.ordersamount.OAReport;
import medstore.print.reports.ordersdetails.ODReport;
import medstore.print.reports.orderspending.OPReport;
import medstore.print.reports.relations.SetPersons;
import medstore.print.reports.salesdaily.SADayReport;
import medstore.print.reports.salesmonthly.SAMonthReport;
import medstore.print.reports.unpaid.OUReport;
import medstore.print.reports.usage.USAGEReport;
import medstore.print.reports.usagemonthly.MUSAGEReport;
import org.jfree.report.Element;
import org.jfree.report.GroupHeader;
import org.jfree.report.JFreeReport;
import org.jfree.report.JFreeReportBoot;


/**
 *
 * @author  JohnyEdu
 */
public class MedStoreNavigatorDialog extends javax.swing.JFrame implements SharedConstants {
    
    /** Creates new form MedStoreNavigatorDialog */
    private OrderFullfilment dlgOrderFullfilment;
    private SetPrintForm setPrintForm;
    private SetLangForm setLangForm;
    private static SetPersons spersons;
    
    public MedStoreNavigatorDialog(java.awt.Frame parent, boolean modal) {
        beforeInitConponents();
        initComponents();
        disableMenus();
        afterInitComponents();
        JFreeReportBoot jf = JFreeReportBoot.getInstance();
        if(!jf.isBootDone() || !jf.isBootInProgress()){
            jf.start();
        }
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        labelWellcome = new javax.swing.JLabel();
        menubMainMenu = new javax.swing.JMenuBar();
        menuFile = new javax.swing.JMenu();
        mitemFileExit = new javax.swing.JMenuItem();
        menuMovement = new javax.swing.JMenu();
        mitemMoveInOut = new javax.swing.JMenuItem();
        mitemMoveFromTo = new javax.swing.JMenuItem();
        mitemMovementRevision = new javax.swing.JMenuItem();
        menuNomenclature = new javax.swing.JMenu();
        mitemNomenclatureStocks = new javax.swing.JMenuItem();
        mitemStocksOperator = new javax.swing.JMenuItem();
        mitemNomenclatureStore = new javax.swing.JMenuItem();
        mitemNomenclatureAccount = new javax.swing.JMenuItem();
        mitemNomenclatureSetPrinter = new javax.swing.JMenuItem();
        menuItemNomLang = new javax.swing.JMenuItem();
        menuInventory = new javax.swing.JMenu();
        mitemStartInventory = new javax.swing.JMenuItem();
        mitemEditInventory = new javax.swing.JMenuItem();
        mitemLimits = new javax.swing.JMenuItem();
        menuInventoryReports = new javax.swing.JMenu();
        mitemMovRevision = new javax.swing.JMenuItem();
        mitemOnHand = new javax.swing.JMenuItem();
        mitemOnHandTotals = new javax.swing.JMenuItem();
        mitemInventoryCheckOut = new javax.swing.JMenuItem();
        mitemInvChkDiff = new javax.swing.JMenuItem();
        mitemTimeToPurchase = new javax.swing.JMenuItem();
        mitemSalesMov = new javax.swing.JMenuItem();
        menuOrders = new javax.swing.JMenu();
        mitemOrderFullfilment = new javax.swing.JMenuItem();
        mitemPlaceOrders = new javax.swing.JMenuItem();
        menuOrderReports = new javax.swing.JMenu();
        mItemOrdersHistory = new javax.swing.JMenuItem();
        mitemOrdersQuery = new javax.swing.JMenuItem();
        mitemOrdersDetails = new javax.swing.JMenuItem();
        mitemOrdersAmmount = new javax.swing.JMenuItem();
        mitemPendingOrders = new javax.swing.JMenuItem();
        mitemUnpaidOrders = new javax.swing.JMenuItem();
        mitemNumOrdersDaily = new javax.swing.JMenuItem();
        mitemNumOrdersMonthly = new javax.swing.JMenuItem();
        mitemUssage = new javax.swing.JMenuItem();
        mitemUsageMonths = new javax.swing.JMenuItem();
        mitemActiveSalesPD = new javax.swing.JMenuItem();
        mitemActiveSalesPM = new javax.swing.JMenuItem();
        mitemActiveCutomersD = new javax.swing.JMenuItem();
        mitemActiveCutomersM = new javax.swing.JMenuItem();
        mitemOrdersComm = new javax.swing.JMenuItem();
        mitemCommAmmount = new javax.swing.JMenuItem();
        mitemCommPersonAmmount = new javax.swing.JMenuItem();
        mitemCommPersonAmmountMA = new javax.swing.JMenuItem();
        mitemAnalysisMaDr = new javax.swing.JMenuItem();
        mitemRelations = new javax.swing.JMenuItem();
        mitemActivePersons = new javax.swing.JMenuItem();
        menuGenerate = new javax.swing.JMenu();
        mitemGenLetter1 = new javax.swing.JMenuItem();
        mitemGenLetter2 = new javax.swing.JMenuItem();
        mitemGenLetter3 = new javax.swing.JMenuItem();
        menuQuery = new javax.swing.JMenu();
        mitemLetter1 = new javax.swing.JMenuItem();
        mitemLetter2 = new javax.swing.JMenuItem();
        mitemLetter3 = new javax.swing.JMenuItem();

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Isvita - Inventory");
        setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        setFont(new java.awt.Font("Arial", 0, 10));
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                MedStoreNavigatorDialog.this.windowClosed(evt);
            }
        });

        labelWellcome.setFont(new java.awt.Font("Palatino Linotype", 1, 14));
        labelWellcome.setForeground(javax.swing.UIManager.getDefaults().getColor("Button.disabledForeground"));
        labelWellcome.setText("Inventory Control System ver. 1.4.");
        getContentPane().add(labelWellcome);
        labelWellcome.setBounds(300, 10, 270, 20);

        menubMainMenu.setBackground(new java.awt.Color(204, 204, 255));
        menubMainMenu.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        menuFile.setText("File  ");
        menuFile.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuFile.setName("fil");
        mitemFileExit.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemFileExit.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemFileExit.setText("Exit");
        mitemFileExit.setName("fil_ext");
        mitemFileExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemFileExitActionPerformed(evt);
            }
        });

        menuFile.add(mitemFileExit);

        menubMainMenu.add(menuFile);

        menuMovement.setText("Movement  ");
        menuMovement.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuMovement.setName("mov");
        mitemMoveInOut.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemMoveInOut.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemMoveInOut.setText("Move In/Out...");
        mitemMoveInOut.setName("mov_io");
        mitemMoveInOut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuMovement.add(mitemMoveInOut);

        mitemMoveFromTo.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemMoveFromTo.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemMoveFromTo.setText("Move From-To...");
        mitemMoveFromTo.setName("mov_ft");
        mitemMoveFromTo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuMovement.add(mitemMoveFromTo);

        mitemMovementRevision.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemMovementRevision.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemMovementRevision.setText("Movement(Revision)...");
        mitemMovementRevision.setName("mov_rev");
        mitemMovementRevision.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuMovement.add(mitemMovementRevision);

        menubMainMenu.add(menuMovement);

        menuNomenclature.setText("Nomenclature  ");
        menuNomenclature.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuNomenclature.setName("menu_nomenclature");
        mitemNomenclatureStocks.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemNomenclatureStocks.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemNomenclatureStocks.setText("Stocks, Admin ...");
        mitemNomenclatureStocks.setName("nom_stc_adm");
        mitemNomenclatureStocks.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuNomenclature.add(mitemNomenclatureStocks);

        mitemStocksOperator.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemStocksOperator.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemStocksOperator.setText("Stocks, operator...");
        mitemStocksOperator.setName("nom_stc_opr");
        mitemStocksOperator.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuNomenclature.add(mitemStocksOperator);

        mitemNomenclatureStore.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemNomenclatureStore.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemNomenclatureStore.setText("Stores...");
        mitemNomenclatureStore.setName("nom_str");
        mitemNomenclatureStore.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuNomenclature.add(mitemNomenclatureStore);

        mitemNomenclatureAccount.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemNomenclatureAccount.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemNomenclatureAccount.setText("Change Password");
        mitemNomenclatureAccount.setName("nom_str_acc");
        mitemNomenclatureAccount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemNomenclatureAccountActionPerformed(evt);
            }
        });

        menuNomenclature.add(mitemNomenclatureAccount);

        mitemNomenclatureSetPrinter.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemNomenclatureSetPrinter.setText("Default Printer");
        mitemNomenclatureSetPrinter.setName("nom_set_printer");
        mitemNomenclatureSetPrinter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemNomenclatureSetPrinterActionPerformed(evt);
            }
        });

        menuNomenclature.add(mitemNomenclatureSetPrinter);

        menuItemNomLang.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuItemNomLang.setText("Default Language");
        menuItemNomLang.setName("nom_set_lang");
        menuItemNomLang.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuItemNomLangActionPerformed(evt);
            }
        });

        menuNomenclature.add(menuItemNomLang);

        menubMainMenu.add(menuNomenclature);

        menuInventory.setText("Inventory  ");
        menuInventory.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuInventory.setName("inv");
        mitemStartInventory.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemStartInventory.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemStartInventory.setText("Start stock counting");
        mitemStartInventory.setName("inv_str");
        mitemStartInventory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventory.add(mitemStartInventory);

        mitemEditInventory.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemEditInventory.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemEditInventory.setText("Inventory Check Out...");
        mitemEditInventory.setName("inv_edt");
        mitemEditInventory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventory.add(mitemEditInventory);

        mitemLimits.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemLimits.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemLimits.setText("Inventory Limits");
        mitemLimits.setName("inv_chk_out");
        mitemLimits.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventory.add(mitemLimits);

        menubMainMenu.add(menuInventory);

        menuInventoryReports.setText("Inventory Reports  ");
        menuInventoryReports.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuInventoryReports.setName("inv_rep");
        menuInventoryReports.setOpaque(false);
        mitemMovRevision.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemMovRevision.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemMovRevision.setText("Movement Revision");
        mitemMovRevision.setName("qur_mov_rev");
        mitemMovRevision.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventoryReports.add(mitemMovRevision);

        mitemOnHand.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemOnHand.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemOnHand.setText("Stock On Hand");
        mitemOnHand.setName("qur_on_hand");
        mitemOnHand.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventoryReports.add(mitemOnHand);

        mitemOnHandTotals.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemOnHandTotals.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemOnHandTotals.setText("On Hand Totals");
        mitemOnHandTotals.setName("qur_hnd_tot");
        mitemOnHandTotals.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventoryReports.add(mitemOnHandTotals);

        mitemInventoryCheckOut.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemInventoryCheckOut.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemInventoryCheckOut.setText("Inventory Check Out");
        mitemInventoryCheckOut.setName("qur_inv_cot");
        mitemInventoryCheckOut.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventoryReports.add(mitemInventoryCheckOut);

        mitemInvChkDiff.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemInvChkDiff.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemInvChkDiff.setText("Inventory Check Out Differencies");
        mitemInvChkDiff.setName("qur_chk_dff");
        mitemInvChkDiff.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventoryReports.add(mitemInvChkDiff);

        mitemTimeToPurchase.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemTimeToPurchase.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemTimeToPurchase.setText("Time to Purchase");
        mitemTimeToPurchase.setName("qur_tim_pch");
        mitemTimeToPurchase.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventoryReports.add(mitemTimeToPurchase);

        mitemSalesMov.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemSalesMov.setText("Sales Movement");
        mitemSalesMov.setName("sales_mov");
        mitemSalesMov.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuInventoryReports.add(mitemSalesMov);

        menubMainMenu.add(menuInventoryReports);

        menuOrders.setText("Orders  ");
        menuOrders.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuOrders.setName("ord");
        mitemOrderFullfilment.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemOrderFullfilment.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemOrderFullfilment.setText("Order Fullfilment...");
        mitemOrderFullfilment.setName("ord_flf");
        mitemOrderFullfilment.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrders.add(mitemOrderFullfilment);

        mitemPlaceOrders.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemPlaceOrders.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemPlaceOrders.setText("Place Orders");
        mitemPlaceOrders.setName("ord_plc");
        mitemPlaceOrders.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrders.add(mitemPlaceOrders);

        menubMainMenu.add(menuOrders);

        menuOrderReports.setText("Order Reports  ");
        menuOrderReports.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuOrderReports.setName("qur");
        mItemOrdersHistory.setFont(new java.awt.Font("Tahoma", 1, 13));
        mItemOrdersHistory.setText("Orders History");
        mItemOrdersHistory.setName("qur_ord_history");
        mItemOrdersHistory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mItemOrdersHistory);

        mitemOrdersQuery.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemOrdersQuery.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemOrdersQuery.setText("Orders History Items");
        mitemOrdersQuery.setName("ord_hist_item");
        mitemOrdersQuery.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemOrdersQuery);

        mitemOrdersDetails.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        mitemOrdersDetails.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemOrdersDetails.setText("Orders Details");
        mitemOrdersDetails.setName("qur_ord_dtl");
        mitemOrdersDetails.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemOrdersDetails);

        mitemOrdersAmmount.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemOrdersAmmount.setText("Orders Amount");
        mitemOrdersAmmount.setName("ord_am");
        mitemOrdersAmmount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemOrdersAmmount);

        mitemPendingOrders.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemPendingOrders.setText("Pending Orders");
        mitemPendingOrders.setName("ord_pend");
        mitemPendingOrders.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemPendingOrders);

        mitemUnpaidOrders.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemUnpaidOrders.setText("Unpaid Orders");
        mitemUnpaidOrders.setName("ord_unp");
        mitemUnpaidOrders.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemUnpaidOrders);

        mitemNumOrdersDaily.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemNumOrdersDaily.setText("Number of Orders (Daily)");
        mitemNumOrdersDaily.setName("num_ord_daily");
        mitemNumOrdersDaily.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemNumOrdersDaily);

        mitemNumOrdersMonthly.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemNumOrdersMonthly.setText("Number of Orders (Monthly)");
        mitemNumOrdersMonthly.setName("num_ord_monthly");
        mitemNumOrdersMonthly.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemNumOrdersMonthly);

        mitemUssage.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemUssage.setText("Usage");
        mitemUssage.setName("usage");
        mitemUssage.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemUssage);

        mitemUsageMonths.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemUsageMonths.setText("Usage by months ");
        mitemUsageMonths.setName("usage_months");
        mitemUsageMonths.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemUsageMonths);

        mitemActiveSalesPD.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemActiveSalesPD.setText("Active Sales People(Daily)");
        mitemActiveSalesPD.setName("act_sal_peo_d");
        mitemActiveSalesPD.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemActiveSalesPD);

        mitemActiveSalesPM.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemActiveSalesPM.setText("Active Sales People(Monthly)");
        mitemActiveSalesPM.setName("act_sal_peo_m");
        mitemActiveSalesPM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemActiveSalesPM);

        mitemActiveCutomersD.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemActiveCutomersD.setText("Active Customers(Daily)");
        mitemActiveCutomersD.setName("act_cust_d");
        mitemActiveCutomersD.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemActiveCutomersD);

        mitemActiveCutomersM.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemActiveCutomersM.setText("Active Customers(Monthly)");
        mitemActiveCutomersM.setName("act_cust_m");
        mitemActiveCutomersM.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemActiveCutomersM);

        mitemOrdersComm.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemOrdersComm.setText("Orders Commission");
        mitemOrdersComm.setName("report_orders_commission");
        mitemOrdersComm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemOrdersComm);

        mitemCommAmmount.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemCommAmmount.setText("Commissions by period");
        mitemCommAmmount.setName("repport_comm_by_per");
        mitemCommAmmount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemCommAmmount);

        mitemCommPersonAmmount.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemCommPersonAmmount.setLabel("Commissions by person");
        mitemCommPersonAmmount.setName("repport_comm_by_person");
        mitemCommPersonAmmount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemCommPersonAmmountActionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemCommPersonAmmount);

        mitemCommPersonAmmountMA.setFont(new java.awt.Font("Tahoma", 1, 12));
        mitemCommPersonAmmountMA.setText("Commision By Person (Ma)");
        mitemCommPersonAmmountMA.setName("mitemCommPersonAmmountMA");
        mitemCommPersonAmmountMA.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemCommPersonAmmountMAActionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemCommPersonAmmountMA);

        mitemAnalysisMaDr.setFont(new java.awt.Font("Tahoma", 1, 12));
        mitemAnalysisMaDr.setActionCommand("Analysis");
        mitemAnalysisMaDr.setLabel("Commission Analysis");
        mitemAnalysisMaDr.setName("AnalysisMaDr");
        mitemAnalysisMaDr.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemAnalysisMaDrActionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemAnalysisMaDr);

        mitemRelations.setFont(new java.awt.Font("Tahoma", 1, 12));
        mitemRelations.setText("Provision Relations");
        mitemRelations.setName("mitemRelations");
        mitemRelations.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemRelationsActionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemRelations);

        mitemActivePersons.setFont(new java.awt.Font("Tahoma", 1, 12));
        mitemActivePersons.setText("Active Persons");
        mitemActivePersons.setName("mitemActivePersons");
        mitemActivePersons.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mitemActivePersonsActionPerformed(evt);
            }
        });

        menuOrderReports.add(mitemActivePersons);

        menubMainMenu.add(menuOrderReports);

        menuGenerate.setText("Generate");
        menuGenerate.setActionCommand("Generate  ");
        menuGenerate.setAutoscrolls(true);
        menuGenerate.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuGenerate.setName("Generate   ");
        mitemGenLetter1.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemGenLetter1.setText("Generate Letters 1");
        mitemGenLetter1.setName("mitemGenLetter1");
        mitemGenLetter1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuGenerate.add(mitemGenLetter1);

        mitemGenLetter2.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemGenLetter2.setText("Generate Letters 2");
        mitemGenLetter2.setName("mitemGenLetter2");
        mitemGenLetter2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuGenerate.add(mitemGenLetter2);

        mitemGenLetter3.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemGenLetter3.setText("Generate Letters 3");
        mitemGenLetter3.setName("mitemGenLetter3");
        mitemGenLetter3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuGenerate.add(mitemGenLetter3);

        menubMainMenu.add(menuGenerate);

        menuQuery.setFont(new java.awt.Font("Tahoma", 1, 13));
        menuQuery.setLabel("Query");
        menuQuery.setName("Query");
        mitemLetter1.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemLetter1.setText("Letter 1");
        mitemLetter1.setName("mitemLetter1");
        mitemLetter1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuQuery.add(mitemLetter1);

        mitemLetter2.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemLetter2.setText("Letter 2");
        mitemLetter2.setName("mitemLetter2");
        mitemLetter2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuQuery.add(mitemLetter2);

        mitemLetter3.setFont(new java.awt.Font("Tahoma", 1, 13));
        mitemLetter3.setText("Letter 3");
        mitemLetter3.setName("mitemLetter3");
        mitemLetter3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MedStoreNavigatorDialog.this.actionPerformed(evt);
            }
        });

        menuQuery.add(mitemLetter3);

        menubMainMenu.add(menuQuery);

        setJMenuBar(menubMainMenu);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-907)/2, (screenSize.height-94)/2, 907, 94);
    }
    // </editor-fold>//GEN-END:initComponents

    private void mitemActivePersonsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemActivePersonsActionPerformed
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                try{
                    new ActiveUsersForm().setVisible(true);
                }
                catch(Exception e){
                    JOptionPane.showMessageDialog(null,"Error Message: "+e.getMessage());
                    return;
                }
            }
        });
    }//GEN-LAST:event_mitemActivePersonsActionPerformed

    private void mitemCommPersonAmmountMAActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemCommPersonAmmountMAActionPerformed
        new medstore.print.reports.commissions.CommissionQueryFilter(new javax.swing.JFrame(), true,RDERS_ORDERS_COMMISIONS_BY_PERSON_MA).setVisible(true);        
    }//GEN-LAST:event_mitemCommPersonAmmountMAActionPerformed

    private void mitemAnalysisMaDrActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemAnalysisMaDrActionPerformed
        new medstore.print.reports.commissions.CommissionQueryFilter(new javax.swing.JFrame(), true,ORDERS_ANALYSIS_MA_DR).setVisible(true);        
    }//GEN-LAST:event_mitemAnalysisMaDrActionPerformed

    private void mitemRelationsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemRelationsActionPerformed
         if(spersons!=null && spersons.isShowing()) {
        } else{           
         spersons = new SetPersons(this);
        }
        spersons.setVisible(true);
    }//GEN-LAST:event_mitemRelationsActionPerformed
        
    private void mitemCommPersonAmmountActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemCommPersonAmmountActionPerformed
        new medstore.print.reports.commissions.CommissionQueryFilter(new javax.swing.JFrame(), true,ORDERS_ORDERS_COMMISIONS_BY_PERSON).setVisible(true);
    }//GEN-LAST:event_mitemCommPersonAmmountActionPerformed
    
    private void menuItemNomLangActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_menuItemNomLangActionPerformed
        if(setLangForm!=null && setLangForm.isShowing()) {
        } else
            setLangForm = new SetLangForm(this);
        setLangForm.setVisible(true);
    }//GEN-LAST:event_menuItemNomLangActionPerformed
    
    private void mitemNomenclatureSetPrinterActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemNomenclatureSetPrinterActionPerformed
        if(setPrintForm!=null && setPrintForm.isShowing()) {
        } else
            setPrintForm = new SetPrintForm(this);
        setPrintForm.setVisible(true);
        
    }//GEN-LAST:event_mitemNomenclatureSetPrinterActionPerformed
    
    private void mitemNomenclatureAccountActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemNomenclatureAccountActionPerformed
        adminmodul.accesscontrol.FormPassChange frmPassCh = new adminmodul.accesscontrol.FormPassChange();
        frmPassCh.setVisible(true);
    }//GEN-LAST:event_mitemNomenclatureAccountActionPerformed
    
    private void mitemFileExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_mitemFileExitActionPerformed
        dispose();
    }//GEN-LAST:event_mitemFileExitActionPerformed
    
    private void windowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowClosed
        System.exit(0);
    }//GEN-LAST:event_windowClosed
    
    private void beforeInitConponents() {
       /*
        try {
              UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        */
    }
    private void afterInitComponents() {
        //setDefaultLookAndFeelDecorated(false);
        saveNewMenus();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-907)/2, (screenSize.height-477)/4, 907, 100);
        //setControlsBackGround();
        this.getRootPane().setOpaque(true);
        menubMainMenu.setBackground(javax.swing.UIManager.getDefaults().getColor("Button.background"));
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        String strSQL = "SELECT MENU_CODE,USER_PERM FROM VIEW_USER_MENU WHERE USER_IDNT =" + SharedUtils.nUserID;
        try{
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            boolean bMore = rsDBData.next();
            while( bMore ){
                String strMenuName = rsDBData.getString(1);
                int nUserPerm = rsDBData.getInt(2);
                boolean bPerm;
                if(nUserPerm==MENU_ALLOWED)
                    bPerm = true;
                else
                    bPerm = false;
                setMenuPerms(strMenuName,bPerm);
                
                bMore = rsDBData.next();
            }
            
            cleanMenus();
            rsDBData.close();
            stm.close();
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        } catch(Exception e){
            e.printStackTrace();
        }
    }
    public void setMenuPerms(String strMenuName,boolean bVisible){
        int nMenuCount = menubMainMenu.getMenuCount();
        for(int i = 0; i< nMenuCount; i++){
            JMenu menu = menubMainMenu.getMenu(i);
            if(menu==null)
                continue;
            
            
            if(menu.getName().trim().equals(strMenuName.trim())){
                try{
                    Main.def_app_lang.loadMenuLabel(menu);
                } catch(Exception e){
                    
                }
                menu.setVisible(true);
                return;
            }
            
            int nMenuItemCount = menu.getItemCount();
            
            for(int j = 0; j< nMenuItemCount; j++){
                JMenuItem mitem = menu.getItem(j);
                if(mitem==null)
                    continue;
                String[] arr = strMenuName.split(":");
                
                if(mitem.getName().trim().equals(arr[0].trim())){
                    mitem.setVisible(true);
                    try{
                        Main.def_app_lang.loadMenuLabel(mitem);
                    } catch(Exception e){
                        
                    }
                    return;
                }
            }
        }
    }
    public void cleanMenus(){
        int nMenuCount = menubMainMenu.getMenuCount();
        for(int i = 0; i< nMenuCount; i++){
            boolean bVisibleFound = false;
            JMenu menu = menubMainMenu.getMenu(i);
            int nMenuItemCount = menu.getItemCount();
            for(int j = 0; j< nMenuItemCount; j++){
                JMenuItem mitem = menu.getItem(j);
                if(mitem.isVisible()){
                    bVisibleFound=true;
                    break;
                }
            }
            if(!bVisibleFound)
                menu.setVisible(false);
        }
        
    }
    public void disableMenus(){
        int nMenuCount = menubMainMenu.getMenuCount();
        for(int i = 0; i< nMenuCount; i++){
            
            JMenu menu = menubMainMenu.getMenu(i);
            menu.setVisible(false);
            
            int nMenuItemCount = menu.getItemCount();
            for(int j = 0; j< nMenuItemCount; j++){
                JMenuItem mitem = menu.getItem(j);
                mitem.setVisible(false);
            }
            
        }
    }
    public void saveNewMenus() {
        Connection conn = null;
        JMenuItem mitem1 = null;
        try {
            HashSet menuCodes = new HashSet();
            conn = SharedUtils.getConnection();
            
            Statement stm = conn.createStatement();
            String sql = "select menu_code from base_menu";
            ResultSet rs = stm.executeQuery(sql);
            
            while( rs.next() ) {
                
                menuCodes.add( rs.getString(1).trim() );
            }
            rs.close();
            stm.close();
            
            //search
            int nMenuCount = menubMainMenu.getMenuCount();
            
            for(int i = 0; i< nMenuCount; i++) {
                JMenu menu = menubMainMenu.getMenu(i);
                String name = menu.getName().trim();
                
                String id = "0";
                if( !menuCodes.contains( name ) ) {
                    sql = "insert into base_menu (menu_code,menu_desc) values('" + name + "','" + menu.getText() + "');";
                    
                    
                    CallableStatement cstm = null;
                    cstm = conn.prepareCall(sql);
                    cstm.execute();
                    
                }
                int nMenuItemCount = menu.getItemCount();
                for(int j = 0; j< nMenuItemCount; j++) {
                    JMenuItem mitem = mitem1 = menu.getItem(j);
                    String c_name = mitem.getName().trim();
                    
                    if( !menuCodes.contains( c_name +":" + name ) ) {
                        sql = "insert into base_menu (menu_code,menu_desc) values('" +
                                c_name +":" + menu.getName().trim() + "','" + mitem.getText().trim() + "')";
                        stm = conn.createStatement();
                        stm.executeUpdate(sql);
                        stm.close();
                        
                    }
                }
            }
        } catch(SQLException e) {
            System.out.println(e.getMessage());
            SharedUtils.handleError(GENERAL_DB_ERROR);
        } finally {
            SharedUtils.closeConnection(conn);
        }
    }
    public void reload(){
        initComponents();
        disableMenus();
        afterInitComponents();
    }
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource() == mitemNomenclatureStocks) {
            StockManagerAdmin dlgStockManager = new StockManagerAdmin(new JFrame(),false);
            dlgStockManager.show();
        } else if(evt.getSource() == mitemStocksOperator) {
            StockManager dlgStockOperator = new StockManager(new JFrame(),false);
            dlgStockOperator.show();
        } else if(evt.getSource() == mitemNomenclatureStore) {
            StoreManager dlgStoreManager = new StoreManager(new JFrame(),false);
            dlgStoreManager.show();
        } else if(evt.getSource() == mitemMoveInOut) {
            
            MovementInOut dlgMovementInOut = new MovementInOut(new JFrame(),false);
            dlgMovementInOut.show();
        } else if(evt.getSource() == mitemMoveFromTo) {
            //StockOnHand dlgStockOnHand = new StockOnHand(new JFrame(),false);
            //dlgStockOnHand.show();
            MovementFromTo dlgMovementFromTo = new MovementFromTo(new JFrame(),false);
            dlgMovementFromTo.show();
        } else if(evt.getSource() == mitemMovementRevision) {
            //StockOnHand dlgStockOnHand = new StockOnHand(new JFrame(),false);
            //dlgStockOnHand.show();
            MovementRevision dlgMovementRevision = new MovementRevision(/*new JFrame(),false*/);
            dlgMovementRevision.show();
        } else if(evt.getSource() == mitemStartInventory) {
            int result = JOptionPane.showConfirmDialog((Component)this,"With this operation you will put all counted values to zero!Do you want to continue?","Confirm Inventory",JOptionPane.YES_NO_OPTION);
            
            if( result == JOptionPane.YES_OPTION){
                Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
                String strSQL = "UPDATE CONN_STCK_IN_STOR SET STCK_IVTR = 0";
                try{
                    Statement stm = connDB.createStatement();
                    int nRowsModified = stm.executeUpdate(strSQL);
                }catch(Exception e){
                    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please restart!");
                    return;
                }
            }
            
        } else if(evt.getSource() == mitemEditInventory) {
            
            EditInventory frmEditInventory = new EditInventory();
            frmEditInventory.show();
        } else if(evt.getSource() == mitemOrderFullfilment) {
            if(dlgOrderFullfilment!=null && dlgOrderFullfilment.isShowing()) {
            } else{
                dlgOrderFullfilment= new OrderFullfilment(new JFrame(),false);
                dlgOrderFullfilment.start();
            }
            dlgOrderFullfilment.setVisible(true);
            
        } else if( evt.getSource() == mitemSalesMov ) {
            SalesMovementDialog dlg = new SalesMovementDialog(new JFrame(),false);
            dlg.show();
        } else if(evt.getSource() == mitemMovRevision) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0)
                try{
                    final PrintPreview preview = new PrintPreview(new MRevReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            //new QueryTextResult(new javax.swing.JFrame(), true,htbFilterParams,MOVEMENT_REVISION_QUERY).setVisible(true);
        } else if(evt.getSource() == mitemOnHand) {
            try{
                final JFreeReport report = new SOHReport(null).getReport();
                GroupHeader el = report.getGroupByName("header").getHeader();
                Element filter = el.getElement("report.filter");
                filter.setVisible(false);
                final PrintPreview preview = new PrintPreview(report);
                preview.setSize(750, 750);
                preview.setVisible(true);
            } catch(Exception e){
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
            //new QueryTextResult(new javax.swing.JFrame(), true,null,STOCK_ON_HAND_QUERY).setVisible(true);
        } else if(evt.getSource() == mitemOnHandTotals) {
            try{
                final JFreeReport report = new SOHTReport(null).getReport();
                GroupHeader el = report.getGroupByName("header").getHeader();
                Element filter = el.getElement("report.filter");
                filter.setVisible(false);
                final PrintPreview preview = new PrintPreview(report);
                preview.setSize(750, 750);
                preview.setVisible(true);
            } catch(Exception e){
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
            //new QueryTextResult(new javax.swing.JFrame(), true,null,STOCK_ON_HAND_TOTALS_QUERY).setVisible(true);
        } else if(evt.getSource() == mitemInventoryCheckOut) {
            try{
                final JFreeReport report = new COutReport(null).getReport();
                GroupHeader el = report.getGroupByName("header").getHeader();
                Element filter = el.getElement("report.filter");
                filter.setVisible(false);
                final PrintPreview preview = new PrintPreview(report);
                preview.setSize(750, 750);
                preview.setVisible(true);
            } catch(Exception e){
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
            //new QueryTextResult(new javax.swing.JFrame(), true,null,INVENTORY_CHECKOUT_QUERY).setVisible(true);
        } else if(evt.getSource() == mitemInvChkDiff) {
            try{
                final JFreeReport report = new COutDiffReport(null).getReport();
                GroupHeader el = report.getGroupByName("header").getHeader();
                Element filter = el.getElement("report.filter");
                filter.setVisible(false);
                final PrintPreview preview = new PrintPreview(report);
                preview.setSize(750, 750);
                preview.setVisible(true);
            } catch(Exception e){
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
            // new QueryTextResult(new javax.swing.JFrame(), true,null,INVENTORY_CHECKOUT_DIFF_QUERY).setVisible(true);
        } else if(evt.getSource() == mitemTimeToPurchase) {
            int filters[] = {5};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0){
                
                try{
                    /**/
                    final PrintPreview preview = new PrintPreview(new TTPReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                    /**/
                    
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
                
            }
            // new QueryTextResult(new javax.swing.JFrame(), true,htbFilterParams,TIME_TO_PURCHASE_QUERY).setVisible(true);
        } else if(evt.getSource() == mitemLimits) {
            final int STOCK_NAME_INDEX=0;
            final int STOCK_BARCODE_INDEX=1;
            final int STOCK_CSUM_INDEX=2;
            final int STOCK_LIMIT_INDEX=3;
            final int STOCK_CNTN_BARCODE_INDEX=4;
            final int STOCK_KEY=5;
            JFrame frmLimits;
            StockLimits dlgLimits;
            String strTableSQL = "SELECT PCKG_NAME,PCKG_BRCD,(PCKG_ONHN*PCKG_PCNT) AS CSUM,PCKG_LIMT,CNTN_BRCD,PCKG_KEY FROM VIEW_STCK_CNT where composite = 1";
            String str_rgn_columns[] = {"Stock Name","Barcode","On Hand","Limit"};
            try{
                Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery(strTableSQL);
                UniversalTableModel tbmAllStocks = new UniversalTableModel(rsDBData,str_rgn_columns);
                tbmAllStocks.convertStringToInt(STOCK_CSUM_INDEX);
                int nRowCount = tbmAllStocks.getRowCount();
                for(int i=0; i < nRowCount; i++ ){
                    String strCntnBcode = (String)tbmAllStocks.getValueAt(i, STOCK_CNTN_BARCODE_INDEX);
                    String strOnHand = (String)tbmAllStocks.getValueAt(i, STOCK_CSUM_INDEX);
                    if(!strCntnBcode.equals("")){
                        int nContentIndex = tbmAllStocks.getContentIndex(STOCK_BARCODE_INDEX,strCntnBcode);
                        if(nContentIndex!= -1){
                            String strCntnOnHand = (String)tbmAllStocks.getValueAt(nContentIndex, STOCK_CSUM_INDEX);
                            int nNewValue = Integer.parseInt(strCntnOnHand) + Integer.parseInt(strOnHand);
                            tbmAllStocks.setValueAt(String.valueOf(nNewValue), nContentIndex, STOCK_CSUM_INDEX);
                        }
                        
                    }
                }
                
                for(int i=0; i < tbmAllStocks.getRowCount(); i++ ){
                    String strCntnBcode = (String)tbmAllStocks.getValueAt(i, STOCK_CNTN_BARCODE_INDEX);
                    String strOnHand = (String)tbmAllStocks.getValueAt(i, STOCK_CSUM_INDEX);
                    String strLimit = (String)tbmAllStocks.getValueAt(i, STOCK_LIMIT_INDEX);
                    
                    if(strCntnBcode.compareTo("")!=0){
                        tbmAllStocks.removeItemAt(i);
                        i--;
                        //continue;
                    }else if(Integer.parseInt(strOnHand) > Integer.parseInt(strLimit)){
                        tbmAllStocks.removeItemAt(i);
                        i--;
                        //continue;
                    }
                    
                }
                
                if(tbmAllStocks.getRowCount() > 0){
                    frmLimits = new JFrame();
                    dlgLimits = new StockLimits(frmLimits,true,tbmAllStocks);
                    dlgLimits.show();
                }else
                    JOptionPane.showMessageDialog(null,"All Stocks are in appropriate count limit!");
            }catch(SQLException sqle){
                SharedUtils.handleError(GENERAL_DB_ERROR);
            }
        }
        /*else if(evt.getSource() == mitemPersonSearch)
        {
            Vector vecResults = new Vector();
            new PersonSearch(new javax.swing.JFrame(), false, vecResults, PersonSearch.PATIENT_SEARCH ).setVisible(true);
        }
        else if(evt.getSource() == mitemAddPerson)
        {
            Vector vecResults = new Vector();
            new AddClient(new javax.swing.JFrame(),false,AddClient.ADD_MODE,vecResults).setVisible(true);
        }*/
        else if(evt.getSource() == mitemPlaceOrders) {
            new OrdersPlacement(new javax.swing.JFrame(), false, mitemPlaceOrders ).setVisible(true);
        }
        
        /*--------------REPORTS START--------------------*/
        else if(evt.getSource() == mItemOrdersHistory ) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0)
                try{
                    final PrintPreview preview = new PrintPreview(new OHReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            
            //new QueryTextResult( new javax.swing.JFrame(), true, htbFilterParams, ORDERS_HISTORY_QUERY ).setVisible(true);
        }///
        else if(evt.getSource() == mitemOrdersQuery) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0){
                try{
                    final PrintPreview preview = new PrintPreview(new OHIReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            //   new QueryTextResult(new javax.swing.JFrame(), true,htbFilterParams,ORDERS_HISTORY_ITEMS_QUERY).setVisible(true);
        } else if(evt.getSource() == mitemOrdersDetails) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0){
                try{
                    /**/
                    final PrintPreview preview = new PrintPreview(new ODReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                    /**/
                    //new QueryTextResult(new javax.swing.JFrame(), true,htbFilterParams,ORDERS_DETAILS_QUERY).setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
                
            }
            
        } else if( evt.getSource() == mitemOrdersAmmount ) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0){
                try{
                    /**/
                    final PrintPreview preview = new PrintPreview(new OAReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                    /**/
                    //new QueryTextResult( new javax.swing.JFrame(), true, htbFilterParams, ORDERS_AMMOUNT_QUERY ).setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            
        } else if( evt.getSource() == mitemPendingOrders ) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0){
                try{
                    final PrintPreview preview = new PrintPreview(new OPReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            //  new QueryTextResult( new javax.swing.JFrame(), true, htbFilterParams, ORDERS_PENDING_QUERY ).setVisible(true);
        } else if( evt.getSource() == mitemUnpaidOrders ) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0){
                try{
                    final PrintPreview preview = new PrintPreview(new OUReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            //new QueryTextResult( new javax.swing.JFrame(), true, htbFilterParams, ORDERS_UNPAID_QUERY ).setVisible(true);
        } else if(evt.getSource() == mitemNumOrdersDaily ) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0){
                try{
                    final PrintPreview preview = new PrintPreview(new ODayReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            // new QueryTextResult( new javax.swing.JFrame(), true, htbFilterParams, ORDERS_NUMORDERS_DAILY ).setVisible(true);
        } else if(evt.getSource() == mitemNumOrdersMonthly ) {
            int filters[] = {YEAR_FILTER};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0){
                try{
                    final PrintPreview preview = new PrintPreview(new OMonthReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            // new QueryTextResult(new javax.swing.JFrame(), true,htbFilterParams, ORDERS_NUMORDERS_MONTHLY ).setVisible(true);
        } else if(evt.getSource() == mitemUssage ) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0) {
                try{
                    final PrintPreview preview = new PrintPreview(new USAGEReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            // new QueryTextResult( new javax.swing.JFrame(), true, htbFilterParams, ORDERS_USAGE ).setVisible(true);
        } else if(evt.getSource() == mitemUsageMonths ) {
            
            try{
                JFreeReport report = new MUSAGEReport(null).getReport();
                GroupHeader el = report.getGroupByName("header").getHeader();
                Element filter = el.getElement("report.filter");
                filter.setVisible(false);
                
                
                final PrintPreview preview = new PrintPreview(report);
                preview.setSize(750, 750);
                preview.setVisible(true);
            } catch(Exception e){
                System.out.println(e.getMessage());
                e.printStackTrace();
            }
            
//new QueryTextResult(new javax.swing.JFrame(), true,null,ORDERS_USAGE_MONTHS).setVisible(true);
        } else if(evt.getSource() == mitemActiveSalesPD ) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0) {
                try{
                    final PrintPreview preview = new PrintPreview(new SADayReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            //new QueryTextResult( new javax.swing.JFrame(), true, htbFilterParams, ORDERS_ACTIVE_SALES_PEOPLE_DAILY ).setVisible(true);
        } else if(evt.getSource() == mitemActiveSalesPM ) {
            int filters[] = {YEAR_FILTER};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0) {
                try{
                    final PrintPreview preview = new PrintPreview(new SAMonthReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            //   new QueryTextResult(new javax.swing.JFrame(), true,htbFilterParams,ORDERS_ORDERS_ACTIVE_SALES_PEOPLE_MONTHLY ).setVisible(true);
        } else if(evt.getSource() == mitemActiveCutomersD ) {
            int filters[] = {1};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0) {
                try{
                    final PrintPreview preview = new PrintPreview(new CADayReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            //     new QueryTextResult( new javax.swing.JFrame(), true, htbFilterParams, ORDERS_ACTIVE_CUSTOMERS_DAILY ).setVisible(true);
        } else if(evt.getSource() == mitemActiveCutomersM ) {
            int filters[] = {YEAR_FILTER};
            Hashtable htbFilterParams = new Hashtable();
            new FilterQueryDialog(new javax.swing.JFrame(), true,filters,htbFilterParams).setVisible(true);
            if(htbFilterParams.size()>0) {
                try{
                    final PrintPreview preview = new PrintPreview(new CAMonthReport(htbFilterParams).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            //    new QueryTextResult(new javax.swing.JFrame(), true,htbFilterParams, ORDERS_ACTIVE_CUSTOMERS_MONTHLY ).setVisible(true);
        } else if(evt.getSource() == mitemOrdersComm) {
            new CommissionQueryFilter(new javax.swing.JFrame(), true,ORDERS_ORDERS_COMMISIONS).setVisible(true);
        } else if(evt.getSource() == mitemCommAmmount) {
            new medstore.print.reports.commissions.CommissionQueryFilter(new javax.swing.JFrame(), true,ORDERS_COMMISSION_AMMOUNT).setVisible(true);
        } else if( evt.getSource() == mitemGenLetter1 ) {
            GenerateLetter g = new GenerateLetter();
            try{
                setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));                
                g.showReport(1);
            }
            catch(Exception e){
                e.printStackTrace();
            }
            finally{
                setCursor(Cursor.getDefaultCursor());
                g = null;
            }
        } else if( evt.getSource() == mitemGenLetter2 ) {           
            GenerateLetter g = new GenerateLetter();
            try{
                 setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
                g.showReport(2);
            }
            catch(Exception e){
                JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
                e.printStackTrace();
            }
            finally{
                setCursor(Cursor.getDefaultCursor());
                g = null;
            }
        } else if( evt.getSource() == mitemGenLetter3 ) {           
            GenerateLetter g = new GenerateLetter();
            try{
                 setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));
                g.showReport(3);
            }
            catch(Exception e){
                JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
                e.printStackTrace();
            }
            finally{
                setCursor(Cursor.getDefaultCursor());
                g = null;
            }
        } else if( evt.getSource() == mitemLetter1 ) {
            new QueryTextResult(new javax.swing.JFrame(), true,null,ORDERS_LETTER1).setVisible(true);
        } else if( evt.getSource() == mitemLetter2 ) {
            new QueryTextResult(new javax.swing.JFrame(), true,null,ORDERS_LETTER2).setVisible(true);
        } else if( evt.getSource() == mitemLetter3 ) {
            new QueryTextResult(new javax.swing.JFrame(), true,null,ORDERS_LETTER3).setVisible(true);
        }
    }//GEN-LAST:event_actionPerformed
    
    /**
     * @param args the command line arguments
     */
    
    
    
    private void setControlsBackGround(){
        
        this.getContentPane().setBackground(SharedUtils.bgColor);
        //panelControl.setBackground(SharedUtils.bgColor);
        //jButton1.setBackground(SharedUtils.bgColor);
        //jButton2.setBackground(SharedUtils.bgColor);
        //jButton3.setBackground(SharedUtils.bgColor);
        //jButton4.setBackground(SharedUtils.bgColor);
        /*
        menuFile.setBackground(SharedUtils.bgColor);
        menuInventory.setBackground(SharedUtils.bgColor);
        menuMovement.setBackground(SharedUtils.bgColor);
        menuNomenclature.setBackground(SharedUtils.bgColor);
        menuOrders.setBackground(SharedUtils.bgColor);
        menubMainMenu.setBackground(SharedUtils.bgColor);
         */
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel labelWellcome;
    private javax.swing.JMenuItem mItemOrdersHistory;
    private javax.swing.JMenu menuFile;
    private javax.swing.JMenu menuGenerate;
    private javax.swing.JMenu menuInventory;
    private javax.swing.JMenu menuInventoryReports;
    private javax.swing.JMenuItem menuItemNomLang;
    private javax.swing.JMenu menuMovement;
    private javax.swing.JMenu menuNomenclature;
    private javax.swing.JMenu menuOrderReports;
    private javax.swing.JMenu menuOrders;
    private javax.swing.JMenu menuQuery;
    private javax.swing.JMenuBar menubMainMenu;
    private javax.swing.JMenuItem mitemActiveCutomersD;
    private javax.swing.JMenuItem mitemActiveCutomersM;
    private javax.swing.JMenuItem mitemActivePersons;
    private javax.swing.JMenuItem mitemActiveSalesPD;
    private javax.swing.JMenuItem mitemActiveSalesPM;
    private javax.swing.JMenuItem mitemAnalysisMaDr;
    private javax.swing.JMenuItem mitemCommAmmount;
    private javax.swing.JMenuItem mitemCommPersonAmmount;
    private javax.swing.JMenuItem mitemCommPersonAmmountMA;
    private javax.swing.JMenuItem mitemEditInventory;
    private javax.swing.JMenuItem mitemFileExit;
    private javax.swing.JMenuItem mitemGenLetter1;
    private javax.swing.JMenuItem mitemGenLetter2;
    private javax.swing.JMenuItem mitemGenLetter3;
    private javax.swing.JMenuItem mitemInvChkDiff;
    private javax.swing.JMenuItem mitemInventoryCheckOut;
    private javax.swing.JMenuItem mitemLetter1;
    private javax.swing.JMenuItem mitemLetter2;
    private javax.swing.JMenuItem mitemLetter3;
    private javax.swing.JMenuItem mitemLimits;
    private javax.swing.JMenuItem mitemMovRevision;
    private javax.swing.JMenuItem mitemMoveFromTo;
    private javax.swing.JMenuItem mitemMoveInOut;
    private javax.swing.JMenuItem mitemMovementRevision;
    private javax.swing.JMenuItem mitemNomenclatureAccount;
    private javax.swing.JMenuItem mitemNomenclatureSetPrinter;
    private javax.swing.JMenuItem mitemNomenclatureStocks;
    private javax.swing.JMenuItem mitemNomenclatureStore;
    private javax.swing.JMenuItem mitemNumOrdersDaily;
    private javax.swing.JMenuItem mitemNumOrdersMonthly;
    private javax.swing.JMenuItem mitemOnHand;
    private javax.swing.JMenuItem mitemOnHandTotals;
    private javax.swing.JMenuItem mitemOrderFullfilment;
    private javax.swing.JMenuItem mitemOrdersAmmount;
    private javax.swing.JMenuItem mitemOrdersComm;
    private javax.swing.JMenuItem mitemOrdersDetails;
    private javax.swing.JMenuItem mitemOrdersQuery;
    private javax.swing.JMenuItem mitemPendingOrders;
    private javax.swing.JMenuItem mitemPlaceOrders;
    private javax.swing.JMenuItem mitemRelations;
    private javax.swing.JMenuItem mitemSalesMov;
    private javax.swing.JMenuItem mitemStartInventory;
    private javax.swing.JMenuItem mitemStocksOperator;
    private javax.swing.JMenuItem mitemTimeToPurchase;
    private javax.swing.JMenuItem mitemUnpaidOrders;
    private javax.swing.JMenuItem mitemUsageMonths;
    private javax.swing.JMenuItem mitemUssage;
    // End of variables declaration//GEN-END:variables
    
}
