

package medstore;

import java.awt.event.InputEvent;
import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.sql.Types;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import medstore.procedures.*;
import medstore.products.composite.CompositeProduct;

public class MovementFromTo extends CommonDialog implements SharedConstants{    
    private String strOperationCode;
    private String strOperName;
    //private int nStoreId;
    private String strSQL;    
    private int nStockID,nErrorCode,nNewStockBalance,nTranID;
    private String strStockName;
    private String[] strrgnColumnNames = {"Source Store","Destination Store","Stock Name","Barcode","Quantity","Status"};
    private int[] nrgnWidths = {300,300,250,250,120,120};    
    private final int BARCODE_INDEX = 3;
    private final int COUNT_INDEX = 4; 
    private final int EVENTTEXT_INDEX = 5;    
    private final int STOCK_ID_INDEX = 6;
    private final int STORE_IDFROM_INDEX = 7;    
    private final int STORE_IDTO_INDEX = 8;
    private final int TRAN_ID_INDEX = 9;
        
    
    public MovementFromTo(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        nTranID = -1;        
        strStockName ="";
        nStockID = -1;
        nNewStockBalance = -1;
        nErrorCode = NO_ERROR;
        strOperationCode = OPCODE_MOVE;
        strSQL = "SELECT STCK_NAME,CONN_STCK_IN_STOR.STCK_CNT,CONN_STCK_IN_STOR.STCK_PCNT, STCK_KEY " +
                " FROM BASE_STCK INNER JOIN CONN_STCK_IN_STOR ON (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT)" +
                "WHERE STOR_IDNT = ";
        strOperName = "Move In";
        initComponents();
        afterInitComponents();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        btngOperations = new javax.swing.ButtonGroup();
        jpmUndo = new javax.swing.JPopupMenu();
        jmiUndo = new javax.swing.JMenuItem();
        scrAllStocks = new javax.swing.JScrollPane();
        tblActions = new javax.swing.JTable();
        lblStocks = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        comboStoreFrom = new javax.swing.JComboBox();
        jLabel4 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        comboStoreTo = new javax.swing.JComboBox();
        jPanel4 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        lblStockCount = new javax.swing.JLabel();
        editStockCount = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        editStockBarcode = new javax.swing.JTextField();
        buttonSubmit = new javax.swing.JButton();
        jPanel3 = new javax.swing.JPanel();
        buttonStockQuery = new javax.swing.JButton();

        jmiUndo.setText("Undo");
        jmiUndo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MovementFromTo.this.actionPerformed(evt);
            }
        });

        jpmUndo.add(jmiUndo);

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Movement From To");
        scrAllStocks.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED));
        scrAllStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        tblActions.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        tblActions.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblActions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });

        scrAllStocks.setViewportView(tblActions);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        getContentPane().add(scrAllStocks, gridBagConstraints);

        lblStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStocks.setText("Current operations");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 3, 0);
        getContentPane().add(lblStocks, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMinimumSize(new java.awt.Dimension(519, 69));
        jPanel1.setPreferredSize(new java.awt.Dimension(519, 69));
        jLabel2.setFont(new java.awt.Font("Tahoma", 1, 16));
        jLabel2.setForeground(new java.awt.Color(250, 0, 0));
        jLabel2.setText(" Move from:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 60;
        gridBagConstraints.ipady = -1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(18, 10, 0, 0);
        jPanel1.add(jLabel2, gridBagConstraints);

        comboStoreFrom.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboStoreFrom.setBorder(null);
        comboStoreFrom.setMaximumSize(new java.awt.Dimension(28, 22));
        comboStoreFrom.setMinimumSize(new java.awt.Dimension(28, 22));
        comboStoreFrom.setPreferredSize(new java.awt.Dimension(28, 22));
        comboStoreFrom.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                valueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        jPanel1.add(comboStoreFrom, gridBagConstraints);

        jLabel4.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medstore/pictures/8ar01a.gif")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.ipadx = 24;
        gridBagConstraints.ipady = 6;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(35, 4, 4, 0);
        jPanel1.add(jLabel4, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("Tahoma", 1, 16));
        jLabel3.setForeground(new java.awt.Color(250, 0, 0));
        jLabel3.setText(" To:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 120;
        gridBagConstraints.ipady = -1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(18, 6, 0, 0);
        jPanel1.add(jLabel3, gridBagConstraints);

        comboStoreTo.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboStoreTo.setBorder(null);
        comboStoreTo.setMaximumSize(new java.awt.Dimension(28, 22));
        comboStoreTo.setMinimumSize(new java.awt.Dimension(28, 22));
        comboStoreTo.setPreferredSize(new java.awt.Dimension(28, 22));
        comboStoreTo.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                valueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 6, 0, 0);
        jPanel1.add(comboStoreTo, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(jPanel4, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 10, 0);
        getContentPane().add(jPanel1, gridBagConstraints);

        jPanel2.setLayout(null);

        jPanel2.setMinimumSize(new java.awt.Dimension(519, 50));
        jPanel2.setPreferredSize(new java.awt.Dimension(519, 50));
        lblStockCount.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStockCount.setText("Count");
        jPanel2.add(lblStockCount);
        lblStockCount.setBounds(10, 0, 40, 15);

        editStockCount.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editStockCount.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        editStockCount.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                MovementFromTo.this.keyPressed(evt);
            }
        });

        jPanel2.add(editStockCount);
        editStockCount.setBounds(10, 20, 50, 20);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Barcode");
        jLabel1.setRequestFocusEnabled(false);
        jPanel2.add(jLabel1);
        jLabel1.setBounds(70, 0, 60, 15);

        editStockBarcode.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editStockBarcode.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        editStockBarcode.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                MovementFromTo.this.keyPressed(evt);
            }
        });

        jPanel2.add(editStockBarcode);
        editStockBarcode.setBounds(70, 20, 220, 20);

        buttonSubmit.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonSubmit.setText("Move");
        buttonSubmit.setEnabled(false);
        buttonSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MovementFromTo.this.actionPerformed(evt);
            }
        });

        jPanel2.add(buttonSubmit);
        buttonSubmit.setBounds(310, 17, 80, 26);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(jPanel2, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        buttonStockQuery.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonStockQuery.setText("Stock on hand");
        buttonStockQuery.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MovementFromTo.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        jPanel3.add(buttonStockQuery, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        getContentPane().add(jPanel3, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-697)/2, (screenSize.height-663)/2, 697, 663);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void tblActionsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblActionsMouseClicked
        
        if ((evt.getModifiers() & InputEvent.BUTTON3_MASK) != 0) {
            int nRow = tblActions.rowAtPoint(evt.getPoint());
            String strEventStatus = (String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(nRow)).getRowElement(EVENTTEXT_INDEX);
            if(strEventStatus.equals(EVENT_STATUS_TEXT_ACTIVE)){
                tblActions.getSelectionModel().setSelectionInterval( nRow,nRow ) ;
                jpmUndo.show(evt.getComponent(),evt.getX(),evt.getY());
            }
        }
        
    }//GEN-LAST:event_tblActionsMouseClicked
    
    private void keyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyPressed
        char chKeyPressed = evt.getKeyChar();
        if(evt.getSource() == editStockCount) {
            if(chKeyPressed == evt.VK_ENTER) {
                editStockBarcode.requestFocus();
            }
        } else if(evt.getSource() == editStockBarcode) {
            if(chKeyPressed == evt.VK_ENTER) {
                buttonSubmit.requestFocus();
                buttonSubmit.doClick();
            }
        }
    }//GEN-LAST:event_keyPressed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        
        if(evt.getSource() == buttonSubmit){
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editStockCount)){
                JOptionPane.showMessageDialog(null,"Please, enter valid integer for stoc count!");
                return;
            }
            if(!UniversalInputVerifier.BARCODE_Verifier(editStockBarcode)){
                JOptionPane.showMessageDialog(null,"Please, enter valid barcode!");
                return;
            }
            String strStockCount = editStockCount.getText();
            int nStockCount = Integer.parseInt(strStockCount);
            String strBarcode = editStockBarcode.getText();
            int nStoreIDSrc = ((ComboDataModel)comboStoreFrom.getModel()).getCObjectAt(comboStoreFrom.getSelectedIndex()).nItemDBKey;
            String strStoreNameFrom = (String)comboStoreFrom.getSelectedItem();
            int nStoreIDDst = ((ComboDataModel)comboStoreTo.getModel()).getCObjectAt(comboStoreTo.getSelectedIndex()).nItemDBKey;
            String strStoreNameTo = (String)comboStoreTo.getSelectedItem();
            String date = SharedUtils.getDateStringFormatted( java.util.Calendar.getInstance() );
            if( executeTranStoreOperation(strOperationCode,nStockCount,strBarcode,
                    nStoreIDSrc,nStoreIDDst,date,SharedUtils.nUserID,null,1) )
            {           
                Vector vecRow = new Vector();
                vecRow.addElement(strStoreNameFrom);
                vecRow.addElement(strStoreNameTo);
                vecRow.addElement(strStockName);
                vecRow.addElement(strBarcode);
                vecRow.addElement(String.valueOf(nStockCount));            
                vecRow.addElement(EVENT_STATUS_TEXT_ACTIVE);
                vecRow.addElement(String.valueOf(nStockID));
                vecRow.addElement(String.valueOf(nStoreIDSrc));            
                vecRow.addElement(String.valueOf(nStoreIDDst));
                vecRow.addElement(String.valueOf(nTranID));
                UniversalTableRow tableRow = new UniversalTableRow(vecRow);
                ((UniversalTableModel)tblActions.getModel()).insertItem((Object)tableRow);
                tblActions.updateUI();
                editStockBarcode.setText("");
                editStockCount.setText("1");
                editStockCount.setSelectionStart(0);
                editStockCount.setSelectionEnd(1);
                editStockCount.requestFocus();
            }                                    
        } else if(evt.getSource() == jmiUndo){
                        
            int row = tblActions.getSelectedRow();            
            //String strStockCount = (String)tblActions.getModel().getValueAt(row,COUNT_INDEX);
            //String strBarcode = (String)tblActions.getModel().getValueAt(row,BARCODE_INDEX);
            int nStoreIdFrom = Integer.parseInt((String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(STORE_IDFROM_INDEX));
            int nStoreIdTo = Integer.parseInt((String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(STORE_IDTO_INDEX));    
            int nTranID = Integer.parseInt((String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(TRAN_ID_INDEX));            
            //String strStoreIdFrom = ((String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(EVENT_IDFROM_INDEX));
            String date = SharedUtils.getCurrentDateStringFormatted();
            UndoTranStoreOperation(date,SharedUtils.nUserID,nTranID,null,1);            
            ((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).setRowElement(EVENT_STATUS_TEXT_NOTACTIVE, EVENTTEXT_INDEX);
            tblActions.updateUI();
            
        }
        else if(evt.getSource() == buttonStockQuery){
            StockOnHand dlgStockOnHand = new StockOnHand(/*new JFrame(),false*/);
            dlgStockOnHand.show();
       }
    }//GEN-LAST:event_actionPerformed
    
    private void valueChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_valueChanged
       if(evt.getSource() == comboStoreFrom){
            if(evt.getItem() == comboStoreFrom.getSelectedItem()){
                if(((String)comboStoreFrom.getSelectedItem()).equals((String)comboStoreTo.getSelectedItem())){
                    buttonSubmit.setEnabled(false);                    
                }
                else
                    buttonSubmit.setEnabled(true);  
            }            
        }
        else if(evt.getSource() == comboStoreTo){
            if(evt.getItem() == comboStoreTo.getSelectedItem()){
                if(((String)comboStoreTo.getSelectedItem()).equals((String)comboStoreFrom.getSelectedItem())){
                    buttonSubmit.setEnabled(false);                    
                }
                else
                    buttonSubmit.setEnabled(true);  
            }
            
        }
    }//GEN-LAST:event_valueChanged
    private boolean executeTranStoreOperation(String strOperationCode,int nStockCount,
            String strBarcode,int nStoreIdSrc, int nStoreIdDst,
            String date, int nUserID, String strTranDesc, int nEventTranSeq)
    {
        Connection conn = null;        
        try
        {       
            if(CompositeProduct.isCompositeForBarcode(strBarcode)){
                throw new Exception("Can't move composite products!");
            }
            conn = SharedUtils.getConnection();  
            conn.setAutoCommit(false);
            ProcedureTranStore proc = new ProcedureTranStore();
            proc.execTranStoreOperation(conn, strOperationCode, nStockCount, 
                    strBarcode, "" + nStoreIdSrc, "" + nStoreIdDst, date, 
                    "" + nUserID, strTranDesc, nEventTranSeq );            
            nTranID = proc.m_nTranID;
            nStockID = proc.m_nStockID;
            strStockName = proc.m_strStockName;
            nNewStockBalance = proc.m_nNewStockBalance;
            conn.commit();
        }
        catch(Throwable e)
        {
            SharedUtils.handleException( e, "Operation can not be completed!\n" + e.getMessage() );
            SharedUtils.rollback(conn);
            return false;
        }
        finally
        {
            SharedUtils.closeConnection(conn);
        }
        return true;
    }
    
    private boolean UndoTranStoreOperation(String date,int nUserID,int nTranID,
            String strTranDesc,int nTranSeqNum)
    {  	   
        Connection conn = null;
        try
        {
            conn = SharedUtils.getConnection();  
            conn.setAutoCommit(false);
            ProcedureUndoTranStore proc = new ProcedureUndoTranStore();
            proc.execUndoTranStore(conn, date, nUserID, strTranDesc, nTranID, nTranSeqNum );
            nTranID = Integer.parseInt( proc.m_newTranId );  
            conn.commit();
        }
        catch(Throwable e)
        {
            SharedUtils.handleException( e, "Operation can not be completed!" );
            SharedUtils.rollback(conn);
            return false;
        }
        finally
        {
            SharedUtils.closeConnection(conn);
        }
        return true;
    }
    
    private void afterInitComponents() {
        editStockCount.setText("1");
        editStockCount.setSelectionStart(0);
        editStockCount.setSelectionEnd(1);
        UniversalInputVerifier stockCountInputVerifier = new UniversalInputVerifier(MovementFromTo_STOCK_COUNT,this);
        editStockCount.setInputVerifier(stockCountInputVerifier);
        try
        {
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
            String strSQL = "SELECT STOR_NAME,STOR_KEY FROM BASE_STOR ORDER BY STOR_NAME";
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbStoresFrom = new ComboDataModel(rsDBData);
            comboStoreFrom.setModel(cdbStoresFrom);
            rsDBData.close();
            stm.close();        
            strSQL = "SELECT STOR_NAME,STOR_KEY FROM BASE_STOR ORDER BY STOR_NAME";
            stm = connDB.createStatement();
            rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbStores = new ComboDataModel(rsDBData);
            comboStoreTo.setModel(cdbStores);
            rsDBData.close();
            stm.close();
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);            
        }        
        UniversalTableModel tbmAllStocks = new UniversalTableModel(null,strrgnColumnNames);        
        tblActions.setModel(tbmAllStocks);
        tblActions.getTableHeader().setReorderingAllowed(false);
        tblActions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        SharedUtils.setTableColumnsWidth(tblActions,nrgnWidths);
        scrAllStocks.setViewportView(tblActions);
        //
        enableExit(tblActions);
        enableExit(comboStoreFrom);
        enableExit(comboStoreTo);
        UIUtils.setTableFonts(tblActions);
        /////////
        UIUtils.setHorizontalAlignment(tblActions, 4, javax.swing.JTextField.RIGHT );
        UIUtils.setTableFonts( tblActions );
        UIUtils.setColumnWidth( tblActions, 0, 170 );
        UIUtils.setColumnWidth( tblActions, 1, 170 );
        UIUtils.setColumnWidth( tblActions, 3, 100 );
        UIUtils.setColumnWidth( tblActions, 4, 100 );
        UIUtils.setColumnWidth( tblActions, 5, 100 );        
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup btngOperations;
    private javax.swing.JButton buttonStockQuery;
    public javax.swing.JButton buttonSubmit;
    private javax.swing.JComboBox comboStoreFrom;
    private javax.swing.JComboBox comboStoreTo;
    private javax.swing.JTextField editStockBarcode;
    private javax.swing.JTextField editStockCount;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JMenuItem jmiUndo;
    private javax.swing.JPopupMenu jpmUndo;
    private javax.swing.JLabel lblStockCount;
    private javax.swing.JLabel lblStocks;
    private javax.swing.JScrollPane scrAllStocks;
    private javax.swing.JTable tblActions;
    // End of variables declaration//GEN-END:variables
    
}
