package medstore;

import java.awt.*;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.plaf.basic.BasicTableHeaderUI;
import medstore.procedures.*;
import java.util.*;
import medstore.products.composite.CompositeProduct;

public class MovementInOut extends CommonDialog implements ItemListener,SharedConstants{
    private final String MESSAGE_IN = "<html><body><font color=\"#0000ff\">You are</font> <font color=\"#ff0000\">filling up</font> <font color=\"#0000ff\">your<br> warehouse</font> <font color=\"#ff0000\"> !</font> </body> </html>";
    private final String MESSAGE_OUT = "<html><body><font color=\"#0000ff\">You are </font><font color=\"#ff0000\">taking out </font><font color=\"#0000ff\">stocks now</font><font color=\"#ff0000\"> !</font>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br></body></html>";
    
    
    /////////////////////////////////////////////
    private String strOperName,strOperCode;
    private int nStoreId;
    //private String strSQL;
    private String[] strrgnColumnNames = {"Store Name","Stock Name","Barcode","Quantity","Operation","Status"};
    private int[] nrgnWidths = {250,250,250,120,120,130};
    private final int STORE_NAME_INDEX = 0;
    private final int STOCK_NAME_INDEX = 1;
    private final int BARCODE_INDEX = 2;
    private final int COUNT_INDEX = 3;
    private final int QUANTITY_INDEX = 4;
    private final int EVENTTEXT_INDEX = 5;
    private final int EVENTTYPE_INDEX = 6;
    private final int STOCK_ID_INDEX = 7;
    private final int STORE_INDEX = 8;
    private final int EVENTID_INDEX = 9;
    private final int ACTUAL_COUNT_INDEX = 10;
    private final int STOCK_CONTENTBARCODE_INDEX = 11;
    private boolean m_firstActivated = false;
    
    
    public MovementInOut(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        //nEventType = EVENT_TYPE_INPUT;
        strOperCode = OPCODE_INPUT;
        strOperName = OPNAME_INPUT;
        initComponents();
        afterInitComponents();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        btngOperations = new javax.swing.ButtonGroup();
        jpmUndo = new javax.swing.JPopupMenu();
        jmiUndo = new javax.swing.JMenuItem();
        scrAllStocks = new javax.swing.JScrollPane();
        tblActions = new javax.swing.JTable();
        lblStocks = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        lblStore = new javax.swing.JLabel();
        comboStore = new javax.swing.JComboBox();
        lblOutArrow = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        rdbMoveIn = new javax.swing.JRadioButton();
        rdbMoveOut = new javax.swing.JRadioButton();
        jPanel5 = new javax.swing.JPanel();
        lblInArrow = new javax.swing.JLabel();
        jPanel6 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        lblStockCount = new javax.swing.JLabel();
        editStockCount = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        editStockBarcode = new javax.swing.JTextField();
        buttonSubmit = new javax.swing.JButton();
        lblActionMessage = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        buttonStockQuery = new javax.swing.JButton();

        jmiUndo.setText("Undo");
        jmiUndo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MovementInOut.this.actionPerformed(evt);
            }
        });

        jpmUndo.add(jmiUndo);

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Move Stock In and Out");
        addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                formFocusGained(evt);
            }
        });
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowActivated(java.awt.event.WindowEvent evt) {
                formWindowActivated(evt);
            }
        });

        scrAllStocks.setFont(new java.awt.Font("Tahoma", 1, 13));
        scrAllStocks.setPreferredSize(new java.awt.Dimension(1, 1));
        tblActions.setFont(new java.awt.Font("Tahoma", 1, 13));
        tblActions.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblActions.setSelectionBackground(new java.awt.Color(125, 162, 246));
        tblActions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });

        scrAllStocks.setViewportView(tblActions);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 10);
        getContentPane().add(scrAllStocks, gridBagConstraints);

        lblStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStocks.setText("Current operations");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 94;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        getContentPane().add(lblStocks, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMinimumSize(new java.awt.Dimension(609, 79));
        jPanel1.setPreferredSize(new java.awt.Dimension(609, 79));
        lblStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStore.setText(" Store");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanel1.add(lblStore, gridBagConstraints);

        comboStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboStore.setBorder(null);
        comboStore.setMaximumSize(new java.awt.Dimension(200, 22));
        comboStore.setMinimumSize(new java.awt.Dimension(200, 22));
        comboStore.setPreferredSize(new java.awt.Dimension(200, 22));
        comboStore.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                valueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 20, 0);
        jPanel1.add(comboStore, gridBagConstraints);

        lblOutArrow.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medstore/pictures/8ar01a.gif")));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        jPanel1.add(lblOutArrow, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        rdbMoveIn.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        rdbMoveIn.setText("Move In");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel3.add(rdbMoveIn, gridBagConstraints);

        rdbMoveOut.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        rdbMoveOut.setText("Move Out");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        jPanel3.add(rdbMoveOut, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(jPanel3, gridBagConstraints);

        jPanel5.setLayout(new java.awt.GridBagLayout());

        jPanel5.setMaximumSize(new java.awt.Dimension(100, 28));
        jPanel5.setMinimumSize(new java.awt.Dimension(100, 28));
        jPanel5.setOpaque(false);
        jPanel5.setPreferredSize(new java.awt.Dimension(100, 28));
        lblInArrow.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medstore/pictures/8ar01a.gif")));
        lblInArrow.setAutoscrolls(true);
        lblInArrow.setMaximumSize(new java.awt.Dimension(1, 1));
        lblInArrow.setMinimumSize(new java.awt.Dimension(1, 1));
        lblInArrow.setPreferredSize(new java.awt.Dimension(1, 1));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        jPanel5.add(lblInArrow, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        jPanel1.add(jPanel5, gridBagConstraints);

        jPanel6.setLayout(new java.awt.GridBagLayout());

        jPanel6.setMinimumSize(new java.awt.Dimension(50, 28));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 100.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        jPanel1.add(jPanel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(jPanel1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setMinimumSize(new java.awt.Dimension(619, 59));
        jPanel2.setPreferredSize(new java.awt.Dimension(619, 59));
        lblStockCount.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStockCount.setText("Count");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        jPanel2.add(lblStockCount, gridBagConstraints);

        editStockCount.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockCount.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        editStockCount.setMaximumSize(new java.awt.Dimension(70, 20));
        editStockCount.setMinimumSize(new java.awt.Dimension(70, 20));
        editStockCount.setPreferredSize(new java.awt.Dimension(70, 20));
        editStockCount.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                editStockCountFocusLost(evt);
            }
        });
        editStockCount.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                MovementInOut.this.keyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 20);
        jPanel2.add(editStockCount, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Barcode");
        jLabel1.setMaximumSize(new java.awt.Dimension(70, 18));
        jLabel1.setMinimumSize(new java.awt.Dimension(70, 18));
        jLabel1.setPreferredSize(new java.awt.Dimension(70, 18));
        jLabel1.setRequestFocusEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        jPanel2.add(jLabel1, gridBagConstraints);

        editStockBarcode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockBarcode.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        editStockBarcode.setMaximumSize(new java.awt.Dimension(160, 20));
        editStockBarcode.setMinimumSize(new java.awt.Dimension(160, 20));
        editStockBarcode.setPreferredSize(new java.awt.Dimension(160, 20));
        editStockBarcode.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                MovementInOut.this.keyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 0);
        jPanel2.add(editStockBarcode, gridBagConstraints);

        buttonSubmit.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonSubmit.setText("Move In");
        buttonSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MovementInOut.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        jPanel2.add(buttonSubmit, gridBagConstraints);

        lblActionMessage.setFont(new java.awt.Font("Tahoma", 1, 16));
        lblActionMessage.setText("<html><body><font color=\"#0000ff\">You are </font><font color=\"#ff0000\">taking out </font><font color=\"#0000ff\">stocks now</font><font color=\"#ff0000\">!</font><br></body></html>");
        lblActionMessage.setMaximumSize(new java.awt.Dimension(270, 42));
        lblActionMessage.setMinimumSize(new java.awt.Dimension(270, 42));
        lblActionMessage.setPreferredSize(new java.awt.Dimension(270, 42));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 2.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(7, 10, 0, 0);
        jPanel2.add(lblActionMessage, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 10);
        getContentPane().add(jPanel2, gridBagConstraints);

        jPanel4.setLayout(new java.awt.GridBagLayout());

        buttonStockQuery.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonStockQuery.setText("Stock on hand");
        buttonStockQuery.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                MovementInOut.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        jPanel4.add(buttonStockQuery, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.gridheight = java.awt.GridBagConstraints.REMAINDER;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jPanel4, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-677)/2, (screenSize.height-677)/2, 677, 677);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void formWindowActivated(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowActivated
        // TODO add your handling code here:
        if( m_firstActivated )
            return;
        m_firstActivated = true;
        editStockCount.requestFocus();
    }//GEN-LAST:event_formWindowActivated
    
    private void editStockCountFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_editStockCountFocusLost
        // TODO add your handling code here:
    }//GEN-LAST:event_editStockCountFocusLost
    
    private void formFocusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_formFocusGained
        //System.out.println("formFocusGained");
    }//GEN-LAST:event_formFocusGained
    
    private void tblActionsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblActionsMouseClicked
        if ((evt.getModifiers() & InputEvent.BUTTON3_MASK) != 0) {
            int nRow = tblActions.rowAtPoint(evt.getPoint());
            String strEventStatus = (String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(nRow)).getRowElement(EVENTTEXT_INDEX);
            if(strEventStatus.equals(EVENT_STATUS_TEXT_ACTIVE)){
                tblActions.getSelectionModel().setSelectionInterval( nRow,nRow ) ;
                jpmUndo.show(evt.getComponent(),evt.getX(),evt.getY());
            }
        }
        //JOptionPane.showMessageDialog(null,"mouse!");
    }//GEN-LAST:event_tblActionsMouseClicked
    
    private void keyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyPressed
        char chKeyPressed = evt.getKeyChar();
        if(evt.getSource() == editStockCount) {
            if(chKeyPressed == evt.VK_ENTER) {
                editStockBarcode.requestFocus();
            }
        } else if(evt.getSource() == editStockBarcode) {
            if(chKeyPressed == evt.VK_ENTER) {
                buttonSubmit.requestFocus();
                buttonSubmit.doClick();
            }
        }
    }//GEN-LAST:event_keyPressed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        scrAllStocks.setBackground(SharedUtils.bgColor);
        //tblActions.setBackground(new Color(255,0,0));
        if(evt.getSource() == buttonSubmit){
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editStockCount)){
                JOptionPane.showMessageDialog(null,"Please, enter valid integer for stock count!");
                return;
            }
            if(!UniversalInputVerifier.BARCODE_Verifier(editStockBarcode)){
                JOptionPane.showMessageDialog(null,"Please, enter valid barcode!");
                return;
            }
            String strStockCount = editStockCount.getText();
            String strBarcode = editStockBarcode.getText();
            nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
            String strStoreName = (String)comboStore.getSelectedItem();
            int nStockCount = Integer.parseInt(strStockCount);
            boolean is_composite = CompositeProduct.isCompositeForBarcode(strBarcode);
            
            if(is_composite && nStoreId!=11){
                JOptionPane.showMessageDialog(null,"This product is composite,\nand can be moved only IN/OUT Packing room!");
                return;
            } else{
                Connection conn = null;
                try{
                    conn = SharedUtils.getConnection();
                    conn.setAutoCommit(false);
                    if(is_composite){
                        CompositeProduct cp = new CompositeProduct(CompositeProduct.getCompositeKeyFromBarcode(strBarcode));
                        UniversalTableModel childModel = cp.loadChilds();
                        int cRowCount = childModel.getRowCount();
                        for(int cRow = 0; cRow < cRowCount; cRow++){
                            int cStockCount = nStockCount * Integer.valueOf(((UniversalTableRow)childModel.getRowObject(cRow)).getRowElement(CompositeProduct.count_index).toString());
                            String cBarcode = ((UniversalTableRow)childModel.getRowObject(cRow)).getRowElement(CompositeProduct.poduct_barcode).toString();
                            executeStoreOperation(conn, strOperCode,cStockCount,cBarcode,nStoreId,strStoreName,SharedUtils.nUserID, SharedUtils.getDateStringFormatted(Calendar.getInstance()) );
                        }
                    }// else{
                        executeStoreOperation(conn, strOperCode,nStockCount,strBarcode,nStoreId,strStoreName,SharedUtils.nUserID, SharedUtils.getDateStringFormatted(Calendar.getInstance()) );
                    //}
                    conn.commit();
                } catch(Throwable e) {
                    SharedUtils.handleException( e, "Operation can not be completed!\n"+e.getMessage() );
                    SharedUtils.rollback(conn);
                    return;
                } finally {
                    SharedUtils.closeConnection(conn);
                }
                
            }
            
            
        } else if(evt.getSource() == jmiUndo){
            int row = tblActions.getSelectedRow();
            String strEventID = (String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(EVENTID_INDEX);
            int nEventID = Integer.parseInt(strEventID);
            String date = SharedUtils.getCurrentDateStringFormatted();
            UndoStoreOperation(nEventID, SharedUtils.nUserID, date, row);
            
        } else if(evt.getSource() == buttonStockQuery){
            int nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
            StockOnHand dlgStockOnHand = new StockOnHand(nStoreId);
            dlgStockOnHand.setVisible(true);
        }
    }//GEN-LAST:event_actionPerformed
    
    private void valueChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_valueChanged
        
    }//GEN-LAST:event_valueChanged
    
    private void executeStoreOperation(Connection conn, String strOperationCode,int nStockCount,
            String strBarcode,int nStoreId,String strStoreName,int nUserID,String date) throws Exception{
        
        
        //conn.setAutoCommit(false);
        ProcedureStore proc = new ProcedureStore();
        proc.execStoreOperation( conn, strOperationCode, nStockCount,
                strBarcode, "" + nStoreId, date, "" +nUserID );
        long lLastEventID = Long.parseLong(proc.m_insertedEventId);
        int nStockID = Integer.parseInt( proc.m_stockId );
        String strStockName = proc.m_stockName;
        int nNewStockBalance = proc.m_newStockCountOnHand;
        Vector vecRow = new Vector();
        vecRow.addElement(strStoreName);
        vecRow.addElement(strStockName);
        vecRow.addElement(strBarcode);
        vecRow.addElement(String.valueOf(nStockCount));
        vecRow.addElement(strOperName);
        vecRow.addElement(EVENT_STATUS_TEXT_ACTIVE);
        vecRow.addElement(strOperCode);
        vecRow.addElement(String.valueOf(nStockID));
        vecRow.addElement(String.valueOf(nStoreId));
        vecRow.addElement(String.valueOf(lLastEventID));
        UniversalTableRow tableRow = new UniversalTableRow(vecRow);
        ((UniversalTableModel)tblActions.getModel()).insertItem((Object)tableRow);
        tblActions.updateUI();
        editStockBarcode.setText("");
        editStockCount.setText("1");
        editStockCount.setSelectionStart(0);
        editStockCount.setSelectionEnd(1);
        editStockCount.requestFocus();
        
    }
    
    private void UndoStoreOperation(int nEventID,int nUserID,String date,int nTableRow) {
        Connection conn = null;
        try {
            conn = SharedUtils.getConnection();
            conn.setAutoCommit(false);
            ProcedureUndoStore proc = new ProcedureUndoStore();
            proc.execUndoStoreOperation( conn, date, nEventID, nUserID );
            
            long lLastEventID = Long.parseLong( proc.m_insertedEventId );
            int nNewStockBalance = proc.m_newStockcountOnHand;
            ((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(nTableRow)).setRowElement(EVENT_STATUS_TEXT_NOTACTIVE, EVENTTEXT_INDEX);
            tblActions.updateUI();
            conn.commit();
        } catch(Throwable e) {
            SharedUtils.handleException( e, "Operation can not be completed!" );
            SharedUtils.rollback(conn);
            return;
        } finally {
            SharedUtils.closeConnection(conn);
        }
    }
    
    private void afterInitComponents() {
        editStockCount.setText("1");
        editStockCount.setSelectionStart(0);
        editStockCount.setSelectionEnd(1);
        UniversalInputVerifier stockCountInputVerifier = new UniversalInputVerifier(MovementInOut_STOCK_COUNT,this);
        editStockCount.setInputVerifier(stockCountInputVerifier);
        btngOperations.add(rdbMoveIn);
        btngOperations.add(rdbMoveOut);
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        String strSQL = "SELECT STOR_NAME,STOR_KEY FROM BASE_STOR ORDER BY STOR_NAME";
        try{
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbStores = new ComboDataModel(rsDBData);
            cdbStores.selectIndexByKey(11);
            comboStore.setModel(cdbStores);
            
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
        
        rdbMoveIn.setSelected(true);
        rdbMoveIn.addItemListener(this);
        rdbMoveOut.addItemListener(this);
        
        UniversalTableModel tbmAllStocks = new UniversalTableModel(null,strrgnColumnNames);
        tblActions = new javax.swing.JTable(tbmAllStocks);
        tblActions.setModel(tbmAllStocks);
        SharedUtils.setTableColumnsWidth(tblActions,nrgnWidths);
        tblActions.getTableHeader().setReorderingAllowed(false);
        tblActions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        scrAllStocks.setViewportView(tblActions);
        tblActions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });
        enableExit(comboStore);
        enableExit(tblActions);
        UIUtils.setTableFonts(tblActions);
        editStockCount.requestFocusInWindow();
        this.setFocusTraversalPolicy(new MovInOutFocusTraversalPolicy());
        ///
        UIUtils.setHorizontalAlignment(tblActions, 3, javax.swing.JTextField.RIGHT );
        UIUtils.setTableFonts( tblActions );
        UIUtils.setColumnWidth( tblActions, 0, 160 );
        UIUtils.setColumnWidth( tblActions, 2, 90 );
        UIUtils.setColumnWidth( tblActions, 3, 100 );
        UIUtils.setColumnWidth( tblActions, 4, 90 );
        UIUtils.setColumnWidth( tblActions, 5, 80 );
        //
        lblInArrow.setVisible(true);
        lblOutArrow.setVisible(false);
        ///
        lblActionMessage.setText( MESSAGE_IN );
        //lblStore.setText(" To Store");
        
    }
    
    public void itemStateChanged(ItemEvent ie){
        if(rdbMoveIn.isSelected()) {
            buttonSubmit.setText("Move In");
            strOperCode = OPCODE_INPUT;
            strOperName = OPNAME_INPUT;
            //lblInArrow.setVisible(true);
            lblInArrow.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medstore/pictures/8ar01a.gif")));
            lblOutArrow.setVisible(false);
            //lblOutArrow.setIcon(null);
            lblActionMessage.setText( MESSAGE_IN );
            //lblStore.setText(" To Store");
            
        } else {
            buttonSubmit.setText("Move Out");
            strOperCode = OPCODE_OUTPUT;
            strOperName = OPNAME_OUTPUT;
            //lblInArrow.setVisible(false);
            lblInArrow.setIcon(null);
            lblOutArrow.setVisible(true);
            //lblOutArrow.setIcon(new javax.swing.ImageIcon(getClass().getResource("/medstore/pictures/8ar01a.gif")));
            lblActionMessage.setText( MESSAGE_OUT );
            //lblStore.setText(" From Store");
        }
    }
    private void setControlsBackGround(){
        //tblActions.getTableHeader().updateUI();
        this.getContentPane().setBackground(SharedUtils.bgColor);
        rdbMoveIn.setBackground(SharedUtils.bgColor);
        rdbMoveOut.setBackground(SharedUtils.bgColor);
        BasicTableHeaderUI basicHeader = new BasicTableHeaderUI();
        basicHeader.installUI(tblActions.getTableHeader());
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup btngOperations;
    private javax.swing.JButton buttonStockQuery;
    public javax.swing.JButton buttonSubmit;
    private javax.swing.JComboBox comboStore;
    private javax.swing.JTextField editStockBarcode;
    private javax.swing.JTextField editStockCount;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JMenuItem jmiUndo;
    private javax.swing.JPopupMenu jpmUndo;
    private javax.swing.JLabel lblActionMessage;
    private javax.swing.JLabel lblInArrow;
    private javax.swing.JLabel lblOutArrow;
    private javax.swing.JLabel lblStockCount;
    private javax.swing.JLabel lblStocks;
    private javax.swing.JLabel lblStore;
    private javax.swing.JRadioButton rdbMoveIn;
    private javax.swing.JRadioButton rdbMoveOut;
    private javax.swing.JScrollPane scrAllStocks;
    private javax.swing.JTable tblActions;
    // End of variables declaration//GEN-END:variables
    
    class MovInOutFocusTraversalPolicy
            extends FocusTraversalPolicy {
        
        public Component getComponentAfter(Container focusCycleRoot,
                Component aComponent) {
            if (aComponent.equals(rdbMoveIn)) {
                return editStockCount;
            } else if (aComponent.equals(rdbMoveOut)) {
                return editStockCount;
            } else if (aComponent.equals(comboStore)) {
                return editStockCount;
            } else if (aComponent.equals(editStockCount)) {
                return editStockBarcode;
            } else if (aComponent.equals(editStockBarcode)) {
                return editStockBarcode;
            } else if (aComponent.equals(buttonSubmit)) {
                return editStockCount;
            } else if (aComponent.equals(tblActions)) {
                return editStockCount;
            }
            return editStockCount;
        }
        
        public Component getComponentBefore(Container focusCycleRoot,
                Component aComponent) {
            if (aComponent.equals(rdbMoveIn)) {
                return null;
            } else if (aComponent.equals(rdbMoveOut)) {
                return null;
            } else if (aComponent.equals(comboStore)) {
                return null;
            } else if (aComponent.equals(editStockCount)) {
                return null;
            } else if (aComponent.equals(editStockBarcode)) {
                return editStockCount;
            } else if (aComponent.equals(buttonSubmit)) {
                return editStockBarcode;
            } else if (aComponent.equals(tblActions)) {
                return null;
            }
            return null;
        }
        
        public Component getDefaultComponent(Container focusCycleRoot) {
            return editStockCount;
        }
        
        public Component getLastComponent(Container focusCycleRoot) {
            return editStockCount;
        }
        
        public Component getFirstComponent(Container focusCycleRoot) {
            return editStockCount;
        }
    }
    
}
