/*
 * OrderDetailsReport.java
 *
 * Created on , 2005,  15, 16:02
 */

package medstore;

/**
 *
 * @author ait
 */

import java.util.*;
import java.sql.*;



public class OrderDetailsReport 
{    
    public static int ALLIGN_LEFT = 0;
    public static int ALLIGN_RIGHT = 1;
    //
    private int m_maxColumns = 85;
    private StringBuffer m_buffer = new StringBuffer();
    private ArrayList m_data;
    private int[] m_widths;
    private int[] m_alignments;
    private int m_rowsPerPage;    
    private String m_description;
    private String[] m_columns;
    private String m_firstColumnSpace = "     ";
    private int m_rowsCount = 0;
    private String m_antetka;
    public String m_header;
    
    public OrderDetailsReport( String description,
            ArrayList data, int rowsPerPage, String antetka )
    {   
        m_data = data;
        m_description = description;
        m_columns = new String[] {" Date","Order No","Barcode","Stock Name","Quantity","Price"};
        m_widths = new int[] { 22, 11, 10, 25, 10, 9 };
        m_alignments = new int[] { ALLIGN_LEFT, ALLIGN_LEFT, ALLIGN_LEFT,
                                   ALLIGN_LEFT, ALLIGN_RIGHT, ALLIGN_RIGHT };
        m_rowsPerPage = rowsPerPage;
        m_antetka = "--------";
    }
    
    public String generateReport()
        //throws Exception
    {
        m_buffer.append( m_description + "\n\n\n" );
        String str = m_buffer.toString();
        for( int i = 0; i < str.length(); i++ )
        {
            char c = str.charAt(i);
            if( c == '\n' )
                m_rowsCount++ ;
        }        
        generateHeader();
        generateRows();
        return m_buffer.toString();
    }
    
    private void generateHeader()
    {   
        String header = "";
        String[] columns = new String[ m_columns.length ];
        for( int i = 0; i < m_columns.length; i++ )
        {
            columns[i] = m_columns[i];
        }
        
        boolean isEmpty;
        do
        {
            isEmpty = true;
            for( int i = 0; i < columns.length; i++ )
            {
                String colText = columns[i];
                if( colText == null )
                    colText = "";
                int dif = m_widths[i] - colText.length();
                if( dif > 0 )
                {
                    colText = colText + getPadding(dif);                
                    columns[i] = "";
                }
                else if( dif < 0 )
                {
                    colText = colText.substring( 0, m_widths[i] );
                    columns[i] = columns[i].substring(m_widths[i]);
                    isEmpty = false;
                }                
                else
                {
                    columns[i] = "";
                }
                header += colText;
            }
            m_buffer.append( header + "\n" );
            checkNewPage();
            break;
        }while( !isEmpty ); 
        m_header = header;
    }
    
    private void addAntetka()
    {
        int antLength = m_antetka.length();
        for( int i = 0; i < m_columns.length; i++ )
        {
            int dif = m_widths[i] - antLength;
            if( dif >= 0 )
            {
                String colText = m_antetka + getPadding(dif); 
                if( i == 0 )
                    colText = colText.replaceFirst( "-" , " " );
                m_buffer.append( colText );
            }                
            else
                throw new java.lang.AssertionError();
        }
        m_buffer.append( "\n" );
        checkNewPage();        
    }
    
    private void generateRows()
    {
        String strOldNo="";
        int nRowProductCount=0,nAllProductCount=0,nAllOrders=0;
        float  nOldRowPrice=0,nAllPrice=0;
        float prevOrderTotalPrice = 0;
        for(int i = 0; i < m_data.size(); i++ )
        {
            ArrayList dataRow = (ArrayList)m_data.get(i);                 
                           
            if( nRowProductCount==0 )
               nRowProductCount++;
            nAllProductCount++;
            String strRow = "";
            Timestamp tmsp = (Timestamp)dataRow.get(1);
            String strDate = " " + SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
            String strOrderNo = (String)dataRow.get(2);
            String strBarcode = (String)dataRow.get(3);
            String strStockName = (String)dataRow.get(4);
            int nQuantity = ((Integer)dataRow.get(5)).intValue();
            String strQuantity = String.valueOf(nQuantity);
            float fPrice = ((Float)dataRow.get(6)).floatValue();//rsDBData.getFloat(6);
            float orderTotalPrice = ((Float)dataRow.get(7)).floatValue();
            String strPrice = String.valueOf(fPrice);                
            
             if(strOrderNo.equals(strOldNo))
             {
                 //print row
                 ArrayList row = new ArrayList();
                 row.add("");
                 row.add("");
                 row.add(strBarcode);
                 row.add(strStockName);
                 row.add(strQuantity + "  ");
                 row.add( SharedUtils.formatFloat( strPrice, '.') );
                 generateRow(row);                 
                 nRowProductCount++;                
             }
             else
             {
                 nAllPrice += orderTotalPrice;
                 if( nAllProductCount > 1 )
                 {
                     ArrayList row = new ArrayList();
                     row.add("");
                     row.add("Order Total:");
                     row.add("" + nRowProductCount + "   " );
                     row.add("");
                     row.add("");
                     row.add("" + SharedUtils.formatFloat( "" + prevOrderTotalPrice,'.' ) );
                     m_alignments[ 2 ] = ALLIGN_RIGHT;
                     generateRow(row);
                     m_alignments[ 2 ] = ALLIGN_LEFT;
                     nRowProductCount=0;
                 }
                 addAntetka();

                 ArrayList row = new ArrayList();
                 row.add(strDate);
                 row.add(strOrderNo);
                 row.add(strBarcode);
                 row.add(strStockName);
                 row.add(strQuantity + "  ");
                 row.add( SharedUtils.formatFloat( strPrice, '.') );
                 generateRow(row);                 
                 nAllOrders++;
             }
             
             strOldNo = strOrderNo;
             if( i == m_data.size() -1 )
             {
                 nRowProductCount++;
                 ArrayList row = new ArrayList();
                 row.add("");
                 row.add("Order Total:");
                 row.add("" + nRowProductCount + "   " );
                 row.add("");
                 row.add("");
                 row.add( SharedUtils.formatFloat( "" + orderTotalPrice, '.') );
                 m_alignments[ 2 ] = ALLIGN_RIGHT;
                 generateRow(row);
                 m_alignments[ 2 ] = ALLIGN_LEFT;
                 //
                 addAntetka();
                 //
                 row = new ArrayList();
                 row.add(" Total:");
                 row.add( String.valueOf(nAllOrders) + "   " );
                 row.add("" + nAllProductCount + "   ");
                 row.add("");
                 row.add("");
                 row.add("" + SharedUtils.formatFloat( "" + nAllPrice, '.' ));  
                 m_alignments[1] = m_alignments[2] = m_alignments[5] = ALLIGN_RIGHT;
                 m_widths[5] += 2;
                 m_widths[4] -= 2;
                 generateRow(row);                
            }
            prevOrderTotalPrice = orderTotalPrice;
        }
    }
    
    private void generateRow( ArrayList rowList )
    {
        Object[] row = rowList.toArray();
        boolean isEmpty = true;
        do
        {
            isEmpty = true;
            String strRow = "";
            for( int i = 0; i < row.length; i++ )            
            {
                String colText = (String)row[i];
                if( colText == null )
                    colText = "";
                int dif = m_widths[i] - colText.length();
                if( dif > 0 )
                {
                    colText = getColText( colText, dif, m_alignments[i] );                
                    row[i] = "";
                }
                else if( dif < 0 )
                {
                    colText = colText.substring( 0, m_widths[i] );
                    row[i] = ((String)row[i]).substring(m_widths[i]);
                    isEmpty = false;
                }                
                else
                {
                    row[i] = "";
                }    
                strRow += colText;
                m_buffer.append( colText );                
            }
            m_buffer.append( "\n" );
            checkNewPage();
            break;
        }while( !isEmpty );
    }
    
    private String getColText( String text, int padding, int align )
    {
        String strPadding = getPadding( padding );
        if( align == ALLIGN_LEFT )
            return text + strPadding;
        return strPadding + text;
    }
    
    private String getPadding( int count )
    {
        String result = "";
        for( int i = 0; i < count; i++  )
        {
            result += " ";
        }
        return result;
    }
    
    private void checkNewPage()
    {
        //m_rowsCount++;
       // if( m_rowsCount % m_rowsPerPage == 0 )
        //    m_buffer.append( "\r\n\r\n\r\n" );        
    }    
}
