/*
 * OrdersInOut.java
 *
 * Created on , 2005,  28, 23:21
 */

package medstore;

import java.awt.Component;
import java.awt.Rectangle;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Vector;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.plaf.basic.BasicTableHeaderUI;
import medstore.fullfillment.data.FFData;
import medstore.fullfillment.FFDbUtils;
import medstore.procedures.*;
import java.util.*;
import javax.swing.JScrollBar;
import javax.swing.SwingUtilities;
import medstore.auftrag.AuftragData;
import medstore.auftrag.AuftragFile;
import medstore.products.composite.CompositeProduct;
import org.jfree.report.JFreeReportBoot;


/**
 *
 * @author  JohnyEdu
 */
public class OrderFullfilment extends CommonDialog implements SharedConstants, Runnable{
    //private JTable tblActions;
    //private int nEventType;
    private String strOperName,strOperCode;
    private int nStoreId;
    private String strSQL;
    private int nCurrentOrderNo,nOrderStockCount;
    private String[] strrgnColumnNames = {"Order No.","Stock Name","Barcode","Quantity"};
    private int[] nrgnWidths = {250,250,250,120};
    //private ResultSet rsOrderInfo;
    private final int ORDER_NO_INDEX = 0;
    private final int STOCK_NAME_INDEX = 1;
    private final int BARCODE_INDEX = 2;
    private final int COUNT_INDEX = 3;
    private final int STOCK_ID_INDEX = 4;
    medstore.offers.OrderPrintUtils op;
    private volatile Thread mainThread = null;
    private int curRow = -1;
    private UniversalTableModel tbmOrders = null;
    
    public OrderFullfilment(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        //nEventType = EVENT_TYPE_INPUT;
        strSQL = "SELECT STCK_NAME,CONN_STCK_IN_STOR.STCK_CNT,CONN_STCK_IN_STOR.STCK_PCNT, STCK_KEY " +
                " FROM BASE_STCK INNER JOIN CONN_STCK_IN_STOR ON (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT)" +
                "WHERE STOR_IDNT = ";
        strOperCode = OPCODE_INPUT;
        strOperName = OPNAME_INPUT;
        nCurrentOrderNo = -1;
        nOrderStockCount = -1;
        
        initComponents();
        afterInitComponents();
        
        radioGroupNoAct.add(radioToday);
        radioGroupNoAct.add(radioAll);
        radioToday.setSelected(true);
        setNoActOrders();
        JScrollBar vert = jScrollPane1.getVerticalScrollBar();
        
        
    }
    public void start() {
        if (mainThread == null) {
            mainThread = new Thread(this, "Orders");
            mainThread.start();
        }
    }
    
    public void run() {
        Thread th = Thread.currentThread();
        while (mainThread == th) {
            final Rectangle rect = tblOrders.getVisibleRect();
            setNoActOrders();
            SwingUtilities.invokeLater(new Runnable() {
                public void run(){
                    tblOrders.scrollRectToVisible(rect);
                    if(curRow>-1 && tblOrders.getRowCount() > 0){
                        curRow = Math.min(curRow,tblOrders.getRowCount()-1);
                        tblOrders.setRowSelectionInterval(curRow,curRow);
                    }
                    
                }
            });
            try {
                th.sleep(20000);
                
            } catch (InterruptedException e){ }
            
            
        }
        
    }
    public void stop() {
        mainThread = null;
    }
    
    private void setNoActOrders(){
        
        String str_rgn_columnNamesActive[] = {"Order No","Date","Doc. Type"};
        if(tbmOrders==null){
            tbmOrders = new UniversalTableModel(null,str_rgn_columnNamesActive);
            tblOrders.setModel(tbmOrders);
            tblOrders.getTableHeader().setReorderingAllowed(false);
            tblOrders.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            int[] nrgnOrdersWidthsOrd = {100,150,100};
            SharedUtils.setTableColumnsWidth(tblOrders,nrgnOrdersWidthsOrd);
        }
        //tblOrders.updateUI();
        try{
            if(radioToday.isSelected()){
                getNoActOrders(1);
            } else{
                getNoActOrders(-1);
            }
        } catch(Exception e){
            
        }
        
    }
    private void getNoActOrders(int stat) throws Exception{
        String noActSql = "";
        
        switch(stat){
            case 1:
                SimpleDateFormat df = new SimpleDateFormat("yyyy.MM.dd 00:00:00");
                noActSql = "SELECT     * FROM         [dbo].[view_flfl_ordr_noact] where invc_date >= '" + df.format(new Date()) + "'";
                break;
            default:
                noActSql = "SELECT     * FROM         [dbo].[view_flfl_ordr_noact]";
        }
        
        //String str_rgn_columnNamesActive[] = {"Order No","Date","Doc. Type"};
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        Statement stm = connDB.createStatement();
        ResultSet rsDBData=stm.executeQuery(noActSql);
        
        
        ((UniversalTableModel)tblOrders.getModel()).setSQLResult(rsDBData);
        
        
    }
    private boolean isFilled(boolean show){
        try{
            String orderId = editOrderNo.getText();
            
            
            FFData ffdata = new FFData(orderId, "", 0, "", 0,
                    0, "");
            FFDbUtils ffDbUtils = new FFDbUtils(ffdata);
            
            boolean isFilled = ffDbUtils.isFilled();
            if(isFilled){
                if(show)
                    JOptionPane.showMessageDialog(this,"This order is already fulfilled!");
                nCurrentOrderNo=-1;
                nOrderStockCount=-1;
                validateUI();
                return true;
            }
        } catch(Exception e){
            
        }
        return false;
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        btngOperations = new javax.swing.ButtonGroup();
        jpmUndo = new javax.swing.JPopupMenu();
        jmiUndo = new javax.swing.JMenuItem();
        radioGroupNoAct = new javax.swing.ButtonGroup();
        scrAllStocks = new javax.swing.JScrollPane();
        tblActions = new javax.swing.JTable();
        lblStocks = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        editOrderNo = new javax.swing.JTextField();
        lblStore = new javax.swing.JLabel();
        comboStore = new javax.swing.JComboBox();
        jPanel3 = new javax.swing.JPanel();
        lblStockCount = new javax.swing.JLabel();
        editStockCount = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        editStockBarcode = new javax.swing.JTextField();
        btnAddToFullfill = new javax.swing.JButton();
        btnPrint = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        btnOrderSubmit = new javax.swing.JButton();
        btnCancelOrder = new javax.swing.JButton();
        btnShowOrder = new javax.swing.JButton();
        buttonStockQuery = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jPanel7 = new javax.swing.JPanel();
        jPanel8 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tblOrders = new javax.swing.JTable();
        jPanel4 = new javax.swing.JPanel();
        radioToday = new javax.swing.JRadioButton();
        radioAll = new javax.swing.JRadioButton();

        jmiUndo.setText("Undo");
        jmiUndo.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrderFullfilment.this.actionPerformed(evt);
            }
        });

        jpmUndo.add(jmiUndo);

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Fullfil Order");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        scrAllStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        tblActions.setFont(new java.awt.Font("Tahoma", 0, 13));
        tblActions.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblActions.setSelectionBackground(new java.awt.Color(125, 162, 246));
        tblActions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });

        scrAllStocks.setViewportView(tblActions);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 23;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 9);
        getContentPane().add(scrAllStocks, gridBagConstraints);

        lblStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStocks.setText("Current operations");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.ipadx = 62;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        getContentPane().add(lblStocks, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText("OrderNo");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(15, 0, 0, 0);
        jPanel1.add(jLabel2, gridBagConstraints);

        editOrderNo.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOrderNo.setMinimumSize(new java.awt.Dimension(60, 20));
        editOrderNo.setPreferredSize(new java.awt.Dimension(60, 20));
        editOrderNo.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                OrderFullfilment.this.focusLost(evt);
            }
        });
        editOrderNo.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                OrderFullfilment.this.keyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 0);
        jPanel1.add(editOrderNo, gridBagConstraints);

        lblStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStore.setText("Take stocks from:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(15, 6, 0, 0);
        jPanel1.add(lblStore, gridBagConstraints);

        comboStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboStore.setBorder(null);
        comboStore.setMinimumSize(new java.awt.Dimension(200, 22));
        comboStore.setPreferredSize(new java.awt.Dimension(200, 22));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 6, 0, 0);
        jPanel1.add(comboStore, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        getContentPane().add(jPanel1, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        lblStockCount.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStockCount.setText("Count");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        jPanel3.add(lblStockCount, gridBagConstraints);

        editStockCount.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockCount.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        editStockCount.setMinimumSize(new java.awt.Dimension(60, 20));
        editStockCount.setPreferredSize(new java.awt.Dimension(60, 20));
        editStockCount.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                OrderFullfilment.this.keyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel3.add(editStockCount, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Barcode");
        jLabel1.setRequestFocusEnabled(false);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(8, 6, 0, 0);
        jPanel3.add(jLabel1, gridBagConstraints);

        editStockBarcode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStockBarcode.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        editStockBarcode.setMinimumSize(new java.awt.Dimension(180, 20));
        editStockBarcode.setPreferredSize(new java.awt.Dimension(180, 20));
        editStockBarcode.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                OrderFullfilment.this.keyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 6, 0, 0);
        jPanel3.add(editStockBarcode, gridBagConstraints);

        btnAddToFullfill.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnAddToFullfill.setText("Add to fullfilment");
        btnAddToFullfill.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrderFullfilment.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 0, 0);
        jPanel3.add(btnAddToFullfill, gridBagConstraints);

        btnPrint.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 13));
        btnPrint.setText("Print");
        btnPrint.setEnabled(false);
        btnPrint.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btnPrint.setMaximumSize(new java.awt.Dimension(76, 23));
        btnPrint.setMinimumSize(new java.awt.Dimension(76, 23));
        btnPrint.setPreferredSize(new java.awt.Dimension(76, 23));
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPrintActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel3.add(btnPrint, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 16;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 0);
        getContentPane().add(jPanel3, gridBagConstraints);

        jPanel5.setLayout(new java.awt.GridBagLayout());

        btnOrderSubmit.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnOrderSubmit.setText("Submit Order");
        btnOrderSubmit.setEnabled(false);
        btnOrderSubmit.setMaximumSize(new java.awt.Dimension(117, 26));
        btnOrderSubmit.setMinimumSize(new java.awt.Dimension(117, 26));
        btnOrderSubmit.setPreferredSize(new java.awt.Dimension(117, 26));
        btnOrderSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrderFullfilment.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel5.add(btnOrderSubmit, gridBagConstraints);

        btnCancelOrder.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnCancelOrder.setText("Cancel Order");
        btnCancelOrder.setEnabled(false);
        btnCancelOrder.setMaximumSize(new java.awt.Dimension(117, 26));
        btnCancelOrder.setMinimumSize(new java.awt.Dimension(117, 26));
        btnCancelOrder.setPreferredSize(new java.awt.Dimension(117, 26));
        btnCancelOrder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrderFullfilment.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        jPanel5.add(btnCancelOrder, gridBagConstraints);

        btnShowOrder.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnShowOrder.setText("Show Order");
        btnShowOrder.setEnabled(false);
        btnShowOrder.setMaximumSize(new java.awt.Dimension(109, 26));
        btnShowOrder.setMinimumSize(new java.awt.Dimension(109, 26));
        btnShowOrder.setPreferredSize(new java.awt.Dimension(109, 26));
        btnShowOrder.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrderFullfilment.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        jPanel5.add(btnShowOrder, gridBagConstraints);

        buttonStockQuery.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonStockQuery.setText("Stock on hand");
        buttonStockQuery.setMaximumSize(new java.awt.Dimension(123, 26));
        buttonStockQuery.setMinimumSize(new java.awt.Dimension(123, 26));
        buttonStockQuery.setPreferredSize(new java.awt.Dimension(123, 26));
        buttonStockQuery.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrderFullfilment.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel5.add(buttonStockQuery, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel5.add(jPanel6, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel5.add(jPanel7, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        jPanel5.add(jPanel8, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 21;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        getContentPane().add(jPanel5, gridBagConstraints);

        jScrollPane1.setPreferredSize(new java.awt.Dimension(24, 28));
        tblOrders.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblOrders.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblOrdersMouseClicked(evt);
            }
        });

        jScrollPane1.setViewportView(tblOrders);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 16;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 7;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 0);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        jPanel4.setLayout(new java.awt.GridBagLayout());

        radioToday.setFont(new java.awt.Font("Tahoma", 1, 13));
        radioToday.setLabel("Today");
        radioToday.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioTodayActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(15, 0, 0, 0);
        jPanel4.add(radioToday, gridBagConstraints);

        radioAll.setFont(new java.awt.Font("Tahoma", 1, 13));
        radioAll.setLabel("All");
        radioAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radioAllActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        jPanel4.add(radioAll, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 12;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 4;
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.VERTICAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 5, 0, 10);
        getContentPane().add(jPanel4, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-698)/2, (screenSize.height-333)/2, 698, 333);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        stop();
        dispose();
    }//GEN-LAST:event_formWindowClosing
    
    private void btnPrintActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPrintActionPerformed
        if(isFilled(true))
            return;
        try{
            JFreeReportBoot jf = JFreeReportBoot.getInstance();
            if(!jf.isBootDone() || !jf.isBootInProgress()){
                jf.start();
            }
            op = new medstore.offers.OrderPrintUtils(editOrderNo.getText());
            op.printInvoice();
            op.printPacking();
        } catch(Exception e){
            JOptionPane.showMessageDialog(this,e.getMessage());
            e.printStackTrace();
        }
        
    }//GEN-LAST:event_btnPrintActionPerformed
    
    private void tblOrdersMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblOrdersMouseClicked
        try{
            int row = tblOrders.getSelectedRow();
            curRow = row;
            String strOrderIdnt = (String)tblOrders.getModel().getValueAt(row,0);
            editOrderNo.setText(strOrderIdnt);
            editOrderNo.requestFocus();
        } catch(Exception e){
            
        }
    }//GEN-LAST:event_tblOrdersMouseClicked
    
    private void radioAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioAllActionPerformed
        try{
            getNoActOrders(0);
            curRow = -1;
            
        } catch(Exception e){
            e.printStackTrace();
        }
    }//GEN-LAST:event_radioAllActionPerformed
    
    private void radioTodayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_radioTodayActionPerformed
        try{
            getNoActOrders(1);
            curRow=-1;
        } catch(Exception e){
            e.printStackTrace();
        }
    }//GEN-LAST:event_radioTodayActionPerformed
    
    private void focusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_focusLost
        if(evt.getSource() == editOrderNo){
            
        }
    }//GEN-LAST:event_focusLost
    
    private void tblActionsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblActionsMouseClicked
        
    }//GEN-LAST:event_tblActionsMouseClicked
    
    private void keyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyPressed
        int chKeyPressed = evt.getKeyCode();
        
        if(chKeyPressed==123){
            btnOrderSubmit.doClick(10);
        } else{
            if(evt.getSource() == editOrderNo) {
                if(chKeyPressed == evt.VK_ENTER || chKeyPressed == evt.VK_TAB) {
                    
                    if(!UniversalInputVerifier.Universal_Integer_Verifier(editOrderNo)){
                        JOptionPane.showMessageDialog(null,"Please, enter valid Order Number!");
                        return;
                    }
                    if(isFilled(true))
                        return;
                    String strOrderNo = editOrderNo.getText();
                    String strSQL = "SELECT COUNT(*) " +
                            " FROM POSITION WHERE V_NR =" + strOrderNo;
                    try{
                        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
                        Statement stm = connDB.createStatement();
                        ResultSet rsDBData=stm.executeQuery(strSQL);
                        rsDBData.next();
                        nOrderStockCount = rsDBData.getInt(1);
                        if(nOrderStockCount < 1){
                            //editOrderNo.requestFocus();
                            rsDBData.close();
                            stm.close();
                            rsDBData = null;
                            stm=null;
                            editOrderNo.selectAll();
                            JOptionPane.showMessageDialog(this,"There is no such query registered in the system!");
                            return;
                        }
                        rsDBData.close();
                        stm.close();
                        rsDBData = null;
                        stm=null;
                        //connDB = null;
                        
                        nCurrentOrderNo = Integer.parseInt(strOrderNo);
                        editOrderNo.setEnabled(false);
                        tblOrders.setEnabled(false);
                        editStockCount.requestFocus();
                        editStockCount.setSelectionStart(0);
                        editStockCount.setSelectionEnd(1);
                        btnShowOrder.setEnabled(true);
                        btnCancelOrder.setEnabled(true);
                        btnOrderSubmit.setEnabled(true);
                        btnPrint.setEnabled(true);
                        radioAll.setEnabled(false);
                        radioToday.setEnabled(false);
                        return;
                    }catch(SQLException sqle){
                        nCurrentOrderNo=-1;
                        nOrderStockCount=-1;
                        JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
                    }
                    
                }
                
            } else if(evt.getSource() == editStockCount) {
                if(chKeyPressed == evt.VK_ENTER) {
                    editStockBarcode.requestFocus();
                }
            } else if(evt.getSource() == editStockBarcode) {
                if(chKeyPressed == evt.VK_ENTER) {
                    //buttonSubmit.requestFocus();
                    btnAddToFullfill.doClick();
                }
            }
        }
    }//GEN-LAST:event_keyPressed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        //scrAllStocks.setBackground(SharedUtils.bgColor);
        //tblActions.setBackground(new Color(255,0,0));
        if(evt.getSource() == btnAddToFullfill){
            String orderId = editOrderNo.getText();
            if(isFilled(true))
                return;
            if(Integer.parseInt(orderId) == -1){
                JOptionPane.showMessageDialog(null,"You havent submit your order number yet!\nPlease enter order number and hit enter key!");
                return;
            }
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editOrderNo)){
                JOptionPane.showMessageDialog(null,"Please, enter valid Order Number!");
                return;
            }
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editStockCount)){
                JOptionPane.showMessageDialog(null,"Please, enter valid integer for stock count!");
                return;
            }
            if(!UniversalInputVerifier.BARCODE_Verifier(editStockBarcode)){
                JOptionPane.showMessageDialog(null,"Please, enter valid barcode!");
                return;
            }
            
            String strStockCount = editStockCount.getText();
            //int nStockCount = Integer.parseInt(strStockCount);
            String strBarcode = editStockBarcode.getText();
            String strOrderNo = editOrderNo.getText();
            int nStockID = -1;
            String strStockName="";
            
            if(((UniversalTableModel)tblActions.getModel()).objectExistsAt(strBarcode, BARCODE_INDEX )){
                JOptionPane.showMessageDialog(null,"You have already checked this stock for that order!You can press the 'Show Order' for more info.");
                return;
            }
            //int nOrderNo = Integer.parseInt(strOrderNo);
            //Timestamp tmspCurrentDate = SharedUtils.getCurrentTimestamp();
            String strSQL = "SELECT STCK_KEY,STCK_NAME " +
                    " FROM BASE_STCK WHERE STCK_BRCD = '" + strBarcode + "'";
            try{
                Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery(strSQL);
                if(!rsDBData.next()){
                    rsDBData.close();
                    JOptionPane.showMessageDialog(null,"There is no stock registered with that barcode!");
                    return;
                }
                nStockID = rsDBData.getInt(1);
                strStockName = rsDBData.getString(2);
                rsDBData.close();
                stm.close();
                rsDBData = null;
                stm = null;
                
                strSQL = "SELECT  V_NR FROM VIEW_ORDER_INFO WHERE STCK_KEY='" + nStockID + "' AND P_MENGE=" + strStockCount + " AND V_NR=" + String.valueOf(nCurrentOrderNo);
                try{
                    //Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
                    stm = connDB.createStatement();
                    rsDBData=stm.executeQuery(strSQL);
                    if(!rsDBData.next()){
                        rsDBData.close();
                        JOptionPane.showMessageDialog(null,"There is no such record for this order!");
                        return;
                    }
                    /*
                    nStockID = rsDBData.getInt(1);
                    strStockName = rsDBData.getString(2);
                     */
                    rsDBData.close();
                    stm.close();
                    rsDBData = null;
                    stm = null;
                }catch(SQLException sqle){
                    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
                }
            }catch(SQLException sqle){
                JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
            }
            
            Vector vecRow = new Vector();
                        
            vecRow.addElement(strOrderNo);
            vecRow.addElement(strStockName);
            vecRow.addElement(strBarcode);
            vecRow.addElement(strStockCount);
            vecRow.addElement(String.valueOf(nStockID));
            
            UniversalTableRow tableRow = new UniversalTableRow(vecRow);
            
            ((UniversalTableModel)tblActions.getModel()).insertItem((Object)tableRow);
            tblActions.updateUI();
            editStockBarcode.setText("");
            editStockCount.setText("1");
            editStockCount.setSelectionStart(0);
            editStockCount.setSelectionEnd(1);
            editStockCount.requestFocus();
            
            
        } else if(evt.getSource() == jmiUndo){
            
        } else if(evt.getSource() == buttonStockQuery){
            int nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
            StockOnHand dlgStockOnHand = new StockOnHand(nStoreId);
            dlgStockOnHand.show();
        } else if(evt.getSource() == btnShowOrder){
            if(nCurrentOrderNo == -1)
                return;
            ShowOrderInfo dlgShowOrderInfo = new ShowOrderInfo(new JFrame(),false,nCurrentOrderNo);
            dlgShowOrderInfo.show();
        } else if(evt.getSource() == btnOrderSubmit){
            if(isFilled(true))
                return;
            if(nOrderStockCount != tblActions.getRowCount()){
                JOptionPane.showMessageDialog(null,"Your current stock count doesn't match the order stock count!\nYou can press the 'Show Order' for more info..");
                return;
            }
            
            String strOperCode = "OT";
            nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
            int nRowCount = tblActions.getRowCount();
            Connection connDB = null;
            try{
                
                
                connDB = SharedUtils.getConnection();
                connDB.setAutoCommit(false);
                for(int row=0; row < nRowCount; row++){
                    String strOrderID = (String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(ORDER_NO_INDEX);
                    String strStockCount = (String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(COUNT_INDEX);
                    int nStockCount = Integer.parseInt(strStockCount);
                    String strBarcode = (String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(BARCODE_INDEX);
                    
                    String STOCK_ID = ((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(STOCK_ID_INDEX).toString();
                    String name = ((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(row)).getRowElement(STOCK_NAME_INDEX).toString();
                    
                    try{
                        if(CompositeProduct.isComposite(STOCK_ID)){
                            CompositeProduct cp = new CompositeProduct(STOCK_ID);
                            UniversalTableModel childModel = cp.loadChilds();
                            int cRowCount = childModel.getRowCount();
                            for(int cRow = 0; cRow < cRowCount; cRow++){
                                int cStockCount = nStockCount * Integer.valueOf(((UniversalTableRow)childModel.getRowObject(cRow)).getRowElement(CompositeProduct.count_index).toString());
                                String cBarcode = ((UniversalTableRow)childModel.getRowObject(cRow)).getRowElement(CompositeProduct.poduct_barcode).toString();
                                
                                executeQueryStoreOperation(
                                        connDB,
                                        strOrderID,
                                        strOperCode,
                                        cStockCount,
                                        cBarcode,
                                        nStoreId,
                                        SharedUtils.nUserID,
                                        SharedUtils.getDateStringFormatted(Calendar.getInstance())
                                        );
                                
                            }
                            
                        } //else{
                            
                            executeQueryStoreOperation(connDB,
                                    strOrderID,
                                    strOperCode,
                                    nStockCount,
                                    strBarcode,
                                    nStoreId,
                                    SharedUtils.nUserID,
                                    SharedUtils.getDateStringFormatted(Calendar.getInstance())
                                    );
                       // }
                    } catch(Exception e){
                        throw new Exception("Error while processing '" +
                                name + "'\nReason - " + e.getMessage());
                        
                    }
                    
                }
                
                connDB.commit();
                connDB.setAutoCommit(true);
                
                writeToAuftrag();
                afterInitComponents();
                
                
                
                
            } catch(Throwable e) {
                SharedUtils.handleException( e, e.getMessage() );
                SharedUtils.rollback(connDB);
                return;
            } finally {
                try{
                    SharedUtils.closeConnection(connDB);
                } catch(Exception e){
                    
                }
                
                validateUI();
            }
            JOptionPane.showMessageDialog(null,"Your order was successfully fulfilled!");
            validateUI();
        } else if(evt.getSource()==btnCancelOrder){
            int result = JOptionPane.showConfirmDialog((Component)this,"Do you really want to cancel the order?","Confirm Order Canceling",JOptionPane.YES_NO_OPTION);
            if( result == JOptionPane.YES_OPTION){
                validateUI();
            }
        }
    }//GEN-LAST:event_actionPerformed
    private synchronized void validateUI(){
        
        nOrderStockCount = -1;
        nCurrentOrderNo = -1;
        editStockBarcode.setText("");
        editOrderNo.setText("");
        editOrderNo.setEnabled(true);
        editStockCount.setText("1");
        editStockBarcode.setText("");
        btnCancelOrder.setEnabled(false);
        btnShowOrder.setEnabled(false);
        btnOrderSubmit.setEnabled(false);
        ((UniversalTableModel)tblActions.getModel()).clearData();
        tblActions.updateUI();
        tblOrders.setEnabled(true);
        btnPrint.setEnabled(false);
        
        radioAll.setEnabled(true);
        radioToday.setEnabled(true);
        
        setNoActOrders();
        
        editOrderNo.requestFocus();
        
    }
    
    private void executeQueryStoreOperation(Connection conn,String strOrderID,
            String strOperationCode,int nStockCount,String strBarcode,int nStoreId,
            int nUserID,String date)
            throws Exception {
        
        
        ProcedureStore proc = new ProcedureStore();
        proc.execStoreOperation( conn, strOperationCode, nStockCount,
                strBarcode, "" + nStoreId, date, "" + nUserID );
        long lLastEventID = Long.parseLong(proc.m_insertedEventId);
        int nStockID = Integer.parseInt( proc.m_stockId );
        
        String strEvntQuery ="INSERT INTO CONN_EVNT_QUER (evnt_idnt,quer_idnt ) VALUES(" + String.valueOf(lLastEventID) + "," + strOrderID + ")";
        Statement stm = conn.createStatement();
        int nAffectedRows = stm.executeUpdate(strEvntQuery);
        stm.close();
        if(nAffectedRows!=1)
            throw new Exception( "Database Error" );
    }
    
    private void UndoStoreOperation(int nEventID,int nUserID,String date,int nTableRow) {
        Connection conn = null;
        try {
            conn = SharedUtils.getConnection();
            conn.setAutoCommit(false);
            ProcedureUndoStore proc = new ProcedureUndoStore();
            proc.execUndoStoreOperation( conn, date, nEventID, nUserID );
        } catch(Throwable e) {
            SharedUtils.handleException( e, "Operation can not be completed!" );
            SharedUtils.rollback(conn);
            return;
        } finally {
            SharedUtils.closeConnection(conn);
        }
    }
    
    private void afterInitComponents() {
        
        editStockCount.setText("1");
        UniversalInputVerifier stockCountInputVerifier = new UniversalInputVerifier(OrderFullfilment_STOCK_COUNT,this);
        editStockCount.setInputVerifier(stockCountInputVerifier);
        UniversalInputVerifier orderNoInputVerifier = new UniversalInputVerifier(OrderFullfilment_ORDERNO,this);
        editOrderNo.setInputVerifier(orderNoInputVerifier);
        
        
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        String strSQL = "SELECT STOR_NAME,STOR_KEY FROM BASE_STOR WHERE STOR_TYPE='" + STORE_TYPE_PACKING + "' ORDER BY STOR_NAME";
        try{
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbStores = new ComboDataModel(rsDBData);
            comboStore.setModel(cdbStores);
            rsDBData.close();
            stm.close();
            
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
        
        UniversalTableModel tbmAllStocks = new UniversalTableModel(null,strrgnColumnNames);
        tblActions = new javax.swing.JTable(tbmAllStocks);
        tblActions.setModel(tbmAllStocks);
        SharedUtils.setTableColumnsWidth(tblActions,nrgnWidths);
        tblActions.getTableHeader().setReorderingAllowed(false);
        tblActions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        scrAllStocks.setViewportView(tblActions);
        tblActions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });
        enableExit(tblActions);
        UIUtils.setTableFonts(tblActions);
    }
    
    private void setControlsBackGround(){
        
        this.getContentPane().setBackground(SharedUtils.bgColor);
        
        BasicTableHeaderUI basicHeader = new BasicTableHeaderUI();
        basicHeader.installUI(tblActions.getTableHeader());
        
    }
    public void writeToAuftrag(){
        try {
            op = new medstore.offers.OrderPrintUtils(editOrderNo.getText());
            AuftragData auftragData = op.getAufftragData();
            AuftragFile auftragFile = Main.getAuftragFile();
            auftragFile.appendOrder(auftragData);
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null,"GENERAL ERROR: ORDER WAS NOT ADDED TO Auftrag file!\n" +
                    "THE ORDER IS REGISTERED TO DATABASE BUT WILL NOT BE PROCEEDED!\nReasen: " + ex.getMessage());
            ex.printStackTrace();
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JButton btnAddToFullfill;
    private javax.swing.JButton btnCancelOrder;
    private javax.swing.JButton btnOrderSubmit;
    private javax.swing.JButton btnPrint;
    private javax.swing.JButton btnShowOrder;
    private javax.swing.ButtonGroup btngOperations;
    private javax.swing.JButton buttonStockQuery;
    private javax.swing.JComboBox comboStore;
    private javax.swing.JTextField editOrderNo;
    private javax.swing.JTextField editStockBarcode;
    private javax.swing.JTextField editStockCount;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel7;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JMenuItem jmiUndo;
    private javax.swing.JPopupMenu jpmUndo;
    private javax.swing.JLabel lblStockCount;
    private javax.swing.JLabel lblStocks;
    private javax.swing.JLabel lblStore;
    private javax.swing.JRadioButton radioAll;
    private javax.swing.ButtonGroup radioGroupNoAct;
    private javax.swing.JRadioButton radioToday;
    private javax.swing.JScrollPane scrAllStocks;
    private javax.swing.JTable tblActions;
    private javax.swing.JTable tblOrders;
    // End of variables declaration//GEN-END:variables
    
}
