package medstore;

import java.awt.Color;
import java.awt.Component;
import java.awt.event.FocusEvent;
import java.awt.event.FocusListener;
import java.awt.event.InputEvent;
import java.awt.print.*;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.Vector;
import java.util.HashSet;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.*;
import javax.swing.SwingUtilities;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelEvent;
import javax.swing.event.TableModelListener;
import java.util.*;
import java.io.*;
import java.text.SimpleDateFormat;

import javax.swing.table.TableColumn;
import medstore.actors.CustomerActor;
import medstore.actors.Provisioner;
import medstore.base_cntr.VatTaxData;
import medstore.math.BigDec;
import medstore.products.Quotes;
import medstore.trans.LangPack;
import medstore.print.CustomPrintUtil;
import medstore.print.SimplePrintUtils;
import medstore.print.invoice.Article;
import medstore.print.invoice.Customer;
import medstore.print.invoice.Invoice;
import medstore.print.invoice.InvoiceTableModel;
import org.jfree.report.JFreeReport;
import org.jfree.report.JFreeReportBoot;
import org.jfree.report.modules.gui.print.PrintUtil;

public class OrdersPlacement extends javax.swing.JFrame implements TableModelListener,ListSelectionListener{
    
    /** Creates new form NewJDialog */
    public static final int PROV1_NAME_INDEX = 0;
    public static final int PROV2_NAME_INDEX = 1;
    private final int ORDER_NUMBER_INDEX = 0;
    public static final int VEC_STOCK_ABRV_INDEX = 0;
    public static final int VEC_STOCK_NAME_INDEX = 1;
    public static final int VEC_STOCK_KEY_INDEX = 2;
    
    public static final int NETTO_INDEX = 0;
    public static final int DISCOUNT_INDEX = 1;
    public static final int PORTO_INDEX = 2;
    public static final int TOTAL_WITHOUT_VAT = 3;
    public static final int VAT_INDEX = 4;
    public static final int TOTAL_INDEX = 5;
    
    public static final int VALUE_COL_INDEX = 2;
    
    public static final int STOCK_CODE_INDEX = 0;
    public static final int STOCK_NAME_INDEX = 2;
    public static final int STOCK_COUNT_INDEX = 3;
    public static final int STOCK_UNIT_INDEX = 4;
    public static final int STOCK_SUM_INDEX = 5;
    public static final int STOCK_KEY_INDEX = 6;
    public static final int CAMPAIGN_ID_INDEX = 7;
    
    public static final int TABLE_MODE_MANUAL = 1;
    public static final int TABLE_MODE_AUTOMATIC = 2;
    
    UniversalInputVerifier dateVerifier, strVerifier;
    private int nTableMode;
    Vector vecPatientSearchResults;
    
    Vector vecStockResults;
    
    AlternateAddress dlgAlternateAddress;
    private char chDialogSearch;
    float fVat;
    String strCountryID;
    double dPorto;
    boolean bControlsEnabled;
    boolean bUpdatedStocks = false;
    boolean m_bCalculateSums = true;
    ArrayList m_prov3Data = new ArrayList();
    JMenuItem m_menuItem;
    int m_currentRow; //current row count in invoice
    
    VatTaxData ctdata = null;
    private SimplePrintUtils spUtils;
    
    private String c_name = "";
    
    private CustomerActor customer;
    
    public OrdersPlacement(java.awt.Frame parent, boolean modal,JMenuItem menuItem ) {
        
        ctdata = new VatTaxData();
        
        customer = null;
        customer = new CustomerActor();
        customer.canPrucahse(false);
        
        vecPatientSearchResults = new Vector();
        
        vecStockResults = new Vector();
        
        dlgAlternateAddress = null;
        fVat = 0.0f;
        dPorto = SharedUtils.porto;
        strCountryID = "-1";
        bControlsEnabled = true;
        nTableMode = TABLE_MODE_MANUAL;
        dlgAlternateAddress = new AlternateAddress(new javax.swing.JFrame(), true);
        initComponents();
        afterInitComponents();
        m_menuItem = menuItem;
        m_menuItem.setEnabled(false);
        translate();
        
    }
    private void translate(){
        tabPane.setTitleAt(0,"Order Participants");
        Main.def_app_lang.loadTabbedPane(tabPane, 0, LangPack.tabpane_orderParticipants);
        
        tabPane.setTitleAt(1,"Orders Session");
        Main.def_app_lang.loadTabbedPane(tabPane, 1, LangPack.tabpane_orderSession);
        
        tbpOrders.setTitleAt(0,"Orders");
        Main.def_app_lang.loadTabbedPane(tbpOrders, 0, LangPack.tabpane_orders);
        
        tbpOrders.setTitleAt(1,"Invoice");
        Main.def_app_lang.loadTabbedPane(tbpOrders, 1, LangPack.tabpane_invoice);
        
        tbpOrders.setTitleAt(2,"Packing List");
        Main.def_app_lang.loadTabbedPane(tbpOrders, 2, LangPack.tabpane_packingList);
        
        
        Main.def_app_lang.loadLabelsFromPanel(jpanOPClient);
        Main.def_app_lang.loadLabelsFromPanel(jpanOPOrderDetails);
        Main.def_app_lang.loadLabelsFromPanel(jpanOPOrders);
        
    }
    private void logErrToFile(Exception ex){
        String userHomePath = (String)System.getProperty("user.home");
        String pathSeparator = (String)System.getProperty("file.separator");
        String lineSep = (String)System.getProperty("line.separator");
        String fullName = userHomePath + pathSeparator + "medstore_log.properties";
        Properties props = new Properties();
        
        try {
            File f = new File( fullName );
            FileOutputStream ostream = new FileOutputStream( f , true );
            if(! f.exists() ) {
                f.createNewFile();
            }
            if(ex!=null){
                String message = lineSep+lineSep+new Date().toString()+
                        lineSep+"Error Message:" + ex.getMessage();
                for(int i=0; i<ex.getStackTrace().length; i++){
                    StackTraceElement el = ex.getStackTrace()[i];
                    message+= lineSep+"File:" + el.getFileName() +
                            " Line:" + el.getLineNumber();
                }
                ostream.write(message.getBytes());
            }
            ostream.flush();
            ostream.close();
            
        } catch(Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
    }
    private BigDecimal getBdmPorto() {
        BigDecimal bdm = new BigDecimal( dPorto );
        return bdm.setScale(2,BigDecimal.ROUND_HALF_UP);
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jpmOrders = new javax.swing.JPopupMenu();
        mitemDelete = new javax.swing.JMenuItem();
        buttonGroup1 = new javax.swing.ButtonGroup();
        tabPane = new javax.swing.JTabbedPane();
        jPanel1 = new javax.swing.JPanel();
        jpanOPClient = new javax.swing.JPanel();
        editAppeal = new javax.swing.JTextField();
        editUIN = new javax.swing.JTextField();
        editDiscount = new javax.swing.JTextField();
        editAlternateName = new javax.swing.JTextField();
        btnSearchClient = new javax.swing.JButton();
        editSurname = new javax.swing.JTextField();
        editFirstName = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        editStreet = new javax.swing.JTextField();
        editCity = new javax.swing.JTextField();
        editCode = new javax.swing.JTextField();
        lblOPFName = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        jLabel11 = new javax.swing.JLabel();
        jLabel12 = new javax.swing.JLabel();
        jLabel13 = new javax.swing.JLabel();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        btnMoreClient = new javax.swing.JButton();
        btnNewClient = new javax.swing.JButton();
        editType = new javax.swing.JTextField();
        editCountry = new javax.swing.JTextField();
        chkbCanPurchase = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        editCLCode = new javax.swing.JTextField();
        chkVatFree = new javax.swing.JCheckBox();
        jPanel3 = new javax.swing.JPanel();
        editProv1UIN = new javax.swing.JTextField();
        editProv1Name = new javax.swing.JTextField();
        editProv1Pers = new javax.swing.JTextField();
        btnDoctors = new javax.swing.JButton();
        editProv2UIN = new javax.swing.JTextField();
        editProv2Name = new javax.swing.JTextField();
        editProv2Pers = new javax.swing.JTextField();
        btnDealers = new javax.swing.JButton();
        btnShowPercents = new javax.swing.JButton();
        lblProv1 = new javax.swing.JLabel();
        lblProv2 = new javax.swing.JLabel();
        scrProvs = new javax.swing.JScrollPane();
        tblProvs = new javax.swing.JTable();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane5 = new javax.swing.JScrollPane();
        edpInfo = new javax.swing.JEditorPane();
        jPanel4 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jEditorPane1 = new javax.swing.JEditorPane();
        jButton1 = new javax.swing.JButton();
        tbpOrders = new javax.swing.JTabbedPane();
        jPanel8 = new javax.swing.JPanel();
        jpanOPOrderDetails = new javax.swing.JPanel();
        editOrderDate = new javax.swing.JTextField();
        editOperator = new javax.swing.JTextField();
        editDocNo = new javax.swing.JTextField();
        lblDate = new javax.swing.JLabel();
        lblDocNum = new javax.swing.JLabel();
        comboDocType = new javax.swing.JComboBox();
        lblDocType = new javax.swing.JLabel();
        lblOper = new javax.swing.JLabel();
        jScrollPane6 = new javax.swing.JScrollPane();
        tblOrderGoods = new javax.swing.JTable();
        btnPlaceOrders = new javax.swing.JButton();
        btnControl = new javax.swing.JButton();
        tblSums = new javax.swing.JTable();
        editPayDate = new javax.swing.JTextField();
        jLabel22 = new javax.swing.JLabel();
        editPayed = new javax.swing.JTextField();
        jLabel23 = new javax.swing.JLabel();
        chkbAltAddress = new javax.swing.JCheckBox();
        btnSet = new javax.swing.JButton();
        editNewStock = new javax.swing.JTextField();
        jLabel24 = new javax.swing.JLabel();
        btnSelectStock = new javax.swing.JButton();
        editCount = new javax.swing.JTextField();
        jLabel25 = new javax.swing.JLabel();
        btnAddStock = new javax.swing.JButton();
        btnPay = new javax.swing.JButton();
        btnSearchOrders = new javax.swing.JButton();
        lblStockName = new javax.swing.JLabel();
        lblInvoice = new javax.swing.JLabel();
        editInvoiceNum = new javax.swing.JTextField();
        jpanOPOrders = new javax.swing.JPanel();
        jScrollPane7 = new javax.swing.JScrollPane();
        tblOrders = new javax.swing.JTable();
        btnSendLetter = new javax.swing.JButton();
        btnMacros = new javax.swing.JButton();
        btnCreditNote = new javax.swing.JButton();
        jPanel9 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        edpInvoice = new javax.swing.JEditorPane();
        bynPrintLabelInvoice = new javax.swing.JButton();
        btnPrint = new javax.swing.JButton();
        btnChangeMacro = new javax.swing.JButton();
        jPanel5 = new javax.swing.JPanel();
        jScrollPane8 = new javax.swing.JScrollPane();
        edpPackings = new javax.swing.JEditorPane();
        bynPrintLabelPList = new javax.swing.JButton();
        btnPrintPList = new javax.swing.JButton();

        mitemDelete.setText("Delete row");
        mitemDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpmOrders.add(mitemDelete);

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Place Orders");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        tabPane.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jPanel1.setLayout(null);

        jpanOPClient.setLayout(null);

        jpanOPClient.setBorder(new javax.swing.border.TitledBorder(null, "Client", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jpanOPClient.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jpanOPClient.setName("jpanOPClient");
        editAppeal.setFont(new java.awt.Font("Tahoma", 0, 13));
        editAppeal.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editAppeal.setEnabled(false);
        jpanOPClient.add(editAppeal);
        editAppeal.setBounds(260, 80, 50, 21);

        editUIN.setFont(new java.awt.Font("Tahoma", 0, 13));
        editUIN.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editUIN.setEnabled(false);
        jpanOPClient.add(editUIN);
        editUIN.setBounds(140, 310, 90, 21);

        editDiscount.setFont(new java.awt.Font("Tahoma", 0, 13));
        editDiscount.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editDiscount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editDiscountActionPerformed(evt);
            }
        });

        jpanOPClient.add(editDiscount);
        editDiscount.setBounds(230, 180, 60, 21);

        editAlternateName.setFont(new java.awt.Font("Tahoma", 0, 13));
        editAlternateName.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editAlternateNameActionPerformed(evt);
            }
        });

        jpanOPClient.add(editAlternateName);
        editAlternateName.setBounds(10, 130, 210, 21);

        btnSearchClient.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSearchClient.setText("Search");
        btnSearchClient.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSearchClient.setName("btnOPSearchClient");
        btnSearchClient.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPClient.add(btnSearchClient);
        btnSearchClient.setBounds(230, 30, 80, 26);

        editSurname.setFont(new java.awt.Font("Tahoma", 0, 13));
        editSurname.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editSurname.setEnabled(false);
        jpanOPClient.add(editSurname);
        editSurname.setBounds(140, 80, 110, 21);

        editFirstName.setFont(new java.awt.Font("Tahoma", 0, 13));
        editFirstName.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editFirstName.setEnabled(false);
        jpanOPClient.add(editFirstName);
        editFirstName.setBounds(10, 80, 120, 21);

        jLabel5.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel5.setText("UIN");
        jLabel5.setName("lblOPUIN");
        jpanOPClient.add(jLabel5);
        jLabel5.setBounds(140, 290, 180, 18);

        jLabel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel6.setText("Appeal");
        jLabel6.setName("lblOPApeal");
        jpanOPClient.add(jLabel6);
        jLabel6.setBounds(260, 60, 60, 18);

        jLabel7.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel7.setText("Type");
        jLabel7.setName("lblOPType");
        jpanOPClient.add(jLabel7);
        jLabel7.setBounds(230, 110, 90, 18);

        jLabel8.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel8.setText("Discount %");
        jLabel8.setName("lblOPDiscount");
        jpanOPClient.add(jLabel8);
        jLabel8.setBounds(230, 160, 90, 18);

        editStreet.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStreet.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editStreet.setEnabled(false);
        jpanOPClient.add(editStreet);
        editStreet.setBounds(10, 180, 210, 21);

        editCity.setFont(new java.awt.Font("Tahoma", 0, 13));
        editCity.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editCity.setEnabled(false);
        jpanOPClient.add(editCity);
        editCity.setBounds(110, 230, 110, 21);

        editCode.setFont(new java.awt.Font("Tahoma", 0, 13));
        editCode.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editCode.setEnabled(false);
        jpanOPClient.add(editCode);
        editCode.setBounds(10, 230, 90, 21);

        lblOPFName.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblOPFName.setText("First Name");
        lblOPFName.setName("lblOPFName");
        jpanOPClient.add(lblOPFName);
        lblOPFName.setBounds(10, 60, 120, 18);

        jLabel10.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel10.setText("Surname");
        jLabel10.setName("lblOPLName");
        jpanOPClient.add(jLabel10);
        jLabel10.setBounds(140, 60, 110, 18);

        jLabel11.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel11.setText("Alternative Name");
        jLabel11.setName("lblOPAltName");
        jpanOPClient.add(jLabel11);
        jLabel11.setBounds(10, 110, 210, 18);

        jLabel12.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel12.setText("Street");
        jLabel12.setName("lblOPStreet");
        jpanOPClient.add(jLabel12);
        jLabel12.setBounds(10, 160, 210, 18);

        jLabel13.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel13.setText("Code");
        jLabel13.setName("lblOPCode");
        jpanOPClient.add(jLabel13);
        jLabel13.setBounds(10, 210, 100, 18);

        jLabel14.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel14.setText("City");
        jLabel14.setName("lblOPCity");
        jpanOPClient.add(jLabel14);
        jLabel14.setBounds(110, 210, 120, 18);

        jLabel15.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel15.setText("Country");
        jLabel15.setName("lblOPCountry");
        jpanOPClient.add(jLabel15);
        jLabel15.setBounds(230, 210, 90, 18);

        btnMoreClient.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnMoreClient.setText("Edit");
        btnMoreClient.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnMoreClient.setName("btnOPEditClient");
        btnMoreClient.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPClient.add(btnMoreClient);
        btnMoreClient.setBounds(120, 30, 80, 26);

        btnNewClient.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnNewClient.setText("New");
        btnNewClient.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnNewClient.setName("btnOPNewClient");
        btnNewClient.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPClient.add(btnNewClient);
        btnNewClient.setBounds(10, 30, 80, 26);

        editType.setFont(new java.awt.Font("Tahoma", 0, 13));
        editType.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editType.setEnabled(false);
        jpanOPClient.add(editType);
        editType.setBounds(230, 130, 90, 21);

        editCountry.setFont(new java.awt.Font("Tahoma", 0, 13));
        editCountry.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editCountry.setEnabled(false);
        jpanOPClient.add(editCountry);
        editCountry.setBounds(230, 230, 90, 21);

        chkbCanPurchase.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkbCanPurchase.setText("Can purchase");
        chkbCanPurchase.setEnabled(false);
        chkbCanPurchase.setMargin(new java.awt.Insets(0, 0, 0, 0));
        chkbCanPurchase.setName("chkOPCanPurchase");
        chkbCanPurchase.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                chkbCanPurchaseActionPerformed(evt);
            }
        });

        jpanOPClient.add(chkbCanPurchase);
        chkbCanPurchase.setBounds(10, 265, 130, 20);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Client/Firm No ");
        jLabel1.setName("lblOPFirmNo");
        jpanOPClient.add(jLabel1);
        jLabel1.setBounds(10, 290, 130, 18);

        editCLCode.setEditable(false);
        editCLCode.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        jpanOPClient.add(editCLCode);
        editCLCode.setBounds(10, 310, 120, 21);

        chkVatFree.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkVatFree.setText("VAT free");
        chkVatFree.setEnabled(false);
        chkVatFree.setName("chkOPVatFree");
        jpanOPClient.add(chkVatFree);
        chkVatFree.setBounds(140, 265, 180, 20);

        jPanel1.add(jpanOPClient);
        jpanOPClient.setBounds(10, 10, 330, 340);

        jPanel3.setLayout(null);

        jPanel3.setBorder(new javax.swing.border.TitledBorder(null, "Provision1/Provision2", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jPanel3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        editProv1UIN.setEditable(false);
        editProv1UIN.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv1UIN.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editProv1UIN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jPanel3.add(editProv1UIN);
        editProv1UIN.setBounds(10, 30, 50, 21);

        editProv1Name.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv1Name.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editProv1Name.setEnabled(false);
        jPanel3.add(editProv1Name);
        editProv1Name.setBounds(70, 30, 120, 21);

        editProv1Pers.setText("0");
        editProv1Pers.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editProv1Pers.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editProv1PersActionPerformed(evt);
            }
        });
        editProv1Pers.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                editProv1PersFocusLost(evt);
            }
        });

        jPanel3.add(editProv1Pers);
        editProv1Pers.setBounds(220, 30, 50, 20);

        btnDoctors.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnDoctors.setText("?");
        btnDoctors.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnDoctors.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jPanel3.add(btnDoctors);
        btnDoctors.setBounds(275, 30, 20, 23);

        editProv2UIN.setEditable(false);
        editProv2UIN.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv2UIN.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editProv2UIN.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jPanel3.add(editProv2UIN);
        editProv2UIN.setBounds(10, 60, 50, 21);

        editProv2Name.setFont(new java.awt.Font("Tahoma", 0, 13));
        editProv2Name.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editProv2Name.setEnabled(false);
        jPanel3.add(editProv2Name);
        editProv2Name.setBounds(70, 60, 120, 21);

        editProv2Pers.setText("0");
        editProv2Pers.setDisabledTextColor(javax.swing.UIManager.getDefaults().getColor("Button.darkShadow"));
        editProv2Pers.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                editProv2PersActionPerformed(evt);
            }
        });
        editProv2Pers.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                editProv2PersFocusLost(evt);
            }
        });

        jPanel3.add(editProv2Pers);
        editProv2Pers.setBounds(220, 60, 50, 20);

        btnDealers.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnDealers.setText("?");
        btnDealers.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnDealers.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jPanel3.add(btnDealers);
        btnDealers.setBounds(275, 60, 20, 20);

        btnShowPercents.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnShowPercents.setText("%");
        btnShowPercents.setIconTextGap(1);
        btnShowPercents.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnShowPercents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jPanel3.add(btnShowPercents);
        btnShowPercents.setBounds(200, 30, 20, 50);

        lblProv1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblProv1.setText("DR");
        jPanel3.add(lblProv1);
        lblProv1.setBounds(300, 30, 20, 18);

        lblProv2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblProv2.setText("DL");
        jPanel3.add(lblProv2);
        lblProv2.setBounds(300, 60, 20, 18);

        scrProvs.setFont(new java.awt.Font("Tahoma", 0, 13));
        tblProvs.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Prov.1 %", "Prov.2 %"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblProvs.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                OrdersPlacement.this.mousePressed(evt);
            }
        });

        scrProvs.setViewportView(tblProvs);

        jPanel3.add(scrProvs);
        scrProvs.setBounds(220, 10, 90, 84);

        jPanel1.add(jPanel3);
        jPanel3.setBounds(10, 350, 330, 100);

        jPanel6.setLayout(null);

        jPanel6.setBorder(new javax.swing.border.TitledBorder(null, "Additional Client Info", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jPanel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jPanel6.setName("jpanOPClientInfo");
        edpInfo.setFont(new java.awt.Font("Tahoma", 0, 13));
        edpInfo.setEnabled(false);
        jScrollPane5.setViewportView(edpInfo);

        jPanel6.add(jScrollPane5);
        jScrollPane5.setBounds(10, 20, 310, 120);

        jPanel1.add(jPanel6);
        jPanel6.setBounds(10, 450, 330, 150);

        tabPane.addTab("tab1", jPanel1);

        jPanel4.setLayout(null);

        jEditorPane1.setText("\nOrder Session altered at 05.05.2005\nUser: admin\n\nActions:\n\n...");
        jScrollPane1.setViewportView(jEditorPane1);

        jPanel4.add(jScrollPane1);
        jScrollPane1.setBounds(10, 10, 320, 550);

        jButton1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jButton1.setText("Save To File...");
        jPanel4.add(jButton1);
        jButton1.setBounds(170, 575, 140, 26);

        tabPane.addTab("tab4", jPanel4);

        getContentPane().add(tabPane);
        tabPane.setBounds(10, 10, 350, 640);

        tbpOrders.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        tbpOrders.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                OrdersPlacement.this.stateChanged(evt);
            }
        });

        jPanel8.setLayout(null);

        jpanOPOrderDetails.setLayout(null);

        jpanOPOrderDetails.setBorder(new javax.swing.border.TitledBorder(null, "Order Details", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jpanOPOrderDetails.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jpanOPOrderDetails.setName("jpanOPOrderDetails");
        editOrderDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        jpanOPOrderDetails.add(editOrderDate);
        editOrderDate.setBounds(10, 40, 80, 21);

        editOperator.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOperator.setEnabled(false);
        jpanOPOrderDetails.add(editOperator);
        editOperator.setBounds(450, 40, 90, 21);

        editDocNo.setEditable(false);
        editDocNo.setFont(new java.awt.Font("Tahoma", 0, 13));
        editDocNo.setEnabled(false);
        jpanOPOrderDetails.add(editDocNo);
        editDocNo.setBounds(95, 40, 90, 21);

        lblDate.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDate.setText("Date");
        lblDate.setName("lblOPDate");
        jpanOPOrderDetails.add(lblDate);
        lblDate.setBounds(10, 20, 60, 18);

        lblDocNum.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocNum.setText("Document No.");
        lblDocNum.setName("lblOPDocNo");
        jpanOPOrderDetails.add(lblDocNum);
        lblDocNum.setBounds(85, 20, 130, 18);

        comboDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboDocType.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Invoice" }));
        comboDocType.setEnabled(false);
        comboDocType.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                comboDocTypeActionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(comboDocType);
        comboDocType.setBounds(330, 40, 110, 22);

        lblDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocType.setText("Document Type");
        lblDocType.setName("lblOPDocType");
        jpanOPOrderDetails.add(lblDocType);
        lblDocType.setBounds(330, 20, 120, 18);

        lblOper.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblOper.setText("Operator");
        lblOper.setName("lblOPOperator");
        jpanOPOrderDetails.add(lblOper);
        lblOper.setBounds(450, 20, 90, 18);

        jScrollPane6.setFont(new java.awt.Font("Tahoma", 1, 13));
        tblOrderGoods.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Stock Code", "Abbr.", "Stock Name", "Count", "Unit Price", "Sum Price"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblOrderGoods.setName("tblOrderGoods");
        tblOrderGoods.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                OrdersPlacement.this.mouseClicked(evt);
            }
        });

        jScrollPane6.setViewportView(tblOrderGoods);

        jpanOPOrderDetails.add(jScrollPane6);
        jScrollPane6.setBounds(10, 70, 560, 130);

        btnPlaceOrders.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnPlaceOrders.setText("Place Order");
        btnPlaceOrders.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnPlaceOrders.setName("btnOPPlaceOrder");
        btnPlaceOrders.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(btnPlaceOrders);
        btnPlaceOrders.setBounds(10, 330, 140, 26);

        btnControl.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnControl.setText("Cancel Order");
        btnControl.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnControl.setName("btnOPCancelNewOrder");
        btnControl.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(btnControl);
        btnControl.setBounds(190, 330, 150, 26);

        tblSums.setBackground(javax.swing.UIManager.getDefaults().getColor("CheckBox.shadow"));
        tblSums.setFont(new java.awt.Font("SansSerif", 1, 13));
        tblSums.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"Netto", "EUR", "0"},
                {"Discount", "EUR", "0"},
                {"Porto", "EUR", "4.5"},
                {"Total", "EUR", "0"},
                {"VAT", "EUR", "0"},
                {"Total", "EUR", "0"}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, true
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblSums.setAutoCreateColumnsFromModel(false);
        jpanOPOrderDetails.add(tblSums);
        tblSums.setBounds(360, 210, 210, 96);

        editPayDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        jpanOPOrderDetails.add(editPayDate);
        editPayDate.setBounds(410, 330, 80, 21);

        jLabel22.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel22.setText("Pay Date");
        jLabel22.setName("lblOPPayDate");
        jpanOPOrderDetails.add(jLabel22);
        jLabel22.setBounds(410, 310, 100, 20);

        editPayed.setFont(new java.awt.Font("Tahoma", 0, 13));
        editPayed.setHorizontalAlignment(javax.swing.JTextField.RIGHT);
        editPayed.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                OrdersPlacement.this.focusLost(evt);
            }
        });
        editPayed.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                OrdersPlacement.this.mouseClicked(evt);
            }
        });

        jpanOPOrderDetails.add(editPayed);
        editPayed.setBounds(510, 330, 60, 21);

        jLabel23.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel23.setText("Payed");
        jLabel23.setName("lblOPPayed");
        jpanOPOrderDetails.add(jLabel23);
        jLabel23.setBounds(510, 310, 60, 20);

        chkbAltAddress.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        chkbAltAddress.setText("Use alternate address");
        chkbAltAddress.setName("chkAltAddress");
        chkbAltAddress.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                OrdersPlacement.this.stateChanged(evt);
            }
        });

        jpanOPOrderDetails.add(chkbAltAddress);
        chkbAltAddress.setBounds(10, 287, 180, 20);

        btnSet.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSet.setText("Set Address");
        btnSet.setEnabled(false);
        btnSet.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSet.setName("btnOPSetAltAddress");
        btnSet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(btnSet);
        btnSet.setBounds(190, 285, 160, 26);

        editNewStock.setFont(new java.awt.Font("Tahoma", 0, 13));
        editNewStock.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                OrdersPlacement.this.keyPressed(evt);
            }
        });

        jpanOPOrderDetails.add(editNewStock);
        editNewStock.setBounds(10, 230, 100, 21);

        jLabel24.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel24.setText("Stock");
        jLabel24.setName("lblOPStock");
        jpanOPOrderDetails.add(jLabel24);
        jLabel24.setBounds(10, 210, 100, 18);

        btnSelectStock.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSelectStock.setText("?");
        btnSelectStock.setToolTipText("Search stock");
        btnSelectStock.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSelectStock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(btnSelectStock);
        btnSelectStock.setBounds(120, 230, 20, 23);

        editCount.setFont(new java.awt.Font("Tahoma", 0, 13));
        editCount.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(editCount);
        editCount.setBounds(150, 230, 40, 21);

        jLabel25.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel25.setText("Count");
        jLabel25.setName("lblOPCount");
        jpanOPOrderDetails.add(jLabel25);
        jLabel25.setBounds(150, 210, 110, 18);

        btnAddStock.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnAddStock.setText("Add");
        btnAddStock.setEnabled(false);
        btnAddStock.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnAddStock.setName("btnOPAddProduct");
        btnAddStock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(btnAddStock);
        btnAddStock.setBounds(200, 227, 70, 26);

        btnPay.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnPay.setText("Pay");
        btnPay.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnPay.setName("btnOPPay");
        btnPay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(btnPay);
        btnPay.setBounds(345, 330, 60, 26);

        btnSearchOrders.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSearchOrders.setText("?");
        btnSearchOrders.setToolTipText("Search order");
        btnSearchOrders.setMargin(new java.awt.Insets(0, 0, 0, 0));
        btnSearchOrders.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrderDetails.add(btnSearchOrders);
        btnSearchOrders.setBounds(160, 330, 20, 26);

        lblStockName.setFont(new java.awt.Font("MS Sans Serif", 1, 12));
        lblStockName.setText("Stock not selected!");
        lblStockName.setName("lblOPStockNotSel");
        jpanOPOrderDetails.add(lblStockName);
        lblStockName.setBounds(11, 254, 250, 16);

        lblInvoice.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblInvoice.setText("Invoice No.");
        lblInvoice.setName("lblOPInvNo");
        jpanOPOrderDetails.add(lblInvoice);
        lblInvoice.setBounds(220, 20, 110, 18);

        editInvoiceNum.setEditable(false);
        editInvoiceNum.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editInvoiceNum.setEnabled(false);
        editInvoiceNum.setPreferredSize(new java.awt.Dimension(62, 21));
        jpanOPOrderDetails.add(editInvoiceNum);
        editInvoiceNum.setBounds(220, 40, 100, 21);

        jPanel8.add(jpanOPOrderDetails);
        jpanOPOrderDetails.setBounds(10, 10, 580, 370);

        jpanOPOrders.setLayout(null);

        jpanOPOrders.setBorder(new javax.swing.border.TitledBorder(null, "Orders", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        jpanOPOrders.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jScrollPane7.setFont(new java.awt.Font("Tahoma", 1, 13));
        tblOrders.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "Order No", "Date", "Doc. Type", "Netto", "Total", "Payed"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tblOrders.setEnabled(false);
        tblOrders.setName("tblOrders");
        tblOrders.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                OrdersPlacement.this.mouseClicked(evt);
            }
        });

        jScrollPane7.setViewportView(tblOrders);

        jpanOPOrders.add(jScrollPane7);
        jScrollPane7.setBounds(10, 20, 560, 150);

        btnSendLetter.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSendLetter.setText("Send Letter");
        btnSendLetter.setName("btnOPSendLetter");
        btnSendLetter.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrders.add(btnSendLetter);
        btnSendLetter.setBounds(215, 180, 170, 26);

        btnMacros.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnMacros.setText("Macros...");
        btnMacros.setName("btnOPMacros");
        btnMacros.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jpanOPOrders.add(btnMacros);
        btnMacros.setBounds(60, 180, 130, 26);

        btnCreditNote.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnCreditNote.setText("Credit Note");
        btnCreditNote.setEnabled(false);
        btnCreditNote.setName("btnOPCreditNote");
        btnCreditNote.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCreditNoteActionPerformed(evt);
            }
        });

        jpanOPOrders.add(btnCreditNote);
        btnCreditNote.setBounds(410, 180, 110, 26);

        jPanel8.add(jpanOPOrders);
        jpanOPOrders.setBounds(10, 380, 580, 220);

        tbpOrders.addTab("tab1", jPanel8);

        jPanel9.setLayout(null);

        edpInvoice.setText("Macro 1\n\nand/or\n\nMacro 2\n\nand/or\n\nMacro 3\n\n...\n\n\nInvoice Data");
        jScrollPane4.setViewportView(edpInvoice);

        jPanel9.add(jScrollPane4);
        jScrollPane4.setBounds(10, 10, 530, 550);

        bynPrintLabelInvoice.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        bynPrintLabelInvoice.setText("Print Label");
        bynPrintLabelInvoice.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bynPrintLabelInvoiceActionPerformed(evt);
            }
        });

        jPanel9.add(bynPrintLabelInvoice);
        bynPrintLabelInvoice.setBounds(190, 575, 140, 26);

        btnPrint.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnPrint.setText("Print ...");
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OrdersPlacement.this.actionPerformed(evt);
            }
        });

        jPanel9.add(btnPrint);
        btnPrint.setBounds(50, 575, 100, 26);

        btnChangeMacro.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnChangeMacro.setText("Change macro");
        btnChangeMacro.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnChangeMacroActionPerformed(evt);
            }
        });

        jPanel9.add(btnChangeMacro);
        btnChangeMacro.setBounds(370, 575, 130, 27);

        tbpOrders.addTab("tab2", jPanel9);

        jPanel5.setLayout(null);

        edpPackings.setText("Macro 1\n\nand/or\n\nMacro 2\n\nand/or\n\nMacro 3\n\n...\n\n\nInvoice Data");
        jScrollPane8.setViewportView(edpPackings);

        jPanel5.add(jScrollPane8);
        jScrollPane8.setBounds(10, 10, 530, 550);

        bynPrintLabelPList.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        bynPrintLabelPList.setText("Print Label");
        bynPrintLabelPList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bynPrintLabelPListActionPerformed(evt);
            }
        });

        jPanel5.add(bynPrintLabelPList);
        bynPrintLabelPList.setBounds(280, 575, 140, 26);

        btnPrintPList.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnPrintPList.setText("Print ...");
        btnPrintPList.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnPrintPListActionPerformed(evt);
            }
        });

        jPanel5.add(btnPrintPList);
        btnPrintPList.setBounds(140, 575, 100, 26);

        tbpOrders.addTab("tab3", jPanel5);

        getContentPane().add(tbpOrders);
        tbpOrders.setBounds(370, 10, 600, 640);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-983)/2, (screenSize.height-673)/2, 983, 673);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void btnPrintPListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnPrintPListActionPerformed
        
        printInvoice();
    }//GEN-LAST:event_btnPrintPListActionPerformed
    
    private void bynPrintLabelPListActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bynPrintLabelPListActionPerformed
        printLabel(false);
    }//GEN-LAST:event_bynPrintLabelPListActionPerformed
    
    private void bynPrintLabelInvoiceActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bynPrintLabelInvoiceActionPerformed
        printLabel(true);
    }//GEN-LAST:event_bynPrintLabelInvoiceActionPerformed
    
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        m_menuItem.setEnabled(true);
    }//GEN-LAST:event_formWindowClosed
    
    private void editProv2PersFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_editProv2PersFocusLost
        
    }//GEN-LAST:event_editProv2PersFocusLost
    
    private void editProv2PersActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editProv2PersActionPerformed
        
    }//GEN-LAST:event_editProv2PersActionPerformed
    
    private void editProv1PersFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_editProv1PersFocusLost
        
    }//GEN-LAST:event_editProv1PersFocusLost
    
    private void editProv1PersActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editProv1PersActionPerformed
        
    }//GEN-LAST:event_editProv1PersActionPerformed
    
    private void btnChangeMacroActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnChangeMacroActionPerformed
        try{
            MacroChangeDialog changeMacro = new MacroChangeDialog( new JFrame(), true, editDocNo.getText() );
            changeMacro.show();
        } catch(Exception e){
            logErrToFile(e);
        }
        generateInvoice();
    }//GEN-LAST:event_btnChangeMacroActionPerformed
    
    private void comboDocTypeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_comboDocTypeActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_comboDocTypeActionPerformed
    
    
    private void btnCreditNoteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCreditNoteActionPerformed
        // TODO add your handling code here:
        if(editUIN.getText().equals("")){
            JOptionPane.showMessageDialog(null,"Please select patient to asociate with this credit note!");
            return;
        }
        
        if(!dateVerifier.DATE_Verifier((JComponent)editOrderDate) || editOrderDate.getText().length()==0){
            JOptionPane.showMessageDialog(null,"Please enter valid credit note date!");
            return;
        }
        
        if(!strVerifier.Universal_String_Verifier((JComponent)editAlternateName)){
            JOptionPane.showMessageDialog(null,"Please enter valid credit note date!");
            return;
        }
        int nRowCount = tblOrderGoods.getRowCount();
        if(nRowCount < 1){
            JOptionPane.showMessageDialog(null,"You have to add at least one stock for this credit note!");
            return;
        }
        
        try{
            checkProvs();
        } catch(Exception e){
            JOptionPane.showMessageDialog(null,e.getMessage());
            return;
        }
        
        String strAlternateAddress = "NULL";
        try {
            String sql = "select * from vorgang where invoiceid=" + editDocNo.getText();
            Connection connDB = SharedUtils.DBConnect( SharedUtils.connectionString,true );
            Statement stmt = connDB.createStatement();
            ResultSet rs = stmt.executeQuery(sql);
            if(rs.next()) {
                JOptionPane.showMessageDialog(null,"Credit note for this order already exists!");
                rs.close();
                stmt.close();
                return;
            }
            rs.close();
            stmt.close();
        } catch(Exception sqle){
            logErrToFile(sqle);
            SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
            return;
        }
        
        int result = JOptionPane.showConfirmDialog((Component)this,"You are about to issue Kredit Note to Order No " + editDocNo.getText() + ", please confirm!Do you want to continue?","Confirm Place Order",JOptionPane.YES_NO_OPTION);
        if( result != JOptionPane.YES_OPTION)
            return;
        
        String strUIN = editUIN.getText();
        String strDiscount = editDiscount.getText();
        String strVat = String.valueOf(fVat);
        String strAltName = editAlternateName.getText();
        String strCountry = editCountry.getText();
        String strCity  = editCity.getText();
        String strCode = editCode.getText();
        String strStreet = editStreet.getText();
        
        String strProv1Idnt = (String) editProv1UIN.getText();
        String strProv1Pers = editProv1Pers.getText();
        strProv1Pers = BigDec.scaledRoundHalfUp(strProv1Pers,2);
        
        String strProv2Idnt = (String)editProv2UIN.getText();
        String strProv2Pers = editProv2Pers.getText();
        strProv2Pers = BigDec.scaledRoundHalfUp(strProv2Pers,2);
        
        Calendar cal = Calendar.getInstance();
        String strOrderDate = cal.get( Calendar.DATE ) + "." +
                ( cal.get( Calendar.MONTH ) + 1 ) + "." + cal.get( Calendar.YEAR );
        String dateFields[] = strOrderDate.split("\\.");
        strOrderDate = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        strOrderDate = strOrderDate + " " + SharedUtils.getCurrentTimeString();
        int nTypeID = ((ComboDataModel)comboDocType.getModel()).getCObjectAt(comboDocType.getSelectedIndex()).nItemDBKey;
        String strTypeID = String.valueOf(nTypeID);
        String strDocType = (String)comboDocType.getSelectedItem();
        String strOperIdnt = String.valueOf(SharedUtils.nUserID);
        
        String strNetto = (String)tblSums.getModel().getValueAt(NETTO_INDEX,VALUE_COL_INDEX);
        String strTotal = (String)tblSums.getModel().getValueAt(TOTAL_INDEX,VALUE_COL_INDEX);
        String strPorto = (String)tblSums.getModel().getValueAt(PORTO_INDEX,VALUE_COL_INDEX);
        
        String strPay = "0.0";
        String strPayDate = SharedUtils.getCurrentOnlyDateSQLFormat();
        String orderNo = editDocNo.getText();
        String strProv3Idnt = SharedUtils.executeSqlScalar("select prv3_idnt from vorgang where v_nr=" + orderNo );
        String strProv3Pers = SharedUtils.executeSqlScalar("select prv3_comm from vorgang where v_nr=" + orderNo );
        strProv3Pers = BigDec.scaledRoundHalfUp(strProv3Pers,2);
        
        String macro = SharedUtils.getMacro( "macro" + SharedUtils.activeMacro );
        if( macro == null )
            macro = "";
        String docLastName = SharedUtils.executeSqlScalar("select prsn_lnam from base_prsn where prsn_key=" + strProv1Idnt );
        if( docLastName == null )
            docLastName = "";
        macro = macro.replaceAll("<DOCTOR>", docLastName );
        macro = macro.replaceAll("<USER>", SharedUtils.strUserAbrv );
        macro = macro.replaceAll("<DATE>", editOrderDate.getText() );
        if( SharedUtils.discountSum >= 0 )
            macro = macro.replaceAll("<PORTO_DISCOUNT>",
                    SharedUtils.formatFloat(  "" + SharedUtils.discountSum, '.' ) );
        else
            macro = macro.replaceAll("<PORTO_DISCOUNT>", "" );
        
        
        Connection connDB = null;
        try{
            connDB = SharedUtils.getConnection();//SharedUtils.DBConnect(SharedUtils.connectionString,true);
            connDB.setAutoCommit(false);
            String strSQL="";
            strSQL = "INSERT INTO VORGANG " +
                    " (patn_idnt,patn_dscn,prv1_idnt,prv1_comm,prv2_idnt, " +
                    " prv2_comm,invc_addr,oper_idnt,doc_type_idnt,invc_date, " +
                    " pay_date,pay_sum,neto_sum,vat_pers,totl_sum,altr_name, " +
                    " patn_cntr,patn_city,patn_code,patn_strt,invc_prto, " +
                    " invoiceid,prv3_idnt,prv3_comm,macro1text,letter1date, " +
                    " letter2date,letter3date, vatcode, cntr_code  ) " +
                    " VALUES(" + strUIN + "," +
                    strDiscount + "," + strProv1Idnt + "," + strProv1Pers  + "," + strProv2Idnt + "," + strProv2Pers + "," +
                    strAlternateAddress + "," + strOperIdnt + "," + "2" + ",'" + strOrderDate +
                    "','" + strPayDate + "'," + strPay + "," + strNetto +
                    "," + strVat + "," + strTotal + ",'" + strAltName +
                    "','" + strCountry + "','" + strCity +
                    "','" + strCode + "','" + strStreet + "'," + strPorto + "," + orderNo +
                    ", " + strProv3Idnt + "," + strProv3Pers + " ,'" + macro +
                    "',null,null,null," + ctdata.cntr_vat_code() + "," + ctdata.cntr_code() + ")";
            
            Statement stm = connDB.createStatement();
            int nResult = stm.executeUpdate(strSQL);
            if(nResult != 1){
                JOptionPane.showMessageDialog(null,"Error while trying to register new Credit Note in the system!Operation canceled!");
                stm.close();
                connDB.rollback();
                return;
            }
            stm.close();
            
            String strInvoiceID = SharedUtils.getLastInsertedID(connDB);
            Vector data =  ((UniversalTableModel)tblOrderGoods.getModel()).getDataVector();
            for( int i = 0; i < nRowCount; i++ ) {
                UniversalTableRow row = (UniversalTableRow)data.get(i);
                String strCount = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_COUNT_INDEX);
                String strUnit = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_UNIT_INDEX);
                String strSum = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_SUM_INDEX);
                String strStockKey = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_KEY_INDEX);
                String campId = "null";
                if( row.size() - 1 >= CAMPAIGN_ID_INDEX ) {
                    campId = (String)row.getRowElement(CAMPAIGN_ID_INDEX);
                }
                strSQL = "INSERT INTO POSITION" +
                        " (v_nr,a_nr,p_pos,p_menge,nstk_idnt,unit_pric,sum_pric,campaign_id)" +
                        " VALUES(" + strInvoiceID + ",NULL," + (i+1) + "," + strCount +
                        ", " + strStockKey + ", " + strUnit + ", " + strSum + "," + campId + ")";
                stm = connDB.createStatement();
                nResult = stm.executeUpdate(strSQL);
                if(nResult != 1) {
                    JOptionPane.showMessageDialog(null,"Error while trying to register Credit Note in the system!Operation canceled!");
                    stm.close();
                    connDB.rollback();
                    return;
                }
                stm.close();
            }
            
            connDB.commit();
            connDB.setAutoCommit(true);
            editDocNo.setText(strInvoiceID);
            loadOrderInfo(strInvoiceID);
            loadClientOrders(editUIN.getText());
            int lastIndex = tblOrders.getModel().getRowCount() - 1;
            tblOrders.setRowSelectionInterval( lastIndex,lastIndex );
            btnCreditNote.setEnabled(false);
            ((ComboDataModel)comboDocType.getModel()).selectIndexByKey(2);
            JOptionPane.showMessageDialog(null,"New Credit Note added successfully!");
        }catch(Exception e){
            logErrToFile(e);
            SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
            e.printStackTrace();
        } finally {
            try {
                if( connDB != null )
                    connDB.close();
            } catch(Exception e){}
        }
    }//GEN-LAST:event_btnCreditNoteActionPerformed
    
    private void chkbCanPurchaseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_chkbCanPurchaseActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_chkbCanPurchaseActionPerformed
    
    private void editDiscountActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editDiscountActionPerformed
        try {
            BigDecimal discount = new BigDecimal(BigDec.scaledRoundHalfUp(editDiscount.getText(),2));
            if( discount.doubleValue() > 100 ) {
                discount = new BigDecimal(100.00);
                editDiscount.setText(discount.toString());
            }
            if( discount.doubleValue() > 0 ) {
                tblSums.getModel().setValueAt(discount.toString(), DISCOUNT_INDEX, VALUE_COL_INDEX);
                calculateSums(false);
            }
        } catch(Exception e) {
            logErrToFile(e);
        }
    }//GEN-LAST:event_editDiscountActionPerformed
    
    private void focusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_focusLost
        if( evt.getSource() == editPayed){
            editPayed.setHorizontalAlignment(JLabel.RIGHT);
            try{
                BigDecimal bgdPayed = new BigDecimal(editPayed.getText());
                bgdPayed = bgdPayed.setScale(2,BigDecimal.ROUND_HALF_UP);
                editPayed.setText(bgdPayed.toString());
            }catch( NumberFormatException nfe){
                logErrToFile(nfe);
            }
        }
    }//GEN-LAST:event_focusLost
    
    public void valueChanged(ListSelectionEvent e) {
        /*
        if(e.getSource()==tblOrders.getSelectionModel())
        {
         
        }
         */
    }
    
    private void mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mouseClicked
        if(evt.getSource() == tblOrderGoods){
            if ((evt.getModifiers() & InputEvent.BUTTON3_MASK) != 0) {
                int nRow = tblOrderGoods.rowAtPoint(evt.getPoint());
                //String strEventStatus = (String)((UniversalTableRow)((UniversalTableModel)tblActions.getModel()).getRowObject(nRow)).getRowElement(EVENTTEXT_INDEX);
                if(nRow < 0)
                    return;
                tblOrderGoods.getSelectionModel().setSelectionInterval( nRow,nRow ) ;
                jpmOrders.show(evt.getComponent(),evt.getX(),evt.getY());
                
            }
        } else if(evt.getSource() == tblOrders){
            if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
                if(tblOrders.getSelectedRow()>=0 && !this.bControlsEnabled){
                    int row = tblOrders.getSelectedRow();
                    String strOrderIdnt = (String)tblOrders.getModel().getValueAt(row,0);                    
                    loadOrderInfo(strOrderIdnt);
                    //fix ait
                    if( ((ComboDataModel)comboDocType.getModel()).getCObjectAt(comboDocType.getSelectedIndex()).nItemDBKey == 1 )
                        btnCreditNote.setEnabled(true);
                    else
                        btnCreditNote.setEnabled(false);                                        
                }
            }
        } else if(evt.getSource() == editPayed){
            if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 ) {
                editPayed.setHorizontalAlignment(JLabel.LEFT);
                try{
                    BigDecimal bgdPayed = new BigDecimal(editPayed.getText());
                    bgdPayed.setScale(2,BigDecimal.ROUND_HALF_UP);
                    editPayed.setText(bgdPayed.toString());
                }catch( NumberFormatException nfe){
                    logErrToFile(nfe);
                }
            }
        }
    }//GEN-LAST:event_mouseClicked
    public void tableChanged(TableModelEvent tev){
        if(tev.getSource() == tblOrderGoods.getModel()){
            final int row = tev.getFirstRow();
            final int col = tev.getColumn();
            if(col != STOCK_COUNT_INDEX)
                return;
            
            String strCount = (String)tblOrderGoods.getValueAt(row, col);
            String strUnitSum = (String)tblOrderGoods.getValueAt(row, STOCK_UNIT_INDEX);
            BigDecimal bgdCount = new BigDecimal(strCount);
            BigDecimal bgdUnit = new BigDecimal(strUnitSum);
            BigDecimal bgdSum = bgdUnit.multiply(bgdCount);
            final String strResult = bgdSum.toString();
            SwingUtilities.invokeLater(new Runnable(){
                public void run() {
                    tblOrderGoods.setValueAt(strResult, row, STOCK_SUM_INDEX);
                    try{
                        calculateSums(true);
                    } catch(Exception e){
                        JOptionPane.showMessageDialog(null,"Warning: System detect that some fields has no absolutely correct data!\nPlease validate sums calculations!", "Warning", JOptionPane.WARNING_MESSAGE, null);
                    }
                }
            });
        }
        if(tev.getSource() == tblSums.getModel()){
            final int row = tev.getFirstRow();
            final int col = tev.getColumn();
            if(col != VALUE_COL_INDEX || row != PORTO_INDEX)
                return;
            
            String strPorto = (String)tblSums.getValueAt(row, col);
            this.dPorto = Double.parseDouble(strPorto);
                        
            SwingUtilities.invokeLater(new Runnable(){
                public void run() {
                    try{                       
                        calculateSums(false);
                    } catch(Exception e){
                        JOptionPane.showMessageDialog(null,"Warning: System detect that some fields has no absolutely correct data!\nPlease validate sums calculations!", "Warning", JOptionPane.WARNING_MESSAGE, null);
                    }
                }
            });
        }
    }
    private void keyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyPressed
        if(evt.getSource() == editNewStock){
            SwingUtilities.invokeLater(new Runnable(){
                public void run() {
                    editNewStock.updateUI();
                    String strSearchText = editNewStock.getText();
                    editNewStock.setCaretPosition(strSearchText.length());
                    if(strSearchText.equals("")){
                        lblStockName.setText("Stock not selected!");
                        btnAddStock.setEnabled(false);
                        vecStockResults.removeAllElements();
                        return;
                    }
                    String strSQL = " SELECT STCK_NAME, STCK_ABRV, STCK_KEY " +
                            " FROM BASE_STCK " +
                            " WHERE STCK_ABRV = '" + strSearchText +
                            "' AND STOCKGROUP < 10 " +
                            " ORDER BY STCK_NAME";
                    Statement stm;
                    final ResultSet rsDBData;
                    try{
                        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
                        stm = connDB.createStatement();
                        rsDBData=stm.executeQuery(strSQL);
                        boolean bMore = rsDBData.next();
                        if(bMore){
                            final String strStockName = rsDBData.getString(1);
                            final String strStockAbrv = rsDBData.getString(2);
                            String strStockKey = rsDBData.getString(3);
                            
                            vecStockResults.removeAllElements();
                            vecStockResults.addElement(strStockAbrv);
                            vecStockResults.addElement(strStockName);
                            vecStockResults.addElement(strStockKey);
                            lblStockName.setText(strStockName);
                            btnAddStock.setEnabled(true);
                            return;
                        } else{
                            lblStockName.setText("No such stock exists!");
                            btnAddStock.setEnabled(false);
                            vecStockResults.removeAllElements();
                        }
                        rsDBData.close();
                        stm.close();
                    }catch(SQLException sqle){
                        logErrToFile(sqle);
                        SharedUtils.handleError(SharedUtils.GENERAL_DB_ERROR);
                    }
                    
                }
            });
            
            
        }
    }//GEN-LAST:event_keyPressed
    
    private void mousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed
        if( evt.getSource() == tblProvs ){
            if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
                int nRow = tblProvs.rowAtPoint(evt.getPoint());
                String strProv1 = (String)((UniversalTableRow)((UniversalTableModel)tblProvs.getModel()).getRowObject(nRow)).getRowElement(PROV1_NAME_INDEX);
                String strProv2 = (String)((UniversalTableRow)((UniversalTableModel)tblProvs.getModel()).getRowObject(nRow)).getRowElement(PROV2_NAME_INDEX);
                tblProvs.setVisible(false);
                scrProvs.setVisible(false);
                editProv1Pers.setText(BigDec.scaledRoundHalfUp(strProv1,2));
                editProv2Pers.setText(BigDec.scaledRoundHalfUp(strProv2,2));
                editProv1Pers.setVisible(true);
                editProv2Pers.setVisible(true);
                lblProv1.setVisible(true);
                lblProv2.setVisible(true);
                btnDoctors.setVisible(true);
                btnDealers.setVisible(true);
            }
        }
    }//GEN-LAST:event_mousePressed
    
    private void stateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_stateChanged
        if(evt.getSource() == chkbAltAddress){
            if( chkbAltAddress.isSelected() ){
                btnSet.setEnabled(true);
            } else{
                btnSet.setEnabled(false);
            }
        } else if(evt.getSource() == tbpOrders){
            
            if(tbpOrders.getSelectedIndex()==1 && !editDocNo.getText().trim().equals("")){
                generateInvoice();
                edpInvoice.scrollRectToVisible(new java.awt.Rectangle(0,0,0,0));
            } else if(tbpOrders.getSelectedIndex()==2 && !editDocNo.getText().trim().equals("")){
                generatePackings();
                edpPackings.scrollRectToVisible(new java.awt.Rectangle(0,0,0,0));
            }
        }
    }//GEN-LAST:event_stateChanged
    
    private synchronized void generatePackings() {
        String strAppeal = editAppeal.getText();
        String strDate = editOrderDate.getText();
        String strOrderNo = editDocNo.getText();
        String strClientIdnt = editUIN.getText();
        
        int printerRows = 16;
        int pageCount = 1;
        int rowsPerPage = 21;
        
        String userAbbrv = SharedUtils.executeSqlScalar( "select base_user.user_abrv " +
                " from base_user,vorgang " +
                " where vorgang.v_nr=" + strOrderNo +
                " and vorgang.oper_idnt=base_user.user_key" );
        String macro = "Ihre Bestellung von " + editOrderDate.getText() +
                " " + userAbbrv +"<br>";
        
        String altName = editAlternateName.getText();
        if( altName != null && !altName.equals("") )
            altName += "<br>";
        
        // check if the diffrence between current date and order date is 1 day
        long currentTime = Calendar.getInstance().getTimeInMillis();
        long orderTime = 0;
        Connection conn = null;
        try {
            String sql = "select invc_date from vorgang where v_nr=" + strOrderNo;
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            rs.next();
            orderTime = rs.getTimestamp(1).getTime();
        } catch( SQLException e ) {
            logErrToFile(e);
            return;
        } finally {
            SharedUtils.closeConnection(conn);
        }
        long dif = currentTime - orderTime;
        boolean enableEdit = dif > 0 && dif < 24*60*60*1000;//1 day
        btnChangeMacro.setEnabled( enableEdit );
        String altAddress = this.dlgAlternateAddress.getAddress();
        if( altAddress == null )
            altAddress = "";
        altAddress = altAddress.replaceAll( "\n", "<br>" );
        String strHtml = "<html><body><table width='100%' border='0' style=\"FONT-SIZE: 12pt\">" +
                "<tr>" +
                "<td align='center' colspan='2'>" +
                "<br><font size='6'><b>VITA NATURA</b></font>" +
                "<br><font size='3'><b>Internationaler Apothekenservice</b></font></td></tr>" +
                "<tr>" +
                "<td align='center' colspan='2'><br></td></tr>" +
                "<tr>" +
                "<td width='50%' align='left'>";
        strHtml += altAddress;
        strHtml += "</td><td><b>KEINE RECHNUNG</b></td></tr><tr><td colspan='2' align='right'><br><font face='code 128ab hr' size='22'>" + SharedUtils.generateBarcodeString(strOrderNo) + "</font><br></td></tr>";
        strHtml += "<tr><td align='left' id='macro1'>" + macro + "</td><td align='right'></td></tr>" +
                "<tr><td align='left'></td><td align='right'></td></tr></table>";
        
        strHtml += "<table border='1' width='100%' cellspacing='1' cellpadding='1' bordercolor='#000000'><tr><td>";
        strHtml += "<table border='0' width='100%'><tr><td align='left'>Datum:&nbsp;&nbsp;<b>" + strDate +
                "</b></td><td align='center'>Lieferschein Nr.: <b>" + strOrderNo +
                "</b></td><td align='right'>Kunden Nr:&nbsp;&nbsp;<b>" + strClientIdnt + "</b></td></tr></table>";
        strHtml += "</td></tr></table>";
        ////////////////////////////////////////////////////////////////////////
        strHtml += "<br><table  width='100%' cellspacing='0' cellpadding='0' style=\"FONT-SIZE: 12pt\"><tr>";
        strHtml += "<td><b>Artikel</b></td><td><b>Bezeichnung</b></td><td align='right'><b>Anzahl</b></td></tr>";
        int nRowCount = tblOrderGoods.getRowCount();
        
        ArrayList artilcles = new ArrayList();
        
        for(int i=0; i<nRowCount; i++){
            String strBarcode = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_CODE_INDEX);
            String strStockName = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_NAME_INDEX);
            String strCount = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_COUNT_INDEX);
            
            final Article article = new Article(strBarcode, strStockName, "", strCount, "");
            artilcles.add(article);
            
            strHtml += "<tr><td>" + strBarcode + "</td><td>" + strStockName + "</td><td align='right'>" + strCount + "</td></tr>";
            printerRows ++;
        }
        
        strHtml += "</table><table  width='100%'><tr><td>&nbsp;</td></tr></table>";
        strHtml += "<table  width='100%'><tr><td>&nbsp;</td></tr></table>";
        
        edpPackings.setContentType("text/html");
        edpPackings.setText(strHtml);
        //System.out.println(strHtml);
        
        String firstName = "";
        String lastName = "";
        String salutation = editAppeal.getText();
        String street = "";
        String postalCode = "";
        String town = "";
        String country = "";
        String altAddressCaption = "";
        String invAltAddress = this.dlgAlternateAddress.getAddress();
        
        String invmacro = "Ihre Bestellung von " + editOrderDate.getText() +
                " " + userAbbrv +"\n";
        
        String invAltName = "";
        
        String date = editOrderDate.getText();
        String invoiceNumber = editDocNo.getText();
        String invoiceVersand = "";
        String invoiceDiscount = "";
        String invoiceSum = "";
        String invoiceVat = "";
        String invoiceTotalSum = "";
        String invoiceVatPerc = "";
        String customerId = editUIN.getText();
        String invoiceBarcode = SharedUtils.generateBarcodeString(strOrderNo);
        String invoiceDicountPerc = "";
        
        try{
            Customer customer = new Customer(firstName, lastName, salutation, street, postalCode, town, country,
                    altAddressCaption, invAltAddress, "", invAltName, invmacro);
            Invoice packing = new Invoice(customer, date, invoiceNumber, invoiceVersand, invoiceDiscount, invoiceSum,
                    invoiceVat, invoiceTotalSum, invoiceVatPerc, customerId, invoiceBarcode, invoiceDicountPerc);
            packing.setArticles(artilcles);
            InvoiceTableModel data = new InvoiceTableModel();
            data.addInvoice(packing);
            spUtils = new SimplePrintUtils(data, "invoice/packing.xml", "Packing");
        } catch(Exception e){
            e.printStackTrace();
            
        }
    }
    
    private synchronized void generateInvoice() {
        String strAppeal = editAppeal.getText();
        String strFirstName = editFirstName.getText();
        String strLastName = editSurname.getText();
        String strStreet = editStreet.getText();
        String strCode = editCode.getText();
        String strCity = editCity.getText();
        String strDate = editOrderDate.getText();
        String strOrderNo = editDocNo.getText();
        String strClientIdnt = editUIN.getText();
        String strDiscount = (String)tblSums.getModel().getValueAt(DISCOUNT_INDEX,VALUE_COL_INDEX);
        
        int printerRows = 23;
        int pageCount = 1;
        int rowsPerPage = 38;
        
        String macro = SharedUtils.executeSqlScalar( "select macro1text from vorgang where v_nr=" + strOrderNo );
        String invoiceMacro = macro;
        if( macro == null )
            macro = "";
        if(invoiceMacro == null)
            invoiceMacro = " ";
        
        
        macro = macro.replaceAll("\n", "<br>" );
        macro = macro.replaceAll("\r\n", "<br>" );
        macro = macro.replaceAll(" ", "&nbsp;" );
        String userAbbrv = SharedUtils.executeSqlScalar( "select base_user.user_abrv " +
                " from base_user,vorgang " +
                " where vorgang.v_nr=" + strOrderNo +
                " and vorgang.oper_idnt=base_user.user_key" );
        
        String altName = editAlternateName.getText();
        
        
        if( altName != null && !altName.equals("") ){
            altName += "<br>";
        }
        // check if the diffrence between current date and order date is 1 day
        long currentTime = Calendar.getInstance().getTimeInMillis();
        long orderTime = 0;
        Connection conn = null;
        try {
            String sql = "select invc_date from vorgang where v_nr=" + strOrderNo;
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            rs.next();
            orderTime = rs.getTimestamp(1).getTime();
        } catch( SQLException e ) {
            logErrToFile(e);
            return;
        } finally {
            SharedUtils.closeConnection(conn);
        }
        long dif = currentTime - orderTime;
        boolean enableEdit = dif > 0 && dif < 24*60*60*1000;//1 day
        btnChangeMacro.setEnabled( enableEdit );
        String altAddress = this.dlgAlternateAddress.getAddress();
        
        if( altAddress == null ) {
            altAddress = "";
            
        }
        altAddress = altAddress.replaceAll( "\n", "<br>" );
        if( !altAddress.trim().equals("") ) {
            altAddress = "<b>Lieferranschrift:</b><br>" + altAddress;
        }
        String address = strStreet  + "<br>" + c_name + " - " + strCode + " " + strCity;
        
        String clientNum = "<br>";
//        boolean pmore = false;
        if( chkVatFree.isSelected() && !editCLCode.getText().trim().equals("") )
            clientNum = "<br>Ihre MwSt: " + editCLCode.getText();
        
        String strHtml = "<html>" +
                "<body>" +
                "<table width='100%' border='0' style=\"FONT-SIZE: 12pt\">" +
                "<tr>" +
                "<td align='center' colspan='2'>" +
                "<br><font size='6'><b>VITA NATURA</b></font>" +
                "<br><font size='3'><b>Internationaler Apothekenservice</b></font></td></tr>" +
                "<tr>" +
                "<td align='center' colspan='2'><br></td></tr>" +
                "<tr>" +
                "<td width='50%' align='left'>";
        strHtml += strAppeal + "<br>" + strFirstName + " " + strLastName + "<br>" + altName;
        strHtml += address + clientNum;
        strHtml += "</td><td>" + altAddress + "</td></tr><tr><td colspan='2' align='right'><br><font face='code 128ab hr' size='22'>" + SharedUtils.generateBarcodeString(strOrderNo) + "</font><br></td></tr>";
        strHtml += "<tr><td colspan='2' align='left' id='macro1' style=\"FONT-SIZE: 11pt\">" + macro + "</tr>" +
                "<tr><td colspan='2' align='left'  style=\"FONT-SIZE: 11pt\"><br>Ihr Vita Natura Team.</tr></table>";
        
        //////////////////////////////////////////////////////////////////////
        strHtml += "<table border='1' width='100%' cellspacing='0' cellpadding='1' bordercolor='#808080'  style=\"FONT-SIZE: 11pt\"><tr><td>";
        strHtml += "<table border='0' width='100%'><tr><td align='left'>Datum:&nbsp;&nbsp;<b>" + strDate +
                "</b></td><td align='center'>Rechnung Nr.: <b>" + strOrderNo +
                "</b></td><td align='right'>Kunden Nr:&nbsp;&nbsp;<b>" + strClientIdnt + "</b></td></tr></table>";
        strHtml += "</td></tr></table>";
        ///////////////////////////////////////////////////////////////////////
        
        strHtml += "<table border='0' width='100%' cellspacing='0' cellpadding='0' style=\"FONT-SIZE: 11pt\">";
        strHtml += "<tr><td><b>Artikel</b></td><td><b>Bezeichnung</b></td><td align='right'><b>Anzahl</b></td><td align='right'><b>E-Preis</b></td><td align='right'><b>G-Preis</b></td></tr>";
        String strPorto = (String)tblSums.getModel().getValueAt(PORTO_INDEX,VALUE_COL_INDEX);
        BigDecimal bdmPorto = new BigDecimal(strPorto);
        if( !strPorto.equals("") )
            strPorto = "" + ( ((double)Math.round( Double.parseDouble(strPorto) * 100 )) / 100);
        int nRowCount = tblOrderGoods.getRowCount();
        int macCount = brCount(macro);
        
        printerRows+=brCount(macro);
        
        ArrayList artilcles = new ArrayList();
        
        for(int i=0; i<nRowCount; i++){
            String strBarcode = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_CODE_INDEX);
            String strStockName = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_NAME_INDEX);
            String strCount = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_COUNT_INDEX);
            String strUnit = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_UNIT_INDEX);
            String strSum = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_SUM_INDEX);
            
            final Article article = new Article(strBarcode, strStockName, strUnit, strCount, strSum);
            artilcles.add(article);
            
            strHtml += "<tr><td>" + strBarcode + "</td><td>" + strStockName + "</td><td align='right'>" + strCount + "</td>";
            strHtml += "<td align='right'>" + SharedUtils.formatFloat(strUnit, '.' ) + "</td><td align='right'>" + SharedUtils.formatFloat(strSum, '.' ) + "</td></tr>";
            printerRows++;
            
        }
        
        strHtml += "<tr><td>&nbsp;</td><td align='right' colspan='2'>Versandkostenanteil:</td>";
        strHtml += "<td align='right'>&nbsp;</td><td align='right'>" + SharedUtils.formatFloat(strPorto, '.' ) + "</td></tr>";
        strHtml += "<tr><td>&nbsp;</td><td align='right' colspan='2'>Diskont:</td>";
        strHtml += "<td align='right'>&nbsp;</td><td align='right'>" + SharedUtils.formatFloat(strDiscount, '.' ) + "</td></tr>";
        String strNetto = (String)tblSums.getModel().getValueAt(TOTAL_WITHOUT_VAT,VALUE_COL_INDEX);
        String strVat = (String)tblSums.getModel().getValueAt(VAT_INDEX,VALUE_COL_INDEX);
        String strTotal = (String)tblSums.getModel().getValueAt(TOTAL_INDEX,VALUE_COL_INDEX);
        
        String strVatPers = (String)tblSums.getModel().getValueAt(VAT_INDEX,VALUE_COL_INDEX - 1);
        
        BigDecimal bdmDiscount = new BigDecimal(strDiscount);
        BigDecimal bdmNetto = new BigDecimal(strNetto);
        BigDecimal bdmSubTotal = bdmNetto.subtract(bdmDiscount).add(bdmPorto);
        String strSubTotal = bdmSubTotal.toString();
        BigDecimal bdmDiscountPer = new BigDecimal(0.0);
        
        
        try{
            bdmDiscountPer = new BigDecimal(editDiscount.getText());
            bdmDiscountPer = bdmDiscountPer.setScale(2,BigDecimal.ROUND_HALF_UP);
        } catch(Exception e){
            e.printStackTrace();
        }

        strHtml += "<tr><td></td><td align='right' colspan='2'><b>Summe    :</b></td><td  align='right'><b>EUR</b></td><td align='right'><b>" + SharedUtils.formatFloat(strNetto, '.' ) + "</b></td></tr>";
        strHtml += "<tr><td></td><td align='right' colspan='2'>" + strVatPers + " MwSt    :</td><td align='right'>EUR</td><td align='right'>" + SharedUtils.formatFloat(strVat, '.' ) + "</td></tr>";
        strHtml += "<tr><td></td><td align='right' colspan='2'><b>Rechnungsbetrag :</b></td><td align='right'><b>EUR</b></td><td align='right'><b>" + SharedUtils.formatFloat(strTotal, '.' ) + "</b></td></tr>";
        //hardcoded text
        strHtml += "</table><table  width='100%'><tr><td>&nbsp;</td></tr></table>";
        strHtml += "<table  width='100%'><tr><td>&nbsp;</td></tr></table>";
        
        edpInvoice.setContentType("text/html");
        edpInvoice.setText(strHtml);
        
        String firstName = editFirstName.getText();
        String lastName = editSurname.getText();
        String salutation = editAppeal.getText();
        String street = editStreet.getText();
        String postalCode = editCode.getText();
        String town = editCity.getText();
        String country = c_name;
        String altAddressCaption = "Lieferranschrift:";
        String invAltAddress = this.dlgAlternateAddress.getAddress();
        String invmacro = invoiceMacro;
        String invAltName = editAlternateName.getText();
        
        String date = editOrderDate.getText();
        String invoiceNumber = editDocNo.getText();
        String invoiceVersand = SharedUtils.formatFloat(strPorto, '.' );
        String invoiceDiscount = strDiscount;
        String invoiceSum = strNetto;
        String invoiceVat = strVat;
        String invoiceTotalSum = strTotal;
        String invoiceVatPerc =  strVatPers;
        String customerId = editUIN.getText();
        String invoiceBarcode = SharedUtils.generateBarcodeString(strOrderNo);
        String invoiceDicountPerc =  bdmDiscountPer.toString() + "%";
        
        lastName+="\n";
        if(invAltName!=null && invAltName.trim().length()>0){
            lastName += invAltName + "\n";
        }
        if(street!=null && street.trim().length()>0){
            lastName+=street + "\n";
        }
        if(country!=null && country.trim().length()>0){
            lastName+=country + " - ";
        }
        if(postalCode!=null && postalCode.trim().length()>0){
            lastName+=postalCode + " ";
        }
        if(town!=null && town.trim().length()>0){
            lastName+=town;
        }
        if( chkVatFree.isSelected() && !editCLCode.getText().trim().equals("") )
            lastName+= "\nIhre MwSt: " + editCLCode.getText();
        try{
            Customer customer = new Customer(firstName, lastName, salutation, street, postalCode, town, country,
                    altAddressCaption, invAltAddress, invmacro, invAltName,"");
            Invoice invoice = new Invoice(customer, date, invoiceNumber, invoiceVersand, invoiceDiscount, invoiceSum,
                    invoiceVat, invoiceTotalSum, invoiceVatPerc, customerId, invoiceBarcode, invoiceDicountPerc);
            invoice.setArticles(artilcles);
            InvoiceTableModel data = new InvoiceTableModel();
            data.addInvoice(invoice);
            spUtils = new SimplePrintUtils(data, "invoice/invoice.xml","Invoice");
        } catch(Exception e){
            e.printStackTrace();
            
        }               
    }
    
    private synchronized void printInvoice(final JFreeReport report){
        JFreeReportBoot jf = JFreeReportBoot.getInstance();
        if(!jf.isBootDone() || !jf.isBootInProgress()){
            jf.start();
        }
        
        try{
            try{
                BigDecimal bdmDiscountPer = new BigDecimal(editDiscount.getText());
                if(bdmDiscountPer.doubleValue()<=0){
                    spUtils.ShowHideItems(report, false);
                }
                
            } catch(Exception e){
                System.out.println(e.getMessage());
            }
            boolean printed = CustomPrintUtil.printOn(report,Main.printer.getId(),2);
            if(printed==false){
                JOptionPane.showMessageDialog(this,"Document Prining failed!\nTry to set another default printer!");
            }
        } catch(Exception e){
            System.out.println(e.getMessage());
        }
    }
    
    private void printInvoice(){
        JFreeReportBoot jf = JFreeReportBoot.getInstance();
        if(!jf.isBootDone() || !jf.isBootInProgress()){
            jf.start();
        }
        
        try{
            
            final JFreeReport report = spUtils.createReport();
            try{
                BigDecimal bdmDiscountPer = new BigDecimal(editDiscount.getText());
                if(bdmDiscountPer.doubleValue()<=0){
                    spUtils.ShowHideItems(report, false);
                }
                
            } catch(Exception e){
                System.out.println(e.getMessage());
            }
            
            boolean printed = PrintUtil.print(report);
            if(printed==false){
                JOptionPane.showMessageDialog(this,"Document Prining failed!\nTry to set another default printer!");
            }
        } catch(Exception e){
            System.out.println(e.getMessage());
        }
    }
    
    private int brCount(String macro){
        
        String temp = macro;
        int findex = -1;
        int lindex = -1;
        int count = 0;
        
        if(macro==null || macro.trim().length()<=0){
            
            return 0;
        }
        macro = java.net.URLDecoder.decode(macro);
        
        macro = macro.replaceAll("&lt;", "<");
        macro = macro.replaceAll("&gt;", ">");
        macro = macro.replaceAll("&quot;", "\"");
        macro = macro.replaceAll("&apos", "'");
        macro = macro.replaceAll("&amp;", "&");
        
        for(int i=0; i < macro.length(); i++){
            
            if(macro.charAt(i) == '<'){
                
                lindex = macro.indexOf('>', i);
                if(lindex<0){
                    continue;
                } else{
                    
                    temp = macro.substring(i+1, lindex);
                    temp = temp.replace('/',' ');
                    temp = temp.trim();
                    if(temp.equals("br")){
                        count++;
                    }
                }
            } else{
                
                continue;
            }
            
        }
        
        return count;
    }
    
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        
        if(evt.getSource()==editCount){
            btnAddStock.doClick();
        } else if(evt.getSource()==btnNewClient) {
            Vector vecResults = new Vector();
            new AddClient(new javax.swing.JFrame(), true, AddClient.ADD_MODE,vecResults).setVisible(true);
            if( vecResults.size() > 0 ) {
                loadClientInfo( vecResults );
                try{
                    calculateSums(true);
                } catch(Exception e){
                    JOptionPane.showMessageDialog(null,"Warning: System detect that some fields has no absolutely correct data!\nPlease validate sums calculations!", "Warning", JOptionPane.WARNING_MESSAGE, null);
                }
                
                this.dlgAlternateAddress.setAddress("");
                dlgAlternateAddress.setIsPermanent( false );
                
                chkbAltAddress.setSelected(false);
                btnSet.setEnabled(false);
            }
        } else if(evt.getSource() == btnSet){
            dlgAlternateAddress.setVisible(true);
        } else if(evt.getSource()==btnMoreClient){
            if( editUIN.getText().length() == 0 ){
                JOptionPane.showMessageDialog(null,"Please select client first!");
                return;
            }
            Vector vecResults = new Vector();
            vecResults.addElement(editUIN.getText());
            new AddClient(new javax.swing.JFrame(), true, AddClient.EDIT_MODE, vecResults).setVisible(true);
            if(vecResults.size() > 0){
                loadClientInfo(vecResults);
                try{
                    calculateSums(true);
                } catch(Exception e){
                    JOptionPane.showMessageDialog(null,"Warning: System detect that some fields has no absolutely correct data!\nPlease validate sums calculations!", "Warning", JOptionPane.WARNING_MESSAGE, null);
                }
            }
        } else if(evt.getSource()==btnSearchClient) {
            new PersonSearch(new javax.swing.JFrame(), true, vecPatientSearchResults,PersonSearch.PATIENT_SEARCH ).setVisible(true);
            if(vecPatientSearchResults.size() > 0){
                loadClientInfo(vecPatientSearchResults);
                try{
                    calculateSums(true);
                } catch(Exception e){
                    JOptionPane.showMessageDialog(null,"Warning: System detect that some fields has no absolutely correct data!\nPlease validate sums calculations!", "Warning", JOptionPane.WARNING_MESSAGE, null);
                }
                String altAddress =
                        SharedUtils.executeSqlScalar("select alternate_address from" +
                        " base_prsn where prsn_key=" + editUIN.getText() );
                if( altAddress != null ) {
                    this.dlgAlternateAddress.setAddress(altAddress);
                    dlgAlternateAddress.setIsPermanent(true);
                    chkbAltAddress.setSelected(true);
                    btnSet.setEnabled(true);
                } else {
                    this.dlgAlternateAddress.setAddress("");
                    dlgAlternateAddress.setIsPermanent(false);
                    chkbAltAddress.setSelected(false);
                    btnSet.setEnabled(false);
                }
            }
            
        } else if(evt.getSource()==btnShowPercents){
            lblProv1.setVisible(false);
            lblProv2.setVisible(false);
            editProv1Pers.setVisible(false);
            editProv2Pers.setVisible(false);
            btnDoctors.setVisible(false);
            btnDealers.setVisible(false);
            tblProvs.setVisible(true);
            scrProvs.setVisible(true);
        } else if(evt.getSource()==btnDoctors) {
            
            Vector vecProvSearchResults = new Vector();
            new PersonSearch(new javax.swing.JFrame(), true, vecProvSearchResults,PersonSearch.DOCTOR_SEARCH ).setVisible(true);
            if(vecProvSearchResults.size() == 0) {
                vecProvSearchResults = null;
                return;
            }
            String strUIN = (String)vecProvSearchResults.get(0);
            String strName = (String)vecProvSearchResults.get(1);
            String strProv1Comm = (String)vecProvSearchResults.get(3);
            
            CustomerActor curCustomer = customer;
            
            Provisioner prov1 = new Provisioner(strUIN, strName, strProv1Comm);
            editProv1Name.setText(prov1.getName());
            editProv1UIN.setText(prov1.getId());
            editProv1Pers.setText(prov1.getCommission());
            
            Provisioner prov2 = new Provisioner("", "", "0");
            try{
                prov2 = loadProv(Provisioner.prov2, prov1);
                editProv2Name.setText(prov2.getName());
                editProv2UIN.setText(prov2.getId());
                editProv2Pers.setText(prov2.getCommission());
            } catch(Exception e){
                editProv2Name.setText("");
                editProv2UIN.setText("");
                editProv2Pers.setText("0.00");
                m_prov3Data = new ArrayList();
                return;
            }
            
            Provisioner prov3 = new Provisioner("", "", "0");
            m_prov3Data = new ArrayList();
            try{
                
                prov3 = loadProv(Provisioner.prov3, prov2);
                m_prov3Data = prov3.toArrayList();               
            } catch(Exception e){
                
            }
            
        } else if(evt.getSource()==btnDealers) {
            Vector result = new Vector();
            new PersonSearch(new javax.swing.JFrame(), true, result,PersonSearch.DEALER_SEARCH ).setVisible(true);
            if(result.size() == 0)
                return;
            
            String strUIN = (String)result.get(0);
            String strName = (String)result.get(1);
            
            Provisioner prov2 = new Provisioner(strUIN,strName, "0");
            editProv2Name.setText(prov2.getName());
            editProv2UIN.setText(prov2.getId());
            editProv2Pers.setText(prov2.getCommission());
            
            Provisioner prov3 = new Provisioner("", "", "0");
            m_prov3Data = new ArrayList();
            try{
                prov3 = loadProv(Provisioner.prov3, prov2);
                m_prov3Data = prov3.toArrayList();                
            } catch(Exception e){
                
            }
            
            editProv1Pers.setText("0.00");
                        
            JOptionPane.showMessageDialog(null,"You choose to change the dealer but now you have to put the provisions charge manually!");
        } else if(evt.getSource() == btnSelectStock){
            //vecStockResults = new Vector(3);
            if(vecStockResults==null)
                vecStockResults = new Vector();
            new StockSelection(new javax.swing.JFrame(), true,vecStockResults).setVisible(true);
            if(vecStockResults.size()< 1) {
                lblStockName.setText("Stock not selected!");
                return;
            }
            btnAddStock.setEnabled(true);
            String strStockAbrv = (String)vecStockResults.get(VEC_STOCK_ABRV_INDEX);
            String strStockName = (String)vecStockResults.get(VEC_STOCK_NAME_INDEX);
            editNewStock.setText(strStockName);
            lblStockName.setText(strStockAbrv);
        } else if( evt.getSource() == btnAddStock ) {
            
            try{                
                checkProvs();
            } catch(Exception e){
                JOptionPane.showMessageDialog(null,e.getMessage());
                return;
            }
            
            if(editUIN.getText().equals("")) {
                JOptionPane.showMessageDialog(null,"Please select patient to asociate with this order!");
                return;
            }
            if( vecStockResults.size() < 1 )
                return;
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editCount)) {
                JOptionPane.showMessageDialog(null,"Please, enter valid integer for stock count!");
                return;
            }
            if(editCount.getText()!=null && Integer.parseInt(editCount.getText())<=0) {
                JOptionPane.showMessageDialog(null,"Please, enter valid integer for stock count!");
                return;
            }
            try {
                String strStockID = (String)vecStockResults.get( VEC_STOCK_KEY_INDEX );
                if (((UniversalTableModel)tblOrderGoods.getModel()).objectExistsAt(strStockID, STOCK_KEY_INDEX)) {
                    JOptionPane.showMessageDialog(null,"This stock is already registered with this order!");
                    editNewStock.setText("");
                    editCount.setText("");
                    lblStockName.setText("Stock not selected!");
                    return;
                }
                String strCount = editCount.getText();
                Quotes quotes = new Quotes(editUIN.getText(),strStockID);
                quotes.setQuote(strCount);
                String cntToPay = String.valueOf(quotes.getRemain());
                
                String strSQL = " SELECT STCK_BRCD, STCK_ABRV, STCK_NAME, " + strCount +
                        " , PRIC_SELL, PRIC_SELL * " + cntToPay + ", STCK_KEY " +
                        " FROM BASE_STCK " +
                        " WHERE STCK_KEY = " + strStockID;
                Vector row = new Vector( SharedUtils.executeSqlScalarList( strSQL ) );
                String curDate = SharedUtils.getCurrentDateStringFormatted();
                curDate = "'" + curDate + "'";
                Date date = new Date();
                SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
                String today = sdf.format(date);
                curDate = "'" + curDate + "'";
                String sql = "select id, discount from campaign where stockid=" + strStockID +
                        " and lownum<= " + strCount + " and  highnum>=" + strCount +
                        " and fromdate<='" + today + " 23:59:59'" + " and '" + today + " 00:00:00'" + "<=todate";
                
                ArrayList campaignList = SharedUtils.executeSqlScalarList(sql);
                if( campaignList.size() > 0 ) {
                    
                    String campId = (String)campaignList.get(0);
                    int disc = Integer.parseInt( (String)campaignList.get(1) );
                    double price = Double.parseDouble( (String)row.get(STOCK_SUM_INDEX) );
                    //price = price * ( 100 - disc ) / 100;
                    
                    double unit_price = Double.parseDouble( (String)row.get(STOCK_UNIT_INDEX) );
                    
                    double disc_unit_price = unit_price * ( 100 - disc ) / 100;
                    String strUPrice = SharedUtils.formatFloat( "" + disc_unit_price, '.' );
                    double disc_price = Double.parseDouble(strUPrice)*Integer.parseInt(strCount);
                    
                    int i = JOptionPane.showConfirmDialog(this,"Please confirm CAMPAIGN discount\n\n Price: " +
                            "" + SharedUtils.formatFloat( "" + price, '.' ) + " - " + disc +"% = " + SharedUtils.formatFloat( "" + disc_price, '.' )+"\n\n","Please confirm CAMPAIGN discount" +
                            "",JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                    
                    if(i==JOptionPane.OK_OPTION){
                        row.set( STOCK_UNIT_INDEX, SharedUtils.formatFloat( "" + disc_unit_price, '.' ) );
                        row.set( STOCK_SUM_INDEX, SharedUtils.formatFloat( "" + disc_price, '.' ));
                        row.add(campId);
                    }
                }
                
                UniversalTableRow uniTableRow = new UniversalTableRow( row );
                ((UniversalTableModel)tblOrderGoods.getModel()).addRow(uniTableRow);
                tblOrderGoods.updateUI();
                editNewStock.requestFocus();
                editNewStock.selectAll();
                editNewStock.setText("");
                editCount.setText("");
                lblStockName.setText("Stock not selected!");
                bUpdatedStocks = true;
                // if we have add for the first time
                if( ((UniversalTableModel)tblOrderGoods.getModel()).getRowCount() == 1 ) {
                    calculatePercents();
                    enableLeftSide(false);
                }
                calculateSums(true);
            } catch(Exception e) {
                logErrToFile(e);
                SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
            }
            
        } else if(evt.getSource() == mitemDelete) {
            int nRow = tblOrderGoods.getSelectedRow();
            ((UniversalTableModel)tblOrderGoods.getModel()).removeItemAt(nRow);
            tblOrderGoods.updateUI();
            try{
                calculateSums(true);
            } catch(Exception e){
                JOptionPane.showMessageDialog(null,"Warning: System detect that some fields has no absolutely correct data!\nPlease validate sums calculations!", "Warning", JOptionPane.WARNING_MESSAGE, null);
            }
            bUpdatedStocks = true;
            //
            if( ((UniversalTableModel)tblOrderGoods.getModel()).getRowCount() == 0 )
                enableLeftSide(true);
        } else if(evt.getSource() == btnPlaceOrders) {
            try{
                if(editDocNo.getText().trim().length()>0){
                    JOptionPane.showMessageDialog(null,"Already placed!");
                    return;
                }
                try{
                    Integer.parseInt(editUIN.getText());
                } catch(Exception e){
                    JOptionPane.showMessageDialog(null,"Please select patient to asociate with this order!");
                    return;
                }
                if(!dateVerifier.DATE_Verifier((JComponent)editOrderDate) || editOrderDate.getText().length()==0){
                    JOptionPane.showMessageDialog(null,"Please enter valid order date!");
                    return;
                }
                if(!strVerifier.Universal_String_Verifier((JComponent)editAlternateName)){
                    JOptionPane.showMessageDialog(null,"Please enter valid order date!");
                    return;
                }
                int nRowCount = tblOrderGoods.getRowCount();
                if(nRowCount < 1){
                    JOptionPane.showMessageDialog(null,"You have to add at least one stock for this order!");
                    return;
                }
                
                try{
                    checkProvs();
                } catch(Exception e){
                    JOptionPane.showMessageDialog(null,e.getMessage());
                    return;
                }
                
                int result = JOptionPane.showConfirmDialog((Component)this,"You are about to place an order, once order is registered it couldn't be edited, please confirm!Do you want to continue?","Confirm Place Order",JOptionPane.YES_NO_OPTION);
                if( result != JOptionPane.YES_OPTION)
                    return;
                
                String strAlternateAddress = "NULL";
                boolean isPermanent = false;
                
                if(chkbAltAddress.isSelected()) {
                    String strInput = dlgAlternateAddress.getAddress();
                    
                    if(strInput==null || strInput.trim().length()<=0){
                        JOptionPane.showMessageDialog(null,"You decided to use alternate address,please go back and enter valid value(1-250 characters)!");
                        return;
                    }
                    
                    strAlternateAddress = "'" + strInput + "'";
                    if(strAlternateAddress.length() < 1 || strAlternateAddress.length()>250){
                        
                        JOptionPane.showMessageDialog(null,"You decided to use alternate address, please go back and enter valid value(1-250 characters)!");
                        return;
                    }
                    
                }
                isPermanent = dlgAlternateAddress.isPermanent();
                String strUIN = editUIN.getText();
                String strProv1Idnt = (String) editProv1UIN.getText();
                String strProv2Idnt = (String) editProv2UIN.getText();
                String strProv3Idnt = null;
                String strProv3Pers = "0";
                if( m_prov3Data.size() > 0 ) {
                    strProv3Idnt = (String)m_prov3Data.get(0);
                    strProv3Pers = (String)m_prov3Data.get(1);
                }
                strProv3Pers = BigDec.scaledRoundHalfUp(strProv3Pers,2);
                
                String  strDiscount = editDiscount.getText();
                String strProv1Pers = editProv1Pers.getText();
                strProv1Pers = BigDec.scaledRoundHalfUp(strProv1Pers,2);
                
                String strProv2Pers = editProv2Pers.getText();
                strProv2Pers = BigDec.scaledRoundHalfUp(strProv2Pers,2);
                
                String strVat = String.valueOf(fVat);
                String strAltName = editAlternateName.getText();
                String strCountry = editCountry.getText();
                String strCity  = editCity.getText();
                String strCode = editCode.getText();
                String strStreet = editStreet.getText();
                String strOrderDate = editOrderDate.getText();
                String dateFields[] = strOrderDate.split("\\.");
                strOrderDate = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
                strOrderDate = strOrderDate + " " + SharedUtils.getCurrentTimeString();
                int nTypeID = ((ComboDataModel)comboDocType.getModel()).getCObjectAt(comboDocType.getSelectedIndex()).nItemDBKey;
                String strTypeID = String.valueOf(nTypeID);
                String strDocType = (String)comboDocType.getSelectedItem();
                String strOperIdnt = String.valueOf(SharedUtils.nUserID);
                
                String strNetto = (String)tblSums.getModel().getValueAt(NETTO_INDEX,VALUE_COL_INDEX);
                String strTotal = (String)tblSums.getModel().getValueAt(TOTAL_INDEX,VALUE_COL_INDEX);
                String strPorto = (String)tblSums.getModel().getValueAt(PORTO_INDEX,VALUE_COL_INDEX);
                
                String strPay = "0.0";
                String strPayDate = SharedUtils.getCurrentOnlyDateSQLFormat();
                
                String macro = SharedUtils.getMacro( "macro" + SharedUtils.activeMacro );
                if( macro == null )
                    macro = "";
                String docLastName = SharedUtils.executeSqlScalar("select prsn_lnam from base_prsn where prsn_key=" + strProv1Idnt );
                if( docLastName == null )
                    docLastName = "";
                macro = macro.replaceAll("<DOCTOR>", docLastName );
                macro = macro.replaceAll("<USER>", SharedUtils.strUserAbrv );
                macro = macro.replaceAll("<DATE>", editOrderDate.getText() );
                if( SharedUtils.discountSum >= 0 )
                    macro = macro.replaceAll("<PORTO_DISCOUNT>",
                            SharedUtils.formatFloat(  "" + SharedUtils.discountSum, '.' ) );
                else
                    macro = macro.replaceAll("<PORTO_DISCOUNT>", "" );
                
                Connection connDB = null;
                try{
                    connDB = SharedUtils.getConnection();
                    connDB.setAutoCommit(false);
                    
                    String orderNo = editDocNo.getText();
                    String strSQL="";
                    strSQL = "INSERT INTO VORGANG" +
                            " (patn_idnt,patn_dscn,prv1_idnt,prv1_comm,prv2_idnt, " +
                            " prv2_comm,invc_addr,oper_idnt,doc_type_idnt,invc_date, " +
                            " pay_date,pay_sum,neto_sum,vat_pers,totl_sum,altr_name, " +
                            " patn_cntr,patn_city,patn_code,patn_strt,invc_prto, " +
                            " invoiceid,prv3_idnt,prv3_comm,macro1text,letter1date, " +
                            " letter2date,letter3date, vatcode, cntr_code) " +
                            " VALUES(" + strUIN + "," + strDiscount + "," + strProv1Idnt + "," + strProv1Pers  + "," + strProv2Idnt + "," +
                            strProv2Pers + "," + strAlternateAddress + "," + strOperIdnt + "," + strTypeID + ",'" + strOrderDate + "','" +
                            strPayDate + "'," + strPay + "," + strNetto + "," + strVat + "," + strTotal + ",'" + strAltName +
                            "','" + strCountry + "','" + strCity + "','" + strCode + "','" + strStreet + "'," + strPorto + "," +
                            "null" + "," + strProv3Idnt + "," + strProv3Pers + ", '" + macro + "',null," +
                            "null,null," + ctdata.cntr_vat_code() + "," + ctdata.cntr_code() + ")";
                    
                    Statement stm = connDB.createStatement();
                    int nResult = stm.executeUpdate(strSQL);
                    if(nResult != 1){
                        JOptionPane.showMessageDialog(null,"Error while trying to register new order in the system!Operation canceled!");
                        stm.close();
                        connDB.rollback();
                        return;
                    }
                    stm.close();
                    String strInvoiceID = SharedUtils.getLastInsertedID(connDB);
                    Vector data =  ((UniversalTableModel)tblOrderGoods.getModel()).getDataVector();
                    for( int i = 0; i < nRowCount; i++ ) {
                        UniversalTableRow row = (UniversalTableRow)data.get(i);
                        String strCount = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_COUNT_INDEX);
                        String strUnit = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_UNIT_INDEX);
                        String strSum = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_SUM_INDEX);
                        String strStockKey = (String)tblOrderGoods.getModel().getValueAt(i,STOCK_KEY_INDEX);
                        String campId = "null";
                        if( row.size() - 1 >= CAMPAIGN_ID_INDEX ) {
                            campId = (String)row.getRowElement(CAMPAIGN_ID_INDEX);
                        }
                        strSQL = "INSERT INTO POSITION" +
                                " (v_nr,a_nr,p_pos,p_menge,nstk_idnt,unit_pric,sum_pric,campaign_id)" +
                                " VALUES(" + strInvoiceID + ",NULL," + (i+1) + "," + strCount +
                                ", " + strStockKey + ", " + strUnit + ", " + strSum + "," + campId + ")";
                        stm = connDB.createStatement();
                        nResult = stm.executeUpdate(strSQL);
                        if(nResult != 1){
                            JOptionPane.showMessageDialog(null,"Error while trying to register new order in the system!Operation canceled!");
                            stm.close();
                            connDB.rollback();
                            return;
                        }
                        stm.close();
                    }
                    if( isPermanent ) {
                        String sql = "update base_prsn set alternate_address=" +
                                strAlternateAddress + " where prsn_key=" + strUIN;
                        stm = connDB.createStatement();
                        stm.executeUpdate( sql );
                        stm.close();
                    } else if( !strAlternateAddress.equals( "NULL" ) ) {
                        String sql = "update base_prsn set alternate_address=null" +
                                " where prsn_key=" + strUIN;
                        stm = connDB.createStatement();
                        stm.executeUpdate( sql );
                        stm.close();
                    }
                    connDB.commit();
                    connDB.setAutoCommit(true);
                    editDocNo.setText(strInvoiceID);
                    //1.remove order
                    btnControl.doClick();
                    //2.select new order in the grid bellow
                    int lastIndex = tblOrders.getModel().getRowCount() - 1;
                    tblOrders.setRowSelectionInterval( lastIndex,lastIndex );
                    //3.load order data again
                    loadOrderInfo(strInvoiceID);
                    
                    JOptionPane.showMessageDialog(null,"New order was added successfully!");
                    if(tbpOrders.isEnabledAt(1)){
                        try{
                            generateInvoice();
                            final JFreeReport report = spUtils.createReport();
                            printInvoice(report);
                            
                        } catch(Exception e){
                            System.out.println(e.getMessage());
                        }
                    }
                    if(tbpOrders.isEnabledAt(2)){
                        generatePackings();
                        try{
                            final JFreeReport report = spUtils.createReport();
                            printInvoice(report);
                        } catch(Exception e){
                            System.out.println(e.getMessage());
                        }
                    }
                    btnCreditNote.setEnabled( true );
                    
                }catch(Exception sqle){
                    logErrToFile(sqle);
                    SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
                    sqle.printStackTrace();
                } finally {
                    try {
                        if( connDB != null )
                            connDB.close();
                    } catch(Exception e){
                        logErrToFile(e);
                        e.printStackTrace();
                    }
                }
            } catch(Exception e){
                logErrToFile(e);
                e.printStackTrace();
            }
        } else if(evt.getSource()==btnControl) {
            
            lblStockName.setText("Stock not selected!");
            bControlsEnabled = !bControlsEnabled;
            if(!editUIN.getText().equals("")){
                vecPatientSearchResults.removeAllElements();
                vecPatientSearchResults.addElement(editUIN.getText());
                loadClientInfo(vecPatientSearchResults);
            }
            
            editableCellProto(bControlsEnabled);
            ((ComboDataModel)comboDocType.getModel()).selectIndexByKey(1); // invoice
            this.dPorto = SharedUtils.porto;
            tblSums.getModel().setValueAt( getBdmPorto().toString(), PORTO_INDEX, VALUE_COL_INDEX);
            placeControls4Invoice();
            enableControls(bControlsEnabled);
            btnCreditNote.setEnabled(false);
            tbpOrders.setEnabledAt( 1, false );
            tbpOrders.setEnabledAt( 2, false );
            editOrderDate.setText(SharedUtils.getCurrentOnlyDateStringFormatted());
            
            if( bControlsEnabled && !editUIN.getText().equals("")) {
                String altAddress = SharedUtils.executeSqlScalar("select alternate_address from" +
                        " base_prsn where prsn_key=" + editUIN.getText() );
                if( altAddress != null ) {
                    this.dlgAlternateAddress.setAddress(altAddress);
                    dlgAlternateAddress.setIsPermanent(true);
                    chkbAltAddress.setEnabled(true);
                    chkbAltAddress.setSelected(true);
                    btnSet.setEnabled(true);
                }
            }
        } else if(evt.getSource() == editProv1UIN) {
            String strPrsnIdnt = editProv1UIN.getText();
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editProv1UIN)){
                editProv1UIN.setText("");
                return;
            }
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT PRSN_LNAM + ' , ' +  PRSN_FNAM AS NAME " +
                    " ,PRV1_COMM,PRV2_IDNT,PRV2_COMM  FROM BASE_PRSN " +
                    " WHERE PRSN_KEY = " + strPrsnIdnt;
            try{
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery(strSQL);
                if(rsDBData.next()){
                    String strName = rsDBData.getString(1);
                    String strProv1Comm = rsDBData.getString(2);
                    String strProv2Idnt = rsDBData.getString(3);
                    String strProv2Comm = rsDBData.getString(4);
                    rsDBData.close();
                    stm.close();
                    
                    editProv1Name.setText(strName);
                    editProv1Pers.setText(BigDec.scaledRoundHalfUp(strProv1Comm,2));
                    
                    if(!UniversalInputVerifier.Universal_Integer_Verifier(editProv2UIN)){
                        return;
                    }
                    
                    connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
                    strSQL = " SELECT base_prsn.prsn_lnam + ' , ' + base_prsn.prsn_fnam as name " +
                            " FROM base_prsn " +
                            " WHERE prsn_key = " + strProv2Idnt;
                    stm = connDB.createStatement();
                    rsDBData=stm.executeQuery(strSQL);
                    boolean bMore = rsDBData.next();
                    if(bMore) {
                        String strProv2Name = rsDBData.getString(1);
                        editProv2UIN.setText(strProv2Idnt);
                        editProv2Name.setText(strProv2Name);
                        editProv2Pers.setText(BigDec.scaledRoundHalfUp(strProv2Comm,2));
                    }
                    rsDBData.close();
                    stm.close();
                    
                } else {
                    JOptionPane.showMessageDialog(null,"There is no person with UIN - " + strPrsnIdnt + "!");
                    editProv1UIN.setText("");
                    return;
                }
            } catch(SQLException sqle) {
                logErrToFile(sqle);
                SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
                sqle.printStackTrace();
            }
        } else if(evt.getSource() == editProv2UIN){
            String strPrsnIdnt = editProv2UIN.getText();
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editProv2UIN)){
                return;
            }
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT PRSN_LNAM + ' , ' +  PRSN_FNAM AS NAME " +
                    " ,PRV2_COMM  FROM BASE_PRSN " +
                    " WHERE PRSN_KEY = " + strPrsnIdnt;
            try {
                Statement stm = connDB.createStatement();
                ResultSet rsDBData=stm.executeQuery(strSQL);
                if(rsDBData.next()){
                    String strName = rsDBData.getString(1);
                    String strProv2Comm = rsDBData.getString(2);
                    rsDBData.close();
                    stm.close();
                    
                    editProv2UIN.setText(strPrsnIdnt);
                    editProv2Name.setText(strName);
                    editProv2Pers.setText(BigDec.scaledRoundHalfUp(strProv2Comm,2));
                } else{
                    JOptionPane.showMessageDialog(null,"There is no person with UIN - " + strPrsnIdnt + "!");
                    editProv2UIN.setText("");
                }
            }catch(SQLException sqle){
                editProv2UIN.setText("");
                logErrToFile(sqle);
                SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
                sqle.printStackTrace();
            }
        } else if( evt.getSource() == btnSearchOrders ) {
            Vector vecResults = new Vector();
            new SearchOrders(new javax.swing.JFrame(), true, vecResults).setVisible(true);
            if(vecResults.size() > 0) {
                //fix
                bControlsEnabled = false;
                enableControls(bControlsEnabled);
                ((UniversalTableModel)tblOrders.getModel()).clearData();
                tblOrders.updateUI();
                //
                loadOrderInfo((String)vecResults.get(0));
                // load client and client's orders
                vecPatientSearchResults.removeAllElements();
                vecPatientSearchResults.addElement(editUIN.getText());
                loadClientInfo(vecPatientSearchResults);
                loadOrderInfo((String)vecResults.get(0));
                if( ((ComboDataModel)comboDocType.getModel()).getCObjectAt(comboDocType.getSelectedIndex()).nItemDBKey == 1 )
                    btnCreditNote.setEnabled(true);
                else
                    btnCreditNote.setEnabled(false);
            }
        } else if( evt.getSource() == btnPrint){
            //print(edpInvoice);
            printInvoice();
        } else if ( evt.getSource() == btnPay){
            String strOrderNo = editDocNo.getText();
            String strPaySum = editPayed.getText();
            if(strOrderNo.length()==0){
                JOptionPane.showMessageDialog(null,"There must be selected order in order to pay!");
                return;
            }
            if(strPaySum.length()==0){
                JOptionPane.showMessageDialog(null,"Please, enter valid pay sum!");
                return;
            }
            if( editPayDate.getText().length()==0 ){
                JOptionPane.showMessageDialog(null,"Please, enter valid pay date!");
                return;
            }
            try{
                int nOrderNo = Integer.parseInt(strOrderNo);
                String strFromDate = editPayDate.getText();
                String dateFields[] = strFromDate.split("\\.");
                strFromDate = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
                strFromDate = strFromDate + " " + SharedUtils.getCurrentTimeString();
                Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
                Statement stm = connDB.createStatement();
                String strSQL = "UPDATE VORGANG SET PAY_DATE='" + strFromDate + "' , PAY_SUM = " + strPaySum + " WHERE V_NR = " + strOrderNo;
                
                int nResult = stm.executeUpdate(strSQL);
                System.out.println(nResult);
                if(nResult != 1){
                    JOptionPane.showMessageDialog(null,"Error while trying to pay sum to order!");
                    stm.close();
                    return;
                }
                stm.close();
                JOptionPane.showMessageDialog(null,"Payment is successfully registred in the system!");
                String strUIN = editUIN.getText();
                if(strUIN.length()!=0)
                    loadClientOrders(strUIN);
            }catch(NumberFormatException e){
                logErrToFile(e);
                JOptionPane.showMessageDialog(null,"Please, enter valid integer for Order number!");
                return;
            }catch(SQLException sqle){
                logErrToFile(sqle);
                SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
                sqle.printStackTrace();
            }
        } else if( evt.getSource() == btnSendLetter ){
            
            String strAppeal = editAppeal.getText();
            String strFirstName = editFirstName.getText();
            String strLastName = editSurname.getText();
            String strStreet = editStreet.getText();
            String strCode = editCode.getText();
            String strCity = editCity.getText();
            String strDate = editOrderDate.getText();
            String strOrderNo = editDocNo.getText();
            String strClientIdnt = editUIN.getText();
            
            if( strClientIdnt.length() < 1 ){
                JOptionPane.showMessageDialog(null,"Please, select client first!");
                return;
            }
            
            Vector vecClientInfo = new Vector();
            vecClientInfo.addElement(strAppeal);
            vecClientInfo.addElement(strFirstName);
            vecClientInfo.addElement(strLastName);
            vecClientInfo.addElement(strStreet);
            vecClientInfo.addElement(strCode);
            vecClientInfo.addElement(strCity);
            vecClientInfo.addElement(strDate);
            vecClientInfo.addElement(strOrderNo);
            vecClientInfo.addElement(strClientIdnt);
            
            String strMacroDate =   SharedUtils.getCurrentOnlyDateStringFormatted();
            String docLastName = editProv1Name.getText().trim();
            if( docLastName.indexOf(",") == docLastName.length() -1 )
                docLastName = "";
            else
                docLastName = docLastName.substring( docLastName.indexOf(",") + 1 );
            SendLetterDialog sendLetterDialog = new SendLetterDialog( this, true, vecClientInfo);
            sendLetterDialog.setVisible(true);
        } else if( evt.getSource() == btnMacros ){
            MacroEditDialog editMacro = new MacroEditDialog( new JFrame(), true, editProv1Name.getText());
            editMacro.show();
        }
        
    }//GEN-LAST:event_actionPerformed
    
    //        
    private void calculatePercents() throws Exception{
        String strUIN = editUIN.getText();
        String strProv1Idnt = (String) editProv1UIN.getText();
        String strProv2Idnt = (String) editProv2UIN.getText();
        
        int strProv3Idnt = 0;
        double strProv3Pers = 0;
        
        if( m_prov3Data.size() > 0 ) {
            try{
                strProv3Idnt = Integer.parseInt(String.valueOf(m_prov3Data.get(0)));
            } catch(Exception e){
                strProv3Idnt = 0;
            }
            try{
                strProv3Pers = Double.parseDouble(String.valueOf(m_prov3Data.get(1)));
            } catch(Exception e){
                strProv3Pers = 0;
            }
        }
        
        try{
            Integer.parseInt(strProv1Idnt);                
        } catch(Exception e){
            editProv1Pers.setText( "0.00" );
        }
        
        try{            
            Integer.parseInt(strProv2Idnt);   
        } catch(Exception e){
            editProv1Pers.setText( "0.00" );
        }
        
        
        double discount = 0;
        try{
            discount = Double.parseDouble( editDiscount.getText() );
        } catch(Exception e){
            discount = 0;
        }
        
        double prov1Pers = 0;
        try{
            prov1Pers = Double.parseDouble( editProv1Pers.getText() );
        } catch(Exception e){
            prov1Pers = 0;
        }
        
        double prov2Pers = 0;
        try{
            prov2Pers = Double.parseDouble( editProv2Pers.getText() );
        } catch(Exception e){
            prov2Pers = 0;
        }
        
        {
            if(discount + prov1Pers>50){
                double calc = 50 - discount;
                prov1Pers = calc > 0 ? calc : 0;
            }
            if(discount + prov1Pers + prov2Pers > 50){
                double calc = 50 - ( discount + prov1Pers );
                prov2Pers = calc > 0 ? calc : 0;
            }
            if(discount + prov1Pers + prov2Pers + strProv3Pers > 50){
                double calc = 50 - (discount + prov1Pers + prov2Pers + strProv3Pers);
                strProv3Pers = calc > 0 ? calc : 0;
            }
        }
        
        editProv1Pers.setText(BigDec.scaledRoundHalfUp(prov1Pers,2));
        editProv2Pers.setText(BigDec.scaledRoundHalfUp(prov2Pers,2));
        m_prov3Data.set(1,BigDec.scaledRoundHalfUp(strProv3Pers,2));
        
        if( strUIN.equals( strProv1Idnt )  ) {
            discount += prov1Pers;
            prov1Pers = 0;
            editProv1Pers.setText("0.00");
        }
        if( strUIN.equals( strProv2Idnt )  ) {
            discount += prov2Pers;
            prov2Pers = 0;
            editProv2Pers.setText("0.00");
        }
        if( strUIN.equals( String.valueOf(strProv3Idnt ))  ) {
            discount += strProv3Pers;
            strProv3Pers = 0;
            m_prov3Data.set(1,BigDec.scaledRoundHalfUp(strProv3Pers,2));
        }
        String strDiscount = BigDec.scaledRoundHalfUp(discount,2);
        editDiscount.setText( strDiscount );
        tblSums.getModel().setValueAt(strDiscount, DISCOUNT_INDEX, VALUE_COL_INDEX);
        
    }
    
    private void enableControls(boolean bEnabled){
        
        editAlternateName.setEnabled(bEnabled);
        btnNewClient.setEnabled(bEnabled);
        btnMoreClient.setEnabled(bEnabled);
        btnSearchClient.setEnabled(bEnabled);
        btnShowPercents.setEnabled(bEnabled);
        editOrderDate.setEnabled(bEnabled);
        editNewStock.setEnabled(bEnabled);
        btnSelectStock.setEnabled(bEnabled);
        editCount.setEnabled(bEnabled);
        editProv2Pers.setEnabled(bEnabled);
        editProv1Pers.setEnabled(bEnabled);
        editProv1UIN.setEnabled(bEnabled);
        editProv2UIN.setEnabled(bEnabled);
        
        if(bEnabled){
            chkbAltAddress.setEnabled(bEnabled);
            if(chkbAltAddress.isSelected())
                btnNewClient.setEnabled(bEnabled);
            
            // System.out.println(bEnabled);
            //fix ait
            // if we have new order
            lblStockName.setText("Stock not selected!");
            btnControl.setText("Cancel Order");
            Main.def_app_lang.loadMenuLabel(btnControl, 1);
            Main.def_app_lang.loadMenuLabel(lblStockName, 1);
        } else{
            chkbAltAddress.setEnabled(bEnabled);
            btnNewClient.setEnabled(bEnabled);
            btnControl.setText("New Order");
            Main.def_app_lang.loadMenuLabel(btnControl, 2);
            // System.out.println(bEnabled);
        }
        btnPlaceOrders.setEnabled(customer.canPrucahse());
        tblOrderGoods.setEnabled(bEnabled);
        btnDoctors.setEnabled(bEnabled);
        btnDealers.setEnabled(bEnabled);
        tblOrders.setEnabled(!bEnabled);
        this.mitemDelete.setEnabled(bEnabled);
        this.mitemDelete.setVisible(bEnabled);
        editDiscount.setEnabled(bEnabled);
        btnAddStock.setEnabled(customer.canPrucahse());
        clearControls();
    }
    
    private void enableLeftSide(boolean bEnabled) {
        btnNewClient.setEnabled(bEnabled);
        btnMoreClient.setEnabled(bEnabled);
        btnSearchClient.setEnabled(bEnabled);
        btnShowPercents.setEnabled(bEnabled);
        editProv2Pers.setEnabled(bEnabled);
        editProv1Pers.setEnabled(bEnabled);
        editProv1UIN.setEnabled(bEnabled);
        editProv2UIN.setEnabled(bEnabled);
        btnDoctors.setEnabled(bEnabled);
        btnDealers.setEnabled(bEnabled);
        editDiscount.setEnabled(bEnabled);
    }
    
    private void editAlternateNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_editAlternateNameActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_editAlternateNameActionPerformed
    public void afterInitComponents(){
        clearProv();
        //btnFont.setFont(new Font("Code 128AB",Font.PLAIN,12));
        
        tblSums.setBackground(new Color(222,222,222));
        int[] nrgnOrdersWidths = {100,100,220,120,120};
        int[] nrgnSumsWidths = {120,120,120};
        SharedUtils.setTableColumnsWidth(tblOrderGoods,nrgnOrdersWidths);
        
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString, true);
        String strSQL = "SELECT COMM_PRV1,COMM_PRV2,COMM_KEY FROM BASE_COMM";
        String[] str_rgn_columnNames ={"Prov.1","Prov.2"};
        SharedUtils.setTableDBModel(tblProvs, strSQL, str_rgn_columnNames);
        tblProvs.getTableHeader().setReorderingAllowed(false);
        tblProvs.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tblProvs.setVisible(false);
        scrProvs.setVisible(false);
        try{
            strSQL = "SELECT TYPE_NAME, TYPE_KEY  FROM BASE_DOC_TYPE ORDER BY TYPE_NAME";
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbDocTypes = new ComboDataModel(rsDBData);
            comboDocType.setModel(cdbDocTypes);
            rsDBData.close();
            stm.close();
        }catch(SQLException sqle){
            logErrToFile(sqle);
            SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
        }
        
        String str_rgn_columnNamesOrd[] = {"Stock Code","Abbr.","Stock Name","Count","Unit Price","Sum Price"};
        try{
            str_rgn_columnNamesOrd = Main.def_app_lang.loadTableHeader(tblOrderGoods);
        } catch(Exception e){
        }
        
        UniversalTableModel tbmOrderGoods = new UniversalTableModel(null,str_rgn_columnNamesOrd);
        tblOrderGoods.setModel(tbmOrderGoods);
        tblOrderGoods.getTableHeader().setReorderingAllowed(false);
        tblOrderGoods.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        Vector vecCellToEdit = new Vector();
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(true));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        ((UniversalTableModel)tblOrderGoods.getModel()).setEditableCells(vecCellToEdit);
        tblOrderGoods.updateUI();
        tblOrderGoods.getModel().addTableModelListener(this);
        
        String str_rgn_columnNamesActive[] = {"Order No","Date","Doc. Type","Netto","Total","Payed"};
        try{
            str_rgn_columnNamesActive = Main.def_app_lang.loadTableHeader(tblOrders);
        } catch(Exception e){
            
        }
        UniversalTableModel tbmOrders = new UniversalTableModel(null,str_rgn_columnNamesActive);
        tblOrders.setModel(tbmOrders);
        tblOrders.getTableHeader().setReorderingAllowed(false);
        tblOrders.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        int[] nrgnOrdersWidthsOrd = {200,200,200,120,160,120};
        SharedUtils.setTableColumnsWidth(tblOrders,nrgnOrdersWidthsOrd);
        
        dateVerifier = new UniversalInputVerifier(UniversalInputVerifier.UNI_DATE_VERIFIER,new Vector());
        editOrderDate.setInputVerifier(dateVerifier);
        editPayDate.setInputVerifier(dateVerifier);
        
        Vector vecParams = new Vector(2);
        vecParams.addElement(new Integer(0));
        vecParams.addElement(new Integer(250));
        strVerifier = new UniversalInputVerifier(UniversalInputVerifier.UNI_STRING_VERIFIER,vecParams);
        //editAlternateName.setInputVerifier(strVerifier);
        editOrderDate.setText(SharedUtils.getCurrentOnlyDateStringFormatted());
        editOperator.setText(SharedUtils.strUsername);
        tblOrders.getSelectionModel().addListSelectionListener(this);
        
        //TableColumn col = tblOrderGoods.getColumnModel().getColumn(STOCK_SUM_INDEX);
        UniversalTableCellRenderer uniRenderer = new UniversalTableCellRenderer();
        int rgn_n_aligns[][] = {{STOCK_COUNT_INDEX,JLabel.RIGHT},{STOCK_UNIT_INDEX,JLabel.RIGHT},{STOCK_UNIT_INDEX,JLabel.RIGHT}};
        uniRenderer.setAlignment(rgn_n_aligns);
        tblOrderGoods.setDefaultRenderer(String.class, uniRenderer);
        //col.setCellRenderer(uniRenderer);
        
        String str_rgn_columnNamesSums[] = {"","","","","",""};
        UniversalTableModel tbmSums = new UniversalTableModel(null,str_rgn_columnNamesActive);
        tblSums.setModel(tbmSums);
        int[] nrgnSumsWidthsOrd = {185,100,120};
        SharedUtils.setTableColumnsWidth(tblSums, nrgnSumsWidthsOrd);
        UniversalTableRow uniTableRow1 = null;
        UniversalTableRow uniTableRow2 = null;
        UniversalTableRow uniTableRow3 = null;
        UniversalTableRow uniTableRow4 = null;
        UniversalTableRow uniTableRow5 = null;
        UniversalTableRow uniTableRow6 = null;
        {
            Vector vecRow1 = new Vector();
            vecRow1.addElement("Netto");
            vecRow1.addElement("");
            vecRow1.addElement("0");
            uniTableRow1 = new UniversalTableRow(vecRow1);
            
            Vector vecRow2 = new Vector();
            vecRow2.addElement("Discount");
            vecRow2.addElement("");
            vecRow2.addElement("0");
            uniTableRow2 = new UniversalTableRow(vecRow2);
            
            Vector vecRow3 = new Vector();
            vecRow3.addElement("Porto");
            vecRow3.addElement("");
            vecRow3.addElement(getBdmPorto().toString());
            uniTableRow3 = new UniversalTableRow(vecRow3);
            //
            Vector vecRow4 = new Vector();
            vecRow4.addElement("Total");
            vecRow4.addElement("");
            vecRow4.addElement("0");
            uniTableRow4 = new UniversalTableRow(vecRow4);
            
            Vector vecRow5 = new Vector();
            vecRow5.addElement("VAT");
            vecRow5.addElement("");
            vecRow5.addElement("0");
            uniTableRow5 = new UniversalTableRow(vecRow5);
            
            Vector vecRow6 = new Vector();
            vecRow6.addElement("Total");
            vecRow6.addElement("EUR");
            vecRow6.addElement("0");
            uniTableRow6 = new UniversalTableRow(vecRow6);
        }
        
        try{
            Vector vecRow1 = new Vector();
            vecRow1.addElement(Main.def_app_lang.getSingleValue(LangPack.wordNetto));
            vecRow1.addElement("");
            vecRow1.addElement("0");
            uniTableRow1 = new UniversalTableRow(vecRow1);
            
            Vector vecRow2 = new Vector();
            vecRow2.addElement(Main.def_app_lang.getSingleValue(LangPack.wordDiscount));
            vecRow2.addElement("");
            vecRow2.addElement("0");
            uniTableRow2 = new UniversalTableRow(vecRow2);
            
            Vector vecRow3 = new Vector();
            vecRow3.addElement(Main.def_app_lang.getSingleValue(LangPack.wordPorto));
            vecRow3.addElement("");
            vecRow3.addElement(getBdmPorto().toString());
            uniTableRow3 = new UniversalTableRow(vecRow3);
            //
            Vector vecRow4 = new Vector();
            vecRow4.addElement(Main.def_app_lang.getSingleValue(LangPack.wordTotal));
            vecRow4.addElement("");
            vecRow4.addElement("0");
            uniTableRow4 = new UniversalTableRow(vecRow4);
            
            Vector vecRow5 = new Vector();
            vecRow5.addElement(Main.def_app_lang.getSingleValue(LangPack.wordVAT));
            vecRow5.addElement("");
            vecRow5.addElement("0");
            uniTableRow5 = new UniversalTableRow(vecRow5);
            
            Vector vecRow6 = new Vector();
            vecRow6.addElement(Main.def_app_lang.getSingleValue(LangPack.wordTotalSum));
            vecRow6.addElement("EUR");
            vecRow6.addElement("0");
            uniTableRow6 = new UniversalTableRow(vecRow6);
        } catch(Exception e){
            
        }
        
        ((UniversalTableModel)tblSums.getModel()).addObject(uniTableRow1);
        ((UniversalTableModel)tblSums.getModel()).addObject(uniTableRow2);
        ((UniversalTableModel)tblSums.getModel()).addObject(uniTableRow3);
        ((UniversalTableModel)tblSums.getModel()).addObject(uniTableRow4);
        ((UniversalTableModel)tblSums.getModel()).addObject(uniTableRow5);
        ((UniversalTableModel)tblSums.getModel()).addObject(uniTableRow6);
        TableColumn col = tblSums.getColumnModel().getColumn(VALUE_COL_INDEX);
        col.setCellRenderer(new OrderPortoTableRenderer());
        javax.swing.JTextField txtEditorField = new javax.swing.JTextField();
        txtEditorField.setFont( new java.awt.Font("Tahoma", 1, 13) );
        
        txtEditorField.addFocusListener(new FocusListener(){
            public void focusLost(FocusEvent tev){
                try{
                    
                    JTextField f = ((JTextField)tev.getComponent());
                    f.postActionEvent();
                    
                } catch(Exception e){
                    e.printStackTrace();
                }
            }
            public void focusGained(FocusEvent evt){
                
            }
        });
        
        javax.swing.DefaultCellEditor cellEditor = new javax.swing.DefaultCellEditor( txtEditorField );
        col.setCellEditor(cellEditor);
        
        UniversalTableCellRenderer uniRendererSums = new UniversalTableCellRenderer();
        int rgn_n_alignsSums[][] = {{0,JLabel.LEFT},{1,JLabel.CENTER},{VALUE_COL_INDEX,JLabel.RIGHT}};
        uniRendererSums.setAlignment(rgn_n_alignsSums);
        
        
        tblSums.setDefaultRenderer(String.class, uniRendererSums);
        tblSums.getModel().addTableModelListener(this);
        vecCellToEdit = new Vector();
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(true));
        ((UniversalTableModel)tblSums.getModel()).setEditableCells(vecCellToEdit);
        
        vecCellToEdit = new Vector();
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(true));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        ((UniversalTableModel)tblSums.getModel()).setEditableCellsRows(vecCellToEdit);
        
        //tempPanel.setVisible(false);
        //ait
        placeControls4Invoice();
        UIUtils.setTableFonts(tblOrderGoods);
        UIUtils.setTableFonts(tblOrders);
        ((ComboDataModel)comboDocType.getModel()).selectIndexByKey(1);
        
        UIUtils.setHorizontalAlignment(tblOrders, 3, javax.swing.JTextField.RIGHT );
        UIUtils.setHorizontalAlignment(tblOrders, 4, javax.swing.JTextField.RIGHT );
        UIUtils.setHorizontalAlignment(tblOrders, 5, javax.swing.JTextField.RIGHT );
        
        UIUtils.setHorizontalAlignment(tblOrderGoods, 0, javax.swing.JTextField.LEFT );
        UIUtils.setHorizontalAlignment(tblOrderGoods, 1, javax.swing.JTextField.LEFT );
        UIUtils.setHorizontalAlignment(tblOrderGoods, 2, javax.swing.JTextField.LEFT );
        UIUtils.setHorizontalAlignment(tblOrderGoods, 3, javax.swing.JTextField.RIGHT );
        UIUtils.setHorizontalAlignment(tblOrderGoods, 4, javax.swing.JTextField.RIGHT );
        UIUtils.setHorizontalAlignment(tblOrderGoods, 5, javax.swing.JTextField.RIGHT );
        
        //set width
        UIUtils.setColumnWidth( tblOrderGoods, 2, 200 );
        UIUtils.setColumnWidth( tblOrderGoods, 0, 90 );
        UIUtils.setColumnWidth( tblOrders, 1, 330 );
        
        editProv1Pers.setInputVerifier( new UniversalInputVerifier(SharedConstants.SCALED2_PERSENT,new Vector()) );
        editProv2Pers.setInputVerifier( new UniversalInputVerifier(SharedConstants.SCALED2_PERSENT,new Vector()) );
        Vector minMaxVector = new Vector();
        minMaxVector.add( new Integer(0) );
        minMaxVector.add( new Integer(50) );
        //editDiscount.setInputVerifier( new UniversalInputVerifier( SharedConstants.UNI_SCALED2_PARAMS, minMaxVector ) );
        
        tbpOrders.setEnabledAt( 1, false );
        tbpOrders.setEnabledAt( 2, false );
        edpInvoice.setEditable(false);
        edpPackings.setEditable(false);
        
        
        editDiscount.addFocusListener(new FocusListener(){
            public void focusLost(FocusEvent evt){
                discountChange();
            }
            public void focusGained(FocusEvent evt){
                
                
            }
        });
        
        
    }
    
    private void loadClientInfo(Vector vecPatientSearchResults){
        clearProv();
        String strUIN = (String)vecPatientSearchResults.get(0);
        loadClientOrders(strUIN);
        try{
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT base_prsn.prsn_lnam, base_prsn.prsn_fnam, base_prsn.prsn_appl," +
                    " base_prsn_type.type_abbr, base_prsn.prsn_dscn, base_prsn.prsn_info, " +
                    " base_prsn.alow_prch, base_cntr.cntr_name, base_prsn.prsn_city, " +
                    " base_prsn.city_code, base_prsn.prsn_strt, base_prsn.prv1_idnt, " +
                    " base_prsn.prv1_comm, base_prsn.prv2_idnt, base_prsn.prv2_comm, " +
                    " base_cntr.cntr_vat,base_prsn.cntr_idnt, base_prsn.clcode, base_prsn.vatfree, " +
                    " altr_name,base_cntr.cntr_no_vat, base_cntr.cntr_no_vat_code, base_cntr.cntr_vat_code," +
                    " base_cntr.cntr_code, base_cntr.cntr_code_free " +
                    " FROM base_prsn INNER JOIN " +
                    " base_prsn_type ON base_prsn.type_idnt = base_prsn_type.type_key INNER JOIN " +
                    " base_cntr ON base_prsn.cntr_idnt = base_cntr.cntr_key" +
                    " WHERE base_prsn.prsn_key = " + strUIN;
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            boolean bMore = rsDBData.next();
            if(!bMore){
                JOptionPane.showMessageDialog(null,"Error while loading client information.Client Data Corrupted!");
                return;
            }
            
            String strSurname = SharedUtils.readStringTrimmed( rsDBData, 1);
            String strFirstName = SharedUtils.readStringTrimmed( rsDBData, 2);
            String strAppeal = SharedUtils.readStringTrimmed( rsDBData, 3);
            String strType = rsDBData.getString(4);
            
            String strDiscount = rsDBData.getString(5);
            strDiscount = BigDec.scaledRoundHalfUp(strDiscount,2);
            
            String strPrsnInfo = rsDBData.getString(6);
            String strCanPurchase = rsDBData.getString(7);
            String strCountry = SharedUtils.readStringTrimmed( rsDBData, 8);
            String strCity = SharedUtils.readStringTrimmed( rsDBData, 9);
            String strCode = rsDBData.getString(10);
            String strStreet = SharedUtils.readStringTrimmed( rsDBData, 11);
            String strProv1Idnt = rsDBData.getString(12);
            
            String strProv1Comm = rsDBData.getString(13);
            strProv1Comm = BigDec.scaledRoundHalfUp(strProv1Comm,2);
            
            String strProv2Idnt = rsDBData.getString(14);
            String strProv2Comm = rsDBData.getString(15);
            strProv2Comm = BigDec.scaledRoundHalfUp(strProv2Comm,2);
            
            String strVat = rsDBData.getString(16);
            this.strCountryID =rsDBData.getString(17);
            this.fVat = Float.parseFloat(strVat);
            String strCLCode = rsDBData.getString(18);
            String strVatFree = rsDBData.getString(19);
            String strAltName = SharedUtils.readStringTrimmed( rsDBData, 20 );
            float strNoVat = rsDBData.getFloat(21);
            
            //c_abbr = rsDBData.getString("abbr");
            c_name = rsDBData.getString("cntr_name");
            /* Start Init VatTaxData */
            
            float cntr_vat = Float.parseFloat(rsDBData.getString("cntr_vat"));
            int cntr_vat_code = rsDBData.getInt("cntr_vat_code");
            float cntr_no_vat = Float.parseFloat(rsDBData.getString("cntr_no_vat"));
            int cntr_no_vat_code = rsDBData.getInt("cntr_no_vat_code");
            String vatfree = rsDBData.getString("vatfree");
            int cntr_code = rsDBData.getInt("cntr_code");
            int cntr_code_free = rsDBData.getInt("cntr_code_free");
            
            ctdata = new VatTaxData(cntr_vat,cntr_vat_code, cntr_code, cntr_no_vat,cntr_no_vat_code, cntr_code_free,vatfree);
            
            /* End Init VatTaxData */
            
            if( "Y".equals(strVatFree) ) {
                this.fVat = strNoVat;
                strVat = ""+strNoVat;
            }
            
            strDiscount = BigDec.scaledRoundHalfUp(strDiscount,2);
            tblSums.getModel().setValueAt(strDiscount+"%", DISCOUNT_INDEX, 1);
            tblSums.getModel().setValueAt(strVat+"%", VAT_INDEX, 1);
            
            editAppeal.setText(strAppeal);
            editFirstName.setText(strFirstName);
            editSurname.setText(strSurname);
            editType.setText(strType);
            editDiscount.setText(strDiscount);
            editCountry.setText(strCountry);
            editCity.setText(strCity);
            editCode.setText(strCode);
            editStreet.setText(strStreet);
            editUIN.setText(strUIN);
            edpInfo.setText(strPrsnInfo);
            editAlternateName.setText(strAltName);
            
            chkbCanPurchase.setSelected(strCanPurchase.equalsIgnoreCase("Y"));
            
            customer = null;
            customer = new CustomerActor();
            customer.canPrucahse(strCanPurchase.equalsIgnoreCase("Y"));
            canPurchase(customer.canPrucahse());
            
            chkVatFree.setSelected( "Y".equals(strVatFree) );
            editCLCode.setText( strCLCode );
            
            rsDBData.close();
            stm.close();
            
            // TODO getSqlSelectPersonNamesById
            if( strProv1Idnt != null ) {
                strSQL = SharedUtils.dbSettings.getSqlSelectPersonNamesById(strProv1Idnt);
                stm = connDB.createStatement();
                rsDBData=stm.executeQuery(strSQL);
                bMore = rsDBData.next();
                if(bMore){
                    String strProv1Name = rsDBData.getString(1);
                    editProv1UIN.setText(strProv1Idnt);
                    editProv1Name.setText(strProv1Name);
                    editProv1Pers.setText(BigDec.scaledRoundHalfUp(strProv1Comm,2));
                }
                rsDBData.close();
                stm.close();
            } else {
                editProv1UIN.setText("");
                editProv1Name.setText("");
                editProv1Pers.setText("0.00");
            }
            
            // TODO getSqlSelectPersonNamesById
            if( strProv2Idnt != null ) {
                strSQL = SharedUtils.dbSettings.getSqlSelectPersonNamesById(strProv2Idnt);
                stm = connDB.createStatement();
                rsDBData=stm.executeQuery(strSQL);
                bMore = rsDBData.next();
                if(bMore){
                    String strProv2Name = rsDBData.getString(1);
                    editProv2UIN.setText(strProv2Idnt);
                    editProv2Name.setText(strProv2Name);
                    editProv2Pers.setText(BigDec.scaledRoundHalfUp(strProv2Comm,2));
                }
                rsDBData.close();
                stm.close();
            } else {
                editProv2UIN.setText("");
                editProv2Name.setText("");
                editProv2Pers.setText("0.00");
            }
            
            m_prov3Data.clear();
            m_prov3Data = SharedUtils.executeSqlScalarList( " select prv3_idnt, prv3_comm from " +
                    " base_prsn where prsn_key=" + strUIN );
            
        }catch(SQLException sqle){
            logErrToFile(sqle);
            SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
        }
        
    }
    
    private void calculateSums( boolean correctPorto ) throws Exception{
        if( !m_bCalculateSums ) {
            m_bCalculateSums = true;
            return;
        }
        
        BigDecimal bdmNetto = new BigDecimal(0.0);
        String strDiscount = editDiscount.getText();
        
        try{
            if(strDiscount.equals(""))
                strDiscount = "0";
        } catch(Exception e){
            strDiscount = "0";
        }
        
        BigDecimal bdmDiscountPers = new BigDecimal(0);
        try{
            bdmDiscountPers = new BigDecimal(strDiscount);
        } catch(Exception e){
            
        }
        
        String strVat = String.valueOf(this.fVat);
        BigDecimal bdmVatPers = new BigDecimal(0);
        try{
            bdmVatPers = new BigDecimal(strVat);
        } catch(Exception e){
            
        }
        bdmVatPers = bdmVatPers.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal bdmTotal = new BigDecimal(0.0);
        BigDecimal bdmTotalWithoutVat = new BigDecimal(0.0);
        
        int nStockCount = tblOrderGoods.getRowCount();
        
        for(int i=0 ; i< nStockCount; i++) {
            try{
                BigDecimal bdmSum = new BigDecimal((String)tblOrderGoods.getModel().getValueAt(i, STOCK_SUM_INDEX));
                bdmNetto = bdmNetto.add(bdmSum);
            } catch(Exception e){
                logErrToFile(e);
            }
        }
        bdmNetto = bdmNetto.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal bdmPorto = new BigDecimal( this.dPorto );
        BigDecimal bdmDiscount = bdmNetto.multiply( bdmDiscountPers ).divide(new BigDecimal(100.0),3,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal discNeto = new BigDecimal(bdmNetto.doubleValue() - bdmDiscount.doubleValue());
        //fix ait .Discount for purchases above SharedUtils.discountSum
        if( SharedUtils.discountSum >= 0 && Math.abs( discNeto.doubleValue() ) >= SharedUtils.discountSum && correctPorto ) {
            bdmPorto = new BigDecimal( 0.0 );
            m_bCalculateSums = false;
            tblSums.getModel().setValueAt("0.00", PORTO_INDEX, VALUE_COL_INDEX);
            
        } else{
            if(correctPorto && Math.abs( discNeto.doubleValue() ) < SharedUtils.discountSum)
                tblSums.getModel().setValueAt("4.50", PORTO_INDEX, VALUE_COL_INDEX);
        }
        BigDecimal subTotal = new BigDecimal(discNeto.doubleValue() + bdmPorto.doubleValue());
        subTotal = subTotal.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal dVat = subTotal.multiply(bdmVatPers).divide( new BigDecimal(100.0), 3, BigDecimal.ROUND_HALF_UP );
        bdmTotal = new BigDecimal(subTotal.doubleValue() + dVat.doubleValue());
        bdmTotal = bdmTotal.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        dVat = dVat.setScale(2,BigDecimal.ROUND_HALF_UP);
        if( lblInvoice.isVisible() )
            bdmDiscount = new BigDecimal( Math.abs(bdmDiscount.doubleValue()) );
        else
            bdmDiscount = new BigDecimal( - Math.abs(bdmDiscount.doubleValue()) );
        
        bdmDiscount = bdmDiscount.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        bdmPorto = bdmPorto.setScale(2,BigDecimal.ROUND_HALF_UP);
        bdmTotalWithoutVat = bdmTotalWithoutVat.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        String strNetto = bdmNetto.toString();
        String strDiscountValue = bdmDiscount.toString();
        String strVatValue = dVat.toString();
        String strTotal = bdmTotal.toString();
        String strTotalWithoutVat = subTotal.toString();
        
        // if we have credit note
        if( lblInvoice.isVisible() ) {
            strNetto = negate(strNetto);
            strTotal = negate(strTotal);
            strTotalWithoutVat = negate(strTotalWithoutVat);
            strVatValue = negate( strVatValue);
        } else {
            strDiscountValue = negate(strDiscountValue);
        }
        strDiscount = BigDec.scaledRoundHalfUp(strDiscount,2);
        tblSums.getModel().setValueAt(strNetto, NETTO_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt(strDiscountValue, DISCOUNT_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt(strDiscount+"%", DISCOUNT_INDEX, 1);
        tblSums.getModel().setValueAt(strTotalWithoutVat, TOTAL_WITHOUT_VAT, VALUE_COL_INDEX );
        tblSums.getModel().setValueAt(strVatValue, VAT_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt(bdmVatPers.toString()+"%", VAT_INDEX, 1 );
        tblSums.getModel().setValueAt(strTotal, TOTAL_INDEX, VALUE_COL_INDEX);
    }
    
    
    private String negate(String str) throws Exception{
        if(str == null)
            return str;
        str = str.trim();
        if( !str.equals("") && !str.equals("0") && !str.startsWith("-") ) {
            if( Float.parseFloat(str) > 0  )
                return "-" + str;
        }
        //if( str.startsWith("-") )
        //    return str.substring(1);
        return str;
    }
    
    private void loadClientOrders(String strPersonID){
        ((UniversalTableModel)tblOrders.getModel()).clearData();
        String strSQL = " SELECT V_NR, INVC_DATE, TYPE_NAME, " +
                " NETO_SUM, TOTL_SUM, PAY_SUM " + //DOC_TYPE_IDNT
                " FROM VORGANG INNER JOIN BASE_DOC_TYPE ON " +
                " (VORGANG.DOC_TYPE_IDNT = BASE_DOC_TYPE.TYPE_KEY) " +
                " WHERE PATN_IDNT = " + strPersonID +
                " ORDER BY INVC_DATE DESC";
        try{
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            Statement stm = connDB.createStatement();
            ResultSet rs = stm.executeQuery(strSQL);
            ((UniversalTableModel)tblOrders.getModel()).addSQLResult(rs);
            
            rs.close();
            stm.close();
            tblOrders.updateUI();
        }catch(SQLException sqle){
            logErrToFile(sqle);
            SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
        }
        
        strSQL = " SELECT V_NR, DOC_TYPE_IDNT " +
                " FROM VORGANG " +
                " WHERE PATN_IDNT = " + strPersonID;
        try{
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            Statement stm = connDB.createStatement();
            ResultSet rs = stm.executeQuery(strSQL);
            HashSet creditNoteIDs = new HashSet();
            while(rs.next()) {
                String v_nr = rs.getString(1);
                String dtype = rs.getString(2);
                if(dtype.equals("2")) {
                    creditNoteIDs.add(v_nr);
                }
            }
            UniversalTableModel model = ((UniversalTableModel)tblOrders.getModel());
            for( int i = 0; i < model.getRowCount(); i++ ) {
                String v_nr = (String)model.getValueAt(i, 0);
                if(!creditNoteIDs.contains(v_nr))
                    continue;
                String price = (String)model.getValueAt(i,3);
                try {
                    if( Double.parseDouble(price) > 0 );
                    model.setValueAt("-"+price, i, 3);
                } catch(Exception e) {
                    logErrToFile(e);
                }
                price = (String)model.getValueAt(i,4);
                try {
                    if( Double.parseDouble(price) > 0 );
                    model.setValueAt("-"+price, i, 4);
                } catch(Exception e) {
                    logErrToFile(e);
                }
            }
            rs.close();
            stm.close();
            tblOrders.updateUI();
        } catch(SQLException sqle) {
            logErrToFile(sqle);
            SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
        }
    }
    
    private void loadOrderInfo(String strOrderIdnt) {
        clearProv();
        try {
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = " SELECT  base_prsn.prsn_lnam, base_prsn.prsn_fnam, " +
                    " base_prsn.prsn_info ,base_prsn.prsn_appl," +
                    " base_prsn_type.type_abbr , " +
                    " base_user.user_name , vorgang.prv1_comm, vorgang.prv2_comm," +
                    " vorgang.patn_idnt, vorgang.patn_dscn, vorgang.prv1_idnt, " +
                    " vorgang.prv2_idnt, vorgang.invc_addr, vorgang.doc_type_idnt, vorgang.invc_date," +
                    " vorgang.pay_date, vorgang.pay_sum, vorgang.neto_sum," +
                    " vorgang.vat_pers, vorgang.totl_sum,vorgang.invc_prto, vorgang.altr_name, vorgang.patn_cntr," +
                    " vorgang.patn_city, vorgang.patn_code, vorgang.patn_strt,base_prsn.alow_prch,base_prsn.clcode," +
                    " base_prsn.vatfree, vorgang.invoiceid, vorgang.vatcode, vorgang.cntr_code " +
                    " FROM  base_prsn_type INNER JOIN " +
                    " base_prsn ON base_prsn_type.type_key = base_prsn.type_idnt INNER JOIN " +
                    " vorgang ON base_prsn.prsn_key = vorgang.patn_idnt INNER JOIN " +
                    " base_user ON vorgang.oper_idnt = base_user.user_key" +
                    " WHERE vorgang.v_nr = " + strOrderIdnt;
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            boolean bMore = rsDBData.next();
            if(!bMore) {
                JOptionPane.showMessageDialog(null,"Error while loading order information.Order Data Corrupted!");
                return;
            }
            
            String strSurname = SharedUtils.readStringTrimmed( rsDBData, 1);
            String strFirstName = SharedUtils.readStringTrimmed( rsDBData, 2);
            String strPrsnInfo = SharedUtils.readStringTrimmed( rsDBData, 3);
            String strAppeal = SharedUtils.readStringTrimmed( rsDBData, 4 );
            String strPrsnType = SharedUtils.readStringTrimmed( rsDBData, 5);
            String strOperator = rsDBData.getString(6);
            
            String strProv1Comm = rsDBData.getString(7);
            strProv1Comm = BigDec.scaledRoundHalfUp(strProv1Comm,2);
            
            String strProv2Comm = rsDBData.getString(8);
            strProv2Comm = BigDec.scaledRoundHalfUp(strProv2Comm,2);
            
            String strPersonIdnt = rsDBData.getString(9);
            
            String strDiscount = rsDBData.getString(10);
            strDiscount = BigDec.scaledRoundHalfUp(strDiscount,2);
            
            String strProv1Idnt = rsDBData.getString(11);
            String strProv2Idnt = rsDBData.getString(12);
            String strInvoiceAddress = SharedUtils.readStringTrimmed( rsDBData, 13);
            int  nDocTypeIdnt = rsDBData.getInt(14);
            Timestamp tmsp = rsDBData.getTimestamp(15);
            String strOrderDate = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_ONLY_DATE);
            tmsp = rsDBData.getTimestamp(16);
            String strPayDate = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_ONLY_DATE);
            String strPaySum = rsDBData.getString(17);
            String strNettoSum = rsDBData.getString(18);
            String strVatPers = rsDBData.getString(19);
            this.fVat = Float.parseFloat(strVatPers);
            String strTotalSum = rsDBData.getString(20);
            String strPorto = rsDBData.getString(21);
            this.dPorto = Double.parseDouble(strPorto);
            String strAlternateName = SharedUtils.readStringTrimmed( rsDBData, 22);
            String strCountry = SharedUtils.readStringTrimmed( rsDBData, 23);
            String strCity = SharedUtils.readStringTrimmed( rsDBData, 24 );
            String strCode = SharedUtils.readStringTrimmed( rsDBData, 25);
            String strStreet = SharedUtils.readStringTrimmed( rsDBData, 26);
            String strCanPurchase = rsDBData.getString(27);
            String strClCode = rsDBData.getString(28);
            String strVATFree = rsDBData.getString(29);
            String strInvoiceNo = rsDBData.getString(30);
            
            c_name = rsDBData.getString("patn_cntr");
            
            float cntr_vat = Float.parseFloat(rsDBData.getString("vat_pers"));
            int cntr_vat_code = rsDBData.getInt("vatcode");
            int cntr_code = rsDBData.getInt("cntr_code");
            
            ctdata = new VatTaxData(cntr_vat,cntr_vat_code, cntr_code);
            
            /*if( "Y".equals(strVATFree) ) {
                this.fVat = 0.0f;
                strVatPers = "0";
            }
             */
            rsDBData.close();
            stm.close();
            dlgAlternateAddress.setAddress( strInvoiceAddress == null ? "" : strInvoiceAddress);
            editInvoiceNum.setText(strInvoiceNo);
            editCLCode.setText( strClCode );
            chkVatFree.setSelected( "Y".equals(strVATFree) );
            editAppeal.setText(strAppeal);
            editFirstName.setText(strFirstName);
            editSurname.setText(strSurname);
            editType.setText(strPrsnType);
            editDiscount.setText(strDiscount);
            editAlternateName.setText( strAlternateName );
            editCountry.setText(strCountry);
            editCity.setText(strCity);
            editCode.setText(strCode);
            editStreet.setText(strStreet);
            editUIN.setText(strPersonIdnt);
            edpInfo.setText(strPrsnInfo);
            if(strCanPurchase.equals("Y"))
                chkbCanPurchase.setSelected(true);
            else
                chkbCanPurchase.setSelected(false);
            
            editProv1UIN.setText(strProv1Idnt);
            //editProv1Name.setText(strProv1Name);
            editProv1Pers.setText(BigDec.scaledRoundHalfUp(strProv1Comm, 2));
            editProv2UIN.setText(strProv2Idnt);
            //editProv2Name.setText(strProv2Name);
            editProv2Pers.setText(BigDec.scaledRoundHalfUp(strProv2Comm,2));
            // TODO getSqlSelectPersonNamesById
            String sql = SharedUtils.dbSettings.getSqlSelectPersonNamesById(strProv1Idnt);
            String str = SharedUtils.executeSqlScalar(sql);
            if( str == null )
                str = "";
            editProv1Name.setText( str );
            // TODO getSqlSelectPersonNamesById
            sql = SharedUtils.dbSettings.getSqlSelectPersonNamesById(strProv2Idnt);
            str = SharedUtils.executeSqlScalar(sql);
            if( str == null )
                str = "";
            editProv2Name.setText( str );
            if(strInvoiceAddress == null) {
                btnSet.setText("View Address");
                btnSet.setEnabled(false);
                chkbAltAddress.setSelected(false);
            } else {
                chkbAltAddress.setSelected(true);
                btnSet.setText("View Address");
                btnSet.setEnabled(true);
            }
            editOrderDate.setText(strOrderDate);
            editDocNo.setText(strOrderIdnt);
            ((ComboDataModel)comboDocType.getModel()).selectIndexByKey(nDocTypeIdnt);
            editOperator.setText(strOperator);
            editPayed.setText(strPaySum);
            editPayDate.setText(strPayDate);
            ((UniversalTableModel)tblOrderGoods.getModel()).clearData();
            // load stocks
            strSQL = " SELECT base_stck.stck_brcd, base_stck.stck_abrv," +
                    " base_stck.stck_name, position.p_menge, position.unit_pric,position.sum_pric, base_stck.stck_key " +
                    " FROM  vorgang INNER JOIN " +
                    " position ON vorgang.v_nr = position.v_nr INNER JOIN" +
                    " base_stck ON position.nstk_idnt = base_stck.stck_key  " +
                    " WHERE vorgang.v_nr = " + strOrderIdnt +
                    " order by position.p_pos asc";
            
            connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            stm = connDB.createStatement();
            rsDBData = stm.executeQuery(strSQL);
            ((UniversalTableModel)tblOrderGoods.getModel()).addSQLResult(rsDBData);
            rsDBData.close();
            stm.close();
            tblOrderGoods.updateUI();
            this.dPorto = Double.parseDouble(strPorto);
            strPorto = "" + ( ((double)Math.round( this.dPorto * 100 )) / 100);
            if(nDocTypeIdnt == 1) {
                placeControls4Invoice();
            } else {
                strPorto = "-" + strPorto;
                this.dPorto = -this.dPorto;
                placeControls4CreditNote();
                UniversalTableModel model = (UniversalTableModel)tblOrderGoods.getModel();
                for( int i = 0; i < model.getRowCount(); i++ ) {
                    String sprice = (String)model.getValueAt(i,4);
                    String price = (String)model.getValueAt(i,5);
                    if( sprice != null && !sprice.equals("") )
                        model.setValueAt( "-" + sprice, i, 4 );
                    if( price != null && !price.equals("") )
                        model.setValueAt( "-" + price, i, 5 );
                    
                }
                ((UniversalTableModel)tblOrderGoods.getModel()).fireTableDataChanged();
            }
            tblSums.getModel().setValueAt(strPorto, PORTO_INDEX, VALUE_COL_INDEX);
            // the porto is set out of calculateSums because this function is executed in tableChange event
            // and is modifying the table model in the same time...
            try{
                calculateSums(false);
            } catch(Exception e){
                JOptionPane.showMessageDialog(null,"Warning: System detect that some fields has no absolutely correct data!\nPlease validate sums calculations!", "Warning", JOptionPane.WARNING_MESSAGE, null);
            }
            tbpOrders.setEnabledAt( 1, true );
            tbpOrders.setEnabledAt( 2, strInvoiceAddress != null );
            
            editableCellProto(false);
            
        } catch(SQLException sqle) {
            logErrToFile(sqle);
            SharedUtils.handleError(SharedConstants.GENERAL_DB_ERROR);
        }
    }
    private void editableCellProto(boolean value){
        Vector vecCellToEdit = new Vector();
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(value));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        vecCellToEdit.addElement(new Boolean(false));
        ((UniversalTableModel)tblSums.getModel()).setEditableCellsRows(vecCellToEdit);
    }
    private void clearControls(){
        chkbAltAddress.setSelected(false);
        btnSet.setText("Set Address");
        btnSet.setEnabled(false);
        dlgAlternateAddress.setAddress("");
        
        editNewStock.setText("");
        editCount.setText("");
        ((UniversalTableModel)tblOrderGoods.getModel()).clearData();
        tblOrderGoods.updateUI();
        editDocNo.setText("");
        comboDocType.setSelectedIndex(0);
        editPayed.setText("");
        editPayDate.setText("");
        
        tblSums.getModel().setValueAt("0", NETTO_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt("0", DISCOUNT_INDEX, VALUE_COL_INDEX);
        //m_bCalculateSums = false;
        tblSums.getModel().setValueAt("0", PORTO_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt("0", TOTAL_WITHOUT_VAT, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt("0", VAT_INDEX, VALUE_COL_INDEX);
        tblSums.getModel().setValueAt("0", TOTAL_INDEX, VALUE_COL_INDEX);
    }
    
    private void placeControls4Invoice() {
        editInvoiceNum.setVisible(false);
        lblInvoice.setVisible(false);
        
        lblDate.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDate.setForeground(javax.swing.UIManager.getDefaults().getColor("close_button_highlight"));
        lblDate.setText("Date");
        lblDate.setBounds(10, 20, 50, 18);
        
        lblDocNum.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocNum.setText("Document No.");
        lblDocNum.setBounds(130, 20, 130, 18);
        
        lblDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocType.setForeground(javax.swing.UIManager.getDefaults().getColor("close_button_highlight"));
        lblDocType.setText("Document Type");
        lblDocType.setBounds(270, 20, 110, 18);
        
        lblOper.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblOper.setText("Operator");
        lblOper.setBounds(430, 20, 80, 18);
        
        editOrderDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOrderDate.setBounds(10, 40, 90, 21);
        
        editDocNo.setEditable(false);
        editDocNo.setFont(new java.awt.Font("Tahoma", 0, 13));
        editDocNo.setEnabled(false);
        editDocNo.setBounds(130, 40, 90, 21);
        
        comboDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboDocType.setEnabled(false);
        comboDocType.setBounds(270, 40, 110, 22);
        
        editOperator.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOperator.setEnabled(false);
        editOperator.setBounds(430, 40, 90, 21);
        translate();
    }
    
    private void placeControls4CreditNote() {
        editInvoiceNum.setVisible(true);
        lblInvoice.setVisible(true);
        
        lblDate.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDate.setForeground(javax.swing.UIManager.getDefaults().getColor("close_button_highlight"));
        lblDate.setText("Date");
        lblDate.setBounds(10, 20, 50, 18);
        
        lblDocNum.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocNum.setText("Document No.");
        lblDocNum.setBounds(95, 20, 125, 18);
        
        lblInvoice.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblInvoice.setText("Invoice No.");
        lblInvoice.setBounds(225, 20, 110, 18);
        
        lblDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblDocType.setForeground(javax.swing.UIManager.getDefaults().getColor("close_button_highlight"));
        lblDocType.setText("Document Type");
        lblDocType.setBounds(335, 20, 110, 18);
        
        lblOper.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblOper.setText("Operator");
        lblOper.setBounds(450, 20, 80, 18);
        
        editOrderDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOrderDate.setBounds(10, 40, 80, 21);
        
        editDocNo.setEditable(false);
        editDocNo.setFont(new java.awt.Font("Tahoma", 0, 13));
        editDocNo.setEnabled(false);
        editDocNo.setBounds(95, 40, 90, 21);
        
        editInvoiceNum.setEditable(false);
        editInvoiceNum.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editInvoiceNum.setPreferredSize(new java.awt.Dimension(62, 21));
        editInvoiceNum.setBounds(225, 40, 100, 21);
        
        comboDocType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboDocType.setEnabled(false);
        comboDocType.setBounds(335, 40, 110, 22);
        
        editOperator.setFont(new java.awt.Font("Tahoma", 0, 13));
        editOperator.setEnabled(false);
        editOperator.setBounds(450, 40, 90, 21);
        translate();
    }
    
    private void printLabel(boolean bInvoice) {
        try {
            String content = "";
            if( bInvoice ) {
                String strAppeal = editAppeal.getText().replaceAll("\n","");
                String strFirstName = editFirstName.getText().replaceAll("\n","");
                String strLastName = editSurname.getText().replaceAll("\n","");
                String strStreet = editStreet.getText().replaceAll("\n","");
                String strCode = editCode.getText().replaceAll("\n","");
                String strCity = editCity.getText().replaceAll("\n","");
                
                String address = strStreet  + "\r\n" + strCode + " " + strCity;
                content = strAppeal + "\r\n" + strFirstName + " " + strLastName + "\r\n" + address;
            } else {
                String altAddress = this.dlgAlternateAddress.getAddress();
                if( altAddress == null )
                    altAddress = "";
                StringTokenizer tokenizer = new StringTokenizer( altAddress, "\n");
                int numLines = 0;
                while( tokenizer.hasMoreTokens() ) {
                    numLines++;
                    String tok = tokenizer.nextToken();
                    tok = tok.replaceAll( "\r", "" );
                    if( numLines >= 4 )
                        content += tok + " ";
                    else
                        content += tok + "\r\n";
                }
                
                for( int i = numLines + 1; i < 4; i++ )
                    content += "\r\n";
            }
            
            String text = "\r\n" + (char)0x0F + (char)0x1B;
            text += "S" + (char)0x01 + "Heerenweg 251 /  6414 AJ Heerlen NL";
            text += "\r\n" + (char)0x1B;
            text += "T" + (char)0x1B + "S" + (char)0x00 + "___________________________________";
            text += "\r\n" + (char)0x1B;
            text += "T" + (char)0x12 + "\r\n\r\n";
            text += content;
            text += "\r\n\r\n\r\n\r\n" + (char)0x1A;
            
            // create text file
            String userHomePath = (String)System.getProperty("user.home");
            String pathSeparator = "/";
            String lineSep = (String)System.getProperty("line.separator");
            String fullName = userHomePath + pathSeparator + "ETIKET.TXT";
            FileOutputStream stream = new FileOutputStream( fullName );
            stream.write( text.getBytes("UNICODE") );
            stream.close();
            
            //create bat file if not exists
            String batFileName = userHomePath + pathSeparator + "startprint.bat";
            File batFile = new File(batFileName);
            
            FileOutputStream ostream = new FileOutputStream( batFile );
            ostream.write( ("cd " + userHomePath + lineSep +
                    "type etiket.txt > lpt1").getBytes() );
            ostream.flush();
            ostream.close();
            
            Runtime rt = Runtime.getRuntime();
            rt.exec( batFileName );
            JOptionPane.showMessageDialog( null, "Label has been sent to the printer." );
        } catch(Exception e) {
            logErrToFile(e);
            JOptionPane.showMessageDialog( null, "Label cannot be generated! :" +
                    e.getMessage() );
            return;
        }
        
    }
    
    private void print( JEditorPane txtPane ) {
        PrintUtilities printUtilities = new PrintUtilities((Component)txtPane,-2.5);
        //////
        PrinterJob printerJob = PrinterJob.getPrinterJob();
        PageFormat pageFormat = printerJob.defaultPage();
        Paper paper = new Paper();
        paper.setImageableArea( 28.346456692913385, 28.346456692913385,
                538.5826771653543, 785.1968503937007 );
        paper.setSize( 595.275590551181, 841.8897637795276 );
        pageFormat.setPaper( paper );
        //pageFormat = printerJob.pageDialog(pageFormat);
        ////
        ComponentPageable componentPagable = new ComponentPageable((Component)txtPane, pageFormat, (Printable)printUtilities);
        printerJob.setPageable(componentPagable);
        try {
            //if(printerJob.printDialog()) {
            printerJob.print();
            //}
        } catch(Exception ex) {
            logErrToFile(ex);
            JOptionPane.showMessageDialog(null,"There is a problem with your printer!");
            return;
        }
    }
    
    public void clearProv(){
        editProv1UIN.setText("");
        editProv2UIN.setText("");
        
        editProv1Name.setText("");
        editProv2Name.setText("");
        
        editProv1Pers.setText("0.00");
        editProv2Pers.setText("0.00");
        //m_prov3Data.clear();
    }
    private boolean checkProvs() throws Exception{
        boolean ok = UniversalInputVerifier.Universal_Integer_Verifier(editProv1UIN) && UniversalInputVerifier.Universal_Integer_Verifier(editProv2UIN);
        if(!ok){
            throw new Exception("Please select both  Provision1 and Provision2!");
        }
        return true;
    }
    public void discountChange(){
        try {
            BigDecimal discount = new BigDecimal(BigDec.scaledRoundHalfUp( editDiscount.getText(),2 ));
            if( discount.doubleValue() > 100 ) {
                discount = new BigDecimal(100.00);
                editDiscount.setText(discount.toString());
            }
            if( discount.doubleValue() >= 0 ) {
                tblSums.getModel().setValueAt(discount.toString(), DISCOUNT_INDEX, VALUE_COL_INDEX);
                calculateSums(false);
            }
        } catch(Exception e) {
            logErrToFile(e);
        }
    }
    public void postEvents(){
        try{
            editProv1UIN.postActionEvent();
            editProv2UIN.postActionEvent();
        } catch(Exception e){
            return;
        }
    }
    private void canPurchase(boolean enable){
        btnAddStock.setEnabled(enable);
        btnPlaceOrders.setEnabled(enable);
    }
    public Provisioner loadProv(int type, Provisioner prov) throws Exception{
        
        
        String sql = " select " +
                "   base_prsn.prv"+type+"_idnt, " +
                "   base_prsn.prv"+type+"_comm, " +
                "   prov"+type+".prsn_lnam + ' , ' + prov"+type+".prsn_fnam as name " +
                " from " +
                "   base_prsn " +
                "       inner join base_prsn prov"+type + " on base_prsn.prv"+type + "_idnt = prov"+type + ".prsn_key " +
                " where base_prsn.prsn_key=" + prov.getId();
        
        
        ArrayList m_provData = new ArrayList();
                System.out.println(sql);
        try{
            m_provData = SharedUtils.executeSqlScalarList(sql);
        } catch(Exception sqle) {
            sqle.printStackTrace();
            throw new Exception("Can't load Provision " + type + " for  Name: " + " , UID: " );
        }
        
        boolean bMore = m_provData.size()>0;
        Provisioner m_prov = new Provisioner("", "", "0");
        if(bMore){
            m_prov.setId(String.valueOf(m_provData.get(0)));
            m_prov.setCommission(String.valueOf(m_provData.get(1)));
            m_prov.setName( String.valueOf(m_provData.get(2)));
        }
        else{
             throw new Exception("Name: " + prov.getName() + " , UID: " + prov.getId() + " have not Provision " + type);
        }
        return m_prov;
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddStock;
    private javax.swing.JButton btnChangeMacro;
    private javax.swing.JButton btnControl;
    private javax.swing.JButton btnCreditNote;
    private javax.swing.JButton btnDealers;
    private javax.swing.JButton btnDoctors;
    private javax.swing.JButton btnMacros;
    private javax.swing.JButton btnMoreClient;
    private javax.swing.JButton btnNewClient;
    private javax.swing.JButton btnPay;
    private javax.swing.JButton btnPlaceOrders;
    private javax.swing.JButton btnPrint;
    private javax.swing.JButton btnPrintPList;
    private javax.swing.JButton btnSearchClient;
    private javax.swing.JButton btnSearchOrders;
    private javax.swing.JButton btnSelectStock;
    private javax.swing.JButton btnSendLetter;
    private javax.swing.JButton btnSet;
    private javax.swing.JButton btnShowPercents;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton bynPrintLabelInvoice;
    private javax.swing.JButton bynPrintLabelPList;
    private javax.swing.JCheckBox chkVatFree;
    private javax.swing.JCheckBox chkbAltAddress;
    private javax.swing.JCheckBox chkbCanPurchase;
    private javax.swing.JComboBox comboDocType;
    private javax.swing.JTextField editAlternateName;
    private javax.swing.JTextField editAppeal;
    private javax.swing.JTextField editCLCode;
    private javax.swing.JTextField editCity;
    private javax.swing.JTextField editCode;
    private javax.swing.JTextField editCount;
    private javax.swing.JTextField editCountry;
    private javax.swing.JTextField editDiscount;
    private javax.swing.JTextField editDocNo;
    private javax.swing.JTextField editFirstName;
    private javax.swing.JTextField editInvoiceNum;
    private javax.swing.JTextField editNewStock;
    private javax.swing.JTextField editOperator;
    private javax.swing.JTextField editOrderDate;
    private javax.swing.JTextField editPayDate;
    private javax.swing.JTextField editPayed;
    private javax.swing.JTextField editProv1Name;
    private javax.swing.JTextField editProv1Pers;
    private javax.swing.JTextField editProv1UIN;
    private javax.swing.JTextField editProv2Name;
    private javax.swing.JTextField editProv2Pers;
    private javax.swing.JTextField editProv2UIN;
    private javax.swing.JTextField editStreet;
    private javax.swing.JTextField editSurname;
    private javax.swing.JTextField editType;
    private javax.swing.JTextField editUIN;
    private javax.swing.JEditorPane edpInfo;
    private javax.swing.JEditorPane edpInvoice;
    private javax.swing.JEditorPane edpPackings;
    private javax.swing.JButton jButton1;
    private javax.swing.JEditorPane jEditorPane1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel22;
    private javax.swing.JLabel jLabel23;
    private javax.swing.JLabel jLabel24;
    private javax.swing.JLabel jLabel25;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JPanel jPanel8;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JScrollPane jScrollPane5;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JScrollPane jScrollPane7;
    private javax.swing.JScrollPane jScrollPane8;
    private javax.swing.JPanel jpanOPClient;
    private javax.swing.JPanel jpanOPOrderDetails;
    private javax.swing.JPanel jpanOPOrders;
    private javax.swing.JPopupMenu jpmOrders;
    private javax.swing.JLabel lblDate;
    private javax.swing.JLabel lblDocNum;
    private javax.swing.JLabel lblDocType;
    private javax.swing.JLabel lblInvoice;
    private javax.swing.JLabel lblOPFName;
    private javax.swing.JLabel lblOper;
    private javax.swing.JLabel lblProv1;
    private javax.swing.JLabel lblProv2;
    private javax.swing.JLabel lblStockName;
    private javax.swing.JMenuItem mitemDelete;
    private javax.swing.JScrollPane scrProvs;
    private javax.swing.JTabbedPane tabPane;
    private javax.swing.JTable tblOrderGoods;
    private javax.swing.JTable tblOrders;
    private javax.swing.JTable tblProvs;
    private javax.swing.JTable tblSums;
    private javax.swing.JTabbedPane tbpOrders;
    // End of variables declaration//GEN-END:variables
    
}
