/*
 * PersonSearch.java
 *
 * Created on , 2005,  4, 18:44
 */

package medstore;
import java.awt.event.InputEvent;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.JOptionPane;




/**
 *
 * @author  JohnyEdu
 */
public class PersonSearch extends CommonDialog implements SharedConstants{
    public final static int PATIENT_SEARCH = 1;
    public final static int DOCTOR_SEARCH = 2;
    public final static int DEALER_SEARCH = 3;
    public final static int PROV3_SEARCH = 4;
    public final static int PROV_GOOD_SEARCH = 5;
    
    public final static String DOCTOR_STRING = "DR";
    public final static String DEALER_STRING = "MA";
    public final static String PATIENT_STRING = "PAT";
    
    public final static int UIN_INDEX = 0;
    public final static int NAME_INDEX = 1;
    public final static int PROV1_IDNT_INDEX = 5;
    public final static int PROV1_COMM_INDEX = 6;
    public final static int PROV2_IDNT_INDEX = 7;
    public final static int PROV2_COMM_INDEX = 8;
    /** Creates new form PersonSearch */
    private String strSelectClause;
    private Vector vecResults;
    int nSearchCriteria;
    private String str_rgn_searchFields[] = {"prsn_lnam","prsn_fnam","prsn_city","city_code","prsn_strt"};
    private int[] width = {50,180,30,80,200};
    
    public PersonSearch(java.awt.Frame parent, boolean modal, Vector vecResults, int nSearchCriteria ) {
        super(parent, modal);
        super.setSize(600, 600);
        strSelectClause="";
        vecResults.removeAllElements();
        this.vecResults = vecResults;
        this.nSearchCriteria = nSearchCriteria;
        initComponents();
        afterInitComponents();
        translate();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        scrPersons = new javax.swing.JScrollPane();
        tblPersons = new javax.swing.JTable();
        editKeywords = new javax.swing.JTextField();
        btnSearch = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        comboCountry = new javax.swing.JComboBox();
        comboPrsType = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        editUid = new javax.swing.JTextField();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Persons search");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                PersonSearch.this.windowClosed(evt);
            }
        });

        scrPersons.setFont(new java.awt.Font("Tahoma", 1, 13));
        tblPersons.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "UIN", "Name", "Type", "Country", "Address"
            }
        ));
        tblPersons.setName("tblClSearchPersons");
        tblPersons.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                PersonSearch.this.keyPressed(evt);
            }
        });
        tblPersons.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                PersonSearch.this.mousePressed(evt);
            }
        });

        scrPersons.setViewportView(tblPersons);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 10, 10);
        getContentPane().add(scrPersons, gridBagConstraints);

        editKeywords.setFont(new java.awt.Font("Tahoma", 0, 13));
        editKeywords.setMinimumSize(new java.awt.Dimension(260, 21));
        editKeywords.setPreferredSize(new java.awt.Dimension(260, 21));
        editKeywords.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PersonSearch.this.actionPerformed(evt);
            }
        });
        editKeywords.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                PersonSearch.this.keyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(editKeywords, gridBagConstraints);

        btnSearch.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSearch.setText("Search");
        btnSearch.setName("btnSearch");
        btnSearch.setPreferredSize(new java.awt.Dimension(73, 26));
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PersonSearch.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 11);
        getContentPane().add(btnSearch, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Enter Keywords:");
        jLabel1.setName("lblEnterKeyWords");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 37;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(20, 10, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        comboCountry.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboCountry.setMaximumSize(new java.awt.Dimension(20, 24));
        comboCountry.setMinimumSize(new java.awt.Dimension(20, 24));
        comboCountry.setPreferredSize(new java.awt.Dimension(20, 24));
        comboCountry.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                PersonSearch.this.focusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                PersonSearch.this.focusLost(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.ipadx = 92;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(comboCountry, gridBagConstraints);

        comboPrsType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboPrsType.setMaximumSize(new java.awt.Dimension(10, 24));
        comboPrsType.setMinimumSize(new java.awt.Dimension(10, 24));
        comboPrsType.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                PersonSearch.this.focusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                PersonSearch.this.focusLost(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.ipadx = 72;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 10);
        getContentPane().add(comboPrsType, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText("Country");
        jLabel2.setName("lblOPCountry");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(20, 10, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel3.setText("Person Type");
        jLabel3.setName("lblPersonType");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(20, 10, 0, 0);
        getContentPane().add(jLabel3, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("Tahoma", 1, 12));
        jLabel4.setText("No.:");
        jLabel4.setMaximumSize(new java.awt.Dimension(34, 21));
        jLabel4.setMinimumSize(new java.awt.Dimension(34, 21));
        jLabel4.setName("lblUID");
        jLabel4.setPreferredSize(new java.awt.Dimension(34, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 12, 0, 12);
        getContentPane().add(jLabel4, gridBagConstraints);

        editUid.setFont(new java.awt.Font("Tahoma", 1, 12));
        editUid.setMaximumSize(new java.awt.Dimension(100, 21));
        editUid.setMinimumSize(new java.awt.Dimension(100, 21));
        editUid.setPreferredSize(new java.awt.Dimension(100, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 40, 0, 40);
        getContentPane().add(editUid, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-619)/2, (screenSize.height-305)/2, 619, 305);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void focusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_focusLost
        if( evt.getSource() == comboCountry)
            comboCountry.hidePopup();
        if( evt.getSource() == comboPrsType)
            comboPrsType.hidePopup();
    }//GEN-LAST:event_focusLost
    
    private void focusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_focusGained
        if( evt.getSource() == comboCountry)
            comboCountry.showPopup();
        if( evt.getSource() == comboPrsType)
            comboPrsType.showPopup();
    }//GEN-LAST:event_focusGained
    
    private void keyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyPressed
        if(evt.getSource() == tblPersons){
            int selectedRow = tblPersons.getSelectedRow();
            if( evt.getKeyCode()== evt.VK_UP ) {
                if( selectedRow ==0){
                    editKeywords.requestFocus();
                    editKeywords.selectAll();
                }
            } else if( evt.getKeyCode()== evt.VK_ENTER ){
                int nRow = tblPersons.getSelectedRow();
                String strUIN = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(UIN_INDEX);
                String strName = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(NAME_INDEX);
                //String strProv1Idnt = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV1_IDNT_INDEX);
                String strProv2Idnt = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV2_IDNT_INDEX);
                String strProv1Comm = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV1_COMM_INDEX);
                String strProv2Comm = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV2_COMM_INDEX);
                if(nSearchCriteria == DOCTOR_SEARCH || nSearchCriteria == DEALER_SEARCH ){
                    vecResults.addElement(strUIN);
                    vecResults.addElement(strName);
                    //vecResults.addElement(strProv1Idnt);
                    vecResults.addElement(strProv2Idnt);
                    vecResults.addElement(strProv1Comm);
                    vecResults.addElement(strProv2Comm);
                    dispose();
                } else if(nSearchCriteria == PATIENT_SEARCH){
                    strUIN = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(UIN_INDEX);
                    String strProv1Idnt = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV1_IDNT_INDEX);
                    strProv2Idnt = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV2_IDNT_INDEX);
                    strProv1Comm = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV1_COMM_INDEX);
                    strProv2Comm = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV2_COMM_INDEX);
                    vecResults.addElement(strUIN);
                    /*
                    vecResults.addElement(strProv1Idnt);
                    vecResults.addElement(strProv2Idnt);
                    vecResults.addElement(strProv1Comm);
                    vecResults.addElement(strProv2Comm);
                     */
                    dispose();
                } else if( nSearchCriteria == PROV3_SEARCH ){
                    vecResults.addElement(strUIN);
                    vecResults.addElement(strName);
                    dispose();
                }
                else if(nSearchCriteria == PROV_GOOD_SEARCH){
                   try{
                       vecResults.clear();
                       vecResults.add((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow));
                   }
                   catch(Exception e){
                       JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
                       e.printStackTrace();
                   }   
                   dispose();
                }
            }
        } else if( evt.getSource() == editKeywords){
            if( evt.getKeyCode()== evt.VK_DOWN){
                if(tblPersons.getRowCount() > 0){
                    tblPersons.requestFocus();
                    tblPersons.getSelectionModel().setSelectionInterval(0,0);
                    //tblPersons.updateUI();
                }
            }
            
        }
        
    }//GEN-LAST:event_keyPressed
    
    private void windowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowClosed
        vecResults.removeAllElements();
        //dispose();
    }//GEN-LAST:event_windowClosed
    
    private void mousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed
        if( evt.getSource() == tblPersons ) {
            if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
                int nRow = tblPersons.rowAtPoint(evt.getPoint());
                String strUIN = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(UIN_INDEX);
                String strName = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(NAME_INDEX);
                String strProv2Idnt = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV2_IDNT_INDEX);
                String strProv1Comm = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV1_COMM_INDEX);
                String strProv2Comm = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV2_COMM_INDEX);
                if(nSearchCriteria == DOCTOR_SEARCH || nSearchCriteria == DEALER_SEARCH){
                    vecResults.addElement(strUIN);
                    vecResults.addElement(strName);
                    //vecResults.addElement(strProv1Idnt);
                    vecResults.addElement(strProv2Idnt);
                    vecResults.addElement(strProv1Comm);
                    vecResults.addElement(strProv2Comm);
                    dispose();
                } else if(nSearchCriteria == PATIENT_SEARCH){
                    strUIN = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(UIN_INDEX);
                    String strProv1Idnt = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV1_IDNT_INDEX);
                    strProv2Idnt = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV2_IDNT_INDEX);
                    strProv1Comm = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV1_COMM_INDEX);
                    strProv2Comm = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(PROV2_COMM_INDEX);
                    vecResults.addElement(strUIN);
                    /*
                    vecResults.addElement(strProv1Idnt);
                    vecResults.addElement(strProv2Idnt);
                    vecResults.addElement(strProv1Comm);
                    vecResults.addElement(strProv2Comm);
                     */
                    dispose();
                } else if(nSearchCriteria == PROV3_SEARCH){
                    vecResults.addElement(strUIN);
                    vecResults.addElement(strName);
                    dispose();
                }
                else if(nSearchCriteria == PROV_GOOD_SEARCH){
                   try{
                       vecResults.clear();
                       vecResults.add((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow));
                   }
                   catch(Exception e){
                       JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
                       e.printStackTrace();
                   }   
                   dispose();
                }
            }
        }
    }//GEN-LAST:event_mousePressed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
       
        if(evt.getSource()==btnSearch){
            String strKeywords = editKeywords.getText().trim();
            String strWhereClause = "";
            int nConditions = 0;
            if(!strKeywords.equals("")){
                nConditions++;
                String str_rgn_keywordTokens[] = strKeywords.split(" ");
                int nKeywordsCount = str_rgn_keywordTokens.length;
                if(nKeywordsCount < 1){
                    JOptionPane.showMessageDialog(null,"Please enter at least one keyword for search");
                    return;
                }
                int nSearchFieldsCount = str_rgn_searchFields.length;
                for(int i = 0; i < nKeywordsCount; i++){
                    str_rgn_keywordTokens[i] = str_rgn_keywordTokens[i].trim();
                    
                    if(str_rgn_keywordTokens[i].equals("")){
                        continue;
                    }
                    for(int j = 0; j < nSearchFieldsCount; j++){
                        if(i == 0 && j == 0)
                            strWhereClause += "(";
                        else if(i > 0 && j == 0)
                            strWhereClause += ") AND (";
                        else if(i > 0 || j > 0)
                            strWhereClause += " OR ";
                        strWhereClause = strWhereClause + " UPPER(" + str_rgn_searchFields[j] + ") " + " like UPPER('" + str_rgn_keywordTokens[i] + "%') ";
                    }
                    if(i==nKeywordsCount-1){
                        strWhereClause += " ) ";
                    }
                }
            }
            int nCountryId = ((ComboDataModel)comboCountry.getModel()).getCObjectAt(comboCountry.getSelectedIndex()).nItemDBKey;
            int nTypeId = ((ComboDataModel)comboPrsType.getModel()).getCObjectAt(comboPrsType.getSelectedIndex()).nItemDBKey;
            if(nCountryId >=0){
                if(nConditions>0)
                    strWhereClause += " AND CNTR_IDNT = " + nCountryId;
                else
                    strWhereClause += " CNTR_IDNT = " + nCountryId;
                nConditions++;
            }
            if(nTypeId >=0){
                if(comboPrsType.isEnabled()){
                    if(nConditions>0){                       
                        strWhereClause += " and type_idnt = " + nTypeId;
                    } else{                       
                        strWhereClause += " type_idnt = " + nTypeId;                       
                    }
                    nConditions++;
                } else{
                    if(nConditions>0){
                        if(((String)comboPrsType.getSelectedItem()).equals(DOCTOR_STRING))
                            strWhereClause += " AND PRV1_GOOD = 'Y' ";
                        else if(((String)comboPrsType.getSelectedItem()).equals(DEALER_STRING))
                            strWhereClause += " AND PRV2_GOOD = 'Y'";
                        else if(((String)comboPrsType.getSelectedItem()).equals(PATIENT_STRING))
                            strWhereClause += " AND type_idnt = 3 ";
                    } else{
                        if(((String)comboPrsType.getSelectedItem()).equals(DOCTOR_STRING))
                            strWhereClause += " PRV1_GOOD = 'Y'";
                        else if(((String)comboPrsType.getSelectedItem()).equals(DEALER_STRING))
                            strWhereClause += " PRV2_GOOD = 'Y'";
                        else if(((String)comboPrsType.getSelectedItem()).equals(PATIENT_STRING))
                            strWhereClause += " type_idnt = 3 ";
                        nConditions++;
                    }
                }
            }
            
            // TODO getSqlSearchPersons
            strSelectClause = SharedUtils.dbSettings.getSqlSearchPersons();
            if(nConditions > 0)
                strWhereClause = " WHERE " + strWhereClause;
            if(editUid.getText().trim().length()>0){
                try{
                    strWhereClause = " WHERE prsn_key = " + Long.parseLong(editUid.getText().trim());
                }
                catch(Exception e){
                    JOptionPane.showMessageDialog(this,"Only numbers (without white spaces)");
                    return;
                }
            }
            String strSQL = strSelectClause + strWhereClause;
            
            String str_rgn_columnNames[] = {"UIN","Name","Type","Country","Address"};
            
            try{
                str_rgn_columnNames = Main.def_app_lang.loadTableHeader(tblPersons);
            } catch(Exception e){
                
            }
            
            System.out.println(strSQL);
            SharedUtils.setTableDBModel(tblPersons,strSQL,str_rgn_columnNames);
            
            SharedUtils.setTableColumnsWidth(tblPersons, width);
            
            String strSearch = editKeywords.getText();
            int begIndex = 0;
            int length= strSearch.length();
            editKeywords.requestFocus();
            if(tblPersons.getRowCount() > 0){
                //tblPersons.requestFocus();
                //tblPersons.getSelectionModel().setSelectionInterval(0,0);
                //tblPersons.updateUI();
                //fix ait
                editKeywords.setCaretPosition(length);
            } else {
                //fix ait
                //editKeywords.setSelectionStart(begIndex);
                //editKeywords.setSelectionEnd(length);
                editKeywords.setCaretPosition(length);
            }
        }
        if(evt.getSource() == editKeywords){
            btnSearch.doClick();
            editKeywords.requestFocus();
            
        }
        if(evt.getSource() == editUid){
            btnSearch.doClick();
            editUid.requestFocus();
            
        }
    }//GEN-LAST:event_actionPerformed
    
    private void afterInitComponents(){
        try{
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT CNTR_NAME,CNTR_KEY FROM BASE_CNTR ORDER BY CNTR_NAME";
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbCountry = new ComboDataModel(rsDBData);
            ComboDataRow cdrRow = new ComboDataRow("All",-1);
            cdbCountry.insertCObjectAt(0,cdrRow);
            cdbCountry.setSelectedIndex(0);
            comboCountry.setModel(cdbCountry);
            rsDBData.close();
            stm.close();
            
            //cdbCountry.setSelectedIndex(1);
            //comboCountry.
            
            strSQL = "SELECT TYPE_ABBR, TYPE_KEY  FROM BASE_PRSN_TYPE ORDER BY TYPE_ABBR";
            stm = connDB.createStatement();
            rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbClients = new ComboDataModel(rsDBData);
            cdrRow = new ComboDataRow("All",-1);
            cdbClients.insertCObjectAt(0,cdrRow);
            cdbClients.setSelectedIndex(0);
            comboPrsType.setModel(cdbClients);
            rsDBData.close();
            stm.close();
            if(nSearchCriteria == DOCTOR_SEARCH){
                ((ComboDataModel)comboPrsType.getModel()).selectIndexByContent(DOCTOR_STRING);
                comboPrsType.setEnabled(false);
            } else if((nSearchCriteria == DEALER_SEARCH)){
                ((ComboDataModel)comboPrsType.getModel()).selectIndexByContent(DEALER_STRING);
                comboPrsType.setEnabled(false);
            } else if ( nSearchCriteria == PROV3_SEARCH ){
                comboPrsType.setEnabled(false);
            } 
                
            String str_rgn_columnNames[] = {"UIN","Name","Type","Country","Address"};
                        
            try{
                str_rgn_columnNames = Main.def_app_lang.loadTableHeader(tblPersons);
            } catch(Exception e){
                
            }
            
            tblPersons.setModel(new UniversalTableModel(null, str_rgn_columnNames));
            
            SharedUtils.setTableColumnsWidth(tblPersons, width);
            //comboPrsType.updateUI();
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        } catch(Exception e){
            e.printStackTrace();
        }
        //
        enableExit(comboCountry);
        enableExit(comboPrsType);
        enableExit(tblPersons);
        UIUtils.setTableFonts(tblPersons);
        try{
            editUid.addKeyListener(new KeyListener(){
                public void keyReleased(java.awt.event.KeyEvent evt){
                    if(evt.getKeyCode() == evt.VK_ENTER){
                        btnSearch.doClick();
                        editUid.requestFocus();
                    }
                }
                public void keyPressed(java.awt.event.KeyEvent evt){
                    
                }
                public void keyTyped(java.awt.event.KeyEvent evt){
                    
                }
            });
        }
        catch(Exception e){
            
        }
    }
    public void translate(){
        Main.def_app_lang.loadLabelsFromPanel(this.getContentPane());
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSearch;
    private javax.swing.JComboBox comboCountry;
    private javax.swing.JComboBox comboPrsType;
    private javax.swing.JTextField editKeywords;
    private javax.swing.JTextField editUid;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane scrPersons;
    private javax.swing.JTable tblPersons;
    // End of variables declaration//GEN-END:variables
    
}
