/*
 * GenerateLettersDialog.java
 *
 * Created on , 2005,  3, 15:21
 */

package medstore;

import java.awt.*;
import java.awt.print.*;
import javax.swing.*;
import java.util.*;
import java.sql.*;
/**
 *
 * @author  JohnyEdu
 */
public class PlainTextLettersDialog extends CommonDialog 
        implements Printable,Pageable,SharedConstants {
    ArrayList m_lettersTexts;
    ArrayList m_pages;    
    ArrayList m_orderIDs = new ArrayList();
    int m_letterNum;
    PageFormat m_pageFormat;
    double m_textWidth;
    float m_fontSize;
    
    /** Creates new form GenerateLettersDialog */
    public PlainTextLettersDialog(java.awt.Frame parent, boolean modal, int letterNum ) {
        super(parent, false);
        initComponents();     
        PlainTextLettersGenerator gen = new PlainTextLettersGenerator();
        txtAreaLetters.setEditable(false);
        txtAreaLetters.setText( gen.getLettersText(letterNum) );
        m_lettersTexts = gen.m_lettersTexts;
        m_orderIDs = gen.m_orderIDs;
        m_letterNum = letterNum; 
        this.txtAreaLetters.setBackground( Color.WHITE );   
        m_fontSize = PRINT_FONT_SIZE;
    }    
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel9 = new javax.swing.JPanel();
        jScrollPane4 = new javax.swing.JScrollPane();
        txtAreaLetters = new javax.swing.JTextArea();
        btnPrint = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Send Letter");
        jPanel9.setLayout(new java.awt.GridBagLayout());

        jScrollPane4.setViewportView(txtAreaLetters);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel9.add(jScrollPane4, gridBagConstraints);

        btnPrint.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnPrint.setText("Print ...");
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PlainTextLettersDialog.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.ipadx = 21;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 10, 10);
        jPanel9.add(btnPrint, gridBagConstraints);

        getContentPane().add(jPanel9, java.awt.BorderLayout.CENTER);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-595)/2, (screenSize.height-596)/2, 595, 596);
    }//GEN-END:initComponents

    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if( evt.getSource() == btnPrint){
            printData();              
            
        }
    }//GEN-LAST:event_actionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnPrint;
    private javax.swing.JPanel jPanel9;
    private javax.swing.JScrollPane jScrollPane4;
    private javax.swing.JTextArea txtAreaLetters;
    // End of variables declaration//GEN-END:variables

    String getOrdreNumsSet()
    {
        String sql = "";
        for( int i = 0; i < m_orderIDs.size(); i++ )
        {
            if( i == 0 )
                sql += m_orderIDs.get(i);
            else
                sql += "," + m_orderIDs.get(i);                
        }
        return sql;
    }
    
    ////////////////////////////////////////////////////////////////////////////
    
    public void printData() 
    {
        try 
        {
            PrinterJob printerJob = PrinterJob.getPrinterJob();
            m_pageFormat = printerJob.defaultPage();
            Paper paper = new Paper();
            paper.setImageableArea( 28.346456692913385, 28.346456692913385, 
                538.5826771653543, 785.1968503937007 );
            paper.setSize( 595.275590551181, 841.8897637795276 );
            m_pageFormat.setPaper( paper );
            m_pageFormat = printerJob.pageDialog(m_pageFormat);
            int pageHeight = (int) m_pageFormat.getImageableHeight();
            Font font = txtAreaLetters.getFont().deriveFont( m_fontSize );
            int lineHeight = this.txtAreaLetters.getFontMetrics(font).getHeight();
            calculatePages( pageHeight, lineHeight );  
            printerJob.setPageable(this);
            if (!printerJob.printDialog())
                return;
            printerJob.print();            
            /////
            if( m_orderIDs.size() > 0 )
            {
                Connection conn = null;
                try
                {
                    Timestamp tmspCurrentDate = SharedUtils.getCurrentTimestamp();
                    String  sql = "update vorgang set letter" + m_letterNum + "date=?" + 
                            " where v_nr in(" + getOrdreNumsSet() + ")";
                    System.out.println(sql);
                    conn = SharedUtils.getConnection();
                    PreparedStatement pstm = conn.prepareStatement(sql);
                    pstm.setTimestamp(1, tmspCurrentDate );
                    pstm.executeUpdate();
                    pstm.close();
                }
                catch(SQLException e)
                {
                    SharedUtils.handleError( GENERAL_DB_ERROR );
                }
                finally
                {
                    SharedUtils.closeConnection(conn);
                }
            }
        }
        catch (PrinterException ex) 
        {
            JOptionPane.showMessageDialog( null, "Error while printing document: " + ex.toString() );           
        }
    }
    
    private void calculatePages( int pageHeight, int fontHeight )
    {
        m_pages = new ArrayList();
        for( int i = 0; i < m_lettersTexts.size(); i++ )
        {
            String letterText = (String)m_lettersTexts.get(i);
            m_pages.addAll( getPagesPerLetter( letterText, pageHeight, fontHeight ) );
        }
    }
    
    public int print( Graphics pageGraphics, PageFormat pageFormat, int pageIndex) 
      throws PrinterException 
    {
        int pageWidth = (int) pageFormat.getImageableWidth();
        int pageHeight = (int) pageFormat.getImageableHeight();
        pageGraphics.setFont( txtAreaLetters.getFont().deriveFont( m_fontSize ) );
        //calculate maxWidth
        if( pageIndex == 0 )
            calculateTextWidth( pageGraphics, pageGraphics.getFontMetrics() );
        // scale if needed
        if ( pageWidth < m_textWidth ) 
        {
            correctTextWidth( pageGraphics, pageGraphics.getFontMetrics(), pageWidth);
        }
        FontMetrics fm = pageGraphics.getFontMetrics();
        int lineHeight = fm.getHeight();
        if (pageIndex >= m_pages.size())
            return NO_SUCH_PAGE;
        pageGraphics.translate( (int) pageFormat.getImageableX(),
                (int) pageFormat.getImageableY() );            
        pageGraphics.setClip( 0, 0, pageWidth, pageHeight);
        int x = 0;
        int y = fm.getAscent();
        ArrayList lines = (ArrayList) m_pages.get(pageIndex);
        for (int i = 0; i < lines.size(); i++) 
        {
            assert y < pageHeight;
            String str = (String) lines.get(i);
            pageGraphics.drawString(str, x, y);
            y += lineHeight;
        }
        return PAGE_EXISTS;
    }
    
    //Pageable methods    
    public int getNumberOfPages() 
    {
        return m_pages.size();
    }    
    public PageFormat getPageFormat(int pageIndex) 
    {
        return m_pageFormat;         
    }    
    public Printable getPrintable(int pageIndex) 
    {
        return this;         
    }
    //
    private void calculateTextWidth(Graphics printGraphics,FontMetrics fm)
    {    
        String maxString = "";
        for( int i = 0; i < m_pages.size(); i++ )
        {
            ArrayList page = (ArrayList)m_pages.get(i);
            for( int j = 0; j < page.size(); j++ )
            {
                String line = (String)page.get(j);
                if( line.length() > maxString.length() )
                    maxString = line;
            }
        }
        m_textWidth = fm.getStringBounds( maxString, printGraphics ).getWidth();
    }
    
    private void correctTextWidth(Graphics printGraphics,FontMetrics fm,int pageWidth)
    {    
        while( pageWidth < m_textWidth )
        {
            Font font = printGraphics.getFont();
            m_fontSize = m_fontSize - 0.1f;
            printGraphics.setFont( font.deriveFont( m_fontSize ) );
            calculateTextWidth( printGraphics, printGraphics.getFontMetrics() );            
        }       
    }
    
    private ArrayList getPagesPerLetter( String letterText, int pageHeight, int fontHeight ) 
    {
        ArrayList pagesPerLetter = new ArrayList();
        ArrayList page = new ArrayList();
        StringTokenizer st = new StringTokenizer(letterText, "\n", true);
        int currentPageHeight = 0;
        String prevToken = "";
        while (st.hasMoreTokens()) 
        {
            String line = st.nextToken();
            
            if ( line.equals("\n") && prevToken.equals("\n") )
            {
                page.add("");
                prevToken = line;
            }
            else if( !line.equals("\n") )
            {
                line = line.replaceAll( "\t", " " );
                page.add( line );
                prevToken = line;
            }            
            else 
            {
                prevToken = line;
                continue;                
            }
            
            currentPageHeight += fontHeight;
            if( currentPageHeight + fontHeight > pageHeight )
            {
                pagesPerLetter.add( page );
                page = new ArrayList();
                currentPageHeight = 0;
                prevToken = "";                
            }           
        }    
        if( page.size() > 0 )
            pagesPerLetter.add( page );
        return pagesPerLetter;
    }
}

