/*
 * PlainTextLettersGenerator.java
 *
 * Created on , 2005,  25, 14:31
 */

package medstore;

import java.util.*;
import java.sql.*;

public class PlainTextLettersGenerator implements SharedConstants
{
    private final int ALIGN_LEFT = 1;
    private final int ALIGN_CENTER = 2;
    private final int ALIGN_RIGHT = 3;
    public ArrayList m_lettersTexts;
    public ArrayList m_orderIDs;
    public PlainTextLettersGenerator() {
    }
    
    public String getLettersText( int letterNum )
    {
        m_orderIDs = new ArrayList();
        m_lettersTexts = new ArrayList();
        String html = "";
        String letterDateIdent = "letter" + letterNum + "date";
        String sql = "select vorgang.invc_date, " +
                " base_prsn.prsn_appl, base_prsn.prsn_lnam, base_prsn.prsn_fnam, base_prsn.prsn_strt, " +
                " base_prsn.city_code, base_prsn.prsn_city, base_prsn.prsn_key, base_prsn.altr_name, " +
                " vorgang.v_nr, base_doc_type.type_name, vorgang.neto_sum, " +
                " vorgang.totl_sum, vorgang.pay_sum " +
                " from base_prsn,vorgang, base_doc_type " +
                " where pay_sum < totl_sum AND vorgang." + letterDateIdent + " is null " +
                " and base_doc_type.type_key=vorgang.doc_type_idnt " +
                " and vorgang.patn_idnt=base_prsn.prsn_key " + 
                " and vorgang.doc_type_idnt=1 " +
                " and vorgang.v_nr not in(select distinct invoiceid from vorgang where doc_type_idnt=2)" +
                " order by vorgang.v_nr";        
        Connection conn = null;
        Calendar currentDate = Calendar.getInstance();
        currentDate.add( Calendar.DAY_OF_MONTH ,1 );
        SharedUtils.set2BeginOfTheDay(currentDate);
        Calendar endDate = Calendar.getInstance();        
        try
        {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            boolean isFirst = true;
            while( rs.next() )
            {     
                Timestamp orderTimeStamp = rs.getTimestamp(1);
                endDate.setTimeInMillis( orderTimeStamp.getTime() );
                endDate.add( Calendar.DAY_OF_MONTH, SharedUtils.letterSendDays[letterNum-1] );
                if( endDate.getTimeInMillis() >= currentDate.getTimeInMillis() )
                    continue;
                //load person info
                ArrayList personInfo = new ArrayList();
                String strAppeal = rs.getString(2);                
                String strLastName = rs.getString(3);
                String strFirstName = rs.getString(4);
                String strStreet = rs.getString(5);
                String strCode = rs.getString(6);
                String strCity = rs.getString(7);
                String strDate = SharedUtils.getCurrentOnlyDateStringFormatted();
                String strClientIdnt = rs.getString(8);
                String altName = rs.getString(9);                  
                personInfo.add( strAppeal );
                personInfo.add( strFirstName );
                personInfo.add( strLastName );
                personInfo.add( strStreet );
                personInfo.add( strCode );
                personInfo.add( strCity );
                personInfo.add( strDate );
                personInfo.add( strClientIdnt );
                personInfo.add( altName );
                
                //load order info                
                ArrayList ordersData = new ArrayList();
                ArrayList orderInfo = new ArrayList();
                String strTableOrderNo = rs.getString(10);
                String strDocType = rs.getString(11);
                String strOrderDate = SharedUtils.getStringFromTimestamp(orderTimeStamp,SharedUtils.PARSE_ONLY_DATE);
                String strNetto = rs.getString(12);
                String strTotal = rs.getString(13);
                String strPayed = rs.getString(14);
                orderInfo.add(strTableOrderNo);
                orderInfo.add(strOrderDate);
                orderInfo.add(strDocType);
                orderInfo.add(strNetto);
                orderInfo.add(strTotal);
                orderInfo.add(strPayed);
                ordersData.add( orderInfo );
                if( !isFirst )
                    html += "\n\n\n";
                String letterText = getLetterText( ordersData, letterNum, personInfo );
                m_lettersTexts.add(letterText);
                html += letterText;
                isFirst = false;
                m_orderIDs.add(strTableOrderNo);
            }
            rs.close();
            stm.close();
        }
        catch( SQLException e )
        {
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
        finally
        {
            SharedUtils.closeConnection(conn);
        }
        return html;
    }
    
    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////
    
    private String getLetterText( ArrayList ordersData, int letterNum, ArrayList clientInfo )
    {
        String strAppeal = (String) clientInfo.get(0);
        String strFirstName = (String) clientInfo.get(1);
        String strLastName = (String) clientInfo.get(2);
        String strStreet = (String) clientInfo.get(3);
        String strCode = (String) clientInfo.get(4);
        String strCity = (String) clientInfo.get(5);
        String strDate = (String) clientInfo.get(6);
        String strClientIdnt = (String) clientInfo.get(7);
        String altName = (String) clientInfo.get(8);
        if( altName == null )
            altName = "";
        if( altName != null && !altName.equals("") )
            altName += "\n";
        int printerRows = 13;
        int rowsPerPage = 20;
        String letterText = "\n";
        letterText += getText( "VITA NATURA", 72, ALIGN_CENTER ) + "\n\n\n";
        letterText += getText( " " + strAppeal, 36, ALIGN_LEFT ) + "\n";
        letterText += getText( " " + strFirstName + " " + strLastName, 72, ALIGN_LEFT ) + "\n";
        
        letterText += getText( " " + altName + " ", 36, ALIGN_LEFT );
        letterText += getText( "Ihre Kunden-Nr.: " + strClientIdnt, 36 + 5, ALIGN_RIGHT ) + "\n";
        
        letterText += getText( " " + strStreet, 36, ALIGN_LEFT );
        letterText += getText( " Datum: " + strDate, 36 + 5, ALIGN_RIGHT ) + "\n";        
        
        letterText += getText( " " + strCode + " " + strCity, 72, ALIGN_LEFT ) + "\n\n\n";        
        
        letterText += getBeforTableText( strAppeal, strLastName, letterNum );
        letterText += "\n\n\n";
        
        letterText += 
                getText( " Rechnunng", 14, ALIGN_LEFT ) + getText( "Datum", 11, ALIGN_LEFT ) +
                getText( "Zinstage", 12, ALIGN_LEFT ) + getText( "Betrag", 13, ALIGN_LEFT ) +
                getText( "bezahlt", 13, ALIGN_LEFT ) + getText( "zu zahlen", 15, ALIGN_LEFT ) + "\n";
        
        letterText += 
                getText( " " + getAntetka(12), 14, ALIGN_LEFT ) + getText( getAntetka(10 ), 11, ALIGN_LEFT ) +
                getText( getAntetka(11), 12, ALIGN_LEFT ) + getText( getAntetka(12), 13, ALIGN_LEFT ) +
                getText( getAntetka(12), 13, ALIGN_LEFT ) + getText( getAntetka(14), 15, ALIGN_LEFT ) + "\n";        
        
        String strTableOrderNo = "";
        String strDocType = "";
        String strNetto = "";
        String strTotal = "";
        String strPayed = "";
        double sumTotals = 0;
        for( int i = 0; i < ordersData.size(); i++ ){
            String strTableDate = "";
            ArrayList orderInfo = (ArrayList)ordersData.get(i);
            strTableOrderNo = (String)orderInfo.get( 0 );
            strTableDate = (String)orderInfo.get( 1 );
            strDocType = (String)orderInfo.get( 2 );
            strNetto = (String)orderInfo.get( 3 );
            strTotal = (String)orderInfo.get( 4 );
            strPayed = (String)orderInfo.get( 5 );
            sumTotals += Double.parseDouble(strTotal);
            
            letterText += getText( " " + strTableOrderNo, 14, ALIGN_LEFT ) + 
                getText( strTableDate, 11, ALIGN_LEFT ) +
                getText( strDocType, 12, ALIGN_LEFT ) + 
                getText( SharedUtils.formatFloat(strNetto, '.' ) + " ", 13, ALIGN_RIGHT ) +
                getText( SharedUtils.formatFloat(strPayed, '.' ) + " ", 13, ALIGN_RIGHT ) + 
                getText( SharedUtils.formatFloat(strTotal, '.' ) + " EUR", 14, ALIGN_RIGHT ) + "\n";
        }
        String penalty = getPenalty(letterNum);
        String totalPenalty = "" + ( Double.parseDouble( penalty ) + sumTotals );
        letterText += getText( "Zwischensumme:   ", 65, ALIGN_RIGHT );
        letterText += getText( SharedUtils.formatFloat( "" + sumTotals, '.' ) + " EUR ", 13, ALIGN_RIGHT ) + "\n";
        
        if( Double.parseDouble( penalty ) > 0 )
        {
            letterText += getText( "Mahneb" + (char)252 + "hr:   ", 65, ALIGN_RIGHT );
            letterText += getText( SharedUtils.formatFloat( penalty, '.' ) + " EUR ", 13, ALIGN_RIGHT ) + "\n";
        }
        
        letterText += getText( "Gesamtsumme:   ", 65, ALIGN_RIGHT );
        letterText += getText( SharedUtils.formatFloat( totalPenalty, '.' ) + " EUR ", 13, ALIGN_RIGHT ) + "\n";
        
        letterText += "\n\n\n";
        letterText += getAfterTableText( strDate, letterNum );
        letterText += "\n\n\n";
        letterText += getFooter();
        return letterText;
    }
    
    private String getText( String text, int width, int alignment )
    {
        if( text == null )
            text = "";
        
        text = text.replaceAll( "\n", " " );
        
        if( text.length() > width )
            return text.substring(0, width);
        
        switch( alignment )
        {
            case  ALIGN_LEFT:
            {
                return text + getPadding( width - text.length() );
            }
            case ALIGN_CENTER:
            {
                int dif = width - text.length();
                return getPadding( dif/2 )  + text + getPadding( dif - dif/2 );
            }
            case ALIGN_RIGHT:
            {
                return getPadding( width - text.length() ) + text;
            }
        }
        throw new java.lang.AssertionError();
    }
    
    private String getAntetka( int width )
    {
        String str = "";
        for( int i = 0; i < width; i++ )
        {
            str += "-";
        }
        return str;
    }
    
    private String getPadding( int width )
    {
        String str = "";
        for( int i = 0; i < width; i++ )
        {
            str += " ";
        }
        return str;
    }
    
    private String getPenalty( int letterMode )
    {
        return "" + SharedUtils.letterPenalties[letterMode-1];        
    }
   
   private String getBeforTableText(String strAppeal,String strLastName,  int letterMode )
   {
       strLastName = strLastName.trim();
       if( letterMode == 1 )
             return 
               getText( " Zahlungserinnerung", 72, ALIGN_LEFT ) + "\n" +
               getText( " Sehr geehrter " + strAppeal + " " + strLastName + ",", 72, ALIGN_LEFT ) + "\n\n" +
               getText( " Sicherlich ist es Ihnen entgangen , die im folgenden aufgef" + (char)252 + "hrten", 72, ALIGN_LEFT ) + "\n" +
               getText( " Rechnungen zubegleichen:", 72, ALIGN_LEFT );               
             
       if( letterMode == 2 )
           return 
               getText( " Zahlungserinnerung", 72, ALIGN_LEFT ) + "\n" +
               getText( " Sehr geehrter " + strAppeal + " " + strLastName + ",", 72, ALIGN_LEFT ) + "\n\n" +
               getText( " sicher haben Sie " + (char)252 + "bersehen, dab die unten aufgef" + (char)252 + "hrten Rechnungen", 72, ALIGN_LEFT ) + "\n" +
               getText( " zur Zahlung f" + (char)228 + "lling geworden sind.Wir bitten Sie deshalb um sofortige", 72, ALIGN_LEFT )  + "\n" +
               getText( " " + (char)252 + "berweisung des Gesamtbetrages auf unser Konto.", 72, ALIGN_LEFT );
       
       if( letterMode == 3 )
           return 
               getText( " Zahlungserinnerung", 72, ALIGN_LEFT ) + "\n" +
               getText( " Sehr geehrter " + strAppeal + " " + strLastName  + ",", 72, ALIGN_LEFT ) + "\n\n" +
               getText( " nachdem unsere 1. und 2. Mahnung ohne Erfolg blieb, setzen wir Ihnen", 72, ALIGN_LEFT ) + "\n" +
               getText( " nun eine letzte Zahlungsfrist.", 72, ALIGN_LEFT ) + "\n" +
               getText( " folgendem Datum auf unser Konto eingegangen sein, so warden wir ein", 72, ALIGN_LEFT ) + "\n" +
               getText( " Inkassoinstitut damit beauftragen, unsere Forderungen von Ihnen.", 72, ALIGN_LEFT ) + "\n" +
               getText( " einzuziehen Die damit verbundenen Kosten gehen zu Ihren Lasten", 72, ALIGN_LEFT );
               
       throw new java.lang.AssertionError();       
   }
   
   private String getAfterTableText(String date, int letterMode )
   {
       if( letterMode == 1 )
           return 
               getText( " Wir bitten Sie h" + (char)246 + "flichst den o.g. Betrag innerhalb der n" + (char)228 + "chsten 7 Tage", 72, ALIGN_LEFT ) + "\n" +
               getText( " auf unser Konto zu " + (char)252 + "berweisen.", 72, ALIGN_LEFT ) +  "\n\n" +
               getText( " Sollten Sie inzwischen den Betrag an uns " + (char)252 + "berwiesen haben, so", 72, ALIGN_LEFT ) +  "\n" +
               getText( " sehen Sie dieses Schreiben als gegenstandslos an.", 72, ALIGN_LEFT ) +  "\n\n" +
               getText( " Mit freundlichen Gr" + (char)252 + "ben", 72, ALIGN_LEFT ) +  "\n\n" +
               getText( " (Diese Mahnung ist nicht unterschrieben, da maschinell erstellt.)", 72, ALIGN_LEFT );
       
       if( letterMode == 2 )
           return 
               getText( " Wir erwarten Ihre Zahlung bis zum " + 
                   SharedUtils.incDate(date, 10), 72, ALIGN_LEFT ) + "\n\n" +
                   getText( " Sollten Sie inzwischen den Betrag an uns " + (char)252 + "berwiesen haben , so sehen", 72, ALIGN_LEFT ) + "\n" +
                   getText( " Sie dieses Schreiben als gegenstandslos an.", 72, ALIGN_LEFT ) + "\n\n" +
                   getText( " Mit freundlichen Gr" + (char)252 + "ben ", 72, ALIGN_LEFT ) + "\n\n" +
                   getText( " (Diese Mahnung ist nicht unterschrieben, da maschinell erstellt.)", 72, ALIGN_LEFT );
      
       if( letterMode == 3 )
           return 
               getText( " Wir gew" + (char)228 + "hren Ihnen eine letzte Zahlungsfrist bis zum " + SharedUtils.incDate(date, 10), 72, ALIGN_LEFT ) + "\n\n" +
               getText( " Sollte der Betrag bis zu diesem Datum nicht auf unser auf unser Konto,", 72, ALIGN_LEFT ) + "\n" +
               getText( " eingegangen sein werden wir rechtliche Schritte gegen Sie einleiten,", 72, ALIGN_LEFT ) + "\n" +
               getText( " die mit weiteren Kosten f" + (char)252 + "r Sie verbunden sind.", 72, ALIGN_LEFT ) + "\n\n\n" + 
               getText( " Mit freundlichen Gr" + (char)252 + "ben", 72, ALIGN_LEFT ) + "\n\n\n" +
               getText( " (Diese Mahnung ist nicht unterschrieben, da maschinell erstellt.)", 72, ALIGN_LEFT );
               
       throw new java.lang.AssertionError();       
   }
     
   private String getFooter()
   {
       return 
           getText( " " + (char)220 + "berweisungen aus Deutschland an:", 30, ALIGN_LEFT ) +
           getText( " ISV Europe BV i.o.", 19, ALIGN_LEFT ) +
           getText( " Kontaktb" + (char)252 + "ro Deutschland:", 24, ALIGN_LEFT ) + "\n" +

           getText( " ABN/AMRO_489437753", 30, ALIGN_LEFT ) +
           getText( " Heerenweg 251", 19, ALIGN_LEFT ) +
           getText( " Telefon :(ISDN)(0180)5236312", 24 + 5, ALIGN_LEFT ) + "\n" +

           getText( " IBAN:_NL04ABNA0489437753", 30, ALIGN_LEFT ) +
           getText( " 6414 AJ Heerlen", 19, ALIGN_LEFT ) +
           getText( " FAX :(ISDN)(0180)5236311", 24 + 5, ALIGN_LEFT ) + "\n" +

           getText( " BIC:_ABNANL2A", 30, ALIGN_LEFT ) +
           getText( " NL", 19, ALIGN_LEFT ) +
           getText( " E-Mail:order@isvita.com", 24 + 5, ALIGN_LEFT ) + "\n";
   }    
}
