/*
 * QueryTextResult.java
 *
 * Created on , 2005,  15, 18:26
 */

package medstore;
import java.awt.print.PrinterException;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.sql.Types;
import java.util.Calendar;
import java.util.Hashtable;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.text.html.HTMLEditorKit;
import medstore.print.reports.ReportTop;
import medstore.print.reports.orderhistory.OHData;
import medstore.print.reports.orderhistory.OHReportData;
import medstore.print.reports.orderhistory.OHTableModel;
import xmlutils.DOMParser;
import java.util.ArrayList;
import java.util.*;
import javax.swing.text.*;
import java.awt.*;
import medstore.print.reports.orderhistory.OHPrintUtils;
import org.jfree.report.JFreeReport;
import org.jfree.report.JFreeReportBoot;
import org.jfree.report.modules.gui.base.PreviewDialog;


/**
 *
 * @author  JohnyEdu
 */
public class QueryTextResult extends CommonDialog implements SharedConstants 
{
    private Hashtable htbFilterParams;
    private int nQueryType;
    String results[];
    String str_rgn_columns[][];
    private String m_strTextDateFrom;
    private String m_strTextDateTo;
    private String[] m_strMonths = {"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG",
            "SEP","OCT","NOV","DEC"};
    private String str_rgn_searchFields[] = {"prsn_key","prsn_appl","type_abbr","prsn_lnam","prsn_fnam","cntr_name","prsn_city","city_code","prsn_strt"};
   
    private String m_reportHeader;
    
    public QueryTextResult(java.awt.Frame parent, 
            boolean modal, 
            Hashtable htbFilterParams,
            int nQueryType) 
    {
        super(parent, modal);
        this.htbFilterParams = htbFilterParams;
        this.nQueryType = nQueryType;
        results = new String[3];
        initComponents();
        afterInitComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane1 = new javax.swing.JScrollPane();
        tpQueryResult = new javax.swing.JEditorPane();
        jPanel1 = new javax.swing.JPanel();
        btnPrint = new javax.swing.JButton();
        btnSaveToFile = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Query Results");
        tpQueryResult.setEditable(false);
        tpQueryResult.setFont(new java.awt.Font("Times New Roman", 0, 12));
        tpQueryResult.setAlignmentX(0.0F);
        tpQueryResult.setAlignmentY(0.0F);
        tpQueryResult.setMargin(new java.awt.Insets(0, 0, 0, 0));
        jScrollPane1.setViewportView(tpQueryResult);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        getContentPane().add(jScrollPane1, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMinimumSize(new java.awt.Dimension(195, 30));
        jPanel1.setPreferredSize(new java.awt.Dimension(195, 30));
        btnPrint.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnPrint.setText("Print...");
        btnPrint.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                QueryTextResult.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 20);
        jPanel1.add(btnPrint, gridBagConstraints);

        btnSaveToFile.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSaveToFile.setText("Save to file");
        btnSaveToFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                QueryTextResult.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        jPanel1.add(btnSaveToFile, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 10, 0);
        getContentPane().add(jPanel1, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-709)/2, (screenSize.height-684)/2, 709, 684);
    }
    // </editor-fold>//GEN-END:initComponents

    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if( evt.getSource() == btnSaveToFile ){
            saveToFile(nQueryType);
        }
        else if( evt.getSource() == btnPrint){
            printResults();
        }
    }//GEN-LAST:event_actionPerformed

    private void handleQuery(int nQueryType){

        switch(nQueryType){            
            case ORDERS_AMMOUNT_QUERY:
            {       
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                
               String strSQL = " SELECT base_prsn.prsn_lnam , base_prsn.prsn_fnam , " +
                                " vorgang.invc_date, vorgang.v_nr, vorgang.neto_sum, " +
                                " vorgang.totl_sum, vorgang.vat_pers, vorgang.invc_prto, " + 
                                " vorgang.patn_dscn, vorgang.doc_type_idnt " + 
                                " FROM base_prsn, vorgang " +
                                " WHERE invc_date>='" + strTextDateFrom + "'" +
                                " AND invc_date<'" + strTextDateTo + "'" + 
                                " AND vorgang.patn_idnt=base_prsn.prsn_key " + 
                                " ORDER BY vorgang.invc_date ASC ";
                
                Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
                ArrayList data = new ArrayList();
                Calendar cal = Calendar.getInstance();
                int count = 1;
                try
                {
                    Statement stm = connDB.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);   
                    float fSumNetto = 0, fSumPorto = 0, fSumVAT = 0, fSumTotal = 0;
                    while( rs.next() )
                    {
                        ArrayList entry = new ArrayList();
                        entry.add("" + count + ")" );
                        count++;
                        data.add(entry);                        
                        String name2 = rs.getString(1);
                        String name1 = rs.getString(2);
                        Timestamp tmsp = rs.getTimestamp(3);
                        String date = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_ONLY_DATE);
                        String vnr = rs.getString(4);
                        
                        float fNeto = SharedUtils.readFloat( rs, 5, 2 );
                        float fTotal = SharedUtils.readFloat( rs, 6, 2 );
                        float fVat = rs.getFloat(7);
                        float fPorto = SharedUtils.readFloat( rs, 8, 2 );
                        float iDiscount = rs.getFloat( 9 );
                        int iDocType = rs.getInt( 10 );
                        
                        if( iDocType == 2 ) //credit note
                        {
                            fNeto  *= -1;
                            fTotal *= -1;
                            iDiscount *= -1;
                            fPorto *= -1;
                        }
                        
                        float fDiscount =  fNeto * 0.01f * iDiscount;
                        //if( SharedUtils.discountSum >= 0 && Math.abs( fNeto ) >= SharedUtils.discountSum )
                        //    fPorto = 0;
                        fTotal = fNeto + fPorto - fDiscount;
                        fVat = fTotal * 0.01f * fVat;
                        fTotal +=fVat;
                        
                        //
                        String strNetto = SharedUtils.formatFloat("" + fNeto, '.');
                        String strPorto = SharedUtils.formatFloat("" + fPorto, '.'); 
                        String strVAT = SharedUtils.formatFloat("" + fVat, '.');
                        String strTotal = SharedUtils.formatFloat("" + fTotal, '.');
                        //
                        fSumNetto += fNeto; 
                        fSumPorto += fPorto; 
                        fSumVAT += fVat;
                        fSumTotal += fTotal;
                                                
                        String name = "";
                        if( name1 != null && !name1.trim().equals("") && 
                            name2 != null && !name2.trim().equals("") )
                        {
                            name = name1.trim() + " , " + name2.trim();
                        }
                        else if( name1!=null && !name1.trim().equals("") )
                        {
                            name = name1.trim();                        
                        }
                        else if( name2!=null && !name2.trim().equals("") )
                        {
                            name = name2.trim();
                        }
                        /*Date Name OrderNO Netto Transport VAT Total*/
                        entry.add(date);
                        entry.add(name);
                        entry.add(vnr);
                        entry.add(strNetto);
                        entry.add(strPorto);
                        entry.add(strVAT);
                        entry.add(strTotal);
                    }
                    ArrayList entry = new ArrayList();
                    data.add(entry);
                    entry.add( "Total:" );
                    entry.add( "" );
                    entry.add( "" );
                    entry.add( "" );                    
                    entry.add( SharedUtils.formatFloat("" + fSumNetto, '.') );
                    entry.add( SharedUtils.formatFloat("" + fSumPorto, '.') );
                    entry.add( SharedUtils.formatFloat("" + fSumVAT, '.') );
                    entry.add( SharedUtils.formatFloat("" + fSumTotal, '.') );
                }
                catch(Exception e)
                {
                    SharedUtils.handleError(GENERAL_DB_ERROR);
                    return;
                }
                
                /*Date Name OrderNO Netto Transport VAT Total*/
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                                      "Query: 'Orders Ammount'\n" +
                                      "Filtered by:\n" +
                                      "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                                      "produced by user: " + SharedUtils.strUsername;
                String[] cols = { "" , "Date", "Patient Name","Order No","Netto ","Transport","VAT","Total"};
                int[] widths = { 5,  9, 27, 10, 8, 10, 4, 8 };
                int[] aligns = 
                { 
                  SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                  SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                  SimpleReportGenerator.ALLIGN_RIGHT, SimpleReportGenerator.ALLIGN_RIGHT, 
                  SimpleReportGenerator.ALLIGN_RIGHT, SimpleReportGenerator.ALLIGN_RIGHT
                };

                OrdersAmmountReport report = 
                        new OrdersAmmountReport( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );  
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_HISTORY_ITEMS_QUERY:
            {
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                String strSQL = "SELECT EVNT_DATE,STCK_NAME,STCK_BRCD," +
                                "STCK_CNT " +
                                " FROM view_flfl_ordr_info ";
                String strWhereClause = " WHERE EVNT_DATE >='" + strTextDateFrom + "' AND " +
                                        " EVNT_DATE <'" + strTextDateTo + "'";
                String strOrderClause = " ORDER BY EVNT_DATE ASC,STCK_NAME ASC ";
                strSQL =  strSQL + strWhereClause + strOrderClause;
                String str_rgn_columns[][] = {{"Date","align='left'"},{"Stock Name","align='left'"},{"Barcode","align='left'"},{"Stock Count","align='right'"}};
                this.str_rgn_columns = str_rgn_columns;
                ArrayList data = getResults(strSQL,str_rgn_columns.length);
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Orders History Items'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                String[] cols = { "" , "Date", "Stock Name", "Barcode " , "Stock Count" };
                int[] widths = { 5, 30, 20, 10, 13 };
                int[] aligns = 
                { 
                  SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                  SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                  SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );   
                m_reportHeader = report.m_header;
            }
            break;
            case MOVEMENT_REVISION_QUERY:
            {    
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                String strSQL = " SELECT   BASE_EVNT.EVNT_DATE,BASE_STOR.STOR_NAME,BASE_OPER.OPER_NAME," +
                         " BASE_STCK.STCK_NAME,CONN_STCK_IN_EVNT.STCK_CNT" +
                         " FROM    BASE_EVNT INNER JOIN BASE_OPER ON(BASE_EVNT.OPER_IDNT = BASE_OPER.OPER_KEY)" +
                         " INNER JOIN CONN_STCK_IN_EVNT ON(CONN_STCK_IN_EVNT.EVNT_IDNT = BASE_EVNT.EVNT_KEY)" +
                         " INNER JOIN BASE_STCK ON(CONN_STCK_IN_EVNT.STCK_IDNT = BASE_STCK.STCK_KEY)" +
                         " INNER JOIN BASE_STOR ON(BASE_EVNT.STOR_IDNT = BASE_STOR.STOR_KEY)";

                String strWhereClause = " WHERE  EVNT_DATE >='" +
                                   strTextDateFrom + "' AND " +
                                   " EVNT_DATE <'" + strTextDateTo + "'";
                String strOrderClause = " ORDER BY EVNT_DATE DESC ";
                strSQL =  strSQL + strWhereClause + strOrderClause;
                ArrayList data = getResults(strSQL,5);
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Movement Revision'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                String[] cols = { "" , "Date", "Store Name", "Operation " , "Stock Name" , "Stock Count" };
                int[] widths = { 5,  20, 20, 11, 20, 12 };
                int[] aligns = 
                { 
                  SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                  SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                  SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_RIGHT
                };

                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );  
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_DETAILS_QUERY:
                setTextAreaActive(false);
                handleOrdersDetails("Query Details");
                break;
            case STOCK_ON_HAND_QUERY:
                handleOnHand("Stocks On Hand");
                break;
            case STOCK_ON_HAND_TOTALS_QUERY:
                setTextAreaActive(false);
                handleOnHandTotals("Stocks On Hand Totals");
                break;
            case INVENTORY_CHECKOUT_QUERY:
                setTextAreaActive(false);
                handleInventoryCheckout("Inventory CheckOut");
                break;
            case INVENTORY_CHECKOUT_DIFF_QUERY:
                setTextAreaActive(false);
                handleInventoryCheckoutDiff("Inventory CheckOut Differencies");
                break;
            case TIME_TO_PURCHASE_QUERY:
                setTextAreaActive(false);
                handleTimeToPurchase("Time to purchase");
                break;
            case ORDERS_PENDING_QUERY:
            {
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                
                String strSQL = " SELECT vorgang.invc_date, " +
                                " base_prsn.prsn_fnam , base_prsn.prsn_lnam, " +
                                " vorgang.v_nr, vorgang.totl_sum " +
                                " FROM base_prsn, vorgang " +
                                " WHERE v_nr not in(select quer_idnt from conn_evnt_quer) " + 
                                " AND vorgang.INVC_DATE >='" + strTextDateFrom + "' AND " +
                                " vorgang.INVC_DATE <'" + strTextDateTo + "'" +
                                " AND vorgang.doc_type_idnt=1 " +
                                " AND vorgang.patn_idnt=base_prsn.prsn_key " + 
                                " ORDER BY vorgang.INVC_DATE ASC, vorgang.v_nr ASC";
                                
                //////////////////////////
                ArrayList data = new ArrayList();
                Connection connDB = null;
                int count = 1;
                try
                {
                    connDB = SharedUtils.getConnection();
                    Statement stm = connDB.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);   
                    while( rs.next() )
                    {
                        ArrayList entry = new ArrayList();
                        entry.add("" + count + ")" );
                        count++;
                        data.add(entry);
                        
                        String date = rs.getString(1);
                        String name1 = rs.getString(2);
                        String name2 = rs.getString(3);
                        String vnr = rs.getString(4);
                        float fTotal = SharedUtils.readFloat( rs, 5, 2 );
                        String strTotal = SharedUtils.formatFloat( "" + fTotal, '.' );
                        String name = "";
                        if( name1 != null && !name1.trim().equals("") && 
                            name2 != null && !name2.trim().equals("") )
                        {
                            name = name1.trim() + " , " + name2.trim();
                        }
                        else if( name1!=null && !name1.trim().equals("") )
                        {
                            name = name1.trim();                        
                        }
                        else if( name2!=null && !name2.trim().equals("") )
                        {
                            name = name2.trim();
                        }
                        /*Date Name OrderNO Netto Transport VAT Total*/
                        entry.add(date);
                        entry.add(name);
                        entry.add(vnr);
                        entry.add(strTotal);
                    }                    
                }
                catch(Exception e)
                {
                    SharedUtils.handleError(GENERAL_DB_ERROR);
                    return;
                }
                finally
                {
                    if( connDB != null ){
                        try{
                            connDB.close();
                        }
                        catch( Exception e ){e.printStackTrace();}
                    }                    
                }
                ////////////////////////////////////////////////////                
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Pending Orders'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + 
                              " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Date", "Patient Name", "Order No " , "Total" };
                int[] widths = { 5, 20, 30, 10, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_UNPAID_QUERY:
            {
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                String strSQL = " SELECT vorgang.invc_date, " +
                                " base_prsn.prsn_fnam , base_prsn.prsn_lnam, " +
                                " vorgang.v_nr, vorgang.totl_sum, vorgang.pay_sum " +
                                " FROM base_prsn, vorgang " +
                                " WHERE vorgang.pay_sum < vorgang.totl_sum " +
                                " AND vorgang.doc_type_idnt=1 " +
                                " AND vorgang.patn_idnt=base_prsn.prsn_key " + 
                                " AND vorgang.INVC_DATE >='" + strTextDateFrom + "' AND " +
                                " vorgang.INVC_DATE <'" + strTextDateTo + "'" +
                                " ORDER BY vorgang.INVC_DATE ASC, vorgang.v_nr ASC ";
                //////////////////////////
                ArrayList data = new ArrayList();
                Calendar cal = Calendar.getInstance();
                Connection connDB = null;
                int count = 1;
                try
                {
                    connDB = SharedUtils.getConnection();
                    Statement stm = connDB.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);   
                    while( rs.next() )
                    {
                        ArrayList entry = new ArrayList();
                        entry.add("" + count + ")" );
                        count++;
                        data.add(entry);
                        
                        String date = rs.getString(1);
                        String name1 = rs.getString(2);
                        String name2 = rs.getString(3);
                        String vnr = rs.getString(4);
                        float fTotal = SharedUtils.readFloat( rs, 5, 2 );
                        String strTotal = SharedUtils.formatFloat( "" + fTotal, '.' );
                        float fPayed = SharedUtils.readFloat( rs, 6, 3 );
                        String strPayed = SharedUtils.formatFloat( "" + fPayed, '.' );
                        String name = "";
                        if( name1 != null && !name1.trim().equals("") && 
                            name2 != null && !name2.trim().equals("") )
                        {
                            name = name1.trim() + " , " + name2.trim();
                        }
                        else if( name1!=null && !name1.trim().equals("") )
                        {
                            name = name1.trim();                        
                        }
                        else if( name2!=null && !name2.trim().equals("") )
                        {
                            name = name2.trim();
                        }
                        /*Date Name OrderNO Netto Transport VAT Total*/
                        entry.add( date );
                        entry.add( name );
                        entry.add( vnr );
                        entry.add( strTotal );
                        entry.add( strPayed );
                    }                    
                }
                catch(Exception e)
                {
                    SharedUtils.handleError(GENERAL_DB_ERROR);
                    return;
                }
                finally
                {
                    if( connDB != null ){
                        try{
                            connDB.close();
                        }
                        catch( Exception e ){e.printStackTrace();}
                    }                    
                }
                ////////////////////////////////////////////////////                
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Unpaid Orders'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + 
                              " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Date", "Patient Name", "Order No " , "Total", "Paid" };
                int[] widths = { 5, 20, 30, 10, 10, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                    SimpleReportGenerator.ALLIGN_RIGHT, SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );   
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_HISTORY_QUERY:
            {
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                
                String strSQL = " SELECT " +
                        " vorgang.v_nr, base_evnt.evnt_date, base_prsn.prsn_lnam, " +
                        " base_prsn.prsn_fnam , vorgang.totl_sum " +
                        " FROM " +
                        " base_prsn, vorgang, conn_evnt_quer, base_evnt " +
                        " WHERE base_evnt.evnt_date >='" + strTextDateFrom + "' " +
                        " AND base_evnt.evnt_date <'" + strTextDateTo + "'" +
                        " AND vorgang.patn_idnt=base_prsn.prsn_key " +
                        " AND vorgang.v_nr = conn_evnt_quer.quer_idnt " +
                        " AND base_evnt.evnt_key=conn_evnt_quer.evnt_idnt " +
                        " ORDER BY base_evnt.evnt_date ASC, vorgang.v_nr ASC ";
                System.out.println(strSQL);
                ArrayList data = new ArrayList();
                Connection conn = null;
                
                String rep_date = "Date: " +SharedUtils.getCurrentDateStringFormatted();
                String type = "Query: 'Orders History'\n";
                String rep_date_interval = "date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO);
                String producer = "produced by user: " + SharedUtils.strUsername;
                
                JFreeReportBoot jf = JFreeReportBoot.getInstance();
                if(!jf.isBootDone() || !jf.isBootInProgress()){
                    jf.start();
                }
                
                
                ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
                OHReportData rep = new OHReportData(top);
                
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);
                    HashSet vnrs = new HashSet();
                    int count = 1;
                    while( rs.next() )
                    {
                        String orderNum = rs.getString(1).trim();
                        if( !vnrs.add(orderNum)  )
                            continue;
                        
                        ArrayList entry = new ArrayList();
                        entry.add("" + count + ")" );
                        count++;
                        data.add(entry);
                        
                        String date = rs.getString(2);                        
                        String name2 = rs.getString(3);
                        String name1 = rs.getString(4);
                        
                        float fTotal = SharedUtils.readFloat( rs, 5, 2 );
                        String strTotal = SharedUtils.formatFloat("" + fTotal, '.');
                                                                        
                        String name = "";
                        if( name1 != null && !name1.trim().equals("") && 
                            name2 != null && !name2.trim().equals("") )
                        {
                            name = name1.trim() + " , " + name2.trim();
                        }
                        else if( name1!=null && !name1.trim().equals("") )
                        {
                            name = name1.trim();                        
                        }
                        else if( name2!=null && !name2.trim().equals("") )
                        {
                            name = name2.trim();
                        }
                        entry.add(date);
                        entry.add(name);
                        entry.add(orderNum);
                        entry.add(strTotal);
                        OHData rep_data = new OHData((count-1) + ")", date, name, orderNum, strTotal);
                        rep.addOrderHistoryData(rep_data);
                    }
                    vnrs = null;
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
                finally
                {
                    SharedUtils.closeConnection(conn);                    
                }
                
                
                
                OHTableModel tm = new OHTableModel();
                tm.addOrderHistoryReport(rep);
                OHPrintUtils spUtils = new OHPrintUtils(tm,"/medstore/print/reports/orderhistory/rep_hist.xml","name");
                try{
                    JFreeReport prn_rep = spUtils.createReport();
                    //CustomPrintUtil.printOn(prn_rep, Main.printer.getId());
                    final PreviewDialog preview = new PreviewDialog(prn_rep);
                    preview.setVisible(true);
                }
                catch(Exception e){
                    System.out.println(e.getMessage());
                }
                //
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Orders History'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Date", "Patient Name", "Order No " , "Total" };
                int[] widths = { 5, 20, 30, 10, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( false );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
                 
            }
            break;
            case ORDERS_USAGE:
            {
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                
                String strSQL = "select " +
                    " base_stck.stck_key,base_stck.stck_name," +
                    " base_stck.stck_brcd,position.p_menge " +
                    " from " +
                    " vorgang, position, base_stck " +
                    " WHERE " +
                    " position.nstk_idnt=base_stck.stck_key " +
                    " AND vorgang.v_nr=position.v_nr " +
                    " AND vorgang.pay_date is not null " +
                    " AND vorgang.pay_sum >= vorgang.totl_sum " +
                    " AND vorgang.pay_date>='" + strTextDateFrom + "'" +
                    " AND vorgang.pay_date<'" + strTextDateTo + "'" +
                    " order by base_stck.stck_key ASC";
                
                ArrayList data = new ArrayList();
                Connection conn = null;
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);
                    int num = 1;
                    int oldStockId = -1;
                    int stockCount = 0;
                    while( rs.next() )
                    {
                        int stockId = rs.getInt(1);
                        if( oldStockId == stockId )
                        {
                            stockCount += rs.getInt(4);
                            continue;                            
                        }
                        
                        if( data.size() > 0 )
                        {
                            ArrayList entry = (ArrayList)data.get( data.size() -1 );
                            entry.set(3, "" + stockCount );
                        }
                        
                        oldStockId = stockId;
                        ArrayList entry = new ArrayList();
                        data.add(entry);
                        
                        entry.add("" + num + ")" );
                        num++;
                        
                        String stockName = rs.getString(2);
                        String stockBarcode = rs.getString(3);
                        stockCount = rs.getInt(4);
                        
                        entry.add( stockName );
                        entry.add( stockBarcode );
                        entry.add( "" + stockCount );
                    }    
                    
                    if( data.size() > 0 )
                    {
                        ArrayList entry = (ArrayList)data.get( data.size() -1 );
                        entry.set(3, "" + stockCount );
                    }
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
                finally
                {
                    SharedUtils.closeConnection( conn );
                }
                
                Collections.sort(data, 
                            new Comparator()
                            {
                               public int compare(Object o1, Object o2 )
                               {
                                   ArrayList arr1 = (ArrayList)o1;
                                   ArrayList arr2 = (ArrayList)o2;
                                   String name1 = (String)arr1.get(1);
                                   String name2 = (String)arr2.get(1); 
                                   return name1.compareTo(name2);                                   
                               }
                            }
                    );
                  
                // correct numbers
                for( int i = 0; i < data.size(); i++ )
                {
                   ArrayList row = (ArrayList)data.get(i);
                   row.set( 0, (i+1) + ")" );
                }
                
                /* Nom.  Stock Name  Barcode  Stock Count */
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Usage'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Stock Name", "Barcode" , "Count" };
                int[] widths = { 5, 50, 10, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_USAGE_MONTHS:
            {
                String strSQL = "select " +
                    " base_stck.stck_key,vorgang.pay_date,base_stck.stck_name," +
                    " base_stck.stck_brcd,position.p_menge " +
                    " from " +
                    " vorgang, position, base_stck " +
                    " WHERE " +
                    " position.nstk_idnt=base_stck.stck_key " +
                    " AND vorgang.v_nr=position.v_nr " +
                    " AND vorgang.pay_date is not null " +
                    " AND vorgang.pay_sum >= vorgang.totl_sum " +
                    " order by base_stck.stck_key ASC,vorgang.pay_date ASC";
                
                ArrayList data = new ArrayList();
                Connection conn = null;
                Calendar cal = Calendar.getInstance();
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);
                    int num = 1;
                    int oldStockId = -1;
                    int oldMonth = -1;
                    int oldYear = -1;
                    int stockCount = 0;
                    while( rs.next() )
                    {
                        int stockId = rs.getInt(1);
                        cal.setTimeInMillis( rs.getTimestamp(2).getTime() );
                        int month = cal.get( Calendar.MONTH );
                        int year = cal.get( Calendar.YEAR );
                        
                        if( oldStockId == stockId && oldMonth == month && oldYear == year )
                        {
                            stockCount += rs.getInt(5);
                            continue;                            
                        }
                        
                        //
                        if( data.size() > 0 )
                        {
                            ArrayList entry = (ArrayList)data.get( data.size() -1 );
                            entry.set(5, "" + stockCount );
                        }
                        
                        oldStockId = stockId;
                        oldMonth = month;
                        oldYear = year;
                        ArrayList entry = new ArrayList();
                        data.add(entry);
                        
                        String stockName = rs.getString(3);
                        String stockBarcode = rs.getString(4);
                        stockCount = rs.getInt(5);
                        
                        entry.add("" + num + ")" );
                        num++;  
                        if( stockName == null )
                            stockName = "";
                        entry.add( stockName );
                        entry.add( "" + month );
                        entry.add( "" + year );
                        entry.add( stockBarcode );
                        entry.add( "" + stockCount );
                        entry.add( "" + stockId );                        
                    }    
                    
                    if( data.size() > 0 )
                    {
                        ArrayList entry = (ArrayList)data.get( data.size() -1 );
                        entry.set(5, "" + stockCount );
                    }
                    
                    Collections.sort(data, 
                            new Comparator()
                            {
                               public int compare(Object o1, Object o2 )
                               {
                                   ArrayList arr1 = (ArrayList)o1;
                                   ArrayList arr2 = (ArrayList)o2;
                                   
                                   int year1 = Integer.parseInt( (String)arr1.get(3) );
                                   int year2 = Integer.parseInt( (String)arr2.get(3) );
                                   int dif = year1- year2;
                                   if( dif != 0 )
                                       return dif;
                                   
                                   int m1 = Integer.parseInt( (String)arr1.get(2) );
                                   int m2 = Integer.parseInt( (String)arr2.get(2) );
                                   dif = m1 - m2;
                                   if( dif != 0 )
                                       return dif;
                                   
                                   String name1 = (String)arr1.get(1);
                                   String name2 = (String)arr2.get(1); 
                                   return name1.compareTo(name2);                                   
                               }
                            }
                    );                    
                    for( int i = 0; i < data.size(); i++ )
                    {
                        ArrayList entry = (ArrayList)data.get(i);
                        entry.set(0, "" + (i+1) );
                        int month = Integer.parseInt( (String)entry.get(2) );
                        entry.set(2, m_strMonths[month]  );
                        entry.remove(entry.size()-1);
                    }
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
                finally
                {
                    SharedUtils.closeConnection( conn );
                }
                
                /* Nom.  Stock Name  Barcode  Stock Count */
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Usage Months'\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Stock Name", "Month", "Year", "Barcode" , "Count" };
                int[] widths = { 5, 40, 7, 8, 10, 8 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_NUMORDERS_DAILY:
            {
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );     
                
                String strSQL = "select invc_date, v_nr from " + 
                        " vorgang where " +
                        " invc_date>='" + strTextDateFrom + "'" +
                        " AND invc_date<'" + strTextDateTo + "'" +
                        " AND doc_type_idnt=1 " + //only invoices
                        " order by invc_date ASC";                     
                
                ArrayList data = new ArrayList();
                Connection conn = null;
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);
                    int num = 1;
                    String oldDate = null;
                    int ordersCount = 0;
                    while( rs.next() )
                    {
                        String date = SharedUtils.getStringFromTimestamp(rs.getTimestamp(1),
                                SharedUtils.PARSE_ONLY_DATE);
                        if( date.equals(oldDate ) )
                        {
                            ordersCount++;
                            continue;                            
                        }
                        
                        if( data.size() > 0 )
                        {
                            ArrayList entry = (ArrayList)data.get( data.size() -1 );
                            entry.set(2, "" + ordersCount );
                        }   
                        ordersCount = 1;
                        oldDate = date;
                        ArrayList entry = new ArrayList();
                        data.add(entry);
                        entry.add("" + num + ")" );
                        num++;
                        entry.add( date );
                        entry.add( "1" );
                    }                    
                    if( data.size() > 0 )
                    {
                        ArrayList entry = (ArrayList)data.get( data.size() -1 );
                        entry.set(2, "" + ordersCount );
                    }
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
                finally
                {
                    SharedUtils.closeConnection( conn );
                }
                
                /* Nom.  Stock Name  Barcode  Stock Count */
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Number of orders(Daily)'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Date", "Count" };
                int[] widths = { 5, 20, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_NUMORDERS_MONTHLY:
            {
                String year = (String)htbFilterParams.get(YEAR_FILTER_VALUE);
                year = year.substring(2);
                String strTextDateFrom = "01.01." + year;
                String strTextDateTo = "01.01." + ( Integer.parseInt(year) + 1 );
                
                String strSQL = "select invc_date,v_nr from " + 
                        " vorgang where " +
                        " invc_date>='" + strTextDateFrom + "'" +
                        " AND invc_date<'" + strTextDateTo + "'" +
                        " AND doc_type_idnt=1 " +
                        " order by invc_date "; 
                
                ArrayList data = new ArrayList();
                Connection conn = null;
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);
                    int num = 1;
                    int oldMonth = -1;
                    int ordersCount = 0;
                    Calendar cal = Calendar.getInstance();
                    
                    for( int i = 0; i < 12; i++ )
                    {
                        ArrayList entry = new ArrayList();
                        data.add(entry);                        
                        entry.add("" + (i+1) + ")" );
                        entry.add( m_strMonths[i] );
                        entry.add( "0" );                           
                    }
                    
                    while( rs.next() )
                    {
                        cal.setTimeInMillis( rs.getTimestamp(1).getTime() );
                        int month = cal.get( Calendar.MONTH );
                        if( month == oldMonth )
                        {
                            ordersCount++;
                            continue;                            
                        }
                        
                        if( oldMonth != -1 )
                        {
                            ArrayList entry = (ArrayList)data.get( oldMonth );
                            entry.set( 2, "" + ordersCount );
                        }
                        ordersCount = 1;
                        oldMonth = month;
                    }   
                    
                    if( oldMonth >= 0 )
                    {
                        ArrayList entry = (ArrayList)data.get( oldMonth );
                        entry.set( 2, "" + ordersCount );                    
                    }
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
                finally
                {
                    SharedUtils.closeConnection( conn );
                }
                
                /* Nom.  Stock Name  Barcode  Stock Count */
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Number of orders(Monthly)'\n" +
                              "Filtered by:\n" +
                              "    Year: " + "20"+year + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Month", "Count" };
                int[] widths = { 5, 10, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );   
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_ACTIVE_SALES_PEOPLE_DAILY: //dealers
            {
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                
                //get person's create dates
                ArrayList createTimes = getOrdersCreateTimes4SalesPeople(strTextDateFrom, strTextDateTo, 2 );//dealers
                
                ArrayList data = getActivePersonsData( strTextDateFrom, strTextDateTo,
                        createTimes,Calendar.DAY_OF_MONTH, "", false );                
                                
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Active sales people(Daily)'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Date", "Count" };
                int[] widths = { 5, 20, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_ORDERS_ACTIVE_SALES_PEOPLE_MONTHLY: //dealers
            {
                String year = (String)htbFilterParams.get(YEAR_FILTER_VALUE);
                year = year.substring(2);
                String strTextDateFrom = "01.01." + year;
                String strTextDateTo = "01.01." + ( Integer.parseInt(year) + 1 );
                
                //get person's create dates
                ArrayList createTimes = getOrdersCreateTimes4SalesPeople(strTextDateFrom, strTextDateTo, 2 );//dealers
                
                //initialize data
                // walk ascending
                ArrayList data = getActivePersonsData( strTextDateFrom, strTextDateTo,
                        createTimes,Calendar.MONTH, year, true );
                                
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Active sales people(Monthly)'\n" +
                              "Filtered by:\n" +
                              "    date : " + "20"+year + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Month", "Count" };
                int[] widths = { 5, 20, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_ACTIVE_CUSTOMERS_DAILY:  //patients
            {
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                
                //get person's create dates
                ArrayList createTimes = getOrdersCreateTimes4Patients(strTextDateFrom, strTextDateTo, 3 );//patients
                
                //initialize data
                // walk ascending
                ArrayList data = getActivePersonsData( strTextDateFrom, strTextDateTo,
                        createTimes,Calendar.DAY_OF_MONTH, "", false );
                                
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Active customers(Daily)'\n" +
                              "Filtered by:\n" +
                              "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Date", "Count" };
                int[] widths = { 5, 20, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_ACTIVE_CUSTOMERS_MONTHLY: //patients
            {
                String year = (String)htbFilterParams.get(YEAR_FILTER_VALUE);
                year = year.substring(2);
                String strTextDateFrom = "01.01." + year;
                String strTextDateTo = "01.01." + ( Integer.parseInt(year) + 1 );
                
                //get person's create dates
                ArrayList createTimes = getOrdersCreateTimes4Patients(strTextDateFrom, strTextDateTo, 3 );//patients
                
                //initialize data
                // walk ascending
                ArrayList data = getActivePersonsData( strTextDateFrom, strTextDateTo,
                        createTimes,Calendar.MONTH, year, true );
                                
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: 'Active Customers(Monthly)'\n" +
                              "Filtered by:\n" +
                              "    date : " + "20"+year + "\n" +
                              "produced by user: " + SharedUtils.strUsername;
                
                String[] cols = { "" , "Month", "Count" };
                int[] widths = { 5, 20, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;  
            case ORDERS_ORDERS_COMMISIONS:
            {         
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                
                // select orders for that period
                String sql = "select " +
                    " invc_date, v_nr,prv1_idnt, prv1_comm, " +
                    " prv2_idnt, prv2_comm, prv3_idnt, prv3_comm, neto_sum, totl_sum " +
                    " from vorgang " +
                    " where " +
                    " doc_type_idnt=1 " +
                    " AND invc_date>='" + strTextDateFrom + "'" +
                    " AND invc_date<'" + strTextDateTo + "'" +
                    " order by invc_date asc, v_nr asc";                
                
                Connection conn = null;
                ArrayList orders = new ArrayList();
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while(rs.next())
                    {
                        ArrayList row = new ArrayList();
                        Timestamp tmsp = rs.getTimestamp(1);
                        String strDate = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
                        row.add( strDate );
                        row.add(rs.getString(2));
                        row.add(rs.getString(3));
                        row.add(rs.getString(4));
                        row.add(rs.getString(5));
                        row.add(rs.getString(6));
                        row.add(rs.getString(7));
                        row.add(rs.getString(8));
                        row.add( new Float( (float)SharedUtils.round( rs.getFloat(9), 2 ) ) );
                        row.add( new Float(rs.getFloat(10)) );
                        orders.add(row);
                    }
                    rs.close();
                    stm.close();
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
                finally
                {
                    SharedUtils.closeConnection(conn);
                }             
                //get persons
                HashMap personNames = new HashMap();
                sql = constructSqlForCommissionEnquiries( strTextDateFrom, 
                        strTextDateTo, (String)htbFilterParams.get("person") );
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while(rs.next())
                    {
                        String id = rs.getString(1);
                        String name1 = rs.getString("prsn_fnam");
                        String name2 = rs.getString("prsn_lnam");
                        String name = "";
                        if( name1 != null && !name1.trim().equals("") && 
                            name2 != null && !name2.trim().equals("") )
                        {
                            name = name1.trim() + " , " + name2.trim();
                        }
                        else if( name1!=null && !name1.trim().equals("") )
                        {
                            name = name1.trim();                        
                        }
                        else if( name2!=null && !name2.trim().equals("") )
                        {
                            name = name2.trim();
                        }                        
                        personNames.put( id, name );
                    }
                    rs.close();
                    stm.close();
                }
                catch(SQLException e)
                {
                    SharedUtils.handleError(GENERAL_DB_ERROR);
                }
                finally
                {
                    SharedUtils.closeConnection(conn);
                }                   
                //
                ArrayList result = new ArrayList();
                for( int i = 0; i < orders.size(); i++ )
                {
                    ArrayList order = (ArrayList)orders.get(i);
                    String date = (String)order.get(0);
                    String v_nr = (String)order.get(1);
                    String prv1_idnt = (String)order.get(2);
                    String prv1_comm = (String)order.get(3);
                    String prv2_idnt = (String)order.get(4);
                    String prv2_comm = (String)order.get(5);
                    String prv3_idnt = (String)order.get(6);
                    String prv3_comm = (String)order.get(7);
                    Float netto = (Float)order.get(8);
                    String person1Name = (String)personNames.get(prv1_idnt);
                    String person2Name = (String)personNames.get(prv2_idnt);
                    String person3Name = (String)personNames.get(prv3_idnt);
                    
                    if( netto.floatValue() == 0 )
                    {
                        orders.remove(i);
                        i--;
                        continue;
                    }
                    
                    if( person1Name == null && 
                        person2Name == null &&
                        person3Name == null )
                    {
                        orders.remove(i);
                        i--;
                        continue;
                    }                    
                    
                    // add main row
                    ArrayList orderRow = new ArrayList();
                    orderRow.add( (i+1) + ")" );
                    orderRow.add(date);
                    orderRow.add(v_nr);
                    orderRow.add("");
                    orderRow.add(SharedUtils.formatFloat( "" + netto, '.' ));

                    boolean bAdd = false;
                    ArrayList prov1Row = new ArrayList();
                    float comm = Float.parseFloat(prv1_comm) * netto.floatValue() * 0.01f;
                    if( comm > 0 && person1Name != null )
                    {
                        prov1Row.add("");
                        prov1Row.add("");
                        prov1Row.add("");
                        prov1Row.add(personNames.get(prv1_idnt));
                        prov1Row.add( SharedUtils.formatFloat( "" + comm, '.' ) );
                        bAdd = true;
                    }

                    ArrayList prov2Row = new ArrayList();
                    comm = Float.parseFloat(prv2_comm) * netto.floatValue() * 0.01f;
                    if( comm > 0 && person2Name != null )
                    {
                        prov2Row.add("");
                        prov2Row.add("");
                        prov2Row.add("");
                        prov2Row.add(personNames.get(prv2_idnt));
                        prov2Row.add( SharedUtils.formatFloat( "" + comm, '.' ) );
                        bAdd = true;
                    }
                    
                    ArrayList prov3Row = new ArrayList();
                    if( prv3_idnt != null && person3Name != null )
                    {
                        comm = Float.parseFloat(prv3_comm) * netto.floatValue() * 0.01f;
                        if( comm > 0 )
                        {
                            prov3Row.add("");
                            prov3Row.add("");
                            prov3Row.add("");
                            prov3Row.add(personNames.get(prv3_idnt));
                            prov3Row.add( SharedUtils.formatFloat( "" + comm, '.' ) );                        
                            bAdd = true;
                        }
                    }
                    
                    if( bAdd )
                    {
                        result.add(orderRow);
                        if( prov1Row.size() > 0 )
                            result.add(prov1Row);
                        if( prov2Row.size() > 0 )
                            result.add(prov2Row);
                        if( prov3Row.size() > 0 )
                            result.add(prov3Row);
                    }
                    else
                    {
                        orders.remove(i);
                        i--;                        
                    }
                }
                orders = null;
                personNames = null;                

                //
                String[] cols = { "" , "Date", "Order No", "Provision Name", "Amount" };
                int[] widths = { 5, 22, 10, 30, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                          "Query: 'Orders - Commissions'\n" +
                          "Filtered by:\n" +
                          "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                          "produced by user: " + SharedUtils.strUsername;
                OrdCommReportGenerator report = 
                        new OrdCommReportGenerator( desc , cols,  
                            result, widths, aligns, QueryTextResult.rowsPerPage );
                
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_COMMISSION_AMMOUNT:
            {                
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                
                //select orders
                String sql = "select " +
                    " v_nr,prv1_idnt, prv1_comm, " +
                    " prv2_idnt, prv2_comm, prv3_idnt, prv3_comm, neto_sum, totl_sum " +
                    " from vorgang " +
                    " where " +
                    " doc_type_idnt=1 " +
                    " AND invc_date>='" + strTextDateFrom + "'" +
                    " AND invc_date<'" + strTextDateTo + "'";
                
                Connection conn = null;
                HashMap personCommMap = new HashMap();
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while(rs.next())
                    {
                        String v_nr = rs.getString(1);
                        String prv1_idnt = rs.getString(2);
                        String prv1_comm = rs.getString(3);
                        String prv2_idnt = rs.getString(4);
                        String prv2_comm = rs.getString(5);
                        String prv3_idnt = rs.getString(6);
                        String prv3_comm = rs.getString(7);
                        float  neto_sum = rs.getFloat(8); 
                        
                        float comm = Float.parseFloat(prv1_comm) * neto_sum * 0.01f;
                        if( comm > 0 )
                        {
                            Float allComm = (Float)personCommMap.get(prv1_idnt);
                            if( allComm == null )
                                personCommMap.put( prv1_idnt, new Float(comm) );
                            else
                                personCommMap.put( prv1_idnt, new Float( comm + allComm.floatValue() ) );
                        }
                        
                        
                        comm = Float.parseFloat(prv2_comm) * neto_sum * 0.01f;
                        if( comm > 0 )
                        {
                            Float allComm = (Float)personCommMap.get(prv2_idnt);
                            if( allComm == null )
                                personCommMap.put( prv2_idnt, new Float(comm) );
                            else
                                personCommMap.put( prv2_idnt, new Float( comm + allComm.floatValue() ) );
                        }
                        
                        if( prv3_idnt == null )
                            continue;
                        
                        comm = Float.parseFloat(prv3_comm) * neto_sum * 0.01f;
                        if( comm > 0 )
                        {
                            Float allComm = (Float)personCommMap.get(prv3_idnt);
                            if( allComm == null )
                                personCommMap.put( prv3_idnt, new Float(comm) );
                            else
                                personCommMap.put( prv3_idnt, new Float( comm + allComm.floatValue() ) );                                                
                        }
                    }
                    rs.close();
                    stm.close();                    
                }
                catch(SQLException e)
                {
                     SharedUtils.handleError(GENERAL_DB_ERROR);
                }
                finally
                {
                    SharedUtils.closeConnection(conn);
                }
                ArrayList data = new ArrayList();
                sql = constructSqlForCommissionEnquiries( strTextDateFrom, 
                        strTextDateTo, (String)htbFilterParams.get("person") );
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    int num = 1;
                    while(rs.next())
                    {
                        String id = rs.getString(1);
                        String name1 = rs.getString("prsn_fnam");
                        String name2 = rs.getString("prsn_lnam");
                        String name = "";
                        if( name1 != null && !name1.trim().equals("") && 
                            name2 != null && !name2.trim().equals("") )
                        {
                            name = name1.trim() + " , " + name2.trim();
                        }
                        else if( name1!=null && !name1.trim().equals("") )
                        {
                            name = name1.trim();                        
                        }
                        else if( name2!=null && !name2.trim().equals("") )
                        {
                            name = name2.trim();
                        }   
                        
                        Float comm = (Float)personCommMap.get(id);
                        if( comm != null )
                        {
                            ArrayList row = new ArrayList();                        
                            row.add( num + ")");
                            num++;
                            row.add( name );                            
                            row.add( SharedUtils.formatFloat( comm.floatValue() + "", '.' ) );
                            data.add(row);
                        }                        
                    }
                    rs.close();
                    stm.close();
                }
                catch(SQLException e)
                {}
                finally
                {
                    SharedUtils.closeConnection(conn);
                }        
                
                //
                String[] cols = { "" , "Provision", "Amount" };
                int[] widths = { 5, 40, 10 };
                int[] aligns = 
                {
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_RIGHT
                };
                String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                          "Query: 'Commissions by period'\n" +
                          "Filtered by:\n" +
                          "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                          "produced by user: " + SharedUtils.strUsername;
                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_LETTER1:
            {
                String sql = "select vorgang.invc_date, vorgang.v_nr, vorgang.letter1Date, " + 
                        " base_prsn.prsn_lnam, base_prsn.prsn_fnam " + 
                        " from vorgang,base_prsn " +
                        " where pay_sum < totl_sum " +
                        " and vorgang.doc_type_idnt=1 " +
                        " and base_prsn.prsn_key=vorgang.patn_idnt " + 
                        " and vorgang.v_nr not in(select distinct invoiceid from vorgang where doc_type_idnt=2)" +
                        " order by vorgang.v_nr";
                
                Connection conn = null;
                Calendar currentDate = Calendar.getInstance();
                currentDate.add( Calendar.DAY_OF_MONTH ,1 );
                SharedUtils.set2BeginOfTheDay(currentDate);
                Calendar endDate = Calendar.getInstance();
                ArrayList data = new ArrayList();
                int num = 1;
                
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while( rs.next() )
                    {     
                        Timestamp orderTimeStamp = rs.getTimestamp(1);
                        endDate.setTimeInMillis( orderTimeStamp.getTime() );
                        endDate.add( Calendar.DAY_OF_MONTH, SharedUtils.letterSendDays[1] );
                        if( endDate.getTimeInMillis() >= currentDate.getTimeInMillis() )
                            continue;
                        
                        String strOrderDate = SharedUtils.getStringFromTimestamp(orderTimeStamp,SharedUtils.PARSE_BOTH_TIMES);
                        String orderNum = rs.getString(2);
                        String letterDate = "";
                        Timestamp tmsp = rs.getTimestamp(3); 
                        if( tmsp != null )
                            letterDate = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
                        
                        String name2 = rs.getString(4);
                        String name1 = rs.getString(5);
                        
                        String name = getName(name1,name2);
                        
                        ArrayList row = new ArrayList();
                        row.add( num + ")" );
                        num++;
                        row.add(orderNum);
                        row.add(name);
                        row.add(letterDate);
                        data.add(row);
                    }
                    rs.close();
                    stm.close();
                }
                catch( SQLException e )
                {
                    SharedUtils.handleError(GENERAL_DB_ERROR);
                }
                finally
                {
                    SharedUtils.closeConnection(conn);
                }
                ///////////////////////////////////////
                
                String desc = "Query: 'Orders for letter 1\n" +
                              "produced by user: " + SharedUtils.strUsername;
                String[] cols = { "" , "Order No",  "Client", "Letter 1 Date"};
                int[] widths = { 5,  10, 20, 20 };
                int[] aligns = 
                { 
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                            SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT
                };

                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_LETTER2:
            {
                String sql = "select vorgang.invc_date, vorgang.v_nr, vorgang.letter1Date, " + 
                        " vorgang.letter2Date, base_prsn.prsn_lnam, base_prsn.prsn_fnam " + 
                        " from vorgang,base_prsn " +
                        " where pay_sum < totl_sum " +
                        " and vorgang.doc_type_idnt=1 " +
                        " and base_prsn.prsn_key=vorgang.patn_idnt " +
                        " and vorgang.v_nr not in(select distinct invoiceid from vorgang where doc_type_idnt=2)" +
                        " order by vorgang.v_nr";
                
                Connection conn = null;
                Calendar currentDate = Calendar.getInstance();
                currentDate.add( Calendar.DAY_OF_MONTH ,1 );
                SharedUtils.set2BeginOfTheDay(currentDate);
                Calendar endDate = Calendar.getInstance();
                ArrayList data = new ArrayList();
                int num = 1;
                
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while( rs.next() )
                    {     
                        Timestamp orderTimeStamp = rs.getTimestamp(1);
                        endDate.setTimeInMillis( orderTimeStamp.getTime() );
                        endDate.add( Calendar.DAY_OF_MONTH, SharedUtils.letterSendDays[1] );
                        if( endDate.getTimeInMillis() >= currentDate.getTimeInMillis() )
                            continue;
                        String orderNum = rs.getString(2);
                        
                        String letter1Date = "";
                        Timestamp tmsp = rs.getTimestamp(3); 
                        if( tmsp != null )
                            letter1Date = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
                        
                        String letter2Date = "";
                        tmsp = rs.getTimestamp(4); 
                        if( tmsp != null )
                            letter2Date = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
                        
                        String name2 = rs.getString(5);
                        String name1 = rs.getString(6);
                        
                        String name = getName( name1, name2 );
                        
                        ArrayList row = new ArrayList();
                        row.add( num + ")" );
                        num++;
                        row.add(orderNum);
                        row.add(name);
                        row.add(letter1Date);
                        row.add(letter2Date);
                        data.add(row);
                    }
                    rs.close();
                    stm.close();
                }
                catch( SQLException e )
                {
                    SharedUtils.handleError(GENERAL_DB_ERROR);
                }
                finally
                {
                    SharedUtils.closeConnection(conn);
                }
                ///////////////////////////////////////
                String desc = "Query: 'Orders for letter 2\n" +
                              "produced by user: " + SharedUtils.strUsername;
                String[] cols = { "" , "Order No",  "Client", "Letter 1 Date", "Letter 2 Date" };
                int[] widths = { 5,  10, 20, 20, 20 };
                int[] aligns = 
                { 
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                            SimpleReportGenerator.ALLIGN_LEFT
                };

                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
            case ORDERS_LETTER3:
            {
                String sql = "select vorgang.invc_date, vorgang.v_nr, vorgang.letter1Date, " + 
                        " vorgang.letter2Date, vorgang.letter3Date, base_prsn.prsn_lnam, base_prsn.prsn_fnam " + 
                        " from vorgang,base_prsn " +
                        " where pay_sum < totl_sum " +
                        " and vorgang.doc_type_idnt=1 " +
                        " and base_prsn.prsn_key=vorgang.patn_idnt " +
                        " and vorgang.v_nr not in(select distinct invoiceid from vorgang where doc_type_idnt=2)" +
                        " order by vorgang.v_nr";
                
                Connection conn = null;
                Calendar currentDate = Calendar.getInstance();
                currentDate.add( Calendar.DAY_OF_MONTH ,1 );
                SharedUtils.set2BeginOfTheDay(currentDate);
                Calendar endDate = Calendar.getInstance();
                ArrayList data = new ArrayList();
                int num = 1;
                
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while( rs.next() )
                    {     
                        Timestamp orderTimeStamp = rs.getTimestamp(1);
                        endDate.setTimeInMillis( orderTimeStamp.getTime() );
                        endDate.add( Calendar.DAY_OF_MONTH, SharedUtils.letterSendDays[1] );
                        if( endDate.getTimeInMillis() >= currentDate.getTimeInMillis() )
                            continue;
                        String orderNum = rs.getString(2);
                        
                        String letter1Date = "";
                        Timestamp tmsp = rs.getTimestamp(3); 
                        if( tmsp != null )
                            letter1Date = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
                        
                        String letter2Date = "";
                        tmsp = rs.getTimestamp(4); 
                        if( tmsp != null )
                            letter2Date = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
                        
                        String letter3Date = "";
                        tmsp = rs.getTimestamp(5); 
                        if( tmsp != null )
                            letter3Date = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
                        
                         
                         String name2 = rs.getString(6);
                         String name1 = rs.getString(7);
                         String name = getName( name1, name2 );
                        
                        ArrayList row = new ArrayList();
                        row.add( num + ")" );
                        num++;
                        row.add(orderNum);
                        row.add(name);
                        row.add(letter1Date);
                        row.add(letter2Date);
                        row.add(letter3Date);
                        data.add(row);
                    }
                    rs.close();
                    stm.close();
                }
                catch( SQLException e )
                {
                    SharedUtils.handleError(GENERAL_DB_ERROR);
                }
                finally
                {
                    SharedUtils.closeConnection(conn);
                }
                ///////////////////////////////////////
                String desc = "Query: 'Orders for letter 3\n" +
                              "produced by user: " + SharedUtils.strUsername;
                String[] cols = { "" , "Order No","Client", "Letter 1 Date", "Letter 2 Date", 
                        "Letter 3 Date" };
                int[] widths = { 5,  10, 20, 20, 20, 20 };
                int[] aligns = 
                { 
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT
                };

                SimpleReportGenerator report = 
                        new SimpleReportGenerator( desc , cols,  
                            data, widths, aligns, QueryTextResult.rowsPerPage );
                setTextAreaActive( true );
                m_textArea.setText( report.generateReport() );
                m_reportHeader = report.m_header;
            }
            break;
        }
    }    
    
    private String getName( String name1 , String name2 )
    {
        String name = "";
        if( name1 != null && !name1.trim().equals("") && 
            name2 != null && !name2.trim().equals("") )
        {
            name = name1.trim() + " , " + name2.trim();
        }
        else if( name1!=null && !name1.trim().equals("") )
        {
            name = name1.trim();                        
        }
        else if( name2!=null && !name2.trim().equals("") )
        {
            name = name2.trim();
        }
        return name;
    }
    
    private String constructSqlForCommissionEnquiries( String strTextDateFrom, String strTextDateTo, String clientId )
    {
        String constraint = "";
        if( clientId != null )
            constraint = " and prsn_key=" + clientId;
        String sql = "SELECT distinct prsn_key, prsn_lnam , prsn_fnam " +
                " FROM BASE_PRSN,VORGANG " +
                " WHERE " + 
                " prsn_key in( VORGANG.prv1_idnt, VORGANG.prv2_idnt, VORGANG.prv3_idnt ) " + 
                " AND VORGANG.doc_type_idnt=1 AND VORGANG.invc_date>='" + strTextDateFrom + "'" +
                " AND VORGANG.invc_date<'" + strTextDateTo + "'" + constraint +
                " order by prsn_lnam asc ";
        return sql;
    }
    
    ArrayList getActivePersonsData( String strTextDateFrom, String strTextDateTo,
            ArrayList createTimesPersons,int rate,String year, boolean hasEmptyPeriods )
    {
        ArrayList data = new ArrayList();                
        Calendar calEnd = Calendar.getInstance();
        String[] fields = strTextDateTo.split( "\\." );
        calEnd.set( Calendar.YEAR, 2000 + Integer.parseInt( fields[2] ) );
        calEnd.set( Calendar.MONTH, Integer.parseInt( fields[0] ) - 1 );
        calEnd.set( Calendar.DAY_OF_MONTH, Integer.parseInt( fields[1] ) );
        SharedUtils.set2BeginOfTheDay( calEnd );
        
        Calendar calBeg = Calendar.getInstance();
        fields = strTextDateFrom.split( "\\." );
        calBeg.set( Calendar.YEAR, 2000 + Integer.parseInt( fields[2] ) );
        calBeg.set( Calendar.MONTH, Integer.parseInt( fields[0] ) - 1 );
        calBeg.set( Calendar.DAY_OF_MONTH, Integer.parseInt( fields[1] ) );
        SharedUtils.set2BeginOfTheDay( calBeg );
        int num = 1;
        int beginJ = 0;
        while( calEnd.getTimeInMillis() > calBeg.getTimeInMillis() )
        {
            long begin = calBeg.getTimeInMillis();
            calBeg.add( rate, 1 );
            long end = calBeg.getTimeInMillis();
            int count = 0;
            HashSet persons = new HashSet();
            for( int j = beginJ; j < createTimesPersons.size(); j++ )
            {
                ArrayList row = (ArrayList)createTimesPersons.get(j);
                String persId = (String)row.get(0);
                long createTime = ((Long)row.get(1)).longValue(); 
                
                if( createTime < begin )
                {
                    beginJ = j + 1;
                    continue;
                }
                
                if( /*createTime>=begin &&*/ createTime<end  )
                {
                    beginJ = j + 1;
                    if( persons.add(persId) )
                        count++;
                }                
            }
            
            if( !hasEmptyPeriods && count == 0 )
                continue;
            ArrayList row = new ArrayList();            
            row.add( num + ")" );
            if( rate == Calendar.DAY_OF_MONTH )
            {
                row.add( SharedUtils.getDateFromMillis( 
                        begin,  SharedUtils.PARSE_ONLY_DATE ) );
            }
            else if( rate == Calendar.MONTH )
            {
                row.add( m_strMonths[num-1] + " " + year );                                
            }
            else
                throw new java.lang.AssertionError();
            row.add( "" + count );
            data.add(row);
            num++;
        }         
        System.out.println("\n\n\n");
        return data;
    }    
    
    
    ArrayList getOrdersCreateTimes4Patients(String strTextDateFrom, String strTextDateTo, int pesrsonType)
    {
        String strSQL = " select " +
                        " patn_idnt,invc_date  " +
                        " from vorgang " +
                        " where " +
                        " invc_date>='" + strTextDateFrom + "'" + 
                        " AND invc_date<'" + strTextDateTo + "'" + 
                        " order by invc_date asc";
        ArrayList createTimes = new ArrayList();
        Connection conn = null;
        try
        {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(strSQL);
            while( rs.next() )
            {
                ArrayList list = new ArrayList();
                String persId = rs.getString(1);
                Long createTime = new Long( rs.getTimestamp(2).getTime() );
                list.add( persId );
                list.add(createTime);   
                createTimes.add(list);
            }                                        
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        finally
        {
            SharedUtils.closeConnection( conn );
        }
        return createTimes;
    }
    
    ArrayList getOrdersCreateTimes4SalesPeople(String strTextDateFrom, String strTextDateTo, int pesrsonType)
    {
        String strSQL = " select " +
                        " invc_date, prv2_idnt, prv3_idnt " +
                        " from vorgang " +
                        " where " +
                        " invc_date>='" + strTextDateFrom + "'" + 
                        " AND invc_date<'" + strTextDateTo + "'" + 
                        " order by invc_date asc";
        ArrayList createTimes = new ArrayList();
        Connection conn = null;
        try
        {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(strSQL);
            while( rs.next() )
            {
                ArrayList list = new ArrayList();
                Long createTime = new Long( rs.getTimestamp(1).getTime() );
                String persId = rs.getString(2);  //prov2              
                list.add( persId );
                list.add(createTime);   
                createTimes.add(list);
                
                persId = rs.getString(3);//prov3
                if( persId != null )
                {
                    list = new ArrayList();
                    list.add( persId );
                    list.add(createTime);
                    createTimes.add(list);
                }                
            }                                        
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        finally
        {
            SharedUtils.closeConnection( conn );
        }
        return createTimes;
    }
    
    public void toHTMLFile(File file){
        String strResult = tpQueryResult.getText();
        FileOutputStream fileOutStream=null;
        try{
            fileOutStream = new FileOutputStream(file);
            fileOutStream.write(strResult.getBytes("US-ASCII"));
            fileOutStream.close();
            JOptionPane.showMessageDialog(null, "You have successfully export the data into a file:  " + file.getAbsolutePath());
        }catch(IOException ioe){
            SharedUtils.handleError(INTERNAL_SYSTEM_ERROR);
            fileOutStream=null;
            file = null;
            return;
        }
    }
    
     public void toTXTFile(File file){
        String strResult = m_textArea.getText();
        FileOutputStream fileOutStream=null;
        try{
            fileOutStream = new FileOutputStream(file);
            fileOutStream.write(strResult.getBytes("US-ASCII"));
            fileOutStream.close();
            JOptionPane.showMessageDialog(null, "You have successfully export the data into a file:  " + file.getAbsolutePath());
        }catch(IOException ioe){
            SharedUtils.handleError(INTERNAL_SYSTEM_ERROR);
            fileOutStream=null;
            file = null;
            return;
        }
    }

    public void saveToFile(int nQueryID){
        FileOutputStream fileOutStream=null;
        File file = null;
        JFileChooser chooser = new JFileChooser();
        chooser.setAcceptAllFileFilterUsed(false);
        if( !m_isTextAreaActive )
        {
            UniversalFileFilter htmlFilter = new UniversalFileFilter(UniversalFileFilter.HTML_FILES);
            chooser.addChoosableFileFilter(htmlFilter);
        }
        else
        {
            UniversalFileFilter htmlFilter = new UniversalFileFilter(UniversalFileFilter.TXT_FILES);
            chooser.addChoosableFileFilter(htmlFilter);
        }
        int returnVal = chooser.showSaveDialog(this);
        while(returnVal == JFileChooser.APPROVE_OPTION) {
            byte bRowDelimiter[] = {'\n'};
            byte bElemDelimiter[] = {';'};
            file = chooser.getSelectedFile();
            int nFileType = ((UniversalFileFilter)chooser.getFileFilter()).filter;
            String extension = UniversalFileFilter.getExtension(file);
            if(extension==null){
                JOptionPane.showMessageDialog(null, "Please select appropriate file extension");
                returnVal = chooser.showSaveDialog(this);
                continue;
            }
            if(nFileType == UniversalFileFilter.CSV_FILES){
                if(!extension.equals(UniversalFileFilter.str_rgn_extensions[UniversalFileFilter.CSV_FILES])){
                    JOptionPane.showMessageDialog(null, "Please select appropriate file extension");
                    returnVal = chooser.showSaveDialog(this);
                    continue;
                }
                break;
            }
            else if(nFileType == UniversalFileFilter.HTML_FILES){
                if(!extension.equals(UniversalFileFilter.str_rgn_extensions[UniversalFileFilter.HTML_FILES]) &&
                        !extension.equals("htm")){
                    JOptionPane.showMessageDialog(null, "Please select appropriate file extension");
                    returnVal = chooser.showSaveDialog(this);
                    continue;
                }
                toHTMLFile(file);
                break;
            }
            else if( nFileType == UniversalFileFilter.TXT_FILES ){
                if(!extension.equals(UniversalFileFilter.str_rgn_extensions[UniversalFileFilter.TXT_FILES]) &&
                        !extension.equals("txt")){
                    JOptionPane.showMessageDialog(null, "Please select appropriate file extension");
                    returnVal = chooser.showSaveDialog(this);
                    continue;
                }
                toTXTFile(file);
                break;
            }
            else {
                JOptionPane.showMessageDialog(null, "Please select appropriate file format");
                returnVal = chooser.showSaveDialog(this);
                continue;
            }
        }
    }

    public void afterInitComponents(){
        HTMLEditorKit htmlEditorKit = new HTMLEditorKit();
        tpQueryResult.setEditorKit(htmlEditorKit);
        DOMParser parser = new DOMParser();
        QueryTextResult.rowsPerPage = SharedUtils.rowsPerPage;
        tpQueryResult.setContentType("text/html");
        handleQuery(nQueryType);         
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
    
    private void handleOrdersDetails(String strQueryName)
    {
        String strTextDateFrom = getFromDate();
        String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
        strTextDateTo = SharedUtils.getToDate( strTextDateTo );
        
        String strSQL = " SELECT EVNT_DATE,V_NR,STCK_BRCD," +
                        " STCK_NAME,P_MENGE,SUM_PRIC,TOTL_SUM " +
                        " FROM VIEW_ORDR_DTLS ";
        String strWhereClause = " WHERE  EVNT_DATE >='" +
                                   strTextDateFrom + "' AND " +
                                   " EVNT_DATE <'" + strTextDateTo + "'";
        
        strSQL =  strSQL + strWhereClause;// + strOrderClause;
        try{
            
            String strAntetka = "--------------";            
            ArrayList data = getOrdersDetailsResults(strSQL);
            //generate plain text
            String strDesc = "Date: " + 
            SharedUtils.getCurrentOnlyDateStringFormatted() + "\n" +
                  "Query: '" + strQueryName + "'\n" +
                  "Filtered by:\n" +
                  "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO) + "\n" +
                  "produced by user: " + SharedUtils.strUsername;
            OrderDetailsReport report = 
                    new OrderDetailsReport( strDesc, data, 
                        rowsPerPage, strAntetka );
            setTextAreaActive( true );
            m_textArea.setText( report.generateReport() );
            m_reportHeader = report.m_header;
            return;            
        }catch(SQLException sqle){
            sqle.printStackTrace();
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
    }
    
    private ArrayList getOrdersDetailsResults(String strSQL)
        throws SQLException
    {
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        Statement stm = connDB.createStatement();
        ResultSet rsDBData = stm.executeQuery(strSQL);
        ResultSetMetaData resultsMetaData = rsDBData.getMetaData();
        ArrayList result = new ArrayList();
        while(rsDBData.next())
        {
             String strRow = "";
             Timestamp tmsp = rsDBData.getTimestamp(1);
             //String strDate = SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES);
             String strOrderNo = rsDBData.getString(2);
             String strBarcode = rsDBData.getString(3);
             String strStockName = rsDBData.getString(4);
             int nQuantity = rsDBData.getInt(5);
             String strQuantity = String.valueOf(nQuantity);
             float fPrice = rsDBData.getFloat(6);
             float fTotal = rsDBData.getFloat(7);
             
             ArrayList row = new ArrayList();
             result.add( row );
             row.add( null );
             row.add( tmsp );
             row.add( strOrderNo );
             row.add( strBarcode );
             row.add( strStockName );
             row.add( new Integer(nQuantity) );
             row.add( new Float( fPrice ) );
             row.add( new Float( fTotal ) ); // total             
        }  
        Collections.sort( result, new Comparator()
        {
            public int compare( Object o1, Object o2 )        
            {
                ArrayList arr1 = (ArrayList)o1;
                ArrayList arr2 = (ArrayList)o2;
                
                Timestamp tmsp1 = (Timestamp)arr1.get(1);
                Timestamp tmsp2 = (Timestamp)arr2.get(1);
                long ldif = tmsp1.getTime() - tmsp2.getTime();
                if( ldif > 0 )
                    return 1;
                if( ldif < 0 )
                    return -1;
                String strOrderNo1 = (String)arr1.get(2);
                String strOrderNo2 = (String)arr1.get(2);
                return strOrderNo1.compareTo(strOrderNo2);
            }
        }
        );
        return result;
    }
    
    private void handleOnHand(String strQueryName){
        try{
            String strSQL = " SELECT STOR_NAME, STCK_NAME,STCK_BRCD,CONN_STCK_IN_STOR.STCK_CNT " +
                            " FROM BASE_STCK INNER JOIN CONN_STCK_IN_STOR ON " +
                            " (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT)" +
                            " INNER JOIN BASE_STOR ON CONN_STCK_IN_STOR.STOR_IDNT = BASE_STOR.STOR_KEY";
            String strWhereClause = "";
            String strOrderClause = " ORDER BY STOR_NAME,STCK_BRCD";
            strSQL =  strSQL + strWhereClause + strOrderClause;

            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ResultSetMetaData resultsMetaData = rsDBData.getMetaData();
            boolean more = rsDBData.next();
            String strOldStore="";
            String strAntetka = "-----------------";
            ArrayList data = new ArrayList();
            int num = 0;
            while(more)
            {
                 String strStore = rsDBData.getString(1);
                 String strStockName = rsDBData.getString(2);
                 String strBarcode = rsDBData.getString(3);
                 int nQuantity = rsDBData.getInt(4);
                 String strQuantity = String.valueOf(nQuantity);
                 
                 ArrayList row = new ArrayList();
                 if(strStore.equals(strOldStore))
                 {
                     row.add( " " );
                     row.add( strStockName );
                     row.add( strBarcode );
                     row.add( strQuantity );                    
                 }
                 else
                 {
                     if( num > 0 )
                     {
                         row.add( strAntetka );
                         row.add( strAntetka );
                         row.add( strAntetka );
                         row.add( strAntetka );
                         data.add(row);                     
                         row = new ArrayList();
                     }
                     row.add( strStore );
                     row.add( strStockName );
                     row.add( strBarcode );
                     row.add( strQuantity );
                 }
                 data.add(row);
                 strOldStore = strStore;
                 more = rsDBData.next();  
                 num++;
            }
            rsDBData.close();
            stm.close();
            /////////////////////////
            String desc = "Date: " + SharedUtils.getCurrentDateStringFormatted() + "\n" +
                              "Query: '" + strQueryName + "'\n" +
                              "produced by user: " + SharedUtils.strUsername;            
            String[] cols = {"Store","Stock Name","Barcode","Stock Count"};
            int[] widths = { 20,  30, 10, 12 };            
            int[] aligns = { 
                SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_RIGHT };                
            SimpleReportGenerator report = 
                   new SimpleReportGenerator( desc , cols,  
                   data, widths, aligns, QueryTextResult.rowsPerPage, false );
            setTextAreaActive( true );
            m_textArea.setText( report.generateReport() );
            m_reportHeader = report.m_header;
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }

    }

    private void handleOnHandTotals(String strQueryName){
        try{
            String strSQL = " SELECT STCK_BRCD, STCK_NAME, STOR_NAME,CONN_STCK_IN_STOR.STCK_CNT " +
                            " FROM BASE_STCK INNER JOIN CONN_STCK_IN_STOR ON " +
                            " (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT)" +
                            " INNER JOIN BASE_STOR ON CONN_STCK_IN_STOR.STOR_IDNT = BASE_STOR.STOR_KEY";
            String strWhereClause = "";
            String strOrderClause = " ORDER BY STCK_BRCD,STOR_NAME";
            strSQL =  strSQL + strWhereClause + strOrderClause;
            
            //System.out.println(strSQL);
            
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ResultSetMetaData resultsMetaData = rsDBData.getMetaData();
            boolean more = rsDBData.next();
            String strOldBarcode="";
            String strAntetka = "--------------";
            int nProductCount=0;
            ArrayList data = new ArrayList();
            int num = 0;
            while(more){
                ArrayList row;
                String strBarcode = rsDBData.getString(1);
                String strStockName = rsDBData.getString(2);
                String strStore = rsDBData.getString(3);
                int nQuantity = rsDBData.getInt(4);
                String strQuantity = String.valueOf(nQuantity);
                
                if(strOldBarcode.equals(strBarcode))
                {
                    row = new ArrayList();
                    row.add(" ");
                    row.add(" ");
                    row.add(strStore);
                    row.add(strQuantity);                     
                    data.add(row);
                }
                else
                {
                    if(rsDBData.getRow()>1)
                    {
                        row = new ArrayList();
                        row.add(" ");
                        row.add(" ");
                        row.add("Total Count");
                        row.add(String.valueOf(nProductCount));
                        data.add(row);                         
                        row = new ArrayList();
                    }
                    if( num > 0 )
                    {
                        row = new ArrayList();
                        row.add(strAntetka);
                        row.add(strAntetka);
                        row.add(strAntetka);
                        row.add(strAntetka);
                        data.add(row);
                    }
                     
                    row = new ArrayList();                     
                    row.add(strBarcode);
                    row.add(strStockName);
                    row.add(strStore);
                    row.add(strQuantity);                    
                    data.add(row);
                     
                    nProductCount=0;
                 }
                 strOldBarcode = strBarcode;
                 nProductCount += nQuantity;
                 more = rsDBData.next();
                 if(!more)
                 {
                     row = new ArrayList();
                     row.add(" ");
                     row.add(" ");
                     row.add("Total Count");                     
                     row.add(String.valueOf(nProductCount));                     
                     data.add(row);
                 }
                 num++;
            }
            rsDBData.close();
            stm.close();
            if( data.size() > 0 )
                data.remove(0);
            
            /////////////////////////
            String desc = "Date: " + SharedUtils.getCurrentOnlyDateStringFormatted() + "\n" +
                    "Query: '" + strQueryName + "\n" +
                    "produced by user: " + SharedUtils.strUsername;
            String cols[] = {"Barcode","Stock Name","Store","Stock Count"};
            int[] widths = { 10,  30, 20, 12 };            
            int[] aligns = { 
                SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_RIGHT };                
            SimpleReportGenerator report = 
                   new SimpleReportGenerator( desc , cols,  
                   data, widths, aligns, QueryTextResult.rowsPerPage, false );
            setTextAreaActive( true );
            m_textArea.setText( report.generateReport() );
            m_reportHeader = report.m_header;
            
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }

    }

    private void handleInventoryCheckout(String strQueryName){
        try{
            String strSQL = " SELECT STOR_NAME, STCK_NAME,STCK_BRCD,CONN_STCK_IN_STOR.STCK_CNT " +
                            " FROM BASE_STCK INNER JOIN CONN_STCK_IN_STOR ON " +
                            " (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT)" +
                            " INNER JOIN BASE_STOR ON CONN_STCK_IN_STOR.STOR_IDNT = BASE_STOR.STOR_KEY";
            String strWhereClause = "";
            String strOrderClause = " ORDER BY STOR_NAME,STCK_BRCD";
            strSQL =  strSQL + strWhereClause + strOrderClause;
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ResultSetMetaData resultsMetaData = rsDBData.getMetaData();
            boolean more = rsDBData.next();
            String strOldStore="";
            String strAntetka = "---------";
            ArrayList data = new ArrayList();
            int num = 0;
            while(more)
            {
                 String strRow = "";
                 String strStore = rsDBData.getString(1);
                 String strStockName = rsDBData.getString(2);
                 String strBarcode = rsDBData.getString(3);
                 int nQuantity = rsDBData.getInt(4);
                 String strQuantity = String.valueOf(nQuantity);
                 
                 if(strStore.equals(strOldStore))
                 {
                     ArrayList row = new ArrayList();
                     row.add( "" );
                     row.add( strStockName );
                     row.add( strBarcode );
                     row.add( strQuantity );
                     row.add( "......" );
                     data.add( row );                     
                 }
                 else
                 {
                     if( num > 0 )
                     {
                         ArrayList row = new ArrayList();
                         row.add( "strAntetka" );
                         row.add( "strAntetka" );
                         row.add( "strAntetka" );
                         row.add( "strAntetka" );
                         row.add( "strAntetka" );
                         data.add(row);
                     }
                     
                     ArrayList row = new ArrayList();
                     row.add( strStore );
                     row.add( strStockName );
                     row.add( strBarcode );
                     row.add( strQuantity );
                     row.add( "......" );
                     data.add(row);
                 }
                 strOldStore = strStore;
                 more = rsDBData.next();
            }
            rsDBData.close();
            stm.close();
            
            String desc = "Date: " + SharedUtils.getCurrentOnlyDateStringFormatted() + "\n" +
                                  "Query: '" + strQueryName + "'\n" +
                                  "produced by user: " + SharedUtils.strUsername;
            String cols[] = { "Store","Stock Name","Barcode","Stock Count", "Check Out" };
            int[] widths = { 20,  30, 10, 12, 10 };
            int[] aligns = { 
                SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_RIGHT,
                SimpleReportGenerator.ALLIGN_RIGHT};                
            SimpleReportGenerator report = 
                   new SimpleReportGenerator( desc , cols,  
                   data, widths, aligns, QueryTextResult.rowsPerPage, false );
            setTextAreaActive( true );
            m_textArea.setText( report.generateReport() );
            m_reportHeader = report.m_header;
        }
        catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
    }

    private void handleInventoryCheckoutDiff(String strQueryName){
        try{
            String strSQL = " SELECT STOR_NAME, STCK_NAME,STCK_BRCD,CONN_STCK_IN_STOR.STCK_CNT," +
                            " CONN_STCK_IN_STOR.STCK_IVTR, (CONN_STCK_IN_STOR.STCK_CNT - CONN_STCK_IN_STOR.STCK_IVTR) AS DIFF " +
                            " FROM BASE_STCK INNER JOIN CONN_STCK_IN_STOR ON " +
                            " (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT)" +
                            " INNER JOIN BASE_STOR ON CONN_STCK_IN_STOR.STOR_IDNT = BASE_STOR.STOR_KEY";
            String strWhereClause = "";
            String strOrderClause = " ORDER BY STOR_NAME,STCK_BRCD";
            strSQL =  strSQL + strWhereClause + strOrderClause;
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ResultSetMetaData resultsMetaData = rsDBData.getMetaData();
            boolean more = rsDBData.next();
            String strOldStore="";
            String strAntetka = "---------------";
            ArrayList data = new ArrayList();
            int num = 0;
            while(more)
            {
                 String strRow = "";
                 String strStore = rsDBData.getString(1);
                 String strStockName = rsDBData.getString(2);
                 String strBarcode = rsDBData.getString(3);
                 int nQuantity = rsDBData.getInt(4);
                 String strQuantity = String.valueOf(nQuantity);
                 String strIvtr = rsDBData.getString(5);
                 String strDiff = rsDBData.getString(6);

                 if(strStore.equals(strOldStore))
                 {
                     ArrayList row = new ArrayList();
                     row.add("");
                     row.add(strStockName);
                     row.add(strBarcode);
                     row.add(strQuantity);
                     row.add(strIvtr);
                     row.add(strDiff);
                     data.add(row);
                 }
                 else
                 {
                     ArrayList row = new ArrayList();
                     if( num > 0 )
                     {
                         row.add(strAntetka);
                         row.add(strAntetka);
                         row.add(strAntetka);
                         row.add(strAntetka);
                         row.add(strAntetka);
                         row.add(strAntetka);
                         data.add( row );
                         row = new ArrayList();
                     }                                          
                     row.add(strStore);
                     row.add(strStockName);
                     row.add(strBarcode);
                     row.add(strQuantity);
                     row.add(strIvtr);
                     row.add(strDiff);                     
                     data.add( row );
                 }
                 strOldStore = strStore;
                 more = rsDBData.next(); 
                 num++;
            }
            rsDBData.close();
            stm.close();
            //
            String desc = "Date: " + SharedUtils.getCurrentOnlyDateStringFormatted() + "\n" +
                    "Query: '" + strQueryName + "'\n" +
                    "produced by user: " + SharedUtils.strUsername;
            String cols[] = {"Store","Stock Name","Barcode","Stock Count","Check Out","Difference"};
            int[] widths = { 20,  25, 9, 12, 10, 11 };
            int[] aligns = { 
                SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT,
                SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_RIGHT,
                SimpleReportGenerator.ALLIGN_RIGHT, SimpleReportGenerator.ALLIGN_RIGHT
            };
            SimpleReportGenerator report = 
                   new SimpleReportGenerator( desc , cols,  
                   data, widths, aligns, QueryTextResult.rowsPerPage, false );
            setTextAreaActive( true );
            m_textArea.setText( report.generateReport() );
            m_reportHeader = report.m_header;                                  
        }
        catch(SQLException sqle)
        {
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
    }

    private void handleTimeToPurchase(String strQueryName){
        //int nStoreKey  = ((Integer)htbFilterParams.get(COMBO_OBJ_ID)).intValue();
        String strPersent = (String)htbFilterParams.get(LIMIT_PERSENT);
        int nPersent = Integer.parseInt(strPersent);
        final int STOCK_NAME_INDEX=0;
        final int STOCK_BARCODE_INDEX=1;
        final int STOCK_CSUM_INDEX=2;
        final int STOCK_LIMIT_INDEX=3;
        final int STOCK_CNTN_BARCODE_INDEX=4;
        final int STOCK_KEY=5;
        String strTableSQL = "SELECT PCKG_NAME,PCKG_BRCD,(PCKG_ONHN*PCKG_PCNT) AS CSUM,PCKG_LIMT,CNTN_BRCD,PCKG_KEY FROM VIEW_STCK_CNT";
        String str_rgn_columns[] = {"Stock Name","Barcode","On Hand","Limit + " + strPersent + "%" };
        try
        {
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strTableSQL);
            UniversalTableModel tbmAllStocks = new UniversalTableModel(rsDBData,str_rgn_columns);
            tbmAllStocks.convertStringToInt(STOCK_CSUM_INDEX);
            int nRowCount = tbmAllStocks.getRowCount();
            for(int i=0; i < nRowCount; i++ ){
                String strCntnBcode = (String)tbmAllStocks.getValueAt(i, STOCK_CNTN_BARCODE_INDEX);
                String strOnHand = (String)tbmAllStocks.getValueAt(i, STOCK_CSUM_INDEX);
                if(!strCntnBcode.equals("")){
                    int nContentIndex = tbmAllStocks.getContentIndex(STOCK_BARCODE_INDEX,strCntnBcode);
                    if(nContentIndex!= -1){
                        String strCntnOnHand = (String)tbmAllStocks.getValueAt(nContentIndex, STOCK_CSUM_INDEX);
                        int nNewValue = Integer.parseInt(strCntnOnHand) + Integer.parseInt(strOnHand);
                        tbmAllStocks.setValueAt(String.valueOf(nNewValue), nContentIndex, STOCK_CSUM_INDEX);
                    }

                }
            }
            for(int i=0; i < tbmAllStocks.getRowCount(); i++ )
            {
                String strCntnBcode = (String)tbmAllStocks.getValueAt(i, STOCK_CNTN_BARCODE_INDEX);
                String strOnHand = (String)tbmAllStocks.getValueAt(i, STOCK_CSUM_INDEX);
                String strLimit = (String)tbmAllStocks.getValueAt(i, STOCK_LIMIT_INDEX);
                int nLimit = Integer.parseInt(strLimit);
                nLimit = nLimit + nLimit*nPersent/100;
                strLimit = String.valueOf(nLimit);
                tbmAllStocks.setValueAt(strLimit,i,STOCK_LIMIT_INDEX);
                if(strCntnBcode.compareTo("")!=0){
                    tbmAllStocks.removeItemAt(i);
                    i--;                    
                }else if(Integer.parseInt(strOnHand) > nLimit){
                    tbmAllStocks.removeItemAt(i);
                    i--;                    
                }
            }
            String strAntetka = "-----------------";
            ArrayList data = new ArrayList();
            nRowCount = tbmAllStocks.getRowCount();
            for(int i=0; i < nRowCount; i++ ){
                String strStockName = (String)tbmAllStocks.getValueAt(i, STOCK_NAME_INDEX);
                String strBarcode = (String)tbmAllStocks.getValueAt(i, STOCK_BARCODE_INDEX);
                String strOnHand = (String)tbmAllStocks.getValueAt(i, STOCK_CSUM_INDEX);
                String strLimit = (String)tbmAllStocks.getValueAt(i, STOCK_LIMIT_INDEX);
                
                ArrayList row = new ArrayList();
                row.add( strStockName );
                row.add( strBarcode );
                row.add( strOnHand );
                row.add( strLimit );                  
                data.add( row );
            }
            rsDBData.close();
            stm.close();
            
            /////////////////////////
            String desc = 
                    "Date: " + SharedUtils.getCurrentOnlyDateStringFormatted() + "\n" +
                    "Query: '" + strQueryName + "'\n" +
                                  "Filtered by:\n" +
                                  "    percent of stock limit:" + strPersent + "\n" +
                                  "produced by user: " + SharedUtils.strUsername;
            
            String cols[] = { "Stock Name", "Barcode", "On Hand",
                    "Limit + " + strPersent + "%" };
            int[] widths = { 30,  10, 10, 13 };          
            int[] aligns = { SimpleReportGenerator.ALLIGN_LEFT, 
                    SimpleReportGenerator.ALLIGN_LEFT, SimpleReportGenerator.ALLIGN_LEFT, 
                    SimpleReportGenerator.ALLIGN_RIGHT };                
            SimpleReportGenerator report = 
                   new SimpleReportGenerator( desc , cols,  
                   data, widths, aligns, QueryTextResult.rowsPerPage, false );
            setTextAreaActive( true );
            m_textArea.setText( report.generateReport() );
            m_reportHeader = report.m_header;            
        }
        catch(SQLException sqle)
        {
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
    }
    
      
    private ArrayList getResults( String strSQL,int nColumnCount )
    {
        ArrayList result = new ArrayList();
        try
        {           
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ResultSetMetaData resultsMetaData = rsDBData.getMetaData();
            boolean more = rsDBData.next();
            int count = 1;
            while(more)
            { 
                ArrayList entry = new ArrayList();
                result.add(entry);
                entry.add( "" + count + ")" );
                count++;
                for(int i = 1; i < nColumnCount + 1; i++)
                {
                    if(resultsMetaData.getColumnType(i)==Types.TIMESTAMP){
                         Timestamp tmsp = rsDBData.getTimestamp(i);
                         entry.add( SharedUtils.getStringFromTimestamp(tmsp,SharedUtils.PARSE_BOTH_TIMES) );
                    }
                    else
                    {
                        String str = rsDBData.getString(i);
                        str = (str == null) ? "" : str.trim();
                        entry.add( str );
                    }                          
                }
                more = rsDBData.next();
            }
            rsDBData.close();
            stm.close();

        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        } 
        return result;
    }
    
    
    public void printResults()
    {
        JTextComponent componnent;
        if( m_isTextAreaActive )
        {
            componnent = m_textArea;
        }
        else
        {
            componnent = tpQueryResult;
        }          
        try
        {
            PrinterPageableText printer = 
                    new PrinterPageableText( componnent, 
                    m_reportHeader, nQueryType );
            printer.print();
        }
        catch(PrinterException pex)
        {
            JOptionPane.showMessageDialog(null,"There is a problem with your printer!Invoice cannot be printed!");
            return;
        }
    }
    
    private void setTextAreaActive(boolean isActive)
    {
        if( m_isTextAreaActive == isActive )
            return;
        m_isTextAreaActive = isActive;
        if( isActive )
        {
            m_textArea = new javax.swing.JTextArea();       
            m_textArea.setMargin(new java.awt.Insets(0, 0, 0, 0));
            m_textArea.setEditable(false);
            m_textArea.setBackground( Color.WHITE );
            jScrollPane1.setViewportView(m_textArea);  
        }
        else
        {
            tpQueryResult.setFont(new java.awt.Font("Times New Roman", 0, 13));
            tpQueryResult.setAlignmentX(0.0F);
            tpQueryResult.setAlignmentY(0.0F);
            tpQueryResult.setMargin(new java.awt.Insets(0, 0, 0, 0));
            jScrollPane1.setViewportView(tpQueryResult);            
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnPrint;
    private javax.swing.JButton btnSaveToFile;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JEditorPane tpQueryResult;
    // End of variables declaration//GEN-END:variables
    public static int fontSize = 10;
    public static int rowsPerPage = 0;
    javax.swing.JTextArea m_textArea = new javax.swing.JTextArea();
    boolean m_isTextAreaActive = false;
}
