/*
 * SalesMovDiagramPanel.java
 *
 * Created on , 2005,  7, 16:52
 */

package medstore;

import java.awt.*;
import java.sql.*;
import java.util.*;
import javax.swing.*;

/**
 *
 * @author  ait
 */
public class SalesMovDiagramPanel extends javax.swing.JPanel implements SharedConstants {
    int m_year;
    String m_stockId;
    ArrayList m_sales;
    
    /** Creates new form SalesMovDiagramPanel */
    public SalesMovDiagramPanel() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents

        setLayout(new java.awt.BorderLayout());

        setBackground(new java.awt.Color(255, 255, 255));
    }//GEN-END:initComponents
    
    
    private void drawCoordinateSystem(Graphics2D g, int padLeft, int padBottom,
            int divSizeY, int numDivY, int divSizeX )
    {
        //1.draw vertical axis   
        int bottomLeftX = padLeft;
        int bottomLeftY = this.getHeight() - padBottom;
        int xWidth = 12 * divSizeX;
        g.drawLine( bottomLeftX, bottomLeftY,
                    bottomLeftX, this.getHeight() - numDivY * divSizeY );
        //2.draw vertical divisions and horizontal dahsed lines
        int x1 = bottomLeftX - 2;
        int x2 = x1 + 4;
        for( int i = 0; i < numDivY; i++ )
        {
            int y =  this.getHeight() - divSizeY * ( i + 1 );
            g.drawLine( x1, y, x2, y );
        }
        float dashes[] = { 10 };
        Stroke oldStroke = g.getStroke();
        g.setStroke( new BasicStroke( 1, BasicStroke.CAP_ROUND,
                BasicStroke.JOIN_ROUND, 10, dashes, 4 ) );
        for( int i = 0; i < numDivY; i++ )
        {
            int y =  this.getHeight() - divSizeY * ( i + 1 );
            g.drawLine( bottomLeftX, y, bottomLeftX + xWidth, y );
        }
        g.setStroke(oldStroke);
        //3.draw horizontal axis   
        g.drawLine( bottomLeftX, bottomLeftY, 
                bottomLeftX + xWidth, bottomLeftY ); 
        //4.draw horizontal divisions
        int y1 = bottomLeftY + 2;
        int y2 = y1 - 4;
        for( int i = 0; i < 12; i++ )
        {
            int x =  divSizeX * ( i + 1 );
            g.drawLine( x, y1, x, y2 );
        }        
    }
    
    public void paint( Graphics g )
    {
        super.paint(g);
        g.setColor(getBackground());
        g.fillRect(0, 0, getWidth(), getHeight());
        g.setColor(getForeground());
        drawCoordinateSystem( (Graphics2D)g, 20, //int padLeft,
                                20, //int padBottom
                                20, //int divSizeY
                                20, //int numDivY
                                20 ); //int divSizeX
    }
    
    public void setBackground( java.awt.Color color )
    {
        super.setBackground(color);
    }     
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    
    private void afterInitComponent()
    {
        m_year = Calendar.getInstance().get( Calendar.YEAR );
    }
    
    public void onChangeYear( int year )
    {
        year = m_year;
        if( m_stockId == null )
            return;
        loadData();
        revalidate();
    }
    
    public void onChnageStock( String stockId )
    {        
        m_stockId = stockId;
        loadData();
        revalidate();
    }
    
    private void loadData()
    {
        Calendar calendar = Calendar.getInstance();
        SharedUtils.set2FirstDayFromYear(calendar);
        String begDate = SharedUtils.getDateStringFormatted(calendar);
        SharedUtils.set2LastDayFromYear(calendar);        
        String endDate = SharedUtils.getDateStringFormatted(calendar);
        
        String sql = "select vorgang.invc_date , position.totl_sum from vorgang,position " +
                " where vorgang.v_nr=position.v_nr and vorgang.invc_date>=" + begDate + 
                " and vorgang.inv_date<="  + endDate;
        Connection conn = SharedUtils.DBConnect(SharedUtils.connectionString);
        m_sales = new ArrayList();
        for( int i = 0; i < 12; i++ )
        {
            m_sales.add( new Double(0) );
        }
        try
        {        
            Statement stmt = conn.createStatement();
            ResultSet rs = stmt.executeQuery( sql );
            while(rs.next())
            {
                Timestamp tmsp = rs.getTimestamp(1);
                double sum = rs.getDouble(2);
                calendar.setTimeInMillis( tmsp.getTime() );
                int month = calendar.get( Calendar.MONTH );
                Double allSum = new Double( sum + ((Double)m_sales.get(month)).doubleValue() );
                m_sales.set(month, allSum);                
            }            
        }
        catch(Exception e)
        { 
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
        finally
        {
            if( conn != null )
            {
                try
                {
                    conn.close();                    
                }
                catch(Exception e){}
            }
        }
    }
}
