/*
 * SharedUtils.java
 *
 * Created on , 2005,  27, 14:01
 */

package medstore;

import java.awt.Color;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.sql.Types;
import java.util.Calendar;
import javax.swing.JComboBox;
import javax.swing.JTable;
import javax.swing.table.TableColumn;
import javax.swing.JOptionPane;
import java.util.*;
import java.text.*;
import java.io.*;
import java.math.BigDecimal;
import medstore.print.DateUtils;

/**
 *
 * @author JohnyEdu
 */
public class SharedUtils implements SharedConstants {
    
    public static final int PARSE_ONLY_TIME = 1;
    public static final int PARSE_ONLY_DATE = 2;
    public static final int PARSE_BOTH_TIMES = 3;
    private static Connection connPermamentDB = null;
    public static Color bgColor = new Color(219,209,183);
    public static Color bgLightColor = new Color(150,220,255);
    public static int nUserID = -1;
    public static String strUserAbrv = "";
    public static String strUsername=null;
    public static float porto = 4.5f;
    public static float discountSum  = -1f;
    public static int activeMacro = 1;
    ////////////////////////////////////////////////////////
    // Properties file settings
    ////////////////////////////////////////////////////////
    //database settings
    public static String dbUserName = "medstore";
    public static String dbPassword = "medstore";
    public static String databaseUrlPort = "1433";
    public static String databaseName = "medstore";
    public static String databaseUrl = "localhost";
    //printer settings
    public static int rowsPerPage = 26;
    ////////////////////////////////////////////////////////
    //Send Letter Settings                                //
    ////////////////////////////////////////////////////////
    public static int[] letterSendDays = { 1, 2, 3 };
    public static double[] letterPenalties = { 0 , 5, 10 };
    ////////////////////////////////////////////////////////
    public static DBSettings dbSettings;
    private static String sqlSelectLastInsertedId;
    
    /*******************************************************************************
     *                                                                             *
     *         Macro related functions
     *                                                                             *
     *******************************************************************************/
    
    // public static String strMacroClientName = "";
    // public static String strMacroDate = "";
    
    public static String subText1="",subText2="",subText3="",subText4="";
    private static String macroText1="",
            macroText2="von Doctor",
            macroText3="";
    
    public static void setSubTexts( String strMacroClientName, String strMacroDate, String strDoctorLastName ) {
        if(!strDoctorLastName.equals(""))
            strDoctorLastName = "&nbsp;von Doctor&nbsp;" + strDoctorLastName;
        SharedUtils.subText1 = "<br> Ihre Bestellung von " + strMacroDate + "&nbsp;" + SharedUtils.getMacro("macro1") + "<br>" +
                " Unsere Ums. St nr : NL-814305398" + "<br><br>" +
                " Wir Liefern abstract 150 EUR Netto Portofrei<br>";
    }
    
    public static String getMacro(String strMacroName) {
        String macro = "";
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
        String strSQL = " SELECT mcro_text " +
                " FROM base_mcro " +
                " WHERE mcro_name = '" + strMacroName + "' AND " +
                " user_idnt = " + SharedUtils.nUserID;
        try{
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            boolean bMore = rsDBData.next();
            if(bMore){
                macro = rsDBData.getString(1);
            } else {
                macro = "";
                if( strMacroName.equals("macro1") ) {
                    macro = generateMacro1();
                }
            }
            rsDBData.close();
            stm.close();
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
        return macro;
    }
    
    public static String generateMacro1(){
        return "\n\nIhre Bestellung von <DATE> <USER> von Doctor <DOCTOR>" +
                "\nUnsere Ums. St nr : NL-814305398" +
                "\n\nWir Liefern abstract 150 EUR Netto Portofrei\n\n";
    }
    
    public static void setActiveMacro(int macroNum) {
        String macro = "";
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
        String strSQL = " UPDATE base_user " +
                " SET active_macro='" + macroNum +  "'" +
                " WHERE user_key=" + nUserID;
        try{
            Statement stm = connDB.createStatement();
            stm.executeUpdate(strSQL);
            activeMacro = macroNum;
            stm.close();
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
    }
    
    public static void setMacro(String strMacroName, String strMacroText){
        String macro = "";
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
        String strSQL = " SELECT mcro_key " +
                " FROM base_mcro " +
                " WHERE mcro_name = '" + strMacroName + "' AND " +
                " user_idnt = " + SharedUtils.nUserID;
        if( SharedUtils.executeSqlScalar(strSQL) == null )
            strSQL = " insert base_mcro " +
                    " values( '" + strMacroName + "', '" + strMacroText +  "'" +
                    " ," + nUserID + ")";
        else
            strSQL = " UPDATE base_mcro " +
                    " SET mcro_text='" + strMacroText +  "'" +
                    " WHERE mcro_name = '" + strMacroName + "' AND user_idnt=" + nUserID;
        
        try{
            Statement stm = connDB.createStatement();
            stm.executeUpdate(strSQL);
            stm.close();
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
    }
    
    /*******************************************************************************
     *                                                                             *
     *         Database related functions
     *                                                                             *
     *******************************************************************************/
    static java.sql.Connection DBConnect(String strConnectionString) {
        Connection dbConn = null;
        try {
            if(connPermamentDB != null && !connPermamentDB.isClosed())
                return connPermamentDB;
            dbConn = dbSettings.getConnection();
        } catch(SQLException sqle) {
            sqle.printStackTrace();
            return null;
        }
        connPermamentDB = dbConn;
        return dbConn;
    }
    
    public static Connection getConnection() {
        return dbSettings.getConnection();
    }
    
    public static Connection DBConnect(String strConnectionString , boolean bPooled) {
        Connection dbConn = null;
        try {
            if((connPermamentDB != null) && bPooled && !connPermamentDB.isClosed())
                return connPermamentDB;
            dbConn = dbSettings.getConnection();
        } catch(Exception acce) {
        }
        connPermamentDB = dbConn;
        return dbConn;
    }
    
    public static java.sql.Connection connectOdbc() {
        Connection dbConn = null;
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver").newInstance();
            return DriverManager.getConnection( "jdbc:odbc:medstore_postgre", "postgres", "test");
            //return DriverManager.getConnection("jdbc:odbc:medstore_postgre");
        } catch(Exception sqle) {
            return null;
        }
    }
    
    public static java.sql.Connection DBConnectIsvita(String strConnectionString) {
        Connection dbConn = null;
        try {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver").newInstance();
            dbConn=DriverManager.getConnection(strConnectionString);
            //JOptionPane.showMessageDialog(null,String.valueOf(dbConn.getTransactionIsolation()));
        } catch(SQLException sqle) {
            return null;
        } catch(ClassNotFoundException cnfe) {
            JOptionPane.showMessageDialog(null,"The system cannot find it's database driver");
            return null;
        }
        
        catch(InstantiationException inste) {
            JOptionPane.showMessageDialog(null,"The system encountered a problem while loading one of it's components");
            return null;
        } catch(IllegalAccessException acce) {
            //JOptionPane.showMessageDialog(null,"The system encountered a problem while loading one of it's components");
            return null;
        }
        connPermamentDB = dbConn;
        return dbConn;
    }
    
    public static ResultSet executeSelect(Connection dbConn,String strSQL) {
        Statement stm = null;
        ResultSet rs = null;
        if(dbConn == null || strSQL == null)
            return null;
        try {
            stm = dbConn.createStatement();
        } catch(SQLException sqle) {
            //dbConn.close();
            return null;
        }
        try {
            rs=stm.executeQuery(strSQL);
            //stm.close();
        } catch(SQLException sqle) {
            stm=null;
            return null;
        }
        
        return rs;
    }
    
    public static String getLastInsertedID(Connection connDB){
        String strLastOrdrID = null;
        try{
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(sqlSelectLastInsertedId);
            boolean bMore = rsDBData.next();
            if(bMore){
                strLastOrdrID = rsDBData.getString(1);
            } else{
                JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
                return null;
            }
            rsDBData.close();
            stm.close();
        }catch(Exception e){
            JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
            return null;
        }
        return strLastOrdrID;
    }
    
    public static int recordExists(Connection connDB,String strSQL){
        try{
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            boolean bMore = rsDBData.next();
            rsDBData.close();
            stm.close();
            if(bMore){
                return DB_RECORD_EXISTS;
            } else{
                return DB_RECORD_DONTEXISTS;
            }
        }catch(Exception e){
            JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
            return DB_ERROR;
        }
        //return DB_RECORD_DONTEXISTS;
    }
    
    public static int populatePQuery(ResultSet rsDBDataOldSys, PreparedStatement pquery) {
        try {
            ResultSetMetaData resultsMetaData = rsDBDataOldSys.getMetaData();
            int nColumnCount = resultsMetaData.getColumnCount();
            boolean more = rsDBDataOldSys.next();
            while(more) {
                for(int i = 1; i < nColumnCount + 1; i++) {
                    String strColumnElement="";
                    int nColumnType = resultsMetaData.getColumnType(i);
                    if( nColumnType==Types.INTEGER){
                        pquery.setInt(i, rsDBDataOldSys.getInt(i));
                    } else if(nColumnType==Types.VARCHAR || nColumnType==Types.LONGVARCHAR){
                        strColumnElement = rsDBDataOldSys.getString(i);
                        pquery.setString(i, strColumnElement);
                    } else if(nColumnType==Types.DECIMAL){
                        pquery.setBigDecimal(i, rsDBDataOldSys.getBigDecimal(i));
                    } else if(nColumnType==Types.VARCHAR || nColumnType==Types.LONGVARCHAR){
                        strColumnElement = rsDBDataOldSys.getString(i);
                        pquery.setString(i, strColumnElement);
                    } else if(nColumnType==Types.DATE){
                        java.sql.Date dateSQL = rsDBDataOldSys.getDate(i);
                        pquery.setDate(i,dateSQL);
                    } else if(nColumnType==Types.TIME){
                        java.sql.Time timeSQL = rsDBDataOldSys.getTime(i);
                        pquery.setTime(i,timeSQL);
                    } else if(nColumnType==Types.TIMESTAMP){
                        java.sql.Timestamp tmsp = rsDBDataOldSys.getTimestamp(i);
                        pquery.setTimestamp(i, tmsp);
                    } else if(nColumnType==Types.VARBINARY){
                        pquery.setBlob(i, rsDBDataOldSys.getBlob(i));
                    } else{
                        strColumnElement = rsDBDataOldSys.getString(i);
                        pquery.setString(i, strColumnElement);
                    }
                }
                more = rsDBDataOldSys.next();
            }
            return NO_ERROR;
        } catch(SQLException sqle) {
            SharedUtils.handleError(GENERAL_DB_ERROR);
            return GENERAL_DB_ERROR;
        }
    }
    
    /*******************************************************************************
     *                                                                              *
     *         Date - Time functions
     *                                                                              *
     *******************************************************************************/
    
    public static String getCurrentTimeString(){
        Calendar calendar = Calendar.getInstance();
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
        
        String strHour = String.valueOf(hour);
        if(hour < 10 )
            strHour = "0" + strHour;
        String strMinute = String.valueOf(minute);
        if(minute < 10 )
            strMinute = "0" + strMinute;
        String strSecond = String.valueOf(second);
        if(second < 10 )
            strSecond = "0" + strSecond;
        return  strHour + ":" + strMinute + ":" + strSecond;
    }
    
    public static String getCurrentDateStringFormatted() {
        Calendar calendar = Calendar.getInstance();
        return getDateStringFormatted( calendar );
    }
    
    public static String getDateStringFormatted( Calendar calendar ) {
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month);
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day);
        if(day < 10 )
            strDay = "0" + strDay;
        
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
        
        String strHour = String.valueOf(hour);
        if(hour < 10 )
            strHour = "0" + strHour;
        String strMinute = String.valueOf(minute);
        if(minute < 10 )
            strMinute = "0" + strMinute;
        String strSecond = String.valueOf(second);
        if(second < 10 )
            strSecond = "0" + strSecond;
        return  String.valueOf(year)  + "." + strMonth  + "." + strDay +
                " " +  strHour + ":" + strMinute + ":" + strSecond;
    }
    
    public static void set2FirstDayFromYear( Calendar calendar ) {
        calendar.set( Calendar.MONTH, Calendar.JANUARY );
        calendar.set( Calendar.DATE, 1 );
        calendar.set( Calendar.HOUR, 0 );
        calendar.set( Calendar.MINUTE, 0 );
        calendar.set( Calendar.SECOND, 0 );
    }
    
    public static void set2LastDayFromYear( Calendar calendar ) {
        calendar.set( Calendar.MONTH, Calendar.DECEMBER );
        calendar.set( Calendar.DATE, 31 );
        calendar.set( Calendar.HOUR, 23 );
        calendar.set( Calendar.MINUTE, 59 );
        calendar.set( Calendar.SECOND, 59 );
    }
    
    public static void set2EndOfTheDay( Calendar calendar ) {
        calendar.set( Calendar.HOUR_OF_DAY, 23 );
        calendar.set( Calendar.MINUTE, 59 );
        calendar.set( Calendar.SECOND, 59 );
    }
    
    public static void set2BeginOfTheDay( Calendar calendar ) {
        calendar.set( Calendar.HOUR_OF_DAY, 0 );
        calendar.set( Calendar.MINUTE, 0 );
        calendar.set( Calendar.SECOND, 0 );
        calendar.set( Calendar.MILLISECOND, 0 );
    }
    
    public static String getCurrentOnlyDateStringFormatted() {
        Calendar calendar = Calendar.getInstance();
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month);
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day);
        if(day < 10 )
            strDay = "0" + strDay;
        String strYear = String.valueOf(year).substring(2);
        return strDay + "." + strMonth + "." + strYear;
    }
    public static String getCurrentOnlyDateSQLFormat() {
        Calendar calendar = Calendar.getInstance();
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month);
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day);
        if(day < 10 )
            strDay = "0" + strDay;
        String strYear = String.valueOf(year).substring(2);
        return  strMonth + "." + strDay + "." + strYear;
    }
    
    public static String getCurrentDateUnixTimestamp() {
        Calendar calendar = Calendar.getInstance();
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month);
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day);
        if(day < 10 )
            strDay = "0" + strDay;
        
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
        
        String strHour = String.valueOf(hour);
        if(hour < 10 )
            strHour = "0" + strHour;
        String strMinute = String.valueOf(minute);
        if(minute < 10 )
            strMinute = "0" + strMinute;
        String strSecond = String.valueOf(second);
        if(second < 10 )
            strSecond = "0" + strSecond;
        return  String.valueOf(year)   + strMonth  + strDay +
                strHour +  strMinute +  strSecond;
    }
    public static java.sql.Date getCurrentDateSQL() {
        Calendar calendar = Calendar.getInstance();
        return new java.sql.Date(calendar.getTimeInMillis());
    }
    public static java.sql.Timestamp getCurrentTimestamp() {
        Calendar calendar = Calendar.getInstance();
        /*
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
         */
        return new java.sql.Timestamp(calendar.getTimeInMillis());
    }
    public static String getStringFromTimestamp(Timestamp tmsp,int nMode){
        long millis = tmsp.getTime();
        return getDateFromMillis( millis, nMode );
    }
    
    public static String getDateFromMillis(long millis,int nMode){
        
        Calendar calendar = Calendar.getInstance();
        calendar.setTimeInMillis(millis);
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month);
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day);
        if(day < 10 )
            strDay = "0" + strDay;
        
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
        
        String strHour = String.valueOf(hour);
        if(hour < 10 )
            strHour = "0" + strHour;
        String strMinute = String.valueOf(minute);
        if(minute < 10 )
            strMinute = "0" + strMinute;
        String strSecond = String.valueOf(second);
        if(second < 10 )
            strSecond = "0" + strSecond;
        if(nMode == PARSE_BOTH_TIMES)
            return  String.valueOf(year)  + "." + strMonth  + "." + strDay +
                    " " +  strHour + ":" + strMinute + ":" + strSecond;
        else if(nMode == PARSE_ONLY_TIME)
            return strHour + ":" + strMinute + ":" + strSecond;
        else if(nMode == PARSE_ONLY_DATE){
            String strYear = String.valueOf(year);
            strYear = strYear.substring(2);
            return  strDay + "." + strMonth + "." + strYear ;
        }
        return "";
    }
    
    public static String[] parseDateString(String strInput){
        strInput = strInput.replace('-', '.');
        String dateFields[] = strInput.split("\\.");
        int dfCount = dateFields.length;
        for(int i = 0; i < dfCount; i++){
            //if(dateFields[i].length()>2)
            //dateFields[i] = dateFields[i].substring(0, 1);
            if(dateFields[i].length()<2)
                dateFields[i]="0" + dateFields[i];
            if(i==2){
                if(dateFields[2].length()==4)
                    dateFields[2] = dateFields[2].substring(2);
            }
        }
        
        String strCurrentDate = SharedUtils.getCurrentOnlyDateStringFormatted();
        String currDateFields[] = strCurrentDate.split("\\.");
        int cdfCount = currDateFields.length;
        String strFormattedDate="";
        for(int i = 0; i < cdfCount; i++){
            if(i < dfCount)
                currDateFields[i] = dateFields[i];
        }
        return currDateFields;
    }
    
    
    
    /*******************************************************************************
     *                                                                              *
     *         GUI functions
     *                                                                              *
     *******************************************************************************/
    
    public static void setTableColumnsWidth(JTable table,int[] widths){
        int columns = widths.length;
        for(int i=0;i<columns;i++){
            TableColumn col = table.getColumnModel().getColumn(i);
            col.setPreferredWidth(widths[i]);
        }
        table.updateUI();
    }
    
    public static UniversalTableModel setTableDBModel(JTable table, String strSQL, String[] strrgnColumnNames) {
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        ResultSet rsDBData=null;
        Statement stm=null;
        if(strSQL!=null){
            try{
                stm = connDB.createStatement();
                rsDBData=stm.executeQuery(strSQL);
            }catch(SQLException sqle){
                SharedUtils.handleError(GENERAL_DB_ERROR);
            }
        }
        UniversalTableModel tbmOrders = new UniversalTableModel(rsDBData,strrgnColumnNames);
        table.setModel(tbmOrders);
        table.updateUI();
        if(rsDBData!=null){
            try{
                rsDBData.close();
                stm.close();
            }catch(SQLException sqle){
                SharedUtils.handleError(GENERAL_DB_ERROR);
                sqle.printStackTrace();
            }
        }
        return tbmOrders;
    }
   /*
    public static void sortTableBySingleColumn(JTable table, int nColIndex, int elIndex, boolean ascending){
        TableModel model = table.getModel();
        Vector data = ((UniversalTableModel)model).getDataVector();
        Collections.sort(data, new TableSingleColumnSorter(nColIndex,elIndex,ascending));
        table.updateUI();
    
    }
    */
    public static String getUniTableValue(JTable table, int nRow, int nCol){
        return (String)((UniversalTableRow)((UniversalTableModel)table.getModel()).getRowObject(nRow)).getRowElement(nCol);
    }
    
    public static void setComboIndexByContent(JComboBox combo, String content){
        for(int index=0;index<combo.getItemCount();index++) {
            if(((String)combo.getItemAt(index)).equals(content)) {
                combo.setSelectedIndex(index);
                break;
            }
        }
    }
    /*******************************************************************************
     *                                                                             *
     *         Error functions
     *                                                                             *
     *******************************************************************************/
    
    public static void handleError(int nErrorCode){
        switch(nErrorCode){
            
            case UNKNOWN_BARCODE:                     JOptionPane.showMessageDialog(null,"The Barcode, you are trying to use is not registered in the system!");
            break;
            
            case INVALID_BALANCE:                     JOptionPane.showMessageDialog(null,"You cant' move out more stocks that you have on hand!");
            break;
            
            case STOCK_COUNT_IN_STOR_INSERT_ERROR:    JOptionPane.showMessageDialog(null,"Database error - please restart!");
            break;
            
            case STOCK_COUNT_IN_STOR_UPDATE_ERROR:    JOptionPane.showMessageDialog(null,"Database error - please restart!");
            break;
            
            case STOCK_COUNT_IN_STOR_DELETE_ERROR:    JOptionPane.showMessageDialog(null,"Database error - please restart!");
            break;
            
            case INVALID_OPCODE:                      JOptionPane.showMessageDialog(null,"You are trying to execute invalida operation!");
            break;
            
            case INSERT_EVENT_ERROR:                  JOptionPane.showMessageDialog(null,"Database error - please restart!");
            break;
            
            case STOCK_COUNT_IN_EVENT_INSERT_ERROR:   JOptionPane.showMessageDialog(null,"Database error - please restart!");
            break;
            
            case EVENT_FOR_STORNO_NOT_FOUND :         JOptionPane.showMessageDialog(null,"There is no information for this event to storno!");
            break;
            
            case STORNO_UPDATE_EVENT_TABLE_ERROR :    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
            break;
            
            case INSERT_TRANSACTION_EVENT_ERROR :     JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
            break;
            
            case INSERT_EVENTS_IN_TRAN_ERROR :        JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
            break;
            
            case NO_EVENTS_FOR_TRAN_FOUND :           JOptionPane.showMessageDialog(null,"No events associated with this operation are found!");
            break;
            
            case UNPACK_AGAINST_ATOMIC_STOCK_ERROR : JOptionPane.showMessageDialog(null,"You cannot use unpack operation against atomic stock!");
            break;
            
            case GENERAL_DB_ERROR :                   JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
            break;
            
            case INTERNAL_SYSTEM_ERROR :              JOptionPane.showMessageDialog(null,"There is an internal system error!Please restart this application and try again.");
            break;
            
            default:                                  JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
            break;
        }
    }
    
    
    /*******************************************************************************
     *                                                                             *
     *         Calculating Barcode value functions
     *                                                                             *
     *******************************************************************************/
    
    public static String generateBarcodeString(String strBarcode){
        
        int len = strBarcode.length();
        char barcode[] = new char[len + 3];
        int checksum = 104;
        barcode[0] = '|';
        for( int i = 0; i <  len; i++){
            char ch = strBarcode.charAt(i);
            barcode[i + 1] = ch;
            checksum = checksum + (i+1)*getCharBarcodeValue(strBarcode.charAt(i));
        }
        checksum = (checksum%103);
        barcode[len + 1] = (char)getValueBarcodeChar((char)checksum);
        barcode[len + 2] = '~';
        String barcodeString = new String(barcode);
        
        return barcodeString;
    }
    
    public static int getCharBarcodeValue(char ch){
        
        int value = -1;
        for( int i = 0; i < SharedUtils.codes.length; i++) {
            if( SharedUtils.codes[i][0] == ch)
                value = SharedUtils.codes[i][1];
        }
        if(value == -1 ){
            JOptionPane.showMessageDialog(null,"cannot find barcode value");
        }
        
        return value;
    }
    
    public static char getValueBarcodeChar(int val){
        
        char value = (char)-1;
        for( int i = 0; i < SharedUtils.codes.length; i++) {
            if( SharedUtils.codes[i][1] == val){
                value = (char)SharedUtils.codes[i][0];                
            }
        }
        if(value == -1 ){
            JOptionPane.showMessageDialog(null,"cannot find barcode value");
        }
        return value;
    }
    
    public static void loadSettings() {
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
        String strSQL = "SELECT porto,discountsum,letter1days,letter2days,letter3days," +
                " letter1penalty,letter2penalty,letter3penalty" +
                " FROM settings";
        try {
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            if(rsDBData.next()) {
                String str = rsDBData.getString(1);
                if( str != null )
                    porto = Float.parseFloat(str);
                //float p = rsDBData.getFloat("porto");
                //if( !rsDBData.wasNull() )
                //    porto = p;
                str = rsDBData.getString(1);
                if( str != null )
                    porto = Float.parseFloat(str);
                
                str = rsDBData.getString(2);
                if( str != null )
                    discountSum = Float.parseFloat(str);
                
                str = rsDBData.getString(3);
                if( str != null )
                    letterSendDays[0] = Integer.parseInt(str);
                
                str = rsDBData.getString(4);
                if( str != null )
                    letterSendDays[1] = Integer.parseInt(str);
                
                str = rsDBData.getString(5);
                if( str != null )
                    letterSendDays[2] = Integer.parseInt(str);
                
                str = rsDBData.getString(6);
                if( str != null )
                    letterPenalties[0] = Float.parseFloat(str);
                
                str = rsDBData.getString(7);
                if( str != null )
                    letterPenalties[1] = Float.parseFloat(str);
                
                str = rsDBData.getString(8);
                if( str != null )
                    letterPenalties[2] = Float.parseFloat(str);
            }
            rsDBData.close();
            stm.close();
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
    }
    
    
    public static String incDate(String date,int days) {
        StringTokenizer tok = new StringTokenizer(date,".");
        int day =  Integer.parseInt( tok.nextToken() );
        int month =  Integer.parseInt( tok.nextToken() ) - 1;
        int year =  Integer.parseInt( "20" + tok.nextToken() );
        Calendar cal = Calendar.getInstance();
        cal.set( Calendar.YEAR, year );
        cal.set( Calendar.MONTH, month);
        cal.set( Calendar.DATE, day );
        
        cal.add( Calendar.DATE, days );
        
        date = cal.get( Calendar.DATE ) + "." +
                cal.get( Calendar.MONTH ) + "." +
                cal.get( Calendar.YEAR );
        String parsedDate[] = parseDateString(date);
        return DateUtils.ddmmyyy(cal.getTime());//parsedDate[0] + "." + parsedDate[1] + "." + parsedDate[2];
    }
    
    public static String separateDate( String strDateTime ) {
        StringTokenizer tok = new StringTokenizer(strDateTime,".");
        String year =  tok.nextToken().substring(2);
        String month =  tok.nextToken();
        String day =  tok.nextToken().substring( 0, 2);
        return day + "." + month + "." + year;
    }
    
    public static String formatFloat( String strNum, char decimalSeparator  ) {
        try {
            DecimalFormat floatFormater = new DecimalFormat("#0.00");
            
            DecimalFormatSymbols dfs = floatFormater.getDecimalFormatSymbols();
            dfs.setDecimalSeparator(decimalSeparator);
            floatFormater.setDecimalFormatSymbols(dfs);
            
            double num = Double.parseDouble(strNum);
            strNum = floatFormater.format( num );
        } catch(Exception e) {
        }
        return strNum;
    }
    
    public static String executeSqlScalar( String sql ) {
        try {
            Connection conn = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            if(rs.next())
                return rs.getString(1);
        } catch(Exception e) {
            SharedUtils.handleError(GENERAL_DB_ERROR);
            e.printStackTrace();
        }
        return null;
    }
    
    public static ArrayList executeSqlScalarList( String sql ) {
        ArrayList list = new ArrayList();
        try {
            Connection conn = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            ResultSetMetaData resultsMetaData = rs.getMetaData();
            int nColumnCount = resultsMetaData.getColumnCount();
            
            if( rs.next() ) {
                for(int i = 1; i < nColumnCount + 1; i++) {
                    if(resultsMetaData.getColumnTypeName(i).equals("smallmoney")){
                        BigDecimal bdm = rs.getBigDecimal(i);
                        bdm = bdm.setScale(2, BigDecimal.ROUND_HALF_UP);
                        list.add( bdm.toString() );
                        continue;
                    }
                    else{
                        list.add( rs.getString(i) );
                    }
                }
            }
        } catch(Exception e) {
            SharedUtils.handleError(GENERAL_DB_ERROR);
            e.printStackTrace();
        }
        return list;
    }
    
    
    
    public static void loadProperties() {
        String userHomePath = (String)System.getProperty("user.home");
        String pathSeparator = (String)System.getProperty("file.separator");
        String fullName = userHomePath + pathSeparator + "medstore.properties";
        try {
            File f = new File( fullName );
            if( f.exists() ) {
                FileInputStream istream = new FileInputStream( f );
                Properties props = new Properties();
                props.load(istream);
                istream.close();
                
                //username = props.getProperty("username");
                //password = props.getProperty("password");
                databaseName = props.getProperty("databaseName");
                databaseUrl = props.getProperty("databaseUrl");
                databaseUrlPort = props.getProperty("databaseUrlPort");
                String dbType = props.getProperty( "databaseType" );
                if( dbType == null || dbType.toUpperCase().equals( "MSSQL" ) ) {
                    dbSettings = new DBSettingsMSSQL();
                    sqlSelectLastInsertedId = "SELECT SCOPE_IDENTITY() AS LAST_IDNT";
                } else {
                    dbSettings = new DBSettingsPostgre();
                    sqlSelectLastInsertedId = "select lastval()";
                }
                
                try {
                    int i = Integer.parseInt( props.getProperty("rowsperpage") );
                    if( i > 0 )
                        rowsPerPage = i;
                } catch(Exception e) {
                    props.put("rowsperpage",""+rowsPerPage);
                    createPropertiesFile(props,f);
                }
            } else {
                createPropertiesFile(null,f);
            }
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    
    private static void createPropertiesFile(Properties props, File f)
    throws Exception {
        FileOutputStream ostream = new FileOutputStream( f );
        if( props == null ) {
            props = new Properties();
            //props.setProperty("username" , username );
            //props.setProperty("password" , password );
            props.setProperty("databaseName" , databaseName );
            props.setProperty("rowsperpage" , "" + rowsPerPage );
            props.setProperty("databaseUrl" , databaseUrl );
            props.setProperty("databaseUrlPort" , databaseUrlPort );
        }
        props.store(ostream,"");
        ostream.close();
    }
    
    /**
     *         
     *   
     */
    
    public static String getToDate( String strTextDateTo ) {
        String[] dateFields = strTextDateTo.split("\\.");
        int nToDay = Integer.parseInt(dateFields[0]);
        int nToMonth = Integer.parseInt(dateFields[1]);
        int nToYear = Integer.parseInt(dateFields[2]);
        Calendar calendar = Calendar.getInstance();
        calendar.set(Calendar.MONTH, nToMonth-1);
        
        int nMax = calendar.getActualMaximum(Calendar.DAY_OF_MONTH);
        if(nToDay < nMax)
            nToDay++;
        else {
            nToDay = 1;
            nToMonth++;
            if( nToMonth > calendar.getActualMaximum(Calendar.MONTH) + 1 ) {
                nToMonth = 1;
                nToYear++;
            }
        }
        strTextDateTo = nToMonth + "." + nToDay + "." + nToYear;
        return strTextDateTo;
    }
    ///////
    public static double round(double d, int scale) {
        double  d1 = Math.pow( 10, scale);
        return (double)Math.round( d * d1 ) / d1;
    }
    ///
    public static float readFloat( ResultSet rs, int columnIndex, int scale )
    throws SQLException {
        float f = rs.getFloat(columnIndex);
        if( rs.wasNull() )
            return 0;
        return (float)round(f, scale);
    }
    ///
    public static String readStringTrimmed( ResultSet rs, int columnIndex )
    throws SQLException {
        String str = rs.getString(columnIndex);
        if( str != null )
            str = str.trim();
        return str;
    }
    //
    public static void closeConnection(Connection conn) {
        if( conn == null )
            return;
        try {
            conn.close();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    public static void rollback(Connection conn) {
        if( conn == null )
            return;
        try {
            conn.rollback();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
    ///
    public static int compareDates( String date1, String date2 ) {
        String d1[] = date1.split("\\.");
        String d2[] = date2.split("\\.");
        int dif = Integer.parseInt(d1[2]) - Integer.parseInt(d2[2]);
        if( dif != 0 )
            return dif;
        dif = Integer.parseInt(d1[1]) - Integer.parseInt(d2[1]);
        if( dif != 0 )
            return dif;
        dif = Integer.parseInt(d1[0]) - Integer.parseInt(d2[0]);
        return dif;
    }
    
    public static void handleException( Throwable e, String defaultMessage ) {
        if( ((Object)e) instanceof MedstoreException )
            defaultMessage = e.getMessage();
        JOptionPane.showMessageDialog(null,defaultMessage);
    }
}
