package medstore;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelListener;
import java.awt.event.*;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumnModel;

public class StockManager extends CommonDialog implements ListSelectionListener,TableModelListener{
    
    //public static JTable tblAllStocks;
    public static final int STOCK_NAME_INDEX = 0;
    public static final int STOCK_ABBR_INDEX = 1;
    public static final int STOCK_GROUP_INDEX = 2;
    public static final int STOCK_BARCODE_INDEX = 3;
    public static final int STOCK_CNTN_BARCODE_INDEX = 4;
    public static final int STOCK_PCOUNT_INDEX = 5;
    public static final int STOCK_LIMIT_INDEX = 6;
    public static final int STOCK_MPRICE_INDEX = 7;
    public static final int STOCK_SPRICE_INDEX = 8;
    public static final int STOCK_KEY_INDEX = 9;
    
    public StockManager(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        afterInitComponents();
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        labelAllStocks = new javax.swing.JLabel();
        scrAllStocks = new javax.swing.JScrollPane();
        tblAllStocks = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        btnAddStock = new javax.swing.JButton();
        btnEditStock = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Stock Nomenclature, Operator ");
        labelAllStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        labelAllStocks.setText("All Stocks");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(labelAllStocks, gridBagConstraints);

        scrAllStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        tblAllStocks.setFont(new java.awt.Font("Tahoma", 0, 13));
        tblAllStocks.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblAllStocks.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblAllStocksMouseClicked(evt);
            }
        });

        scrAllStocks.setViewportView(tblAllStocks);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 10);
        getContentPane().add(scrAllStocks, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        btnAddStock.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnAddStock.setText("Add");
        btnAddStock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StockManager.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel1.add(btnAddStock, gridBagConstraints);

        btnEditStock.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnEditStock.setText("Edit");
        btnEditStock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StockManager.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel1.add(btnEditStock, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jPanel1, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-931)/2, (screenSize.height-353)/2, 931, 353);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void tblAllStocksMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblAllStocksMouseClicked
        if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
            editStock();
        }
    }//GEN-LAST:event_tblAllStocksMouseClicked
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource() == btnAddStock) {
            AddStockDialog dlgAddStock = new AddStockDialog(null,new JFrame(),true,-1);
            dlgAddStock.show();
        } else if(evt.getSource() == btnEditStock) {
            editStock();
        }
    }//GEN-LAST:event_actionPerformed
    
    private void editStock() {
        int nStockTableSelRow = tblAllStocks.getSelectedRow();
        if(nStockTableSelRow < 0) {
            JOptionPane.showMessageDialog(null,"Please select stock from the table above!");
            return;
        }
        UniversalTableRow trowSelected = ((UniversalTableModel)tblAllStocks.getModel()).getRowObject(nStockTableSelRow);
        String strStockId = (String)trowSelected.vecRowElements.get(STOCK_KEY_INDEX);
        AddStockDialog dlgAddStock = new AddStockDialog(strStockId,new JFrame(),true,nStockTableSelRow);
        dlgAddStock.show();
    }
    
    public void afterInitComponents() {
        btnEditStock.setEnabled(false);
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        String strSQL = "SELECT STCK_NAME,STCK_ABRV,STOCKGROUP,STCK_BRCD,CNTN_BCOD,STCK_PCNT,STCK_LIMT,PRIC_MID,PRIC_SELL,STCK_KEY FROM BASE_STCK ORDER BY STCK_NAME";
        ResultSet rsAllStocks = SharedUtils.executeSelect(connDB, strSQL);
        String[] str_rgn_ColumnNames = {"Name","ABBREV.","Group","Barcode","Content Barcode","Count In Packet","Stock Limit","MIDDLE PRICE","SELL PRICE"};
        UniversalTableModel tbmAllStocks = new UniversalTableModel(rsAllStocks,str_rgn_ColumnNames);
        tblAllStocks = new javax.swing.JTable(tbmAllStocks);
        tblAllStocks.getTableHeader().setReorderingAllowed(false);
        tblAllStocks.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tblAllStocks.getSelectionModel().addListSelectionListener(this);
        scrAllStocks.setViewportView(tblAllStocks);
        
        enableExit( tblAllStocks  );
        UIUtils.setTableFonts(tblAllStocks);
        
        UIUtils.setColumnWidth( tblAllStocks, 0, 255 );
        UIUtils.setColumnWidth( tblAllStocks, STOCK_GROUP_INDEX, 50 );
        UIUtils.setColumnWidth( tblAllStocks, STOCK_CNTN_BARCODE_INDEX, 120 );//Content Barcode
        UIUtils.setColumnWidth( tblAllStocks, STOCK_PCOUNT_INDEX, 120 );//Count In Packet
        UIUtils.setColumnWidth( tblAllStocks, STOCK_MPRICE_INDEX, 100 );//MIDDLE PRICE
        
        tblAllStocks.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblAllStocksMouseClicked(evt);
            }
        });
        tblAllStocks.getTableHeader().addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent e) {
                JTableHeader h = (JTableHeader)e.getSource();
                TableColumnModel columnModel = h.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX());
                int column = columnModel.getColumn(viewColumn).getModelIndex();
                ((UniversalTableModel)h.getTable().getModel()).sortColumn(column);
                h.getTable().updateUI();
                
            }
        });
        tblAllStocks.setAutoCreateColumnsFromModel(false);
    }
    public void valueChanged(ListSelectionEvent e) {
        if(e.getSource()==tblAllStocks.getSelectionModel()) {
            if(tblAllStocks.getSelectedRow()>=0){
                btnEditStock.setEnabled(true);
            } else{
                btnEditStock.setEnabled(false);
            }
        }
    }
    public void tableChanged(javax.swing.event.TableModelEvent e) {
        
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddStock;
    private javax.swing.JButton btnEditStock;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel labelAllStocks;
    private javax.swing.JScrollPane scrAllStocks;
    public static javax.swing.JTable tblAllStocks;
    // End of variables declaration//GEN-END:variables
    
}
