/*
 * OrdersInOut.java
 *
 * Created on , 2005,  28, 23:21
 */

package medstore;

import java.awt.event.InputEvent;
import java.sql.Connection;
import java.sql.ResultSet;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.table.JTableHeader;
import javax.swing.table.TableColumnModel;
import medstore.procedures.*;

/**
 *
 * @author  JohnyEdu
 */
public class StockOnHand extends javax.swing.JFrame implements SharedConstants{
    private JTable tblStoreStocks;
    private int nStoreId;
    private String strSQL;
    private String[] strrgnColumnNames = {"Stock Name","Barcode","Stock Count"};
    private final int STOCK_BARCODE_INDEX = 1;
    private final int STOCK_STORECONT_INDEX = 2;
    private final int STOCK_ID_INDEX = 3;
    private final int STOCK_PCNT_INDEX = 4;
    private final int STOCK_CNTNBCOD_INDEX = 5;
    private final int STORE_IDNT_INDEX = 6;
    public StockOnHand() {
        this(0);
    }
    public StockOnHand(int nStoreId){
        this.nStoreId = nStoreId;
        strSQL = "SELECT STCK_NAME,STCK_BRCD,CONN_STCK_IN_STOR.STCK_CNT, STCK_KEY,STCK_PCNT,CNTN_BCOD,STOR_IDNT " +
                " FROM BASE_STCK INNER JOIN CONN_STCK_IN_STOR ON (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT)" +
                "WHERE " +
                //"   BASE_STCK.composite = 1  " +
                "   base_stck.pric_sell > 0 " +
                //" AND CONN_STCK_IN_STOR.STCK_CNT > 0 " +
                "   AND STOR_IDNT = ";
        
        initComponents();
        afterInitComponents();
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        btngOperations = new javax.swing.ButtonGroup();
        jpmUnpack = new javax.swing.JPopupMenu();
        mitemUnpack = new javax.swing.JMenuItem();
        comboStore = new javax.swing.JComboBox();
        scrAllStocks = new javax.swing.JScrollPane();
        lblStore = new javax.swing.JLabel();
        lblStocks = new javax.swing.JLabel();
        buttonRefresh = new javax.swing.JButton();

        mitemUnpack.setText("Unpack");
        mitemUnpack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StockOnHand.this.actionPerformed(evt);
            }
        });

        jpmUnpack.add(mitemUnpack);

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Stocks on hand");
        comboStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboStore.setMinimumSize(new java.awt.Dimension(250, 22));
        comboStore.setPreferredSize(new java.awt.Dimension(250, 22));
        comboStore.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                valueChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 100);
        getContentPane().add(comboStore, gridBagConstraints);

        scrAllStocks.setFont(new java.awt.Font("Tahoma", 1, 13));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 10);
        getContentPane().add(scrAllStocks, gridBagConstraints);

        lblStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStore.setText("Store");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 36;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(lblStore, gridBagConstraints);

        lblStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblStocks.setText("Stocks available in selected store");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.ipadx = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(8, 10, 0, 0);
        getContentPane().add(lblStocks, gridBagConstraints);

        buttonRefresh.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonRefresh.setText("Refresh");
        buttonRefresh.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StockOnHand.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 10, 0);
        getContentPane().add(buttonRefresh, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-454)/2, (screenSize.height-259)/2, 454, 259);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource()==buttonRefresh){
            nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
            String strTableSQL = strSQL + String.valueOf(nStoreId);
            SharedUtils.setTableDBModel(tblStoreStocks,strTableSQL,strrgnColumnNames);
            try{
                ((UniversalTableModel)tblStoreStocks.getModel()).sortColumn(2);
                tblStoreStocks.updateUI();
            } catch(Exception e){
                
            }
        } else if(evt.getSource() == mitemUnpack) {
            int nRow = tblStoreStocks.getSelectedRow();
            String strPackBarcode = (String)((UniversalTableRow)((UniversalTableModel)tblStoreStocks.getModel()).getRowObject(nRow)).getRowElement(STOCK_BARCODE_INDEX);
            String strStockCountInPacket = (String)((UniversalTableRow)((UniversalTableModel)tblStoreStocks.getModel()).getRowObject(nRow)).getRowElement(STOCK_PCNT_INDEX);
            String strPackCount = (String)((UniversalTableRow)((UniversalTableModel)tblStoreStocks.getModel()).getRowObject(nRow)).getRowElement(STOCK_STORECONT_INDEX);
            nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
            int nStockCount = 1;
            executePackTranStoreOperation(OPCODE_PACK,nStockCount,strPackBarcode,nStoreId,nStoreId,
                    SharedUtils.getCurrentDateStringFormatted() , SharedUtils.nUserID, null, 1);
            nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
            String strTableSQL = strSQL + String.valueOf(nStoreId);
            SharedUtils.setTableDBModel(tblStoreStocks,strTableSQL,strrgnColumnNames);
        }
    }//GEN-LAST:event_actionPerformed
    
    private void valueChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_valueChanged
        if(evt.getSource() == comboStore){
            if(evt.getItem() == comboStore.getSelectedItem()){
                nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
                String strTableSQL = strSQL + String.valueOf(nStoreId);
                SharedUtils.setTableDBModel(tblStoreStocks,strTableSQL,strrgnColumnNames);
            }
            
        }
        
    }//GEN-LAST:event_valueChanged
    
    private void afterInitComponents() {
        
        //connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        String strSQL = "SELECT STOR_NAME,STOR_KEY FROM BASE_STOR ORDER BY STOR_NAME";
        ResultSet rsDBData = SharedUtils.executeSelect(connDB, strSQL);
        ComboDataModel cdbStores = new ComboDataModel(rsDBData);
        if(nStoreId>0){
            cdbStores.selectIndexByKey(nStoreId);
        }
        comboStore.setModel(cdbStores);
        nStoreId = ((ComboDataModel)comboStore.getModel()).getCObjectAt(comboStore.getSelectedIndex()).nItemDBKey;
        String strTableSQL = this.strSQL + String.valueOf(nStoreId);
        connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        rsDBData = SharedUtils.executeSelect(connDB, strTableSQL);
        UniversalTableModel tbmAllStocks = new UniversalTableModel(rsDBData,strrgnColumnNames);
        tblStoreStocks = new javax.swing.JTable(tbmAllStocks);
        tblStoreStocks.getTableHeader().setReorderingAllowed(false);
        tblStoreStocks.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        scrAllStocks.setViewportView(tblStoreStocks);
        tblStoreStocks.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });
        tblStoreStocks.getTableHeader().addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent e) {
                JTableHeader h = (JTableHeader)e.getSource();
                TableColumnModel columnModel = h.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX());
                int column = columnModel.getColumn(viewColumn).getModelIndex();
                ((UniversalTableModel)h.getTable().getModel()).sortColumn(column);
                h.getTable().updateUI();
                
            }
        });
        tblStoreStocks.setAutoCreateColumnsFromModel(false);
        try{
            ((UniversalTableModel)tblStoreStocks.getModel()).sortColumn(2);
            tblStoreStocks.updateUI();
        } catch(Exception e){
            
        }
        UIUtils.setTableFonts(tblStoreStocks);
        
    }
    private void tblActionsMouseClicked(java.awt.event.MouseEvent evt) {
        
        if ((evt.getModifiers() & InputEvent.BUTTON3_MASK) != 0) {
            int nRow = tblStoreStocks.rowAtPoint(evt.getPoint());
            String strStockCount = (String)((UniversalTableRow)((UniversalTableModel)tblStoreStocks.getModel()).getRowObject(nRow)).getRowElement(STOCK_PCNT_INDEX);
            if(Integer.parseInt(strStockCount)>1){
                tblStoreStocks.getSelectionModel().setSelectionInterval( nRow,nRow ) ;
                jpmUnpack.show(evt.getComponent(),evt.getX(),evt.getY());
            }
        }
        
    }
    private void executePackTranStoreOperation(String strOperationCode,int nStockCount,String strBarcode,int nStoreIdSrc, int nStoreIdDst,String date, int nUserID, String strTranDesc, int nEventTranSeq) {
        Connection conn = null;
        try{
            conn = SharedUtils.getConnection();
            conn.setAutoCommit(false);
            ProcedurePackTranStore proc = new ProcedurePackTranStore();
            proc.execPackStoreOperation(conn, strOperationCode, nStockCount, strBarcode,
                    "" + nStoreIdSrc, "" + nStoreIdDst, date, "" + nUserID, strTranDesc, nEventTranSeq );
            conn.commit();
        } catch(Throwable e) {
            SharedUtils.handleException( e, "Operation can not be completed!" );
            SharedUtils.rollback(conn);
            return;
        } finally {
            SharedUtils.closeConnection(conn);
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.ButtonGroup btngOperations;
    private javax.swing.JButton buttonRefresh;
    private javax.swing.JComboBox comboStore;
    private javax.swing.JPopupMenu jpmUnpack;
    private javax.swing.JLabel lblStocks;
    private javax.swing.JLabel lblStore;
    private javax.swing.JMenuItem mitemUnpack;
    private javax.swing.JScrollPane scrAllStocks;
    // End of variables declaration//GEN-END:variables
    
}
