/*
 * StoreManager.java
 *
 * Created on , 2005,  28, 1:04
 */

package medstore;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 *
 * @author  JohnyEdu
 */
public class StoreManager extends CommonDialog implements ListSelectionListener{
    private JTable tblAllStores;
    public static final int STORE_NAME_INDEX = 0;
    public static final int STORE_KEY_INDEX = 1;
    //private javax.swing.JScrollPane scrAllStores;
    /** Creates new form StoreManager */
    public StoreManager(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        afterInitComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        lblAllStores = new javax.swing.JLabel();
        editStoreName = new javax.swing.JTextField();
        scrAllStores = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        btnAddStore = new javax.swing.JButton();
        btnEditStore = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Store Manager");
        lblAllStores.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        lblAllStores.setText("All Stores");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(15, 10, 0, 0);
        getContentPane().add(lblAllStores, gridBagConstraints);

        editStoreName.setFont(new java.awt.Font("Tahoma", 0, 13));
        editStoreName.setBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.LOWERED));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 10);
        getContentPane().add(editStoreName, gridBagConstraints);

        scrAllStores.setBorder(new javax.swing.border.EtchedBorder());
        scrAllStores.setFont(new java.awt.Font("Tahoma", 1, 13));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(1, 10, 0, 10);
        getContentPane().add(scrAllStores, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        btnAddStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnAddStore.setText("Add");
        btnAddStore.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StoreManager.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel1.add(btnAddStore, gridBagConstraints);

        btnEditStore.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnEditStore.setText("Edit");
        btnEditStore.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                StoreManager.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel1.add(btnEditStore, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        getContentPane().add(jPanel1, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-262)/2, (screenSize.height-273)/2, 262, 273);
    }
    // </editor-fold>//GEN-END:initComponents

    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource()==btnAddStore)
        {
            String strStoreName = editStoreName.getText();
            if( strStoreName == null || strStoreName.trim().equals("") )
            {
                JOptionPane.showMessageDialog(null,"Store name can not be empty!");
                return;
            }    
            if(((UniversalTableModel)tblAllStores.getModel()).objectExistsAt(strStoreName, STORE_NAME_INDEX)){
               JOptionPane.showMessageDialog(null,"Store with that name is already registered in the system.Please, type another name!");
               return;
            }
            String strSQL = "INSERT INTO BASE_STOR (stor_name,stor_type) VALUES('" + strStoreName + "','ST')";
            Connection connDB = null;
            try
            {
                connDB = SharedUtils.getConnection();
                Statement stm = connDB.createStatement();
                int nRowsModified = stm.executeUpdate(strSQL);
                if(nRowsModified != 1){
                    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
                    return;
                }
                stm.close();
                //
                String strLastID = SharedUtils.getLastInsertedID(connDB);
                Vector vecRowElements = new Vector();
                vecRowElements.addElement(strStoreName);
                vecRowElements.addElement(strLastID);
                UniversalTableRow uniTableRow = new UniversalTableRow(vecRowElements);
                ((UniversalTableModel)tblAllStores.getModel()).addObject(uniTableRow);
                tblAllStores.updateUI();
                editStoreName.setText("");
                JOptionPane.showMessageDialog(null,"The store was successfully registered in the system!");
            }
            catch(Exception e)
            {
                JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please restart!");
                return;
            }
            finally
            {
                SharedUtils.closeConnection(connDB);
            }            
        }
        else if(evt.getSource() == btnEditStore){
            int nStoreTableSelRow = tblAllStores.getSelectedRow();
            if(nStoreTableSelRow < 0)
            {
                JOptionPane.showMessageDialog(null,"Please select store from the table above!");
                return;
            }
            UniversalTableRow trowSelected = ((UniversalTableModel)tblAllStores.getModel()).getRowObject(nStoreTableSelRow);
            String strStoreId = (String)trowSelected.vecRowElements.get(STORE_KEY_INDEX);
            String strStoreName = editStoreName.getText();
            String strOLD  = (String)((UniversalTableModel)tblAllStores.getModel()).getValueAt(nStoreTableSelRow, STORE_NAME_INDEX);
            
            if(((UniversalTableModel)tblAllStores.getModel()).objectExistsAt(strStoreName, STORE_NAME_INDEX)){
                if(!strStoreName.equals(strOLD)){
                    JOptionPane.showMessageDialog(null,"Store with that name is already registered in the system.\n" +
                            "Please, type another name!");
                    return;
                }
            }
            
            String strSQL = "UPDATE BASE_STOR SET STOR_NAME = '" + strStoreName +"' WHERE STOR_KEY=" + strStoreId;
            try{
                Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
                Statement stm = connDB.createStatement();
                int nRowsModified = stm.executeUpdate(strSQL);
                if(nRowsModified != 1){
                    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
                    return;
                }
            }catch(Exception e){
                JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please restart!");
                return;
            }
            trowSelected.setRowElement(strStoreName, STORE_NAME_INDEX);
            tblAllStores.updateUI();
            editStoreName.setText("");
            JOptionPane.showMessageDialog(null,"The store was successfully edited!");
            tblAllStores.getSelectionModel().clearSelection();
        }       
    }//GEN-LAST:event_actionPerformed

    /**
     * @param args the command line arguments
     */
   public void afterInitComponents()
    {
        //this.getContentPane().setBackground(SharedUtils.bgColor);
        btnEditStore.setEnabled(false);
        //btnDeleteStore.setEnabled(false);
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString);
        String strSQL = "SELECT STOR_NAME,STOR_KEY FROM BASE_STOR ORDER BY STOR_NAME";
        ResultSet rsAllStocks = SharedUtils.executeSelect(connDB, strSQL);
        String[] str_rgn_columnNames = {"Name"};
        UniversalTableModel tbmAllStores = new UniversalTableModel(rsAllStocks,str_rgn_columnNames);
        tblAllStores = new javax.swing.JTable(tbmAllStores);
        //tblAllStores.getTableHeader().setBackground(new Color(70,80,230));
        //tblAllStores.getTableHeader().setForeground(new Color(255,255,255));
        //UniversalTableCellRenderer uniRenderer = new UniversalTableCellRenderer();
        //tblAllStores.setDefaultRenderer(String.class, uniRenderer);
        tblAllStores.getTableHeader().setReorderingAllowed(false);
        tblAllStores.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        tblAllStores.getSelectionModel().addListSelectionListener(this);
        scrAllStores.setViewportView(tblAllStores);
        tblAllStores.getTableHeader().resizeAndRepaint();
        enableExit(tblAllStores);
        UIUtils.setTableFonts(tblAllStores);
    }
    public void valueChanged(ListSelectionEvent e)
    {
        if(e.getSource()==tblAllStores.getSelectionModel() && !tblAllStores.getSelectionModel().isSelectionEmpty())
        {
            if(tblAllStores.getSelectedRow()>=0){
                btnEditStore.setEnabled(true);
                //btnDeleteStore.setEnabled(true);
            }
            else{
                btnEditStore.setEnabled(false);
                //btnDeleteStore.setEnabled(false);
            }
            int nStoreTableSelRow = tblAllStores.getSelectedRow();
            UniversalTableRow trowSelected = ((UniversalTableModel)tblAllStores.getModel()).getRowObject(nStoreTableSelRow);
            String strStoreName = (String)trowSelected.vecRowElements.get(STORE_NAME_INDEX);
            editStoreName.setText(strStoreName);
        }
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddStore;
    private javax.swing.JButton btnEditStore;
    private javax.swing.JTextField editStoreName;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel lblAllStores;
    private javax.swing.JScrollPane scrAllStores;
    // End of variables declaration//GEN-END:variables

}
