package medstore;
import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/* ImageFilter.java is a 1.4 example used by FileChooserDemo2.java. */
public class UniversalFileFilter extends FileFilter {

    public static final int CSV_FILES = 0;
    public static final int HTML_FILES = 1;
    public static final int TXT_FILES = 2;
    public static final int LAST_SELECTED_TYPE = -1;
    public static String str_rgn_extensions[] = {"csv","html","txt"};
    public static String str_rgn_descriptions[] = {"comma separated files(*.csv)","html files(*.html,*.htm)","text files(*.txt)"};
    public int filter;
    public UniversalFileFilter(int filter){
        this.filter = filter;
    }
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }

    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        String extension = getExtension(f);
        if (extension != null) {
            if(filter == HTML_FILES && extension.equals("htm"))
                return true;
            if (extension.equals(str_rgn_extensions[filter]))               
                return true;             
            else 
                return false;
        }
        return false;    
   }
            
    //The description of this filter
    public String getDescription() {        
        return str_rgn_descriptions[filter];
    }
}