package medstore.actors;

import java.util.ArrayList;
import medstore.math.BigDec;


public class Provisioner extends CustomerActor{
    
    public static final int prov1 = 1;
    public static final int prov2 = 2;
    public static final int prov3 = 3;
    private double commission;    
    
    public Provisioner(String id, String name, String commission){
        setCommission(commission);
        setName(name);
        setId(id);
    }
   
    public void setCommission(String commission){
        try{
            this.commission = Double.parseDouble(commission);
        }
        catch(Exception e){
            this.commission = 0;
        }
    }
    public void setCommission(double commission){        
        this.commission = commission;        
    }
    
    public String getCommission(){
        return BigDec.scaledRoundHalfUp(String.valueOf(commission), 2);
    }   
    public String toString(){
        return "\nUID:" + getId() + ";\nName: " + getName() + ";\nCommission: " + getCommission() + "%;";
    }
    public ArrayList toArrayList(){
        ArrayList toArray = new ArrayList();
        toArray.add(getId());
        toArray.add(getCommission());
        toArray.add(getName());
        return toArray;
    }
}
