package medstore.date;

import java.text.SimpleDateFormat;

public class DateUtil {
    private String date;
    private String delimiter;
    private SimpleDateFormat sdf = new SimpleDateFormat("dd.mm.yyyy");
    
    public DateUtil(){
        date = sdf.format(new java.util.Date());
        delimiter = ".";
    }
    public DateUtil(String date, String delimiter) {
        this.date = date;
        this.delimiter = delimiter;
    }
    
    public void setDate(String value){
        date = value;
    }
    public void setDelimiter(String value){
        delimiter = value;
    }
    
    public String getDMYtoYDM() throws Exception{
        String[] dateFields = date.split("\\" + delimiter);
        if(dateFields.length<3)
            throw new Exception("Error in Class DateUtil:\nInvalid Date Format");
        int nToDay = Integer.parseInt(dateFields[0]);
        int nToMonth = Integer.parseInt(dateFields[1]);
        int nToYear = Integer.parseInt(dateFields[2]);
        
        return nToMonth + "." + nToDay + "." + nToYear;
    }
    public String getYDMtoDMY() throws Exception{
        
        String[] dateFields = date.split("\\" + delimiter);
        if(dateFields.length<3)
            throw new Exception("Error in Class DateUtil:\nInvalid Date Format");
        int nToDay = Integer.parseInt(dateFields[1]);
        int nToMonth = Integer.parseInt(dateFields[2]);
        int nToYear = Integer.parseInt(dateFields[0]);
        
        
        return nToDay + "." + nToMonth + "." + nToYear;
    }
}
