package medstore.fullfillment;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.Statement;
import medstore.SharedUtils;
import medstore.procedures.ProcedureStore;
import medstore.fullfillment.data.FFData;

public abstract class DBConn {
    private String VIEW_FLFL_ORDR_ACTV = "SELECT V_NR FROM VIEW_FLFL_ORDR_ACTV WHERE V_NR=?";
    private String strEvntQuery ="INSERT INTO CONN_EVNT_QUER (evnt_idnt,quer_idnt ) VALUES(?,?)";
    
    private Connection conn;
    
    protected Connection getConnection() throws Exception{
        try{
            if(conn==null || conn.isClosed())
                conn = SharedUtils.getConnection();;
        }
        catch(Exception e){
            throw new Exception("Error: Database connection failed!\n" + e.getMessage());
        }
        return conn;
    }
    
    protected boolean isOrderFilled(String id) throws Exception{
        PreparedStatement pstmt = getConnection().prepareStatement(VIEW_FLFL_ORDR_ACTV);
        pstmt.setString(1,id);
        ResultSet rs = pstmt.executeQuery();
        if(rs!=null && rs.next())
            return true;
        return false;
    }
    
    protected boolean fillOrder(FFData ffdata) throws Exception{
        ProcedureStore proc = new ProcedureStore();
        proc.execStoreOperation( conn, ffdata.strOperationCode(), ffdata.nStockCount().intValue(),
                ffdata.strBarcode(), ffdata.nStoreId().toString(), ffdata.date(), ffdata.nUserID().toString() );
        
        long lLastEventID = Long.parseLong(proc.m_insertedEventId);
        int nStockID = Integer.parseInt( proc.m_stockId );
        
        PreparedStatement pstmt = getConnection().prepareStatement(strEvntQuery);
        pstmt.setString(1,String.valueOf(lLastEventID));
        pstmt.setString(1,ffdata.strOrderID());
        
        int nAffectedRows = pstmt.executeUpdate();
        
        if(nAffectedRows!=1)
            throw new Exception( "Database Error" );
        return true;
    }
    
}
