package medstore.init_config;

import java.sql.PreparedStatement;
import java.sql.Statement;
import java.sql.Connection;
import java.sql.ResultSet;
import medstore.DBSettingsMSSQL;
import medstore.Main;
import medstore.SharedUtils;
import medstore.init_config.print.Printer;
import medstore.trans.MenuLoader;


public class DBConn {
    protected String settingsSql = "select * from settings";    
    protected String insertsettingsSql = "update base_user set print_id = ? where user_key = ?"; 
    protected String setLangSql = "update base_user set lang = ? where user_key = ?"; 
    private Connection conn = null;
    private Statement stmt = null;
    private ResultSet rs = null;
           
    private String auftrag_file_path;
    
    
    private DBSettingsMSSQL mssql;
    
    public DBConn() throws Exception{
        try {
            SharedUtils.loadProperties();
            mssql = new DBSettingsMSSQL();
            conn = mssql.getConnection();
            stmt = conn.createStatement();        
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new Exception("init_config.DBConn Constructor failed:" + ex.getMessage());
        }        
    }
    
    public void initSettings() throws Exception{
        rs = stmt.executeQuery(settingsSql);
        if(rs.next()){                                   
            
            auftrag_file_path = rs.getString("auftrag_file_path");
            auftrag_file_path = rs.wasNull() ? null : auftrag_file_path;
                      
            
        }
        else{
            throw new Exception("Error in: init_config.DBConn.initSettings:");
        }
    }
    public String auftrag_file_path() throws Exception{     
        if(auftrag_file_path==null || "null".equals(auftrag_file_path) || auftrag_file_path.length()<=0)
            throw new Exception("Error in: init_config.DBConn.auftrag_file_path!\nField auftrag_file_path can not be null!\nPlease, contact System Administrator!");
        else
            return auftrag_file_path;
    }
    
    protected boolean setPrinter(Printer printer) throws Exception{
        
        final int pId = printer.getId();
        
        if(pId<0)
            throw new Exception("Printer Setting Error: Index -1 is Out of boundary");
        
        PreparedStatement pstmt = conn.prepareStatement(insertsettingsSql);
        pstmt.setInt(1,pId);
        pstmt.setInt(2,SharedUtils.nUserID);
        
        
        int i = pstmt.executeUpdate();
        
        if(i<=0){
            throw new Exception("Error: Printer was not changed");
        }
        Main.printer = printer;
        return true;
    }
    public boolean setLang(String lang)throws Exception{
        if(lang==null || lang.trim().equals("null") || lang.trim().length()<=0)
            throw new Exception("Lang Setting Error: Can not set Default Language!");
        
        PreparedStatement pstmt = conn.prepareStatement(setLangSql);
        pstmt.setString(1,lang);
        pstmt.setInt(2,SharedUtils.nUserID);
        
        
        int i = pstmt.executeUpdate();
        
        if(i<=0){
            throw new Exception("Error: Default Language was not changed");
        }        
        
        return true;
    }
}
