package medstore.init_config;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import medstore.auftrag.AuftragFile;
import medstore.init_config.print.Printer;

public class DailyLoader{    
    
    private DBConn dbtools;    
    private AuftragFile auftragFile;
    private Date date_now, date;
    private Printer printer;
    
    public DailyLoader() throws Exception{
        try {
            
            dbtools = new DBConn();
            dbtools.initSettings();
            auftragFile = new AuftragFile(dbtools.auftrag_file_path());
            
            date_now = new Date();            
            date = auftragFile.lastModefiedToDate();            
            
            DateFormat df = new SimpleDateFormat("yyyyMMdd", DateFormat.getAvailableLocales()[0]);
           
            long today = Integer.parseInt(df.format(date_now));
            long current = Integer.parseInt(df.format(date));
            
            if(today>current){                                
                /*
                *** auftragFile.deleteFile();                
                *** auftragFile.createNewFile();
                 */
            }
            
        } catch (Exception e) {
            throw new Exception("DailyLoader failed!\n" + e.getMessage());            
        }        
              
    }    
    
    public AuftragFile getAuftragFile(){
        return auftragFile;
    }
    
    public boolean setPrinter(Printer printer) throws Exception{
        return dbtools.setPrinter(printer);
    }
    public boolean setLang(String lang) throws Exception{
        return dbtools.setLang(lang);
    }
}
