package medstore.init_config.print;

import java.awt.print.PrinterJob;
import java.util.ArrayList;
import javax.print.PrintService;
import org.jfree.report.modules.gui.base.ReportPane;

public class Printers {
    private ArrayList printers;
    
    public Printers() {
        final PrinterJob printerJob = PrinterJob.getPrinterJob();
               
        PrintService[] service = printerJob.lookupPrintServices();
        
        printers = new ArrayList();
        
        for(int i=0; i < service.length; i++){
            final int pId = i;
            final String pname = service[i].getName();
            Printer printer = new Printer(pId, pname);
            printers.add(printer);
        }
    }
    
    public ArrayList getPrintersList() throws Exception{
        if(printers == null || printers.size()<=0){
            throw new Exception("No printers founded!");
        }
        else{
            return printers;
        }
    }
}
