package medstore.init_config.print;
import java.awt.Component;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import medstore.Main;
import medstore.init_config.DailyLoader;


public class SetPrintForm extends javax.swing.JFrame implements ListSelectionListener {
    private DefaultListModel listModel;
    private DailyLoader dloader;
    private int old_index = -1;
    private int new_index = -1;
    ArrayList printers;
    private Printer old_printer;
    
    public SetPrintForm(Component parent) {        
        super("Default Printer");
        initComponents();
        setSize(500,250);
        setLocation(parent.getX()+parent.getWidth()/4, parent.getY() + parent.getHeight());
        old_printer = new Printer(-1, "");
        int index = -1;
        try{
            
            dloader = new DailyLoader();
            
            printers = new Printers().getPrintersList();
            listModel = new DefaultListModel();
            for(int i=0; i<printers.size(); i++){
                Printer printer = (Printer)printers.get(i);
                if(Main.printer.getId()==i){
                    index = i;                    
                    old_printer = printer;
                    listModel.addElement(printer.getName() + " - default");
                } else{
                    listModel.addElement(printer.getName());
                }
                
            }
        } catch(Exception e){
            e.printStackTrace();
        }
        
        //Create the list and put it in a scroll pane.
        prnList.setModel(listModel);
        prnList.setSelectionMode(
                ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        prnList.setSelectedIndex(index);
        prnList.addListSelectionListener(this);
        prnList.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e){
                if(e.getClickCount() == 2){                    
                    btnSet.doClick();
                }
            }
             
        });
        
    }
    
    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting() == false) {
            
            if (prnList.getSelectedIndex() == -1) {
                //No selection: disable delete, up, and down buttons.
                
                
            } else if (prnList.getSelectedIndices().length > 1) {
                //Multiple selection: disable up and down buttons.
                
                
            } else {
                //Single selection: permit all operations.
                
            }
        }
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane = new javax.swing.JScrollPane();
        prnList = new javax.swing.JList();
        jPanel1 = new javax.swing.JPanel();
        btnSet = new javax.swing.JButton();
        btnClose = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.FlowLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jScrollPane.setMinimumSize(new java.awt.Dimension(450, 150));
        jScrollPane.setPreferredSize(new java.awt.Dimension(450, 150));
        prnList.setFont(new java.awt.Font("Tahoma", 1, 13));
        jScrollPane.setViewportView(prnList);

        getContentPane().add(jScrollPane);

        btnSet.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 13));
        btnSet.setText("Set Printer");
        btnSet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSetActionPerformed(evt);
            }
        });

        jPanel1.add(btnSet);

        btnClose.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 13));
        btnClose.setText("Close");
        btnClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCloseActionPerformed(evt);
            }
        });

        jPanel1.add(btnClose);

        getContentPane().add(jPanel1);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void btnCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCloseActionPerformed
        dispose();
    }//GEN-LAST:event_btnCloseActionPerformed
    
    private void btnSetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSetActionPerformed
        try{
            final int pId = prnList.getSelectedIndex();
            if(pId<0){
                JOptionPane.showMessageDialog(this,"Select printer!");
                return;
            }
            
            String pname = String.valueOf(prnList.getSelectedValue());
            Printer printer = new Printer(pId, pname);
            
            dloader.setPrinter(printer);
            Main.printer = printer;
            //JOptionPane.showMessageDialog(this,"Printer: " + printer.getName() + " was set as default!");
            
            try{
                if(pId==old_printer.getId())
                    return;
            }
            catch(Exception e){
                old_printer = printer;
            }
            
            listModel.set(pId, ((Printer)printers.get(pId)).getName() + " - default");
            if(old_printer!=null && old_printer.getId()>=0)
            listModel.set(old_printer.getId(), old_printer.getName());
            old_printer = printer;
            
        } catch(Exception e){
            e.printStackTrace();
        }
    }//GEN-LAST:event_btnSetActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnClose;
    private javax.swing.JButton btnSet;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane;
    private javax.swing.JList prnList;
    // End of variables declaration//GEN-END:variables
    class MyListDataListener implements ListDataListener {        
        public void contentsChanged(ListDataEvent e) {
            
        }
        public void intervalAdded(ListDataEvent e) {
            
        }
        public void intervalRemoved(ListDataEvent e) {
            
        }
    }
}


