package medstore.init_config.translate;
import java.awt.Component;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListDataEvent;
import javax.swing.event.ListDataListener;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import medstore.Main;
import medstore.init_config.DailyLoader;
import medstore.trans.MenuLoader;


public class SetLangForm extends javax.swing.JFrame implements ListSelectionListener {
    private DefaultListModel listModel;
    private DailyLoader dloader;
    private int old_index = -1;
    private int new_index = -1;
    private String curr_lang;
        
    public SetLangForm(Component parent) {        
        super("Default Language");
        initComponents();
        setSize(500,250);
        setLocation(parent.getX()+parent.getWidth()/4, parent.getY() + parent.getHeight());
    
        int index = -1;
        try{
            

            dloader = new DailyLoader();
            curr_lang = Main.def_app_lang.getDefaultLang();
            listModel = new DefaultListModel();
            setDefaultLang(listModel);
            
            
        } catch(Exception e){
            e.printStackTrace();
        }
        
        //Create the list and put it in a scroll pane.
        langList.setModel(listModel);
        langList.setSelectionMode(
                ListSelectionModel.SINGLE_INTERVAL_SELECTION);
        langList.setSelectedIndex(index);
        langList.addListSelectionListener(this);
        langList.addMouseListener(new MouseAdapter(){
            public void mouseClicked(MouseEvent e){
                if(e.getClickCount() == 2){                    
                    btnSet.doClick();
                }
            }
             
        });
        
    }
    private void setDefaultLang(DefaultListModel listModel){
        listModel.removeAllElements();        
        if(curr_lang.toLowerCase().equals("German".toLowerCase())){                                 
                listModel.addElement("English");
                 listModel.addElement("German" + " - default");  
                curr_lang = "German";
            }
            else{
                listModel.addElement("English" + " - default");
                listModel.addElement("German");    
                curr_lang = "English";
            }        
    }
    public void valueChanged(ListSelectionEvent e) {
        if (e.getValueIsAdjusting() == false) {
            
            if (langList.getSelectedIndex() == -1) {
                //No selection: disable delete, up, and down buttons.
                
                
            } else if (langList.getSelectedIndices().length > 1) {
                //Multiple selection: disable up and down buttons.
                
                
            } else {
                //Single selection: permit all operations.
                
            }
        }
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jScrollPane = new javax.swing.JScrollPane();
        langList = new javax.swing.JList();
        jPanel1 = new javax.swing.JPanel();
        btnSet = new javax.swing.JButton();
        btnClose = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.FlowLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        jScrollPane.setMinimumSize(new java.awt.Dimension(450, 150));
        jScrollPane.setPreferredSize(new java.awt.Dimension(450, 150));
        langList.setFont(new java.awt.Font("Tahoma", 1, 13));
        jScrollPane.setViewportView(langList);

        getContentPane().add(jScrollPane);

        btnSet.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 13));
        btnSet.setText("Set Langluage");
        btnSet.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSetActionPerformed(evt);
            }
        });

        jPanel1.add(btnSet);

        btnClose.setFont(new java.awt.Font("Microsoft Sans Serif", 1, 13));
        btnClose.setText("Close");
        btnClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCloseActionPerformed(evt);
            }
        });

        jPanel1.add(btnClose);

        getContentPane().add(jPanel1);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void btnCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCloseActionPerformed
        dispose();
    }//GEN-LAST:event_btnCloseActionPerformed
    
    private void btnSetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSetActionPerformed
        try{
            
            final int pId = langList.getSelectedIndex();
            if(pId<0){
                JOptionPane.showMessageDialog(this,"Select Language!");
                return;
            }
            if(Main.openFramesCount()>2){
                int res = JOptionPane.showConfirmDialog(this,"This action will close all open Screens!\nPlease confirm!", "Confirm dialog", JOptionPane.YES_NO_OPTION);
                if(res==JOptionPane.NO_OPTION)
                    return;
            }
                curr_lang = pId == 0 ? "English" : "German";
            
            dloader.setLang(curr_lang);
            setDefaultLang(listModel);
           Main.def_app_lang = new MenuLoader(curr_lang);
            Main.reload();
            
        } catch(Exception e){
            e.printStackTrace();
        }
    }//GEN-LAST:event_btnSetActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnClose;
    private javax.swing.JButton btnSet;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane;
    private javax.swing.JList langList;
    // End of variables declaration//GEN-END:variables
    class MyListDataListener implements ListDataListener {        
        public void contentsChanged(ListDataEvent e) {
            
        }
        public void intervalAdded(ListDataEvent e) {
            
        }
        public void intervalRemoved(ListDataEvent e) {
            
        }
    }
}


