package medstore.offers;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.ArrayList;
import javax.swing.*;
import medstore.Main;
import medstore.SharedUtils;
import medstore.auftrag.AuftragData;
import medstore.print.CustomPrintUtil;
import medstore.print.SimplePrintUtils;
import medstore.print.invoice.Article;
import medstore.print.invoice.Customer;
import medstore.print.invoice.Invoice;
import medstore.print.invoice.InvoiceTableModel;
import org.jfree.report.JFreeReport;



public class OrderPrintUtils {
    
    private Invoice invoice;
    
    private boolean packing = false;
    private boolean hidediscont = true;
    
    private AuftragData auftrag;
    
    public OrderPrintUtils(String strOrderIdnt) throws Exception{
        packing = false;
        loadOrderInfo(strOrderIdnt);
    }
    
    
    
    
    private Invoice loadOrderInfo(String strOrderIdnt) throws Exception{
        
        Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
        String strSQL = "SELECT vorgang.v_nr, vorgang.patn_idnt, vorgang.patn_dscn, vorgang.invc_addr, " +
                " vorgang.invc_date, vorgang.neto_sum, vorgang.vat_pers, vorgang.totl_sum," +
                " vorgang.altr_name, vorgang.patn_cntr, vorgang.patn_city, vorgang.patn_code, vorgang.patn_strt, " +
                " vorgang.invc_prto, vorgang.macro1text, vorgang.doc_type_idnt, vorgang.patn_cntr, " +
                
                " base_prsn.prsn_appl, base_prsn.prsn_fnam, base_prsn.prsn_lnam, base_prsn.vatfree, base_prsn.clcode, " +
                
                " base_user.user_abrv " +
                
                " FROM dbo.base_prsn INNER JOIN base_cntr ON base_prsn.cntr_idnt = base_cntr.cntr_key " +
                "                    INNER JOIN vorgang   ON base_prsn.prsn_key  = vorgang.patn_idnt " +
                "                    INNER JOIN base_user ON vorgang.oper_idnt   = base_user.user_key " +
                "                    INNER JOIN base_doc_type ON vorgang.doc_type_idnt = base_doc_type.type_key " +
                " WHERE vorgang.v_nr = " + strOrderIdnt + " and vorgang.doc_type_idnt = 1";
        
        Statement stm = connDB.createStatement();
        ResultSet rsDBData=stm.executeQuery(strSQL);
        boolean bMore = rsDBData.next();
        if(!bMore) {
            JOptionPane.showMessageDialog(null,"Error while loading order information.Order Data Corrupted!");
            return null;
        }
        String customerId = rsDBData.getString("patn_idnt");
        String firstName = rsDBData.getString("prsn_fnam");
        String lastName = rsDBData.getString("prsn_lnam");
        String salutation = rsDBData.getString("prsn_appl");
        String invAltName = rsDBData.getString("altr_name");
        String country = rsDBData.getString("patn_cntr");
        String street = rsDBData.getString("patn_strt");
        String postalCode = rsDBData.getString("patn_code");
        String town = rsDBData.getString("patn_city");
        
        String altAddressCaption = "Lieferranschrift:";
        String invAltAddress = rsDBData.getString("invc_addr");
        
        String user_abrv = rsDBData.getString("user_abrv");
        
        String invoiceNumber = rsDBData.getString("v_nr");
        String invmacro = rsDBData.getString("macro1text");
        Timestamp tmpdate = rsDBData.getTimestamp("invc_date");
        int invoiceType = rsDBData.getInt("doc_type_idnt");
        
        String invoiceVatPerc = rsDBData.getString("vat_pers");
        String invoiceDicountPerc = rsDBData.getString("patn_dscn");
        String invoiceVersand = rsDBData.getString("invc_prto");
        String invoiceNeto = rsDBData.getString("neto_sum");
        String invoiceTotalSum = "";//rsDBData.getString("totl_sum");
        
        String invoiceVat = "";
        String invoiceDiscount = "";
        String invoiceSum = "";
        
        String clcode = rsDBData.getString("clcode");
        clcode = rsDBData.wasNull() ? "" : clcode.trim();
        
        String vatfree = rsDBData.getString("vatfree");
        
        rsDBData.close();
        stm.close();
        
        if(invAltAddress!=null && !invAltAddress.trim().equals("null") && invAltAddress.trim().length()>0){
            packing = true;
            String[] altArray = null;
            
            try{
                altArray = invAltAddress.split("\n");
                
                switch(altArray.length){
                    case 0: 
                        auftrag =  new AuftragData(invoiceNumber,"", "", "", invAltAddress, customerId,"","","");
                        break;
                    case 1: 
                        auftrag =  new AuftragData(invoiceNumber, "", altArray[0], "", "", customerId,"","","");
                        break;
                    case 2:                         
                        auftrag =  new AuftragData(invoiceNumber,"", altArray[0], altArray[1], "", customerId, "", "", "");
                        break;
                    case 3: 
                        auftrag =  new AuftragData(invoiceNumber,"", altArray[0], altArray[1], "", customerId,altArray[2], "", "");
                        break;
                    case 4: 
                        auftrag =  new AuftragData(invoiceNumber,"", altArray[0], altArray[1], "", customerId,altArray[2],altArray[3],"");
                        break;
                    case 5: 
                        auftrag =  new AuftragData(invoiceNumber,"", altArray[0], altArray[1], "", customerId, altArray[2], altArray[3], altArray[4]);
                        break;
                    default:                         
                        auftrag =  new AuftragData(invoiceNumber,"", "", "", invAltAddress, customerId,"","","");
                        break;
                }
                
                
            } catch(Exception e){
                
            }
        }
        else{
            auftrag =  new AuftragData(invoiceNumber,salutation, firstName, lastName, invAltName, customerId,street,town,postalCode);
        }
        
        if(Double.parseDouble(invoiceDicountPerc)<=0){
            hidediscont = false;
        } else{
            hidediscont = true;
        }
        BigDecimal bdmTotal = new BigDecimal(0.0);
        BigDecimal bdmTotalWithoutVat = new BigDecimal(0.0);
        
        BigDecimal bdmVatPers = new BigDecimal(invoiceVatPerc);
        bdmVatPers = bdmVatPers.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal bdmDiscountPers = new BigDecimal(invoiceDicountPerc);
        bdmDiscountPers = bdmDiscountPers.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal bdmNetto = new BigDecimal(invoiceNeto);
        bdmNetto = bdmNetto.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal bdmPorto = new BigDecimal(invoiceVersand);
        bdmPorto = bdmPorto.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal bdmDiscount = bdmNetto.multiply( bdmDiscountPers ).divide(new BigDecimal(100.0),3,BigDecimal.ROUND_HALF_UP);
        bdmDiscount = bdmDiscount.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal discNeto = new BigDecimal(bdmNetto.doubleValue() - bdmDiscount.doubleValue());
        
        BigDecimal subTotal = new BigDecimal(discNeto.doubleValue() + bdmPorto.doubleValue());
        subTotal = subTotal.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        BigDecimal dVat = subTotal.multiply(bdmVatPers).divide( new BigDecimal(100.0), 3, BigDecimal.ROUND_HALF_UP );
        bdmTotal = new BigDecimal(subTotal.doubleValue() + dVat.doubleValue());
        bdmTotal = bdmTotal.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        dVat = dVat.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        
        bdmDiscount = bdmDiscount.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        bdmPorto = bdmPorto.setScale(2,BigDecimal.ROUND_HALF_UP);
        
        
        invoiceVat = dVat.toString();
        invoiceVatPerc = bdmVatPers.toString();
        
        invoiceDiscount = bdmDiscount.toString();
        invoiceDicountPerc = bdmDiscountPers.toString();
        
        invoiceVersand = bdmPorto.toString();
        
        invoiceSum = subTotal.toString();
        invoiceTotalSum = bdmTotal.toString();
        
        switch(invoiceType){
            case 1:                
                invoiceDiscount = "-" + invoiceDiscount;
                break;
            case 2:
                throw new Exception("Credit Note is not allowed here!");
        }
        
        
        
        String date = SharedUtils.getStringFromTimestamp(tmpdate,SharedUtils.PARSE_ONLY_DATE);
        String invoiceBarcode = SharedUtils.generateBarcodeString(invoiceNumber);
        
        lastName+="\n";
        if(invAltName!=null && invAltName.trim().length()>0){
            lastName += invAltName + "\n";
        }
        if(street!=null && street.trim().length()>0){
            lastName+=street + "\n";
        }
        if(country!=null && country.trim().length()>0){
            lastName+=country + " - ";
        }
        if(postalCode!=null && postalCode.trim().length()>0){
            lastName+=postalCode + " ";
        }
        if(town!=null && town.trim().length()>0){
            lastName+=town;
        }
        if( "Y".equals(vatfree) && clcode.length()>0) {
            lastName+= "\nIhre MwSt: " + clcode;
        }
        String packmacro = "Ihre Bestellung von " + date +
                " " + user_abrv +"\n";
        
        Customer customer = new Customer(firstName, lastName, salutation, street, postalCode, town, country,
                altAddressCaption, invAltAddress, invmacro, invAltName, packmacro);
        
        invoice = new Invoice(customer, date, invoiceNumber, invoiceVersand, invoiceDiscount, invoiceSum,
                invoiceVat, invoiceTotalSum, invoiceVatPerc + "%", customerId, invoiceBarcode, invoiceDicountPerc + "%");
        
        
        invoice.setType(invoiceType);
        
        strSQL = " SELECT base_stck.stck_brcd, base_stck.stck_abrv," +
                " base_stck.stck_name, position.p_menge, position.unit_pric,position.sum_pric, base_stck.stck_key " +
                " FROM  vorgang INNER JOIN " +
                " position ON vorgang.v_nr = position.v_nr INNER JOIN" +
                " base_stck ON position.nstk_idnt = base_stck.stck_key  " +
                " WHERE vorgang.v_nr = " + strOrderIdnt +
                " order by position.p_pos asc";
        
        connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
        stm = connDB.createStatement();
        rsDBData = stm.executeQuery(strSQL);
        
        bMore = rsDBData.next();
        
        ArrayList articles = new ArrayList();
        
        while(bMore){
            String articleNumber = rsDBData.wasNull() ? "" : rsDBData.getString("stck_brcd");
            String name = rsDBData.wasNull() ? "" : rsDBData.getString("stck_name");
            String price = rsDBData.wasNull() ? "" : rsDBData.getString("unit_pric");
            String count = rsDBData.wasNull() ? "" : rsDBData.getString("p_menge");
            String total = rsDBData.wasNull() ? "" : rsDBData.getString("sum_pric");
            
            price = SharedUtils.formatFloat(price, '.' );
            total = SharedUtils.formatFloat(total, '.' );
            
            final Article article = new Article(articleNumber, name, price, count, total);
            articles.add(article);
            bMore = rsDBData.next();
        }
        rsDBData.close();
        stm.close();
        
        invoice.setArticles(articles);
        
        
        
        
        return invoice;
    }
    
    public void printInvoice()throws Exception{
        
        InvoiceTableModel data = new InvoiceTableModel();
        data.addInvoice(invoice);
        SimplePrintUtils spUtils = new SimplePrintUtils(data, "invoice/invoice.xml","Fullfillment Invoice");
        final JFreeReport report = spUtils.createReport();
        try{
            spUtils.ShowHideItems(report,hidediscont);
        } catch(Exception e){
            System.out.println(e.getMessage());
        }
        boolean printed = CustomPrintUtil.printOn(report,Main.printer.getId(),2);
        if(printed==false){
            throw new Exception("Document Prining failed!\nTry to set another default printer!");
        }
        
        
        
    }
    public void printPacking()throws Exception{
        
        if(!packing){
            return;
        }
        
        InvoiceTableModel data = new InvoiceTableModel();
        data.addInvoice(invoice);
        SimplePrintUtils spUtils = new SimplePrintUtils(data, "invoice/packing.xml","Fullfillment Packing");
        final JFreeReport report = spUtils.createReport();
        
        boolean printed = CustomPrintUtil.printOn(report,Main.printer.getId(),2);
        if(printed==false){
            throw new Exception("Document Prining failed!\nTry to set another default printer!");
        }
        
        
    }
    
    public AuftragData getAufftragData() throws Exception{
        if(auftrag!=null)
            return auftrag;
        else
            throw new Exception("Can not inicialize Auftrag data!");
    }
    
}