/*
 * PrintPreview.java
 *
 * Created on , 2006,  17, 21:47
 */

package medstore.print.gui;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.Action;
import org.jfree.report.JFreeReport;
import org.jfree.report.modules.gui.base.CloseAction;
import org.jfree.report.modules.gui.base.PreviewBaseModule;
import org.jfree.report.modules.gui.base.PreviewProxy;
import org.jfree.report.modules.gui.base.PreviewProxyBase;
import org.jfree.report.modules.gui.base.ReportPane;
import org.jfree.report.modules.gui.base.SkinLoader;
import org.jfree.util.ResourceBundleSupport;
import javax.swing.*;
import org.jfree.report.modules.gui.print.PrintUtil;
public class PrintPreview extends javax.swing.JFrame implements PreviewProxy{
    
    public PrintPreview(final JFreeReport report) throws Exception {
        
        initComponents();
        base = new PreviewProxyBase(this) {
            protected JMenuBar createMenuBar() {
                return null;
            }
            protected void initializeToolBar(){                
                return;
            }
            protected JToolBar createToolBar() {
                JToolBar toolbar = super.createToolBar();
                JButton goTo = createButton(getGotoAction());                
                goTo.setText("Go to page");
                JButton print = new JButton("Print");
                print.addActionListener(new ActionListener(){
                    public void actionPerformed(final ActionEvent e) {
                        try{
                            PrintUtil.print(report);
                        }
                        catch(Exception ex){
                            ex.printStackTrace();
                        }
                    }
                });
                
                toolbar.add(createButton(getFirstPageAction()));
                toolbar.add(createButton(getPreviousPageAction()));
                toolbar.add(createButton(getNextPageAction()));
                toolbar.add(createButton(getLastPageAction()));
                toolbar.addSeparator();                
                toolbar.add(createButton(getZoomInAction()));
                toolbar.add(createButton(getZoomOutAction()));
                toolbar.addSeparator();
                toolbar.add(createZoomPane());
                toolbar.add(print);
                toolbar.addSeparator();
                toolbar.add(goTo);                
                return toolbar;
            }
        };
        
        
        base.setReport(report);
        setContentPane(base);
        
    }
    
    public PrintPreview(final JFreeReport report, final JButton print) throws Exception {        
        initComponents();
       
        base = new PreviewProxyBase(this) {
            protected JMenuBar createMenuBar() {
                return null;
            }
            protected void initializeToolBar(){                
                return;
            }
            protected JToolBar createToolBar() {
                JToolBar toolbar = super.createToolBar();
                JButton goTo = createButton(getGotoAction());                
                goTo.setText("Go to page");                                
                toolbar.add(createButton(getFirstPageAction()));
                toolbar.add(createButton(getPreviousPageAction()));
                toolbar.add(createButton(getNextPageAction()));
                toolbar.add(createButton(getLastPageAction()));
                toolbar.addSeparator();                
                toolbar.add(createButton(getZoomInAction()));
                toolbar.add(createButton(getZoomOutAction()));
                toolbar.addSeparator();
                toolbar.add(createZoomPane());
                toolbar.add(print);
                toolbar.addSeparator();
                toolbar.add(goTo);                
                return toolbar;
            }
        };
        
        
        base.setReport(report);
        setContentPane(base);
        
    }
    
    protected PreviewProxyBase createPreviewProxyBase() {
        return new PreviewProxyBase(this);
    }
    public PreviewProxyBase getBase() {
        return base;
    }
    public Action createDefaultCloseAction() {
        
        return new DefaultCloseAction();
    }
    public void close() {
        base.close();
    }
    public ResourceBundleSupport getResources() {
        if (resources == null) {
            resources = new ResourceBundleSupport(PreviewBaseModule.RESOURCES_BASE_NAME);
        }
        return resources;
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        pack();
    }
    // </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
    private ReportPane reportPane;
    private ResourceBundleSupport resources;
    private PreviewProxyBase base;
    
    private class DefaultCloseAction extends CloseAction {
        /**
         * Creates a 'close' action.
         */
        public DefaultCloseAction() {
            super(getResources(), SkinLoader.loadSkin());
        }
        
        /**
         * Closes the preview frame if the default close operation is set to dispose so this
         * frame is reusable.
         *
         * @param e The action event.
         */
        public void actionPerformed(final ActionEvent e) {
            if (getDefaultCloseOperation() == DISPOSE_ON_CLOSE) {
                dispose();
                close();
            } else {
                dispose();
                close();
            }
        }
    }
}
