package medstore.print.reports.analysis.ma_dr;

import java.sql.CallableStatement;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.Hashtable;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;
import medstore.CommissionQueryFilter;
import medstore.SharedConstants;
import medstore.SharedUtils;
import org.jfree.report.JFreeReport;



public class MADRReport implements SharedConstants{
    private Hashtable htbFilterParams;
    private DefaultTableModel deftm;
    
    public MADRReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
        String strYear = (String)htbFilterParams.get(YEAR_FILTER_VALUE);
        String strMonth = (String)htbFilterParams.get(MONTH_FILTER_VALUE);
        String strTextDateFrom = strMonth + ".01." + strYear;
        String strTextDateTo = SharedUtils.getToDate("31." + strMonth +"." + strYear);
        
        String rep_date = strMonth + "." + strYear;
        
        String prsn_key = "";
        if(htbFilterParams.get("person")!=null){
            prsn_key = htbFilterParams.get("person").toString();
        }
        
        
        Connection conn = null;
        
        int count = 0;
        Object[] columnNames = {
            "rep_date",
                    "ma_address",
                    "ma_prsn_key",
                    
                    "doc_address",
                    
                    "stck_abrv",
                    "prod_cnt"
                    
        };
        
        deftm = new DefaultTableModel(columnNames, 0);
        String ma_prsn_key_g = null;
        try {
            conn = SharedUtils.getConnection();
            CallableStatement stmt = conn.prepareCall("{call sp_analysis_ma_dr('" + strTextDateFrom + "','" + strTextDateTo + "','" + prsn_key + "')}");
            ResultSet rs = stmt.executeQuery();
            System.out.println("{call sp_analysis_ma_dr('" + strTextDateFrom + "','" + strTextDateTo + "','" + prsn_key + "')}");
            while(rs.next()) {
                
                String ma_type_abbr = rs.getString("ma_type_abbr");
                String ma_prsn_key = rs.getString("ma_prsn_key");
                String ma_prsn_appl = rs.getString("ma_prsn_appl");
                String ma_prsn_fnam = rs.getString("ma_prsn_fnam");
                String ma_prsn_lnam = rs.getString("ma_prsn_lnam");
                String ma_cntr_name = rs.getString("ma_cntr_name");
                String ma_prsn_city = rs.getString("ma_prsn_city");
                String ma_city_code = rs.getString("ma_city_code");
                String ma_prsn_strt = rs.getString("ma_prsn_strt");
                
                String doc_type_abbr = rs.getString("doc_type_abbr");
                String doc_prsn_key = rs.getString("doc_prsn_key");
                String doc_prsn_lnam = rs.getString("doc_prsn_lnam");
                String doc_prsn_fnam = rs.getString("doc_prsn_fnam");
                String doc_prsn_appl = rs.getString("doc_prsn_appl");
                String doc_prsn_city = rs.getString("doc_prsn_city");
                String doc_city_code = rs.getString("doc_city_code");
                String doc_prsn_strt = rs.getString("doc_prsn_strt");
                String doc_cntr_name = rs.getString("doc_cntr_name");
                String stck_abrv = rs.getString("stck_abrv");
                int prod_cnt = rs.getInt("prod_cnt");
                String ma_address = "";
                String ma_name="";
                
                
                
                if(ma_prsn_appl!=null && ma_prsn_appl.trim().length()>0){
                    ma_address+= ma_prsn_appl+"\n";
                }
                if(ma_prsn_fnam!=null && ma_prsn_fnam.trim().length()>0){
                    ma_name+= ma_prsn_fnam;
                }
                if(ma_prsn_lnam!=null && ma_prsn_lnam.trim().length()>0){
                    if(ma_name.trim().length()>0){
                        ma_name+= ", " + ma_prsn_lnam;
                    } else{
                        ma_name+=ma_prsn_lnam;
                    }
                }
                if(ma_name.trim().length()>0){
                    ma_address+=ma_name + "\n";
                }
                if(ma_type_abbr!=null && ma_type_abbr.trim().length()>0){
                    ma_address+= ma_type_abbr + "\n";
                }
                if(ma_prsn_strt!=null && ma_prsn_strt.trim().length()>0){
                    ma_address+= ma_prsn_strt + "\n";
                }
                if(ma_cntr_name!=null && ma_cntr_name.trim().length()>0){
                    ma_address+= ma_cntr_name + " - ";
                }
                if(doc_city_code!=null && doc_city_code.trim().length()>0){
                    ma_address+=doc_city_code + " ";
                }
                if(ma_prsn_city!=null && ma_prsn_city.trim().length()>0){
                    ma_address+= ma_prsn_city;
                }
                
                String doc_address = "";
                if(doc_prsn_fnam!=null && doc_prsn_fnam.trim().length()>0){
                    doc_address+=doc_prsn_key + " ";
                }
                if(doc_prsn_fnam!=null && doc_prsn_fnam.trim().length()>0){
                    doc_address+=doc_prsn_fnam;
                }
                if(doc_prsn_lnam!=null && doc_prsn_lnam.trim().length()>0){
                    doc_address+=", " + doc_prsn_lnam;
                }
                if(doc_cntr_name!=null && doc_cntr_name.trim().length()>0){
                    doc_address+=" " + doc_cntr_name;
                }
                if(doc_city_code!=null && doc_city_code.trim().length()>0){
                    doc_address+=" " + doc_city_code;
                }
                if(doc_prsn_city!=null && doc_prsn_city.trim().length()>0){
                    doc_address+=" " + doc_prsn_city;
                }
                
                if(!ma_prsn_key.equals(ma_prsn_key_g)){
                    try{
                        
                        ResultSet ttl = joinTotals(ma_prsn_key, strTextDateFrom, strTextDateTo);
                        
                        while(ttl.next()){
                            deftm.addRow(new Object[]
                            {
                                rep_date,
                                        ma_address,
                                        ma_prsn_key,
                                        "",
                                        "               " + ttl.getString("stck_abrv"),
                                        "                                 " + String.valueOf(ttl.getInt("prod_cnt"))
                                        
                                        
                            }
                            );
                        }
                        
                    } catch(Exception e){
                        
                    }
                }
                deftm.addRow(new Object[]
                {
                    rep_date,
                            ma_address,
                            ma_prsn_key,
                            doc_address,
                            stck_abrv,
                            ""+(prod_cnt)
                }
                );
                
                
                ma_prsn_key_g = ma_prsn_key;
            }
            rs.close();
            stmt.close();
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(conn);
        }
        
        MADRPrintUtils spUtils = new MADRPrintUtils(deftm,"/medstore/print/reports/analysis/ma_dr/report.xml","Orders - Analysis 'MA -> DR'");
        return spUtils.createReport();
        
    }
    
    
    private ResultSet joinTotals(String ma_prsn_key, String strTextDateFrom, String strTextDateTo) throws Exception{
        Connection conn = null;
        try{
            conn = SharedUtils.getConnection();
           // System.out.println("{call sp_analysis_ma_dr_totals ('" + strTextDateFrom + "','" + strTextDateTo + "','" + ma_prsn_key + "')}");
            CallableStatement stmt = conn.prepareCall("{call sp_analysis_ma_dr_totals ('" + strTextDateFrom + "','" + strTextDateTo + "','" + ma_prsn_key + "')}");
            ResultSet rs = stmt.executeQuery();
            return rs;
        } finally{
           
        }
    }
}
