
package medstore.print.reports.commissions;

import java.awt.Color;
import java.util.*;
import javax.swing.DefaultComboBoxModel;
import medstore.CommonDialog;
import medstore.PersonSearch;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.gui.PrintPreview;
import medstore.print.reports.analysis.ma_dr.MADRReport;
import medstore.print.reports.commissions.macommperoffer.MACPOReport;
import medstore.print.reports.commissions.personcommperoffer.PCPOReport;
import medstore.print.reports.commissionsamount.OCAReport;

public class CommissionQueryFilter extends CommonDialog implements SharedConstants{
    int m_enquiryType;
    String m_personID;
    
    public CommissionQueryFilter(java.awt.Frame parent, boolean modal, int enquiry) {
        super(parent, modal);
        initComponents();
        afterInitComponents();
        m_enquiryType = enquiry;
        
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        btnSearch = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        panYear = new javax.swing.JPanel();
        comboYear = new javax.swing.JComboBox();
        comboMonth = new javax.swing.JComboBox();
        jPanel2 = new javax.swing.JPanel();
        btnSearchClients = new javax.swing.JButton();
        editPersonName = new javax.swing.JTextField();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Persons search");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                CommissionQueryFilter.this.windowClosed(evt);
            }
        });

        btnSearch.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSearch.setLabel("Apply Filters");
        btnSearch.setMaximumSize(new java.awt.Dimension(120, 26));
        btnSearch.setMinimumSize(new java.awt.Dimension(120, 26));
        btnSearch.setPreferredSize(new java.awt.Dimension(120, 26));
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CommissionQueryFilter.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 10, 10);
        getContentPane().add(btnSearch, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setBorder(new javax.swing.border.TitledBorder(null, "Date Filter", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        panYear.setLayout(null);

        panYear.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        panYear.setMinimumSize(new java.awt.Dimension(150, 60));
        panYear.setPreferredSize(new java.awt.Dimension(250, 60));
        comboYear.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        panYear.add(comboYear);
        comboYear.setBounds(10, 20, 130, 22);

        comboMonth.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboMonth.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "01", "02", "03", "04", "05", "06", "07", "08", "09", "10", "11", "12" }));
        panYear.add(comboMonth);
        comboMonth.setBounds(170, 20, 60, 22);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        jPanel1.add(panYear, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        getContentPane().add(jPanel1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        jPanel2.setBorder(new javax.swing.border.TitledBorder(null, "Commissioner Filter", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 14)));
        btnSearchClients.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSearchClients.setText("Person search");
        btnSearchClients.setMaximumSize(new java.awt.Dimension(130, 26));
        btnSearchClients.setMinimumSize(new java.awt.Dimension(130, 26));
        btnSearchClients.setPreferredSize(new java.awt.Dimension(130, 26));
        btnSearchClients.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSearchClientsActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 10);
        jPanel2.add(btnSearchClients, gridBagConstraints);

        editPersonName.setMaximumSize(new java.awt.Dimension(110, 21));
        editPersonName.setMinimumSize(new java.awt.Dimension(110, 21));
        editPersonName.setPreferredSize(new java.awt.Dimension(110, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 10, 10);
        jPanel2.add(editPersonName, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 10);
        getContentPane().add(jPanel2, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-354)/2, (screenSize.height-270)/2, 354, 270);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void btnSearchClientsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSearchClientsActionPerformed
        Vector vecResults = new Vector();
        if(m_enquiryType == RDERS_ORDERS_COMMISIONS_BY_PERSON_MA){
            new PersonSearch(new javax.swing.JFrame(), true, vecResults, PersonSearch.PATIENT_SEARCH).setVisible(true);
        }
        else{
            new PersonSearch(new javax.swing.JFrame(), true, vecResults, PersonSearch.PATIENT_SEARCH).setVisible(true);
        }
        if( vecResults.size() > 0 ) {
            m_personID = (String)vecResults.get(0);
            String sql = SharedUtils.dbSettings.getSqlSelectPersonNamesById(m_personID);
            String name = SharedUtils.executeSqlScalar( sql );
            this.editPersonName.setText(name);
        }
    }//GEN-LAST:event_btnSearchClientsActionPerformed
    
    private void windowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowClosed
        
    }//GEN-LAST:event_windowClosed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if( evt.getSource() == btnSearch ) {
            
            Hashtable params = new Hashtable();
            params.put( YEAR_FILTER_VALUE , comboYear.getSelectedItem());
            params.put( MONTH_FILTER_VALUE , comboMonth.getSelectedItem());
            if( m_personID != null )
                params.put( "person", m_personID );
            if(m_enquiryType == SharedConstants.ORDERS_COMMISSION_AMMOUNT){
                try{
                    final PrintPreview preview = new PrintPreview(new OCAReport(params).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            } else if(m_enquiryType==SharedConstants.ORDERS_ORDERS_COMMISIONS_BY_PERSON){
                try{
                    final PrintPreview preview = new PrintPreview(new PCPOReport(params).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
                
            } else if(m_enquiryType==ORDERS_ANALYSIS_MA_DR){
                try{
                    final PrintPreview preview = new PrintPreview(new MADRReport(params).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            else if(m_enquiryType == RDERS_ORDERS_COMMISIONS_BY_PERSON_MA){
                try{
                    final PrintPreview preview = new PrintPreview(new MACPOReport(params).getReport());
                    preview.setSize(750, 750);
                    preview.setVisible(true);
                } catch(Exception e){
                    System.out.println(e.getMessage());
                    e.printStackTrace();
                }
            }
            dispose();
        }
    }//GEN-LAST:event_actionPerformed
    
    private void afterInitComponents() {
        Calendar cal = Calendar.getInstance();
        int year = cal.get( Calendar.YEAR );
        int m = cal.get( Calendar.MONTH)+1;
        String month = m > 9 ? ""+m : "0"+m;
        System.out.println(month);
        Vector vec = new Vector();
        int begYear = Math.max( 2000, year - 5 );
        int endYear = Math.max( 2000, year + 1 );
        for( int i = begYear; i <= endYear; i++ ){
            vec.add("" + i);
        }
        DefaultComboBoxModel aModel = new DefaultComboBoxModel(vec);
        comboYear.setModel(aModel);
        comboYear.setSelectedItem(""+year);
        comboMonth.setSelectedItem(""+month);
        editPersonName.setEditable(false);
        editPersonName.setBackground(Color.WHITE);
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSearch;
    private javax.swing.JButton btnSearchClients;
    private javax.swing.JComboBox comboMonth;
    private javax.swing.JComboBox comboYear;
    private javax.swing.JTextField editPersonName;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel panYear;
    // End of variables declaration//GEN-END:variables
    
}
