package medstore.print.reports.commissions;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class OCReport implements SharedConstants{
    private Hashtable htbFilterParams;
    private String[] m_strMonths = {"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG",
            "SEP","OCT","NOV","DEC"};
            public OCReport(Hashtable htbFilterParams) {
                this.htbFilterParams = htbFilterParams;
            }
            
            public JFreeReport getReport() throws Exception{
                String strTextDateFrom = getFromDate();
                String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
                strTextDateTo = SharedUtils.getToDate( strTextDateTo );
                String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
                String type = "Query: 'Orders - Commissions'\n";
                String rep_date_interval = "    date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO);
                String producer = "produced by user: " + SharedUtils.strUsername;
                
                
                
                
                
                // select orders for that period
                String sql = "select " +
                        " pay_date, v_nr,prv1_idnt, prv1_comm, " +
                        " prv2_idnt, prv2_comm, prv3_idnt, prv3_comm, neto_sum, totl_sum " +
                        " from vorgang " +
                        " where (v_nr NOT IN (SELECT invoiceid FROM vorgang WHERE doc_type_idnt = 2)) " +
                        
                        " AND doc_type_idnt=1 " +
                        " AND pay_sum>=totl_sum" +
                        " AND pay_sum>0 " +
                        " AND pay_date>='" + strTextDateFrom + "'" +
                        " AND pay_date<'" + strTextDateTo + "'" +
                        " order by pay_date asc, v_nr asc";
                System.out.println(sql);
                Connection conn = null;
                ArrayList orders = new ArrayList();
                try {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while(rs.next()) {
                        ArrayList row = new ArrayList();
                        Timestamp tmsp = rs.getTimestamp(1);
                        String strDate = DateUtils.ddmmyyy_hhmmss(tmsp);
                        row.add( strDate );
                        row.add(rs.getString(2));
                        row.add(rs.getString(3));
                        row.add(rs.getString(4));
                        row.add(rs.getString(5));
                        row.add(rs.getString(6));
                        row.add(rs.getString(7));
                        row.add(rs.getString(8));
                        row.add( new Float( (float)SharedUtils.round( rs.getFloat(9), 2 ) ) );
                        row.add( new Float(rs.getFloat(10)) );
                        orders.add(row);
                    }
                    rs.close();
                    stm.close();
                } catch(Exception e) {
                    e.printStackTrace();
                } finally {
                    SharedUtils.closeConnection(conn);
                }
                //get persons
                HashMap personNames = new HashMap();
                sql = constructSqlForCommissionEnquiries( strTextDateFrom,
                        strTextDateTo, (String)htbFilterParams.get("person") );
                //System.out.println(sql);
                try {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while(rs.next()) {
                        String id = rs.getString(1);
                        String name1 = rs.getString("prsn_fnam");
                        String name2 = rs.getString("prsn_lnam");
                        String name = "";
                        if( name1 != null && !name1.trim().equals("") &&
                                name2 != null && !name2.trim().equals("") ) {
                            name = name1.trim() + " , " + name2.trim();
                        } else if( name1!=null && !name1.trim().equals("") ) {
                            name = name1.trim();
                        } else if( name2!=null && !name2.trim().equals("") ) {
                            name = name2.trim();
                        }
                        personNames.put( id, name );
                    }
                    rs.close();
                    stm.close();
                } catch(Exception e) {
                    e.printStackTrace();
                } finally {
                    SharedUtils.closeConnection(conn);
                }
                //
                ArrayList result = new ArrayList();
                for( int i = 0; i < orders.size(); i++ ) {
                    ArrayList order = (ArrayList)orders.get(i);
                    String date = (String)order.get(0);
                    String v_nr = (String)order.get(1);
                    String prv1_idnt = (String)order.get(2);
                    String prv1_comm = (String)order.get(3);
                    String prv2_idnt = (String)order.get(4);
                    String prv2_comm = (String)order.get(5);
                    String prv3_idnt = (String)order.get(6);
                    String prv3_comm = (String)order.get(7);
                    Float netto = (Float)order.get(8);
                    String person1Name = (String)personNames.get(prv1_idnt);
                    String person2Name = (String)personNames.get(prv2_idnt);
                    String person3Name = (String)personNames.get(prv3_idnt);
                    
                    if( netto.floatValue() == 0 ) {
                        orders.remove(i);
                        i--;
                        continue;
                    }
                    
                    if( person1Name == null &&
                            person2Name == null &&
                            person3Name == null ) {
                        orders.remove(i);
                        i--;
                        continue;
                    }
                    
                    // add main row
                    ArrayList orderRow = new ArrayList();
                    orderRow.add( (i+1) + ")" );
                    orderRow.add(date);
                    orderRow.add(v_nr);
                    orderRow.add("");
                    orderRow.add(SharedUtils.formatFloat( "" + netto, '.' ));
                    
                    boolean bAdd = false;
                    ArrayList prov1Row = new ArrayList();
                    float comm = Float.parseFloat(prv1_comm) * netto.floatValue() * 0.01f;
                    if( comm > 0 && person1Name != null ) {
                        prov1Row.add("");
                        prov1Row.add("");
                        prov1Row.add("");
                        prov1Row.add(personNames.get(prv1_idnt));
                        prov1Row.add( SharedUtils.formatFloat( "" + comm, '.' ) );
                        bAdd = true;
                    }
                    
                    ArrayList prov2Row = new ArrayList();
                    comm = Float.parseFloat(prv2_comm) * netto.floatValue() * 0.01f;
                    if( comm > 0 && person2Name != null ) {
                        prov2Row.add("");
                        prov2Row.add("");
                        prov2Row.add("");
                        prov2Row.add(personNames.get(prv2_idnt));
                        prov2Row.add( SharedUtils.formatFloat( "" + comm, '.' ) );
                        bAdd = true;
                    }
                    
                    ArrayList prov3Row = new ArrayList();
                    if( prv3_idnt != null && person3Name != null ) {
                        comm = Float.parseFloat(prv3_comm) * netto.floatValue() * 0.01f;
                        if( comm > 0 ) {
                            prov3Row.add("");
                            prov3Row.add("");
                            prov3Row.add("");
                            prov3Row.add(personNames.get(prv3_idnt));
                            prov3Row.add( SharedUtils.formatFloat( "" + comm, '.' ) );
                            bAdd = true;
                        }
                    }
                    
                    if( bAdd ) {
                        result.add(orderRow);
                        if( prov1Row.size() > 0 )
                            result.add(prov1Row);
                        if( prov2Row.size() > 0 )
                            result.add(prov2Row);
                        if( prov3Row.size() > 0 )
                            result.add(prov3Row);
                    } else {
                        orders.remove(i);
                        i--;
                    }
                }
                orders = null;
                personNames = null;
                
                ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
                OCReportData rep = new OCReportData(top);
                int count = 0;
                
                for( int i = 0; i < result.size(); i++ ) {
                    count ++;
                    ArrayList row = (ArrayList)result.get(i);
                    
                    OCData rep_data = new OCData(row.get(0).toString(),
                            row.get(1).toString(), row.get(2).toString(),
                            row.get(3).toString(), row.get(4).toString());
                    rep.addData(rep_data);
                }
                if(count==0){
                    
                    OCData rep_data = new OCData("","","","", "");
                    rep.addData(rep_data);
                }
                OCTableModel tm = new OCTableModel();
                tm.addReport(rep);
                OCPrintUtils spUtils = new OCPrintUtils(tm,"/medstore/print/reports/commissions/report.xml","Orders - Commissions");
                return spUtils.createReport();
                
            }
            private String getFromDate(){
                String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
                String dateFields[] = strTextDateFrom.split("\\.");
                strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
                return strTextDateFrom;
            }
            
            private String constructSqlForCommissionEnquiries( String strTextDateFrom, String strTextDateTo, String clientId ) {
                String constraint = "";
                if( clientId != null )
                    constraint = " and prsn_key=" + clientId;
                String sql = "SELECT distinct prsn_key, prsn_lnam , prsn_fnam " +
                        " FROM BASE_PRSN,VORGANG " +
                        " WHERE " +
                        " prsn_key in( VORGANG.prv1_idnt, VORGANG.prv2_idnt, VORGANG.prv3_idnt ) " +
                        " AND VORGANG.doc_type_idnt=1 AND VORGANG.pay_date>='" + strTextDateFrom + "'" +
                        " AND VORGANG.pay_date<'" + strTextDateTo + "'" + constraint +
                        " order by prsn_lnam asc ";
                
                return sql;
            }
}
