package medstore.print.reports.commissions.personcommperoffer;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Hashtable;
import medstore.CommissionQueryFilter;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class PCPOReport implements SharedConstants{
    private Hashtable htbFilterParams;
    
    public PCPOReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
        String strYear = (String)htbFilterParams.get(YEAR_FILTER_VALUE);
        String strMonth = (String)htbFilterParams.get(MONTH_FILTER_VALUE);
        String strTextDateFrom = strMonth + ".01." + strYear;
        String strTextDateTo = SharedUtils.getToDate("31." + strMonth +"." + strYear);
        
        String rep_date = strMonth + "." + strYear;
        
        String sql = "     SELECT                " +
                "          prsn_key,            " +
                "          prsn_appl,            " +
                "          prsn_fnam,            " +
                "          prsn_lnam,            " +
                "          prsn_city,            " +
                "          city_code,            " +
                "          prsn_strt,            " +
                "          cntr_name,            " +
                "          type_abbr,            " +
                "          prsn_key_rel,         " +
                "          prsn_fnam_rel,        " +
                "          prsn_lnam_rel,        " +
                "          prsn_city_rel,        " +
                "          city_code_rel,        " +
                "          prsn_strt_rel,        " +
                "          cntr_name_rel,        " +
                "          pay_date,            " +
                "          v_nr,                 " +
                "          neto_sum,             " +
                "          comm,                 " +
                "          comm_sum,             " +
                "          invc_addr             " +
                " FROM     groupPersonComm " +
                " WHERE    (v_nr NOT IN (SELECT invoiceid FROM vorgang WHERE doc_type_idnt = 2)) " +
                " AND comm > 0 " +
                " AND pay_sum>=totl_sum" +
                " AND pay_sum>0 " +
                " AND pay_date>='" + strTextDateFrom + "'" +
                " AND pay_date<'" + strTextDateTo + "'";
        if(htbFilterParams.get("person")!=null){
            sql+=" AND prsn_key= " + htbFilterParams.get("person");
        }
        sql+= " order by type_abbr asc, prsn_lnam asc, prsn_key, v_nr asc";
        //System.out.println(sql);
        Connection conn = null;
        ReportTop top = new ReportTop(rep_date, "", "", "");
        PCPOReportData rep = new PCPOReportData(top);
        int count = 0;
        try {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(sql);
            while(rs.next()) {
                count++;
                String prsn_key = rs.getString("prsn_key");
                prsn_key = rs.wasNull() || prsn_key.trim().length()<=0 ? "" : prsn_key;
                
                String sol = rs.getString("prsn_appl");
                sol = rs.wasNull() || sol.trim().length()<=0 ? "" : sol + "\n";
                
                String fname = rs.getString("prsn_fnam");
                fname =  rs.wasNull() || fname.trim().length()<=0 ? sol : sol + fname + ", ";
                
                String lname = rs.getString("prsn_lnam");
                lname =  rs.wasNull() || lname.trim().length()<=0 ? "" : lname;
                
                String name = fname + lname;
                
                String usertype = rs.getString("type_abbr");
                usertype = rs.wasNull() || usertype.trim().length()<=0 ? "" : "\n" + usertype;
                
                String prsn_strt = rs.getString("prsn_strt");
                prsn_strt = rs.wasNull() || prsn_strt.trim().length()<=0 ? "" : "\n" + prsn_strt;
                
                String city_code = rs.getString("city_code");
                city_code = rs.wasNull() || city_code.trim().length()<=0 ? "" : city_code;
                
                String prsn_city = rs.getString("prsn_city");
                prsn_city = rs.wasNull() || prsn_city.trim().length()<=0 ? city_code : city_code + " " + prsn_city;
                
                String cntr_name = rs.getString("cntr_name");
                cntr_name = rs.wasNull() || cntr_name.trim().length()<=0 ? "\n" + prsn_city : "\n" + cntr_name + ", " + prsn_city;
                
                name+= usertype + prsn_strt + cntr_name;
                
                String date = DateUtils.ddmmyyy(rs.getTimestamp("pay_date"));
                date = rs.wasNull() ? "" : date;
                
                String ordno = rs.getString("v_nr");
                ordno = rs.wasNull() ? "" : ordno;
                
                String netto = rs.getString("neto_sum");
                netto = rs.wasNull() ? "0" : netto;
                
                String percent = rs.getString("comm");
                percent = rs.wasNull() ? "" : percent;
                
                String sum = rs.getString("comm_sum");
                sum = rs.wasNull() ? "" : sum;
                
                String prsn_key_rel = rs.getString("prsn_key_rel");
                prsn_key_rel = rs.wasNull() ? "" : prsn_key_rel;
                
                
                String prsn_fnam_rel = rs.getString("prsn_fnam_rel");
                prsn_fnam_rel =  rs.wasNull() || prsn_fnam_rel.trim().length()<=0 ? "" : prsn_fnam_rel + ", ";
                
                String prsn_lnam_rel = rs.getString("prsn_lnam_rel");
                prsn_lnam_rel =  rs.wasNull() || prsn_lnam_rel.trim().length()<=0 ? "" : prsn_lnam_rel;
                
                String name_rel = prsn_fnam_rel + prsn_lnam_rel;
                
                String city_code_rel = rs.getString("city_code_rel");
                city_code_rel =  rs.wasNull() || city_code_rel.trim().length()<=0 ? "" : city_code_rel;
                
                String prsn_city_rel = rs.getString("prsn_city_rel");
                prsn_city_rel =  rs.wasNull() || prsn_city_rel.trim().length()<=0 ? "" : prsn_city_rel;
                
                String cntr_name_rel = rs.getString("cntr_name_rel");
                cntr_name_rel =  rs.wasNull() || cntr_name_rel.trim().length()<=0 ? "" : cntr_name_rel;
                
                String prsn_strt_rel = rs.getString("prsn_strt_rel");
                prsn_strt_rel =  rs.wasNull() || prsn_strt_rel.trim().length()<=0 ? "" : prsn_strt_rel;
                
                String invc_addr = rs.getString("invc_addr");
                invc_addr =  rs.wasNull() || invc_addr.trim().length()<=0 ? "" : invc_addr;
                invc_addr = invc_addr.replaceAll("\r\n", ", ").trim();
                invc_addr = invc_addr.replaceAll("\n", ", ").trim();
                name_rel += " " + cntr_name_rel + "-" + city_code_rel + " " + prsn_city_rel + " " + prsn_strt_rel;
                
                PCPOData rep_data = new PCPOData(prsn_key, name, usertype, date, ordno, netto, percent, sum,prsn_key_rel, name_rel, invc_addr);
                rep.addData(rep_data);
                
            }
            rs.close();
            stm.close();
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(conn);
        }
        
        
        if(count==0){
            PCPOData rep_data = new PCPOData("", "", "",  "", "", "0", "0", "0", "", "", "");
            rep.addData(rep_data);
        }
        PCPOTableModel tm = new PCPOTableModel();
        tm.addReport(rep);
        PCPOPrintUtils spUtils = new PCPOPrintUtils(tm,"/medstore/print/reports/commissions/personcommperoffer/report.xml","Orders - Commissions by person");
        return spUtils.createReport();
        
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
    
    private String constructSqlForCommissionEnquiries( String strTextDateFrom, String strTextDateTo, String clientId ) {
        String constraint = "";
        if( clientId != null )
            constraint = " and prsn_key=" + clientId;
        String sql = "SELECT distinct prsn_key, prsn_lnam , prsn_fnam " +
                " FROM BASE_PRSN,VORGANG " +
                " WHERE " +
                " prsn_key in( VORGANG.prv1_idnt, VORGANG.prv2_idnt, VORGANG.prv3_idnt ) " +
                " AND VORGANG.doc_type_idnt=1 AND VORGANG.pay_date>='" + strTextDateFrom + "'" +
                " AND VORGANG.pay_date<'" + strTextDateTo + "'" + constraint +
                " order by prsn_lnam asc ";
        // System.out.println(sql);
        return sql;
    }
    
    public static void main(String[] args){
        try{
            new CommissionQueryFilter(new javax.swing.JFrame(), true,-1).setVisible(true);
        } catch(Exception e){
            e.printStackTrace();
        } finally{
            System.exit(0);
        }
    }
}
