package medstore.print.reports.commissionsamount;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class OCAReport implements SharedConstants{
    private Hashtable htbFilterParams;
    private String[] m_strMonths = {"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG",
            "SEP","OCT","NOV","DEC"};
            public OCAReport(Hashtable htbFilterParams) {
                this.htbFilterParams = htbFilterParams;
            }
            
            public JFreeReport getReport() throws Exception{
                String strYear = (String)htbFilterParams.get(YEAR_FILTER_VALUE);
                String strMonth = (String)htbFilterParams.get(MONTH_FILTER_VALUE);
                String strTextDateFrom = strMonth + ".01." + strYear;
                String strTextDateTo = SharedUtils.getToDate("31." + strMonth +"." + strYear);
                
                String rep_date = strMonth + "." + strYear;
                
                String sql = "select " +
                        " v_nr, prv1_idnt, prv1_comm, " +
                        " prv2_idnt, prv2_comm, prv3_idnt, prv3_comm, neto_sum, totl_sum " +
                        " from vorgang " +
                        " where (v_nr NOT IN (SELECT invoiceid FROM vorgang WHERE      doc_type_idnt = 2)) " +                     
                        " AND doc_type_idnt=1 " +
                        " AND pay_sum > 0  " +
                        " AND pay_sum>=totl_sum" +
                        " AND pay_date>='" + strTextDateFrom + "'" +
                        " AND pay_date<'" + strTextDateTo + "'";
                
                System.out.println(sql);
                Connection conn = null;
                HashMap personCommMap = new HashMap();
                try {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    while(rs.next()) {
                        String v_nr = rs.getString(1);
                        String prv1_idnt = rs.getString(2);
                        String prv1_comm = rs.getString(3);
                        String prv2_idnt = rs.getString(4);
                        String prv2_comm = rs.getString(5);
                        String prv3_idnt = rs.getString(6);
                        String prv3_comm = rs.getString(7);
                        float  neto_sum = rs.getFloat(8);
                        
                        float comm = Float.parseFloat(prv1_comm) * neto_sum * 0.01f;
                        if( comm > 0 ) {
                            Float allComm = (Float)personCommMap.get(prv1_idnt);
                            if( allComm == null )
                                personCommMap.put( prv1_idnt, new Float(comm) );
                            else
                                personCommMap.put( prv1_idnt, new Float( comm + allComm.floatValue() ) );
                        }
                        
                        
                        comm = Float.parseFloat(prv2_comm) * neto_sum * 0.01f;
                        if( comm > 0 ) {
                            Float allComm = (Float)personCommMap.get(prv2_idnt);
                            if( allComm == null )
                                personCommMap.put( prv2_idnt, new Float(comm) );
                            else
                                personCommMap.put( prv2_idnt, new Float( comm + allComm.floatValue() ) );
                        }
                        
                        if( prv3_idnt == null )
                            continue;
                        
                        comm = Float.parseFloat(prv3_comm) * neto_sum * 0.01f;
                        if( comm > 0 ) {
                            Float allComm = (Float)personCommMap.get(prv3_idnt);
                            if( allComm == null )
                                personCommMap.put( prv3_idnt, new Float(comm) );
                            else
                                personCommMap.put( prv3_idnt, new Float( comm + allComm.floatValue() ) );
                        }
                    }
                    rs.close();
                    stm.close();
                } catch(Exception e) {
                    e.printStackTrace();
                } finally {
                    SharedUtils.closeConnection(conn);
                }
                ArrayList data = new ArrayList();
                sql = constructSqlForCommissionEnquiries( strTextDateFrom,                        
                        strTextDateTo, (String)htbFilterParams.get("person") );
                
                try {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(sql);
                    int num = 1;
                    while(rs.next()) {
                        String prsn_key = rs.getString("prsn_key");
                        String type_abbr = rs.getString("type_abbr");
                        String adr = rs.getString("adr");
                        String id = rs.getString(1);
                        String name = rs.getString("prsn_lnam");
                        
                        
                        Float comm = (Float)personCommMap.get(id);
                        if( comm != null ) {
                            ArrayList row = new ArrayList();
                            row.add( prsn_key );
                            row.add(type_abbr);
                            row.add( name.toUpperCase() );
                            row.add(adr);
                            row.add( SharedUtils.formatFloat( comm.floatValue() + "", '.' ) );
                            data.add(row);
                        }
                    }
                    rs.close();
                    stm.close();
                } catch(Exception e) {
                    e.printStackTrace();
                } finally {
                    SharedUtils.closeConnection(conn);
                }
                
                ReportTop top = new ReportTop(rep_date, "", "", "");
                OCAReportData rep = new OCAReportData(top);
                int count = 0;
                for( int i = 0; i < data.size(); i++ ) {
                    count++;
                    ArrayList row = (ArrayList)data.get(i);
                    
                    OCAData rep_data = new OCAData(row.get(0).toString(), row.get(1).toString(), row.get(2).toString(), row.get(3).toString(), row.get(4).toString());
                    
                    rep.addData(rep_data);
                }
                if(count==0){
                    OCAData rep_data = new OCAData("","","", "", "0");
                    rep.addData(rep_data);
                }
                OCATableModel tm = new OCATableModel();
                tm.addReport(rep);
                OCAPrintUtils spUtils = new OCAPrintUtils(tm,"/medstore/print/reports/commissionsamount/report.xml","Commissions by period");
                return spUtils.createReport();
                
            }
            private String getFromDate(){
                String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
                String dateFields[] = strTextDateFrom.split("\\.");
                strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
                return strTextDateFrom;
            }
            
            private String constructSqlForCommissionEnquiries( String strTextDateFrom, String strTextDateTo, String clientId ) {
                String constraint = "";
                if( clientId != null )
                    constraint = " and prsn_key=" + clientId;
                String sql = "SELECT distinct prsn_key, prsn_lnam , prsn_fnam, (base_prsn.city_code + ' ' + base_prsn.prsn_city) as adr , base_prsn_type.type_abbr " +
                        " FROM BASE_PRSN INNER JOIN base_prsn_type ON base_prsn.type_idnt = dbo.base_prsn_type.type_key ,VORGANG " +
                        " WHERE " +
                        " prsn_key in( VORGANG.prv1_idnt, VORGANG.prv2_idnt, VORGANG.prv3_idnt ) " +
                        " AND VORGANG.doc_type_idnt=1 AND VORGANG.pay_date>='" + strTextDateFrom + "'" +
                        " AND VORGANG.pay_date<'" + strTextDateTo + "'" + constraint +
                        " order by base_prsn_type.type_abbr desc, prsn_lnam ";
                return sql;
            }
}
