package medstore.print.reports.commissionsamount;
import java.util.ArrayList;
import medstore.SharedUtils;
import medstore.math.BigDec;
import medstore.print.reports.ReportTop;

public class OCAReportData extends ReportTop{
    private ArrayList rowdata;
    private ArrayList rowdataCounts;
    private float fSumNetto = 0, 
            fSumPorto = 0, 
            fSumVAT = 0, 
            fSumTotal = 0;
    
    public OCAReportData(ReportTop top) {
        super(top.getReportDate(), top.getReportType(), top.getReportDateInterval(), top.getReportProducer());
        rowdata = new ArrayList();
        rowdataCounts = new ArrayList();
    }
    
    public synchronized void addData( OCAData data) {
        
        
            
            rowdata.add(data);
            rowdataCounts.add(new Integer(1));
        
    }
    
    public synchronized void removeData(final OCAData data) {
        final int index = rowdata.indexOf(data);
        if (index != -1) {
            final Integer oldCount = (Integer) rowdataCounts.get(index);
            if (oldCount.intValue() == 1) {
                rowdataCounts.remove(index);
                rowdata.remove(index);
            } else {
                rowdataCounts.set(index, new Integer(oldCount.intValue() - 1));
            }
        }        
    }
    public synchronized void setData(ArrayList rowdata){
        for(int i = 0; i<rowdata.size(); i++){
            addData((OCAData)rowdata.get(i));
        }
    }
    
    public OCAData getData(final int index) {
        return (OCAData) rowdata.get(index);
    }
    
    public int getDataCount(final int index) {
        final Integer i = (Integer) rowdataCounts.get(index);
        return i.intValue();
    }
    
    public int getDataCount() {
        return rowdata.size();
    }    
}
