package medstore.print.reports.daily;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class ODayReport implements SharedConstants{
    private Hashtable htbFilterParams;
    
    public ODayReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
        String strTextDateFrom = getFromDate();
        String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
        strTextDateTo = SharedUtils.getToDate( strTextDateTo );
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Number of orders(Daily)'\n";
        String rep_date_interval = "date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO);
        String producer = "produced by user: " + SharedUtils.strUsername;
        
        
        
        ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
        ODayReportData rep = new ODayReportData(top);
        String strSQL = " SELECT REPLACE(CONVERT(char(10), invc_date, 105),'-','.') AS invc_date, COUNT(v_nr) AS v_nr " + 
                        " from vorgang " +
                        "where " +                        
                        " invc_date>='" + strTextDateFrom + "'" +
                        " AND invc_date<'" + strTextDateTo + "'" +
                        " AND doc_type_idnt=1 " + //only invoices
                        " GROUP BY REPLACE(CONVERT(char(10), invc_date, 105),'-','.')" + 
                        " order by invc_date ASC, v_nr asc";   
                
                
        Connection conn = null;
        int count = 0;
        try {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(strSQL);
            
            float fSumNetto = 0, 
            fSumPorto = 0, 
            fSumVAT = 0, 
            fSumTotal = 0;
            
            while( rs.next() ) {
                count++;
                
                String ordercount = rs.getString("v_nr").trim();
                SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy");
                String datetime = rs.getString("invc_date");
                
                ODayData rep_data = new ODayData(count + ")", datetime, ordercount);
                rep.addData(rep_data);
                
            }
            
            
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(conn);
        }
        if(count==0)
            rep.addData(new ODayData("", "", ""));
        
        
        ODayTableModel tm = new ODayTableModel();
        tm.addReport(rep);
        ODayPrintUtils spUtils = new ODayPrintUtils(tm,"/medstore/print/reports/daily/report.xml","Number of orders(Daily)");
        return spUtils.createReport();
        
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
}
