package medstore.print.reports.inventory.checkout;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.HashSet;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import medstore.print.reports.inventory.stockonhandtotal.SOHTData;
import medstore.print.reports.inventory.stockonhandtotal.SOHTPrintUtils;
import medstore.print.reports.inventory.stockonhandtotal.SOHTReportData;
import medstore.print.reports.inventory.stockonhandtotal.SOHTTableModel;
import org.jfree.report.JFreeReport;



public class COutReport implements SharedConstants{
    private Hashtable htbFilterParams;
    
    public COutReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
        
        
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Inventory CheckOut'\n"+"produced by user: " + SharedUtils.strUsername;
        String rep_date_interval = "";
        String producer = "";//"produced by user: " + SharedUtils.strUsername;
        
        
        
        ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
        SOHTReportData rep = new SOHTReportData(top);
        
        String strSQL = " " +
                " SELECT STCK_BRCD, STCK_NAME, STOR_NAME,CONN_STCK_IN_STOR.STCK_CNT  " +
                " FROM BASE_STCK " +
                "   INNER JOIN CONN_STCK_IN_STOR ON  (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT) " +
                "   INNER JOIN BASE_STOR ON CONN_STCK_IN_STOR.STOR_IDNT = BASE_STOR.STOR_KEY " +
                " where CONN_STCK_IN_STOR.STCK_CNT>0 and " +
                "       base_stck.composite = 1 " +
                " ORDER BY STCK_BRCD,STOR_NAME ";
        
        Connection conn = null;
        int count = 0;
        try {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(strSQL);
            
            HashSet vnrs = new HashSet();
            while( rs.next() ) {
                count++;
                String barcode = rs.getString("STCK_BRCD");
                String stockname = rs.getString("STCK_NAME");
                String storename = rs.getString("STOR_NAME");
                String stockcount = rs.getString("STCK_CNT");
                
                SOHTData rep_data = new SOHTData(barcode, stockname, storename, stockcount);
                rep.addData(rep_data);                
            }
            
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(conn);
        }
        if(count==0)
            rep.addData(new SOHTData("", "", "", ""));
        
        
        SOHTTableModel tm = new SOHTTableModel();
        tm.addOrderHistoryReport(rep);
        SOHTPrintUtils spUtils = new SOHTPrintUtils(tm,"/medstore/print/reports/inventory/checkout/report.xml","Inventory CheckOut");        
        return spUtils.createReport();
        
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
}
