package medstore.print.reports.inventory.checkoutdiff;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.HashSet;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import medstore.print.reports.inventory.stockonhandtotal.SOHTData;
import medstore.print.reports.inventory.stockonhandtotal.SOHTPrintUtils;
import medstore.print.reports.inventory.stockonhandtotal.SOHTReportData;
import medstore.print.reports.inventory.stockonhandtotal.SOHTTableModel;
import org.jfree.report.JFreeReport;



public class COutDiffReport implements SharedConstants{
    private Hashtable htbFilterParams;
    
    public COutDiffReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
        
        
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Inventory CheckOut Differencies'\n"+"produced by user: " + SharedUtils.strUsername;
        String rep_date_interval = "";
        String producer = "";//"produced by user: " + SharedUtils.strUsername;
        
        
        
        ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
        SOHTReportData rep = new SOHTReportData(top);
        
        String strSQL = " SELECT STOR_NAME, STCK_NAME,STCK_BRCD,CONN_STCK_IN_STOR.STCK_CNT," +
                " CONN_STCK_IN_STOR.STCK_IVTR, (CONN_STCK_IN_STOR.STCK_CNT - CONN_STCK_IN_STOR.STCK_IVTR) AS DIFF " +
                " FROM BASE_STCK INNER JOIN CONN_STCK_IN_STOR ON " +
                " (BASE_STCK.STCK_KEY = CONN_STCK_IN_STOR.STCK_IDNT)" +
                " INNER JOIN BASE_STOR ON CONN_STCK_IN_STOR.STOR_IDNT = BASE_STOR.STOR_KEY";
        String strWhereClause = " where base_stck.composite = 1 ";
        String strOrderClause = " ORDER BY STOR_NAME,STCK_BRCD";
        strSQL =  strSQL + strWhereClause + strOrderClause;
        
        Connection conn = null;
        int count = 0;
        try {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(strSQL);
            
            HashSet vnrs = new HashSet();
            while( rs.next() ) {
                count++;
                String barcode = rs.getString("STCK_BRCD");
                String stockname = rs.getString("STCK_NAME");
                String storename = rs.getString("STOR_NAME");
                String stockcount = rs.getString("STCK_CNT");
                String checkout = rs.getString("STCK_IVTR");
                String diff = rs.getString("DIFF");
                
                SOHTData rep_data = new SOHTData(barcode, stockname, storename, stockcount, checkout, diff);
                rep.addData(rep_data);
            }
            
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(conn);
        }
        if(count==0)
            rep.addData(new SOHTData("", "", "", "", "", ""));
        
        
        SOHTTableModel tm = new SOHTTableModel();
        tm.addOrderHistoryReport(rep);
        SOHTPrintUtils spUtils = new SOHTPrintUtils(tm,"/medstore/print/reports/inventory/checkoutdiff/report.xml","Inventory CheckOut Differencies");
        return spUtils.createReport();
        
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
}
