package medstore.print.reports.inventory.movmentrevision;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class MRevReport implements SharedConstants{
    private Hashtable htbFilterParams;
    
    public MRevReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
        String strTextDateFrom = getFromDate();
        String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
        strTextDateTo = SharedUtils.getToDate( strTextDateTo );
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Movement Revision'\n";
        String rep_date_interval = "date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO);
        String producer = "produced by user: " + SharedUtils.strUsername;
        
        
        
        ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
        MRevReportData rep = new MRevReportData(top);
        
        String strSQL = " SELECT  BASE_EVNT.EVNT_DATE,BASE_STOR.STOR_NAME,BASE_OPER.OPER_NAME," +
                " BASE_STCK.STCK_NAME,CONN_STCK_IN_EVNT.STCK_CNT " +
                " FROM    BASE_EVNT INNER JOIN BASE_OPER ON(BASE_EVNT.OPER_IDNT = BASE_OPER.OPER_KEY)" +
                " INNER JOIN CONN_STCK_IN_EVNT ON(CONN_STCK_IN_EVNT.EVNT_IDNT = BASE_EVNT.EVNT_KEY)" +
                " INNER JOIN BASE_STCK ON(CONN_STCK_IN_EVNT.STCK_IDNT = BASE_STCK.STCK_KEY)" +
                " INNER JOIN BASE_STOR ON(BASE_EVNT.STOR_IDNT = BASE_STOR.STOR_KEY)";
        
        String strWhereClause = " WHERE  " +
                "   base_stck.composite = 1 and " +
                "   EVNT_DATE >='" +
                strTextDateFrom + "' AND " +
                " EVNT_DATE <'" + strTextDateTo + "'";
        String strOrderClause = " ORDER BY EVNT_DATE DESC ";
        strSQL =  strSQL + strWhereClause + strOrderClause;
        
        Connection conn = null;
        int count = 0;
        
        try {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs=stm.executeQuery(strSQL);
            ResultSetMetaData resultsMetaData = rs.getMetaData();
            
            boolean more = rs.next();
            
            while( more ) {
                count++;
                
                SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy hh:mm:ss");                
                
                String date = sdf.format(rs.getTimestamp("EVNT_DATE"));
                String storename = rs.getString("STOR_NAME");
                String operation = rs.getString("OPER_NAME");
                String stockname = rs.getString("STCK_NAME");
                String stockcount = rs.getString("STCK_CNT");
                
                MRevData rep_data = new MRevData(count + ")", date, storename, operation, stockname, stockcount);
                rep.addItemData(rep_data);
                more = rs.next();
            }
            rs.close();
            stm.close();
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(conn);
        }
        if(count==0)
            rep.addItemData(new MRevData("", "", "", "", "", ""));
        
        
        MRevTableModel tm = new MRevTableModel();
        tm.addReport(rep);
        MRevPrintUtils spUtils = new MRevPrintUtils(tm,"/medstore/print/reports/inventory/movmentrevision/report.xml","Movement Revision");
        return spUtils.createReport();
        
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
}
