package medstore.print.reports.inventory.stockonhandtotal;

import java.lang.reflect.Array;
import java.util.ArrayList;
import medstore.print.reports.ReportTop;

public class SOHTReportData extends ReportTop{
    private ArrayList rowdata;
    private ArrayList rowdataCounts;
    
    public SOHTReportData(ReportTop top) {
        super(top.getReportDate(), top.getReportType(), top.getReportDateInterval(), top.getReportProducer());
        rowdata = new ArrayList();
        rowdataCounts = new ArrayList();
    }
    
    public synchronized void addData( SOHTData data) {
        final int index = rowdata.indexOf(data);
        if (index == -1) {
            rowdata.add(data);
            rowdataCounts.add(new Integer(1));
        } else {
            final Integer oldCount = (Integer) rowdataCounts.get(index);
            rowdataCounts.set(index, new Integer(oldCount.intValue() + 1));
        }
    }
    
    public synchronized void removeData(final SOHTData data) {
        final int index = rowdata.indexOf(data);
        if (index != -1) {
            final Integer oldCount = (Integer) rowdataCounts.get(index);
            if (oldCount.intValue() == 1) {
                rowdataCounts.remove(index);
                rowdata.remove(index);
            } else {
                rowdataCounts.set(index, new Integer(oldCount.intValue() - 1));
            }
        }
    }
    public synchronized void setData(ArrayList rowdata){
        for(int i = 0; i<rowdata.size(); i++){
            addData((SOHTData)rowdata.get(i));
        }
    }
    
    public SOHTData getData(final int index) {
        return (SOHTData) rowdata.get(index);
    }
    
    public int getDataCount(final int index) {
        final Integer i = (Integer) rowdataCounts.get(index);
        return i.intValue();
    }
    
    public int getDataCount() {
        return rowdata.size();
    }
}
