package medstore.print.reports.inventory.timetopurchase;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Hashtable;
import javax.swing.table.TableModel;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.UniversalTableModel;
import medstore.print.DateUtils;
import medstore.print.reports.OPrintUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;





public class TTPReport implements SharedConstants{
    private Hashtable htbFilterParams;
    private TableModel table;
    private ReportTop top;
    public TTPReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
        
    }
    
    public JFreeReport getReport() throws Exception{
        
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Time to purchase'\n";
        String rep_date_interval = "percent of stock limit: " + (String)htbFilterParams.get(LIMIT_PERSENT);
        String producer = "produced by user: " + SharedUtils.strUsername;
        
        top = new ReportTop(rep_date, type, rep_date_interval, producer);
        
        ArrayList data = handleTimeToPurchase();
        
        table = new TTPTableModel(data);
        
        OPrintUtils spUtils = new OPrintUtils(table,"/medstore/print/reports/inventory/timetopurchase/report.xml","Time to purchase");
        final JFreeReport report = spUtils.createReport();
        return report;
        
        
    }
    
    private ArrayList handleTimeToPurchase(){
        
        String strPersent = (String)htbFilterParams.get(LIMIT_PERSENT);
        int nPersent = Integer.parseInt(strPersent);
        final int STOCK_NAME_INDEX=0;
        final int STOCK_BARCODE_INDEX=1;
        final int STOCK_CSUM_INDEX=2;
        final int STOCK_LIMIT_INDEX=3;
        final int STOCK_CNTN_BARCODE_INDEX=4;
        final int STOCK_KEY=5;
        String strTableSQL = "SELECT PCKG_NAME,PCKG_BRCD,(PCKG_ONHN*PCKG_PCNT) AS CSUM,PCKG_LIMT,CNTN_BRCD,PCKG_KEY FROM VIEW_STCK_CNT where composite = 1 order by PCKG_NAME";
        String str_rgn_columns[] = {"Stock Name","Barcode","On Hand","Limit + " + strPersent + "%" };
        try {
            Connection connDB = SharedUtils.getConnection();
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strTableSQL);
            UniversalTableModel tbmAllStocks = new UniversalTableModel(rsDBData,str_rgn_columns);
            tbmAllStocks.convertStringToInt(STOCK_CSUM_INDEX);
            int nRowCount = tbmAllStocks.getRowCount();
            for(int i=0; i < nRowCount; i++ ){
                String strCntnBcode = (String)tbmAllStocks.getValueAt(i, STOCK_CNTN_BARCODE_INDEX);
                String strOnHand = (String)tbmAllStocks.getValueAt(i, STOCK_CSUM_INDEX);
                if(!strCntnBcode.equals("")){
                    int nContentIndex = tbmAllStocks.getContentIndex(STOCK_BARCODE_INDEX,strCntnBcode);
                    if(nContentIndex!= -1){
                        String strCntnOnHand = (String)tbmAllStocks.getValueAt(nContentIndex, STOCK_CSUM_INDEX);
                        int nNewValue = Integer.parseInt(strCntnOnHand) + Integer.parseInt(strOnHand);
                        tbmAllStocks.setValueAt(String.valueOf(nNewValue), nContentIndex, STOCK_CSUM_INDEX);
                    }
                    
                }
            }
            for(int i=0; i < tbmAllStocks.getRowCount(); i++ ) {
                String strCntnBcode = (String)tbmAllStocks.getValueAt(i, STOCK_CNTN_BARCODE_INDEX);
                String strOnHand = (String)tbmAllStocks.getValueAt(i, STOCK_CSUM_INDEX);
                String strLimit = (String)tbmAllStocks.getValueAt(i, STOCK_LIMIT_INDEX);
                int nLimit = Integer.parseInt(strLimit);
                nLimit = nLimit + nLimit*nPersent/100;
                strLimit = String.valueOf(nLimit);
                tbmAllStocks.setValueAt(strLimit,i,STOCK_LIMIT_INDEX);
                if(strCntnBcode.compareTo("")!=0){
                    tbmAllStocks.removeItemAt(i);
                    i--;
                }else if(Integer.parseInt(strOnHand) > nLimit){
                    tbmAllStocks.removeItemAt(i);
                    i--;
                }
            }
            
            ArrayList data = new ArrayList();
            nRowCount = tbmAllStocks.getRowCount();
            for(int i=0; i < nRowCount; i++ ){
                String strStockName = (String)tbmAllStocks.getValueAt(i, STOCK_NAME_INDEX);
                String strBarcode = (String)tbmAllStocks.getValueAt(i, STOCK_BARCODE_INDEX);
                String strOnHand = (String)tbmAllStocks.getValueAt(i, STOCK_CSUM_INDEX);
                String strLimit = (String)tbmAllStocks.getValueAt(i, STOCK_LIMIT_INDEX);
                
                ArrayList row = new ArrayList();
                row.add(top.getReportDate());
                row.add(top.getReportType());
                row.add(top.getReportDateInterval());
                row.add(top.getReportProducer());
                row.add( strStockName );
                row.add( strBarcode );
                row.add( strOnHand );
                row.add( strLimit );
                row.add( strPersent );
                data.add( row );
            }
            rsDBData.close();
            stm.close();
            
            return data ;
        } catch(SQLException sqle) {
            SharedUtils.handleError(GENERAL_DB_ERROR);
        }
        return null;
    }
}
