package medstore.print.reports.monthly;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class OMonthReport implements SharedConstants{
    private Hashtable htbFilterParams;
    private String[] m_strMonths = {"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG",
            "SEP","OCT","NOV","DEC"};
            
            public OMonthReport(Hashtable htbFilterParams) {
                this.htbFilterParams = htbFilterParams;
            }
            
            public JFreeReport getReport() throws Exception{
                String year = (String)htbFilterParams.get(YEAR_FILTER_VALUE);
                year = year.substring(2);
                String strTextDateFrom = "01.01." + year;
                String strTextDateTo = "01.01." + ( Integer.parseInt(year) + 1 );
                String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
                String type = "Query: 'Number of orders(Monthly)'\n";
                String rep_date_interval = "    Year: " + "20"+year + "\n";
                String producer = "produced by user: " + SharedUtils.strUsername;
                
                
                
                ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
                OMonthReportData rep = new OMonthReportData(top);
                String strSQL = "select  invc_date,v_nr from " + 
                        " vorgang where " +
                        " invc_date>='" + strTextDateFrom + "'" +
                        " AND invc_date<'" + strTextDateTo + "'" +
                        " AND doc_type_idnt=1 " +
                        " order by invc_date ";
                
                
                Connection conn = null;
                int count = 0;
                try {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);
                    
                    
                    int num = 1;
                    int oldMonth = -1;
                    int ordersCount = 0;
                    Calendar cal = Calendar.getInstance();
                    
                    ArrayList data = new ArrayList();
                    
                    for( int i = 0; i < 12; i++ ) {
                        ArrayList entry = new ArrayList();
                        data.add(entry);
                        entry.add("" + (i+1) + ")" );
                        entry.add( m_strMonths[i] );
                        entry.add( "0" );
                    }
                    
                    while( rs.next() ) {
                        cal.setTimeInMillis( rs.getTimestamp("invc_date").getTime() );
                        int month = cal.get( Calendar.MONTH );
                        if( month == oldMonth ) {
                            ordersCount++;
                            continue;
                        }
                        
                        if( oldMonth != -1 ) {
                            ArrayList entry = (ArrayList)data.get( oldMonth );
                            entry.set( 2, "" + ordersCount );
                        }
                        ordersCount = 1;
                        oldMonth = month;
                    }
                    
                    if( oldMonth >= 0 ) {
                        ArrayList entry = (ArrayList)data.get( oldMonth );
                        entry.set( 2, "" + ordersCount );
                    }
                    
                    for( int i = 0; i < data.size(); i++ ) {
                        ArrayList entry = (ArrayList)data.get( i );
                        String datetime = entry.get(1).toString();
                        String ordercount = entry.get(2).toString();
                        OMonthData rep_data = new OMonthData((i+1) + ")", datetime, ordercount);
                        rep.addData(rep_data);
                    }
                    
                } catch(Exception e) {
                    e.printStackTrace();
                } finally {
                    SharedUtils.closeConnection(conn);
                }
                
                
                if(count==0)
                    rep.addData(new OMonthData("", "", ""));
                
                
                OMonthTableModel tm = new OMonthTableModel();
                tm.addReport(rep);
                OMonthPrintUtils spUtils = new OMonthPrintUtils(tm,"/medstore/print/reports/monthly/report.xml","Number of orders(Monthly)");
                return spUtils.createReport();
                
            }
}
