package medstore.print.reports.orderhistoryitems;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class OHIReport implements SharedConstants{
    private Hashtable htbFilterParams;
    
    public OHIReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
        String strTextDateFrom = getFromDate();
        String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
        strTextDateTo = SharedUtils.getToDate( strTextDateTo );
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Orders History Items'\n";
        String rep_date_interval = "date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO);
        String producer = "produced by user: " + SharedUtils.strUsername;
        
        
        
        ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
        OHIReportData rep = new OHIReportData(top);
        
        String strSQL = "SELECT invc_date,STCK_NAME,STCK_BRCD," +
                                "STCK_CNT " +
                                " FROM order_history_items ";
                String strWhereClause = " WHERE invc_date >='" + strTextDateFrom + "' AND " +
                                        " invc_date <'" + strTextDateTo + "'" +
                        " AND (v_nr NOT IN (SELECT invoiceid FROM vorgang WHERE      doc_type_idnt = 2)) " ;
                String strOrderClause = " ORDER BY invc_date ASC,STCK_NAME ASC ";
                strSQL =  strSQL + strWhereClause + strOrderClause;
        
        Connection conn = null;
        int count = 0;
        
        try {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs=stm.executeQuery(strSQL);
            ResultSetMetaData resultsMetaData = rs.getMetaData();
            
            boolean more = rs.next();
                        
            while( more ) {
                count++;
                String orderNum = rs.getString(1).trim();
                
                
                SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy hh:mm:ss");                
                String datetime = sdf.format(rs.getTimestamp("invc_date"));
                
                String name = rs.getString("STCK_NAME");
                String itemcount = rs.getString("STCK_CNT");
                String barcode = rs.getString("STCK_BRCD");
                
                OHIData rep_data = new OHIData(count + ")", datetime, name, barcode,itemcount);
                rep.addItemData(rep_data);
                more = rs.next();
            }
            rs.close();
            stm.close();
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(conn);
        }
        if(count==0)
            rep.addItemData(new OHIData("", "", "", "", ""));
        
        
        OHITableModel tm = new OHITableModel();
        tm.addReport(rep);
        OHIPrintUtils spUtils = new OHIPrintUtils(tm,"/medstore/print/reports/orderhistoryitems/report.xml","Orders History Items");        
        return spUtils.createReport();
        
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
}
