package medstore.print.reports.ordersdetails;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Statement;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Hashtable;
import javax.swing.table.TableModel;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.OPrintUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;





public class ODReport implements SharedConstants{
    private Hashtable htbFilterParams;
    private TableModel table;
    
    public ODReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
        
    }
    
    public JFreeReport getReport() throws Exception{
        
        String strTextDateFrom = getFromDate();
        String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
        strTextDateTo = SharedUtils.getToDate( strTextDateTo );
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Orders Details'\n";
        String rep_date_interval = "date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO);
        String producer = "produced by user: " + SharedUtils.strUsername;
        
        
        
        ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
        
        String strSQL = " SELECT distinct invc_date, V_NR,STCK_BRCD," +
                " STCK_NAME,P_MENGE,SUM_PRIC, " +
                " neto_sum, vat_pers, invc_prto, patn_dscn " +
                " FROM orders_details ";
        String strWhereClause = " WHERE  invc_date >='" +
                strTextDateFrom + "' AND " +
                " invc_date <'" + strTextDateTo + "'  " +
                " AND (v_nr NOT IN (SELECT invoiceid FROM vorgang WHERE      doc_type_idnt = 2)) " +
                " ORDER BY invc_date ASC, v_nr ASC";
        
        strSQL =  strSQL + strWhereClause;// + strOrderClause;
        //System.out.println(strSQL);
        Connection conn = null;
        ArrayList data = new ArrayList();
        try {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs=stm.executeQuery(strSQL);
            ResultSetMetaData resultsMetaData = rs.getMetaData();
            
            boolean more = rs.next();
            String strOldNo="";
            double sumTotal = 0;
            int ordcount = 0;
            int prodcount = 0;
            while( more ) {
                prodcount++;
                String orderNum = rs.getString(1).trim();
                
                SimpleDateFormat sdf = new SimpleDateFormat("dd.MM.yyyy hh:mm:ss");
                String datetime = sdf.format(rs.getTimestamp("invc_date"));
                
                String orderno = rs.getString("V_NR");
                
                String name = rs.getString("STCK_NAME");
                String barcode = rs.getString("STCK_BRCD");
                int menge = rs.getInt("P_MENGE");
                double sum_price = rs.getDouble("SUM_PRIC");
                
                double fNeto = rs.getDouble("neto_sum");
                double fVat = rs.getDouble("vat_pers");
                double fPorto = rs.getDouble("invc_prto");
                double iDiscount = rs.getDouble( "patn_dscn" );
                
                
                
                double fDiscount =  fNeto * 0.01f * iDiscount;
                double fTotal = fNeto + fPorto - fDiscount;
                fVat = fTotal * 0.01f * fVat;
                fTotal +=fVat;
                
                double total = fTotal;
                String strTotal = SharedUtils.formatFloat("" + total, '.');
                //for(int i=0; i< 400; i++){
                ArrayList row = new ArrayList();
                row.add(top.getReportDate());
                row.add(top.getReportType());
                row.add(top.getReportDateInterval());
                row.add(top.getReportProducer());
                row.add(datetime);
                row.add(orderno);
                row.add(barcode);
                row.add(name);
                row.add(String.valueOf(menge));
                row.add(String.valueOf(sum_price));
                row.add(String.valueOf(strTotal));
                if(!orderno.equals(strOldNo)) {
                    sumTotal+=total;
                    ordcount++;
                }
                strOldNo = orderno;
                String strSumTotal = SharedUtils.formatFloat("" + sumTotal, '.');
                row.add(String.valueOf(strSumTotal));
                row.add(String.valueOf(ordcount));
                row.add(String.valueOf(prodcount));
                data.add(row);
                //}
                more = rs.next();
            }
            rs.close();
            stm.close();
            if(prodcount<=0){
                ArrayList row = new ArrayList();
                row.add(top.getReportDate());
                row.add(top.getReportType());
                row.add(top.getReportDateInterval());
                row.add(top.getReportProducer());
                row.add(null);
                row.add(null);
                row.add(null);
                row.add(null);
                row.add(null);
                row.add(null);
                row.add(null);
                row.add(null);
                row.add(null);
                row.add(null);
                data.add(row);
            }
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection(conn);
        }
        
        
        
        table = new ODTableModel(data);
        
        OPrintUtils spUtils = new OPrintUtils(table,"/medstore/print/reports/ordersdetails/report.xml","Orders Details");
        final JFreeReport report = spUtils.createReport();
        return report;
        
        
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
}
