/*
 * PersonSearch.java
 *
 * Created on , 2005,  4, 18:44
 */

package medstore.print.reports.relations;
import java.awt.event.InputEvent;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.JOptionPane;
import medstore.ComboDataModel;
import medstore.ComboDataRow;
import medstore.CommonDialog;
import medstore.Main;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.UIUtils;
import medstore.UniversalTableModel;
import medstore.UniversalTableRow;

public class PersonSearch extends CommonDialog implements SharedConstants{
    public final static int PROV_GOOD_SEARCH = 5;
    
    public final static int UIN_INDEX = 0;
    public final static int NAME_INDEX = 1;
    public final static int PROV1_IDNT_INDEX = 5;
    public final static int PROV1_COMM_INDEX = 6;
    public final static int PROV2_IDNT_INDEX = 7;
    public final static int PROV2_COMM_INDEX = 8;
    /** Creates new form PersonSearch */
    private String strSelectClause;
    private Vector vecResults;
    int nSearchCriteria;
    private String str_rgn_searchFields[] = {"prsn_key","prsn_appl","type_abbr","prsn_lnam","prsn_fnam","cntr_name","prsn_city","city_code","prsn_strt"};
    
    public PersonSearch(java.awt.Frame parent, boolean modal, Vector vecResults, int nSearchCriteria ) {
        super(parent, modal);
        strSelectClause="";
        vecResults.removeAllElements();
        this.vecResults = vecResults;
        this.nSearchCriteria = nSearchCriteria;
        initComponents();
        afterInitComponents();
        translate();
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        scrPersons = new javax.swing.JScrollPane();
        tblPersons = new javax.swing.JTable();
        editKeywords = new javax.swing.JTextField();
        btnSearch = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        comboCountry = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        comboPrsType = new javax.swing.JComboBox();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Persons search");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                PersonSearch.this.windowClosed(evt);
            }
        });

        scrPersons.setFont(new java.awt.Font("Tahoma", 1, 13));
        tblPersons.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "UIN", "Name", "Type", "Country", "Address"
            }
        ));
        tblPersons.setName("tblClSearchPersons");
        tblPersons.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                PersonSearch.this.keyPressed(evt);
            }
        });
        tblPersons.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                PersonSearch.this.mousePressed(evt);
            }
        });

        scrPersons.setViewportView(tblPersons);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(5, 10, 10, 10);
        getContentPane().add(scrPersons, gridBagConstraints);

        editKeywords.setFont(new java.awt.Font("Tahoma", 0, 13));
        editKeywords.setMinimumSize(new java.awt.Dimension(260, 21));
        editKeywords.setPreferredSize(new java.awt.Dimension(260, 21));
        editKeywords.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PersonSearch.this.actionPerformed(evt);
            }
        });
        editKeywords.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                PersonSearch.this.keyPressed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(editKeywords, gridBagConstraints);

        btnSearch.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnSearch.setText("Search");
        btnSearch.setName("btnSearch");
        btnSearch.setPreferredSize(new java.awt.Dimension(73, 26));
        btnSearch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                PersonSearch.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 11);
        getContentPane().add(btnSearch, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Enter Keywords:");
        jLabel1.setName("lblEnterKeyWords");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 37;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(20, 10, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        comboCountry.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        comboCountry.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                PersonSearch.this.focusGained(evt);
            }
            public void focusLost(java.awt.event.FocusEvent evt) {
                PersonSearch.this.focusLost(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.ipadx = 92;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(comboCountry, gridBagConstraints);

        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText("Country");
        jLabel2.setName("lblOPCountry");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(20, 10, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel4.setText("Persons");
        jLabel4.setName("lblPersons");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.ipadx = 120;
        gridBagConstraints.ipady = -3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(7, 10, 0, 0);
        getContentPane().add(jLabel4, gridBagConstraints);

        comboPrsType.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.ipadx = 72;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 10);
        getContentPane().add(comboPrsType, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-619)/2, (screenSize.height-305)/2, 619, 305);
    }
    // </editor-fold>//GEN-END:initComponents
    
    private void focusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_focusLost
        if( evt.getSource() == comboCountry)
            comboCountry.hidePopup();
        
    }//GEN-LAST:event_focusLost
    
    private void focusGained(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_focusGained
        if( evt.getSource() == comboCountry)
            comboCountry.showPopup();
        
    }//GEN-LAST:event_focusGained
    
    private void keyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyPressed
        if(evt.getSource() == tblPersons){
            int selectedRow = tblPersons.getSelectedRow();
            if( evt.getKeyCode()== evt.VK_UP ) {
                if( selectedRow ==0){
                    editKeywords.requestFocus();
                    editKeywords.selectAll();
                }
            } else if( evt.getKeyCode()== evt.VK_ENTER ){
                int nRow = tblPersons.getSelectedRow();
                if(nSearchCriteria == PROV_GOOD_SEARCH){
                    try{
                        vecResults.clear();
                        vecResults.add((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow));
                    } catch(Exception e){
                        JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
                        e.printStackTrace();
                    }
                    dispose();
                }
            }
        } else if( evt.getSource() == editKeywords){
            if( evt.getKeyCode()== evt.VK_DOWN){
                if(tblPersons.getRowCount() > 0){
                    tblPersons.requestFocus();
                    tblPersons.getSelectionModel().setSelectionInterval(0,0);
                }
            }
            
        }
    }//GEN-LAST:event_keyPressed
    
    private void windowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowClosed
        vecResults.removeAllElements();
        //dispose();
    }//GEN-LAST:event_windowClosed
    
    private void mousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed
        if( evt.getSource() == tblPersons ) {
            if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
                int nRow = tblPersons.rowAtPoint(evt.getPoint());
                if(nSearchCriteria == PROV_GOOD_SEARCH){
                    try{
                        vecResults.clear();
                        vecResults.add((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow));
                    } catch(Exception e){
                        JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
                        e.printStackTrace();
                    }
                    dispose();
                }
            }
        }
    }//GEN-LAST:event_mousePressed
    
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource()==btnSearch){
            String strKeywords = editKeywords.getText().trim();
            String strWhereClause = "";
            int nConditions = 0;
            if(!strKeywords.equals("")){
                nConditions++;
                String str_rgn_keywordTokens[] = strKeywords.split(" ");
                int nKeywordsCount = str_rgn_keywordTokens.length;
                if(nKeywordsCount < 1){
                    JOptionPane.showMessageDialog(null,"Please enter at least one keyword for search");
                    return;
                }
                int nSearchFieldsCount = str_rgn_searchFields.length;
                for(int i = 0; i < nKeywordsCount; i++){
                    str_rgn_keywordTokens[i] = str_rgn_keywordTokens[i].trim();
                    
                    if(str_rgn_keywordTokens[i].equals("")){
                        continue;
                    }
                    for(int j = 0; j < nSearchFieldsCount; j++){
                        if(i == 0 && j == 0)
                            strWhereClause += "(";
                        else if(i > 0 && j == 0)
                            strWhereClause += ") AND (";
                        else if(i > 0 || j > 0)
                            strWhereClause += " OR ";
                        strWhereClause = strWhereClause + " UPPER(" + str_rgn_searchFields[j] + ") " + " like UPPER('%" + str_rgn_keywordTokens[i] + "%') ";
                    }
                    if(i==nKeywordsCount-1){
                        strWhereClause += " ) ";
                    }
                }
            }
            int nCountryId = ((ComboDataModel)comboCountry.getModel()).getCObjectAt(comboCountry.getSelectedIndex()).nItemDBKey;
            
            int nTypeId = ((ComboDataModel)comboPrsType.getModel()).getCObjectAt(comboPrsType.getSelectedIndex()).nItemDBKey;
            if(nTypeId >=0){
                if(nConditions>0){
                    strWhereClause += " and type_idnt = " + nTypeId;
                } else{
                    strWhereClause += " type_idnt = " + nTypeId;
                }
                nConditions++;
            }
            
            
            if(nCountryId >=0){
                if(nConditions>0)
                    strWhereClause += " AND CNTR_IDNT = " + nCountryId;
                else
                    strWhereClause += " CNTR_IDNT = " + nCountryId;
                nConditions++;
            }
            
            
            if(nConditions>0){
                strWhereClause += " AND (prv1_good = 'Y' or prv2_good = 'Y') ";
            } else{
                strWhereClause += " where (prv1_good = 'Y' or prv2_good = 'Y') ";
            }
            
            strSelectClause = SharedUtils.dbSettings.getSqlSearchPersons();
            if(nConditions > 0)
                strWhereClause = " WHERE " + strWhereClause;
            String strSQL = strSelectClause + strWhereClause;
            
            String str_rgn_columnNames[] = {"UIN","Name","Type","Country","Address"};
            try{
                str_rgn_columnNames = Main.def_app_lang.loadTableHeader(tblPersons);
            } catch(Exception e){
                
            }
            
            SharedUtils.setTableDBModel(tblPersons,strSQL,str_rgn_columnNames);
            String strSearch = editKeywords.getText();
            int begIndex = 0;
            int length= strSearch.length();
            editKeywords.requestFocus();
            if(tblPersons.getRowCount() > 0){
                editKeywords.setCaretPosition(length);
            } else {
                editKeywords.setCaretPosition(length);
            }
        }
        if(evt.getSource() == editKeywords){
            btnSearch.doClick();
            editKeywords.requestFocus();
            
        }
    }//GEN-LAST:event_actionPerformed
    
    private void afterInitComponents(){
        try{
            Connection connDB = SharedUtils.DBConnect(SharedUtils.connectionString,true);
            String strSQL = "SELECT CNTR_NAME,CNTR_KEY FROM BASE_CNTR ORDER BY CNTR_NAME";
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbCountry = new ComboDataModel(rsDBData);
            ComboDataRow cdrRow = new ComboDataRow("All",-1);
            cdbCountry.insertCObjectAt(0,cdrRow);
            cdbCountry.setSelectedIndex(0);
            comboCountry.setModel(cdbCountry);
            rsDBData.close();
            stm.close();
            
            strSQL = "SELECT TYPE_ABBR, TYPE_KEY  FROM BASE_PRSN_TYPE ORDER BY TYPE_ABBR";
            stm = connDB.createStatement();
            rsDBData=stm.executeQuery(strSQL);
            ComboDataModel cdbClients = new ComboDataModel(rsDBData);
            cdrRow = new ComboDataRow("All",-1);
            cdbClients.insertCObjectAt(0,cdrRow);
            cdbClients.setSelectedIndex(0);
            comboPrsType.setModel(cdbClients);
            rsDBData.close();
            stm.close();
            
            String str_rgn_columnNames[] = {"UIN","Name","Type","Country","Address"};
            try{
                str_rgn_columnNames = Main.def_app_lang.loadTableHeader(tblPersons);
            } catch(Exception e){
                
            }
            tblPersons.setModel(new UniversalTableModel(null, str_rgn_columnNames));
            
        }catch(SQLException sqle){
            SharedUtils.handleError(GENERAL_DB_ERROR);
        } catch(Exception e){
            e.printStackTrace();
        }
        //
        enableExit(comboCountry);
        enableExit(tblPersons);
        UIUtils.setTableFonts(tblPersons);
    }
    public void translate(){
        Main.def_app_lang.loadLabelsFromPanel(this.getContentPane());
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnSearch;
    private javax.swing.JComboBox comboCountry;
    private javax.swing.JComboBox comboPrsType;
    private javax.swing.JTextField editKeywords;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane scrPersons;
    private javax.swing.JTable tblPersons;
    // End of variables declaration//GEN-END:variables
    
}
