package medstore.print.reports.relations;
import java.awt.Component;
import java.awt.Frame;
import java.awt.event.InputEvent;
import java.io.File;
import java.io.FileOutputStream;
import java.util.Vector;
import javax.swing.JEditorPane;
import javax.swing.JLayeredPane;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
import medstore.CommonDialog;
import medstore.SharedUtils;
import medstore.UniversalTableRow;
import java.sql.*;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import medstore.AddClient;
import medstore.UIUtils;
import medstore.UniversalTableModel;
import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFHeader;
import org.apache.poi.hssf.usermodel.HSSFRow;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;

public class SetPersons extends CommonDialog{
    private Vector vecResults;
    private Frame parent;
    private String userid;
    private String name;
    private String typeabbr;
    private String address;
    private String country;
    
    public SetPersons(Frame parent) {
        super(parent,true);
        this.parent = parent;
        initComponents();
        setSize(650, 400);
        
        setLocationByPlatform(true);
        
        userid = null;
        name = null;
        SharedUtils.setTableDBModel(tblPersons, null, (new String[]{"UID","Name","Type","Address", "Relation"}));
        UIUtils.setTableFonts(tblPersons);
        int[] w = {50,200,50,200,250};
        SharedUtils.setTableColumnsWidth(tblPersons, w);
        
        btnsVisible(false);
    }
    public void btnsVisible(boolean bool){
        cmdSave.setVisible(bool);
        cmdDetails.setVisible(bool);
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        radioGroup = new javax.swing.ButtonGroup();
        setUserPanel = new javax.swing.JPanel();
        cmdFind = new javax.swing.JButton();
        lblCtry = new javax.swing.JLabel();
        lblTypeAbbr = new javax.swing.JLabel();
        lblAddress = new javax.swing.JLabel();
        cmdSave = new javax.swing.JButton();
        cmdDetails = new javax.swing.JButton();
        scrPersons = new javax.swing.JScrollPane();
        tblPersons = new javax.swing.JTable();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setUserPanel.setLayout(null);

        setUserPanel.setBorder(new javax.swing.border.TitledBorder(null, "Set Person", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12)));
        setUserPanel.setMaximumSize(new java.awt.Dimension(600, 160));
        setUserPanel.setMinimumSize(new java.awt.Dimension(600, 120));
        setUserPanel.setPreferredSize(new java.awt.Dimension(600, 160));
        cmdFind.setFont(new java.awt.Font("Tahoma", 1, 12));
        cmdFind.setText("Find");
        cmdFind.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdFindActionPerformed(evt);
            }
        });

        setUserPanel.add(cmdFind);
        cmdFind.setBounds(510, 20, 90, 25);

        lblCtry.setFont(new java.awt.Font("Tahoma", 1, 12));
        lblCtry.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        setUserPanel.add(lblCtry);
        lblCtry.setBounds(20, 60, 160, 30);

        lblTypeAbbr.setFont(new java.awt.Font("Tahoma", 1, 12));
        lblTypeAbbr.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        setUserPanel.add(lblTypeAbbr);
        lblTypeAbbr.setBounds(20, 30, 90, 30);

        lblAddress.setFont(new java.awt.Font("Tahoma", 1, 12));
        lblAddress.setVerticalAlignment(javax.swing.SwingConstants.TOP);
        lblAddress.setVerticalTextPosition(javax.swing.SwingConstants.TOP);
        setUserPanel.add(lblAddress);
        lblAddress.setBounds(180, 30, 320, 60);

        cmdSave.setFont(new java.awt.Font("Tahoma", 1, 12));
        cmdSave.setText("Save");
        cmdSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdSaveActionPerformed(evt);
            }
        });

        setUserPanel.add(cmdSave);
        cmdSave.setBounds(510, 80, 90, 25);

        cmdDetails.setFont(new java.awt.Font("Tahoma", 1, 12));
        cmdDetails.setText("Details");
        cmdDetails.setActionCommand("Details");
        cmdDetails.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdDetailsActionPerformed(evt);
            }
        });

        setUserPanel.add(cmdDetails);
        cmdDetails.setBounds(510, 50, 90, 25);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        getContentPane().add(setUserPanel, gridBagConstraints);

        scrPersons.setFont(new java.awt.Font("Tahoma", 1, 13));
        tblPersons.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {
                "UIN", "Name", "Type", "Country", "Address"
            }
        ));
        tblPersons.setName("tblClSearchPersons");
        tblPersons.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                SetPersons.this.keyPressed(evt);
            }
        });
        tblPersons.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                SetPersons.this.mousePressed(evt);
            }
        });

        scrPersons.setViewportView(tblPersons);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.ipadx = 526;
        gridBagConstraints.ipady = 376;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 10, 0, 10);
        getContentPane().add(scrPersons, gridBagConstraints);

    }
    // </editor-fold>//GEN-END:initComponents
    
    private void cmdDetailsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdDetailsActionPerformed
        if(userid==null || userid.length() == 0 ){
            JOptionPane.showMessageDialog(null,"Please select client first!");
            return;
        }
        Vector provResults = new Vector();
        provResults.addElement(userid);
        viewDeatils(provResults);
    }//GEN-LAST:event_cmdDetailsActionPerformed
    
    private void mousePressed(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mousePressed
        if( evt.getSource() == tblPersons ) {
            if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
                
                if(userid==null || userid.length() == 0 ){
                    JOptionPane.showMessageDialog(null,"Please select client first!");
                    return;
                }
                Vector provResults = new Vector();
                int nRow = tblPersons.rowAtPoint(evt.getPoint());
                String strUIN = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(0);
                provResults.addElement(strUIN);
                viewDeatils(provResults);
                
            }
        }
    }//GEN-LAST:event_mousePressed
    
    private void keyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_keyPressed
        if(evt.getSource() == tblPersons){
            int nRow = tblPersons.getSelectedRow();
            if( evt.getKeyCode()== evt.VK_ENTER ){
                Vector provResults = new Vector();
                String strUIN = (String)((UniversalTableRow)((UniversalTableModel)tblPersons.getModel()).getRowObject(nRow)).getRowElement(0);
                provResults.addElement(strUIN);
                viewDeatils(provResults);
            }
        }
    }//GEN-LAST:event_keyPressed
    
    private void cmdSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdSaveActionPerformed
        JFileChooser chooser = new JFileChooser();
        MyFilter filter = new MyFilter();
        File file = new File("provrel.xls");
        chooser.setFileFilter(filter);
        chooser.setSelectedFile(file);
        int returnVal = chooser.showSaveDialog(this);
        if(returnVal == JFileChooser.APPROVE_OPTION) {
            try{
                int i = JOptionPane.NO_OPTION;
                while(i==JOptionPane.NO_OPTION && new File(chooser.getSelectedFile().getAbsolutePath()).exists()){
                    i = JOptionPane.showConfirmDialog(this,"The file " + file.getAbsolutePath() + " already exist!" +
                            "\nDo you want to replace existing file!", "File replacement!", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE);
                    
                    if(i==JOptionPane.YES_OPTION){
                        break;
                    }
                    if(i==JOptionPane.CANCEL_OPTION){
                        return;
                    }
                    if(JFileChooser.CANCEL_OPTION == chooser.showSaveDialog(this))
                        return;
                    
                }
                
                saveFile(chooser.getSelectedFile().getAbsolutePath());
            } catch(Exception e){
                JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
                e.printStackTrace();
            }
        }
    }//GEN-LAST:event_cmdSaveActionPerformed
    
    private void cmdFindActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdFindActionPerformed
        vecResults = new Vector();
        new PersonSearch(parent, true, vecResults, PersonSearch.PROV_GOOD_SEARCH).setVisible(true);
        try{
            if(vecResults.size()==0)
                return;
            UniversalTableRow tblRow = (UniversalTableRow)vecResults.get(0);
            userid = tblRow.getRowElement(0).toString();
            name = tblRow.getRowElement(1).toString();
            address = tblRow.getRowElement(4).toString();
            typeabbr = tblRow.getRowElement(2).toString();
            country = tblRow.getRowElement(3).toString();
            
            lblTypeAbbr.setText("Type: " + typeabbr);
            lblCtry.setText("Country: " + country);
            lblAddress.setText("Address: " + address);
            setUserPanel.setBorder(new javax.swing.border.TitledBorder(null, name, javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 12)));
            loadRelations();
            btnsVisible(true);
        } catch(Exception e){
            JOptionPane.showMessageDialog(this,"Error: " + e.getMessage());
            e.printStackTrace();
            dispose();
        }
    }//GEN-LAST:event_cmdFindActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cmdDetails;
    private javax.swing.JButton cmdFind;
    private javax.swing.JButton cmdSave;
    private javax.swing.JLabel lblAddress;
    private javax.swing.JLabel lblCtry;
    private javax.swing.JLabel lblTypeAbbr;
    private javax.swing.ButtonGroup radioGroup;
    private javax.swing.JScrollPane scrPersons;
    private javax.swing.JPanel setUserPanel;
    private javax.swing.JTable tblPersons;
    // End of variables declaration//GEN-END:variables
    public static void main(String args[]){
        SetPersons spersons = new SetPersons(null);
    }
    public void disableIt(Component[] comp){
        int count = comp.length;
        for(int i = 0; i < count; i++){
            Component component = comp[i];
            try{
                
                if(JPanel.class == component.getClass()){                    
                    disableIt(((JPanel)component).getComponents());
                    continue;
                }
                if(JLayeredPane.class == component.getClass()){
                    disableIt(((JLayeredPane)component).getComponents());
                    continue;
                }                
                if(JTextField.class == component.getClass()){
                    ((JTextField)component).setEditable(false);
                    continue;
                }
                if(JEditorPane.class == component.getClass()){
                    ((JEditorPane)component).setEditable(false);
                    System.out.println(component);
                    continue;
                }
                if(JLabel.class == component.getClass()){
                    continue;
                }
                                
                component.setEnabled(false);
            } catch(Exception e){
                
            }
            
        }
    }
    public void loadRelations(){
        if(userid==null)
            return;
        String sql = "SELECT  TOP 1000 " +
                "  base_prsn.prsn_key" +
                ", base_prsn.prsn_lnam + ', ' + base_prsn.prsn_fnam as name" +
                ", base_prsn_type.type_abbr" +
                ", base_cntr.cntr_name  + ', ' + " + "  base_prsn.prsn_city  + ', ' + base_prsn.prsn_strt " +
                ", case base_prsn.prv1_idnt when "+ userid +" then 'Provision 1; '   else '' END  " +
                "+ case base_prsn.prv2_idnt when "+ userid +" then ' Provision 2; ' else '' END  " +
                "+ case base_prsn.prv3_idnt when "+ userid +" then ' Provision 3;' else '' END " +
                " FROM base_prsn INNER JOIN " +
                " base_prsn_type ON base_prsn.type_idnt = base_prsn_type.type_key INNER JOIN " +
                " base_cntr ON base_prsn.cntr_idnt = base_cntr.cntr_key" +
                " WHERE " +
                " (base_prsn.prv1_idnt = " + userid + " OR " +
                " base_prsn.prv2_idnt = " + userid + " OR " +
                " base_prsn.prv3_idnt = " + userid + ") AND " +
                " (prv1_good = 'Y' or prv2_good = 'Y')";
        
        try{
            Connection conn = SharedUtils.getConnection();
            Statement stmt =  conn.createStatement();
            ResultSet rs = stmt.executeQuery(sql);
            
            SharedUtils.setTableDBModel(tblPersons, sql, (new String[]{"UID","Name","Type","Address", name + " relate as"}));
            int[] w = {50,200,50,200,250};
            SharedUtils.setTableColumnsWidth(tblPersons, w);
            
        } catch(Exception e){
            e.printStackTrace();
        }
    }
    
    public void saveFile(String filename) throws Exception{
        HSSFWorkbook wb = new HSSFWorkbook();
        HSSFSheet sheet = wb.createSheet("Sheet 1");
        
        Vector data = ((UniversalTableModel)tblPersons.getModel()).getDataVector();
        HSSFHeader header = sheet.getHeader();
        //header.setLeft(userid + ";" + name + ";" + typeabbr + ";" + country + ";" + address);
        
        
        
        HSSFRow firstrow = sheet.createRow((short)0);
        HSSFRow secondrow = sheet.createRow((short)2);
        
        HSSFCell cellUID = firstrow.createCell((short)0);
        cellUID.setCellValue(userid);
        cellUID = secondrow.createCell((short)0);
        cellUID.setCellValue("UID");
        
        HSSFCell cellName = firstrow.createCell((short)1);
        cellName.setCellValue(name);
        cellName = secondrow.createCell((short)1);
        cellName.setCellValue("Name");
        
        HSSFCell cellType = firstrow.createCell((short)2);
        cellType.setCellValue(typeabbr);
        cellType = secondrow.createCell((short)2);
        cellType.setCellValue("Type");
        
        HSSFCell cellCountry = firstrow.createCell((short)3);
        cellCountry.setCellValue(country);
        cellCountry = secondrow.createCell((short)3);
        cellCountry.setCellValue("Address");
        
        HSSFCell cellAddress = firstrow.createCell((short)4);
        cellAddress.setCellValue(address);
        cellAddress = secondrow.createCell((short)4);
        cellAddress.setCellValue("Relation");
        
        
        for(int i = 0; i < data.size(); i++){
            UniversalTableRow tblRow = (UniversalTableRow)data.get(i);
            Vector tblRowData = tblRow.getDataVector();
            
            HSSFRow row = sheet.createRow((short)i+3);
            
            for(int j = 0; j < tblRowData.size(); j++){
                HSSFCell cell = row.createCell((short)j);
                
                String value = tblRowData.get(j).toString();
                cell.setCellValue(value);
            }
        }
        FileOutputStream fileOut = new FileOutputStream(filename);
        wb.write(fileOut);
    }
    
    public void viewDeatils(Vector details){
        AddClient clForm = new AddClient(parent, true, AddClient.EDIT_MODE, details);
        clForm.setLocationByPlatform(true);
        int count = clForm.getRootPane().getComponentCount();
        for(int i = 0; i < count; i++){
            Component[] component = clForm.getRootPane().getComponents();
            disableIt(component);
        }
        clForm.setVisible(true);
    }
    
    
}
