package medstore.print.reports.usage;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class USAGEReport implements SharedConstants{
    private Hashtable htbFilterParams;
    
    public USAGEReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
        String strTextDateFrom = getFromDate();
        String strTextDateTo = (String)htbFilterParams.get(TEXT_DATE_TO);
        strTextDateTo = SharedUtils.getToDate( strTextDateTo );
        
        
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Usage'\n";
        String rep_date_interval = "date - from: " + (String)htbFilterParams.get(TEXT_DATE_FROM) + " to: " + (String)htbFilterParams.get(TEXT_DATE_TO);
        String producer = "produced by user: " + SharedUtils.strUsername;
        
        
        
        ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
        USAGEReportData rep = new USAGEReportData(top);
        
        String strSQL = "select " +
                "   base_stck.stck_key," +
                "   base_stck.stck_name," +
                "   base_stck.stck_brcd," +
                "   position.p_menge, " +
                "   NEWID() AS new_id " +               
                " FROM " +
                "   vorgang, position, base_stck " +
                " WHERE " +
                "   position.nstk_idnt=base_stck.stck_key " +
                "   AND vorgang.v_nr=position.v_nr " +
                /*"   AND vorgang.pay_date is not null " +*/
                //" AND (vorgang.v_nr NOT IN (SELECT invoiceid FROM vorgang WHERE      doc_type_idnt = 2)) " +
                "   AND vorgang.doc_type_idnt =1 " + 
                /*" AND vorgang.pay_sum >= vorgang.totl_sum " +*/
                "   AND vorgang.pay_date>='" + strTextDateFrom + "'" +
                "   AND vorgang.pay_date<'" + strTextDateTo + "'" +
                " UNION " +
                "       SELECT     " +
                "   base_stck.stck_key, " +
                "   base_stck.stck_name, " +
                "   base_stck.stck_brcd, " +
                "   0 as p_menge, " +
                "   NEWID() AS new_id" +
                " FROM        " +
                "    base_stck " +
                " WHERE  " +
                "   base_stck.stck_key not in (select nstk_idnt from position) " +
                "" +
                " order by stck_key "             ;
       // System.out.println(strSQL);
        ArrayList data = new ArrayList();
        Connection conn = null;
        int count = 0;
        
        int num = 1;
        int oldStockId = -1;
        int stockCount = 0;
        try {
            conn = SharedUtils.getConnection();
            Statement stm = conn.createStatement();
            ResultSet rs = stm.executeQuery(strSQL);
            
            while( rs.next() ) {
                
                count++;
                
                int stockId = rs.getInt(1);
                if( oldStockId == stockId ) {
                    stockCount += rs.getInt(4);
                    continue;
                }
                
                if( data.size() > 0 ) {
                    ArrayList entry = (ArrayList)data.get( data.size() -1 );
                    entry.set(3, "" + stockCount );
                }
                
                oldStockId = stockId;
                ArrayList entry = new ArrayList();
                data.add(entry);
                
                entry.add("" + num + ")" );
                num++;
                
                String stockName = rs.getString(2);
                String stockBarcode = rs.getString(3);
                stockCount = rs.getInt(4);
                
                entry.add( stockName );
                entry.add( stockBarcode );
                entry.add( "" + stockCount );
            }
            
            if( data.size() > 0 ) {
                ArrayList entry = (ArrayList)data.get( data.size() -1 );
                entry.set(3, "" + stockCount );
            }
        } catch(Exception e) {
            e.printStackTrace();
        } finally {
            SharedUtils.closeConnection( conn );
        }
        
        Collections.sort(data,
                new Comparator() {
            public int compare(Object o1, Object o2 ) {
                ArrayList arr1 = (ArrayList)o1;
                ArrayList arr2 = (ArrayList)o2;
                String name1 = (String)arr1.get(1);
                String name2 = (String)arr2.get(1);
                return name1.compareTo(name2);
            }
        }
        );
        
        // correct numbers
        for( int i = 0; i < data.size(); i++ ) {
            ArrayList row = (ArrayList)data.get(i);
            String name = row.get(1).toString();
            String barcode = row.get(2).toString();
            String itemcount = row.get(3).toString();
            
            USAGEData rep_data = new USAGEData((i+1) + ")", name, barcode,itemcount);
            rep.addItemData(rep_data);
        }
        
        if(count==0)
            rep.addItemData(new USAGEData("", "", "", ""));
        
        
        USAGETableModel tm = new USAGETableModel();
        tm.addReport(rep);
        USAGEPrintUtils spUtils = new USAGEPrintUtils(tm,"/medstore/print/reports/usage/report.xml","Usage");
        return spUtils.createReport();
        
    }
    private String getFromDate(){
        String strTextDateFrom = (String)htbFilterParams.get(TEXT_DATE_FROM);
        String dateFields[] = strTextDateFrom.split("\\.");
        strTextDateFrom = dateFields[1] + "." + dateFields[0] + "." + dateFields[2];
        return strTextDateFrom;
    }
}
