package medstore.print.reports.usage;

import java.lang.reflect.Array;
import java.util.ArrayList;
import medstore.print.reports.ReportTop;

public class USAGEReportData extends ReportTop{
    private ArrayList rowdata;
    private ArrayList rowdataCounts;
    
    public USAGEReportData(ReportTop top) {
        super(top.getReportDate(), top.getReportType(), top.getReportDateInterval(), top.getReportProducer());
        rowdata = new ArrayList();
        rowdataCounts = new ArrayList();
    }
    
    public synchronized void addItemData(USAGEData data) {
        final int index = rowdata.indexOf(data);
        if (index == -1) {
            rowdata.add(data);
            rowdataCounts.add(new Integer(1));
        } else {
            final Integer oldCount = (Integer) rowdataCounts.get(index);
            rowdataCounts.set(index, new Integer(oldCount.intValue() + 1));
        }
    }
    
    public synchronized void removeItemData(final USAGEData data) {
        final int index = rowdata.indexOf(data);
        if (index != -1) {
            final Integer oldCount = (Integer) rowdataCounts.get(index);
            if (oldCount.intValue() == 1) {
                rowdataCounts.remove(index);
                rowdata.remove(index);
            } else {
                rowdataCounts.set(index, new Integer(oldCount.intValue() - 1));
            }
        }
    }
    public synchronized void setItemData(ArrayList rowdata){
        for(int i = 0; i<rowdata.size(); i++){
            addItemData((USAGEData)rowdata.get(i));
        }
    }
    
    public USAGEData getItemData(final int index) {
        return (USAGEData) rowdata.get(index);
    }
    
    public int getItemCount(final int index) {
        final Integer i = (Integer) rowdataCounts.get(index);
        return i.intValue();
    }
    
    public int getItemDataCount() {
        return rowdata.size();
    }
}
