package medstore.print.reports.usagemonthly;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.Hashtable;
import medstore.SharedConstants;
import medstore.SharedUtils;
import medstore.print.DateUtils;
import medstore.print.reports.ReportTop;
import org.jfree.report.JFreeReport;



public class MUSAGEReport implements SharedConstants{
    private Hashtable htbFilterParams;
    private String[] m_strMonths = {"JAN","FEB","MAR","APR","MAY","JUN","JUL","AUG",
            "SEP","OCT","NOV","DEC"};
    public MUSAGEReport(Hashtable htbFilterParams) {
        this.htbFilterParams = htbFilterParams;
    }
    
    public JFreeReport getReport() throws Exception{
               
        
        String rep_date = "Date: " + DateUtils.ddmmyyy_hhmmss_current();
        String type = "Query: 'Usage Months'\n";
        String rep_date_interval = "";
        String producer = "produced by user: " + SharedUtils.strUsername;
        
        
        
        ReportTop top = new ReportTop(rep_date, type, rep_date_interval, producer);
        MUSAGEReportData rep = new MUSAGEReportData(top);
        
        String strSQL = "select " +
                    "   base_stck.stck_key," +
                    "   vorgang.pay_date," +
                    "   base_stck.stck_name," +
                    "   base_stck.stck_brcd," +
                    "   position.p_menge, " +
                    "   newid()" +
                    " from " +
                    "   vorgang, position, base_stck " +
                    " WHERE " +
                    "   position.nstk_idnt=base_stck.stck_key " +
                    "   AND vorgang.v_nr=position.v_nr " +
                    "   AND vorgang.pay_date is not null " +                
                    "   AND vorgang.doc_type_idnt =1 " + 
                  /*  " AND vorgang.pay_sum >= vorgang.totl_sum " +*/
                    " order by base_stck.stck_key ASC,vorgang.pay_date ASC";
                
                ArrayList data = new ArrayList();
                Connection conn = null;
                Calendar cal = Calendar.getInstance();
                int count = 0;
                try
                {
                    conn = SharedUtils.getConnection();
                    Statement stm = conn.createStatement();
                    ResultSet rs = stm.executeQuery(strSQL);
                    int num = 1;
                    int oldStockId = -1;
                    int oldMonth = -1;
                    int oldYear = -1;
                    int stockCount = 0;
                    while( rs.next() )
                    {
                        count++;
                        int stockId = rs.getInt(1);
                        cal.setTimeInMillis( rs.getTimestamp(2).getTime() );
                        int month = cal.get( Calendar.MONTH );
                        int year = cal.get( Calendar.YEAR );
                        
                        if( oldStockId == stockId && oldMonth == month && oldYear == year )
                        {
                            stockCount += rs.getInt(5);
                            continue;                            
                        }
                        
                        //
                        if( data.size() > 0 )
                        {
                            ArrayList entry = (ArrayList)data.get( data.size() -1 );
                            entry.set(5, "" + stockCount );
                        }
                        
                        oldStockId = stockId;
                        oldMonth = month;
                        oldYear = year;
                        ArrayList entry = new ArrayList();
                        data.add(entry);
                        
                        String stockName = rs.getString(3);
                        String stockBarcode = rs.getString(4);
                        stockCount = rs.getInt(5);
                        
                        entry.add("" + num + ")" );
                        num++;  
                        if( stockName == null )
                            stockName = "";
                        entry.add( stockName );
                        entry.add( "" + month );
                        entry.add( "" + year );
                        entry.add( stockBarcode );
                        entry.add( "" + stockCount );
                        entry.add( "" + stockId );                        
                    }    
                    
                    if( data.size() > 0 )
                    {
                        ArrayList entry = (ArrayList)data.get( data.size() -1 );
                        entry.set(5, "" + stockCount );
                    }
                    
                    Collections.sort(data, 
                            new Comparator()
                            {
                               public int compare(Object o1, Object o2 )
                               {
                                   ArrayList arr1 = (ArrayList)o1;
                                   ArrayList arr2 = (ArrayList)o2;
                                   
                                   int year1 = Integer.parseInt( (String)arr1.get(3) );
                                   int year2 = Integer.parseInt( (String)arr2.get(3) );
                                   int dif = year1- year2;
                                   if( dif != 0 )
                                       return dif;
                                   
                                   int m1 = Integer.parseInt( (String)arr1.get(2) );
                                   int m2 = Integer.parseInt( (String)arr2.get(2) );
                                   dif = m1 - m2;
                                   if( dif != 0 )
                                       return dif;
                                   
                                   String name1 = (String)arr1.get(1);
                                   String name2 = (String)arr2.get(1); 
                                   return name1.compareTo(name2);                                   
                               }
                            }
                    );                    
                    for( int i = 0; i < data.size(); i++ )
                    {
                        ArrayList entry = (ArrayList)data.get(i);
                        entry.set(0, "" + (i+1) );
                        int month = Integer.parseInt( (String)entry.get(2) );
                        entry.set(2, m_strMonths[month]  );
                        entry.remove(entry.size()-1);
                    }
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
                finally
                {
                    SharedUtils.closeConnection( conn );
                }
                
        
        
        
        // correct numbers
        for( int i = 0; i < data.size(); i++ ) {
            ArrayList row = (ArrayList)data.get(i);
            String name = row.get(1).toString();
            String month = row.get(2).toString();
            String year = row.get(3).toString();
            String barcode = row.get(4).toString();
            String itemcount = row.get(5).toString();
            
            
            MUSAGEData rep_data = new MUSAGEData((i+1) + ")", name, month, year, barcode,itemcount);
            rep.addItemData(rep_data);
        }
        
        if(count==0)
            rep.addItemData(new MUSAGEData("", "", "", "", "", ""));
        
        
        MUSAGETableModel tm = new MUSAGETableModel();
        tm.addReport(rep);
        MUSAGEPrintUtils spUtils = new MUSAGEPrintUtils(tm,"/medstore/print/reports/usagemonthly/report.xml","Usage Months");
        return spUtils.createReport();
        
    }    
}
