/*
 * ProcedurePackTranStore.java
 *
 * Created on , 2005,  10, 15:55
 */

package medstore.procedures;

import java.sql.*;
import medstore.*;

/**
 *
 * @author ait
 */
public class ProcedurePackTranStore {
    
    /** Creates a new instance of ProcedurePackTranStore */
    //public String m_stockId;
   // public String m_stockName;
    public String m_insertedTranId;
    
    public ProcedurePackTranStore() {
    }
    
    public void execPackStoreOperation(Connection conn, 
            String operationCode, int addedStockCount, 
            String stockBarcode, String storeIdSrc, 
            String storeIdDst, String date, String userId, 
            String tranDesc, int sequence )
        throws Exception
    {
       // find stock
       String sql =  "SELECT CTB.STCK_BRCD, PTB.STCK_PCNT " +
               " FROM BASE_STCK AS PTB INNER JOIN BASE_STCK AS CTB ON (PTB.CNTN_BCOD = CTB.STCK_BRCD)" + 
               " WHERE PTB.STCK_BRCD='" + stockBarcode + "'";
       Statement stm = conn.createStatement();
       ResultSet rs = stm.executeQuery(sql);
       if( !rs.next() )
           throw new MedstoreException( "BARCODE NOT REGISTERED IN THE SYSTEM" );            
       String contentBarcode = rs.getString(1);
       int countInPacket = rs.getInt(2);
       if( contentBarcode == null )
           throw new MedstoreException( "TRY OF PACK FUNCTION AGAINST ATOMIC STOCK" );
       rs.close();
       stm.close();

       ProcedureStore outProc = new ProcedureStore();
       outProc.execStoreOperation( conn, "OT", addedStockCount, 
               stockBarcode, storeIdSrc, date, userId );

       ProcedureStore inProc = new ProcedureStore();
       inProc.execStoreOperation( conn, "IN", countInPacket * addedStockCount, 
               contentBarcode, storeIdDst, date, userId );

       if( tranDesc != null )
           tranDesc = "'" + tranDesc + "'";
       sql = "INSERT INTO BASE_EVNT_TRNS (trns_descr) VALUES( " + tranDesc + " )";
       stm = conn.createStatement();
       stm.executeUpdate(sql);
       stm.close();
       m_insertedTranId = SharedUtils.getLastInsertedID(conn);           

       sql = "INSERT INTO CONN_EVNT_TRNS ( evnt_idnt, trns_idnt, oper_idnt, sqns_nmbr ) VALUES( " + 
               outProc.m_insertedEventId + "," + m_insertedTranId + ",'" + 
               operationCode +  "'," +  sequence + " )";
       stm = conn.createStatement();
       stm.executeUpdate(sql);
       stm.close();  

       sql = "INSERT INTO CONN_EVNT_TRNS ( evnt_idnt, trns_idnt, oper_idnt, sqns_nmbr ) VALUES(" + 
               inProc.m_insertedEventId + "," + m_insertedTranId + ",'" + 
               operationCode +  "'," +  (sequence + 1) + " )";
       stm = conn.createStatement();
       stm.executeUpdate(sql);
       stm.close();       
    }    
}
