/*
 * ProcedureUndoStore.java
 *
 * Created on , 2005,  10, 18:05
 */

package medstore.procedures;

import java.sql.*;
import medstore.*;

/**
 *
 * @author ait
 */

public class ProcedureUndoStore {
    
    public String m_insertedEventId;
    public int m_newStockcountOnHand;
    /** Creates a new instance of ProcedureUndoStore */
    public ProcedureUndoStore() 
    {        
    }
    
    public void execUndoStoreOperation( Connection conn, String date, int undoEvent, int userId )
        throws Exception
    {
        if( SharedUtils.executeSqlScalar( "SELECT EVNT_KEY " +
                " FROM BASE_EVNT WHERE EVNT_KEY=" + undoEvent ) == null )
            throw new MedstoreException( "NO INFO FOR EVENT TO STORNO" );

        String sql = "SELECT STOR_IDNT,OPER_KEY,STCK_IDNT,STCK_CNT_EVNT " +
                " FROM VIEW_EVNT_INFO WHERE EVNT_KEY=" + undoEvent;
        Statement stm = conn.createStatement();
        ResultSet rs = stm.executeQuery(sql);
        if( !rs.next() )            
            throw new MedstoreException( " NO INFO FOR EVENT TO STORNO" );
        String storeId = rs.getString(1);
        String operationCode = rs.getString(2);
        String stockId = rs.getString(3);
        int stockCount = rs.getInt(4);
        rs.close();
        stm.close();

        //
        int stockCountOnHand = 0;
        sql = " SELECT STCK_CNT " +
              " FROM CONN_STCK_IN_STOR " +
              " WHERE STCK_IDNT=" + stockId +  " AND STOR_IDNT=" + storeId;
        stm = conn.createStatement();
        rs = stm.executeQuery(sql);
        boolean isExistConnStockStore = rs.next();
        if( isExistConnStockStore )
            stockCountOnHand = rs.getInt(1);
        rs.close();
        stm.close();

        // calculate newStockCountOnHand
        int newStockCountOnHand;
        if( operationCode.equals("OT") )
        {
            operationCode = "IN";
            newStockCountOnHand = stockCountOnHand + stockCount;
        }    
        else if( operationCode.equals("IN") )
        {
            operationCode = "OT";
            newStockCountOnHand = stockCountOnHand - stockCount;
        }
        else
            throw new MedstoreException("INVALID STORE OPERATION");
        if( newStockCountOnHand <  0 )                
                throw new MedstoreException( "CANT'T MOVE OUT MORE THAN WE HAVE ON HAND" );

        //update conn_stock_in_count
        String errorMessage = "";
        if( isExistConnStockStore )
        {
            sql = " UPDATE CONN_STCK_IN_STOR SET STCK_CNT = " +  newStockCountOnHand + 
                    " WHERE STCK_IDNT=" + stockId + 
                    " AND STOR_IDNT=" + storeId;
            errorMessage = "ERROR UPDATINGINSERTING STOCK COUNT ON HAND ROW";
        }
        else
        {
            sql = " INSERT INTO CONN_STCK_IN_STOR" +
                    " (stck_idnt,stor_idnt,stck_cnt,stck_ivtr) VALUES" + 
                  " ( " + stockId + "," + storeId + "," + 
                  newStockCountOnHand + ", 0) ";
            errorMessage = "ERROR INSERTING STOCK COUNT ON HAND ROW";
        }
        stm = conn.createStatement();
        if( stm.executeUpdate(sql) <= 0 )
            throw new MedstoreException(errorMessage);
        stm.close();

        // update BASE_EVNT
        sql = "INSERT INTO BASE_EVNT" +
                " (evnt_date ,stor_idnt , oper_idnt, strn_evnt ,user_idnt)" +
                " VALUES('" + date + "'," + storeId + ",'" +
                operationCode + "', NULL," + userId + ")";
        stm = conn.createStatement();
        if( stm.executeUpdate(sql) <= 0 )
            throw new MedstoreException( "ERROR  INSERTING EVENT ROW" );
        stm.close();
        String insertedEventId = SharedUtils.getLastInsertedID(conn);

        //CONN_STCK_IN_EVNT
        sql = "INSERT INTO CONN_STCK_IN_EVNT" +
                " (stck_idnt ,evnt_idnt , stck_cnt) VALUES(" + stockId + ", " +
                insertedEventId + "," + stockCount + ")";
        stm = conn.createStatement();
        if( stm.executeUpdate(sql) <= 0 )
            throw new MedstoreException( "ERROR  INSERTING CONN_STCK_IN_EVNT" );
        stm.close();

        //
        sql = "UPDATE BASE_EVNT SET STRN_EVNT = " + insertedEventId +
              " WHERE EVNT_KEY=" +  undoEvent;
        stm = conn.createStatement();
        if( stm.executeUpdate(sql) <= 0 )
            throw new MedstoreException( "ERROR  UPDATING BASE_EVNT" );
        stm.close();     

        m_insertedEventId = insertedEventId;
        m_newStockcountOnHand = newStockCountOnHand;        
    }    
}
