package medstore.trans;

import java.awt.Component;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTable;


public class MenuLoader {
    private String def_app_lang;
    private LangPack langpack;
    public MenuLoader(String lang) throws Exception{
        def_app_lang = lang;
        if(def_app_lang.toLowerCase().equals("german".toLowerCase())){
            langpack = new GerLangPack();
        } else{
            langpack = null;
        }
    }
    public String getDefaultLang(){
        return def_app_lang;
    }
    public void loadMenuLabel(Component menu){
        try{
            if(menu.getClass() == JMenu.class){
                ((JMenu)menu).setText(langpack.getElementLabel(menu.getName()));
                return;
            }
            if(menu.getClass() == JMenuItem.class){
                ((JMenuItem)menu).setText(langpack.getElementLabel(menu.getName()));
                return;
            }
            if(menu.getClass() == JLabel.class){
                ((JLabel)menu).setText(langpack.getElementLabel(menu.getName()));
                return;
            }
            if(menu.getClass() == JCheckBox.class){
                ((JCheckBox)menu).setText(langpack.getElementLabel(menu.getName()));
                return;
            }
            if(menu.getClass() == JButton.class){
                ((JButton)menu).setText(langpack.getElementLabel(menu.getName()));
                return;
            }
        } catch(Exception e){
            System.out.println(e.getMessage()+" '" + menu.getName()+"'");
        }
        
    }
    public void loadMenuLabel(Component menu, int col){
        try{ if(menu.getClass() == JButton.class){
            ((JButton)menu).setText(langpack.getElementLabel(menu.getName(), col));
            return;
        }
        } catch(Exception e){
            //System.out.println(e.getMessage()+" " + menu);
        }
    }
    public String[] loadTableHeader(JTable table) throws Exception{               
       return langpack.getTblHeader(table.getName());
    }
    public void loadTabbedPane(JTabbedPane pane, int index, String subPanelName ){
        try{
            pane.setTitleAt(index,langpack.getElementLabel(subPanelName));
        } catch(Exception e){
            
        }
    }
    public void loadLabelsFromPanel(Component panel){
        Component[] label = null;
        int count = 0;
        if(panel.getClass() == JPanel.class){            
            label = ((JPanel)panel).getComponents();
            count = ((JPanel)panel).getComponentCount();
        }
        if(panel.getClass() == JDialog.class){            
            label = ((JDialog)panel).getComponents();
            count = ((JDialog)panel).getComponentCount();
            
        }
        //System.out.println(panel.getClass());
        for(int i=0; i < count; i ++){
            if(JLabel.class == label[i].getClass()){
                loadMenuLabel(label[i]);
                continue;
            }
            if(JCheckBox.class == label[i].getClass()){
                loadMenuLabel(label[i]);
                continue;
            }
            if(JButton.class == label[i].getClass()){
                loadMenuLabel(label[i]);
                continue;
            }
        }
    }
    public String getSingleValue(String key) throws Exception{
        return langpack.getElementLabel(key);
    }
}
