package medstore.utils.table;

import java.math.BigDecimal;
import java.util.Collections;
import java.util.Comparator;
import java.util.Vector;
import medstore.UniversalTableModel;
import medstore.UniversalTableRow;

public class ColumnSorter implements Comparator {
    int colIndex;
    boolean ascending;
    
    public ColumnSorter(int colIndex, boolean ascending) {
        this.colIndex = colIndex;
        this.ascending = ascending;
    }
    public int compare(Object a, Object b) {
        Vector v1 = ((UniversalTableRow)a).getDataVector();
        Vector v2 = ((UniversalTableRow)b).getDataVector();
        Object o1 = ascending ? v1.get(colIndex) : v2.get(colIndex);
        Object o2 = ascending ? v2.get(colIndex) : v1.get(colIndex);
        
        boolean is_decimal = false;
        
        try{
            new Float(o1.toString().trim());
            new Float(o2.toString().trim());
            is_decimal = true;
        }
        catch(Exception e){
            
        }
        //System.out.println(o1 + " - " + is_decimal);
        if(is_decimal){
            return new Float(o1.toString()).compareTo(new Float(o2.toString()));
        } else{                        
            return o1.toString().compareToIgnoreCase(o2.toString());            
        }
    }
    public static UniversalTableModel sortColumn(UniversalTableModel model, int colIndex, boolean ascending) {
        Vector data = model.getDataVector();
        Collections.sort(data, new ColumnSorter(colIndex, ascending));
        model.fireTableStructureChanged();
        return model;
    }
}