package adminmodul;

import java.sql.*;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import javax.swing.*;
import adminmodul.campaign.*;

public class AddCampDialog extends javax.swing.JDialog implements SharedConstants{
    
    private String strCampId = "-1";
    private boolean bAddNewStock = false;;
    private String strPanelTitle;
    private Vector nSelRow;
    private CampUtils campUtils;
    private int selIndex = -1;
    
    public AddCampDialog(java.awt.Frame parent, boolean modal,UniversalTableRow nSelRow, int selIndex){
        super(parent, modal);
        
        initComponents();
        
        setLocationRelativeTo(this);
        
        campUtils = new CampUtils();
                
        UniversalInputVerifier dateFilterInputVerifier = new UniversalInputVerifier(UniversalInputVerifier.UNI_DATE_VERIFIER,this);
        editFromDate.setInputVerifier(dateFilterInputVerifier);
        editToDate.setInputVerifier(dateFilterInputVerifier);
        
        String strSQL = "SELECT stck_name, stck_key FROM base_stck ORDER BY stck_name";
        
        try{
             Connection conn = SharedUtils.getConnection();
             Statement stm = conn.createStatement();
             ResultSet rsDBData=stm.executeQuery(strSQL);
             ComboDataModel cdbStocks = new ComboDataModel(rsDBData);
             editStockName.setModel(cdbStocks);
        
        
        if(selIndex == -1) {            
            bAddNewStock = true;
            strPanelTitle = "Operation complete successfully !";
            
        } else {
                 this.nSelRow = nSelRow.vecRowElements;
            this.selIndex = selIndex;
            strCampId = String.valueOf(this.nSelRow.get(this.nSelRow.size()-1));
           
            int p_id = Integer.parseInt(String.valueOf(this.nSelRow.get(this.nSelRow.size()-2)));
            
            this.nSelRow = nSelRow.vecRowElements;
            strPanelTitle = "Edit complete successfully !";            
                        
            setProdName(p_id);
            editFromDate.setText(String.valueOf(this.nSelRow.get(2)));
            editToDate.setText(String.valueOf(this.nSelRow.get(3)));
            editLow.setText(String.valueOf(this.nSelRow.get(4)));
            editHgh.setText(String.valueOf(this.nSelRow.get(5)));
            editDisc.setText(String.valueOf(this.nSelRow.get(6)));
            
        }
        
        }catch(Exception e){            
            e.printStackTrace();
            return;
        }
    }
    
    private void setProdName(int id){     
        
        Vector data = ((ComboDataModel)editStockName.getModel()).vecData;
        for(int i=0; i < data.size(); i++){
            int pId = ((ComboDataModel)editStockName.getModel()).getCObjectAt(i).nItemDBKey;
            if(pId==id)
                editStockName.setSelectedIndex(i);         
        }   
        
    }
    
    private void InsertCamp(){   
        try{
            int id = ((ComboDataModel)editStockName.getModel()).getCObjectAt(editStockName.getSelectedIndex()).nItemDBKey;
            String fromdate = editFromDate.getText();
            String todate = editToDate.getText();
            int lownum = Integer.parseInt(editLow.getText());
            int highnum = Integer.parseInt(editHgh.getText());
            int discount = Integer.parseInt(editDisc.getText());

            CampDataObject data = new CampDataObject(id, fromdate, todate, lownum, highnum, discount);
            strCampId = String.valueOf(campUtils.insertData(data));
            if(strCampId==null || Integer.parseInt(strCampId)<=0){
                throw new Exception("strCampId: null");
            }
            data = campUtils.getParamCamp(strCampId);
            UpdateCampUI(data);
        }
        catch(Exception e){
             System.out.println("InsertCamp: " + e.getMessage());
             e.printStackTrace();
        }
    }
    private void UpdateCamp(){       
        try{
            int id = Integer.parseInt(String.valueOf(this.nSelRow.get(this.nSelRow.size()-1)));
            int p_id = ((ComboDataModel)editStockName.getModel()).getCObjectAt(editStockName.getSelectedIndex()).nItemDBKey;
            String fromdate = editFromDate.getText();
            String todate = editToDate.getText();
            int lownum = Integer.parseInt(editLow.getText());
            int highnum = Integer.parseInt(editHgh.getText());
            int discount = Integer.parseInt(editDisc.getText());

            CampDataObject data = new CampDataObject(id,p_id, fromdate, todate, lownum, highnum, discount);
            campUtils.updateData(data);
            data = campUtils.getParamCamp(strCampId);
            UpdateCampUI(data);
        }
        catch(Exception e){
            System.out.println("UpdateCamp() " + e.getMessage());
            e.printStackTrace();
        }
        
    }
    
    private void UpdateCampUI(CampDataObject data){
        if(data==null)
            return;
        Vector vecRowElements = new Vector();
        vecRowElements.addElement(String.valueOf(data.getBarcode()));
        vecRowElements.addElement(data.getProdName());
        vecRowElements.addElement(data.getFromDate());
        vecRowElements.addElement(data.getToDate());
        vecRowElements.addElement(String.valueOf(data.getLowNum()));
        vecRowElements.addElement(String.valueOf(data.getHighNum()));
        vecRowElements.addElement(String.valueOf(data.getDiscount()));
        vecRowElements.addElement(String.valueOf(data.getStockId()));
        vecRowElements.addElement(String.valueOf(data.getId()));        
        
        if(bAddNewStock){
            InsertRow(vecRowElements);
        }
        else{
            UpdateRow(vecRowElements);
        }
        
     }
    
    private void UpdateRow(Vector vecRowElements){       
        
        final UniversalTableRow uniTableRow = new UniversalTableRow(vecRowElements);
        javax.swing.SwingUtilities.invokeLater(new Runnable(){
            public void run()
        {
            ((UniversalTableModel)CampManager.tblActions.getModel()).setRowObject((Object)uniTableRow,selIndex);
            CampManager.tblActions.updateUI();
            JOptionPane.showMessageDialog(null,strPanelTitle);
            dispose();
        }});
    }
    
    private void InsertRow(Vector vecRowElements){
     
        final UniversalTableRow uniTableRow = new UniversalTableRow(vecRowElements);
            javax.swing.SwingUtilities.invokeLater(new Runnable(){
                public void run()
            {
                ((UniversalTableModel)CampManager.tblActions.getModel()).addObject((Object)uniTableRow);
                CampManager.tblActions.updateUI();
                JOptionPane.showMessageDialog(null,strPanelTitle);                
                dispose();
            }});
    }
    
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabel2 = new javax.swing.JLabel();
        editHgh = new javax.swing.JTextField();
        editDisc = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        editLow = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        editStockName = new javax.swing.JComboBox();
        jLabel5 = new javax.swing.JLabel();
        editFromDate = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        editToDate = new javax.swing.JTextField();
        jPanel1 = new javax.swing.JPanel();
        buttonSubmit = new javax.swing.JButton();
        jButton1 = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Add Campaigns");
        jLabel2.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel2.setText("High Qty");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 11;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel2, gridBagConstraints);

        editHgh.setFont(new java.awt.Font("MS Sans Serif", 0, 13));
        editHgh.setMinimumSize(new java.awt.Dimension(11, 21));
        editHgh.setPreferredSize(new java.awt.Dimension(50, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 0);
        getContentPane().add(editHgh, gridBagConstraints);

        editDisc.setFont(new java.awt.Font("Tahoma", 0, 13));
        editDisc.setMinimumSize(new java.awt.Dimension(40, 21));
        editDisc.setPreferredSize(new java.awt.Dimension(50, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 10);
        getContentPane().add(editDisc, gridBagConstraints);

        jLabel4.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel4.setText("Discount");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 8;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel4, gridBagConstraints);

        editLow.setFont(new java.awt.Font("Tahoma", 0, 13));
        editLow.setMinimumSize(new java.awt.Dimension(50, 21));
        editLow.setPreferredSize(new java.awt.Dimension(50, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 0);
        getContentPane().add(editLow, gridBagConstraints);

        jLabel6.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel6.setText("Low Qty");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel6, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel1.setText("Name");
        jLabel1.setMinimumSize(new java.awt.Dimension(50, 18));
        jLabel1.setPreferredSize(new java.awt.Dimension(50, 18));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(jLabel1, gridBagConstraints);

        editStockName.setPreferredSize(new java.awt.Dimension(230, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(editStockName, gridBagConstraints);

        jLabel5.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel5.setText("Date From");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 26;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(jLabel5, gridBagConstraints);

        editFromDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        editFromDate.setMinimumSize(new java.awt.Dimension(100, 21));
        editFromDate.setPreferredSize(new java.awt.Dimension(100, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 0);
        getContentPane().add(editFromDate, gridBagConstraints);

        jLabel7.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jLabel7.setText("Date To");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.ipadx = 9;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 20, 0, 0);
        getContentPane().add(jLabel7, gridBagConstraints);

        editToDate.setFont(new java.awt.Font("Tahoma", 0, 13));
        editToDate.setMinimumSize(new java.awt.Dimension(100, 21));
        editToDate.setPreferredSize(new java.awt.Dimension(100, 21));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 20, 0, 0);
        getContentPane().add(editToDate, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        jPanel1.setMinimumSize(new java.awt.Dimension(182, 27));
        jPanel1.setPreferredSize(new java.awt.Dimension(182, 27));
        buttonSubmit.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        buttonSubmit.setText("Submit");
        buttonSubmit.setAlignmentX(0.5F);
        buttonSubmit.setMargin(new java.awt.Insets(1, 5, 2, 4));
        buttonSubmit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                AddCampDialog.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 12;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 20);
        jPanel1.add(buttonSubmit, gridBagConstraints);

        jButton1.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        jButton1.setAlignmentX(0.5F);
        jButton1.setLabel("Cancel");
        jButton1.setMargin(new java.awt.Insets(1, 5, 2, 4));
        jButton1.setMaximumSize(new java.awt.Dimension(55, 25));
        jButton1.setMinimumSize(new java.awt.Dimension(55, 25));
        jButton1.setPreferredSize(new java.awt.Dimension(55, 25));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 16;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 20, 0, 0);
        jPanel1.add(jButton1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 6;
        gridBagConstraints.gridwidth = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        getContentPane().add(jPanel1, gridBagConstraints);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents
        
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        dispose();
    }//GEN-LAST:event_jButton1ActionPerformed
            
    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource()==buttonSubmit){
            if(!UniversalInputVerifier.DATE_Verifier(editFromDate) || editFromDate.getText().length()==0){
                JOptionPane.showMessageDialog(null,"Please, enter valid 'from' date!");
                return;
            }
            if(!UniversalInputVerifier.DATE_Verifier(editToDate) || editToDate.getText().length()==0){
                JOptionPane.showMessageDialog(null,"Please, enter valid 'to' date!");
                return;
            }
            if( SharedUtils.compareDates(editToDate.getText(),editFromDate.getText()) < 0) {                
                JOptionPane.showMessageDialog(null,"End Date cannot be smaller that start date!");
                return;
            }
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editLow) || editLow.getText().length()==0){
                JOptionPane.showMessageDialog(null,"Please, enter valid Low Qty!");
                return;
            }
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editHgh) || editHgh.getText().length()==0){
                JOptionPane.showMessageDialog(null,"Please, enter valid High Qty!");
                return;
            }
            if(!UniversalInputVerifier.Universal_Integer_Verifier(editDisc) || editDisc.getText().length()==0 || Integer.parseInt(editDisc.getText())>100){
                JOptionPane.showMessageDialog(null,"Please, enter valid Discount!");
                return;
            }
            if(bAddNewStock){                
                InsertCamp();
                
            }
            else{
                UpdateCamp();
                
            }
        }                
    }//GEN-LAST:event_actionPerformed
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JButton buttonSubmit;
    private javax.swing.JTextField editDisc;
    private javax.swing.JTextField editFromDate;
    private javax.swing.JTextField editHgh;
    private javax.swing.JTextField editLow;
    private javax.swing.JComboBox editStockName;
    private javax.swing.JTextField editToDate;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JPanel jPanel1;
    // End of variables declaration//GEN-END:variables
    
}
