package adminmodul;

import adminmodul.campaign.*;
import java.awt.*;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import javax.swing.table.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.TableModelListener;
import java.awt.event.*;

public class CampManager extends javax.swing.JFrame {

    private Component parent;
    
    public CampManager(Component parent) {
       
        initComponents();
        afterInitComponents();
        
        setLocationRelativeTo(this);
        this.parent = parent;
        try{
            CampUtils cu = new CampUtils();
            TableModel tm = cu.getTableModel();
            tblActions = new javax.swing.JTable(tm);            
            tblActions.getTableHeader().setReorderingAllowed(false);
            tblActions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            scrAllStocks.setViewportView(tblActions);
            
            tblActions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });
        }
        catch(Exception ex){
            System.out.println(ex.getMessage());
        }
    }

    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        labelAllStocks = new javax.swing.JLabel();
        scrAllStocks = new javax.swing.JScrollPane();
        tblActions = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        btnAddStock = new javax.swing.JButton();
        btnEditStock = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Campaigns List");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        labelAllStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        labelAllStocks.setText("All Stocks");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 38;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 0, 0);
        getContentPane().add(labelAllStocks, gridBagConstraints);

        scrAllStocks.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        tblActions.setFont(new java.awt.Font("Tahoma", 0, 13));
        tblActions.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        tblActions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });

        scrAllStocks.setViewportView(tblActions);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(2, 10, 0, 10);
        getContentPane().add(scrAllStocks, gridBagConstraints);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        btnAddStock.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnAddStock.setText("Add");
        btnAddStock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CampManager.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel1.add(btnAddStock, gridBagConstraints);

        btnEditStock.setFont(new java.awt.Font("MS Sans Serif", 1, 13));
        btnEditStock.setText("Edit");
        btnEditStock.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CampManager.this.actionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(10, 10, 10, 10);
        jPanel1.add(btnEditStock, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        getContentPane().add(jPanel1, gridBagConstraints);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-931)/2, (screenSize.height-353)/2, 931, 353);
    }
    // </editor-fold>//GEN-END:initComponents

    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        if(parent!=null)
            parent.setVisible(true);
    }//GEN-LAST:event_formWindowClosed

    private void tblActionsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tblActionsMouseClicked
        if ((evt.getModifiers() & InputEvent.BUTTON1_MASK) != 0 && evt.getClickCount()>1) {
           editStock();
        }
    }//GEN-LAST:event_tblActionsMouseClicked

    private void actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_actionPerformed
        if(evt.getSource() == btnAddStock)
        {           
            AddCampDialog dlgAddStock = new AddCampDialog(new JFrame(),true, null,-1);
            dlgAddStock.show();
        }
        else if(evt.getSource() == btnEditStock)
        {
           editStock();
        }        
    }//GEN-LAST:event_actionPerformed

    private void editStock()
    {
        try{
            int nStockTableSelRow = tblActions.getSelectedRow();
            
            if(nStockTableSelRow < 0)
            {
                JOptionPane.showMessageDialog(null,"Please select stock from the table above!");
                return;
            }
            UniversalTableRow trowSelected = ((UniversalTableModel)tblActions.getModel()).getRowObject(nStockTableSelRow);        
            AddCampDialog dlgAddStock = new AddCampDialog(new JFrame(),true, trowSelected, nStockTableSelRow);
            dlgAddStock.show();
        }
        catch(Exception e){
            System.out.println("editStock() " + e.getMessage());
            e.printStackTrace();
        }
    }
    
    public void afterInitComponents()
    {
        setLocationRelativeTo(this);
        
        try{
            CampUtils cu = new CampUtils();
            TableModel tm = cu.getTableModel();
            tblActions = new javax.swing.JTable(tm);            
            tblActions.getTableHeader().setReorderingAllowed(false);
            tblActions.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            scrAllStocks.setViewportView(tblActions);
            
            tblActions.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tblActionsMouseClicked(evt);
            }
        });
        }
        catch(Exception ex){
            System.out.println(ex.getMessage());
        }
                
    }
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddStock;
    private javax.swing.JButton btnEditStock;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel labelAllStocks;
    private javax.swing.JScrollPane scrAllStocks;
    public static javax.swing.JTable tblActions;
    // End of variables declaration//GEN-END:variables

}
