/*
 * SharedUtils.java
 *
 * Created on , 2005,  27, 14:01
 */

package adminmodul;

import java.awt.Color;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.Timestamp;
import java.util.*;
import java.io.*;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.table.TableColumn;
import javax.swing.table.TableModel;

/**
 *
 * @author JohnyEdu
 */
public class SharedUtils implements SharedConstants {
    
    private static Connection connPermamentDB = null;
    public static Color bgColor = new Color(219,209,183);
    public static Color bgLightColor = new Color(150,220,255);
    public static int nUserID = -1;
    public static String strUsername=null;
    ////////////////////////////////////////////////////////
    // Properties file settings
    ////////////////////////////////////////////////////////
    //database settings
    public static String dbUserName = "medstore";
    public static String dbPassword = "medstore";
    public static String databaseUrlPort = "1433";
    public static String databaseName = "medstore";
    public static String databaseUrl = "localhost";
    
     /*******************************************************************************
     *                                                                             *
     *         Database related functions                    
     *                                                                             *
     *******************************************************************************/
    /*public static Connection DBConnect(String strConnectionString)
    {        
        if(connPermamentDB != null)
            return connPermamentDB;
        Connection dbConn = null;
        try
        {
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver").newInstance();            
            dbConn=DriverManager.getConnection(connectionString,username,password);
            //JOptionPane.showMessageDialog(null,String.valueOf(dbConn.getTransactionIsolation()));
        }
        catch(SQLException sqle)
        {            
            return null;
        }
        catch(ClassNotFoundException cnfe)
        {            
            JOptionPane.showMessageDialog(null,"The system cannot find it's database driver");
            return null;
        }        
        catch(InstantiationException inste)
        {            
            JOptionPane.showMessageDialog(null,"The system encountered a problem while loading one of it's components");
            return null;
        }
        catch(IllegalAccessException acce)
        {            
            //JOptionPane.showMessageDialog(null,"The system encountered a problem while loading one of it's components");
            return null;
        }
        connPermamentDB = dbConn;        
        return dbConn;
    }
    
    public static Connection DBConnect(String strConnectionString , boolean bPooled)
    {        
        Connection dbConn = null;
        try
        {
            if((connPermamentDB != null) && bPooled && !connPermamentDB.isClosed())
                return connPermamentDB;                    
            Class.forName("sun.jdbc.odbc.JdbcOdbcDriver").newInstance();            
            dbConn=DriverManager.getConnection(strConnectionString,username,password);
            //JOptionPane.showMessageDialog(null,String.valueOf(dbConn.getTransactionIsolation()));
        }
        catch(SQLException sqle)
        {            
            return null;
        }
        catch(ClassNotFoundException cnfe)
        {            
            JOptionPane.showMessageDialog(null,"The system cannot find it's database driver");
            return null;
        }
        
        catch(InstantiationException inste)
        {            
            JOptionPane.showMessageDialog(null,"The system encountered a problem while loading one of it's components");
            return null;
        }
        catch(IllegalAccessException acce)
        {            
            //JOptionPane.showMessageDialog(null,"The system encountered a problem while loading one of it's components");
            return null;
        }
        connPermamentDB = dbConn;        
        return dbConn;
    }*/
    
    public static Connection getConnection()
    {
        return msConnect();
    }
    
    public static Connection msConnect()
    {
         java.sql.Connection  con = null;
         String url = "jdbc:microsoft:sqlserver://";
         //String selectMethod = "cursor";
         String fullUrl = url + databaseUrl + ":" + databaseUrlPort + 
                 ";databaseName=" + databaseName + ";";
         try
         {
             Class.forName("com.microsoft.jdbc.sqlserver.SQLServerDriver");
             Properties props = new Properties();
             props.setProperty("user", dbUserName );
             props.setProperty("password", dbPassword );
             props.setProperty("charSet", "ISO-8859-1" );
             props.setProperty("useUnicode", "true");
             props.setProperty("SendStringParametersAsUnicode", "true");   
             con = java.sql.DriverManager.getConnection(fullUrl,props);             
         }
         catch(Exception e)
         {
               e.printStackTrace();
               System.out.println("Error Trace in getConnection() : " + e.getMessage() );
               JOptionPane.showMessageDialog(null,e.getMessage() + "---" + fullUrl);
         }
         return con;
    }
    
    public static void loadProperties()
   {
       String userHomePath = (String)System.getProperty("user.home");
       String pathSeparator = (String)System.getProperty("file.separator");
       String fullName = userHomePath + pathSeparator + "medstoreadmin.properties";
       try
       {
           File f = new File( fullName );
           if( f.exists() )
           {
               FileInputStream istream = new FileInputStream( f );
               Properties props = new Properties();
               props.load(istream);
               istream.close();
               
               //username = props.getProperty("username");
               //password = props.getProperty("password");    
               databaseName = props.getProperty("databaseName"); 
               databaseUrl = props.getProperty("databaseUrl"); 
               databaseUrlPort = props.getProperty("databaseUrlPort");                             
           }
           else
           {
               createPropertiesFile(null,f);
           }           
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
   }   
   
   private static void createPropertiesFile(Properties props, File f)
      throws Exception
   {
       FileOutputStream ostream = new FileOutputStream( f );
       if( props == null )
       {
           props = new Properties();
           //props.setProperty("username" , username );
           //props.setProperty("password" , password );
           props.setProperty("databaseName" , databaseName );
           props.setProperty("databaseUrl" , databaseUrl ); 
           props.setProperty("databaseUrlPort" , databaseUrlPort );
       }
       props.store(ostream,"");
       ostream.close();       
   }
    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////////
    public static ResultSet executeSelect(Connection dbConn,String strSQL)
    {
        Statement stm = null; 
        ResultSet rs = null;
        if(dbConn == null || strSQL == null)
            return null;
        try
        {
            stm = dbConn.createStatement();
        }
        catch(SQLException sqle)
        {
            //dbConn.close();
            return null;
        }                
        try
        {
            rs=stm.executeQuery(strSQL);
            //stm.close();
        }
        catch(SQLException sqle)
        {
           stm=null;
           return null; 
        }
                        
        return rs;
    }
    
    public static String getLastInsertedID(Connection connDB){
        String strLastOrdrID = null;
        String strSQL = "SELECT SCOPE_IDENTITY() AS LAST_IDNT";                 
        try{
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL); 
            boolean bMore = rsDBData.next();
            if(bMore){ 
                strLastOrdrID = rsDBData.getString("LAST_IDNT");
            }                       
            else{
               // JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
               // return null;
            }
           
        }catch(Exception e){
           // JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
            e.printStackTrace();
            return null;
        }        
        return strLastOrdrID;
    }      
    
     public static int recordExists(Connection connDB,String strSQL){                 
        try{
            Statement stm = connDB.createStatement();
            ResultSet rsDBData=stm.executeQuery(strSQL);    
            boolean bMore = rsDBData.next();
            rsDBData.close();
            stm.close();
            if(bMore){ 
                return DB_RECORD_EXISTS;
            }                       
            else{                
                return DB_RECORD_DONTEXISTS;
            }
        }catch(Exception e){
            JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later");
            return DB_ERROR;
        }
        //return DB_RECORD_DONTEXISTS;
    }  
    public static UniversalTableModel setTableDBModel(JTable table, String strSQL, String[] strrgnColumnNames)
    {
        Connection connDB = null;
        try
        {
            connDB = SharedUtils.getConnection();  
            ResultSet rsDBData=null;
            Statement stm=null;
            if(strSQL!=null){
                try{
                    stm = connDB.createStatement();
                    rsDBData=stm.executeQuery(strSQL);  
                }catch(SQLException sqle){
                    SharedUtils.handleError(GENERAL_DB_ERROR);            
                }
            }
            UniversalTableModel tbmOrders = new UniversalTableModel(rsDBData,strrgnColumnNames);
            table.setModel(tbmOrders);
            table.updateUI();
            if(rsDBData!=null){
                try{
                    rsDBData.close();
                    stm.close();
                }catch(SQLException sqle){
                    SharedUtils.handleError(GENERAL_DB_ERROR);            
                }
            }
            return tbmOrders;
        }
        finally
        {
            closeConnection( connDB );
        }
    }
     /*******************************************************************************
     *                                                                              *
     *         Date - Time functions                    
     *                                                                              *
     *******************************************************************************/ 
    
   public static String getCurrentDateStringFormatted()
   {
        Calendar calendar = Calendar.getInstance();          
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month); 
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day); 
        if(day < 10 )
            strDay = "0" + strDay;
        
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
        
        String strHour = String.valueOf(hour); 
        if(hour < 10 )
            strHour = "0" + strHour;
        String strMinute = String.valueOf(minute); 
        if(minute < 10 )
            strMinute = "0" + strMinute;
        String strSecond = String.valueOf(second); 
        if(second < 10 )
            strSecond = "0" + strSecond;
        return  String.valueOf(year)  + "." + strMonth  + "." + strDay + 
               " " +  strHour + ":" + strMinute + ":" + strSecond;
    }
   public static String getCurrentOnlyDateStringFormatted()
   {
        Calendar calendar = Calendar.getInstance();          
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month); 
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day); 
        if(day < 10 )
            strDay = "0" + strDay; 
        String strYear = String.valueOf(year).substring(2);
        return strDay + "." + strMonth + "." + strYear;
    }
   public static String getCurrentDateUnixTimestamp()
   {
        Calendar calendar = Calendar.getInstance();          
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month); 
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day); 
        if(day < 10 )
            strDay = "0" + strDay;
        
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
        
        String strHour = String.valueOf(hour); 
        if(hour < 10 )
            strHour = "0" + strHour;
        String strMinute = String.valueOf(minute); 
        if(minute < 10 )
            strMinute = "0" + strMinute;
        String strSecond = String.valueOf(second); 
        if(second < 10 )
            strSecond = "0" + strSecond;
        return  String.valueOf(year)   + strMonth  + strDay + 
                strHour +  strMinute +  strSecond;
    }
    public static java.sql.Date getCurrentDateSQL()
    {
        Calendar calendar = Calendar.getInstance(); 
        return new java.sql.Date(calendar.getTimeInMillis());
    }
    public static java.sql.Timestamp getCurrentTimestamp()
    {
        Calendar calendar = Calendar.getInstance();          
        /*
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);                                  
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);        
         */
        return new java.sql.Timestamp(calendar.getTimeInMillis());
    }
    public static String getStringFromTimestamp(Timestamp tmsp){
        long millis = tmsp.getTime();
        Calendar calendar = Calendar.getInstance(); 
        calendar.setTimeInMillis(millis);
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR);
        String strMonth = String.valueOf(month); 
        if(month < 10 )
            strMonth = "0" + strMonth;
        String strDay = String.valueOf(day); 
        if(day < 10 )
            strDay = "0" + strDay;
        
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
        
        String strHour = String.valueOf(hour); 
        if(hour < 10 )
            strHour = "0" + strHour;
        String strMinute = String.valueOf(minute); 
        if(minute < 10 )
            strMinute = "0" + strMinute;
        String strSecond = String.valueOf(second); 
        if(second < 10 )
            strSecond = "0" + strSecond;
        return  String.valueOf(year)  + "." + strMonth  + "." + strDay + 
               " " +  strHour + ":" + strMinute + ":" + strSecond;
        
    }
    public static String[] parseDateString(String strInput){
        strInput = strInput.replace('-', '.');  
        String dateFields[] = strInput.split("\\.");
        int dfCount = dateFields.length;
        for(int i = 0; i < dfCount; i++){           
            //if(dateFields[i].length()>2)
                //dateFields[i] = dateFields[i].substring(0, 1);
            if(dateFields[i].length()<2)
                dateFields[i]="0" + dateFields[i];
            if(i==2){
                if(dateFields[2].length()==4)
                    dateFields[2] = dateFields[2].substring(2);
            }
        }
        
        String strCurrentDate = SharedUtils.getCurrentOnlyDateStringFormatted();
        String currDateFields[] = strCurrentDate.split("\\.");
        int cdfCount = currDateFields.length;
        String strFormattedDate="";
        for(int i = 0; i < cdfCount; i++){
            if(i < dfCount)
                currDateFields[i] = dateFields[i];          
        } 
        return currDateFields;
         
    }
    
    
     
     /*******************************************************************************
     *                                                                              *
     *         GUI functions                    
     *                                                                              *
     *******************************************************************************/
     
    public static void setTableColumnsWidth(JTable table,int[] widths){
        int columns = widths.length;
        for(int i=0;i<columns;i++){
            TableColumn col = table.getColumnModel().getColumn(i);
            col.setPreferredWidth(widths[i]);
        }
        table.updateUI();
    }
    public static void sortTableBySingleColumn(JTable table, int nColIndex, int elIndex, boolean ascending){
        TableModel model = table.getModel();
        Vector data = ((UniversalTableModel)model).getDataVector();
        Collections.sort(data, new TableSingleColumnSorter(nColIndex,elIndex,ascending));
        table.updateUI();

    }
    
    
    
    /*******************************************************************************
     *                                                                             *
     *         Error functions                    
     *                                                                             *
     *******************************************************************************/
            
    public static void handleError(int nErrorCode){
        switch(nErrorCode){
            
            case UNKNOWN_BARCODE:                     JOptionPane.showMessageDialog(null,"The Barcode, you are trying to use is not registered in the system!");
                                                      break;
                
            case INVALID_BALANCE:                     JOptionPane.showMessageDialog(null,"You cant' move out more stocks that you have on hand!");
                                                      break;
                
            case STOCK_COUNT_IN_STOR_INSERT_ERROR:    JOptionPane.showMessageDialog(null,"Database error - please restart!");
                                                      break;
                
            case STOCK_COUNT_IN_STOR_UPDATE_ERROR:    JOptionPane.showMessageDialog(null,"Database error - please restart!");
                                                      break;
                
            case STOCK_COUNT_IN_STOR_DELETE_ERROR:    JOptionPane.showMessageDialog(null,"Database error - please restart!");
                                                      break;
                
            case INVALID_OPCODE:                      JOptionPane.showMessageDialog(null,"You are trying to execute invalida operation!");
                                                      break;
                
            case INSERT_EVENT_ERROR:                  JOptionPane.showMessageDialog(null,"Database error - please restart!");
                                                      break;                                                
                
            case STOCK_COUNT_IN_EVENT_INSERT_ERROR:   JOptionPane.showMessageDialog(null,"Database error - please restart!");
                                                      break;   
            
            case EVENT_FOR_STORNO_NOT_FOUND :         JOptionPane.showMessageDialog(null,"There is no information for this event to storno!");
                                                      break;
            
            case STORNO_UPDATE_EVENT_TABLE_ERROR :    JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
                                                      break;
            
            case INSERT_TRANSACTION_EVENT_ERROR :     JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
                                                      break;
            
            case INSERT_EVENTS_IN_TRAN_ERROR :        JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
                                                      break;
            
            case NO_EVENTS_FOR_TRAN_FOUND :           JOptionPane.showMessageDialog(null,"No events associated with this operation are found!");
                                                      break;
            
            case UNPACK_AGAINST_ATOMIC_STOCK_ERROR : JOptionPane.showMessageDialog(null,"You cannot use unpack operation against atomic stock!");
                                                      break;   
            
            case GENERAL_DB_ERROR :                   JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
                                                      break;
            
            case INTERNAL_SYSTEM_ERROR :              JOptionPane.showMessageDialog(null,"There is an internal system error!Please restart this application and try again.");
                                                      break;
            
            default:                                  JOptionPane.showMessageDialog(null,"There is a problem with the database server!Please try again later.");
                                                      break;
        }
    }
    
     public static String getCurrentTimeString()
     {
        Calendar calendar = Calendar.getInstance(); 
        int hour = calendar.get(Calendar.HOUR_OF_DAY);
        int minute = calendar.get(Calendar.MINUTE);
        int second = calendar.get(Calendar.SECOND);
        
        String strHour = String.valueOf(hour); 
        if(hour < 10 )
            strHour = "0" + strHour;
        String strMinute = String.valueOf(minute); 
        if(minute < 10 )
            strMinute = "0" + strMinute;
        String strSecond = String.valueOf(second); 
        if(second < 10 )
            strSecond = "0" + strSecond;
        return  strHour + ":" + strMinute + ":" + strSecond;
   }
     
   public static void closeConnection(Connection conn)
   {
       if( conn == null )              
           return;
       try
       {
           conn.close();
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
   }
   public static void rollConnection(Connection conn)
   {
       if( conn == null )              
           return;
       try
       {
           conn.rollback();
           conn.close();
       }
       catch(Exception e)
       {
           e.printStackTrace();
       }
   }
   public static int compareDates( String date1, String date2 )
   {
       String d1[] = date1.split("\\.");
       String d2[] = date2.split("\\.");
       int dif = Integer.parseInt(d1[2]) - Integer.parseInt(d2[2]);
       if( dif != 0 )
           return dif;
       dif = Integer.parseInt(d1[1]) - Integer.parseInt(d2[1]);
       if( dif != 0 )
           return dif;
       dif = Integer.parseInt(d1[0]) - Integer.parseInt(d2[0]);
       return dif;
   }
   
   public static String getToDate( String strTextDateTo )
   {
        String[] dateFields = strTextDateTo.split("\\.");
        int nToDay = Integer.parseInt(dateFields[0]);
        int nToMonth = Integer.parseInt(dateFields[1]);
        int nToYear = Integer.parseInt(dateFields[2]);        
              
       
        strTextDateTo = nToMonth + "." + nToDay + "." + nToYear;
        return strTextDateTo;
   }
}
