/*
 * UniversalTableModel.java
 *
 * Created on , 2005,  3, 10:44
 */

package adminmodul;

import java.math.BigDecimal;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Timestamp;
import java.sql.Types;
import java.util.Vector;
import javax.swing.JOptionPane;
import javax.swing.table.AbstractTableModel;
import javax.swing.table.TableModel;

/**
 *
 * @author JohnyEdu
 */
public class UniversalTableModel extends AbstractTableModel implements TableModel,SharedConstants{
    private ResultSet rsSQLResult;
    private ResultSetMetaData resultsMetaData;
    private Vector vecData;
    private String[] rgnstrColumnNames;
    private int nColumnCount;
    private int nTotalDBAttributes;
    private Vector vecEditable;
    /** Creates a new instance of UniversalTableModel */
    
    public UniversalTableModel(Vector data,String[] columnNames) {
        vecData = new Vector();      
        try{
            if(data != null){                
                nColumnCount = columnNames.length;   
                vecEditable = new Vector(nColumnCount);
                rgnstrColumnNames = new String[nColumnCount];                                
                for(int i=0; i<nColumnCount ;i++){   
                        rgnstrColumnNames[i] = columnNames[i];
                        vecEditable.addElement(new Boolean(false));
                }
                vecData = data;
                System.out.println(data.size());
            }      
            else{
               
            }
        }     
        catch(Exception e){
            System.out.println(e.getMessage());
        }
    }
    
    public UniversalTableModel(ResultSet rsSQLResult,String[] columnNames) {
        vecData = new Vector();       
        this.rsSQLResult = rsSQLResult; 
        //this.nTotalDBAttributes = nTotalDBAttributes;
        nColumnCount = columnNames.length;   
        vecEditable = new Vector(nColumnCount);
        rgnstrColumnNames = new String[nColumnCount];                                
        for(int i=0; i<nColumnCount ;i++){   
                rgnstrColumnNames[i] = columnNames[i];
                vecEditable.addElement(new Boolean(false));
        }
        if(rsSQLResult != null){            
            try{                
                    ResultSetMetaData resultsMetaData = rsSQLResult.getMetaData();
                    this.nTotalDBAttributes = resultsMetaData.getColumnCount();                
                    boolean bMore = this.rsSQLResult.next();                 
                    while( bMore )
                    {
                           Vector vecRowElements = new Vector(nTotalDBAttributes);
                           for(int i = 1; i < nTotalDBAttributes + 1; i++)
                           {
                               String strColumnElement="";                                
                               if(resultsMetaData.getColumnTypeName(i).equals("smallmoney")){
                                   BigDecimal bdm = rsSQLResult.getBigDecimal(i);
                                   bdm = bdm.setScale(2, BigDecimal.ROUND_HALF_UP);
                                   strColumnElement = bdm.toString();
                               }
                               else if(resultsMetaData.getColumnType(i)==Types.TIMESTAMP){
                                    Timestamp tmsp = this.rsSQLResult.getTimestamp(i);
                                    strColumnElement = SharedUtils.getStringFromTimestamp(tmsp);
                               }
                               else if(resultsMetaData.getColumnType(i)==Types.FLOAT){
                                    float  fv = this.rsSQLResult.getFloat(i);
                                    strColumnElement = String.valueOf(fv);                                    
                               }
                               else
                                    strColumnElement = this.rsSQLResult.getString(i);
                                if(strColumnElement == null)
                                    strColumnElement="";
                                vecRowElements.addElement(strColumnElement);
                           }
                           UniversalTableRow  uniTableRow = new UniversalTableRow(vecRowElements);
                           vecData.add(uniTableRow);
                           bMore = this.rsSQLResult.next();
                    }
            //rsSQLResult.close();        
            }catch(SQLException sqle){  JOptionPane.showMessageDialog(null,sqle.toString());  } 
             catch(NullPointerException npe){ JOptionPane.showMessageDialog(null,npe.toString());  }
        }
    }
    
    public void clearData(){
        if(vecData !=null)    
            vecData.removeAllElements();
    }
    public Vector getDataVector()
    {
        return vecData;
    }
    public int getColumnCount() {               
        if(rgnstrColumnNames!=null)
              return rgnstrColumnNames.length; 
        return 0;                
    }
    
    public void addObject(Object value){
        if(vecData !=null)
            vecData.addElement(value);       
    }
    public void removeItemAt(int index){
       if(vecData != null) 
            vecData.removeElementAt(index);          
   }
    public synchronized UniversalTableRow getRowObject(int row){
        if ( vecData != null && row>=0 && row < vecData.size() )
            return ((UniversalTableRow)vecData.get(row));   
        return null;          
    }
    public synchronized void setRowObject(Object value,int row){
        if ( vecData != null && row>=0 && row < vecData.size() )
            vecData.setElementAt(value,row);                    
    }
    public int getRowCount() {
        if(vecData!=null)
                return vecData.size();
        return 0;        
    }

    public String getColumnName(int col) {       
        if(rgnstrColumnNames != null)
            return rgnstrColumnNames[col]; 
        return null;
    }

    public Object getValueAt(int row, int col) {
        if(vecData!=null)
        {                                                                        
           return  ((UniversalTableRow)getRowObject(row)).vecRowElements.get(col);    
        }
        return null;
    }

    public Class getColumnClass(int c) {
        if(vecData!=null){            
                return getValueAt(0, c).getClass();            
        }                
        return null;        
    }

    public boolean isCellEditable(int row, int col) {
       return ((Boolean)vecEditable.get(col)).booleanValue();
    }

    public void setValueAt(Object value, int row, int col) {
  
        if ( vecData != null && row >= 0 && row < vecData.size())
        {                                                               
             ((UniversalTableRow)vecData.elementAt(row)).vecRowElements.setElementAt(value,col);                                                                        
             fireTableCellUpdated(row, col); 
        }
        
      }
    
   // should be considered situation where object is not a String
   public boolean objectExistsAt(Object elem, int col){
        if(vecData ==null)
            return false;
        int nRowCount = getRowCount();
        for(int i=0; i< nRowCount; i++){
            if(((String)getRowObject(i).getRowElement(col)).equals(elem) )
                return true;
        }
        return false;
   }
   public void insertItem(Object value){
       if(vecData != null)   
          vecData.insertElementAt(value,0);
  } 
   public int getContentIndex(int col,Object value){
       if(vecData == null)
           return -1;
       int nRowCount = vecData.size();
       for(int i=0;i<nRowCount;i++){
           if( ((String)getValueAt(i,col)).equals((String)value))
               return i;
       }
       return -1;
   }
   public void setEditableCells(Vector cellsToEdit){
       int rows = vecEditable.size();
       for(int i = 0; i< rows; i++){
           vecEditable.setElementAt(cellsToEdit.get(i),i);
       }
   } 
   public void setEditableCells(Object cellsToEdit[]){
       int rows = vecEditable.size();
       for(int i = 0; i< rows; i++){
           vecEditable.setElementAt(cellsToEdit[i],i);
       }
   } 
   public int getStateAtRow(int row) {
        if(vecData!=null)
        {                                                                        
            return  ((UniversalTableRow)getRowObject(row)).nRowState;    
        }
        return -1;
    }
   public void setStateAtRow(int row,int state) {
        if(vecData!=null)
        {                                                                        
           ((UniversalTableRow)getRowObject(row)).nRowState = state;    
        }
        
    }
   public void convertIntToBooleanAt(int col){
       int rows = getRowCount();
       for(int i = 0; i< rows; i++){
           int value = Integer.parseInt((String)getValueAt(i, col));
           if(value==MENU_ALLOWED)
               setValueAt(new Boolean(true), i, col);
           else
               setValueAt(new Boolean(false), i, col);
       }
       
   }
   public void removeAt(int index){
       try{
           vecData.removeElementAt(index);
           
       }
       catch(Exception e){
           
       }
   }
}
