package adminmodul;

import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.ListSelectionModel;

import adminmodul.accesscontrol.*;
import adminmodul.menucontrol.*;
import java.awt.Component;
import java.util.ArrayList;

public class UserAdd extends javax.swing.JFrame{
    private Component parent;
    private int rbtnType = -1;
    
    private UserData userData;
    
    public final int MENU_NAMEINDEX =0;
    public final int PERM_INDEX =1;
    public final int USER_INDEX =2;
    public final int MENU_INDEX =3;
    
    public UserAdd(Component parent) {
        initComponents();
        setLocationRelativeTo(this);
        this.parent = parent;
        
        try {
            userData = new UserData();
            initCombo();
        } catch(Exception e) {
            
        }
        
    }
    private void init(){
        try{
            
            int id = ((ComboDataModel)cboUsers.getModel()).getCObjectAt(cboUsers.getSelectedIndex()).nItemDBKey;
            
            userData.setId(id);
            
            initTable();
            loadNewUser(id);
            loadPrems();
            txtUsername.setText(userData.getUserName());
            txtPassword.setText(userData.getUserPass());
            txtAbbr.setText(userData.getAbbr());
            
        } catch(Exception e){
            JOptionPane.showMessageDialog(null,e.getMessage());
            e.printStackTrace();
        }
    }
    private void initCombo(){
        try {
            
            cboUsers.setModel(userData.getUserPerm().getUsersComboDataModel());
            init();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    private boolean initTable(){
        
        
        try{
            MenuUtils menuUtils = new MenuUtils();
            
            UniversalTableModel tbmPerms = menuUtils.getTableModel();
            tbmPerms.convertIntToBooleanAt(1);
            Boolean b_rgn_Cells[] = {new Boolean(false),new Boolean(true)};
            tbmPerms.setEditableCells(b_rgn_Cells);
            tblPerms = new javax.swing.JTable(tbmPerms);
            tblPerms.getTableHeader().setReorderingAllowed(false);
            tblPerms.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
            scrPerms.setViewportView(tblPerms);
            
            
        }catch(Exception e){
            System.out.println("initTable " + e.getMessage());
            e.printStackTrace();
        }
        
        return false; //Not Use Yet
    }
    
    public void loadNewUser(int id) throws Exception{
        
        try{
            userData.getUser();
        } catch(Exception e){
            throw new Exception("Error loading new user!\n" + e.getMessage());
        }
        try {
            userData.getUserPerms();
        } catch (Exception e) {
            throw new Exception("Error loading user permission!\n" + e.getMessage());
        }
        
    }
    public void loadPrems(){
        
        ArrayList perms = userData.getPerms();
        
        int brPerms = perms.size();
        int rows = tblPerms.getRowCount();
        
        for(int i=0; i < brPerms; i++){
            PermData permData = (PermData)perms.get(i);
            if(permData.getPermStatus()!=1)
                continue;
            
            for(int j = 0; j < rows; j++){                
                boolean bPerm = ((Boolean)((UniversalTableRow)((UniversalTableModel)tblPerms.getModel()).getRowObject(j)).getRowElement(PERM_INDEX)).booleanValue();
                int nMenuId = Integer.parseInt((String)((UniversalTableRow)((UniversalTableModel)tblPerms.getModel()).getRowObject(j)).getRowElement(MENU_INDEX));
                
                if(permData.getId()==nMenuId){
                    ((UniversalTableRow)((UniversalTableModel)tblPerms.getModel()).getRowObject(j)).setRowElement(new Boolean(true),PERM_INDEX);
                }
            }
        }
    }
    public void insertUser() throws Exception{
        
        String user_name = txtUsername.getText();
        String user_pass = String.valueOf(txtPassword.getPassword());
        int user_type = 1;
        String user_abrv = txtAbbr.getText();
        int active_macro = 1;
        if(user_abrv ==null || user_abrv.length()<1 || user_abrv.length()>3){
            throw new Exception("Abbr must be 0 - 3 digits!");
        }
        if(user_name ==null || user_name.length()<1){
            throw new Exception("Username must be more than 0 digits!");
        }
        if(user_pass ==null || user_pass.length()<1){
            throw new Exception("Password must be more than 0 digits!");
        }
        userData = new UserData(user_name,user_pass,user_type, user_abrv,active_macro);
        
        setUserPerms();
        try{
            try{
                userData.setUserDb();
            } catch(Exception ex){
                throw new Exception("User can not be set!\n" + ex.getMessage());
            }
            try {
                userData.setPerms();
            } catch (Exception ex) {
                throw new Exception("User can not be set!\n" + ex.getMessage());
            }
            
            JOptionPane.showMessageDialog(null, "User & permissions was successfully applied!");
        } catch(Exception e){
            JOptionPane.showMessageDialog(null,"Error: " + e.getMessage());
        }
        
    }
    
    public void setUserPerms(){
        try {
            int rows = tblPerms.getRowCount();
            userData.setPerms(new ArrayList());
            for(int i=0; i < rows; i++){
                
                int nUser = Integer.parseInt((String)((UniversalTableRow)((UniversalTableModel)tblPerms.getModel()).getRowObject(i)).getRowElement(USER_INDEX));
                int nMenuId = Integer.parseInt((String)((UniversalTableRow)((UniversalTableModel)tblPerms.getModel()).getRowObject(i)).getRowElement(MENU_INDEX));
                String permDesc = (String)((UniversalTableRow)((UniversalTableModel)tblPerms.getModel()).getRowObject(i)).getRowElement(MENU_NAMEINDEX);
                
                int permStatus;
                boolean bPerm = ((Boolean)((UniversalTableRow)((UniversalTableModel)tblPerms.getModel()).getRowObject(i)).getRowElement(PERM_INDEX)).booleanValue();
                
                if(bPerm)
                    permStatus = 1;
                else
                    continue;
                
                PermData permData = new PermData(nMenuId, permDesc,permStatus);
                userData.setPerm(permData);
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    public void deleteUserPerms(){
        try {
            userData.setPerms(new ArrayList());
            userData.deleteUserPerms();
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    public void updateUser() throws Exception{
        int id = userData.getId();
        String user_name = txtUsername.getText();
        String user_pass = String.valueOf(txtPassword.getPassword());
        int user_type = 1;
        String user_abrv = txtAbbr.getText();
        int active_macro = 1;
        if(user_abrv ==null || user_abrv.length()<1 || user_abrv.length()>3){
            throw new Exception("Abbr must be 0 - 3 digits!");
        }
        if(user_name ==null || user_name.length()<1){
            throw new Exception("Username must be more than 0 digits!");
        }
        if(user_pass ==null || user_pass.length()<1){
            throw new Exception("Password must be more than 0 digits!");
        }
        userData = new UserData(id,user_name,user_pass,user_type, user_abrv,active_macro);
        
        setUserPerms();
        userData.updateUser();
        ComboDataRow obj = new ComboDataRow(userData.getUserName(),userData.getId());
        ((ComboDataModel)cboUsers.getModel()).setObjectAt(obj,cboUsers.getSelectedIndex());
        cboUsers.updateUI();
        JOptionPane.showMessageDialog(null,"Update complete successfully");
    }
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        cboUsers = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        lblUsername = new javax.swing.JLabel();
        txtUsername = new javax.swing.JTextField();
        txtAbbr = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        lblPassword = new javax.swing.JLabel();
        txtPassword = new javax.swing.JPasswordField();
        jPanel2 = new javax.swing.JPanel();
        scrPerms = new javax.swing.JScrollPane();
        tblPerms = new javax.swing.JTable();
        jLabel3 = new javax.swing.JLabel();
        jPanel3 = new javax.swing.JPanel();
        btnNewUser = new javax.swing.JButton();
        btnConfirm = new javax.swing.JButton();
        cmdDelete = new javax.swing.JButton();

        getContentPane().setLayout(new java.awt.GridBagLayout());

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        jPanel1.setLayout(new java.awt.GridBagLayout());

        cboUsers.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        cboUsers.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cboUsersItemStateChanged(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 3, 0, 0);
        jPanel1.add(cboUsers, gridBagConstraints);

        jLabel2.setText("Select user:");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 3, 0, 0);
        jPanel1.add(jLabel2, gridBagConstraints);

        lblUsername.setFont(new java.awt.Font("Tahoma", 0, 11));
        lblUsername.setText("Username");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 3, 0, 0);
        jPanel1.add(lblUsername, gridBagConstraints);

        txtUsername.setFont(new java.awt.Font("Tahoma", 0, 11));
        txtUsername.setMinimumSize(new java.awt.Dimension(200, 20));
        txtUsername.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.insets = new java.awt.Insets(5, 3, 0, 0);
        jPanel1.add(txtUsername, gridBagConstraints);

        txtAbbr.setFont(new java.awt.Font("Tahoma", 0, 11));
        txtAbbr.setMinimumSize(new java.awt.Dimension(200, 20));
        txtAbbr.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(5, 7, 0, 0);
        jPanel1.add(txtAbbr, gridBagConstraints);

        jLabel1.setFont(new java.awt.Font("Tahoma", 0, 11));
        jLabel1.setText("Abbr.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 7, 0, 2);
        jPanel1.add(jLabel1, gridBagConstraints);

        lblPassword.setFont(new java.awt.Font("Tahoma", 0, 11));
        lblPassword.setText("Password");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 3, 0, 0);
        jPanel1.add(lblPassword, gridBagConstraints);

        txtPassword.setFont(new java.awt.Font("Tahoma", 0, 11));
        txtPassword.setMinimumSize(new java.awt.Dimension(200, 20));
        txtPassword.setPreferredSize(new java.awt.Dimension(200, 20));
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(5, 3, 0, 0);
        jPanel1.add(txtPassword, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 1, 3);
        getContentPane().add(jPanel1, gridBagConstraints);

        jPanel2.setLayout(new java.awt.GridBagLayout());

        scrPerms.setMinimumSize(new java.awt.Dimension(240, 330));
        scrPerms.setPreferredSize(new java.awt.Dimension(240, 340));
        tblPerms.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        scrPerms.setViewportView(tblPerms);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.insets = new java.awt.Insets(5, 0, 1, 0);
        jPanel2.add(scrPerms, gridBagConstraints);

        jLabel3.setFont(new java.awt.Font("Tahoma", 0, 11));
        jLabel3.setText("User Permissions");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.WEST;
        gridBagConstraints.insets = new java.awt.Insets(2, 0, 0, 0);
        jPanel2.add(jLabel3, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridheight = 2;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHEAST;
        gridBagConstraints.insets = new java.awt.Insets(3, 3, 0, 0);
        getContentPane().add(jPanel2, gridBagConstraints);

        jPanel3.setLayout(new java.awt.GridBagLayout());

        jPanel3.setMinimumSize(new java.awt.Dimension(300, 23));
        jPanel3.setPreferredSize(new java.awt.Dimension(300, 23));
        btnNewUser.setText(" New User");
        btnNewUser.setMaximumSize(new java.awt.Dimension(95, 23));
        btnNewUser.setMinimumSize(new java.awt.Dimension(95, 23));
        btnNewUser.setPreferredSize(new java.awt.Dimension(95, 23));
        btnNewUser.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNewUserActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(6, 6, 6, 6);
        jPanel3.add(btnNewUser, gridBagConstraints);

        btnConfirm.setFont(new java.awt.Font("Tahoma", 0, 11));
        btnConfirm.setLabel("Save");
        btnConfirm.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnConfirmActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(6, 6, 6, 6);
        jPanel3.add(btnConfirm, gridBagConstraints);

        cmdDelete.setText("Delete");
        cmdDelete.setMaximumSize(new java.awt.Dimension(95, 23));
        cmdDelete.setMinimumSize(new java.awt.Dimension(95, 23));
        cmdDelete.setPreferredSize(new java.awt.Dimension(95, 23));
        cmdDelete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cmdDeleteActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.insets = new java.awt.Insets(6, 6, 6, 6);
        jPanel3.add(cmdDelete, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.SOUTHWEST;
        gridBagConstraints.insets = new java.awt.Insets(0, 3, 6, 0);
        getContentPane().add(jPanel3, gridBagConstraints);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents

    private void cmdDeleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cmdDeleteActionPerformed
        try{
            int i = JOptionPane.showConfirmDialog(this,"Delete user " + userData.getUserName() + "?", "Delete User", JOptionPane.YES_NO_OPTION);
            if(i== JOptionPane.YES_OPTION){
                userData.deleteUser();
                JOptionPane.showMessageDialog(this,"Delete complete successfully!");
                initCombo();
                init();
            }             
        }
        catch(Exception e){
            JOptionPane.showMessageDialog(null,"Delete not complete successfully!\n"+e.getMessage());
        }
    }//GEN-LAST:event_cmdDeleteActionPerformed
    
    private void btnNewUserActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNewUserActionPerformed
        if(!"Cancel".equals(btnNewUser.getText())){
            userData = new UserData();
            ComboDataRow obj = new ComboDataRow("New User",userData.getId());
            ((ComboDataModel)cboUsers.getModel()).setObject(obj);
            cboUsers.setSelectedIndex(((ComboDataModel)cboUsers.getModel()).getSize()-1);
            cboUsers.updateUI();
            cboUsers.setEnabled(false);
            btnNewUser.setText("Cancel");
        } else{
            btnNewUser.setText("New User");
            cboUsers.setEnabled(true);
            initCombo();
        }
    }//GEN-LAST:event_btnNewUserActionPerformed
    
    private void cboUsersItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cboUsersItemStateChanged
        
        try{
            init();
        } catch(Exception e){
            JOptionPane.showMessageDialog(null,e.getMessage());
            e.printStackTrace();
        }
    }//GEN-LAST:event_cboUsersItemStateChanged
    
    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        if(parent!=null)
            parent.setVisible(true);
    }//GEN-LAST:event_formWindowClosed
    
    private void btnConfirmActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnConfirmActionPerformed
        if(userData.getId()<=0){
            try {
                insertUser();
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(null,ex.getMessage());
            }
        } else{
            try {
                updateUser();
                deleteUserPerms();
                setUserPerms();
                try {
                    userData.setPerms();
                } catch (Exception ex) {
                    throw new Exception("User can not be set!\n" + ex.getMessage());
                }
            } catch (Exception ex) {
                JOptionPane.showMessageDialog(null,ex.getMessage());
            }
        }
    }//GEN-LAST:event_btnConfirmActionPerformed
    
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new UserAdd(null).setVisible(true);
            }
        });
    }
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnConfirm;
    private javax.swing.JButton btnNewUser;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JComboBox cboUsers;
    private javax.swing.JButton cmdDelete;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JLabel lblPassword;
    private javax.swing.JLabel lblUsername;
    private javax.swing.JScrollPane scrPerms;
    private javax.swing.JTable tblPerms;
    private javax.swing.JTextField txtAbbr;
    private javax.swing.JPasswordField txtPassword;
    private javax.swing.JTextField txtUsername;
    // End of variables declaration//GEN-END:variables
    
}
