package adminmodul.accesscontrol;

import java.util.*;

public class UserData {
    private int id;
    private String user_name;
    private String user_pass;
    private int user_type;
    private String user_abrv;
    private int active_macro;
    private ArrayList perms = null;
    private UserPerm userPerm;
    
    public UserData(String user_name, String user_pass, int user_type, String user_abrv, int active_macro) {
        this.id = -1;
        this.user_name = user_name;
        this.user_pass = user_pass;
        this.user_type = user_type; //user_type;
        this.user_abrv = user_abrv;
        this.active_macro = active_macro; //active_macro;
        perms = new ArrayList();
        userPerm = new UserPerm(this);
    }
    public UserData(int id, String user_name, String user_pass, int user_type, String user_abrv, int active_macro) {
        
        this.id = id;
        this.user_name = user_name;
        this.user_pass = user_pass;
        this.user_type = user_type; //user_type;
        this.user_abrv = user_abrv;
        this.active_macro = active_macro; //active_macro;
        perms = new ArrayList();
        userPerm = new UserPerm(this);
    }
    public UserData() {
        this.id = -1;
        this.user_name = "";
        this.user_pass = "";
        this.user_type = 1;
        this.user_abrv = "";
        this.active_macro = 1;
        perms = new ArrayList();
        userPerm = new UserPerm(this);
    }
    
    public void setPerm(PermData value){
        perms.add(value);
    }
    public void setPerms(ArrayList value){
        perms=value;
    }
    public void setId(int value){
        id = value;
    }
    public int getId(){
        return id;
    }
    public String getUserName(){
        return user_name;
    }
    public String getUserPass(){
        return user_pass;
    }
    public String getAbbr(){
        return user_abrv;
    }
    public int getUserType(){
        return user_type;
    }
    public int getActiveMacroId(){
        return active_macro;
    }
    public PermData getPerm(int i){
        return (PermData)perms.get(i);
    }
    public ArrayList getPerms(){
        if(perms==null)
            return new ArrayList();
        return perms;
    }
    
    public void deleteUserPerms()  throws Exception{
        
        userPerm.deleteUserPerms();
        
    }
    public void setPerms() throws Exception{
        
        userPerm.setPerms();
        
    }
    public void getUserPerms() throws Exception{
        userPerm.getUserPerms();
        userPerm = new UserPerm(this);
    }
    public void getUser() throws Exception{
        
        UserData userData= userPerm.getUser();
        this.id = userData.getId();
        this.user_name = userData.getUserName();
        this.user_pass = userData.getUserPass();
        this.user_type = userData.getUserType();
        this.user_abrv = userData.getAbbr();
        this.active_macro = userData.getActiveMacroId();
        perms = new ArrayList();
        
        userPerm = new UserPerm(this);
        
    }
    public void setUserDb() throws Exception{
        userPerm.setUser();
    }
    public void updateUser() throws Exception{
        userPerm.updateUser();
    }
    public UserPerm getUserPerm(){
        return userPerm;
    }
    public void deleteUser() throws Exception{
        
        userPerm.deleteUser();
        
    }
    
}
