package adminmodul.menucontrol;

import java.util.ArrayList;

public class MenuData {

    private int id = -1;
    private String menu_desc = null;
    private String menu_code = null;
    private int status = -1; //-1 skip menu, 0 - menu not exist, 1 - menu exist
    private ArrayList sub_menu = null;
    
    public MenuData() {
        id = -1;
        menu_desc = null;
        menu_code = null;
        sub_menu = new ArrayList();
    }
    
    public MenuData(int id, String menu_desc, String menu_code) {
        this.id = id;
        this.menu_desc = menu_desc;
        this.menu_code = menu_code;
        sub_menu = new ArrayList();
    }
    
    public void setId(int value){
        id = value;
    }
    public void setSubMenu(MenuData value){
        sub_menu.add(value);
    }
    public void setStatus(int value){
        status = value;
    }
    public int getId(){
        return id;
    }
    public String getMenuDesc(){
        if(menu_desc!=null)
            return menu_desc.trim();
        else
            return "";      
    }
    public String getMenuCode(){
        return menu_code;
    }
    public MenuData getSubMenu(int index){
        if(sub_menu!=null && index >= 0 && index <= sub_menu.size())
            return (MenuData)sub_menu.get(index);
        else
            return null;
    }
    public ArrayList getSubMenu(){
        if(sub_menu!=null)
            return sub_menu;
        else
            return new ArrayList();
    }
    public int getStatus(){
        return status;
    }
        
}
