package adminmodul.menucontrol;

import java.util.ArrayList;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;

import adminmodul.SharedUtils;
import adminmodul.UniversalTableModel;
import adminmodul.UniversalTableRow;
import java.util.Vector;

public class MenuUtils extends DBConn{
    
    private Connection connDB = null;
    private PreparedStatement pstm = null;
    private ResultSet rs = null;
    
    private ArrayList menus = null;
        
    public MenuUtils() {
        
    }
    public boolean isNew(ArrayList value, MenuData menu){
        for(int i = 0; i < value.size(); i++){
            MenuData currentMenu = (MenuData)value.get(i);
            if(currentMenu.getId()==menu.getId())
                return true;//((MenuData)value.get(i)).setStatus(1);
        }
        return false;
    }
    public UniversalTableModel getTableModel() throws Exception{
        String[] strColNames = {"Menu","Allow"};
        setMenuData();
        ArrayList temp = getMenus();
        if(temp==null)
            throw new Exception("Permission table can not be loaded!");
                
        Vector data = new Vector();
        for(int i=0; i < temp.size(); i++){
            
            MenuData item = (MenuData)temp.get(i);            
            Vector vecRowEl = new Vector();
            
            vecRowEl.addElement(((MenuData)temp.get(i)).getMenuDesc());
            vecRowEl.addElement(String.valueOf(0));
            vecRowEl.addElement(String.valueOf(-1));
            vecRowEl.addElement(String.valueOf(((MenuData)temp.get(i)).getId()));
            
            data.addElement(new UniversalTableRow(vecRowEl));
            
            ArrayList subitems = item.getSubMenu();
            
            for(int j=0; j < subitems.size(); j++){
                MenuData subitem = (MenuData)subitems.get(j);
                Vector vecRowElSub = new Vector();
                vecRowElSub.addElement("  "+subitem.getMenuDesc());
                vecRowElSub.addElement(String.valueOf(0));
                vecRowElSub.addElement(String.valueOf(-1));
                vecRowElSub.addElement(String.valueOf(subitem.getId()));
                data.addElement(new UniversalTableRow(vecRowElSub));
            }
            
        }
        
        return new UniversalTableModel(data,strColNames);   
        
    }
    public void setMenuData() throws Exception{
        ResultSet rs = null;
        menus = new ArrayList();
        ArrayList all_menus = new ArrayList();
        ArrayList all_menus_copy = new ArrayList();
       try{         
        connDB = SharedUtils.getConnection();        
        
        pstm = connDB.prepareStatement(strAllMenus);
        rs = pstm.executeQuery();
        while(rs.next()){
           int id = rs.getInt("menu_key");
           String menu_desc = rs.getString("menu_desc");
           String menu_code = rs.getString("menu_code");
           
           MenuData menuData = new MenuData(id,menu_desc,menu_code);
           
           all_menus.add(menuData);
           all_menus_copy.add(menuData);
        }
        for(int i=0; i<all_menus.size(); i++){    
            MenuData menu_data = (MenuData)all_menus.get(i);
            
            String[] codeArr = menu_data.getMenuCode().split(":");
            
            if(codeArr.length>1)
                continue;
            
            for(int j=0; j<all_menus_copy.size(); j++){                
                MenuData temp = (MenuData)all_menus_copy.get(j);
                
                String[] s_codeArr = temp.getMenuCode().split(":");
                if(s_codeArr.length<=1)
                    continue;
                if(menu_data.getMenuCode().trim().equals(s_codeArr[1].trim())){
                    menu_data.setSubMenu(temp);                    
                }
                
            }
            
            menus.add(menu_data);
        }
       }
       catch(Exception e){
           throw new Exception("List of menus can not be retrieved!\n"+e.getMessage());
       }
       finally{
           try{
               connDB.close();
           }
           catch(Exception ex){
           
           }           
       }
    }
    
    public ArrayList getMenus(){
        return menus;
    }
}
